<?php 
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");

// para mostrar errores por ejemplo el de falta de memoria en vez de mostarr un error 500 y no saber el problema
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL ^ E_NOTICE);

// para evitar el error 500 por falta de memoria
ini_set('memory_limit', '-1');
set_time_limit(0);



echo "INICIO MIGRACION BI: ".date("Y-m-d H:i:s");

echo "inicio rellenar tablas locales: ".date("Y-m-d H:i:s");
// rellena las tablas locales
rellenar_tablas_locales_bi();
echo "fin rellenar tablas locales: ".date("Y-m-d H:i:s");

echo "inicio mimgrar bi_fac_cab: ".date("Y-m-d H:i:s");
// migrar la tabla bi_fac_cab a bd externa
$columnas_array=array('idbifaccab', 'idventa', 'fechahora', 'totalventa', 'descuento', 'monto_factura', 'ruc', 'razon_social', 'idcaja', 'tipo_venta', 'factura', 'formas_pago', 'sucursal', 'deposito', 'operador', 'cajero', 'estado', 'dia_semana', 'canal', 'canal_venta', 'motorista', 'mesa', 'salon');
$parametros_array=array(
	'nombre_tabla' => 'bi_fac_cab',
	'nombre_tabla_tmp' => 'bi_fac_cab_tmp',
	'idcolumnacontrol' => 'idventa',
	'idpktabla' => 'idbifaccab',
	'migra_total' => 'S',
	'columnas_array' => $columnas_array
);
migrar_bi($parametros_array);
echo "fin mimgrar bi_fac_cab: ".date("Y-m-d H:i:s");

echo "inicio mimgrar bi_fac_det: ".date("Y-m-d H:i:s");
// migrar la tabla bi_fac_det a bd externa
$columnas_array=array('idbifacdet', 'idventa', 'idventadet', 'fechahora', 'factura', 'condicion', 'codprod', 'codbarra', 'producto', 'categoria', 'subcategoria', 'sucursal', 'deposito', 'precio_unitario', 'cantidad', 'subtotal', 'costo_unitario', 'subtotal_costo', 'exenta', 'gravadas', 'ivaml', 'cantidad_referencial_unit', 'cantidad_referencial_total', 'medida_referencial', 'operador', 'cajero', 'ruc', 'razon_social', 'proveedor', 'dia_semana', 'canal', 'canal_venta', 'motorista', 'mesa', 'salon', 'lista_precio', 'estado_factura');
$parametros_array=array(
	'nombre_tabla' => 'bi_fac_det',
	'nombre_tabla_tmp' => 'bi_fac_det_tmp',
	'idcolumnacontrol' => 'idventadet',
	'idpktabla' => 'idbifacdet',
	'migra_total' => 'S',
	'columnas_array' => $columnas_array
);
migrar_bi($parametros_array);
echo "fin mimgrar bi_fac_det: ".date("Y-m-d H:i:s");


echo "FINAL MIGRACION BI: ".date("Y-m-d H:i:s");


function migrar_bi($parametros_array){
	global $conexion;
	global $conexion_bi;
	$nombre_tabla = $parametros_array['nombre_tabla'];
	$nombre_tabla_tmp = $parametros_array['nombre_tabla_tmp'];
	$idcolumnacontrol = $parametros_array['idcolumnacontrol'];
	$idpktabla = $parametros_array['idpktabla'];
	$migra_total = $parametros_array['migra_total'];
	$columnas_array = $parametros_array['columnas_array'];

	// parametros de conexion a bd externa de bi
	$consulta="
	select id_db_bi, dbdriver_db_bi, servidor_db_bi, usuario_db_bi, contrasena_db_bi, database_db_bi, estado
	from bi_conexion 
	where 
	 estado = 1 
	limit 1
	";
	$rsbicon=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	if(intval($rsbicon->fields['id_db_bi']) > 0){
		// conexion bi
		$dbdriver_bi=$rsbicon->fields['dbdriver_db_bi'];
		$conexion_bi = ADONewConnection($dbdriver_bi); # eg 'mysql' o 'postgres'
		$servidor_bi=$rsbicon->fields['servidor_db_bi'];
		$usuario_bi=$rsbicon->fields['usuario_db_bi'];
		$contrasena_bi=$rsbicon->fields['contrasena_db_bi'];
		$database_bi=$rsbicon->fields['database_db_bi'];
		$conexion_bi->Connect($servidor_bi, $usuario_bi, $contrasena_bi, $database_bi);	
		$consulta="
		select id from bi_test limit 1
		";
		$rstestcon=$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));
		if(intval($rstestcon->fields['id']) == 0){
			echo "No se pudo conectar a la BD, o la bd de prueba no tiene registros.";
			exit;
		}
	}else{
		echo "No se indicaron los parametros de conexion a la bd de BI";
		exit;
	}
	
	
	// si la migracion es parcial
	if(trim($migra_total) == 'S'){
		// aca aun no hace nada, abajo si lo hara
	// si la migracion es parcial
	}else{
		// busca el ultimo id insertado en la bd externaa
		$consulta="
		select max($idcolumnacontrol) as $idcolumnacontrol from $nombre_tabla
		";
		$rsext=$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));
		$idcolumnacontrol_ext=intval($rsext->fields[$idcolumnacontrol]);
		$whereadd.="
		and $idcolumnacontrol > $idcolumnacontrol_ext
		";
	}

	// vacia la tabla temporal externa
	$consulta="
	truncate table $nombre_tabla_tmp
	";
	$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));


	// trae datos de base local
	$consulta="
	select * 
	from $nombre_tabla
	where 
	$idpktabla is not null
	$whereadd
	order by $idpktabla asc
	";
	//echo $consulta;exit;
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	
	$insert_cab='';
	$insert_val='';
	$insert_sql='';
	// construye insert
	foreach($columnas_array as $col){
		$insert_cab.=$col.', ';
	}
	$insert_cab=substr(trim($insert_cab),0,-1);

	reset($columnas_array);

	$i=0;
	// recorre e inserta en la db externa de BI temporal
	while(!$rs->EOF){ 
		$insert_val='';
		foreach($columnas_array as $col){
			$valores = antisqlinyeccion($rs->fields[$col],"text");
			$insert_val.=$valores.', ';
		}
		$insert_val=substr(trim($insert_val),0,-1);
		//echo $insert_val;
		
		$consulta="
		insert into $nombre_tabla_tmp
		(
		$insert_cab
		)
		values
		(
		$insert_val
		)
		";
		//echo "<hr />".$consulta;
		$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));
		//if($i>3){
		//	exit;
		//}
		
		$i++;
	$rs->MoveNext(); } //$rs->MoveFirst();

	// si la migracion  es total vacia la tabla real antes de pasar la tempopral
	if(trim($_GET['migra_total']) == 'S'){
		// vaciar tabla externa
		$consulta="
		truncate table $nombre_tabla
		";
		$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));
	}

	// si todo fue correcto migra de la temporal a la definitiva
	$consulta="
	insert into $nombre_tabla
	select * from $nombre_tabla_tmp where $idcolumnacontrol not in (select $idcolumnacontrol from $nombre_tabla)
	";
	$conexion_bi->Execute($consulta) or die(errorpg($conexion_bi,$consulta));
	
	// trae ventas anuladas ultimos 30 dias y anula en db externa
	
	
}

function rellenar_tablas_locales_bi(){
	global $conexion;
	
	$consulta="
	truncate table bi_fac_cab;
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	// cabecera
	$consulta="
	INSERT INTO `bi_fac_cab`
	(`idventa`, `fechahora`, `totalventa`, `descuento`, `monto_factura`, `ruc`, `razon_social`, `idcaja`, `tipo_venta`, `factura`, `formas_pago`, `sucursal`, `deposito`, `operador`, `cajero`, `estado`, `dia_semana`, `canal`, `canal_venta`, `motorista`, `mesa`, `salon`) 
	SELECT idventa, fecha as Fecha, 
	total_venta as Total_Venta,
	descneto as Descuento,
	totalcobrar as Monto_Factura, 
	CONCAT(ruchacienda,'-',dv) as Ruc, 
	(select cliente.razon_social from cliente where cliente.idcliente = ventas.idcliente limit 1) as razon_social,
	idcaja, 
	CASE WHEN tipo_venta = 1
	THEN
	 'CONTADO'
	ELSE
	 'CREDITO'
	END as 'Tipo Venta',
	CASE WHEN 
		LENGTH(factura) = 13
	THEN
		CONCAT(SUBSTRING(factura,1,3),'-',SUBSTRING(factura,4,3),'-',SUBSTRING(factura,7,7))
	ELSE
		factura
	END as Factura,
	(
		SELECT GROUP_CONCAT(formas_pago.descripcion) AS formapago 
		from gest_pagos_det 
		inner join gest_pagos on gest_pagos.idpago = gest_pagos_det.idpago
		inner join formas_pago on formas_pago.idforma = gest_pagos_det.idformapago
		where 
		gest_pagos.idventa = ventas.idventa
		and gest_pagos.estado <> 6
		order by formas_pago.descripcion asc
	 ) as 'Forma de Pago',
	(select nombre from sucursales where sucursales.idsucu = ventas.sucursal) as Sucursal,
	(select descripcion from gest_depositos where iddeposito = ventas.iddeposito) as Deposito,
	(select usuario from usuarios where idusu = ventas.operador_pedido) as Operador,
	(select usuario from usuarios where idusu = ventas.registrado_por) as Cajero,
	CASE WHEN ventas.estado <> 6 THEN 'VIGENTE' ELSE 'ANULADO' END as 'Estado',
	CONCAT(ELT(WEEKDAY(fecha)+1, 
	'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo')) AS dia_semana,
	(select canal from canal where idcanal = ventas.idcanal) as canal,
	(select canal_venta from canal_venta where idcanalventa = ventas.idcanalventa) as canal_venta,
	(select motorista from motoristas where idmotorista = ventas.idmotorista) as motorista,
	(select numero_mesa from mesas where idmesa = ventas.idmesa) as mesa,
	(select salon.nombre from mesas inner join salon on salon.idsalon = mesas.idsalon where idmesa = ventas.idmesa) as salon
	FROM ventas
	WHERE 
	finalizo_correcto = 'S'
	ORDER by date(fecha) asc, factura asc
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	$consulta="
	truncate table bi_fac_det;
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	// detalle
	$consulta="

	INSERT INTO `bi_fac_det`
	(`idventa`, idventadet, `fechahora`, `factura`, `condicion`, `codprod`, `codbarra`, `producto`, `categoria`, `subcategoria`, `sucursal`, `deposito`, `precio_unitario`, `cantidad`, `subtotal`, `costo_unitario`, `subtotal_costo`, `exenta`, `gravadas`, `ivaml`, `cantidad_referencial_unit`, `cantidad_referencial_total`, `medida_referencial`, `operador`, `cajero`, `ruc`, `razon_social`, `proveedor`, `dia_semana`, `canal`, `canal_venta`, `motorista`, `mesa`, `salon`, `lista_precio`, estado_factura)
	select ventas_detalles.idventa, ventas_detalles.idventadet, ventas.fecha as 'Fecha Hora', 
		CASE WHEN 
			LENGTH(ventas.factura) = 13
		THEN
			CONCAT(SUBSTRING(ventas.factura,1,3),'-',SUBSTRING(ventas.factura,4,3),'-',SUBSTRING(ventas.factura,7,7))
		ELSE
			ventas.factura
		END as Factura,
		CASE WHEN 
			tipo_venta = 1
		THEN 
			'CONTADO'
		ELSE
			'CREDITO'
		END as Condicion_Venta,
	(select idinsumo from insumos_lista where idproducto = productos.idprod_serial) as Codprod,
	productos.barcode as Codbarra,
	(select descripcion from productos where idprod_serial = ventas_detalles.idprod) as Producto,
	(
	select categorias.nombre 
	from categorias 
	inner join productos on productos.idcategoria = categorias.id_categoria 
	where 
	idprod_serial = ventas_detalles.idprod
	) as Categoria,

	(
	select sub_categorias.descripcion 
	from sub_categorias
	inner join productos on productos.idsubcate = sub_categorias.idsubcate 
	where 
	idprod_serial = ventas_detalles.idprod
	) as 'Sub Categoria',
	(select nombre from sucursales where sucursales.idsucu = ventas.sucursal) as Sucursal,
	(select descripcion from gest_depositos where iddeposito = ventas.iddeposito) as Deposito,
	pventa as 'Precio Unitario', 
	cantidad as Cantidad, 
	subtotal as Subtotal,
	costo as Costo_unitario,
	subtotal_costo as Subtotal_costo,

	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		(Select sum(gravadoml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet and iva_porc_col=0)
	ELSE
		(Select sum(subtotal) as subtotal from ventas_detalles where idventadet=ventas_detalles.idventadet and iva=0)
	END as exenta,
	(Select sum(gravadoml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet and iva_porc_col > 0) as gravadas,
	(Select sum(ivaml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet) as ivaml,

	productos.cantidad_referencial as cantidad_referencial_unit,
	ventas_detalles.cantidad*productos.cantidad_referencial  as cantidad_referencial_total,
	(select nombre from medidas where id_medida = productos.idmedida_referencial) as medida_referencial,

	(select usuario from usuarios where idusu = ventas.operador_pedido) as Operador,
	(select usuario from usuarios where idusu = ventas.registrado_por) as Cajero,
	ventas.ruc as ruc,
	ventas.razon_social,
	(
	select proveedores.nombre 
	from proveedores 
	inner join insumos_lista on insumos_lista.idproveedor = proveedores.idproveedor
	inner join productos on productos.idprod_serial = insumos_lista.idproducto
	where
	productos.idprod_serial = ventas_detalles.idprod
	) as proveedor,
		CONCAT(ELT(WEEKDAY(fecha)+1, 
		'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo')) AS dia_semana,
	(select canal from canal where idcanal = ventas.idcanal) as canal,
	(select canal_venta from canal_venta where idcanalventa = ventas.idcanalventa) as canal_venta,
	(select motorista from motoristas where idmotorista = ventas.idmotorista) as motorista,
	(select numero_mesa from mesas where idmesa = ventas.idmesa) as mesa,
	(select salon.nombre from mesas inner join salon on salon.idsalon = mesas.idsalon where idmesa = ventas.idmesa) as salon,
	CASE WHEN
	ventas_detalles.idlistaprecio IS NULL
	THEN
		'NORMAL'
	ELSE
		(select lista_precios_venta.lista_precio from lista_precios_venta where idlistaprecio = ventas_detalles.idlistaprecio) 
	END as lista_precio,
	CASE WHEN 
	ventas.estado = 6 
	tHEN 
	 'ANULADO'
	ELSE
	 'VIGENTE'
	END  as estado_factura
	FROM ventas_detalles
	inner join ventas on ventas.idventa = ventas_detalles.idventa
	inner join productos on productos.idprod_serial = ventas_detalles.idprod
	WHERE 
	finalizo_correcto = 'S'
	ORDER by ventas.fecha asc, ventas.factura asc
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
}
?>