<?php
// INICIO OPTIMIZADOR DE TABLAS
// busca si ya se optimizo el dia de hoy
$ahorad=date("Y-m-d");
$consulta="
SELECT `idoptiminizador`, `idcaja`, `fechasola`, `registrado_el` 
FROM `optimizador_cierre_caja` 
WHERE
fechasola = '$ahorad'
limit 1
";
$rsopt=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idoptiminizador=intval($rsopt->fields['idoptiminizador']);

function columnas_tabla($parametros_array) {
    global $conexion;
    
    $tabla = $parametros_array['tabla'];
    $cols_excluye_csv = $parametros_array['cols_excluye_csv'];
    
    // Convertir las columnas a excluir en un array
    $cols_excluye_array = explode(',', $cols_excluye_csv);
    
    $consulta = "
        SELECT *
        FROM $tabla
        LIMIT 1
    ";
    $rs = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
    
    // Asigna los datos de la consulta a una variable
    $array = $rs->fields;
    
    // Elimina las columnas excluidas
    foreach ($cols_excluye_array as $col) {
        unset($array[trim($col)]);
    }
    
    $datos = '';
    
    // Construye la cabecera
    foreach ($array as $key => $value) {
        $datos .=$key . ',';
    }
    
    // Elimina la última coma
    $datos = rtrim($datos, ',');
    
    $res = array(
        'columnas_csv' => $datos
    );
    
    return $res;
}

// si aun no se optimizo hoy
if($idoptiminizador == 0){

	//
	// marca registros viejos como borrados
	$consulta="
	update tmp_ventares_cab 
	set 
	estado = 6 
	where 
	idventa is null 
	and date(fechahora) < date_add(date(NOW()), INTERVAL -60 DAY)
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	update  tmp_ventares 
	set borrado = 'S'
	WHERE
	idtmpventares_cab is null
	 and registrado = 'N'
	 and fechahora < date_add(date(NOW()), INTERVAL -60 DAY) 
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// pimero mover
	$consulta="
	insert into tmp_ventares_bak
	select * from tmp_ventares 
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -3 DAY) 
	and (registrado = 'S' or borrado = 'S')
	and tmp_ventares.idventatmp not in (select idventatmp from tmp_ventares_bak where tmp_ventares_bak.idventatmp = tmp_ventares.idventatmp)
	limit 100000
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	insert into tmp_ventares_bak
	select * from tmp_ventares 
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -3 DAY) 
	and idtmpventares_cab in (select idtmpventares_cab from tmp_ventares_cab where estado = 6)
	and tmp_ventares.idventatmp not in (select idventatmp from tmp_ventares_bak where tmp_ventares_bak.idventatmp = tmp_ventares.idventatmp)
	limit 100000
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	//and tmp_ventares.idventatmp > (select max(idventatmp) from tmp_ventares_bak)
	
	// luego borrar
	$consulta="
	delete from  tmp_ventares
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -3 DAY) 
	and (registrado = 'S' or borrado = 'S')
	and tmp_ventares.idventatmp in (select idventatmp from tmp_ventares_bak where tmp_ventares_bak.idventatmp = tmp_ventares.idventatmp)
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	delete from  tmp_ventares
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -3 DAY) 
	and idtmpventares_cab in (select idtmpventares_cab from tmp_ventares_cab where estado = 6)
	and tmp_ventares.idventatmp in (select idventatmp from tmp_ventares_bak where tmp_ventares_bak.idventatmp = tmp_ventares.idventatmp)
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// primero mover
	$consulta="
	INSERT INTO costo_productos_bak
	select * from costo_productos 
	where 
	disponible <= 0
	and ficticio = 0
	and idseriepkcos not in (select idseriepkcos from costo_productos_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// luego borrar
	$consulta="
	delete from  costo_productos
	where
	idseriepkcos in (select idseriepkcos from costo_productos_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// primero mover
	$consulta="
	INSERT INTO gest_depositos_stock_bak
	select * from gest_depositos_stock 
	where 
	disponible <= 0
	and ficticio = 0
	and idregseriedptostk not in (select idregseriedptostk from gest_depositos_stock_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// luego borrar
	$consulta="
	delete from  gest_depositos_stock
	where
	idregseriedptostk in (select idregseriedptostk from gest_depositos_stock_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));		
	
	// obtiene columnas de stock movimientos excluye la columna fecha_sin_hora xq es autogenerada
	$parametros_array = array(
		'tabla' => 'stock_movimientos',
		'cols_excluye_csv' => 'fecha_sin_hora' // columnas excluidas separadas por coma
	);
	$res = columnas_tabla($parametros_array);
	$columnas_stockmov = $res['columnas_csv'];
	// optimizar tabla stock_movimiento
	$consulta="  
	insert into stock_movimientos_bak
	($columnas_stockmov)
	select 
	$columnas_stockmov
	from stock_movimientos
	WHERE
	date(fechahora) < date_add(date(NOW()), INTERVAL -365 DAY)
	and stock_movimientos.idstockmov not in (select idstockmov from stock_movimientos_bak where stock_movimientos_bak.idstockmov = stock_movimientos.idstockmov)
	limit 100000
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));		
	$consulta="  
	delete from stock_movimientos 
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -365 DAY)
	and idstockmov in (select idstockmov from stock_movimientos_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	
	
	// optimizar venta receta
	$consulta="
	insert into venta_receta_bak 
	select * from venta_receta 
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -365 DAY)
	and venta_receta.idventareceta not in (select idventareceta from venta_receta_bak where venta_receta_bak.idventareceta = venta_receta.idventareceta)
	limit 100000
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	
	$consulta="
	delete from venta_receta 
	where 
	date(fechahora) < date_add(date(NOW()), INTERVAL -365 DAY)
	and venta_receta.idventareceta in (select idventareceta from venta_receta_bak);
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	
	//optimizar factura electronica
	if($facturador_electronico == 'S'){
		

		// ventas
		$consulta="
		WITH temp_ids AS (
			SELECT idventa, iddocumentoemitido
			FROM documentos_electronicos_emitidos 
			WHERE 
			estado = 6
			and idventa is not null
		)
		SELECT deprin.iddocumentoemitido as iddocumentoemitido_apro, deprin.idventa, t.iddocumentoemitido as iddocumentoemitido_del
		FROM documentos_electronicos_emitidos deprin
		inner JOIN temp_ids t ON deprin.idventa = t.idventa
		WHERE 
		deprin.estado_set = 3
		AND deprin.estado = 1
		AND deprin.idventa IS NOT NULL
		AND deprin.iddocumentoemitido <> t.iddocumentoemitido
		order by deprin.idventa asc
		LIMIT 100000;
		";
		$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$i=0;
		while(!$rs->EOF){
			$idventa=intval($rs->fields['idventa']);
			$iddocumentoemitido_apro=intval($rs->fields['iddocumentoemitido_apro']);
			$iddocumentoemitido_del=intval($rs->fields['iddocumentoemitido_del']);
			$consulta="
			delete from documentos_electronicos_emitidos 
			where 
			iddocumentoemitido <> $iddocumentoemitido_apro
			and iddocumentoemitido = $iddocumentoemitido_del
			and idventa = $idventa
			and estado = 6
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$i++;
		$rs->MoveNext(); }
		//echo date("Y-m-d H:i:s").' - '.'Total DE Eliminados: '.$i.'<br />';
		$i=0;
		
		
		// nota credito
		$consulta="
		WITH temp_ids AS (
			SELECT idnotacredito, iddocumentoemitido
			FROM documentos_electronicos_emitidos 
			WHERE 
			estado = 6
			and idnotacredito is not null
		)
		SELECT deprin.iddocumentoemitido as iddocumentoemitido_apro, deprin.idnotacredito, t.iddocumentoemitido as iddocumentoemitido_del
		FROM documentos_electronicos_emitidos deprin
		inner JOIN temp_ids t ON deprin.idnotacredito = t.idnotacredito
		WHERE 
		deprin.estado_set = 3
		AND deprin.estado = 1
		AND deprin.idnotacredito IS NOT NULL
		AND deprin.iddocumentoemitido <> t.iddocumentoemitido
		order by deprin.idnotacredito asc
		LIMIT 100000;
		";
		$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$i=0;
		while(!$rs->EOF){
			$idnotacredito=intval($rs->fields['idnotacredito']);
			$iddocumentoemitido_apro=intval($rs->fields['iddocumentoemitido_apro']);
			$iddocumentoemitido_del=intval($rs->fields['iddocumentoemitido_del']);
			$consulta="
			delete from documentos_electronicos_emitidos 
			where 
			iddocumentoemitido <> $iddocumentoemitido_apro
			and iddocumentoemitido = $iddocumentoemitido_del
			and idnotacredito = $idnotacredito
			and estado = 6
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$i++;
		$rs->MoveNext(); }
		//echo date("Y-m-d H:i:s").' - '.'Total DE Eliminados: '.$i.'<br />';
		$i=0;

	}
		

	$consulta="
	insert into optimizador_cierre_caja
	(idcaja, fechasola, registrado_el)
	values
	($idcaja, '$ahorad', '$ahora')
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));		

} //if($idoptiminizador == 0){
// FIN OPTIMIZADOR DE TABLAS
?>