<?php
/*
PARA QUE FUNCIONE PONER ESTO EN EL ARCHIVO .htaccess del servidor:
RewriteEngine On
RewriteRule .* - [E=HTTP_AUTHORIZATION:%{HTTP:Authorization}]

*/
/*
print_r($_SERVER);

foreach (getallheaders() as $name => $value) {
    echo "$name: $value\n";
}
exit;
*/
$headers = getallheaders();
//$headers=$_SERVER;
$json=json_encode($headers, JSON_PRETTY_PRINT);
//echo $json;exit;
// SE UTILIZA PARA EL QR EN PANTALLA DE BANCARD
require_once("includes/funciones.php");
require_once("includes/conexion.php");

class ConfirmaPago
{

    public function realizaConfirmacion($idlog,$json_input) {

        global $conexion;

		$data = json_decode($json_input, true);

        if ($data === null) {

            // No se pudo decodificar el JSON, manejar el error
            $response = [
                "status" => false,
                "msg" => "Error en el formato JSON recibido"
            ];



        } else {

			$hook_alias = antisqlinyeccion($data['payment']['hook_alias'], "textbox");
			$status = antisqlinyeccion($data['payment']['status'], "textbox");
			$response_code = antisqlinyeccion($data['payment']['response_code'], "textbox");
			$response_description = antisqlinyeccion($data['payment']['response_description'], "textbox");
			$amount = antisqlinyeccion($data['payment']['amount'], "decimal");
			$currency = antisqlinyeccion($data['payment']['currency'], "textbox");
			$installment_number = antisqlinyeccion($data['payment']['installment_number'], "int");
			$description = antisqlinyeccion($data['payment']['description'], "textbox");
			$date_time = antisqlinyeccion(date('Y-m-d H:i:s', strtotime(str_replace('/', '-', $data['payment']['date_time']))), "date");
			$ticket_number = antisqlinyeccion($data['payment']['ticket_number'], "int");
			$authorization_code = antisqlinyeccion($data['payment']['authorization_code'], "textbox");
			$commerce_name = antisqlinyeccion($data['payment']['commerce_name'], "textbox");
			$branch_name = antisqlinyeccion($data['payment']['branch_name'], "textbox");
			$account_type = antisqlinyeccion($data['payment']['account_type'], "textbox");
			$card_last_numbers = antisqlinyeccion($data['payment']['card_last_numbers'], "int");
			$bin = antisqlinyeccion($data['payment']['bin'], "textbox");
			$merchant_code = antisqlinyeccion($data['payment']['merchant_code'], "textbox");
			$payer = $conexion->qstr(json_encode($data['payment']['payer'], JSON_UNESCAPED_UNICODE));

			//  (Escenario poco habitual) Si después de haber llamado al servicio "revert" para cancelar el QR, 
			// reciben una confirmación de pago asociado al mismo QR, el callback response debe ser error.
			$consulta="
			select * from  bancard_qr  where hook_alias = $hook_alias
			";
			$rsest=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 	
			$idestado_qr = $rsest->fields['idestado_qr'];
			$idpostmp = $rsest->fields['idpostmp'];
			// si el estado es reversado
			if($idestado_qr == 2){

				// RESPONDER A BANCARD
				$response = [
					"status" => "error",
					"message" => [

						array(

							"level" => "error",
							"key" => "ConfirmedError",
							"description" => "El pago ya fue reversado."

						)

					]
				];

			}else{ // if($idestado_qr == 2){
				



				// Procesa los datos obtenidos del JSON
				$consulta = "
				INSERT INTO `confirmacion_pago_entidad`
				(
				`hook_alias`,
				`status`,
				`response_code`,
				`response_description`,
				`amount`,
				`currency`,
				`installment_number`,
				`description`,
				`date_time`,
				`ticket_number`,
				`authorization_code`,
				`commerce_name`,
				`branch_name`,
				`account_type`,
				`card_last_numbers`,
				`bin`,
				`merchant_code`,
				`payer`)
				VALUES
				(
					$hook_alias,
					$status,
					$response_code,
					$response_description,
					$amount,
					$currency,
					$installment_number,
					$description,
					$date_time,
					$ticket_number,
					$authorization_code,
					$commerce_name,
					$branch_name,
					$account_type,
					$card_last_numbers,
					$bin,
					$merchant_code,
					$payer);";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				// obtiene el id insertado
				$consulta="
				select id from confirmacion_pago_entidad where hook_alias = $hook_alias order by id desc limit 1
				";
				$rsconf=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));  
				$idconfirmapago=$rsconf->fields['id'];
				
				if($data['payment']['status'] == "confirmed"){
					
					// actualizar estado del qr
					$consulta="
					update bancard_qr set idestado_qr = 3 where hook_alias = $hook_alias
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));    
					
					
					if($idpostmp > 0){
						// generar pedido
						$consulta="
						select idwebpedido, idatc, idqrtmpmonto
						from pos_tmp
						where
						idpostmp = $idpostmp
						order by idpostmp desc
						limit 1
						";
						$rspostmp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));  
						$idwebpedido=intval($rspostmp->fields['idwebpedido']);
						$idatc=intval($rspostmp->fields['idatc']);
						$idqrtmpmonto=intval($rspostmp->fields['idqrtmpmonto']);
						//echo $idatc;
						// si es un pago parcial o con propina
						if($idqrtmpmonto > 0){
							$consulta="
							select monto_abonar, monto_propina, total_abonar
							from qr_tmp_monto
							where
							idqrtmpmonto = $idqrtmpmonto
							";
							$rsqrtmp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
							$monto_abonar=$rsqrtmp->fields['monto_abonar'];
							$monto_propina=$rsqrtmp->fields['monto_propina'];
							$total_abonar=$rsqrtmp->fields['total_abonar'];
							if(floatval($amount) != floatval($total_abonar)){
								echo "MONTO NO COINCIDE";
								exit;
							}
							// forzar este monto para pagos en mesas
							$amount=$monto_abonar;
							
						}
						// si no es un pago de una mesa
						if(intval($idatc) == 0){
							
							// si viene de web o selfservice web
							if($idwebpedido > 0){
								$consulta="
								select idsucursal_sugiere 
								from web_pedidos 
								where 
								idwebpedido = $idwebpedido
								";
								$rsweb=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));  
								$idsucursal=intval($rsweb->fields['idsucursal_sugiere']);
								
								// busca si ya fue aceptado 
								$consulta="
								select idtmpventares_cab
								from tmp_ventares_cab
								where
								idwebpedido = $idwebpedido
								";
								$rsped=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 
								$idtmpventares_cab=intval($rsped->fields['idtmpventares_cab']);
								//$monto=floatval($rsped->fields['monto']);
								
								// si aun no fue aceptado 
								if($idtmpventares_cab == 0){
									
									// funciones para pedidos
									require_once("includes/funciones_pedidos.php");
									
									$consulta="
									select idusu_pedido from preferencias_self
									";
									$rsprefself=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 
									$idusu_pedido=intval($rsprefself->fields['idusu_pedido']);
									if($idusu_pedido == 0){
										$idusu_pedido=1;
									}
								
									// aceptar pedido web
									$parametros_array=array(
										'idusu' => $idusu_pedido,
										'idsucursal' => $idsucursal,
										'idwebpedido' => $idwebpedido,
										'idatc' => '',
										'idapp' => '11',
									);
									$res=aceptar_pedido_web($parametros_array);
									$idtmpventares_cab=$res['idtmpventares_cab'];
									$idcliente=$res['idcliente'];
									
									
									$consulta="
									select idforma from formas_pago where sin_formapago_pos = 'S' order by idforma asc limit 1
									";
									$rssinforma=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
									$idformapago_pos_sinidentificar=intval($rssinforma->fields['idforma']);
									
									$consulta="
									select account_type
									from confirmacion_pago_entidad
									where 
									id = $idconfirmapago
									";
									$rstype=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
									// tarjeta credito
									if($rstype->fields['account_type'] == 'TC'){
										$idformapago_qr=2;
									}
									// tarjeta debito
									if($rstype->fields['account_type'] == 'TD'){
										$idformapago_qr=4;
									} 
									$monto_forma=floatval($amount);
									// insertar el pago en alguna tabla de pagos para que figure en central de pedidos
									/*$consulta="
									INSERT INTO `tmp_ventares_cab_fpag`
									(idtmpventares_cab, idformapago, monto_forma, estado, idconfirmapago_qr) 
									VALUES 
									($idtmpventares_cab,$idformapago_qr,$monto_forma,1, $idconfirmapago)
									";
									$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); */
									$consulta="
									update tmp_ventares_cab_fpag
									set
									monto_forma = $monto_forma,
									idconfirmapago_qr = $idconfirmapago,
									idformapago=$idformapago_qr,
									pago_confirmado='S'
									where
									idtmpventares_cab = $idtmpventares_cab
									and idformapago = 1
									";
									$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
								
								}
							} // if($idwebpedido > 0){
						
						// si es un pago de una mesa
						}else{
							$valido="S";
							$errores="";
							
							
							$idusu_pedido=1; // por defecto
							

							$consulta="
							select idusu_pedido from mesas_qr_preferencias limit 1
							";
							$rsusped=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
							$idusu_pedido=intval($rsusped->fields['idusu_pedido']);
							
							$consulta="
							select account_type
							from confirmacion_pago_entidad
							where 
							id = $idconfirmapago
							";
							$rstype=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
							// tarjeta credito
							if($rstype->fields['account_type'] == 'TC'){
								$idformapago_qr=2;
							}
							// tarjeta debito
							if($rstype->fields['account_type'] == 'TD'){
								$idformapago_qr=4;
							} 

							
							$monto_forma=floatval($amount);
							
							require_once("includes/funciones_mesas.php");
							
							// PARAMETROS PARA PAGO DE MESA
							$parametros_array['idatc']=$idatc;
							$parametros_array['idformapago']=intval($idformapago_qr);
							$parametros_array['montoabonado']=floatval($monto_forma);
							$parametros_array['idclientesel']=floatval(0);
							$parametros_array['iddenominaciontarjeta']=1;
							$parametros_array['banco']='';
							$parametros_array['cheque_numero']='';
							$parametros_array['otros_valores']='';
							$parametros_array['idusu']=$idusu_pedido;
							$parametros_array['idconfirmapago_qr']=$idconfirmapago;
							//print_r($parametros_array);
							//echo $idconfirmapago;exit;
							// validar cobro de mesa
							$res=valida_cobromesa($parametros_array);
							if($res['valido'] != 'S'){
								$valido=$res['valido'];
								$errores=$res['errores'];
								$cod_error=$res['cod_error'];
							}
							

							// si hay error normal
							if($valido != 'S'){
								// genera array con los datos
								$arr = array(
								'valido' => $valido,
								'errores' => $errores
								);
								
								// convierte a formato json
								$respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
								
								$json_validacion_interna_sql=antisqlinyeccion($respuesta,"textbox");

								// actualiza log
								$consulta="
								update log_bancard_vpos
								set 
								json_validacion_interna = $json_validacion_interna_sql
								where 
								idlog = $idlog
								";
								$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
								
								// si tiene un error especial mostrar
								if($cod_error == 2){
									// devuelve la respuesta formateada
									//echo $cod_error;
									//exit;
								}
								
							}
							
							//si todo fue valido
							if($valido == 'S'){
								$res=registra_cobromesa($parametros_array);

								
							}else{
								$enviar_a_bancard['status']="fail";
								$enviar_a_bancard['errores']=$errores;
							}
							
							// si hubo propina
							if($monto_propina > 0){
								
								// PARAMETROS PARA PROPINA DE MESA
								$parametros_array=array(
									'idatc' => $idatc,
									'monto_propina' => $monto_propina,
									'idusu' => $idusu_pedido,
									'idformapago' => $idformapago_qr,
								);
								
								// crear esta funcion
								$res=valida_propinamesa($parametros_array);
								if($res['valido'] != 'S'){
									$valido=$res['valido'];
									$errores=$res['errores'];
									$cod_error=$res['cod_error'];
								}
								
								//si todo fue valido
								if($valido == 'S'){
									$res=registra_propinamesa($parametros_array);

									
								}else{
									$enviar_a_bancard['status']="fail";
									$enviar_a_bancard['errores']=$errores;
								}
								
								
								
								
							}
							
							
							
							
						}
						
					
					}
					
					
					

					// RESPONDER A BANCARD
					$response = [
						"status" => "success",
						"message" => [

							array(

								"level" => "success",
								"key" => "Confirmed",
								"description" => "Pago recibido con exito"

							)

						]
					];



				}else{

					// actualizar estado del qr
					$consulta="
					update bancard_qr set idestado_qr = 4 where hook_alias = $hook_alias
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 	

					$response = [
						"status" => "error",
						"message" => [

							array(

								"level" => "error",
								"key" => "ConfirmedError",
								"description" => "No se pudo procesar la confirmacion"

							)

						]
					];


				}


			} // if($idestado_qr == 2){


        }

        // Establecer el código de estado HTTP 200 OK
        http_response_code(200);

        // Establecer las cabeceras para indicar que el contenido es JSON
        header('Content-Type: application/json');
		$json=json_encode($response, JSON_PRETTY_PRINT);

		$response_sql=antisqlinyeccion($json,"textbox");
        $hook_alias_sql=antisqlinyeccion($data['payment']['hook_alias'],"textbox");
		$consulta="
		UPDATE  log_bancard_qr_pant
		SET 
		json_enviado = $response_sql,
        hook_alias = $hook_alias_sql
		where
		idlog = $idlog
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

        // Enviar la respuesta como JSON
        echo $json;

    }
    
}

$provided_token = $_SERVER['HTTP_AUTHORIZATION'];

$consulta="
select usuario_nuestro, clave_nuestro from bancard_qr_preferencias limit 1
";
$rslogin=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$user = $rslogin->fields['usuario_nuestro']; //'InnovaUser';
$password =  $rslogin->fields['clave_nuestro']; //'InnovasysQR99988$#@-+';
$ip=antisqlinyeccion($_SERVER['REMOTE_ADDR'],'text');
$class_confirma_pago = new ConfirmaPago();

if ($_SERVER['REQUEST_METHOD'] === 'POST') {

	// datos recibidos
	$json_input = file_get_contents('php://input');

    // Verificar si se proporciona un encabezado "Authorization" con el formato "Bearer $token"
    $authorization_header = $_SERVER['HTTP_AUTHORIZATION'];
    $headers = getallheaders();
	$headers['info_adicional']['PHP_AUTH_USER'] = trim($_SERVER['PHP_AUTH_USER']);
	$headers['info_adicional']['PHP_AUTH_PW'] = trim($_SERVER['PHP_AUTH_PW']);
	$headers['info_adicional']['HTTP_AUTHORIZATION'] = trim($_SERVER['HTTP_AUTHORIZATION']);
	$headers['info_adicional']['HTTP_USER_AGENT'] = trim($_SERVER['HTTP_USER_AGENT']);
	$headers['info_adicional']['CONTENT_TYPE'] = trim($_SERVER['CONTENT_TYPE']);
	$headers['info_adicional']['REQUEST_SCHEME'] = trim($_SERVER['REQUEST_SCHEME']);
	$headers['info_adicional']['REQUEST_METHOD'] = trim($_SERVER['REQUEST_METHOD']);
	$headers['info_adicional']['REMOTE_ADDR'] = trim($_SERVER['REMOTE_ADDR']);
	$headers['info_adicional']['CONTENT_TYPE'] = trim($_SERVER['CONTENT_TYPE']);
	$headers['info_adicional']['UNIQUE_ID'] = trim($_SERVER['UNIQUE_ID']);
	$headers['info_adicional']['CONTENT_LENGTH'] = trim($_SERVER['CONTENT_LENGTH']);
	$headers['info_adicional']['HTTP_CONNECTION'] = trim($_SERVER['HTTP_CONNECTION']);
	$headers['info_adicional']['HTTP_ACCEPT'] = trim($_SERVER['HTTP_ACCEPT']);

	$headers_json=json_encode($headers, JSON_PRETTY_PRINT);

	// LOG
	$ahora=date("Y-m-d H:i:s");
	$header_sql=antisqlinyeccion($headers_json,"textbox");
	$json_sql=antisqlinyeccion($json_input,"textbox");
	$consulta="
	insert into log_bancard_qr_pant
	(json_enviado, json_recibido, header_recibido, fechahora, idpostmp, hook_alias, servicio, ip)
	values
	(NULL, $json_sql, $header_sql, '$ahora', NULL, NULL, 'CALLBACK', $ip)
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	select idlog from log_bancard_qr_pant where fechahora = '$ahora' order by idlog desc limit 1
	";
	$rslog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idlog=intval($rslog->fields['idlog']);
	// LOG

    if (isset($headers['Authorization'])) {
        
        if (!isset($_SERVER['PHP_AUTH_USER']) || !isset($_SERVER['PHP_AUTH_PW'])) {

            $data = array(

                "status" => False,
                "msg" => "Error no se recibieron las credenciales"
            );
        
            // Establecer el código de estado HTTP 200 OK
            http_response_code(400);
        
            // Establecer las cabeceras para indicar que el contenido es JSON
            header('Content-Type: application/json');
            
            $json = json_encode($data, JSON_PRETTY_PRINT);

			$response_sql=antisqlinyeccion($json,"textbox");
			$consulta="
			UPDATE  log_bancard_qr_pant
			SET 
			json_enviado = $response_sql
			where
			idlog = $idlog
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
        
            // Imprimir el JSON
            echo $json;
            die();

        }

        if (trim($_SERVER['PHP_AUTH_PW']) == $password && trim($_SERVER['PHP_AUTH_USER']) == $user) {

            $provided_token = $matches[1];

            if ($provided_token === $secret_token) {

                $class_confirma_pago->realizaConfirmacion($idlog,$json_input);

            } else {

                $data = array(

                    "status" => False,
                    "msg" => "Error tocken incorrecto"
                );

                // Establecer el código de estado HTTP 200 OK
                http_response_code(400);

                // Establecer las cabeceras para indicar que el contenido es JSON
                header('Content-Type: application/json');
                
                $json = json_encode($data, JSON_PRETTY_PRINT);

				$response_sql=antisqlinyeccion($json,"textbox");
				$consulta="
				UPDATE  log_bancard_qr_pant
				SET 
				json_enviado = $response_sql
				where
				idlog = $idlog
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

                // Imprimir el JSON
                echo $json;

            }

        }else{

            $data = array(

                "status" => False,
                "msg" => "Error credenciales incorrectas"
            );
        
            // Establecer el código de estado HTTP 200 OK
            http_response_code(400);
        
            // Establecer las cabeceras para indicar que el contenido es JSON
            header('Content-Type: application/json');
            
            $json = json_encode($data, JSON_PRETTY_PRINT);

			$response_sql=antisqlinyeccion($json,"textbox");
			$consulta="
			UPDATE  log_bancard_qr_pant
			SET 
			json_enviado = $response_sql
			where
			idlog = $idlog
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
        
            // Imprimir el JSON
            echo $json;    

        }

    }else{

        $data = array(

            "status" => False,
            "msg" => "Error autorizacion incorrecta"
        );
    
        // Establecer el código de estado HTTP 200 OK
        http_response_code(400);
    
        // Establecer las cabeceras para indicar que el contenido es JSON
        header('Content-Type: application/json');
        
        $json = json_encode($data, JSON_PRETTY_PRINT);

		$response_sql=antisqlinyeccion($json,"textbox");
		$consulta="
		UPDATE  log_bancard_qr_pant
		SET 
		json_enviado = $response_sql
		where
		idlog = $idlog
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
    
        // Imprimir el JSON
        echo $json;
        
    }

}else{

    $data = array(

        "status" => False,
        "msg" => "Error en la llamada API, Metodo no permitido."
    );

    // Establecer el código de estado HTTP 200 OK
    http_response_code(400);

    // Establecer las cabeceras para indicar que el contenido es JSON
    header('Content-Type: application/json');
    
    $json = json_encode($data, JSON_PRETTY_PRINT);

	// LOG
	$ahora=date("Y-m-d H:i:s");
	$json_sql=antisqlinyeccion($json,"textbox");
	$consulta="
	insert into log_bancard_qr_pant
	(json_enviado, json_recibido, fechahora, idpostmp, hook_alias, servicio)
	values
	($json_sql, NULL, '$ahora', NULL, NULL, 'CALLBACK')
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	// LOG

    // Imprimir el JSON
    echo $json;



}
