<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="21";
$submodulo="172";
require_once("includes/rsusuario.php"); 


if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Directorio donde se guardarán los archivos
    $target_dir = "imagenes/menupdf/";
    
    // Verificar si la carpeta existe, si no, crearla
    if (!is_dir($target_dir)) {
        mkdir($target_dir, 0777, true); // 0777 otorga permisos de lectura, escritura y ejecución para todos
        echo "Carpeta 'imagenes/menupdf' creada con permisos adecuados. ";
    }

    // Obtener información del archivo subido
    $file_name = basename($_FILES["fileToUpload"]["name"]);
    $target_file = $target_dir . $file_name;
    $file_type = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));
    $file_size = $_FILES["fileToUpload"]["size"];
    
    // Extensiones permitidas
    $allowed_extensions = ["pdf", "jpg"];
    
    // Validación: solo permitir archivos PDF o JPG y tamaño máximo de 2 MB
    if (!in_array($file_type, $allowed_extensions)) {
         $respuesta= "Solo se permiten archivos PDF o JPG.";
    } elseif ($file_size > 2 * 1024 * 1024) { // 2 MB en bytes
         $respuesta= "El archivo debe ser de 2 MB o menos.";
    } else {
        // Verificar si ya existe un archivo con la misma extensión en el directorio
        $existing_files = glob($target_dir . "*." . $file_type);
        if (count($existing_files) > 0) {
            // Borrar el archivo existente si es del mismo tipo
            foreach ($existing_files as $existing_file) {
                unlink($existing_file);
            }
        }

        // Subir el archivo
        if (move_uploaded_file($_FILES["fileToUpload"]["tmp_name"], $target_file)) {
            $respuesta= "El archivo " . $file_name . " ha sido subido correctamente.";
			 $preview = '<embed src="' . $target_file . '" width="600" height="400" type="application/pdf">';
        } else {
             $respuesta="Hubo un error al subir el archivo.";
        }
    }
}



?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title><?php require("includes/title.php"); ?></title>
<link rel="stylesheet" type="text/css" href="ani/css/demo.css" />
<link rel="stylesheet" type="text/css" href="ani/css/style2.css" />
<link rel="stylesheet" type="text/css" href="css/magnific-popup.css" />
<?php require("includes/head.php"); ?>
</head>
<body bgcolor="#FFFFFF">
	<?php require("includes/cabeza.php"); ?>    
	<div class="clear"></div>
		<div class="cuerpo">
			<div class="colcompleto" id="contenedor">
      <br /><br />

      <div class="divstd">
    		<span class="resaltaditomenor">
    			   Subir archivo PDF o JPG&nbsp;<br />
				   Al subir un nuevo documento se reemplaza el anterior autom&aacute;ticamente
    		</span>
 		</div>
        <br /><hr /><br />
			<div style="height:120px;text-align:center;width:100%;float:left;">
			
				<form action="" method="post" enctype="multipart/form-data">
					<div style="height:40px;text-align:center;width:40%;float:left;">
						<label for="fileToUpload">Selecciona un archivo (PDF o JPG):</label>
						
					</div>
					<div style="height:40px;text-align:center;width:80%;float:left;">
						<input type="file" name="fileToUpload" id="fileToUpload" required>
						<button type="submit">Subir archivo</button>
					</div>
				</form>
			</div><hr />
			<?php if($respuesta!=''){ ?>
			 <br /><br />
			<div style="height:80px;text-align:center;width:100%;font-size:18px;color:red;float:left;">
				<?php echo $respuesta; ?>
			</div>
			
			<?php } ?>
			 <?php
    // Mostrar la vista previa si es un PDF
    if (!empty($preview)) {
        echo "<h3>Vista previa del archivo PDF:</h3>";
        echo $preview;
    }
    ?>
		  </div> <!-- contenedor -->
   		<div class="clear"></div><!-- clear1 -->
	</div> <!-- cuerpo -->
	<div class="clear"></div><!-- clear2 -->
	<?php require("includes/pie.php"); ?>
</body>
</html>