<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="11";
$submodulo="282";
require_once("includes/rsusuario.php"); 


$ano=date("Y");
$inicio_ano=$ano.'-01-01';
$fin_ano=$ano.'-12-31';
$mes_actual=date("m");
$inicio_mes_actual=$ano.'-'.$mes_actual.'-01';

$consulta="
SELECT 
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    cuentas_clientes_pagos_cab
where
    cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
	AND DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
";
$rstot=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$cantidad_global=$rstot->fields['cantidad'];
$monto_global=$rstot->fields['total'];

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Informe de cobro de cuentas a credito</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<?php 
$refemenu="evodia";
require_once("includes/menu_cobro_inf.php"); ?>
<div class="clearfix"></div>
<hr />

 <div class="col-md-12">          
<p class="text-muted font-13 m-b-30">
Evolucion Diaria (Grafico por Linea una linea por mes)
</p>  
 <canvas id="chartjs-1" class="chartjs" width="undefined" height="undefined"></canvas>
</div>

 <div class="col-md-12">          
<p class="text-muted font-13 m-b-30">
Evolucion Diaria Consolidada (Excepto Mes Actual)
</p>  
 <canvas id="chartjs-2" class="chartjs" width="undefined" height="undefined"></canvas>
</div>


 <div class="col-md-12">          
<p class="text-muted font-13 m-b-30">
Evolucion Diaria Consolidada por Quintiles (Excepto Mes Actual)
</p>  
 <canvas id="chartjs-3" class="chartjs" width="undefined" height="undefined"></canvas>
</div>

<div class="clearfix"></div>
<hr />
<?php

$consulta="
WITH RECURSIVE fechas_ano AS (
    SELECT '$inicio_ano' AS fecha
    UNION ALL
    SELECT DATE_ADD(fecha, INTERVAL 1 DAY)
    FROM fechas_ano
    WHERE fecha < '$fin_ano'
)
SELECT 
    DAY(fechas_ano.fecha) AS dia,
    YEAR(fechas_ano.fecha) AS ano,
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    fechas_ano
LEFT JOIN 
    cuentas_clientes_pagos_cab
ON 
    DATE(cuentas_clientes_pagos_cab.fecha_pago) = fechas_ano.fecha
    AND cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
	AND DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
GROUP BY 
    YEAR(fechas_ano.fecha), DAY(fechas_ano.fecha)
ORDER BY 
    YEAR(fechas_ano.fecha) ASC,  DAY(fechas_ano.fecha) ASC;
";
$rsmes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
?>
<p class="text-muted font-13 m-b-30" style="font-weight:bold;">
Evolucion Diaria Consolidada (Excepto Mes Actual):
</p>  
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
          <thead>
            <tr>
              <th align="center" ><strong>Dia</strong></th>
              <th align="center" ><strong>Cantidad de Recibos</strong></th>
              <th align="center" ><strong>Monto Cobrado</strong></th>
			  <th align="center" ><strong>Monto Promedio</strong></th>
			  <th align="center" ><strong>% Cantidad</strong></th>
			  <th align="center" ><strong>% Monto</strong></th>
            </tr>
            </thead>
            <tbody>
           <?php  while (!$rsmes->EOF){ 
		   $totalacum+=$rsmes->fields['total'];
		   
		   ?>
            <tr>
              <td align="center"><?php echo $rsmes->fields['dia'];  ?></td>
              <td align="right"><?php echo formatomoneda($rsmes->fields['cantidad']); ?></td>
              <td align="right"><?php echo formatomoneda($rsmes->fields['total']); ?></td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['total']/$rsmes->fields['cantidad']); ?></td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['cantidad']/$cantidad_global*100); ?>%</td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['total']/$monto_global*100); ?>%</td>
            </tr>
           <?php  $rsmes->MoveNext(); } $rsmes->MoveFirst();  ?> 
          </tbody>
      </table>
</div>

<?php

$consulta = "
WITH RECURSIVE fechas_ano AS (
    SELECT '$inicio_ano' AS fecha
    UNION ALL
    SELECT DATE_ADD(fecha, INTERVAL 1 DAY)
    FROM fechas_ano
    WHERE fecha < '$fin_ano'
)
SELECT 
    YEAR(fechas_ano.fecha) AS ano,
    CASE 
        WHEN DAY(fechas_ano.fecha) BETWEEN 1 AND 5 THEN '1-5'
        WHEN DAY(fechas_ano.fecha) BETWEEN 6 AND 10 THEN '6-10'
        WHEN DAY(fechas_ano.fecha) BETWEEN 11 AND 15 THEN '11-15'
        WHEN DAY(fechas_ano.fecha) BETWEEN 16 AND 20 THEN '16-20'
        WHEN DAY(fechas_ano.fecha) BETWEEN 21 AND 25 THEN '21-25'
        WHEN DAY(fechas_ano.fecha) BETWEEN 26 AND 31 THEN '26-31'
    END AS quintil,
    CASE 
        WHEN DAY(fechas_ano.fecha) BETWEEN 1 AND 5 THEN '1'
        WHEN DAY(fechas_ano.fecha) BETWEEN 6 AND 10 THEN '2'
        WHEN DAY(fechas_ano.fecha) BETWEEN 11 AND 15 THEN '3'
        WHEN DAY(fechas_ano.fecha) BETWEEN 16 AND 20 THEN '4'
        WHEN DAY(fechas_ano.fecha) BETWEEN 21 AND 25 THEN '5'
        WHEN DAY(fechas_ano.fecha) BETWEEN 26 AND 31 THEN '6'
    END AS quintil_orden,
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    fechas_ano
LEFT JOIN 
    cuentas_clientes_pagos_cab
ON 
    DATE(cuentas_clientes_pagos_cab.fecha_pago) = fechas_ano.fecha
    AND cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
    AND DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
GROUP BY 
    YEAR(fechas_ano.fecha),  quintil, quintil_orden
ORDER BY 
      quintil_orden ASC;
";
$rsmes = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

?>
<p class="text-muted font-13 m-b-30" style="font-weight:bold;">
Evolucion Diaria Consolidada por Quintiles (Excepto Mes Actual):
</p>  
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
          <thead>
            <tr>
              <th align="center" ><strong>Quintil</strong></th>
              <th align="center" ><strong>Cantidad de Recibos</strong></th>
              <th align="center" ><strong>Monto Cobrado</strong></th>
			  <th align="center" ><strong>Monto Promedio</strong></th>
			  <th align="center" ><strong>% Cantidad</strong></th>
			  <th align="center" ><strong>% Monto</strong></th>
            </tr>
            </thead>
            <tbody>
           <?php  while (!$rsmes->EOF){ 
		   $totalacum+=$rsmes->fields['total'];
		   
		   ?>
            <tr>
              <td align="center"><?php echo $rsmes->fields['quintil'];  ?></td>
              <td align="right"><?php echo formatomoneda($rsmes->fields['cantidad']); ?></td>
              <td align="right"><?php echo formatomoneda($rsmes->fields['total']); ?></td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['total']/$rsmes->fields['cantidad']); ?></td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['cantidad']/$cantidad_global*100); ?>%</td>
			  <td align="right"><?php echo formatomoneda($rsmes->fields['total']/$monto_global*100); ?>%</td>
            </tr>
           <?php  $rsmes->MoveNext(); } $rsmes->MoveFirst();  ?> 
          </tbody>
      </table>
</div>

<div class="clearfix"></div>
<br />

<div class="clearfix"></div>
<br /><br /><br /><br />


                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>

<?php 

$consulta="
WITH RECURSIVE fechas_ano AS (
    SELECT '$inicio_ano' AS fecha
    UNION ALL
    SELECT DATE_ADD(fecha, INTERVAL 1 DAY)
    FROM fechas_ano
    WHERE fecha < '$fin_ano'
)
SELECT 
    DAY(fechas_ano.fecha) AS dia,
    MONTH(fechas_ano.fecha) AS mes,
    YEAR(fechas_ano.fecha) AS ano,
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    fechas_ano
LEFT JOIN 
    cuentas_clientes_pagos_cab
ON 
    DATE(cuentas_clientes_pagos_cab.fecha_pago) = fechas_ano.fecha
    AND cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
	and DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
GROUP BY 
    YEAR(fechas_ano.fecha), MONTH(fechas_ano.fecha), DAY(fechas_ano.fecha)
ORDER BY 
    YEAR(fechas_ano.fecha) ASC, MONTH(fechas_ano.fecha) ASC, DAY(fechas_ano.fecha) ASC;
";
$rsmes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$rschart = $rsmes;
$data_cant = [];
$data_labels = "";
$month_names = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];

// Inicializa los datos para cada mes
foreach (range(1, 12) as $mes) {
    $data_cant[$mes] = array_fill(1, 31, 0); // Inicializa con 0 para todos los días
}

// Procesa los datos del resultado
while (!$rschart->EOF) {
    $dia = $rschart->fields['dia'];
    $mes = $rschart->fields['mes'];
    $data_cant[$mes][$dia] = $rschart->fields['total'];
    $rschart->MoveNext();
}

// Genera las etiquetas para los días
for ($i = 1; $i <= 31; $i++) {
    $data_labels .= '"' . $i . '", ';
}
$data_labels = rtrim($data_labels, ", ");

// color  de cada mes
$color_mes=array(
	1 => "#FF5733",
	2 => "#33FF57",
	3 => "#3357FF",
	4 => "#FF33A1",
	5 => "#33FFA1",
	6 => "#A133FF",
	7 => "#FF8C33",
	8 => "#8CFF33",
	9 => "#338CFF",
	10 => "#FF33FF",
	11 => "#33FFFF",
	12 => "#FFFF33"
);

// Genera los datos para cada mes
$data_js = "";
foreach ($data_cant as $mes => $dias) {
    $data_js .= '{
        "label": "' . $month_names[$mes - 1] . '",
        "data": [' . implode(", ", $dias) . '],
        "fill": false,
        "backgroundColor": "'.$color_mes[$mes].'",
        "borderColor": "'.$color_mes[$mes].'",
        "borderWidth": 2
    }, ';
}
$data_js = rtrim($data_js, ", ");



?>
<script>
new Chart(document.getElementById("chartjs-1"), {
    "type": "line",
    "data": {
        "labels": [<?php echo $data_labels ?>],
        "datasets": [<?php echo $data_js; ?>]
    },
    "options": {
        "scales": {
            "xAxes": [{
                "ticks": {
                    "beginAtZero": true
                }
            }]
        }
    }
});
<?php 


$consulta="
WITH RECURSIVE fechas_ano AS (
    SELECT '$inicio_ano' AS fecha
    UNION ALL
    SELECT DATE_ADD(fecha, INTERVAL 1 DAY)
    FROM fechas_ano
    WHERE fecha < '$fin_ano'
)
SELECT 
    DAY(fechas_ano.fecha) AS dia,
    YEAR(fechas_ano.fecha) AS ano,
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    fechas_ano
LEFT JOIN 
    cuentas_clientes_pagos_cab
ON 
    DATE(cuentas_clientes_pagos_cab.fecha_pago) = fechas_ano.fecha
    AND cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
	AND DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
GROUP BY 
    YEAR(fechas_ano.fecha), DAY(fechas_ano.fecha)
ORDER BY 
    YEAR(fechas_ano.fecha) ASC,  DAY(fechas_ano.fecha) ASC;
";
$rsmes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));


$rschart = $rsmes;
$data_cant = [];
$data_labels = "";

// Inicializa los datos para cada mes
foreach (range(1, 1) as $mes) {
    $data_cant[$mes] = array_fill(1, 31, 0); // Inicializa con 0 para todos los días
}

//print_r($data_cant);exit;


// Procesa los datos del resultado
while (!$rschart->EOF) {
    $dia = $rschart->fields['dia'];
    $mes = 1;
    $data_cant[$mes][$dia] = $rschart->fields['total'];
    $rschart->MoveNext();
}

// Genera las etiquetas para los días
for ($i = 1; $i <= 31; $i++) {
    $data_labels .= '"' . $i . '", ';
}
$data_labels = rtrim($data_labels, ", ");


// Genera los datos para cada mes
$data_js = "";
foreach ($data_cant as $mes => $dias) {
    $data_js .= '{
        "label": "Meses Consolidados del '.$ano.'",
        "data": [' . implode(", ", $dias) . '],
        "fill": false,
        "backgroundColor": "red",
        "borderColor": "red",
        "borderWidth": 2
    }, ';
}
$data_js = rtrim($data_js, ", ");



?>
new Chart(document.getElementById("chartjs-2"), {
    "type": "bar",
    "data": {
        "labels": [<?php echo $data_labels ?>],
        "datasets": [<?php echo $data_js; ?>]
    },
    "options": {
        "scales": {
            "xAxes": [{
                "ticks": {
                    "beginAtZero": true
                }
            }]
        }
    }
});
<?php 


$consulta = "
WITH RECURSIVE fechas_ano AS (
    SELECT '$inicio_ano' AS fecha
    UNION ALL
    SELECT DATE_ADD(fecha, INTERVAL 1 DAY)
    FROM fechas_ano
    WHERE fecha < '$fin_ano'
)
SELECT 
    YEAR(fechas_ano.fecha) AS ano,
    CASE 
        WHEN DAY(fechas_ano.fecha) BETWEEN 1 AND 5 THEN '1-5'
        WHEN DAY(fechas_ano.fecha) BETWEEN 6 AND 10 THEN '6-10'
        WHEN DAY(fechas_ano.fecha) BETWEEN 11 AND 15 THEN '11-15'
        WHEN DAY(fechas_ano.fecha) BETWEEN 16 AND 20 THEN '16-20'
        WHEN DAY(fechas_ano.fecha) BETWEEN 21 AND 25 THEN '21-25'
        WHEN DAY(fechas_ano.fecha) BETWEEN 26 AND 31 THEN '26-31'
    END AS quintil,
    COALESCE(COUNT(cuentas_clientes_pagos_cab.idcuentaclientepagcab), 0) AS cantidad,
    COALESCE(SUM(cuentas_clientes_pagos_cab.monto_abonado), 0) AS total
FROM
    fechas_ano
LEFT JOIN 
    cuentas_clientes_pagos_cab
ON 
    DATE(cuentas_clientes_pagos_cab.fecha_pago) = fechas_ano.fecha
    AND cuentas_clientes_pagos_cab.estado = 1
    AND YEAR(cuentas_clientes_pagos_cab.fecha_pago) = $ano
    AND DATE(cuentas_clientes_pagos_cab.fecha_pago) < '$inicio_mes_actual'
    AND cuentas_clientes_pagos_cab.notanum IS NULL
GROUP BY 
    YEAR(fechas_ano.fecha),  quintil
ORDER BY 
    YEAR(fechas_ano.fecha) ASC,  quintil ASC;
";
$rsmes = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

$rschart = $rsmes;
$data_cant = [];
$data_labels = "";

// Inicializa los datos para cada mes
foreach ($month_names as $mes) {
    $data_cant[1] = array_fill(0, 6, 0); // Inicializa con 0 para todos los quintiles
}
//print_r($data_cant);exit;
// Procesa los datos del resultado
while (!$rschart->EOF) {
    //$mes_num = $rschart->fields['mes'];
    $quintil = $rschart->fields['quintil'];
    //$mes = $month_names[$mes_num - 1];
    $quintil_index = array_search($quintil, ['1-5', '6-10', '11-15', '16-20', '21-25', '26-31']);
    $data_cant[1][$quintil_index] = $rschart->fields['total'];
    $rschart->MoveNext();
}

// Genera las etiquetas para los quintiles
$data_labels = '"1-5", "6-10", "11-15", "16-20", "21-25", "26-31"';

// Genera los datos para cada mes
$data_js = "";
foreach ($data_cant as $mes => $quintiles) {
   // $color = sprintf('#%06X', mt_rand(0, 0xFFFFFF)); // Genera un color aleatorio para cada mes
    $data_js .= '{
        "label": "Meses Consolidados por Quintiles del '.$ano.'",
        "data": [' . implode(", ", $quintiles) . '],
        "fill": false,
        "backgroundColor": "green",
        "borderColor": "green",
        "borderWidth": 2
    }, ';
}
$data_js = rtrim($data_js, ", ");

?>
new Chart(document.getElementById("chartjs-3"), {
    type: "bar",
    data: {
        labels: [<?php echo $data_labels; ?>],
        datasets: [<?php echo $data_js; ?>]
    },
    options: {
        scales: {
            xAxes: [{
                ticks: {
                    beginAtZero: true
                }
            }]
        }
    }
});
</script>
  </body>
</html>
