<?php
/*-----------------------------------
17/03/2025: Se revisan procedimientos
26/03/2025: Se verifica la venta a credito, se incorporan los codigos de autorizacion en caso de estar activados
---------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="38";
$submodulo="701";
require_once("includes/rsusuario.php"); 
require_once("includes/funciones_stock.php");
require_once("includes/funciones_comisiones.php");
require_once('peluqueria/mini_funciones_nuevo.php');

/*-------------------------------APERTURA DE CAJA--------------------------------*/
$array_entrada=array();
$parametros_caja_new=array(
    'idcajero' => $idusu,
    'sucursalid' => $idsucursal,
    'idtipocaja' => 1
);
//print_r($parametros_caja_new);
$comprobarcaja=comprobar_caja($parametros_caja_new);

$idcaja=intval($comprobarcaja);

if ($idcaja==0){
    header("location: gest_administrar_caja.php");exit;
}
//Comprobar existencia de deposito de ventas

$consulta="
SELECT * 
FROM gest_depositos
where
tiposala = 2
and idempresa = $idempresa
and idsucursal = $idsucursal
and estado = 1
";
$rsdep = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$iddeposito=intval($rsdep->fields['iddeposito']);
if($iddeposito == 0){
    $errores.="No existe deposito de ventas asignado a la sucursal actual.";
    $valido="N";
}
/*------------------------PREFERENCIAS Y CONTROL DE FACTURAS-----------------*/
$buscar="Select * from preferencias where idempresa=$idempresa";
$rspref=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$obliga_factura=trim($rspref->fields['factura_obliga']);
$script=trim($rspref->fields['script_factura']);
$usa_descuento=$rspref->fields['usa_descuento'];
$usa_tarjeta_autorizacion=$rspref->fields['usa_descuento'];
$bloquear=intval($rspref->fields['autorizar']);
$controlfactura=intval($rspref->fields['controlafactura']);
$autoimpresor=trim($rspref->fields['auto_impresor']);

//Vemos preferencias de codigos,pines y tarjetas de autorizacion
$buscar="Select * from preferencias_caja ";
$rsprefcaja=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$usar_tarjeta_autorizacion=trim($rsprefcaja->fields['usar_tarjeta_autorizacion']);
$usar_pin=trim($rsprefcaja->fields['usar_pin']);
$usa_cotizacion=trim($rsprefcaja->fields['usa_cotizacion']);
$usa_multi_moneda=trim($rsprefcaja->fields['usa_cotizacion']);

if ($controlfactura==1){

    $ano=date("Y");
    // busca si existe algun registro
    $buscar="
    Select max(numfac) as mayor 
    from lastcomprobantes 
    where 
    idsuc=$factura_suc 
    and pe=$factura_pexp 
    and idempresa=$idempresa 
    order by ano desc 
    limit 1";
    $rsfactura=$conexion->Execute($buscar) or die(errorpg( $conexion,$buscar));
    $maxnfac=intval(($rsfactura->fields['mayor'])+1);
    if($maxnfac <= 1){
     
                    $consulta="
                    INSERT INTO lastcomprobantes
                    (idsuc, factura, numfac, recibo, numrec, tickete, numtk, ano, pe, numcheque, secuencia_cancela, 
                    numhoja, hojalevante, idempresa) 
                    VALUES
                    ($factura_suc, 0, $maxnfac, NULL, 0, NULL, 0, $ano, $factura_pexp, NULL, 
                    NULL, 0, '', $idempresa)
                    ";
                    $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
    }
}

$parte1=intval($factura_suc);
$parte2=intval($factura_pexp);
if($parte1 == 0 or $parte2 == 0){
    $parte1f='001';
    $parte2f='001';
}else{
    $parte1f=agregacero($parte1,3);
    $parte2f=agregacero($parte2,3);
}
/*-----------------------------FINAL CONTROL DE FACTURAS-------------------------*/
//Eliminar articulo del carrito
$eliminar=intval($_REQUEST['el']);
if ($eliminar>0){
    $delete="delete from carrito_tarjeta where idtarjeta=$eliminar and idusu=$idusu";
    $conexion->Execute($delete) or die(errorpg($conexion,$delete));
    
    //ahora los pagos del carrito
    $delete="delete from tarjetas_cobros_deta where estadopago=1 and registrado_por=$idusu";
    $conexion->Execute($delete) or die(errorpg($conexion,$delete));
    
    header("location: cobro_servicios_peluq.php");exit;
    
}
/*---------------------------------POST DE COBRO--------------------------------------*/
if (isset($_POST['ruc']) && ($_POST['ocidtrans'])){
	$errores="";
	$valido='S';
    //------------------------Transacciones de cabecera-----------------------------//
	$idtransaccion=intval($_POST['ocidtrans']);//Esta ahora es la transaccion de cobro
	if($idtransaccion==0){
		$errores.="* No se recibio el codigo de transaccion para cobranza.<br />";
		$valido='N';
	}
	$idtarjeta=intval($_POST['ocidtarjeta']);//recibimos la tarjeta seleccionada
	if($idtarjeta==0){
		$errores.="* No se recibio el id de la tarjeta seleccionada para el cobro.<br />";
		$valido='N';
	}
	//Buscamos la transaccion activa para esa tarjeta
	$buscar="Select * from tarjetas_transacciones where idtarjeta=$idtarjeta  and estado=1 order by idtrans desc limit 1";
	$rsbusqueda=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$idtransaccion_tarjeta=intval($rsbusqueda->fields['idtrans']);
	if($idtransaccion_tarjeta==0){
		$errores.="* La transaccion perteneciente a la tarjeta no ha sido recibida.<br />";
		$valido='N';
	}
    $tipofacturacion=1;//1Tradicional o 2Diplomatico
    $formaventa=intval($_POST['tipoventa']);//2Credito-1Contado
	if($formaventa==0){
		$errores.="* Debe indicar si la venta es credio o contado.<br />";
		$valido='N';
	}
    $textoimpresion=1;//intval($_POST['timpre']); //Indica si es la lista de productos o consumision agrupada
    //Numeros de la Factura
    
	/* Se anula, ahora usa preferencia 
		if (isset($_POST['solotk'])) {
		//echo "El checkbox está marcado.";
		$factunum=0;
		
	} 
	*/
	$factunum=intval($_POST['factu1']);
    $sucuf=intval($_POST['sucu1']);
    $punf=intval($_POST['pun1']);
    //Datos del Cliente
    //print_r($_POST);exit;
    $idcliente=intval($_POST['ocidcliente']);
   // $tipoventa=1;//intval($_POST['ventatip']);
     
	if($idcliente==0){
		$errores.="* Debe indicar el cliente o bien registrarlo en el formulario de seleccion de clientes.<br />";
		$valido='N';
	}
	if($idcliente==1 && $formaventa==2){
		$errores.="* Debe indicar un cliente con linea de credito para venta credito.El cliente por defecto NO posee linea de credito permitida.<br />";
		$valido='N';
	}
	if($idcliente>1 && $formaventa==2){
		
		$verifica_cliente_linea_credito=verifica_linea_credito($idcliente,$idtransaccion_tarjeta);
		if ($verifica_cliente_linea_credito['valido']=='N'){
			
			$errores.=trim($verifica_cliente_linea_credito['errores']);
			$valido='N';
		}
		
		
	}
/*


   if ($tipoventa==1){
        //ruc
        $documento=antisqlinyeccion($_POST['ruc'],'text');
        $documento=str_replace("'","",$documento);
        $add=" where ruc='$documento' ";
        $diplomatico='N';
    } else {
        if ($tipoventa==2){
            //carnet
            $documento=antisqlinyeccion($_POST['carnet'],'text');
            $documento=str_replace("'","",$documento);
            $add=" where ruc='$documento' ";
            $diplomatico='S';
        }
    }
    $ruc=antisqlinyeccion($_POST['ruc'],'text');
    $razon_social=antisqlinyeccion($_POST['rz'],'text');
    $razon_social=str_replace("'","",$razon_social);
    $ex=explode(" ",$razon_social);
    $nc=$ex[0];
    $ap=$ex[1];
    
    
    if($ruc=="'X'"){
        $buscar="Select * from cliente where ruc=$ruc and estado=1 limit 1";
        $rsgen=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
        $idcliente=intval($rsgen->fields['idcliente']);
    }
    //echo $idcliente.'aca';
    //print_r($_POST);exit;
	
	
	*/
    /*-----------------REGISTRO DE NUEVO CLIENTE SE ANUA Y SE OBLIGA A CREAR O SELECCIONAR EN EL FORM---------*/
    /*if ($idcliente==0){
        //viene vacio o no existe, registramos el cliente
        
        $buscar="Select * from cliente where ruc='$documento'";
        $rscon=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
        if (intval($rscon->fields['idcliente'])==0){
            
            //cambiar aa la Funcion de registrar cliente!!!!
            
            $insertar="Insert into cliente (razon_social,nombre, apellido,ruc,diplomatico,registrado_por,registrado_el,idempresa) values ('$razon_social','$nc','$ap','$documento','$diplomatico',$idusu,current_timestamp,$idempresa)";
            $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
            
            //Traemos el id del cliente
            $buscar="Select * from cliente where registrado_por=$idusu order by idcliente desc limit 1";
            $rsclie=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
            $idcliente=intval($rsclie->fields['idcliente']);
        }
        
        
    }*/
    /*----------------------------------------------------------------------------------*/
    if ($errores=='' && $valido=='S'){
		//print_r($_POST);exit;
		$buscar="Select * from tarjetas_cobros_deta where registrado_por=$idusu and estadopago=1 ";
        $rsl=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idtransaccion_activa=intval($rsl->fields['idtrans']);
		//echo $idtransaccion_activa;exit;
        //echo "falta funcion de registrar ventas<br />";
        $array_entrada['sucursalid']=$idsucursal;
        $array_entrada['idcaja']=$idcaja;
        $array_entrada['idtransaccion']=$idtransaccion;
		$array_entrada['idtransaccion_tarjeta']=$idtransaccion_tarjeta;
		
        $array_entrada['idatc']="";//ATC en curso
        $array_entrada['idmesa']="";//Id de la mesa
        $array_entrada['tipofactura']='S';//Indica si es factura simple o multiple
        $array_entrada['tipofacturacion']=$tipofacturacion;//Indica si es factura normal o diplomatica
        $array_entrada['formaventa']=$formaventa;//Indica si es vta cred o contado
        $array_entrada['textoimpresion']=$textoimpresion;//Indica si se imprimen productos o agrupados
        $array_entrada['idcliente']="$idcliente";
        $array_entrada['iddeposito']="$iddeposito";
        $array_entrada['idempresa']="$idempresa";
        $array_entrada['idsucursal']="$idsucursal";
        $array_entrada['cajeroid']="$idusu";
        $array_entrada['mozoid']="";
        $array_entrada['sucursalfc']="$sucuf";
        $array_entrada['pefc']="$punf";
        $array_entrada['facturanum']="$factunum";

        $idv=registrarventa($array_entrada);
		
        //Si hay venta continuamos
        if ($idv > 0){
			if($formaventa==2){
				//cambiamos a credito
				$update="Update ventas set tipo_venta=$formaventa,formapago=0 where idventa=$idv";
				$conexion->Execute($update) or die(errorpg($conexion,$update));
				
				
				
			}
            // Genera la comision para el profesional
            genera_comision_profesional($idv);

            //recorremos las tarjetas para marcar las transacciones
			//Actualizar saldo del titular
			

           
            while(!$rsl->EOF){
			//	$delete="Delete from carrito_tarjeta where idtarjeta=$idtarjeta";
				//$conexion->Execute($delete) or die(errorpg($conexion,$delete));
				
                $idtarjeta=intval($rsl->fields['idtarjeta']);
                $idtransaccion_activa=intval($rsl->fields['idtrans']);

				$update="update  tarjetas_cobros_deta set idventa=$idv,estadopago=3 where idtarjeta=$idtarjeta ";
                $conexion->Execute($update) or die(errorpg($conexion,$update));
                
				//marcamos la transaccion
                $update="update   tarjetas_transacciones set cajero=$idusu ,cobrado_el=current_timestamp,estado=3 where idtarjeta=$idtarjeta ";
                $conexion->Execute($update) or die(errorpg($conexion,$update));

                $rsl->MoveNext();
            }
			
			
			$update="update tarjetas_transacciones_cobros set idventa=$idv,estado=3,finalizado_el='$ahora' where registrado_por=$idusu and estado=1 ";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
			
			$update="Update tarjetas_transacciones set cajero=$idusu,estado=3,idventa=$idv,cobrado_el='$ahora' where idtrans=$idtransaccion_activa";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
			
			
			if($factunum==0){
				$tk=2;
			
			} else {
				$tk=1;
				
			}
			//?tk=2&modventa=22&v=27
			header("location: script_central_impresion.php?tk=$tk&modventa=22&v=$idv");
			exit;

            header("Location: cobro_servicios_peluq.php");exit;
 
        }
        exit; 
    } 
}
/*--------------------------------------------------FINAL DE POST FACTURACION----------------------------------*/
/*-------------------------------------SELECCION DE TARJETA------------------------------------------------------*/
$tb=trim($_REQUEST['tarje']);
if ($tb!=''){
    //Generamos una transaccion para el usuario, si es que no hay
    
    $buscar="Select * from tarjetas_transacciones where cajero=$idusu and estado=1";
    $rst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	//echo $buscar;exit;
    $idtransaccion=$rst->fields['idtrans'];
	
	//echo $idtransaccion;exit;
	
	
    if ($idtransaccion==0){
        $insertar="Insert into tarjetas_transacciones (cajero,estado) values ($idusu,1)"    ;
        $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
        
        $buscar="Select * from tarjetas_transacciones where cajero=$idusu and estado=1";
        $rst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
        $idtransaccion=$rst->fields['idtrans'];
    }
    $tt=antisqlinyeccion($tb,'text');
   
   $buscar="Select * from tarjetas_activas where numero=$tb";
    $rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
    
    $idtarjeta=intval($rs->fields['idtarjeta']);
    
    $buscar="Select sum(monto) as tabonar from tmp_ventares_cab where idtarjeta=$idtarjeta and registrado='N' and finalizado='S' and idventa is null";
    $rsm=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
    $monto=floatval($rsm->fields['tabonar']);
    
    //Insertamos en el carrito solo si no esta
    
    $buscar="Select * from carrito_tarjeta where idtarjeta=$idtarjeta and monto=$monto ";
    $rscon=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));


    if ($rscon->fields['idtarjeta']==''){
        
        $insertar="insert into carrito_tarjeta (idtarjeta,monto,idcaja,idusu) values ($idtarjeta,$monto,0,$idusu)";
        $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
        //marcamos los temporales con el id de transaccion
        
        $update="Update tmp_ventares_cab set idtrans=$idtransaccion where idtarjeta=$idtarjeta and registrado='N' and finalizado='S' and idventa is null";
        $conexion->Execute($update) or die(errorpg($conexion,$update));
        
        //Ahora el cuerpo
        $update="Update tmp_ventares set idtrans=$idtransaccion where idtarjeta=$idtarjeta and registrado='N' and finalizado='S' and borrado='N'";
        $conexion->Execute($update) or die(errorpg($conexion,$update));

        
        header("location: cobro_servicios_peluq.php");exit;
    }
    
}
/*----------------------------------FIN DE SELECCION DE RTARJETA----------------------------*/
//Buscamos si existe una transaccion para el cobro actual en curso
$buscar="Select * from tarjetas_transacciones_cobros where registrado_por=$idusu and estado=1";
$rgb=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
//echo $buscar;exit;
$idtransaccion_cobro=intval($rgb->fields['idtransaccion_cobro']);

if ($idtransaccion_cobro==0){
    $insertar="insert into tarjetas_transacciones_cobros (registrado_por,registrado_el,estado) values ($idusu,'$ahora',1)";
    $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
    $buscar="Select * from tarjetas_transacciones_cobros where registrado_por=$idusu and estado=1";
    $rgb=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
    $idtransaccion_cobro=intval($rgb->fields['idtransaccion_cobro']);
}

$buscar="Select * from tarjetas_transacciones_cobros where registrado_por=$idusu and estado=1";
$rgb=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$idtransaccion_cobro=intval($rgb->fields['idtransaccion_cobro']);
if($idtransaccion_cobro==0){
	
	echo "Error al obtener codio de transaccion para cobranza activa.";exit;
	
}
/*--------------------HASTA ENCONTRAL SOLUCION FINAL--------------------*/
$buscar="Select idtrans from tarjetas_transacciones where estado=1 order by idtrans asc";
$rscontrol=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
while(!$rscontrol->EOF){
	$idtransaccion_local=intval($rscontrol->fields['idtrans']);
	$buscar="Select idtmpventares_cab,sum(subtotal) as total from tmp_ventares where borrado='N' and idtrans = $idtransaccion_local group by idtmpventares_cab ";
	$rss=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	while(!$rss->EOF){
		
		$idcabeza=intval($rss->fields['idtmpventares_cab']);
		$subtotal=floatval($rss->fields['total']);
		$update="update tmp_ventares_cab set monto=$subtotal where idtmpventares_cab=$idcabeza";
		//echo $update."<br />";
		
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		$rss->MoveNext();
	}
		
	$rscontrol->MoveNext();
}
/*--------------------HASTA ENCONTRAL SOLUCION FINAL--------------------*/


//Buscamos si existen tarjetas pendientes de cobro para mostrar en acceso rapido
$buscar="Select
 razon_social as ccnombre,numero,sum(subtotal) as tglobal,tmp_ventares.idtarjeta

 from tmp_ventares
 inner join tarjetas_activas on tarjetas_activas.idtarjeta=tmp_ventares.idtarjeta
 inner join tmp_ventares_cab on tmp_ventares_cab.idtmpventares_cab=tmp_ventares.idtmpventares_cab
where tmp_ventares_cab.idtarjeta > 0 and tmp_ventares_cab.estado<>6
and tmp_ventares.idtrans in (select idtrans from tarjetas_transacciones where estado=1)
 and tmp_ventares.registrado='N' and tmp_ventares.borrado='N'
group by tmp_ventares_cab.idtarjeta,date(tmp_ventares.fechahora) 
order by tmp_ventares_cab.idtarjeta,date(tmp_ventares.fechahora) desc
";

$buscar="Select date(fechahora) as fecha,razon_social as ccnombre,sum(monto) as tglobal,tmp_ventares_cab.idtarjeta ,numero
from tmp_ventares_cab 
inner join tarjetas_activas on tarjetas_activas.idtarjeta=tmp_ventares_cab.idtarjeta
where monto > 0 and  tmp_ventares_cab.idtarjeta > 0 and estado <>6 and idventa is null
group by idtarjeta
";

$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$tcan=$rs->RecordCount();




/*----------------OTROS CURSORES------------------------*/
$buscar="
	Select ruc, razon_social 
	from cliente 
	where 
	borrable = 'N' 
	and estado <> 6 
	order by idcliente asc 
	limit 1
	";
	//echo  $buscar;exit;
	$rsf=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$genericoruc=trim($rsf->fields['ruc']);
	$genericodv="";
	$razon=trim($rsf->fields['razon_social']);
	$razon_social_pred=$razon;

	$buscar="
	select * from formas_pago where estado=1
	";
	$rsformas = $conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tot=$rsformas->RecordCount();    

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                     <h2>Cobranza de servicios por tarjeta - IDT: <?php echo $idtransaccion_cobro;?></h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					<?php if($errores!=''){ ?>
					<div class="alert alert-danger">
						Errores encontrados<br />
						<?php echo $errores; ?>
						<span class="fa fa-info-circle"></span>&nbsp;Seleccione nuevamente la tarjeta y corrija los errores indicados.
					</div>
					<?php } ?>
					<div class="col-md-12 col-xs-6">
						
							<?php if ($tcan > 0){?>
								<div class="col-md-6 col-sm-6  form-group has-feedback">
									<input type="text" class="form-control has-feedback-left" id="bcodebus" name="bcodebus" placeholder="Leer/buscar tarjeta">
									<span class="fa fa-barcode form-control-feedback left" aria-hidden="true"></span>
									<a class="btn btn-dark" href="gest_impresiones.php" target="_blank"><span class="fa fa-print"></span>Reimpresion documentos</a>
									&nbsp;
									<a class="btn btn-danger" href="gest_administrar_caja_new.php" target="_blank"><span class="fa fa-gear"></span>Administrar Caja</a>
								</div>
								<div class="col-md-6 col-sm-6  form-group has-feedback">
									<select class="select2_multiple form-control" multiple="multiple" name="selectarje" id="selectarje" onchange="seleccionar_tarjeta_cobrar(this.value);" >

										<?php while (!$rs->EOF){ 
										$idtarje=intval($rs->fields['idtarjeta']);
										if($idtarje>0){
										?>
										<option value="<?php echo $rs->fields['idtarjeta'] ?>"><?php echo $rs->fields['ccnombre'] ?>-> <strong>Tarjeta.N:&nbsp;<?php echo $rs->fields['numero'] ?></strong> | Gs. &nbsp;<?php echo formatomoneda($rs->fields['tglobal'],4,'N'); ?>&nbsp;<!--|&nbsp; IDT:<?php echo formatomoneda($rs->fields['idtrans'],4,'N'); ?>--></option>
										<?php } ?>
										<?php $rs->MoveNext();} ?>
									</select>
								</div>
							<?php } else {?>    
							  <input class="form-control" type="text" />
							
							<?php } ?>
					</div>
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
           
             <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                     <h2>Detalle de Servicios/consumos</h2>
                   
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					<?php if($idtransaccion_cobro >0){ 
							$buscar="Select *,
							(Select numero 
								from tarjetas_activas where idtarjeta=tarjetas_transacciones_cobros_detalles.idtarjeta) as numero
							from
							tarjetas_transacciones_cobros_detalles where  estado=1 
							and idtransaccion_cobro=$idtransaccion_cobro";
							//echo $buscar;
							$rscarrito=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
							$tregg=$rscarrito->RecordCount();
							if ($tregg==0){
								$mensaje="<h2>No se seleccionaron tarjetas para cobrar. Seleccione un elemento de la lista para continuar.</h2>";
								echo $mensaje;
							} else {
								
							?>		
							
							<div class="col-md-12 col-xs-12" id="detallado_carrito" >
								<?php require_once('cobro_ventaxtarjeta_carrito.php'); ?>
							</div>
							<!------------------------------FACTURACION-------------------------------->
						<form id="ggh" action="" method="post">
						
						<div class="col-md-12 col-xs-12" style="box-shadow: rgba(0, 0, 0, 0.16) 0px 1px 4px, rgb(51, 51, 51) 0px 0px 0px 3px;">
							<!------------------------------PANEL1------------------------------->
							<div class="col-md-6 col-xs-6">
								<h2>Datos Facturaci&oacute;n</h2>
										<input type="hidden" name="ocidtarjeta" id="ocidtarjeta" value="<?php echo intval($_REQUEST['idtar']); ?>" />
										<input type="hidden" name="ocidtrans" id="ocidtrans" value="<?php echo $idtransaccion_cobro; ?>" />
										<div class="col-md-12 col-xs-12 col-sm-12">
											<label>Factura N&uacute;mero</label>
											<div class="form-group row ">
													
													<div class="col-md-4 col-xs-6">
														<input type="text"  class="form-control"  placeholder="SUC" name="sucu1" id="sucu1"   value="<?php echo $parte1f?>" />
													</div> 
													<div class="col-md-4 col-xs-6">
														<input type="text"  class="form-control" placeholder="PE"  name="pun1" id="pun1" value="<?php echo $parte2f?>"  />
													</div> 
													<div class="col-md-4 col-xs-6">
														<input type="text"  class="form-control" placeholder="FACTURA" name="factu1" id="factu1"   value="<?php echo $maxnfac?>" />
													</div> 
											</div>
											<div class="clearfix"></div>
											<div class="form-group row ">
												<label class="control-label col-md-3 col-sm-3 ">RUC / Razon Social</label>
												<div class="col-md-12 col-xs-12 col-xm-12">
													<div class="col-md-6 col-sm-6">
													<?php 
													$buscar="Select idcliente,razon_social,ruc from cliente where borrable='N' and estado=1 limit 1";
													$rsdef=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
													$ruc_pred=trim($rsdef->fields['ruc']);
													$razon_social_pred=trim($rsdef->fields['razon_social']);
													$idcliente_pred=intval($rsdef->fields['idcliente']);
													?>
														<input type="text"  name="ruc" id="ruc" class="form-control" value="<?php echo $ruc_pred?>"  />
															<a href="javascript:void(0);" style=""  onclick="carga_ruc_h();" class="btn btn-sm btn-default" title="" data-toggle="tooltip" data-placement="right" data-original-title="Buscar"><span class="fa fa-search"></span></a>
															<a href="javascript:void(0);" style=""  onclick="valordef(<?php echo $idcliente_pred; ?>,'<?php echo $ruc_pred?>','<?php echo $razon_social_pred?>');" class="btn btn-sm btn-default" title="" data-toggle="tooltip" data-placement="right" data-original-title="Generico"><span class="fa fa-arrow-left"></span></a>
													
													</div>
													<div class="col-md-6 col-sm-6 col-xs-12 " id="regclie">
														<?php require_once("tarjeta_mregclie.php"); ?>
													</div>        
												</div>
											</div>    
										</div>
										
										
							</div>
							<!------------------------------PANEL2-------------------------------->
							<div class="col-md-6 col-xs-6">
							<p></p>
								<h2>Medios de pago</h2>
								<div class="col-md-12 col-xs-12 col-sm-12">
										<div class="form-group row ">
											<label class="control-label col-md-3 col-sm-3 ">Condicion Venta</label>
												<div class="col-md-9 col-sm-9 ">
													<select name="tipoventa" id="tipoventa" style="height: 40px; width: 90%;" onchange="controlar_este(this.value);">
													  <option value="1" selected>CONTADO</option>
													  <option value="2">CREDITO</option>
											 
													</select>
												</div>
										</div>
										<div id="formas_pago_lista_add">
										<div class="form-group row ">
											<label class="control-label col-md-3 col-sm-3 ">Forma Pago</label>
												<div class="col-md-9 col-sm-9 ">
													<select name="mpago" id="mpago" style="height: 40px; width: 90%;">
													  <?php while (!$rsformas->EOF){?>
													  <option value="<?php echo $rsformas->fields['idforma'] ?>"><?php echo $rsformas->fields['descripcion']?></option>
													  <?php $rsformas->MoveNext();}?>
																				 
													</select>
												</div>
										</div>
										<div class="form-group row ">
											<label class="control-label col-md-3 col-sm-3 ">Monto Abonar</label>
												<div class="col-md-9 col-sm-9 ">
													<input type="text" name="monto" id="monto" style="height:40px; width:50%;" value="">
													<input type="button" class="btn btn-success" name="o" value="Agregar" onclick="registrarpago(<?php echo $idtarjeta ?>);">
												</div>
										</div>
										</div>
								</div>
							</div>
							
							<div class="col-md-12 col-xs-12" id="boton_cierre" style="display:none;text-align:center;">
								<button type="button" id="cierremesa" name="cierremesa" class="btn-btn-round btn-success btn-sm" onClick="cerrar_venta();"><span class="fa fa-save"></span>&nbsp;&nbsp;Generar Venta FC</button>
							</div>
							
							
						</div>
						</form>
						<div class="clearfix"></div>	
						<p></p>
                        <div class="col-md-12 col-xs-12" id="mediospagosc" style="box-shadow: rgba(6, 24, 44, 0.4) 0px 0px 0px 2px, rgba(6, 24, 44, 0.65) 0px 4px 6px -1px, rgba(255, 255, 255, 0.08) 0px 1px 0px inset;">
                             <?php require_once('mini_cobros_tarjeta_nuevo.php'); ?>
                        
                        
                        </div>
							
							
							<!--------------------------------------------------------------------->
							<?php }//de si hay tarjeta seleccionada?>
					<?php }//de idtransaccion cobro > 0 ?>
                </div>
              </div>
            </div>
			</div>
            <!-- SECCION --> 
              <div class="modal fade" id="modpop"  role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
              <div class="modal-content">

                <!-- Modal Header -->
                <div class="modal-header">
                  
                    <div class="alert alert-danger alert-dismissible fade in" role="alert" id="errorescod" style="display: none">
                        <strong>Errores:</strong><br /><span id="errorescodcuerpo"></span>
                        </div>
                    <span  id="modal_titulo" style="font-weight:bold;"></span>
                  <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>

                <!-- Modal body -->
                <div class="modal-body" id="modal_cuerpo" style="height: 500px; overflow-y: scroll">
                  
                </div>

                <!-- Modal footer -->
                <div class="modal-footer">
                  <input type="hidden" name="occantidad" id="occantidad" value="0" />
                                                      <input type="hidden" name="ocserial" id="ocserial" value="0" />
                    <span  id="controlcito" style="display: none"></span>
                </div>

              </div>
            </div>
          </div>
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
 <script>
 function controlar_este(valor){
	if (valor==1){
		$("#formas_pago_lista_add").show();
		$("#mediospagosc").show();
		$("#boton_cierre").hide();
		
	}
	if (valor==2){
		$("#formas_pago_lista_add").hide();
		$("#mediospagosc").hide();
		$("#boton_cierre").show();
	}
 

 }
 function eliminar_temporal(idunicotmp,numero_tarjeta){
		if(idunicotmp!='' && numero_tarjeta!=''){
			var parametros = {
				 "numero_tarjeta"         : numero_tarjeta,
				 "borrar"				: idunicotmp
			 };
			 $.ajax({
				 data:  parametros,
				 url:   '/peluqueria/mini_consumo_tarjeta.php',
				 type:  'post',
				 beforeSend: function () {
					// $("#listaproductos").html("<br /><br />Esperando servicios ... <br /><br />");
				 },
				 success:  function (response) {
					// alert(response);
					 $("#modal_cuerpo").html(response);	
					 if(response=='OK'){
						  window.location.href='cobro_servicios_peluq.php';
						 
						 
					 }
					// $("#modpop").modal("show");	 
				 }
			 });
			
		}
		
	}
	function ver_consumo(tarjeta){
		
		$("#modal_titulo").html("Consumo por tarjeta");
		 
		var numero_tarjeta="";
		numero_tarjeta=tarjeta;
		if (numero_tarjeta!=''){
			var parametros = {
				 "numero_tarjeta"         : numero_tarjeta
			 };
			 $.ajax({
				 data:  parametros,
				 url:   '/peluqueria/mini_consumo_tarjeta.php',
				 type:  'post',
				 beforeSend: function () {
					// $("#listaproductos").html("<br /><br />Esperando servicios ... <br /><br />");
				 },
				 success:  function (response) {
					 $("#modal_cuerpo").html(response);			 
					 $("#modpop").modal("show");
								 
				 }
			 });
		}
	}
    function seleccionar_tarjeta_cobrar(idtarjeta){
		//alert('abrir_seleccion');
        var parametros = {
            "idtarjeta" 		: idtarjeta,
            "cargar_carrito" 	: 1,
			"idcaja"			:<?php echo $idcaja; ?>,
            "transaccion_cobro" : <?php echo $idtransaccion_cobro; ?>
        };
        $.ajax({
		
            data:  parametros,
            url:   'mini_selecciona_tarjeta_well.php',
            type:  'post',
            beforeSend: function () {
                $("#detallado").html("");
            },
            success:  function (response) {
              // alert(response);
                $("#detallado").html(response);
                $("#detallado").show();
                window.location.href='cobro_servicios_peluq.php?idtar='+idtarjeta;
            }     
        
         });    
    }
    function sacar_tarjeta(idtarjeta){
        var parametros = {
            "idtarjeta" : idtarjeta,
            "evento"    : 2
        };
        $.ajax({
            data:  parametros,
            url:   'mini_selecciona_tarjeta_well.php',
            type:  'post',
            beforeSend: function () {
                $("#detallado").html("");
            },
            success:  function (response) {

                $("#detallado").html(response);
                $("#detallado").show();

            }     
        
         });
        
        
    }
    function chaupago(idcobser){
    
    var parametros = {
        "idcobser" : idcobser,
        "eliminar" : 1
    };
    $.ajax({
        data:  parametros,
        url:   'mini_cobros_tarjeta_nuevo.php',
        type:  'post',
        beforeSend: function () {
            $("#mediospagosc").html("");
        },
        success:  function (response) {

            $("#mediospagosc").html(response);

        }     
    
     });
    
    
    
}
    
    function valordef(vv,v1,v2){
        $("#ruc").val(v1);
        $("#rz").val(v2);
		 $("#ocidcliente").val(vv);
        
    }
    function carga_ruc_h(){
        
        var vruc = $("#ruc").val();
        var txtbusca="Buscando...";
        if(txtbusca != vruc){
            var parametros = {
                    "ruc" : vruc
            };
            $.ajax({
                    data:  parametros,
                    url:   'ruc_extrae_deliv.php',
                    type:  'post',
                    beforeSend: function () {
                        $("#ruc").val(txtbusca);
                    },
                    success:  function (response) {
                        if(IsJsonString(response)){
                            var obj = jQuery.parseJSON(response);
                            //alert(response);
                            if(obj.error == ''){
                                var new_ruc = obj.ruc;
                                var new_rz = obj.razon_social;
                                //var new_nom = obj.nombre_ruc;
                                //var new_ape = obj.apellido_ruc;
                                var idcli = obj.idcliente;
                                $("#ruc").val(new_ruc);
                                $("#rz").val(new_rz);
                                $("#ocidcliente").val(idcli);
                                //$("#nombre").val(new_nom);
                                //$("#apellido").val(new_ape);
                                //if(parseInt(idcli)>0){
                                    //nclie(tipocobro,idpedido);
                                    //selecciona_cliente(idcli,tipocobro,idpedido);
                                //}
                            }else{
                                $("#ruc").val(vruc);
                                $("#rz").val('');
                                $("#ocidcliente").val(0);
                            }
                        }else{
            
                            alert(response);
                    
                        }
                        
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        if(jqXHR.status == 404){
                            alert('Pagina no encontrada. '+jqXHR.status+' '+errorThrown);
                        }else if(jqXHR.status == 0){
                            alert('Se ha rechazado la conexión.');
                        }else{
                            alert(jqXHR.status+' '+errorThrown);
                        }
                    }
            }).fail( function( jqXHR, textStatus, errorThrown ) {
                if (jqXHR.status === 0) {
                
                    alert('No conectado: verifique la red.');
                
                } else if (jqXHR.status == 404) {
                
                    alert('Pagina no encontrada [404]');
                
                } else if (jqXHR.status == 500) {
                
                    alert('Internal Server Error [500].');
                
                } else if (textStatus === 'parsererror') {
                
                    alert('Requested JSON parse failed.');
                
                } else if (textStatus === 'timeout') {
                
                    alert('Tiempo de espera agotado, time out error.');
                
                } else if (textStatus === 'abort') {
                
                    alert('Solicitud ajax abortada.'); // Ajax request aborted.
                
                } else {
                
                    alert('Uncaught Error: ' + jqXHR.responseText);
                
                }
            });
        }
    }
    function registrarpago(idtarjeta){
    var monto=$("#monto").val();
    var fpago=$("#mpago").val();
    if (monto!='' && fpago !=''){
         var parametros = {
            "monto" : monto,
            "forma" : fpago,
            "idtarjeta": idtarjeta

        };
          $.ajax({
                data:  parametros,
                url:   'mini_cobros_tarjeta_nuevo.php',
                type:  'post',
                beforeSend: function () {
                    $("#mediospagosc").html("");
                },
                success:  function (response) {
    
                    $("#mediospagosc").html(response);
    
                }     
    
     });
        
        
        
        
        
    } else {
        alert('Debe indicar medio y forma de pago')    ;
    }
}
function cerrar_venta(){
    $("#ggh").submit();
    
    
}
    </script>
  </body>
</html>