<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="11";
$submodulo="542";
require_once("includes/rsusuario.php"); 

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-d");
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));	
}
if(trim($_GET['hdesde']) == '' or trim($_GET['hhasta']) == ''){
	$hdesde="00:00";
	$hhasta="23:59";
}else{
	$hdesde=date("H:i",strtotime($_GET['hdesde']));
	$hhasta=date("H:i",strtotime($_GET['hhasta']));	
}
$desde_completo=$desde." ".$hdesde.':00';
$hasta_completo=$hasta." ".$hhasta.':59';

$idmesa=intval($_GET['idmesa']);
if($idmesa > 0){
	$whereadd.=" and mesas_atc.idmesa = $idmesa ";
}

// rellena fecha de cierre
$consulta="
update mesas_atc
set 
fecha_cierre = (select fecha from ventas where idatc = mesas_atc.idatc)
where 
fecha_cierre is null 
and estado = 3
";
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$consulta="
select idatc, fecha_inicio as apertura_mesa, sucursales.nombre as sucursal, mesas.numero_mesa, salon.nombre as salon,
CASE WHEN
	mesas_atc.estado = 1
THEN 
	'ABIERTO'
ELSE
	'CERRADO'
END as estado_txt,
cant_adultos,
cant_ninos,
cant_nopaga,
fecha_cierre,
TIME_TO_SEC(TIMEDIFF(fecha_cierre,fecha_inicio)) as seg_dif,
COALESCE((select totalcobrar from ventas where idatc = mesas_atc.idatc),0) as monto_venta,
COALESCE((select totalcobrar from ventas where idatc = mesas_atc.idatc),0)/COALESCE(cant_adultos,0) as tk_prom_adultos,
COALESCE((select totalcobrar from ventas where idatc = mesas_atc.idatc),0)/COALESCE(cant_ninos,0) as tk_prom_ninos,
COALESCE((select totalcobrar from ventas where idatc = mesas_atc.idatc),0)/COALESCE(cant_nopaga,0) as tk_prom_nopaga,
COALESCE(cant_adultos,0)+COALESCE(cant_ninos,0)+COALESCE(cant_nopaga,0) as cantidad_total,
COALESCE((select totalcobrar from ventas where idatc = mesas_atc.idatc),0)/(COALESCE(cant_adultos,0)+COALESCE(cant_ninos,0)+COALESCE(cant_nopaga,0)) as tk_prom_total

from mesas_atc 
inner join sucursales on sucursales.idsucu = mesas_atc.idsucursal
inner join mesas on mesas.idmesa = mesas_atc.idmesa
inner join salon on salon.idsalon = mesas.idsalon
where
mesas_atc.estado <> 6
and mesas_atc.estado = 3
and date(mesas_atc.fecha_inicio) >= '$desde' 
and date(mesas_atc.fecha_inicio) <= '$hasta' 
and mesas_atc.fecha_inicio >= '$desde_completo' 
and mesas_atc.fecha_inicio <= '$hasta_completo' 
$whereadd
order by idatc asc
";
$rs = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Informe de Comensales</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">


<form id="form1" name="form1" method="get" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Fecha Desde *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="desde" id="desde" value="<?php  echo $desde; ?>" placeholder="Desde" class="form-control" required />                    

	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Fecha Hasta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="hasta" id="hasta" value="<?php echo $hasta; ?>" placeholder="Hasta" class="form-control" required />                    

	</div>
</div>
	

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Mesa *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php 
// consulta
$consulta="
SELECT idmesa, CONCAT('MESA: ',numero_mesa,' | Salon: ',salon.nombre, ' | Sucursal: ',sucursales.nombre) AS mesa
FROM mesas
inner join salon on mesas.idsalon = salon.idsalon
inner join sucursales on sucursales.idsucu = mesas.idsucursal
where
mesas.estadoex = 1
order by numero_mesa asc, sucursales.nombre asc, salon.nombre asc
 ";

// valor seleccionado
if(isset($_GET['idmesa'])){ 
	$value_selected=htmlentities($_GET['idmesa']); 
}else{
	$value_selected="";
}

// parametros
$parametros_array=array(
	'nombre_campo' => 'idmesa',
	'id_campo' => 'idmesa',
	
	'nombre_campo_bd' => 'mesa',
	'id_campo_bd' => 'idmesa',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'TODAS',
	'pricampo_value' => '',
	'style_input' => 'class="form-control"', 
	'acciones' => '  ',
	'autosel_1registro' => 'N'

);

// construye campo
echo campo_select($consulta,$parametros_array);
		
		?>               
	</div>
</div>
	
<div class="clearfix"></div>
<br />

    <div class="form-group">
		<div class="col-md-12 col-sm-12 col-xs-12 text-center">
        
	   <button type="submit" class="btn btn-default" ><span class="fa fa-search"></span> Generar Reporte</button>

        </div>
    </div>
</form>
<br />
<hr />

<a href="comensales_mesa_csv.php<?php echo parametros_url(); ?>" class="btn btn-sm btn-default"><span class="fa fa-file-excel-o"></span> Descargar CSV</a>
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>

			<th align="center">idtc</th>
			<th align="center">Apertura</th>
			<th align="center">Cierre</th>
			<th align="center">Tiempo Ocupado</th>
			<th align="center">Monto Venta</th>
			<th align="center">Sucursal</th>
			<th align="center">Salon</th>
			<th align="center">Numero Mesa</th>
			<th align="center">Cant Adultos</th>
			<th align="center">TK Prom Adultos</th>
			<th align="center">Cant Ni&ntilde;os</th>
			<th align="center">TK Prom Ni&ntilde;os</th>
			<th align="center">Cant Ni&ntilde;os (No Pagan)</th>
			<th align="center">TK Prom (No Pagan)</th>
			<th align="center">Cant Total</th>
			<th align="center">TK Prom Total</th>
			<th align="center">Estado</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){

		  
?>
		<tr>

			<td align="center"><?php echo intval($rs->fields['idatc']); ?></td>
			<td align="center"><?php if($rs->fields['apertura_mesa'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['apertura_mesa'])); }  ?></td>
			<td align="center"><?php if($rs->fields['fecha_cierre'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['fecha_cierre'])); }  ?></td>
			<td align="center"><?php echo transcurrido($rs->fields['seg_dif']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['monto_venta']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['sucursal']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['salon']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['numero_mesa']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['cant_adultos']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['tk_prom_adultos']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['cant_ninos']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['tk_prom_ninos']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['cant_nopagan']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['tk_prom_nopaga']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['cantidad_total']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['tk_prom_total']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['estado_txt']); ?></td>
			

			
		</tr>
<?php 

$rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>
    </table>
</div>
<br />		  
					  
					  

<br /><br />

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            

            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
