<?php
/*----------------------------
30/08/2024:Se agrega Multi moneda (moneda y tipo)
03/09: Se sube a todos
------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo = "1";
$submodulo = "183";
require_once("includes/rsusuario.php");

if (isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'form1') {

    // recibe parametros
    $cotizacion = antisqlinyeccion($_POST['cotizacion'], "float");
    $estado = antisqlinyeccion(1, "int");
    $fecha = antisqlinyeccion($ahora, "text");
    $tipo_moneda = antisqlinyeccion($_POST['tipo_moneda'], "int");
    $buscar = "select idmoneda from tipo_moneda where idtipo=$tipo_moneda";
    $rgd = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));

    // validaciones basicas
    $valido = "S";
    $errores = "";

    if (intval($_POST['cotizacion']) == 0) {
        $valido = "N";
        $errores .= " - El campo cotizacion no puede ser cero o nulo.<br />";
    }
    if (intval($_POST['tipo_moneda']) == 0) {
        $valido = "N";
        $errores .= " - El campo tipo_moneda no puede ser cero o nulo.<br />";
    }
    $idmoneda = intval($rgd->fields['idmoneda']);
    if ($idmoneda == 0) {
        $valido = "N";
        $errores .= " -El id de la moneda no se ha definido en la tabla tipo_moneda.<br />";
    }

    // si todo es correcto inserta
    if ($valido == "S") {

        $consulta = "
        insert into cotizaciones
        (cotizacion, estado, fecha, tipo_moneda,idmoneda)
        values
        ($cotizacion, $estado, $fecha, $tipo_moneda,$idmoneda)
        ";
        $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

        header("location: cotizaciones.php");
        exit;
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <title><?php require("includes/title.php"); ?></title>
    <link rel="stylesheet" type="text/css" href="ani/css/demo.css" />
    <link rel="stylesheet" type="text/css" href="ani/css/style2.css" />
    <link rel="stylesheet" type="text/css" href="css/magnific-popup.css" />
    <?php require("includes/head.php"); ?>
</head>

<body bgcolor="#FFFFFF">
    <?php require("includes/cabeza.php"); ?>
    <div class="clear"></div>
    <div class="cuerpo">
        <div class="colcompleto" id="contenedor">
            <br /><br />
            <div align="center">
                <table width="70" border="0">
                    <tbody>
                        <tr>
                            <td width="62"><a href="cotizaciones.php"><img src="img/homeblue.png" width="64" height="64" title="Regresar" /></a></td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="divstd">
                <span class="resaltaditomenor">
                    Agregar cotizaci&oacute;n diaria<br />
                </span>
            </div>
            <br />
            <hr />

            <p align="center">&nbsp;</p>
            <p align="center">&nbsp;</p>
            <p>&nbsp;</p>
            <?php if (trim($errores) != "") { ?>
                <div class="mensaje" style="border:1px solid #F00; background-color:#FFC; font-size:12px; padding:10px; margin:10px auto; width:500px; text-align:center;"><strong>Errores:</strong> <br /><?php echo $errores; ?></div><br />
            <?php } ?>
            <form id="form1" name="form1" method="post" action="">
                <table width="400" border="1" class="tablaconborde" align="center">
                    <tbody>

                        <tr>
                            <td width="168" align="center">* Cotizaci&oacute;n </td>
                            <td width="216" align="left"><input type="text" name="cotizacion" id="cotizacion" value="<?php if (isset($_POST['cotizacion'])) {
                                                                                                                            echo htmlentities($_POST['cotizacion']);
                                                                                                                        } else {
                                                                                                                            echo htmlentities($rs->fields['cotizacion']);
                                                                                                                        } ?>" placeholder="cotizacion" required="required" style="height: 40px; width: 99%;" /></td>
                        </tr>

                        <tr>
                            <td height="41" align="center"><a href="monedas_extrangeras.php">[+]</a> *Moneda Extranjera:</td>
                            <td width="216" align="left"><?php
                                                            // consulta
                                                            $consulta = "select * from tipo_moneda  where estado = 1 and idempresa = $idempresa and borrable = 'S'";

                                                            // valor seleccionado
                                                            if (isset($_POST['idtipo'])) {
                                                                $value_selected = htmlentities($_POST['tipo_moneda']);
                                                            } else {
                                                                $value_selected = htmlentities($rs->fields['idtipo']);
                                                            }

                                                            // parametros
                                                            $parametros_array = array(
                                                                'nombre_campo' => 'tipo_moneda',
                                                                'id_campo' => 'tipo_moneda',

                                                                'nombre_campo_bd' => 'descripcion',
                                                                'id_campo_bd' => 'idtipo',

                                                                'value_selected' => $value_selected,

                                                                'pricampo_name' => 'Seleccionar...',
                                                                'pricampo_value' => ''
                                                            );

                                                            // construye campo
                                                            echo campo_select($consulta, $parametros_array);

                                                            ?></td>
                        </tr>

                    </tbody>
                </table>
                <br />
                <p align="center">
                    <input type="submit" name="button" id="button" value="Registrar" />
                    <input type="hidden" name="MM_insert" value="form1" />
                </p>
                <br />
            </form>
            <br /><br /><br />



        </div> <!-- contenedor -->
        <div class="clear"></div><!-- clear1 -->
    </div> <!-- cuerpo -->
    <div class="clear"></div><!-- clear2 -->
    <?php require("includes/pie.php"); ?>
</body>

</html>