<?php
/*-----------------------------
22/08/2023
Se corrigen errores y se agrega limpieza de temporales
-------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="1";
$submodulo="2";
require_once("includes/rsusuario.php"); 


function cuadro_amortizacion_frances($capital,$interes,$monto_cuota,$plazo,$tasa,$decimales=0){
	$saldo_insoluto=$capital;
	$saldo_deuda=$capital+$interes;
	$comprobacion=$monto_cuota*$plazo;
	if($comprobacion > $saldo_deuda){
		$saldo_deuda=$comprobacion;	
	}
	if($saldo_deuda < $saldo_insoluto){
		$saldo_deuda=$saldo_insoluto;	
	}
	$tasa_anual=($tasa/100)/12;
	for($i=1;$i<=$plazo;$i++){
		$interes_cuo=round(($saldo_insoluto*$tasa_anual),$decimales);
		$amortizacion=round(($monto_cuota-$interes_cuo),$decimales);
		$cuadro[$i]['ncuota']=$i;
		$cuadro[$i]['saldo_insoluto']=$saldo_insoluto;
		$cuadro[$i]['saldo_deuda']=$saldo_deuda;
		$cuadro[$i]['monto_cuota']=$monto_cuota;
		$cuadro[$i]['interes']=$interes_cuo;
		$cuadro[$i]['amortizacion']=$amortizacion;
		$saldo_insoluto=$saldo_insoluto-$amortizacion;
		$saldo_deuda=$saldo_deuda-$monto_cuota;
	}
	$cuadronew=redondear_cuadro_frances($cuadro,$capital,$interes,$plazo);
	return $cuadronew;
}


function redondear_cuadro_frances($res,$capital,$interes,$plazo){
	//print_r($res);
	$i=1;
	foreach ($res as $valor){
		if($i == 1){
			$saldo_insoluto_ini=round($valor['saldo_deuda']);
		}
		$cuota=$valor['ncuota'];
		$amortizacion=round($valor['amortizacion']);
		$interes_cuo=round($valor['interes']);
		$saldo_insoluto=round($valor['saldo_insoluto']);
		$saldo_deuda=round($valor['saldo_deuda']);
		$monto_cuota=round($valor['monto_cuota']);
		$gastos=0;
		$sumacapital+=$amortizacion;
		$sumainteres+=$interes_cuo;
		$sumacuota+=$monto_cuota;
		$i++;
	}
	//Ajuste de capital
	if ($sumacapital < $capital) {
		$diferencp=$capital-$sumacapital;
		//$amortred=$amortred+$diferencp;	
		//$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']+$amortred;
		$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']+$diferencp;
		$sumacapital=$sumacapital+$diferencp;
	} else if ($sumacapital > $capital) {
		$diferencp=$sumacapital-$capital;
		//$amortred=$amortred-$diferencp;	
		//$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']-$amortred;
		$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']-$diferencp;
		$sumacapital=$sumacapital-$diferencp;
	}
	//Ajuste de Interes
	if ($sumainteres < $interes) {
		$diferenint=$interes-$sumainteres;
		$res[$plazo]['interes'] = $res[$plazo]['interes']+$diferenint;
		$inteimprime=$inteimprime+$diferenint;	
		$sumainteres=$sumainteres+$diferenint;	
	} else if ($sumainteres > $interes) {

		$diferenint=$sumainteres-$interes;
		$res[$plazo]['interes'] = $res[$plazo]['interes']-$diferenint;
		$inteimprime=$inteimprime-$diferenint;
		$sumainteres=$sumainteres-$diferenint;		
	}
	//echo $saldo_insoluto_ini;
	// ajuste de cuota
	if($sumacuota < $saldo_insoluto_ini){
		//echo $sumacuota;
		$diferencuo=$saldo_insoluto_ini-$sumacuota;
		$res[$plazo]['monto_cuota'] = $res[$plazo]['monto_cuota']+$diferencuo;
		$sumacuota=$sumacuota+$diferencuo;
	} else if ($sumacuota > $saldo_insoluto_ini) {
		$diferencuo=$sumacuota-$saldo_insoluto_ini;
		$res[$plazo]['monto_cuota'] = $res[$plazo]['monto_cuota']-$diferencuo;
		$cuoimprime=$cuoimprime-$diferencuo;
		$sumacuota=$sumacuota-$diferencuo;	
	}
	return $res;
	
} 
/*-------------------------------------------------------------*/
$documento=intval($_POST['documento']);
$pp=intval($_POST['plazo']);
$monto=floatval($_POST['monto']);
$calculin=intval($_POST['calcular']);
if ($_POST['primervto']!=''){
	$primervto=date("Y-m-d",strtotime($_POST['primervto']));
}
/*-------------------------------------------------------------*/

if ($calculin==1){
	
	//$delete="delete from ";
	
	
	//generamos y calculamos
	//print_r($_POST);
	$plazo=intval($_POST['plazo']);
	$monto=intval($_POST['monto']);
	$primervto=antisqlinyeccion($_POST['primervto'],'date');
	$documento=intval($_POST['documento']);
	//echo $primervto;
	$capital=$monto;
	$interes=0;
	$monto_cuota=round($monto/$plazo,0);
	//$plazo=$plazosoli;
	$tasa=0;
	$decimales=0;
	$monto_cuota=redondear_tresceros($monto_cuota);
	$res=cuadro_amortizacion_frances($capital,$interes,$monto_cuota,$plazo,$tasa,$decimales);
	 
	$i=1;
	//$vencimiento=date("Y-m-d");
	$vencimiento=str_replace("'","",$primervto);
	///echo $vencimiento;
	$vtoant=$vencimiento;
	$diavenc=date("d",strtotime($vencimiento));
	
	//Verificamos si ya existe una cabecera
	$buscar="Select * from cuadro_amortizacion_cab where registrado_por=$idusu and estado=1 and documento=$documento and idsolicitudcab is NULL";
	$rcab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$idcabezacu=intval($rcab->fields['idcab']);
	if ($rcab->fields['idcab']==''){
		$insertar="Insert into cuadro_amortizacion_cab 
		(documento,	plazo,primvto,	monto_solicitado,	registrado_por,	estado,idsolicitudcab)
		values
		($documento,$plazo,$primervto,$monto,$idusu,1,NULL)";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
		
		$buscar="Select * from cuadro_amortizacion_cab where registrado_por=$idusu and estado=1 and documento=$documento and idsolicitudcab is NULL order by idcab desc limit 1";
		$rsl1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idcabezacu=intval($rsl1->fields['idcab']);
		
	} else {
		//actualizamos la cabecera para el plazo y monto
		$update="update cuadro_amortizacion_cab set plazo=$plazo,monto_solicitado=$monto where registrado_por=$idusu and documento=$documento and idsolicitudcab is NULL ";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
	}
	
	
	
	$p=0;
	$consulta="delete from cuadro_amortizacion_vendedor where idusu=$idusu and estado=1 and idcuadrocabeza=$idcabezacu";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	foreach($res as $detalle){
		$p=$p+1;
		$nro_cuota=$detalle['ncuota'];
		if ($p==1){
			
			$vencimiento=$vtoant;
		}else{
			
			$vencimiento=mismafechaproximomes($vencimiento,$diavenc);
		}
		
		$amortizacion=$detalle['amortizacion'];
		$vtoant=$vencimiento;
		//echo $vencimiento."<br />";
		$consulta="
		insert into cuadro_amortizacion_vendedor 
		(idcuadrocabeza,idusu, nro_cuota, amortizacion, interes, gastos_adm, vencimiento, registrado_por, registrado_el) 
		values
		($idcabezacu, $idusu, $nro_cuota, $amortizacion, 0, 0, '$vencimiento', $idusu, '$ahora')
		";
		//echo $consulta."<br />";
		
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
	} 
} 
	//else {
	//	$consulta="delete from cuadro_amortizacion_vendedor where idusu=$idusu ";
	// $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	
//}


	/*----------------ARTICULOS EN EL CARRITO----------------*/
$buscar="Select sum(subtotal)as total from tmp_carrito_simulador_creditos_productos where registrado_por=$idusu and estado=1";
$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$monto_global=intval($rs->fields['total']);



//Buscamos la cabecera, si ya existe usamos esta en lugar del POST

$buscar="Select * from cuadro_amortizacion_cab where registrado_por=$idusu and estado=1 and documento=$documento and idsolicitudcab is NULL order by idcab desc limit 1";
$rscab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
if ($rscab->fields['idcab']!=''){
	$documento=intval($rscab->fields['documento']);
	$plazo=intval($rscab->fields['plazo']);
	$primervto=date("Y-m-d",strtotime($rscab->fields['primvto']));
}




?>
<div class="alert alert-danger alert-dismissible fade in" id="alertar" role="alert" style="display:none;">

<strong>Errores:</strong><br /><span id="Errores"></span>
</div>
<div class="col-md-6 col-sm-6 form-group" >
	<label class="control-label col-md-3 col-sm-3 col-xs-12"> Documento </label>
	<div class="col-md-9 col-sm-9 col-xs-12"><input type="text" name="dc" id="dc"  class="form-control" required="required" value="<?php if($_POST['dc']!=''){ echo $_POST['dc']; } else { echo $documento; } ?>"  />                          
	</div>
</div>
<div class="col-md-6 col-sm-6 form-group" >
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Monto Solicitado </label>
	<div class="col-md-9 col-sm-9 col-xs-12"><input type="text" name="montosoli" id="montosoli" class="form-control" required="required" value="<?php echo $monto_global ?>" <?php if($monto_global> 0){ ?>readonly<?php } ?>/>       

	</div>
</div>


<div class="col-md-6 col-sm-6 form-group" >
	<label class="control-label col-md-3 col-sm-3 col-xs-12"> Plazo Solicitado </label>
	<div class="col-md-9 col-sm-9 col-xs-12"><input type="text" name="plazosoli" id="plazosoli"  class="form-control" required="required" value="<?php if($_POST['plazosoli']!=''){ echo $_POST['plazosoli']; } else { echo $plazo; }?>"  />                          
	</div>
</div>
<div class="col-md-6 col-sm-6 form-group" >
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Primer Vto </label>
	<div class="col-md-9 col-sm-9 col-xs-12"><input type="date" name="primvto" id="primvto" class="form-control" required="required" value="<?php if($_POST['primvto']!=''){ echo $_POST['primvto']; }else{ if($primervto!=''){ echo $primervto; }} ?>" />       

	</div>
</div>
<div class="form-group">

		<div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-5">
		
	   <button type="button" class="btn btn-success" onclick="calcular_proforma();"><span class="fa fa-check-square-o"></span> Calcular montos</button>

	   
		</div>
	</div>

<?php 

$consulta="Select * from cuadro_amortizacion_vendedor where idusu=$idusu order by nro_cuota asc ";
$rsf1=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$tdata=$rsf1->RecordCount();
if ($tdata > 0){

?><br />

<table class="table table-striped">
	<thead>
	<tr>
		<th colspan="4" align="center"><a href="javascript:void(0);" onclick="solicitar_credito();" class="btn btn-warning">Solicitar Credito</a>
		&nbsp;<a href="javascript:void(0);" onclick="personalizar();" class="btn btn-dark">Personalizar Proforma</a>
		</th>
	</tr>
		<tr>
			<th colspan="4" align="center">Simulaci&oacute;n para Monto: <?php echo formatomoneda($monto,4,'N'); ?> en <?php echo formatomoneda($plazo,4,'N'); ?>
			
			</th>
			
			
		</tr>
		<tr>
			<th>Cuota Numero</th>
			<th>Vencimiento</th>
			<th>Amortizacion</th>
			<th>Interes</th>
			
		</tr>
	</thead>
	<tbody>
	<?php while (!$rsf1->EOF){ ?>
		<tr>
			<td><?php echo $rsf1->fields['nro_cuota']; ?></td>
			<td><?php echo date("d/m/Y",strtotime($rsf1->fields['vencimiento'])); ?></td>
			<td><?php echo formatomoneda($rsf1->fields['amortizacion'],4,'N'); ?></td>
			<td>0</td>
			
		</tr>
	
	<?php $rsf1->MoveNext();} ?>
	</tbody>
</table>



<?php } ?>