<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");

// nombre del modulo al que pertenece este archivo
$modulo = "1";
$submodulo = "212";
require_once("includes/rsusuario.php");

//session_start();

// Controla si hizo el submit
if ($_SERVER["REQUEST_METHOD"] === "POST") {

    // recibe el id de la venta generada
    $idventa = intval($_POST['idventa']);
    $cancelReason = $_POST['cancel_reason'];

    // el id de teotracks
    $id_app_rider = 5;

    // obteniene el dominion de teotracks para la consulta de la api
    $consulta = "select * from app_rider where id_app_rider = $id_app_rider";
    $rsapp = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
    $dominio_teotracks = $rsapp->fields['dominio'];
    $token_api = $rsapp->fields['token_api'];
	
	$consulta="
	select tmp_ventares_cab.idpedidoexterno from tmp_ventares_cab where idventa = $idventa
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
	$idpedidoexterno=$rs->fields['idpedidoexterno'];
	
	
	// busca si ya se envio y llego correctamente
	$consulta = "SELECT 
					id_app_rider_log, 
					idpedidoexterno, 
					envio_correcto
				FROM 
					app_rider_log_otros
				WHERE 
					idventa = $idventa
					and envio_correcto = 'S'
					and id_app_rider  = $id_app_rider
					and idtipoaccion = 1
				ORDER BY 
					id_app_rider_log DESC 
				LIMIT 1";
	$rsdelolog = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
	//si no se envio este pedido correctamente
	if (intval($rsdelolog->fields['id_app_rider_log']) > 0) {
		echo "No se puede volver a enviar una solicitud de cancelacion a un pedido que ya fue cancelado.";
		exit;
	}

    // Prepara los datos
    $cancelData = json_encode(['code' => $idventa, 'motivo' => $cancelReason]);

    // para el log
    $datos_post_json_ins = antisqlinyeccion($cancelData, "textbox");
    // echo $datos_post_json_ins;//exit;

    // inserta en el log
    $consulta = "
	insert into app_rider_log_otros
	(id_app_rider, idventa, idpedidoexterno, enviado_por, enviado_el, json_enviado, json_respuesta, envio_correcto, idtipoaccion)
	values
	($id_app_rider, $idventa, $idpedidoexterno, $idusu, '$ahora', $datos_post_json_ins, NULL, 'N', 1)
	";

    $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
    // obtener id insertado
    $consulta = "
	select max(id_app_rider_log) as id_app_rider_log from app_rider_log_otros where idventa = $idventa
	";

    $rslog = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
    $id_app_rider_log = intval($rslog->fields['id_app_rider_log']);

    $url_teotracks = $dominio_teotracks . '/api/order/upd/cancelar';

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $url_teotracks,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => $cancelData,
        CURLOPT_HTTPHEADER => array(
            "Authorization: " . $token_api,
            "Content-Type: application/json"
        ),
    ));

    $respuesta = curl_exec($curl);
    $cancelResponse = json_decode($respuesta, true);

    // guarda en el log
    $respuesta_json_ins = antisqlinyeccion($respuesta, "textbox");
    $consulta = "
	update app_rider_log_otros
	set
		json_respuesta=$respuesta_json_ins
	where
		id_app_rider_log = $id_app_rider_log
	";
    $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

    if ($cancelResponse['success'] === true) {
        $cancel = "Respuesta de cancelación de orden: " . $cancelResponse['message'];
    } elseif ($cancelResponse['success'] === false && $cancelResponse['message'] === 'Numero de orden no existe.!') {
        $cancel = "Error: Número de orden no existe.";
    } elseif ($cancelResponse['success'] === false && $cancelResponse['message'] === 'El parámetro code es obligatorio.!') {
        $cancel = "Error: El parámetro code es obligatorio.";
    } elseif ($cancelResponse['success'] === false && $cancelResponse['error'] === 'Token de acceso invalido para el comercio.') {
        $cancel = "Error: Token de acceso inválido para el comercio.";
    } else {
        $cancel = "Respuesta inesperada en la cancelación de orden: " . $respuesta;
    }

    // Guarda la respuesta en la sesion 
    //$_SESSION['cancel_response'] = $cancel;
	
	// si se cancelo exitosamente
	if ($cancelResponse['success'] === true) {
		// guarda en el log
		$respuesta_json_ins = antisqlinyeccion($respuesta, "textbox");
		$consulta = "
		update app_rider_log_otros
		set
			envio_correcto='S'
		where
			id_app_rider_log = $id_app_rider_log
		";
		$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
		

		// cambiar estado de ventares
		$consulta = "update  tmp_ventares_cab
			set
				idestadodelivery=6
			where
				idventa = $idventa
			";
		$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
		
	}

    // Redirecciona a la pagina anterior
    header("location: delivery_micaja_est.php?id=$idventa");
    exit;
} else {
    echo "La cancelacion no se ha podido realizar vuelva a intentar";
}
