<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
require_once("includes/funciones_electronica.php");

// Obtener la hora actual en formato de 24 horas
$hora_actual = date('H');
// Obtener el día de la semana (0 = domingo, 1 = lunes, ..., 6 = sábado)
$dia_semana = date('w');

// Verificar si el día es viernes (5), sábado (6) o domingo (0)
// y si la hora está entre las 19:00 y las 07:00
if (($dia_semana == 5 || $dia_semana == 6 || $dia_semana == 0) &&
    ($hora_actual >= 19 || $hora_actual < 7)) {
    //echo "pausado temporalmente";
    //exit;
}

//exit;
// para mostrar errores por ejemplo el de falta de memoria en vez de mostarr un error 500 y no saber el problema
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL );
error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING & ~E_DEPRECATED);


// automentar el timpo de ejecucion del script
set_time_limit(30);
// para evitar el error 500 por falta de memoria
//ini_set('memory_limit', '-1');
// DOCUMENTOS POR VEZ
$LIMITE_TANDA=25; // 5 se se ejecuta cada 1 minuto son 7200 documentos por dia
$LIMITE_TANDA_ACTU=50;

$fecha_72horas_atras = new DateTime(); 
$fecha_72horas_atras->modify('-720 hour');  // 720 horas son 30 dias  120 son 5 dias
$hace_72horas_atras=$fecha_72horas_atras->format('Y-m-d H:i:s');

$consulta="
select facturador_electronico,fechahora_inicio_electro from preferencias limit 1
";
$rsemp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$facturador_electronico=$rsemp->fields['facturador_electronico'];
	
// funciones para factura electronica
if($facturador_electronico == 'S'){
	// envio documento
	require_once('facturaElectronica/Validate.php');
	require_once("facturaElectronica/GeneradorXMLFacturaElectronica.php");
	// consulta de estado
	require_once('facturaElectronica/VerificarEstadoLote.php');

	$slot_datos=slot_vigente();
	$slot_firma=trim($slot_datos['nombre_slot']);    //'80052292_test';   // nombre del slot con que se dio de alta la firma digital en el servidor
	
	if($slot_firma == ''){
		echo "No esta cargado el slot de la firma electronica.";
		exit;
	}
	
	// Fecha hora Implementacion facturacion electronica
	$fechahora_inicio_electro=$rsemp->fields['fechahora_inicio_electro']; // traer de la base de datos
	

}else{
	echo "No es un facturador electronico.";
	exit;
}

// INICIO log en archivo 
$log_txt='documentos_set_cron.php INICIO!'; // S o N si usa o no el archivo txt para log
$nombre_archivo='1_log_documentos_set_cron.txt';
$texto=date("Y-m-d H:i:s").' - '.$log_txt.$saltolinea;
// Abre el archivo en modo append (añadir al final) o crea el archivo si no existe.
$file = fopen($nombre_archivo, "a");
// Escribe el contenido de la variable $texto en el archivo.
fwrite($file, $texto);
// Cierra el archivo después de escribir.
fclose($file);
// FIN log en archivo 


// busca si esta caida la set
$parametros_array_set=array('slot' => $slot_firma, 'tipo'=> 'P');
$estado_servidor_set=verifica_estado_servidor_set($parametros_array_set);
if($estado_servidor_set['activo_set'] == 'N'){
	// set esta caido, o servicio java de nuestro server esta caido 
	echo "Sin conexion con la SET.";
	exit;
}


// busca si el ultimo cron del mismo tipo ya termino y a que hora fue
$idcronsettipo=1;
$consulta="
select idcronsetlog, fechahora, finalizado
from  cron_set_log 
where 
idcronsettipo = $idcronsettipo 
order by idcronsetlog desc 
limit 1
";
$rsveriflog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$finalizado=$rsveriflog->fields['finalizado'];
$fechahora_ultcron=$rsveriflog->fields['fechahora'];
// Si no ha finalizado
if ($finalizado == 'N') {
    $fechahora_ultcron_timestamp = strtotime($fechahora_ultcron);
    $tiempo_actual_timestamp = time();
    
    // Verifica si han pasado 20 minutos = 1200 segundos
    if (($tiempo_actual_timestamp - $fechahora_ultcron_timestamp) < 1200) {
        echo "Aun no termino el cron anterior.";
        exit;
    }
}

// registra log de inicio del cron nuevo
$consulta="
INSERT INTO cron_set_log
(fechahora, idcronsettipo) 
VALUES 
('$ahora',$idcronsettipo)
";
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
// busca el id insertado
$consulta="
select idcronsetlog, fechahora from  cron_set_log where idcronsettipo = $idcronsettipo order by idcronsetlog desc limit 1
";
$rsultlog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idcronsetlog=$rsultlog->fields['idcronsetlog'];



// PASO 1, TRAER TODOS LOS DOCUMENTOS CON ERROR Y REENVIAR (Exepto 1002 que es documento duplicado)
echo "<hr />INICIO PASO 1 - ".date("d/m/Y H:i:s")." - TRAER TODOS LOS DOCUMENTOS CON ERROR Y REENVIA<br />";
/*$consulta="
select iddocumentoemitido, iddocumentoelectronico, 
idventa, idnotacredito, idnotadebito, idnotaremision, idautofactura,
estado_set, nro_lote
from documentos_electronicos_emitidos
where
estado = 1
and estado_set = 4
and fecha_comprobante >= '$hace_72horas_atras'
and COALESCE(cod_error_documento,0) <> 1002
and COALESCE(tot_reenvios_error,0) < 5
order by iddocumentoemitido desc
limit $LIMITE_TANDA
";*/
// si tiene mas de 3 reenvios pausara durante 8 horas el reenvio pero no desde la fecha de factura desde la ultima vez que intento
$consulta="
SELECT 
    iddocumentoemitido, 
    iddocumentoelectronico, 
    idventa, 
    idnotacredito, 
    idnotadebito, 
    idnotaremision, 
    idautofactura,
    estado_set, 
    nro_lote, 
    fec_ult_envio
FROM 
    (
		SELECT 
			iddocumentoemitido, 
			iddocumentoelectronico, 
			idventa, 
			idnotacredito, 
			idnotadebito, 
			idnotaremision, 
			idautofactura,
			estado_set, 
			nro_lote, 
			fec_ult_envio,
        	COALESCE(tot_reenvios_error, 0) as tot_reenvios_error,
            cod_error_documento,
       		fecha_comprobante
		 FROM documentos_electronicos_emitidos
		 WHERE 
			 estado = 1
			 AND estado_set = 4
			 AND fecha_comprobante >= '$hace_72horas_atras'
			 AND COALESCE(cod_error_documento, 0) <> 1002
			 AND COALESCE(tot_reenvios_error, 0) < 5
    ) AS filtro_basico
WHERE 
    (
        (tot_reenvios_error = 0 OR fec_ult_envio IS NULL)
        AND TIMESTAMPDIFF(HOUR, COALESCE(fec_ult_envio, NOW()), NOW()) >= 0
    ) OR
    (tot_reenvios_error = 1 AND TIMESTAMPDIFF(HOUR, fec_ult_envio, NOW()) >= 1) OR
    (tot_reenvios_error = 2 AND TIMESTAMPDIFF(HOUR, fec_ult_envio, NOW()) >= 3) OR
    (tot_reenvios_error >= 3 AND TIMESTAMPDIFF(HOUR, fec_ult_envio, NOW()) >= 8)
ORDER BY 
    iddocumentoemitido DESC
LIMIT 
    $LIMITE_TANDA;
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idventa_acum="";
while(!$rs->EOF){
	$idventa=intval($rs->fields['idventa']);
	$idnotacredito=intval($rs->fields['idnotacredito']);
	$idnotadebito=intval($rs->fields['idnotadebito']);
	$idnotaremision=intval($rs->fields['idnotaremision']);
	$idautofactura=intval($rs->fields['idautofactura']);
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	$iddocumentoemitido=intval($rs->fields['iddocumentoemitido']);
	$estado_set=$rs->fields['estado_set'];
	$nro_lote=$rs->fields['nro_lote'];
	if($estado_set == 3){
		echo "No se puede reenviar por que ya fue aprobado por la SET.";
		exit;
	}
	if($iddocumentoemitido == 0){
		echo "El documento que intentas enviar ya no existe o ya fue reenviado.";
		exit;
	}
	
	// GENERAR DOCUMENTO ELECTRONICO
	$parametros_array=array(
		'idventa' => $idventa,
		'idnotacredito' => $idnotacredito,
		'idnotadebito' => $idnotadebito,
		'idnotaremision' => $idnotaremision,
		'idautofactura' => $idautofactura,
		'iddocumentoelectronico' => $iddocumentoelectronico
	);
	echo genera_documento_electronico($parametros_array).'<br />';
	
	// acumula idventa
	$idventa_acum.=$idventa.',';
	$idnotacredito_acum.=$idnotacredito.',';
	$idnotadebito_acum.=$idnotadebito.',';
	$idnotaremision_acum.=$idnotaremision.',';
	$idautofactura_acum.=$idautofactura.',';

$rs->MoveNext(); }

// borra la ultima coma
$idventa_acum=trim(substr($idventa_acum,0,-1));
$idnotacredito_acum=trim(substr($idnotacredito_acum,0,-1));
$idnotadebito_acum=trim(substr($idnotadebito_acum,0,-1));
$idnotaremision_acum=trim(substr($idnotaremision_acum,0,-1));
$idautofactura_acum=trim(substr($idautofactura_acum,0,-1));

$documentos_acum=$idventa_acum.$idnotacredito_acum.$idnotadebito_acum.$idnotaremision_acum.$idautofactura_acum;

// HASTA ACA ME QUEDE

echo "<hr />INICIO PASO 2 - ".date("d/m/Y H:i:s")." - ACTUALIZAR ESTADOS DE DOCUMENTOS CON ERROR REENVIADOS<br />";
// PASO 2 ACTUALIZAR ESTADOS DE DOCUMENTOS REENVIADOS
if(trim($documentos_acum) != ''){
	// duerme x segundos para darle tiempo a la SET de procesar los lotes
	sleep(3);

	// trae los nuevos lotes de las ventas reenviadas
	$consulta="
	select nro_lote, iddocumentoemitido
	from documentos_electronicos_emitidos
	where
	estado = 1
	and 
	(
		idventa in ($idventa_acum)
		or idnotacredito in ($idnotacredito_acum)
		or idnotadebito in ($idnotadebito_acum)
		or idnotaremision in ($idnotaremision_acum)
		or idautofactura in ($idautofactura_acum)
	)
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	while(!$rs->EOF){
		$parametros_array=array(
			'nro_lote' => $rs->fields['nro_lote'],
			'iddocumentoemitido'  => $rs->fields['iddocumentoemitido']
		);
		$res=actualiza_estado_documento_electronico($parametros_array);
		print_r($res);
	$rs->MoveNext(); }
}

// PASO 3 (GENERA DOCUMENTOS ELECTRONICOS OPERACIONES SIN DOCUMENTOS GENERADOS) 
echo "<hr />INICIO PASO 3 - ".date("d/m/Y H:i:s")." - GENERA DOCUMENTOS ELECTRONICOS DE OPERACIONES SIN DOCUMENTOS GENERADOS<br />";
// por seguridad las ventas que paso 1 minuto atras por si ya se esta generando en este momento mientras facturan, que no se genere doble
$mifecha = new DateTime(); 
//echo $mifecha->format('Y-m-d H:i:s')."<br />";
$mifecha->modify('-60 second'); 
$hace_1_minuto=$mifecha->format('Y-m-d H:i:s');

// TRAER VENTAS (LUEGO se puede hacer un union all en la consulta para inclcuir nota de credito)
/*$consulta="
select 
1 as iddocumentoelectronico, 
idventa, 
0 as idnotacredito,
0 as idnotadebito,
0 as idnotaremision,
0 as idautofactura
from ventas
where
idventa not in (
	select idventa 
	from documentos_electronicos_emitidos 
	where 
	estado = 1
)
and estado <> 6
AND finalizo_correcto = 'S'
and ventas.fecha <= '$hace_1_minuto'
and ventas.fecha >= '$hace_72horas_atras'
and ventas.fecha >= '$fechahora_inicio_electro'
and ventas.factura is not null
and trim(ventas.factura) <> ''


UNION ALL

SELECT 
2 as iddocumentoelectronico, 
0 AS idventa, 
idnotacred as idnotacredito,
0 as idnotadebito,
0 as idnotaremision,
0 as idautofactura
FROM nota_credito_cabeza
where
idnotacred not in (
	select idnotacredito 
	from documentos_electronicos_emitidos 
	where 
	estado = 1
)
and estado = 3
and nota_credito_cabeza.registrado_el <= '$hace_1_minuto'
and nota_credito_cabeza.fecha_nota >= '$hace_72horas_atras'
and nota_credito_cabeza.fecha_nota >= '$fechahora_inicio_electro'
LIMIT $LIMITE_TANDA
";*/
/*$consulta="
SELECT 
    1 AS iddocumentoelectronico, 
    v.idventa, 
    0 AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura 
FROM 
     (
	 SELECT idventa
     FROM ventas v
     WHERE 
         estado <> 6 
         AND finalizo_correcto = 'S' 
		 and v.fecha <= '$hace_1_minuto'
		 and v.fecha >= '$hace_72horas_atras'
		 and v.fecha >= '$fechahora_inicio_electro'
         AND factura IS NOT NULL 
         AND TRIM(factura) <> ''
    ) v
    LEFT JOIN (
	 SELECT idventa
     FROM documentos_electronicos_emitidos dee
	 where
	 dee.idventa IS NOT NULL
	 AND dee.estado = 1
    ) dee 
    ON v.idventa = dee.idventa 
where
dee.idventa IS NULL

UNION ALL

SELECT 
    2 AS iddocumentoelectronico, 
    0 AS idventa, 
    nc.idnotacred AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura 
FROM 
     (
	 SELECT idnotacred
     FROM nota_credito_cabeza nc
     WHERE 
		nc.estado = 3 
		and nc.registrado_el <= '$hace_1_minuto'
		and nc.fecha_nota >= '$hace_72horas_atras'
		and nc.fecha_nota >= '$fechahora_inicio_electro'
    ) nc
    LEFT JOIN (
	 SELECT idnotacredito
     FROM documentos_electronicos_emitidos dee
	 where
		 dee.idnotacredito IS NOT NULL
		 AND dee.estado = 1
    ) dee 
    ON nc.idnotacred = dee.idnotacredito 
where
dee.idnotacredito IS NULL

LIMIT $LIMITE_TANDA;
";*/
$consulta="
SELECT 
    1 AS iddocumentoelectronico, 
    v.idventa, 
    0 AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura 
FROM 
     (
	 SELECT idventa
     FROM ventas v
     WHERE 
         estado <> 6 
         AND finalizo_correcto = 'S' 
		 and v.fecha <= '$hace_1_minuto'
		 and v.fecha >= '$hace_72horas_atras'
		 and v.fecha >= '$fechahora_inicio_electro'
         AND v.factura IS NOT NULL 
         AND TRIM(v.factura) <> ''
		 and v.electronica_gen = 'N'
    ) v


UNION ALL

SELECT 
    2 AS iddocumentoelectronico, 
    0 AS idventa, 
    nc.idnotacred AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura 
FROM 
     (
	 SELECT idnotacred
     FROM nota_credito_cabeza nc
     WHERE 
		nc.estado = 3 
		and nc.registrado_el <= '$hace_1_minuto'
		and nc.fecha_nota >= '$hace_72horas_atras'
		and nc.fecha_nota >= '$fechahora_inicio_electro'
		and nc.electronica_gen = 'N'
    ) nc

LIMIT $LIMITE_TANDA;
";
//echo $consulta;
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idventa_acum="";
while(!$rs->EOF){
	
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	$idventa=intval($rs->fields['idventa']);
	$idnotacredito=intval($rs->fields['idnotacredito']);
	$idnotadebito=intval($rs->fields['idnotadebito']);
	$idnotaremision=intval($rs->fields['idnotaremision']);
	$idautofactura=intval($rs->fields['idautofactura']);
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	// GENERAR DOCUMENTO ELECTRONICO
	$parametros_array=array(
		'idventa' => $idventa,
		'idnotacredito' => $idnotacredito,
		'idnotadebito' => $idnotadebito,
		'idnotaremision' => $idnotaremision,
		'idautofactura' => $idautofactura,
		'iddocumentoelectronico' => $iddocumentoelectronico
	);
	echo genera_documento_electronico($parametros_array);

$rs->MoveNext(); }





// PASO 4 ACTUALIZAR ESTADOS DE TODOS LOS PENDIENTES
echo "<hr />INICIO PASO 4 - ".date("d/m/Y H:i:s")." - ACTUALIZAR ESTADOS DE TODOS LOS PENDIENTES PROCESO Y PENDIENTES ENVIO<br />";
$consulta="
select nro_lote, idventa, iddocumentoemitido, numero_comprobante
from documentos_electronicos_emitidos
where
estado_set <> 3
and (estado_set = 1 OR estado_set = 5)
and nro_lote > 0
and fecha_comprobante >= '$hace_72horas_atras'
and estado <> 6
order by fecha_comprobante asc
limit $LIMITE_TANDA_ACTU
";
$rslotes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
while(!$rslotes->EOF){
	$parametros_array=array(
		'nro_lote' => $rslotes->fields['nro_lote'],
		'iddocumentoemitido' => $rslotes->fields['iddocumentoemitido']
	);
	$res=actualiza_estado_documento_electronico($parametros_array);
	echo $rslotes->fields['iddocumentoemitido'].','.$rslotes->fields['idventa'].'-'; 
	print_r($res);
	echo $rslotes->fields['numero_comprobante'].'<br />';
$rslotes->MoveNext(); }

// PASO 5 ACTUALIZAR ESTADOS DE TODOS LOS ENVIADOS
echo "<hr />INICIO PASO 5 - ".date("d/m/Y H:i:s")." - ACTUALIZAR ESTADOS DE TODOS LOS ENVIADOS<br />";
$consulta="
select nro_lote, idventa, iddocumentoemitido, numero_comprobante
from documentos_electronicos_emitidos
where
estado = 1
and estado_set <> 3
and (estado_set = 2)
and nro_lote > 0
and fecha_comprobante >= '$hace_72horas_atras'
order by fecha_comprobante asc
limit $LIMITE_TANDA_ACTU
";
$rslotes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
while(!$rslotes->EOF){
	$parametros_array=array(
		'nro_lote' => $rslotes->fields['nro_lote'],
		'iddocumentoemitido' => $rslotes->fields['iddocumentoemitido']
	);
	$res=actualiza_estado_documento_electronico($parametros_array);
	echo $rslotes->fields['iddocumentoemitido'].','.$rslotes->fields['idventa'].'-'; 
	print_r($res);
	echo $rslotes->fields['numero_comprobante'].'<br />';
$rslotes->MoveNext(); }


// PASO 6, REENVIA TODOS LOS DOCUMENTOS pendientes de envio (Solo ventas)
echo "<hr />INICIO PASO 6 - ".date("d/m/Y H:i:s")." - TRAER TODOS LOS DOCUMENTOS PENDIENTES DE ENVIO Y REENVIA<br />";
$consulta="
select iddocumentoemitido, iddocumentoelectronico, 
idventa, idnotacredito, idnotadebito, idnotaremision, idautofactura,
estado_set, nro_lote
from documentos_electronicos_emitidos
where
estado = 1
and estado_set = 1
and xml is not null
and fecha_comprobante >= '$hace_72horas_atras'
order by iddocumentoemitido desc
limit $LIMITE_TANDA
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idventa_acum="";
while(!$rs->EOF){
	$idventa=intval($rs->fields['idventa']);
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	$iddocumentoemitido=intval($rs->fields['iddocumentoemitido']);
	$estado_set=$rs->fields['estado_set'];
	$nro_lote=$rs->fields['nro_lote'];
	$enviar='S';
	if($estado_set == 3){
		echo "No se puede reenviar por que ya fue aprobado por la SET.";
		//exit;
		$enviar='N';
		break;
	}
	if($iddocumentoemitido == 0){
		echo "El documento que intentas enviar ya no existe o ya fue reenviado.";
		//exit;
		$enviar='N';
		break;
	}
	if($enviar == 'S'){
		// GENERAR DOCUMENTO ELECTRONICO
		$parametros_array=array(
			'idventa' => $idventa,
			'iddocumentoelectronico' => $iddocumentoelectronico
		);
		echo genera_documento_electronico($parametros_array);
		
		// acumula idventa
		$idventa_acum.=$idventa.',';
	}

$rs->MoveNext(); }

$consulta="
UPDATE documentos_electronicos_emitidos 
set 
estado_set = 1
where
estado = 1
and estado_set = 2
and (nro_lote is null or nro_lote = 0)
and fecha_comprobante >= '$hace_72horas_atras'
";
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));


// registra como finalizado
$ahora_fin=date("Y-m-d H:i:s");
$consulta="
update  cron_set_log 
set 
finalizado  = 'S',
finalizado_el = '$ahora_fin'
where 
idcronsetlog = $idcronsetlog
";
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));


// INICIO log en archivo 
$log_txt='documentos_set_cron.php FIN!'; // S o N si usa o no el archivo txt para log
$nombre_archivo='1_log_documentos_set_cron.txt';
$texto=date("Y-m-d H:i:s").' - '.$log_txt.$saltolinea;
// Abre el archivo en modo append (añadir al final) o crea el archivo si no existe.
$file = fopen($nombre_archivo, "a");
// Escribe el contenido de la variable $texto en el archivo.
fwrite($file, $texto);
// Cierra el archivo después de escribir.
fclose($file);
// FIN log en archivo 


echo "<hr />FINAL DEL PROCESO - ".date("d/m/Y H:i:s")."<br />";

?>
