<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
require_once("includes/funciones_electronica.php");

// /home/servid20/scripts/factura_electronica01.sh

//exit;

// automentar el timpo de ejecucion del script
set_time_limit(30);
// para evitar el error 500 por falta de memoria
//ini_set('memory_limit', '-1');
// DOCUMENTOS POR VEZ
$LIMITE_TANDA=20; // 5 se se ejecuta cada 1 minuto son 7200 documentos por dia


$fecha_72horas_atras = new DateTime(); 
$fecha_72horas_atras->modify('-120 hour');  // 720 horas son 30 dias  120 son 5 dias
$hace_72horas_atras=$fecha_72horas_atras->format('Y-m-d H:i:s');

$consulta="
select facturador_electronico,fechahora_inicio_electro from preferencias limit 1
";
$rsemp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$facturador_electronico=$rsemp->fields['facturador_electronico'];
	
// funciones para factura electronica
if($facturador_electronico == 'S'){
	// envio documento
	require_once('facturaElectronica/ActualizaMedianteCDC.php');

	$slot_datos=slot_vigente();
	$slot_firma=trim($slot_datos['nombre_slot']);    //'80052292_test';   // nombre del slot con que se dio de alta la firma digital en el servidor
	
	if($slot_firma == ''){
		echo "No esta cargado el slot de la firma electronica.";
		exit;
	}
	
	// Fecha hora Implementacion facturacion electronica
	$fechahora_inicio_electro=$rsemp->fields['fechahora_inicio_electro']; // traer de la base de datos
	
	

	
	
	

}else{
	echo "No es un facturador electronico.";
	exit;
}

// INICIO log en archivo 
$log_txt='documentos_set_cron_cdc.php INICIO!'; // S o N si usa o no el archivo txt para log
$nombre_archivo='1_log_documentos_set_cron.txt';
$texto=date("Y-m-d H:i:s").' - '.$log_txt.$saltolinea;
// Abre el archivo en modo append (añadir al final) o crea el archivo si no existe.
$file = fopen($nombre_archivo, "a");
// Escribe el contenido de la variable $texto en el archivo.
fwrite($file, $texto);
// Cierra el archivo después de escribir.
fclose($file);
// FIN log en archivo 

// busca si esta caida la set
$parametros_array_set=array('slot' => $slot_firma, 'tipo'=> 'P');
$estado_servidor_set=verifica_estado_servidor_set($parametros_array_set);
if($estado_servidor_set['activo_set'] == 'N'){
	// set esta caido, o servicio java de nuestro server esta caido 
	echo "Sin conexion con la SET.";
	exit;
}



// busca si el ultimo cron del mismo tipo ya termino y a que hora fue
$idcronsettipo=2;
$consulta="
select idcronsetlog, fechahora, finalizado
from  cron_set_log 
where 
idcronsettipo = $idcronsettipo 
order by idcronsetlog desc 
limit 1
";
$rsveriflog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$finalizado=$rsveriflog->fields['finalizado'];
$fechahora_ultcron=$rsveriflog->fields['fechahora'];
// Si no ha finalizado
if ($finalizado == 'N') {
    $fechahora_ultcron_timestamp = strtotime($fechahora_ultcron);
    $tiempo_actual_timestamp = time();
    
    // Verifica si han pasado 20 minutos = 1200 segundos
    if (($tiempo_actual_timestamp - $fechahora_ultcron_timestamp) < 1200) {
        echo "Aun no termino el cron anterior.";
        exit;
    }
}

// registra log de inicio del cron nuevo
$consulta="
INSERT INTO cron_set_log
(fechahora, idcronsettipo) 
VALUES 
('$ahora',$idcronsettipo)
";
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
// busca el id insertado
$consulta="
select idcronsetlog, fechahora from  cron_set_log where idcronsettipo = $idcronsettipo order by idcronsetlog desc limit 1
";
$rsultlog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idcronsetlog=$rsultlog->fields['idcronsetlog'];


// PASO 1, TRAER TODOS LOS DOCUMENTOS CON ERROR DE DUPLICIDAD
echo "<hr />INICIO PASO 1 - ".date("d/m/Y H:i:s")." - TRAER TODOS LOS DOCUMENTOS CON ERROR DE DUPLICIDAD<br />";
$consulta="
select cdc, max(fecha_comprobante) as fecha_comprobante, max(iddocumentoemitido) as iddocumentoemitido, idventa
from documentos_electronicos_emitidos
where
 cdc is not null
and cdc_consultado = 'N'
and estado = 6
and estado_set <> 3
group by cdc
order by max(fecha_comprobante) asc
limit $LIMITE_TANDA
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idventa_acum="";
while(!$rs->EOF){
	$idventa=intval($rs->fields['idventa']);
	$iddocumentoemitido=intval($rs->fields['iddocumentoemitido']);
	$cdc=$rs->fields['cdc'];
	if($iddocumentoemitido == 0){
		echo "El documento que intentas enviar ya no existe o ya fue reenviado.";
		exit;
	}
	
	// ACTUALIZA DOCUMENTO ELECTRONICO
	$parametros_array=array(
		'cdc' => $cdc,
		'iddocumentoemitido' => $iddocumentoemitido
	);
	$res=actualiza_estado_documento_electronico_cdc($parametros_array);
	print_r($res);
	echo $cdc.'<br />';

$rs->MoveNext(); }

// PASO 2, TRAER TODOS LOS DOCUMENTOS SIN LOTE
echo "<hr />INICIO PASO 2 - ".date("d/m/Y H:i:s")." - TRAER TODOS LOS DOCUMENTOS SIN LOTE Y PENDIENTES DE ENVIO<br />";
$consulta="
select cdc, max(fecha_comprobante) as fecha_comprobante, max(iddocumentoemitido) as iddocumentoemitido, idventa
from documentos_electronicos_emitidos
where
cdc is not null
and estado = 1
and estado_set = 1
and (nro_lote is null or nro_lote = 0)
and fecha_comprobante >= '$hace_72horas_atras'
group by cdc
order by max(fecha_comprobante) asc
limit $LIMITE_TANDA
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idventa_acum="";
while(!$rs->EOF){
	$idventa=intval($rs->fields['idventa']);
	$iddocumentoemitido=intval($rs->fields['iddocumentoemitido']);
	$cdc=$rs->fields['cdc'];
	if($iddocumentoemitido == 0){
		echo "El documento que intentas enviar ya no existe o ya fue reenviado.";
		exit;
	}
	// ACTUALIZA DOCUMENTO ELECTRONICO
	$parametros_array=array(
		'cdc' => $cdc,
		'iddocumentoemitido' => $iddocumentoemitido
	);
	$res=actualiza_estado_documento_electronico_cdc($parametros_array);
	print_r($res);
	echo $cdc.'<br />';

$rs->MoveNext(); }


// registra como finalizado
$ahora_fin=date("Y-m-d H:i:s");
$consulta="
update  cron_set_log 
set 
finalizado  = 'S',
finalizado_el = '$ahora_fin'
where 
idcronsetlog = $idcronsetlog
";
//echo $consulta;
$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

// INICIO log en archivo 
$log_txt='documentos_set_cron_cdc.php FIN!'; // S o N si usa o no el archivo txt para log
$nombre_archivo='1_log_documentos_set_cron.txt';
$texto=date("Y-m-d H:i:s").' - '.$log_txt.$saltolinea;
// Abre el archivo en modo append (añadir al final) o crea el archivo si no existe.
$file = fopen($nombre_archivo, "a");
// Escribe el contenido de la variable $texto en el archivo.
fwrite($file, $texto);
// Cierra el archivo después de escribir.
fclose($file);
// FIN log en archivo 

echo "<hr />FINAL DEL PROCESO - ".date("d/m/Y H:i:s")."<br />";



?>
