<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
require_once("includes/rs_carrito.php"); 

/* 
si el grupo tiene 1 solo producto cargado
debe hacer un insert directo y no figurar en la lista 
si la cantidad es 6 y solo hay 1 producto cargado hace 6 insert
*/


$prodprinc=intval($_POST['prodprinc']);
$prodpart=intval($_POST['prodpart']);

$valido="S";
$errores="";

// busca producto principal para ver si existe
$consulta="
select * 
from productos 
where 
idtipoproducto = 4
and idprod_serial = $prodprinc
and productos.borrado = 'N'
order by descripcion asc
limit 1
";
$rsprod2=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$cat_princ=$rsprod2->fields['idcategoria'];
$cantidadmax=$rsprod2->fields['combinado_maxitem'];
$cantidadmin=$rsprod2->fields['combinado_minitem'];
if(intval($rsprod2->fields['idprod_serial']) == 0){
	$errores.="-Producto principal inexistente.".$saltolinea;
	$valido="N";
}

// busca producto parte para ver si existe
$consulta="
select * 
from productos 
where 
idtipoproducto = 1
and idprod_serial = $prodpart
and productos.borrado = 'N'
order by descripcion asc
limit 1
";
$rsprod2=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
if(intval($rsprod2->fields['idprod_serial']) == 0){
	$errores.="-Producto seleccionado inexistente.".$saltolinea;
	$valido="N";
}



$consulta="
select * 
from productos_combinado
where 
productos_combinado.idproducto_principal = $prodprinc
and productos_combinado.idproducto_partes = $prodpart
limit 1
";
$rsprod=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

// si forma parte de la lista
$idproducto_principal=intval($rsprod->fields['idproducto_principal']);
if($idproducto_principal == 0){
	$errores.="-Producto seleccionado no se puede combinar con el principal.".$saltolinea;
	$valido="N";
}
// validaciones si forma parte
if($idproducto_principal > 0){
	// validar que no haya llegado al maximo permitido para esa lista
	$consulta="
	select count(*) as total
	from tmp_combinado_listas_ecom
	where
	tmp_combinado_listas_ecom.id_ses = '$session_id'
	and tmp_combinado_listas_ecom.idwebcarrito is null
	and tmp_combinado_listas_ecom.idproducto_principal = $idproducto_principal
	";
	$rscuenta=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$totalbd=intval($rscuenta->fields['total']);
	// si no supero el maximo permitido para el grupo
	if($totalbd >= $cantidadmax){
		$errores.="-Alcanzaste el maximo permitido de combinaciones.".$saltolinea;
		$valido="N";
	}

	
}

if($valido == 'S'){

		// insertar en tabla temporal
		$consulta="
		INSERT INTO tmp_combinado_listas_ecom
		(idwebcarrito, idproducto_principal, idproducto_partes, id_ses, registrado_el)
		VALUES
		(NULL,$prodprinc,$prodpart,'$session_id','$ahora')
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
}

$consulta="
select count(*) as total
from tmp_combinado_listas_ecom
where
tmp_combinado_listas_ecom.idproducto_principal = $prodprinc
and tmp_combinado_listas_ecom.idproducto_partes = $prodpart
and tmp_combinado_listas_ecom.id_ses = '$session_id'
and tmp_combinado_listas_ecom.idwebcarrito is null
";
$rsinsertado=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
// nuevo total bd despues de insertar
$totalbd_part=intval($rsinsertado->fields['total']);



$arr = array(
	'cantidad_seleccionada' => $totalbd_part,
	'cantidad_maxima' => $cantidadmax,
	'cantidad_minima' => $cantidadmin,
	'valido' => $valido,
	'errores' => $errores
);

//print_r($arr);

// convierte a formato json
$respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);

// devuelve la respuesta formateada
echo $respuesta;

?>