<?php
/*----------------------------------
16/07/2024: Se sube a todos los clientes
----------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="2";
require_once("includes/rsusuario.php"); 


$consulta="
	Select factura,fecha,ventas.idmotorista,idventa,total_venta,motorista,(select idtmpventares_cab from tmp_ventares_cab where idventa=ventas.idventa) as idpedido 
	from ventas inner join motoristas on motoristas.idmotorista=ventas.idmotorista 
	where ventas.idmotorista > 0 
	and DATE(ventas.fecha)>= (DATE(NOW() - INTERVAL 2 DAY)) and DATE(ventas.fecha) <=current_date
	and ventas.idventa NOT IN(select idventa from pedidos_entregados)
	order by idventa desc limit 100;
	";
	
	//echo $consulta;exit;
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	



?>
<!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Pedidos listos para enviar</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					<div class="col-md-12">
						<?php
							while(!$rs->EOF){ 
								$idpedido=intval($rs->fields['idpedido']);
								$idventa=intval($rs->fields['idventa']);						
								$factura=antixss($rs->fields['factura']); 
								$motorista=antixss($rs->fields['motorista']); 
							?>
							<div  class="col-md-4" style="border-radius: 0px 0px 7px 7px; -webkit-border-radius: 0px 0px 6px 7px; -moz-border-radius: 0px 0px 6px 7px; border: 4px solid #bbc8e6; width:180px;height:180px;margin-left:2%;float:left;">
								<div class="col-md-12" style="text-align:center;">
										<h3>N&deg; <?php echo $idpedido; ?></h3><hr />
										<span class="fa fa-motorcycle"></span>&nbsp;<?php echo $motorista; ?>
								</div>
								<hr/>
								<span style="color:black;font-size:20px;font-weight:bold;"><?php echo $factura; ?></span>
								<div  style="text-align:center;">
									<a href="javascript:void(0);" class="btn btn-warning" onclick="entregar(<?php echo $idventa; ?>,<?php echo $idpedido; ?>);">Retirado</a>
								</div>
							</div>
						<?php $rs->MoveNext(); } ?> 
					</div>
						<div id="test" style="display"none;">
							
						</div>
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
	<script>
	function entregar(idventa,idpedido){
		
		var parametros = {
			"idventa" : idventa,
			"idpedido" : idpedido
		};
		   $.ajax({
					data:  parametros,
					url:   'pedidos_listos_entregar.php',
					type:  'post',
					beforeSend: function () {
							$("#test").html();
					},
					success:  function (response) {
						//alert(response);
						if(response=='SI'){
							window.open("entregar_pedidos_motoristas.php", "_self");
							
						}
							//$("#test").html(response);
					}
			});
	
		
	}
	
	</script>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
