<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="10";
$submodulo="690";
require_once("includes/rsusuario.php"); 

// se puede mover esta funcion al archivo funciones_agenda_citas_estados.php y realizar un require_once
function agenda_citas_estados_add($parametros_array){
	global $conexion;
	global $saltolinea;

	// validaciones basicas
	$valido="S";
	$errores="";
	
    
	$estado_cita=antisqlinyeccion($parametros_array['estado_cita'],"text");
	$estado=antisqlinyeccion($parametros_array['estado'],"int");
	$color=antisqlinyeccion($parametros_array['color'],"text");
	$orden=antisqlinyeccion($parametros_array['orden'],"int");
	
	if(trim($parametros_array['estado_cita']) == ''){
		$valido="N";
		$errores.=" - El campo estado_cita no puede estar vacio.<br />";	
	}
  
	if(trim($parametros_array['color']) == ''){
		$valido="N";
		$errores.=" - El campo color no puede estar vacio.<br />";	
	}

	if(intval($parametros_array['orden']) == 0){
		$valido="N";
		$errores.=" - El campo orden no puede ser cero o nulo.<br />";	
	}
	

	// si todo es correcto inserta
	if($valido == "S"){
		
		$consulta="
		insert into agenda_citas_estados
		(estado_cita, estado, color, orden)
		values
		($estado_cita, $estado, $color, $orden)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
	}


	return array("errores"=>$errores,"valido"=>$valido);
}


if(isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	

	// recibe parametros
	$estado_cita=$_POST['estado_cita'];
	$estado=1;
	$color=$_POST['color'];
	$orden=$_POST['orden'];



	$parametros_array=array(
		"estado_cita" => $estado_cita,
		"estado" => $estado,
		"color" => $color,
		"orden" => $orden
	);

	// si todo es correcto actualiza
	if($valido == "S"){
		$res=agenda_citas_estados_add($parametros_array);
		if ($res["valido"]=="S") {
			header("location: estados_agendamientos.php");
			exit;
		}else{
			$errores.=$res["errores"];
		}
		
	}else{
		$errores.=$res["errores"];
	}


}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Nuevo estado de agendamiento</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

                    <?php if(trim($errores) != ""){ ?>
                    <div class="alert alert-danger alert-dismissible fade in" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
                    </button>
                    <strong>Errores:</strong><br /><?php echo $errores; ?>
                    </div>
                    <?php } ?>
                    <form id="form1" name="form1" method="post" action="">

                    <div class="col-md-6 col-sm-6 form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12">Nombre *</label>
                        <div class="col-md-9 col-sm-9 col-xs-12">
                        <input type="text" name="estado_cita" id="estado_cita" value="<?php  if(isset($_POST['estado_cita'])){ echo htmlentities($_POST['estado_cita']); }else if(trim($rs->fields['estado_cita']) != ''){ echo htmlentities($rs->fields['estado_cita']); } ?>" placeholder="Estado cita" class="form-control" required="required" />
                        </div>
                    </div>

                    <div class="col-md-6 col-sm-6 form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12">Color *</label>
                        <div class="col-md-9 col-sm-9 col-xs-12">
                        <input type="text" name="color" id="color" value="<?php  if(isset($_POST['color'])){ echo htmlentities($_POST['color']); }else if(trim($rs->fields['color']) != ''){ echo htmlentities($rs->fields['color']); } ?>" placeholder="Color" class="form-control"  />
                        </div>
                    </div>

                    <div class="col-md-6 col-sm-6 form-group">
                        <label class="control-label col-md-3 col-sm-3 col-xs-12">Orden *</label>
                        <div class="col-md-9 col-sm-9 col-xs-12">
                        <input type="text" name="orden" id="orden" value="<?php  if(isset($_POST['orden'])){ echo intval($_POST['orden']); }else if(trim($rs->fields['orden']) != ''){ echo intval($rs->fields['orden']); } ?>" placeholder="Orden" class="form-control" required="required" />
                        </div>
                    </div>

                    <div class="clearfix"></div>
                    <br />

                        <div class="form-group">
                            <div class="col-md-12 col-sm-12 col-xs-12 text-center">
                            
                        <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar</button>
                        <button type="button" class="btn btn-primary" onMouseUp="document.location.href='estados_agendamientos.php'"><span class="fa fa-ban"></span> Cancelar</button>
                            </div>
                        </div>

                    <input type="hidden" name="MM_insert" value="form1" />
                    <input type="hidden" name="form_control" value="<?php echo htmlentities($_SESSION['form_control']); ?>">
                    <br />
                    </form>
                    <div class="clearfix"></div>
                    <br /><br />

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION -->
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
