<?php

    class EventoCancelacionCDC{

        private $cdc;
        private $documentosEmitidos;
        private $json_generated;
        private $processRSP;
        private $slot;
        private $url_enviareventocancelacion;
        private $idcancelacion;
        private $rspSIFENJson;

        public function iniciar($idcancelacion, $slot){

            // Inicializa los parametros necesarios
            $this->idcancelacion = $idcancelacion;
            $this->slot = $slot;
            $this->obtenerURLAPI();
            
            // Cancela el CDC
            $this->obtieneCDCCancelacion();
            $this->obtieneDatosDocumentoElectronico();
			
			//print_r($this->documentosEmitidos);exit;
			
            $array_rsp = $this->cancelarCDC();

            return $array_rsp;

        }
        
        private function cancelarCDC(){
            
            // Convertimos el array en JSON
           /* $this->json_generated = '{"rEves":[{"eId":"'.(int) $this->idcancelacion.'","rEve":"<?xml version=\\"1.0\\" encoding=\\"UTF-8\\"?><rEve Id=\\"\\"><dFecFirma></dFecFirma><dVerFor>150</dVerFor><gGroupTiEvt><rGeVeConf><Id>'.$this->cdc.'</Id><iTipConf>1</iTipConf></rGeVeConf></gGroupTiEvt></rEve>"}],"dId":"'.(int) $this->idcancelacion.'"}';
		   */
			
			$this->json_generated = '{"rEves":[{"eId":"'.(int) $this->idcancelacion.'","rEve":"<?xml version=\\"1.0\\" encoding=\\"UTF-8\\"?><rEve Id=\"\"><dFecFirma/><dVerFor>150</dVerFor><gGroupTiEvt><rGeVeCan><Id>'.$this->cdc.'</Id><mOtEve>CANCELACION</mOtEve></rGeVeCan></gGroupTiEvt></rEve>"}],"dId":"'.(int) $this->idcancelacion.'"}';
			
            # Inicia la cancelacion del CDC
            $rsp = $this->cancelacionCDC();

            $rsp_final = json_decode($rsp, true);
			// si se recibio en hacienda
            if($rsp_final['status']['success'] == true){
				
				$estado_hacienda=$rsp_final['payload']['procesado']['xContEv'][0]['gResProcEVe']['dEstRes']; // Aprobado o Rechazado
				$estado_hacienda_item=$rsp_final['payload']['procesado']['xContEv'][0]['gResProcEVe']['gResProc'][0]['dMsgRes']; 
				$estado_hacienda_item_cod=$rsp_final['payload']['procesado']['xContEv'][0]['gResProcEVe']['gResProc'][0]['dCodRes']; 
				
				// si se aprobo
				if($estado_hacienda == 'Aprobado'){
					$msg_hac='APROBADO: '.$estado_hacienda_item.' ['.$estado_hacienda_item_cod.']';

					$this->processRSP = array(

						"status" => true,
						"msg" => $msg_hac

					);

					$this->generarEventoCancelacion(3,$msg_hac);
					
				// si se rechazo
				}else{
					$msg_hac='RECHAZADO: '.$estado_hacienda_item.' ['.$estado_hacienda_item_cod.']';

					$this->processRSP = array(

						"status" => false,
						"msg" => $msg_hac

					);

					$this->generarEventoCancelacion(4,$msg_hac);
					
				}

			
			// sin respuesta en hacienda
            }else{
				
				$msg_hac=$rsp_final['status']['cause'];

                $this->processRSP = array(

                    "status" => false,
                    "msg" => $msg_hac

                );

                $this->generarEventoCancelacion(4,$msg_hac);

            }

            # Retorna el mensaje desde SIFEN
            return $this->processRSP;


        }

        private function obtieneCDCCancelacion(){

            global $conexion;
            $id = intval($this->idcancelacion);

            $consulta = "SELECT cdc FROM documentos_electronicos_cancelacion_cdc where idcancelacion = $id";
			//echo $consulta;exit;
            $rs = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

            $this->cdc = $rs->fields['cdc'];

        }

        private function obtieneDatosDocumentoElectronico(){

            global $conexion;
            $cdc = antisqlinyeccion($this->cdc, 'text');

            $consulta = "SELECT * FROM documentos_electronicos_emitidos where cdc = $cdc and estado = 1 and estado_set = 3";
			$this->documentosEmitidos = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta));

        }

        private function actualizaEventoElectronicoEmitido(){

            global $conexion;
			global $idusu;
			global $ahora;
            $iddocumentoemitido = antisqlinyeccion($this->documentosEmitidos['iddocumentoemitido'], 'int');

            #Guarda en la tabla documentos emitidos
           /* $consulta = "UPDATE documentos_electronicos_emitidos SET estado = $estado, 
                         estado_enviocliente = $estado_envio_cliente, estado_set = $estado_set, 
                         json_resp = '".$finalRSP."' WHERE iddocumentoemitido = $iddocumentoemitido";
            $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); */

        }
        
        private function cancelacionCDC(){
			
			global $conexion;
			global $ahora;
			
			$json=$this->json_generated;
			$json_ins=antisqlinyeccion($json, "textbox");
            $idtranlog = $this->generateUniqueIDRand();
			$idcancelacion=$this->idcancelacion;
			$idmovimiento = 5; // cancelacioncdc
			
			//print_r($this->documentosEmitidos);exit;

            if(intval($this->documentosEmitidos['idventa']) > 0){
				$idventa=intval($this->documentosEmitidos['idventa']);
                $consulta="
                INSERT INTO documentos_electronicos_log
                (json_enviado, json_respuesta, registrado_el, idservicio, idventa, idtranlog, idcancelacion) 
                VALUES 
                ($json_ins,NULL,'$ahora', $idmovimiento, $idventa, $idtranlog, $idcancelacion)";
                $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 

            }else if(intval($this->documentosEmitidos['idnotacredito']) > 0){
				$idnotacredito=intval($this->documentosEmitidos['idnotacredito']) ;
                $consulta="
                INSERT INTO documentos_electronicos_log
                (json_enviado, json_respuesta, registrado_el, idservicio, idnotacredito, idtranlog, idcancelacion) 
                VALUES 
                ($json_ins,NULL,'$ahora', $idmovimiento, $idnotacredito, $idtranlog, $idcancelacion)";
                $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 

            }else if(intval($this->documentosEmitidos['idnotaremision']) > 0){
				$idnotaremision=intval($this->documentosEmitidos['idnotaremision']);
                $consulta="
                INSERT INTO documentos_electronicos_log
                (json_enviado, json_respuesta, registrado_el, idservicio, idnotaremision, idtranlog, idcancelacion) 
                VALUES 
                ($json_ins,NULL,'$ahora', $idmovimiento, $idnotaremision, $idtranlog, $idcancelacion)";
                $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 

             }else if(intval($this->documentosEmitidos['idnotadebito']) > 0){
				$idnotadebito=intval($this->documentosEmitidos['idnotadebito']);
                $consulta="
                INSERT INTO documentos_electronicos_log
                (json_enviado, json_respuesta, registrado_el, idservicio, idnotadebito, idtranlog, idcancelacion) 
                VALUES 
                ($json_ins,NULL,'$ahora', $idmovimiento, $idnotadebito, $idtranlog, $idcancelacion)";
                $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 

             }else if(intval($this->documentosEmitidos['idautofactura']) > 0){
				$idautofactura=intval($this->documentosEmitidos['idautofactura']);
                $consulta="
                INSERT INTO documentos_electronicos_log
                (json_enviado, json_respuesta, registrado_el, idautofactura, idtranlog, idcancelacion) 
                VALUES 
                ($json_ins,NULL,'$ahora',$idmovimiento, $idautofactura, $idtranlog, $idcancelacion)";
                $conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 

            }

			$consulta="select max(idlog) as idlog from documentos_electronicos_log where  idtranlog = $idtranlog";
			$rslog=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 
			$idlog=$rslog->fields['idlog'];
			
			// si se inserto el log entonces envia a hacienda
			if(intval($idlog) > 0){

				$curl = curl_init();


				curl_setopt_array($curl, array(
					CURLOPT_URL => $this->url_enviareventocancelacion,
					CURLOPT_RETURNTRANSFER => true,
					CURLOPT_ENCODING => '',
					CURLOPT_MAXREDIRS => 10,
					CURLOPT_TIMEOUT => 10, // 10 segundos timeout
					CURLOPT_FOLLOWLOCATION => true,
					CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
					CURLOPT_CUSTOMREQUEST => 'POST',
					CURLOPT_POSTFIELDS => $json,
					CURLOPT_HTTPHEADER => array(
					'X-Set-Contribuyente-Slot: '.$this->slot,
					'Content-Type: application/json'
					),
				));

				$response = curl_exec($curl);

				curl_close($curl);
				
			}
			
			$response_ins=antisqlinyeccion($response,"textbox");
            $this->rspSIFENJson = $response_ins;

			$consulta="
			update documentos_electronicos_log
			set
			json_respuesta = $response_ins
			where
			idlog = $idlog
			";
			$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

            return $response;

        }

        private function obtenerURLAPI(){

            global $conexion;

            $consulta = "SELECT * FROM preferencias_electronica where estado = 1";

            $rs = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta)); 

            $this->url_enviareventocancelacion = $rs['url_enviareventocancelacion'];

        }

        private function generarEventoCancelacion($estadoset,$msg){

            global $conexion;
            global $ahora;
            $iddocumentoemitido = antisqlinyeccion($this->documentosEmitidos['iddocumentoemitido'], 'int');
            $json=$this->json_generated;
            $json_ins=antisqlinyeccion($json, "textbox");
            $json_set=antisqlinyeccion($this->rspSIFENJson, "textbox");
            $estadoset=antisqlinyeccion($estadoset, "int");
            $tipodocumentoelectronico=antisqlinyeccion($this->documentosEmitidos['iddocumentoelectronico'], "int");
			$idcancelacion = antisqlinyeccion($this->idcancelacion, 'int');
			$idtran=$this->documentosEmitidos['iddocumentoelectronico'].date("YmdHis").rand(3);
			if(trim($msg) == ''){
				$msg='SIN CONEXION CON HACIENDA.';
			}
			$msg_sql=antisqlinyeccion($msg, 'textbox');	
			
			// busca  si ya existe un evento registrado
			$consulta="
			select idevento, cdc
			from documentos_electronicos_cancelacion_cdc
			WHERE
			idcancelacion=$idcancelacion
			limit 1
			";
 			$rsev=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idevento=intval($rsev->fields['idevento']);
			$cdc=antisqlinyeccion($rsev->fields['cdc'],"text");
			// si existe elimina
			if($idevento > 0){
				$consulta="
				update documentos_electronicos_emitidos_eventos
				set
				estado = 6
				where
				iddocumentoemitidoevento = $idevento
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			}
			
			//  insertar un nuevo registro
            $consulta = "
			INSERT INTO documentos_electronicos_emitidos_eventos
			 (iddocumentoemitido, idtipoeventoelectronico, estado, 
			 json_enviado, respuesta_set, estado_set, registrado_el, 
			 registrado_por, idtran) 
			 VALUES
			 ($iddocumentoemitido, $tipodocumentoelectronico, 1, $json_ins, $json_set, $estadoset, '$ahora',
			 0, $idtran)
			";
            $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$consulta="
			select iddocumentoemitidoevento from documentos_electronicos_emitidos_eventos  where idtran=$idtran
			";
			$rsdocev=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$iddocumentoemitidoevento=$rsdocev->fields['iddocumentoemitidoevento'];
			
			$consulta="
			UPDATE documentos_electronicos_cancelacion_cdc
			SET 
			estado_set=$estadoset,
			estado_set_txt=$msg_sql,
			idevento = $iddocumentoemitidoevento,
			fecha_cancelacion='$ahora'
			WHERE
			idcancelacion=$idcancelacion
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			
			// si se aprobo
			if($estadoset == 3){
				// busca si hay otro evento de cancelacion con el mismo cdc
				$consulta="
				select idcancelacion
				from documentos_electronicos_cancelacion_cdc
				where
				idcancelacion <> $idcancelacion
				and cdc = $cdc
				and estado = 1
				and estado_set <> 3 
				limit 1
				";
				$rscdcdup=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$idcancelacion_old=intval($rscdcdup->fields['idcancelacion']);
				// si hay anula el anterior
				if($idcancelacion_old > 0){
					$consulta="
					update documentos_electronicos_cancelacion_cdc
					set 
					estado = 6
					where
					idcancelacion = $idcancelacion_old
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				}
			}
			
			

        }

        private function generateUniqueIDRand(){
            $uniquerand = date('YmdHis').rand(10, 99);
            return $uniquerand;

        }

    }