-- use ekaru_app;

CREATE TABLE forma_afectacion_tributaria_iva (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `descripcion` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT INTO forma_afectacion_tributaria_iva (descripcion) VALUES
	 ('Gravado IVA'),
	 ('Exonerado (Art. 83- Ley 125/91)'),
	 ('Exento'),
	 ('Gravado parcial (Grav-Exento)');
	 
ALTER TABLE ventas_detalles ADD id_forma_afectacion_tributaria_iva int DEFAULT 1 NOT NULL;  /* hacer un update despues */

ALTER TABLE `tipo_iva` ADD `id_forma_afectacion_tributaria_iva` INT NOT NULL DEFAULT '1' AFTER `col_fija`, ADD INDEX (`id_forma_afectacion_tributaria_iva`);
update  `tipo_iva` set id_forma_afectacion_tributaria_iva = 3 where idtipoiva = 3;
update  `tipo_iva` set id_forma_afectacion_tributaria_iva = 4 where idtipoiva > 3;


/*ALTER TABLE ventas_detalles ADD proporcion_gravada_iva INT DEFAULT 100 NOT NULL;     cambiar por ventas_Detalles_impuestos */
/*ALTER TABLE empresas ADD fecha_inicio_timbrado_electronico DATE NULL;   tomar de tabla facturas vinculada a timbrado y ventas por idtandatimbrado */
/*
INSERT INTO tipos_clientes (descripcion,estado,registrado_el,anulado_por,anulado_el) VALUES
	 ('Fisica',1,'2023-02-28 09:03:01',NULL,NULL),
	 ('Juridica',1,'2023-02-28 09:03:01',NULL,NULL);
	 */
	 
/*Agregar en ABM Empresas*/	
ALTER TABLE empresas ADD tipo_contribuyente INT DEFAULT 1 NOT NULL COMMENT '1: Persona Fisica, 2: Persona Juridica';
ALTER TABLE empresas ADD numero_casa int DEFAULT 0 NOT NULL;
ALTER TABLE empresas ADD departamento_emisor_set varchar(100) DEFAULT 1 NOT NULL;
ALTER TABLE empresas ADD distrito_emisor_set varchar(100) DEFAULT 1;
ALTER TABLE empresas ADD ciudad_emisor_set varchar(100) DEFAULT 1 NOT NULL;
ALTER TABLE empresas ADD COLUMN actividad_economica_codigo INT NOT NULL DEFAULT 1 AFTER ciudad_emisor_set;


ALTER TABLE cliente ADD departamento INT DEFAULT 1 NOT NULL;


CREATE TABLE indicador_presencia (
	id INT auto_increment NOT NULL,
	descripcion varchar(100) NOT NULL,
	CONSTRAINT indicador_presencia_pk PRIMARY KEY (id)
)
ENGINE=InnoDB
DEFAULT CHARSET=utf8
COLLATE=utf8_general_ci;

INSERT INTO indicador_presencia (descripcion) VALUES
	 ('Operación presencial'),
	 ('Operación electrónica'),
	 ('Operación telemarketing'),
	 ('Venta a domicilio'),
	 ('Operación bancaria'),
	 ('Operación cíclica'),
	 ('Otro');
	 
ALTER TABLE ventas ADD id_indicador_presencia int DEFAULT 1 NULL;  /* asginar por preferencia en cada sucursal */

CREATE TABLE formas_pago_set (
	id INT auto_increment NOT NULL,
	descripcion varchar(100) NOT NULL,
	id_forma_pago int,
	CONSTRAINT formas_pago_set_pk PRIMARY KEY (id)
)
ENGINE=InnoDB
DEFAULT CHARSET=utf8
COLLATE=utf8_general_ci;

INSERT INTO formas_pago_set (descripcion,id_forma_pago) VALUES
	 ('Efectivo',1),
	 ('Cheque',5),
	 ('Tarjeta de crédito',2),
	 ('Tarjeta de débito',4),
	 ('Transferencia',6),
	 ('Giro',NULL),
	 ('Billetera electrónica',NULL),
	 ('Tarjeta empresarial',NULL),
	 ('Vale',NULL),
	 ('Retención',NULL);
INSERT INTO formas_pago_set (descripcion,id_forma_pago) VALUES
	 ('Pago por anticipo',NULL),
	 ('Valor fiscal',NULL),
	 ('Valor comercial',NULL),
	 ('Compensación',NULL),
	 ('Permuta',NULL),
	 ('Pago bancario',NULL),
	 ('Pago Móvil',NULL),
	 ('Donación',NULL),
	 ('Promoción',NULL),
	 ('Consumo Interno',NULL);
INSERT INTO formas_pago_set (descripcion,id_forma_pago) VALUES
	 ('Pago Electrónico',NULL),
	 ('Otro',NULL);
	
ALTER TABLE `formas_pago` ADD `idformapago_set` INT NOT NULL DEFAULT 1, ADD INDEX (`idformapago_set`); /* agregar en abm forma pago */

UPDATE `formas_pago` SET `idformapago_set` = '3' WHERE `formas_pago`.`idforma` = 2;
UPDATE `formas_pago` SET `idformapago_set` = '2' WHERE `formas_pago`.`idforma` = 5;
UPDATE `formas_pago` SET `idformapago_set` = '4' WHERE `formas_pago`.`idforma` = 4;
UPDATE `formas_pago` SET `idformapago_set` = '5' WHERE `formas_pago`.`idforma` = 6;



ALTER TABLE cliente ADD numero_casa int DEFAULT 111 NOT NULL;
ALTER TABLE ventas ADD COLUMN cdc varchar(44) NULL AFTER id_indicador_presencia;


CREATE TABLE IF NOT EXISTS `tipo_operacion_set` (
  `idtipooperacionset` int(11) NOT NULL AUTO_INCREMENT,
  `tipo_operacion` varchar(250) NOT NULL,
  PRIMARY KEY (`idtipooperacionset`),
  UNIQUE KEY `tipo_operacion` (`tipo_operacion`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
INSERT INTO `tipo_operacion_set` (`idtipooperacionset`, `tipo_operacion`) VALUES
(1, 'Negocio a Negocio'),
(2, 'Negocio a Consumidor'),
(3, 'Negocio a Gobierno'),
(4, 'Negocio a Extrangero');

CREATE TABLE IF NOT EXISTS `tipo_transaccion_set` (
  `idtipotranset` int(11) NOT NULL AUTO_INCREMENT,
  `tipo_transaccion_set` varchar(250) NOT NULL,
  PRIMARY KEY (`idtipotranset`),
  UNIQUE KEY `tipo_transaccion_set` (`tipo_transaccion_set`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;
INSERT INTO `tipo_transaccion_set` (`idtipotranset`, `tipo_transaccion_set`) VALUES
(1, 'Venta de mercadería'),
(2, 'Prestación de servicios'),
(3, 'Mixto (Venta de mercadería y servicios)'),
(4, 'Venta de activo fijo'),
(5, 'Venta de divisas'),
(6, 'Compra de divisas'),
(7, 'Promoción o entrega de muestras'),
(8, 'Donación'),
(9, 'Anticipo'),
(10, 'Compra de productos'),
(11, 'Compra de servicios'),
(12, 'Venta de crédito fiscal'),
(13, 'Muestras médicas (Art. 3 RG 24/2014)');


ALTER TABLE `cliente` ADD `idtiporeceptor_set` INT(1) NOT NULL DEFAULT '1' COMMENT '1: contribuyente 2: no contribuyente' AFTER `numero_casa`;
update cliente set `idtiporeceptor_set` = 2 where ruc = 'X' or borrable = 'N';


ALTER TABLE `ventas` ADD `idtipotranset` INT NULL DEFAULT '1' COMMENT 'tabla tipo_transaccion_set' AFTER `cdc`;





ALTER TABLE `cliente` ADD `id_distrito` INT NULL;

ALTER TABLE `cliente` CHANGE `idtiporeceptor_set` `idtiporeceptor_set` INT(1) NOT NULL DEFAULT '1' COMMENT '1: contribuyente 2: no contribuyente\r\n\r\n\r\ntabla: naturaleza_persona';
ALTER TABLE `ventas` ADD `idtipooperacionset` INT(2) NOT NULL DEFAULT '2' AFTER `idtipotranset`;
ALTER TABLE `cliente` ADD `idtipooperacionset` INT(2) NOT NULL DEFAULT '2' AFTER `id_distrito`;
ALTER TABLE `cliente` CHANGE `numero_casa` `numero_casa` INT(11) NULL;

ALTER TABLE `tmp_ventares` ADD `subtotal_orig` DECIMAL(34,4) NULL COMMENT 'subtotal original antes del prorrateo de descuento para la set' AFTER `subtotal`;
ALTER TABLE `tmp_ventares_bak` ADD `subtotal_orig` DECIMAL(34,4) NULL COMMENT 'subtotal original antes del prorrateo de descuento para la set' AFTER `subtotal`;

INSERT INTO `modulo` (`idmodulo`, `modulo`, `landing`, `descripcion`) VALUES ('39', 'Facturacion Electronica', NULL, 'Facturacion Electronica');
UPDATE `modulo_detalle` SET `idmodulo` = '39' WHERE CONCAT(`modulo_detalle`.`idsubmod`) = '565';
UPDATE `modulo_empresa` SET `idmodulo` = '39' WHERE CONCAT(`modulo_empresa`.`idmodulo`) = '1' AND CONCAT(`modulo_empresa`.`idempresa`) = '1' AND CONCAT(`modulo_empresa`.`idsubmod`) = '565';



DROP TABLE IF EXISTS `documentos_electronicos_emitidos`;
CREATE TABLE IF NOT EXISTS `documentos_electronicos_emitidos` (
  `iddocumentoemitido` bigint(20) NOT NULL AUTO_INCREMENT,
  `iddocumentoelectronico` int(11) NOT NULL,
  `xml` text NOT NULL,
  `qr` text DEFAULT NULL,
  `cdc` varchar(44) DEFAULT NULL,
  `fecha_firma` datetime DEFAULT NULL,
  `numero_comprobante` varchar(15) DEFAULT NULL,
  `idtipoenvio` int(11) DEFAULT NULL COMMENT '1: sincrono 2: asincrono (lotes)',
  `idventa` int(11) DEFAULT NULL,
  `idnotacredito` int(11) DEFAULT NULL,
  `idnotadebito` int(11) DEFAULT NULL,
  `idnotaremision` int(11) DEFAULT NULL,
  `idautofactura` int(11) DEFAULT NULL,
  `estado` int(1) NOT NULL DEFAULT 1,
  `estado_enviocliente` int(11) NOT NULL DEFAULT 1 COMMENT '1: pendiente 2: enviado\r\n3: error (no enviado)',
  `estado_set` int(3) NOT NULL DEFAULT 1 COMMENT '1: pendiente envio 2: enviado 3: aprobado 4: error',
  PRIMARY KEY (`iddocumentoemitido`),
  KEY `iddocumentoelectronico` (`iddocumentoelectronico`),
  KEY `estado` (`estado`),
  KEY `idventa` (`idventa`),
  KEY `idnotacredito` (`idnotacredito`),
  KEY `idnotadebito` (`idnotadebito`),
  KEY `idnotaremision` (`idnotaremision`),
  KEY `idautofactura` (`idautofactura`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;

ALTER TABLE `empresas` ADD `slot_firma_electronica` VARCHAR(250) NULL AFTER `actividad_economica_codigo`;

UPDATE `cliente` SET `idclientecat` = NULL, `departamento` = NULL, `numero_casa` = NULL , `id_distrito` = NULL , `idciudad` = NULL, email = 'noreply@innovasys.com.py' WHERE borrable = 'N';

/*ALTER TABLE ventas ADD COLUMN cdc_nc varchar(44) NULL AFTER cdc;*/

ALTER TABLE `documentos_electronicos_emitidos` ADD `json_resp` TEXT NULL AFTER `estado_set`;
ALTER TABLE `documentos_electronicos_emitidos` ADD `fecha_comprobante` DATETIME NULL AFTER `fecha_firma`;
ALTER TABLE `ventas` ADD `electronica_ok` CHAR(1) NOT NULL DEFAULT 'N' AFTER `idtipooperacionset`, ADD INDEX (`electronica_ok`);
ALTER TABLE `documentos_electronicos_emitidos` CHANGE `estado_set` `estado_set` INT(3) NOT NULL DEFAULT '1' COMMENT 'tabla documentos_electronicos_emitidos_estado';


ALTER TABLE `documentos_electronicos_emitidos` CHANGE `estado_enviocliente` `estado_enviocliente` INT(11) NOT NULL DEFAULT '1' COMMENT 'tabla \r\n documentos_electronicos_emitidos_estado_mail';


/*
cliente_add.php
cliente_edit.php
gest_ventas_resto_caja.php
tuempresa.php
factura_electronica_validador_general.php
registrar_venta.php
includes/funciones.php
*/
