<?php
 
    class ActualizaMedianteCDC{

        private $json_generated;
        private $processRSP;
        private $slot;
        private $nrosCDCs;
        private $url_consultarcdc;
		private $iddocumentoemitido;

        public function iniciar($slot, $cdc, $iddocumentoemitido){
			
			//print_r($cdc); 
            $this->slot = $slot;
            $this->nrosCDCs = $cdc;
			$this->iddocumentoemitido = $iddocumentoemitido;
 
            $this->obtenerURLAPI();
            $this->verificacionCDC();

            $this->processRSP = array(

                "status" => true,
                "position" => "FINAL",
                "msg" => "Proceso de actualizacion de CDC culminado"

            );

            return $this->processRSP;

        }

        private function verificacionCDC(){
            
            foreach($this->nrosCDCs as $cdc){

                // Convertimos el array en JSON
                $this->json_generated = '{
                    "cdc": '.$cdc.',
                    "dId": "'.(int) $this->generateUniqueIDRand().'"
                }';

                $rsp = $this->confirmarLoteSet();
                $rspJSON = json_decode($rsp, true);
				
				//print_r($this->json_generated);
				//print_r($rspJSON);

                if(isset($rspJSON['status']['success'])){
					// si se aprobo
                    if($rspJSON['payload']['procesado']['dCodRes'] == "0422"){
                        
                        # APROBADO Ingresa aqui si es que el documento aparece como aprobado en la SET
                        $this->actualizaDocumentoElectronicoEmitido(3, 'Documento aprobado', $cdc, $rspJSON['payload']['procesado']['dCodRes']);                    

                        # Si es que el cdc se encuentra y esta aprobado, busca los demas cdc de esta venta y los marca con estado 6
                        # Recupera el ID venta
                        $idventatemp = $this->obtieneIDVentaDocumento($cdc);
                        $this->actualizarDocumentosEmitidosCDC($idventatemp, $cdc);

                    }else{
						
                        $this->actualizaDocumentoElectronicoEmitido(4, $rspJSON['payload']['procesado']['dMsgRes'], $cdc, $rspJSON['payload']['procesado']['dCodRes']);

                    }

                }else{

                    $this->actualizaDocumentoElectronicoEmitido(5, 'Error en comunicacion con SIFEN', $cdc, '');

                }

            }


        }

        private function obtieneIDVentaDocumento($cdc){

            global $conexion;

            $cdc=antisqlinyeccion($cdc, "text");

            $consulta = "SELECT idventa FROM documentos_electronicos_emitidos where cdc = $cdc";

            $rs = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta)); 

            return $rs['idventa'];

        }

        private function obtenerURLAPI(){

            global $conexion;

            $consulta = "SELECT * FROM preferencias_electronica where estado = 1";

            $rs = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta)); 

            $this->url_consultarcdc = $rs['url_consultarcdc'];

        }
        
        private function confirmarLoteSet(){

			//echo $this->json_generated;
			
            $curl = curl_init();
            
                        
            curl_setopt_array($curl, array(
                CURLOPT_URL => $this->url_consultarcdc,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 5,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $this->json_generated,
                CURLOPT_HTTPHEADER => array(
                'X-Set-Contribuyente-Slot: '.$this->slot,
                'Content-Type: application/json'
                ),
            ));
            
            $response = curl_exec($curl);
            
            curl_close($curl);
			
			
			//print_r($response);

            return $response;

        }

        private function actualizaDocumentoElectronicoEmitido($estado_set, $rspSET, $cdc, $codError){

            global $conexion;

            $estado_set=antisqlinyeccion($estado_set,"text");
            $rspSET=antisqlinyeccion($rspSET,"text");
			$cod_resp_set_orig=trim($codError);
            $codError=antisqlinyeccion($codError,"text");
			$iddocumentoemitido=$this->iddocumentoemitido;
			$cdc=antisqlinyeccion($cdc,"text");

            #Actualiza en la tabla documentos emitidos
            $update = "
			UPDATE documentos_electronicos_emitidos 
			SET 
			estado_set = $estado_set, 
            respuesta_set = ".$rspSET.", 
			fecha_ultactu_estado = '".date('Y-m-d H:i:s')."',
            cod_error_documento = $codError
            WHERE 
			cdc = $cdc
			and iddocumentoemitido = $iddocumentoemitido
			";
            $conexion->Execute($update) or die(errorpg($conexion, $update)); 
			// si codigo respuesta de la set no es vacio, hay comunicacion con la set, marca como consultado
			// cuando es aprobado tambien hay codigo de respuesta $codError es codigo de respuesta no de error
			if($cod_resp_set_orig != ''){
				$update = "
				UPDATE documentos_electronicos_emitidos 
				SET 
				cdc_consultado = 'S'
				WHERE 
				cdc = $cdc
				";
				$conexion->Execute($update) or die(errorpg($conexion, $update)); 
			}
            
        }
		
        private function actualizarDocumentosEmitidosCDC($idventa, $cdc){

            global $conexion;

            //$idventa=antisqlinyeccion($idventa,"int");
            $cdc=antisqlinyeccion($cdc,"text");
			$iddocumentoemitido=$this->iddocumentoemitido;
			
            // si se aprobo anula los demas documentos que tienen el mismo cdc 
            $update = "
			UPDATE documentos_electronicos_emitidos 
			SET 
			estado = 6
            WHERE 
			cdc = $cdc 
			and iddocumentoemitido <> $iddocumentoemitido
			";
			//echo $update.'<br />';
            $conexion->Execute($update) or die(errorpg($conexion, $update)); 

            // si se aprobo marca como activo el documento consultado
            $update = "
			UPDATE documentos_electronicos_emitidos 
			SET 
			estado = 1
            WHERE 
			cdc = $cdc 
			and iddocumentoemitido = $iddocumentoemitido
			";
			//echo $update.'<br />';
            $conexion->Execute($update) or die(errorpg($conexion, $update)); 
			
			// si es una venta
			if(intval($idventa) > 0){
				$idventa=intval($idventa);
				$update = "
				UPDATE documentos_electronicos_emitidos 
				SET 
				estado = 6
				WHERE 
				idventa = $idventa 
				and iddocumentoemitido <> $iddocumentoemitido
				";
				//echo $update.'<br />';
				$conexion->Execute($update) or die(errorpg($conexion, $update)); 
			}
			
            
        }

        private function generateUniqueIDRand(){

            $uniquerand = date('His').rand(100, 999);
            return $uniquerand;

        }

    }