<?php
 
    class VerificarEstadoLote{

        private $json_generated;
        private $processRSP;
        private $slot;
        private $nrosLotes;
		private $nrolote;
        private $url_enviarloterde;
        private $url_enviarrde;
        private $url_firmarde;
        private $url_consultarlotede;
		private $idventa;
		private $idnotacredito;
		private $idnotadebito;
		private $idnotaremision; 
		private $idautofactura;

        public function iniciar($slot, $nroLote){


            $this->slot = $slot;
            $this->nrosLotes = $nroLote;
 
            $this->obtenerURLAPI();
            $this->verificacionLotes();

            $this->processRSP = array(

                "status" => true,
                "position" => "FINAL",
                "msg" => "Proceso de verificacion culminado"

            );

            return $this->processRSP;

        }

        private function verificacionLotes(){
			global $conexion;
            
            foreach($this->nrosLotes as $lote){

                // Convertimos el array en JSON
                $this->json_generated = '{
                    "nroLote": '.$lote.',
                    "dId": "'.(int) $this->generateUniqueIDRand().'"
                }';
				
				$this->nrolote = $lote;

                $rsp = $this->confirmarLoteSet();
                $rspJSON = json_decode($rsp, true);
				if($lote == 111765333171993575){
					/*echo "<hr />";
					print_r($rspJSON);
					echo "<hr />";*/
				}

                if(isset($rspJSON['payload']['procesado']['gResProcLote'][0]['dEstRes'])){ //A veces el procesamiento del lote aun no culmino, entonces debe mostrar otro error

                    if($rspJSON['payload']['procesado']['gResProcLote'][0]['dEstRes'] == "Aprobado"){
                        
                        $this->actualizaDocumentoElectronicoEmitido(3, 'Documento aprobado', $lote);                    

                    }else{
							/*echo "<hr />";
							echo $rspJSON['payload']['procesado']['gResProcLote'][0]['gResProc'][0]['dCodRes']."<br />";
							echo $rspJSON['payload']['procesado']['gResProcLote'][0]['gResProc'][0]['dMsgRes']."<br />";
							echo "<hr />";*/
						
                        $this->actualizaDocumentoElectronicoEmitido(4, $rspJSON['payload']['procesado']['gResProcLote'][0]['gResProc'][0]['dMsgRes'], $lote);
						/*
						1306: El RUC informado no existe en la base de datos de Marangatu
						1309: Dígito Verificador del RUC del receptor incorrecto
						1002: Documento electrónico duplicado					
						*/
						//$cod_error=intval($rspJSON['payload']['procesado']['gResProcLote'][0]['gResProc'][0]['dCodRes']);
						$cod_error=intval($rspJSON['payload']['procesado']['gResProc'][0]['dCodRes']);
						if($cod_error == 0){
							$cod_error=intval($rspJSON['payload']['procesado']['gResProcLote'][0]['gResProc'][0]['dCodRes']);
						}
						if($cod_error > 0){
							$consulta="
							update documentos_electronicos_emitidos
							set
								cod_error_documento = $cod_error
							where
							nro_lote = ".antisqlinyeccion($lote,"text")."
							";
							$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
						}
						if($cod_error == 1306 or $cod_error == 1309){
							// busca cliente generico
							$consulta="
							select idcliente, ruc, razon_social 
							from cliente 
							where 
							borrable = 'N' 
							order by idcliente asc 
							limit 1
							";
							$rs=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
							$idcliente_gen=intval($rs->fields['idcliente']);
							$ruc_gen=antisqlinyeccion($rs->fields['ruc'],"text");
							$razon_social_gen=antisqlinyeccion($rs->fields['razon_social'],"text");
							// busca idventa
							$consulta="
							select 
							idventa, iddocumentoelectronico, iddocumentoemitido 
							from documentos_electronicos_emitidos
							where
							nro_lote = ".antisqlinyeccion($lote,"text")."
							limit 1
							";
							//echo $consulta;
							$rs=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
							$idventa=intval($rs->fields['idventa']);
							if($idventa > 0){
								// log datos
								$consulta="
								INSERT INTO ventaslog
								(idventa, registrado_por, registrado_el, idcliente_ant, idcliente_new, ruc_ant, ruc_new, 
								factura_ant, factura_new, razon_social_ant, razon_social_new) 
								select 
								idventa, 0, '".date("Y-m-d H:i:s")."', idcliente, $idcliente_gen, ventas.ruc, $ruc_gen, 
								factura, factura, razon_social, $razon_social_gen
								from ventas
								where
								idventa = $idventa
								";
								$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
								// editar venta como generico
								$consulta="
								update ventas 
								set
								idcliente = $idcliente_gen,
								ruc = $ruc_gen,
								razon_social = $razon_social_gen
								where
								idventa = $idventa
								";
								$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
							}
							
						}

                    }

                }else{

                    if($rspJSON['payload']['procesado']['gResProc'][0]['dMsgRes']){ //Nueva estructura de error de la SET

                        $this->actualizaDocumentoElectronicoEmitido(5, $rspJSON['payload']['procesado']['gResProc'][0]['dMsgRes'], $lote);

                    }else{

                        $this->actualizaDocumentoElectronicoEmitido(5, $rspJSON['payload']['procesado']['dMsgResLot'], $lote);

                    }                    

                }

            }


        }

        private function obtenerURLAPI(){

            global $conexion;

            $consulta = "SELECT * FROM preferencias_electronica where estado = 1";

            $rs = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta)); 

            $this->url_enviarloterde = $rs['url_enviarloterde'];
            $this->url_enviarrde = $rs['url_enviarrde'];
            $this->url_firmarde = $rs['url_firmarde'];
            $this->url_consultarlotede = $rs['url_consultarlotede'];

        }
        
        private function confirmarLoteSet(){
			
			global $conexion;
			global $ahora;
			
			// parametros globales de la clase
			$idventa=antisqlinyeccion($this->idventa,"int");
			$idnotacredito=antisqlinyeccion($this->idnotacredito,"int");
			$idnotadebito=antisqlinyeccion($this->idnotadebito,"int");
			$idnotaremision=antisqlinyeccion($this->idnotaremision,"int");
			$idautofactura=antisqlinyeccion($this->idautofactura,"int");
			
			$nro_lote=antisqlinyeccion($this->nrolote,"text");
			
			if(intval($this->nrolote) > 0){
				$consulta="
				select idventa, idnotacredito, idnotaremision, idautofactura, idnotadebito
				from documentos_electronicos_emitidos
				where
				nro_lote = $nro_lote
				order by iddocumentoemitido desc
				limit 1
				";
				$rslote=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 
				$idventa=antisqlinyeccion($rslote->fields['idventa'],"int");
				$idnotacredito=antisqlinyeccion($rslote->fields['idnotacredito'],"int");
				$idnotadebito=antisqlinyeccion($rslote->fields['idnotadebito'],"int");
				$idnotaremision=antisqlinyeccion($rslote->fields['idnotaremision'],"int");
				$idautofactura=antisqlinyeccion($rslote->fields['idautofactura'],"int");
			}
			
			$json=$this->json_generated;
			$json_ins=antisqlinyeccion($json,"textbox");
			$idtranlog=antisqlinyeccion(date("YmdHis").rand(1000,9999),"text");
			
			$consulta="
			INSERT INTO documentos_electronicos_log
			(json_enviado, json_respuesta, registrado_el, idservicio, idventa, idnotacredito, idnotaremision, idautofactura, idnotadebito, idtranlog) 
			VALUES 
			($json_ins,NULL,'$ahora',4,$idventa,$idnotacredito,$idnotaremision,$idautofactura,$idnotadebito, $idtranlog)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 
			$consulta="
			select max(idlog) as idlog from documentos_electronicos_log where  idtranlog = $idtranlog
			";
			$rslog=$conexion->Execute($consulta) or die(errorpg($conexion, $consulta)); 
			$idlog=$rslog->fields['idlog'];
			


            $curl = curl_init();
            
                        
            curl_setopt_array($curl, array(
                CURLOPT_URL => $this->url_consultarlotede,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 5,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $json,
                CURLOPT_HTTPHEADER => array(
                'X-Set-Contribuyente-Slot: '.$this->slot,
                'Content-Type: application/json'
                ),
            ));
            
            $response = curl_exec($curl);
            
            curl_close($curl);
			
			$response_ins=antisqlinyeccion($response,"textbox");
			$consulta="
			update documentos_electronicos_log
			set
			json_respuesta = $response_ins
			where
			idlog = $idlog
			";
			$conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

            return $response;

        }

        private function actualizaDocumentoElectronicoEmitido($estado_set, $rspSET, $nroLote){

            global $conexion;

            $estado_set=antisqlinyeccion($estado_set,"texto");
            $rspSET=antisqlinyeccion($rspSET,"texto");

            #Actualiza en la tabla documentos emitidos
            $update = "UPDATE documentos_electronicos_emitidos SET estado_set = $estado_set, 
                       respuesta_set = '".$rspSET."', fecha_ultactu_estado = '".date('Y-m-d H:i:s')."' WHERE nro_lote = $nroLote";

            $conexion->Execute($update) or die(errorpg($conexion, $update)); 
            
        }

        private function generateUniqueIDRand(){

            $len = 8;   // total number of numbers
            $min = 1;  // minimum
            $max = 999999999;  // maximum
            $range = []; // initialize array
            foreach (range(0, $len - 1) as $i) {
                while(in_array($num = mt_rand($min, $max), $range));
                $range[] = $num;
            }
            
            return $range[0];

        }

    }