<?php

    class consultarRUC{

        private $ruc;
        private $json_generated;
        private $processRSP;
        private $slot;
        private $url_consultarruc;

        public function iniciar($slot, $ruc){

            $this->ruc = antisqlinyeccion($ruc, "texto"); 
            $this->slot = $slot;
            
            $this->obtenerURLAPI();
            $array_rsp = $this->buscarRucContribuyente();

            return $array_rsp;

        }

        private function buscarRucContribuyente(){
            
            $this->json_generated = '{
                "dRUCCons": "'.$this->ruc.'",
                "dId": "'.(int) $this->generateUniqueIDRand().'"
            }';
            
            $rsp = $this->enviarComandoCurl();
            $rspJSON = json_decode($rsp, true);

            if(isset($rspJSON['status']['success'])){

                $this->processRSP = $rspJSON['payload']['procesado'];

            }else{

                $this->processRSP = array(

                    'procesado' => array(

                        "dMsgRes" => "Error al buscar el RUC"

                    )

                );

            }

            # Retorna el mensaje desde SIFEN
            return $this->processRSP;


        }
        
        private function enviarComandoCurl(){

            $curl = curl_init();

                        
            curl_setopt_array($curl, array(
                CURLOPT_URL => $this->url_consultarruc,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 5,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => $this->json_generated,
                CURLOPT_HTTPHEADER => array(
                'X-Set-Contribuyente-Slot: '.$this->slot,
                'Content-Type: application/json'
                ),
            ));
            
            $response = curl_exec($curl);

            curl_close($curl);
            
            return $response;

        }

        private function obtenerURLAPI(){

            global $conexion;

            $consulta = "SELECT * FROM preferencias_electronica where estado = 1";

            $rs = $conexion->getRow($consulta) or die(errorpg($conexion,$consulta)); 

            $this->url_consultarruc = $rs['url_consultarruc'];

        }

        private function generateUniqueIDRand(){

            $uniquerand = date('His').rand(100, 999);
            return $uniquerand;

        }

    }