<?php

    /**
     * Validate:
     *
     * @author Gustavo Piris
     * @since 1.0.0
     * @copyright Innovasys SRL 2023
     * 
    */

    class Init {

        /** Cabeceras */

        public $array_cab_general = array(

            
        );

        public $array_cabeceras = array(

            "gOpeDE",
            "gTimb",
            "gDatGralOpe",
            "gOpeCom",
            "gEmis",
            "gActEco",
            "gRespDE",
            "gDatRec",
            "gDtipDE",
            "gCamFE",
            "gCompPub",
            "gCamAE",
            "gCamNCDE",
            "gCamNRE",
            "gCamCond",
            "gPaConEIni",
            "gPagTarCD",
            "gPagCheq",
            "gPagCred",
            "gCuotas",
            "gCamItem",
            "gValorItem",
            "gValorRestaItem",
            "gCamIVA",
            "gRasMerc",
            "gVehNuevo",
            "gCamEsp",
            "gGrupEner",
            "gGrupSeg",
            "gGrupPolSeg",
            "gGrupSup",
            "gGrupAdi",
            "gTransp",
            "gCamSal",
            "gCamEnt",
            "gVehTras",
            "gCamTrans",
            "gTotSub",
            "gCamGen",
            "gCamCarg",
            "gCamDEAsoc",
            //"Signature",
            "gCamFuFD" => ""

        );

        /** Fin cabeceras */

        /** Array de tags del nodo A */

        public $array_nodo_a = array(
            
            "dDVId" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dFecFirma" => [
                "type" => 'spdate',
                "maxlenght" => 19,
                "minlenght" => 19,
                "data" => "",
                "required" => true
            ],
            "dSisFact" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            
        );

        /** Array de tags del nodo B */

        public $array_nodo_b = array(
            
            "iTipEmi" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesTipEmi" => [
                "type" => 'string',
                "maxlenght" => 12,
                "minlenght" => 6,
                "data" => "",
                "required" => true
            ],
            "dCodSeg" => [
                "type" => 'number',
                "maxlenght" => 50,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dInfoEmi" => [
                "type" => 'string',
                "maxlenght" => 3000,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dInfoFisc" => [
                "type" => 'string',
                "maxlenght" => 3000,
                "minlenght" => 1,
                "data" => "",            
                "required" => false
            ],
            
        );

        /** Array de tags del nodo C */

        public $array_nodo_c = array(
            
            "iTiDE" => [
                "type" => "number",
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "joinMandatory" => ['dInfoFisc' => [7], 'iTipTra' => [1,4], 'dDesTipTra' => [1,4], 'dDirRec' => [7,4], 'iTipTrans' => [7], 'dIniTras' => [7], 'iModTrans' => [7], 'dDesModTrans' => [7], 'iRespFlete' => [7], 'dDirLocSal' => [7], 'dNumCasSal' => [7], 'cDepSal' => [7], 'dDesDepSal' => [7], 'cCiuSal' => [7], 'dDesCiuSal' => [7], 'iTipDocAso' => [4,5,6], 'dDesTipDocAso' => [4,5,6]],
                "required" => true,
                "checkSentences" => [['dSubExe','!=',4],['dSubExo','!=',4],['dSub5','!=',4],['dSub10','!=',4],['dIVA5','!=',4],['dIVA10','!=',4],['dTotIVA','!=',4],['dBaseGrav5','!=',4],['dBaseGrav10','!=',4],['dTBasGraIVA','!=',4],['dTotalGs','!=',4]]
            ],
            "dDesTiDE" => [
                "type" => "string",
                "maxlenght" => 40,
                "minlenght" => 15,
                "data" => "",
                "required" => true
            ],
            "dNumTim" => [
                "type" => "number",
                "maxlenght" => 8,
                "minlenght" => 8,
                "data" => 0,
                "required" => true
            ],
            "dEst" => [
                "type" => "string",
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dPunExp" => [
                "type" => "string",
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dNumDoc" => [
                "type" => "string",
                "maxlenght" => 7,
                "minlenght" => 7,
                "data" => "",
                "required" => true
            ],
            "dSerieNum" => [
                "type" => "string",
                "maxlenght" => 2,
                "minlenght" => 2,
                "data" => "",
                "required" => true
            ],            
            "dFeIniT" => [
                "type" => "date",
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => true
            ],            
            /*"dFeFinT" => [
                "type" => "date",
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => true
            ],*/

        );

        /** Array de tags del nodo D */

        public $array_nodo_d = array(
            
            "dFeEmiDE" => [
                "type" => 'date',
                "maxlenght" => 19,
                "minlenght" => 19,
                "data" => "",
                "required" => true
            ],
            
        );

        /** Array de tags del nodo D1 */

        public $array_nodo_d1 = array(
            
            "iTipTra" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "joinMandatory" => ["dCDCAnticipo" => [9], "dNumResCF" => 12],
                "checkSentences" => [['dNumResCF','!=!',[12]]]
            ],
            "dDesTipTra" => [
                "type" => 'string',
                "maxlenght" => 36,
                "minlenght" => 5,
                "data" => "",
                "required" => false
            ],
            "iTImp" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "checkSentences" => [['dSub5','!=!',[1]],['dSub10','!=!',[1]],['dIVA5','!=!',[1,5]],['dIVA10','!=!',[1,5]],['dLiqTotIVA5','!=!',[1,5]],['dLiqTotIVA10','!=!',[1,5]],['dTotIVA','!=!',[1,5]],['dBaseGrav5','!=!',[1,5]],['dBaseGrav10','!=!',[1,5]],['dTBasGraIVA','!=!',[1,5]],['dTotalGs','!=!',[1,5]]],
            ],
            "dDesTImp" => [
                "type" => 'string',
                "maxlenght" => 11,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "cMoneOpe" => [
                "type" => 'currency',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
            "checkSentences" => [['dCondTiCam','<>','PYG'],['dCondTiCam','!=','PYG']/*,['dTiCam','!=','PYG']*/],
                "required" => true
            ],
            "dDesMoneOpe" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 3,
                "data" => 0,
                "required" => true
            ],
            "dCondTiCam" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "joinMandatory" => ['dTiCam' => [1], 'dTiCamIt' => [2]],
                "checkSentences" => [['dTiCam','!=',2],['dTiCamIt','!=',1]],
                "required" => false
            ],
            "dTiCam" => [
                "type" => 'date',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "iCondAnt" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "dDesCondAnt" => [
                "type" => 'string',
                "maxlenght" => 17,
                "minlenght" => 15,
                "data" => "",
                "required" => false
            ],
            
        );
        
        /** Array de tags del nodo D2 */

        public $array_nodo_d2 = array(
            
            "dRucEm" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dDVEmi" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "default" => 0,
                "required" => true
            ],
            "iTipCont" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "cTipReg" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dNomEmi" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 4,
                "data" => "",
                "required" => true,
                "errorMSg" => "En caso de ambiente de prueba, debe contener obligatoriamente el literal 'DE generado en ambiente de prueba - sin valor comercial ni fiscal'"
            ],
            "dNomFanEmi" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 4,
                "data" => 0,
                "required" => false
            ],
            "dDirEmi" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dNumCas" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => "",
                "default" => 0,
                "required" => true
            ],
            "dCompDir1" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "dCompDir2" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cDepEmi" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dDesDepEmi" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 6,
                "data" => "",
                "required" => true
            ],
            "cDisEmi" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesDisEmi','notnull',""]],
            ],
            "dDesDisEmi" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cCiuEmi" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dDesCiuEmi" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dTelEmi" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 6,
                "data" => "",
                "required" => true,
                "errorMSg" => "Debe incluir el prefijo de la ciudad"
            ],
            "dEmailE" => [
                "type" => 'string',
                "maxlenght" => 80,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dDenSuc" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo D2.1 */

        public $array_nodo_d2_1 = array(
            
            "cActEco" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesActEco" => [
                "type" => 'string',
                "maxlenght" => 300,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            
        );

        /** Array de tags del nodo D2.2 */

        public $array_nodo_d2_2 = array(
            
            "iTipIDRespDE" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "joinMandatory" => ['dDTipIDRespDE' => [9]],
            ],
            "dDTipIDRespDE" => [
                "type" => 'string',
                "maxlenght" => 41,
                "minlenght" => 9,
                "data" => "",
                "required" => false
            ],
            "dNumIDRespDE" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dNomRespDE" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dCarRespDE" => [
                "type" => 'string',
                "maxlenght" => 100,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo D3 */

        public $array_nodo_d3 = array(
            
            "iNatRec" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => ["iTiContRec" => [1], /*"dRucRec" => [1], "iTipIDRec" => [2], "dNumIDRec" => [2]/*, "dNumCasRec" => [1]*/],
                "checkSentences" => [/*['iTiContRec','!=',2], */['dRucRec','!=',2]],
            ],
            "iTiOpe" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => ["dDirRec" => [4], "dDncpG" => [3], "iNatRec" => [2]],
                "checkSentences" => [['dNumIDRec','!=',4]/*, ['cDepRec','!=',4],['cDepRec','<=>',4], ['cCiuRec','!=',4],['cCiuRec','<=>',4]*/],
            ],
            "cPaisRec" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => 0,
                /*"joinMandatory" => ["dTelRec" => ["PRY"]],*/
                "required" => true,
                "errorMSg" => "Debe incluir el prefijo de la ciudad"
            ],
            "dDesPaisRe" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],
            "iTiContRec" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dRucRec" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDVRec','notnull',""]],
            ],
            "dDVRec" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
            ],
            "iTipIDRec" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "default" => 0,
                "checkSentences" => [['dDTipIDRec','notnull',""]],
            ],
            "dDTipIDRec" => [
                "type" => 'string',
                "maxlenght" => 50,
                "minlenght" => 9,
                "data" => "",
                "required" => false,
            ],
            "dNumIDRec" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "default" => 0,
                "required" => false
            ],
            "dNomRec" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],
            "dNomFanRec" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dDirRec" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dNumCasRec','notnull',""],['cDepRec','notnull',""], ["cCiuRec",'notnull',""]],
            ],
            "dNumCasRec" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cDepRec" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dDesDepRec" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cDisRec" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDesDisRec','notnull',""]],
            ],
            "dDesDisRec" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cCiuRec" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dDesCiuRec" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dTelRec" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],
            "dCelRec" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ],
            "dEmailRec" => [
                "type" => 'string',
                "maxlenght" => 80,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dCodCliente" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E1 */

        public $array_nodo_e1 = array(
            
            "iIndPres" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => [['dDesIndPres' => [9]]],
            ],
            "dDesIndPres" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 10,
                "data" => "",
                "required" => true
            ],
            "dFecEmNR" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E1.1 */

        public $array_nodo_e1_1 = array(
            
            "dModCont" => [
                "type" => 'string',
                "maxlenght" => 2,
                "minlenght" => 2,
                "data" => "",
                "required" => true
            ],
            "dEntCont" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 5,
                "data" => 0,
                "required" => true
            ],
            "dAnoCont" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 2,
                "data" => 0,
                "required" => true
            ],
            "dSecCont" => [
                "type" => 'number',
                "maxlenght" => 7,
                "minlenght" => 7,
                "data" => "",
                "required" => true
            ],
            "dFeCodCont" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => true
            ],
            
        );

        /** Array de tags del nodo E4 */

        public $array_nodo_e4 = array(
            
            "iNatVen" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesNatVen" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 10,
                "data" => "",
                "required" => true
            ],
            "iTipIDVen" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDTipIDVen" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 9,
                "data" => "",
                "required" => true
            ],
            "dNumIDVen" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dNomVen" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],
            "dDirVen" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => true,
                "errorMSg" => "En caso de extranjeros, colocar la dirección en donde se realizó la transacción."
            ],
            "dNumCasVen" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "cDepVen" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesDepVen" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 6,
                "data" => "",
                "required" => true
            ],
            "cDisVen" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDesDisVen','notnull',""]],
                "errorMSg" => "En caso de extranjeros, colocar el distrito en donde se realizó la transacción."
            ],
            "dDesDisVen" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cCiuVen" => [
                "type" => 'date',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => true,
                "errorMSg" => "En caso de extranjeros, colocar la ciudad en donde se realizó la transacción."
            ],
            "dDesCiuVen" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dDirProv" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "cDepProv" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesDepProv" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 6,
                "data" => "",
                "required" => true
            ],
            "cDisProv" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDesDisProv','notnull',""]],
            ],
            "dDesDisProv" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cCiuProv" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],
            "dDesCiuProv" => [
                "type" => 'date',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E5 */

        public $array_nodo_e5 = array(
            
            "iMotEmi" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesMotEmi" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 6,
                "data" => 0,
                "required" => true
            ],
            
        );

        /** Array de tags del nodo E6 */

        public $array_nodo_e6 = array(
            
            "iMotEmiNR" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => ["dNuDespImp" => [7]]
            ],
            "dDesMotEmiNR" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 5,
                "data" => "",
                "required" => true
            ],
            "iRespEmiNR" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesRespEmiNR" => [
                "type" => 'string',
                "maxlenght" => 36,
                "minlenght" => 20,
                "data" => "",
                "required" => true
            ],
            "dKmR" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "dFecEm" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E7 */

        public $array_nodo_e7 = array(
            
            "iCondOpe" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "dDCondOpe" => [
                "type" => 'string',
                "maxlenght" => 7,
                "minlenght" => 7,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E7.1 */

        public $array_nodo_e7_1 = array(
            
            "iTiPago" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dNumComRet','!=!',[10]]]
            ],
            "dDesTiPag" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dMonTiPag" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "cMoneTiPag" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            "dDMoneTiPag" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            "dTiCamTiPag" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E7.1.1 */

        public $array_nodo_e7_1_1 = array(
            
            "iDenTarj" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dDesDenTarj" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],
            "dRSProTar" => [
                "type" => 'number',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => 0,
                "required" => false
            ],
            "dRUCProTar" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            "dDVProTar" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "iForProPa" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dCodAuOpe" => [
                "type" => 'number',
                "maxlenght" => 10,
                "minlenght" => 6,
                "data" => 0,
                "required" => false
            ],
            "dNomTit" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dNumTarj" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 4,
                "data" => 0,
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E7.1.2 */

        public $array_nodo_e7_1_2 = array(
            
            "dNumCheq" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 8,
                "data" => "",
                "required" => true
            ],
            "dBcoEmi" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],
            
        );

        /** Array de tags del nodo E7.2 */

        public $array_nodo_e7_2 = array(
            
            "iCondCred" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => [['dDesDisRec' => [1]]/*,['dCuotas' => [2]]*/],
            ],
            "dDCondCred" => [
                "type" => 'string',
                "maxlenght" => 6,
                "minlenght" => 5,
                "data" => "",
                "required" => true
            ],
            "dPlazoCre" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 2,
                "data" => "",
                "required" => false
            ],
            "dCuotas" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            "dMonEnt" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E7.2.1 */

        public $array_nodo_e7_2_1 = array(
            
            "cMoneCuo" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dDMoneCuo" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 3,
                "data" => "",
                "required" => true
            ],
            "dMonCuota" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],
            "dVencCuo" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E8 */

        public $array_nodo_e8 = array(
            
            "dCodInt" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dParAranc" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dNCM" => [
                "type" => 'number',
                "maxlenght" => 8,
                "minlenght" => 6,
                "data" => 0,
                "required" => false
            ],
            "dDncpG" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 8,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDncpE','notnull',""]],
            ],
            "dDncpE" => [
                "type" => 'string',
                "maxlenght" => 4,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            "dGtin" => [
                "type" => 'number',
                "maxlenght" => 14,
                "minlenght" => 8,
                "data" => 0,
                "required" => false
            ],
            "dGtinPq" => [
                "type" => 'number',
                "maxlenght" => 14,
                "minlenght" => 8,
                "data" => "",
                "required" => false
            ],
            "dDesProSer" => [
                "type" => 'string',
                "maxlenght" => 120,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cUniMed" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dDesUniMed" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dCantProSer" => [
                "type" => 'number',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
            ],
            "cPaisOrig" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesPaisOrig','notnull',""]],
            ],
            "dDesPaisOrig" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],
            "dInfItem" => [
                "type" => 'string',
                "maxlenght" => 500,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cRelMerc" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dCanQuiMer','notnull',""],['dPorQuiMer','notnull',""]],
            ],
            "dDesRelMerc" => [
                "type" => 'string',
                "maxlenght" => 21,
                "minlenght" => 19,
                "data" => "",
                "required" => false
            ],
            "dCanQuiMer" => [
                "type" => 'number',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dPorQuiMer" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dCDCAnticipo" => [
                "type" => 'string',
                "maxlenght" => 44,
                "minlenght" => 44,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E8.1 */

        public $array_nodo_e8_1 = array(
            
            "dPUniProSer" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dTiCamIt" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dTotOpeGs','notnull',""]],
            ],
            "dTotBruOpeItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            
        );

        /** Array de tags del nodo E8.1.1 */

        public $array_nodo_e8_1_1 = array(
            
            "dDescItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dPorcDesIt','>',0]],
            ],
            "dPorcDesIt" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dDescGloItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dAntPreUniIt" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dAntGloPreUniIt" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dTotOpeItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "errorMSg" => "Calculo para IVA, Renta, ninguno, IVA - Renta
                Si D013 = 1, 3, 4 o 5 (afectado al IVA, Renta, ninguno, IVA - Renta), entonces EA008 corresponde al cálculo aritmetico: (E721 (Precio unitario) – EA002 (Descuento particular) – EA004 (Descuento global) – EA006 (Anticipo particular) – EA007 (Anticipo global)) * E711(cantidad)
                Calculo para Autofactura (C002=4):
                E721*E711"
            ],
            "dTotOpeGs" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "errorMSg" => "Corresponde al cálculo aritmetico EA008* E725"
            ],            
            
        );

        /** Array de tags del nodo E8.2 */

        public $array_nodo_e8_2 = array(
            
            "iAfecIVA" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dDesAfecIVA" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],
            "dPropIVA" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dTasaIVA" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dBasGravIVA" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dLiqIVAItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                    
            
        );

        /** Array de tags del nodo E8.4 */

        public $array_nodo_e8_4 = array(
            
            "dNumLote" => [
                "type" => 'string',
                "maxlenght" => 80,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dVencMerc" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ],
            "dNSerie" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dNumPedi" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dNumSegui" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dNomImp" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],       
            "dDirImp" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dNumFir" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                                        
            "dNumReg" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 20,
                "data" => "",
                "required" => false
            ],
            "dNumRegEntCom" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 20,
                "data" => "",
                "required" => false
            ],             
            
        );

        /** Array de tags del nodo E8.5 */

        public $array_nodo_e8_5 = array(
            
            "iTipOpVN" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesTipOpVN','notnull',""]],
            ],
            "dDesTipOpVN" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 16,
                "data" => "",
                "required" => false
            ],
            "dChasis" => [
                "type" => 'string',
                "maxlenght" => 17,
                "minlenght" => 17,
                "data" => "",
                "required" => false
            ],
            "dColor" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dPotencia" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dCapMot" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],   
            "dPNet" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],  
            "dPBruto" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "iTipCom" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesTipCom','notnull',""]],
            ], 
            "dDesTipCom" => [
                "type" => 'number',
                "maxlenght" => 20,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ], 
            "dNroMotor" => [
                "type" => 'string',
                "maxlenght" => 21,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],    
            "dCapTracc" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],  
            "dAnoFab" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ], 
            "cTipVeh" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],     
            "dCapac" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dCilin" => [
                "type" => 'string',
                "maxlenght" => 4,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                 
            
        );

        /** Array de tags del nodo E9.2 */

        public $array_nodo_e9_2 = array(
            
            "dNroMed" => [
                "type" => 'string',
                "maxlenght" => 150,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dActiv" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 2,
                "data" => "",
                "required" => false
            ],
            "dCateg" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],
            "dLecAnt" => [
                "type" => 'number',
                "maxlenght" => 11,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dLecAct" => [
                "type" => 'number',
                "maxlenght" => 11,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dConKwh" => [
                "type" => 'number',
                "maxlenght" => 11,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                            
            
        );

        /** Array de tags del nodo E9.3 */

        public $array_nodo_e9_3 = array(
            
            "dCodEmpSeg" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 20,
                "data" => "",
                "required" => false
            ],                                      
            
        );

        /** Array de tags del nodo E9.3.1 */

        public $array_nodo_e9_3_1 = array(
            
            "dPoliza" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dUnidVig" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],  
            "dVigencia" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],  
            "dNumPoliza" => [
                "type" => 'string',
                "maxlenght" => 25,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],  
            "dFecIniVig" => [
                "type" => 'date',
                "maxlenght" => 19,
                "minlenght" => 19,
                "data" => "",
                "required" => false
            ],
            "dFecFinVig" => [
                "type" => 'date',
                "maxlenght" => 19,
                "minlenght" => 19,
                "data" => "",
                "required" => false
            ],
            "dCodInt9_3_1" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                                                                                               
            
        );     
        
        /** Array de tags del nodo E9.4 */

        public $array_nodo_e9_4 = array(
            
            "dNomCaj" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dFecIniC','!=',""],['dFecIniC','<=>',""],['dFecFinC','!=',""],['dFecFinC','<=>',""]],
            ], 
            "dEfectivo" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dVuelto" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dDonac" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dDesDonac" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                                                                                        
            
        );   

        /** Array de tags del nodo E9.5 */

        public $array_nodo_e9_5 = array(
            
            "dCiclo" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dFecIniC" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ], 
            "dFecFinC" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ], 
            "dVencPag" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ], 
            "dContrato" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],       
            "dSalAnt" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],                                                                                                               
            
        );     
        
        /** Array de tags del nodo E10 */

        public $array_nodo_e10 = array(
            
            "iTipTrans" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDesTipTrans','notnull',""]]
            ], 
            "dDesTipTrans" => [
                "type" => 'string',
                "maxlenght" => 7,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ], 
            "iModTrans" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dNroVuelo','!=!',[3]]],
                "joinMandatory" => ["dNroVuelo" => [3]],            
            ], 
            "dDesModTrans" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 5,
                "data" => "",
                "required" => false
            ], 
            "iRespFlete" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],       
            "cCondNeg" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],         
            "dNuManif" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dNuDespImp" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 16,
                "data" => 0,
                "required" => false
            ],     
            "dIniTras" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dFinTras','notnull',""]]
            ], 
            "dFinTras" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false
            ], 
            "cPaisDest" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesPaisDest','notnull',""]]
            ],   
            "dDesPaisDest" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                          
            
        );
        
        /** Array de tags del nodo E10.1 */

        public $array_nodo_e10_1 = array(
            
            "dDirLocSal" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dNumCasSal" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "errorMSg" => "Si no tiene numeracion, colocar 0 (cero)"
            ], 
            "dComp1Sal" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dComp2Sal" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "cDepSal" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],       
            "dDesDepSal" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],         
            "cDisSal" => [
                "type" => 'string',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesDisSal','notnull',""]]
            ], 
            "dDesDisSal" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],     
            "cCiuSal" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dDesCiuSal" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dTelSal" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                        
            
        );
        
        /** Array de tags del nodo E10.2 */

        public $array_nodo_e10_2 = array(
            
            "dDirLocEnt" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ], 
            "dNumCasEnt" => [
                "type" => 'number',
                "maxlenght" => 6,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ], 
            "dComp1Ent" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dComp2Ent" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "cDepEnt" => [
                "type" => 'number',
                "maxlenght" => 2,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],       
            "dDesDepEnt" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 6,
                "data" => "",
                "required" => true
            ],         
            "cDisEnt" => [
                "type" => 'number',
                "maxlenght" => 4,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDesDisEnt','notnull',""]]
            ], 
            "dDesDisEnt" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],     
            "cCiuEnt" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ], 
            "dDesCiuEnt" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ], 
            "dTelEnt" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                        
            
        );       
        
        /** Array de tags del nodo E10.3 */

        public $array_nodo_e10_3 = array(
            
            "dTiVehTras" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ], 
            "dMarVeh" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ], 
            "dTipIdenVeh" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => true,
                "joinMandatory" => ["dNroIDVeh" => [1], "dNroMatVeh" => [2]]
            ], 
            "dNroIDVeh" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dAdicVeh" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],       
            "dNroMatVeh" => [
                "type" => 'string',
                "maxlenght" => 6,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],         
            "dNroVuelo" => [
                "type" => 'string',
                "maxlenght" => 6,
                "minlenght" => 6,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                      
            
        );  
        
        /** Array de tags del nodo E10.4 */

        public $array_nodo_e10_4 = array(
            
            "iNatTrans" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => true,
                "checkSentences" => [['dRucTrans','!=!',[1]],['iTipIDTrans','!=!',[1]]],
                "joinMandatory" => ["dRucTrans" => [1],"iTipIDTrans" => [1]],            
            ], 
            "dNomTrans" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ], 
            "dRucTrans" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 3,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dDVTrans','notnull',""]],
            ], 
            "dDVTrans" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "iTipIDTrans" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => true,
                "checkSentences" => [['dDTipIDTrans','notnull',""],['dNumIDTrans','notnull',""]],
            ],       
            "dDTipIDTrans" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 9,
                "data" => "",
                "required" => false
            ],         
            "dNumIDTrans" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],      
            "cNacTrans" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesNacTrans','notnull',""]],
            ],  
            "dDesNacTrans" => [
                "type" => 'string',
                "maxlenght" => 30,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],  
            "dNumIDChof" => [
                "type" => 'string',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => true
            ],  
            "dNomChof" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => "",
                "required" => true
            ],  
            "dDomFisc" => [
                "type" => 'string',
                "maxlenght" => 150,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],         
            "dDirChof" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dNombAg" => [
                "type" => 'string',
                "maxlenght" => 60,
                "minlenght" => 4,
                "data" => "",
                "required" => false
            ],  
            "dRucAg" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],  
            "dDVAg" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],  
            "dDirAge" => [
                "type" => 'string',
                "maxlenght" => 255,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                                                                                                                                                                                                                                                                  
            
        ); 
        
        /** Array de tags del nodo F */

        public $array_nodo_f = array(
            
            "dSubExe" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dSubExo" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dSub5" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dSub10" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dTotOpe" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],       
            "dTotDesc" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],         
            "dTotDescGlotem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],      
            "dTotAntItem" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],  
            "dTotAnt" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],  
            "dPorcDescTotal" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],  
            "dDescTotal" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],  
            "dAnticipo" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ],         
            "dRedon" => [
                "type" => 'number',
                "maxlenght" => 3,
                "minlenght" => 1,
                "data" => 0,
                "default" => 0,
                "required" => true
            ], 
            "dComi" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            "dTotGralOpe" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => true
            ],  
            "dIVA5" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            "dIVA10" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ], 
            "dLiqTotIVA5" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dLiqTotIVA10" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dIVAComi" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dTotIVA" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ], 
            "dBaseGrav5" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],     
            "dBaseGrav10" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            "dTBasGraIVA" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            "dTotalGs" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            /*"dTotCom" => [
                "type" => 'number',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],*/                                                                                                                                                                                                                                                                                                                                      
            
        );

        /** Array de tags del nodo G */

        public $array_nodo_g = array(
            
            "dOrdCompra" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],    
            "dOrdVta" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dAsiento" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                  
            
        );

        /** Array de tags del nodo G1 */

        public $array_nodo_g_1 = array(
            
            "cUniMedTotVol" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],    
            "dDesUniMedTotVol" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "dTotVolMerc" => [
                "type" => 'number',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],
            "cUniMedTotPes" => [
                "type" => 'number',
                "maxlenght" => 5,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],   
            "dDesUniMedTotPes" => [
                "type" => 'string',
                "maxlenght" => 10,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],   
            "dTotPesMerc" => [
                "type" => 'number',
                "maxlenght" => 20,
                "minlenght" => 1,
                "data" => 0,
                "required" => false
            ],  
            "iCarCarga" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "joinMandatory" => ["dDesCarCarga" => [3]]
            ],  
            "dDesCarCarga" => [
                "type" => 'string',
                "maxlenght" => 50,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                                                 
            
        );      

        /** Array de tags del nodo H */

        public $array_nodo_h = array(
            
            "iTipDocAso" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => 0,
                "required" => false,
                "joinMandatory" => ["dCdCDERef" => [1],/*"dNTimDI" => [1], "dEstDocAso" => [1] ,"dPExpDocAso" => [1],"dNumDocAso" => [1],"iTipoDocAso" => [1],"iTipCons" => [1],*/"dNumCons" => [3],"dNumControl" => [3]],
                "checkSentences" => [['dCdCDERef','!=!',[1]],['dNTimDI','!=!',[2]],['dEstDocAso','!=!',[2]],['dPExpDocAso','!=!',[2]],['dNumDocAso','!=!',[2]],['iTipoDocAso','!=!',[2]],['iTipCons','!=!',[3]],['dNumCons','!=!',[3]],['dNumControl','!=!',[3]]],
            ],    
            "dDesTipDocAso" => [
                "type" => 'string',
                "maxlenght" => 11,
                "minlenght" => 7,
                "data" => "",
                "required" => false
            ],
            "dCdCDERef" => [
                "type" => 'string',
                "maxlenght" => 44,
                "minlenght" => 44,
                "data" => "",
                "required" => false
            ],    
            "dNTimDI" => [
                "type" => 'number',
                "maxlenght" => 8,
                "minlenght" => 8,
                "data" => 0,
                "required" => false,
                "checkSentences" => [['dFecEmiDI','notnull',""]]
            ],
            "dEstDocAso" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false,
            ],    
            "dPExpDocAso" => [
                "type" => 'string',
                "maxlenght" => 3,
                "minlenght" => 3,
                "data" => "",
                "required" => false
            ],   
            "dNumDocAso" => [
                "type" => 'string',
                "maxlenght" => 7,
                "minlenght" => 7,
                "data" => "",
                "required" => false
            ],   
            "iTipoDocAso" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDTipoDocAso','notnull',""]]
            ],   
            "dDTipoDocAso" => [
                "type" => 'string',
                "maxlenght" => 16,
                "minlenght" => 7,
                "data" => "",
                "required" => false,
            ],     
            "dFecEmiDI" => [
                "type" => 'date',
                "maxlenght" => 10,
                "minlenght" => 10,
                "data" => "",
                "required" => false,
            ],  
            "dNumComRet" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 15,
                "data" => "",
                "required" => false
            ],  
            "dNumResCF" => [
                "type" => 'string',
                "maxlenght" => 15,
                "minlenght" => 15,
                "data" => "",
                "required" => false
            ],  
            "iTipCons" => [
                "type" => 'number',
                "maxlenght" => 1,
                "minlenght" => 1,
                "data" => "",
                "required" => false,
                "checkSentences" => [['dDesTipCons','notnull',""]],
                "joinMandatory" => ["dNumCons" => [2], "dNumControl" => [2]]
            ],  
            "dDesTipCons" => [
                "type" => 'string',
                "maxlenght" => 34,
                "minlenght" => 30,
                "data" => "",
                "required" => false
            ],  
            "dNumCons" => [
                "type" => 'number',
                "maxlenght" => 11,
                "minlenght" => 11,
                "data" => "",
                "required" => false
            ],   
            "dNumControl" => [
                "type" => 'string',
                "maxlenght" => 8,
                "minlenght" => 8,
                "data" => "",
                "required" => false
            ],                                
            
        );  

        /** Array de tags del nodo G */

        public $array_nodo_j = array(
            
            "dCarQR" => [
                "type" => 'string',
                "maxlenght" => 600,
                "minlenght" => 100,
                "data" => "",
                "required" => false
            ],    
            "dInfAdic" => [
                "type" => 'string',
                "maxlenght" => 5000,
                "minlenght" => 1,
                "data" => "",
                "required" => false
            ],                              
            
        );

        public $array_countries_iso_cod_money = [
                                                "AED","AFN","ALL","AMD","ANG","AOA","ARS","AUD","AWG","AZN","BAM","BBD","BDT",
                                                "BGN","BHD","BIF","BMD","BND","BOB","BOV","BRL","BSD","BTN","BWP","BYN","BZD",
                                                "CAD","CDF","CHE","CHF","CHW","CLF","CLP","CNY","COP","COU","CRC","CUC","CUP",
                                                "CVE","CZK","DJF","DKK","DOP","DZD","EGP","ERN","ETB","EUR","FJD","FKP","GBP",
                                                "GEL","GHS","GIP","GMD","GNF","GTQ","GYD","HKD","HNL","HRK","HTG","HUF","IDR",
                                                "ILS","INR","IQD","IRR","ISK","JMD","JOD","JPY","KES","KGS","KHR","KMF","KPW",
                                                "KRW","KWD","KYD","KZT","LAK","LBP","LKR","LRD","LSL","LYD","MAD","MDL","MGA",
                                                "MKD","MMK","MNT","MOP","MRU","MUR","MVR","MWK","MXN","MXV","MYR","MZN","NAD",
                                                "NGN","NIO","NOK","NPR","NZD","OMR","PAB","PEN","PGK","PHP","PKR","PLN","PYG",
                                                "QAR","RON","RSD","RUB","RWF","SAR","SBD","SCR","SDG","SEK","SGD","SHP","SLL",
                                                "SOS","SRD","SSP","STN","SVC","SYP","SZL","THB","TJS","TMT","TND","TOP","TRY",
                                                "TTD","TWD","TZS","UAH","UGX","USD","USN","UYI","UYU","UYW","UZS","VES","VND",
                                                "VUV","WST","XAF","XAG","XAU","XCD","XDR","XOF","XPD","XPF","XPT","XSU","XTS",
                                                "XUA","XXX","YER","ZAR","ZMW","ZWL"
                                            ];

    }