<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="39";
$submodulo="565";
require_once("includes/rsusuario.php"); 

require_once("fe_funciones_cron.php");

$accion = substr(trim($_REQUEST['accion']),0,1); // Puedes cambiar esto a a: 'add', d: 'delete' o l: 'list' según sea necesario



// Ruta del archivo configuracion del servidor
$ruta_archivo = '1_conf_servidor.json';
// Leer el contenido del archivo
$contenido_archivo = file_get_contents($ruta_archivo);
if(!file_exists($ruta_archivo)){
	echo "No existe el archivo de configuracion del servidor.";
	exit;
}
// Decodificar el JSON en un array asociativo
$datos_servidor = json_decode($contenido_archivo, true);
$user_serv=$datos_servidor['user_serv'];
$admin_serv=$datos_servidor['admin_serv'];
	
// si agrega
if($accion == 'a'){
	// verificar que este activa la factura electronica
	$consulta="
	select fechahora_inicio_electro, facturador_electronico from preferencias limit 1
	";
	$rsfe=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if($rsfe->fields['facturador_electronico'] != 'S'){
		echo "Error: La preferencia facturador_electronico debe estar marcada en SI (Utilice el validador para activarla).";exit;
	}
}	
// si agrega o borra, todos los estados excepto leer
if($accion != 'l'){
	$consulta="
	select 
	idcliente_adm,
	(SELECT count(*) as total FROM `sucursales` where estado <> 6) as total_suc
	 from empresas 
	 limit 1
	";
	$rsemp=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
	$idcliente_adm=$rsemp->fields['idcliente_adm'];
	$total_suc=$rsemp->fields['total_suc'];

	// consulta si tiene cargado el servicio de factura electronica en su estado de cuenta
	$postdata = array(
		'idcliente'=>$idcliente_adm,
		'total_sucursales'=>$total_suc,
		'idoperacion_clase'=>11, // 11 = factura electronica
	);
	$url='http://'.$admin_serv.'/sys_consulta_serv.php';
	$parametros_array_url=array(
		'url' => $url,
		'postdata' => $postdata,
	);
	$respuesta_url=abrir_url($parametros_array_url);
	$datos=$respuesta_url['respuesta'];
	$datos_res=json_decode($datos, true);
	if($datos_res['tiene_servicio'] != 'S'){
		echo "No se puede activar por que no tiene activado el servicio en su estado de cuenta.";
		exit;
	}
}




$rutaArchivo = '/home/'.$user_serv.'/scripts/f_electronica.txt';
$contenidoActual = file_get_contents($rutaArchivo);
$shoppingsArray = json_decode($contenidoActual, true);
$directorioActual = __DIR__;
$nombreCarpeta = basename($directorioActual);
$urlBuscada = $nombreCarpeta;
// si existe el archivo
if (!file_exists($rutaArchivo)) {
    echo "El archivo de configuracion no existe.";exit;
}
// si tiene permisos de lectura
if (!is_readable($rutaArchivo)) {
    echo "El archivo de configuracion no se puede leer verificar permisos.";exit;
}
// si tiene permisos de escritura
if (!is_writable($rutaArchivo)) {
    echo "El archivo de configuracion no se puede escribir verificar permisos.";exit;
}
// Verificar si se pudo leer el archivo
if($contenidoActual === false) {
    // No se pudo leer el archivo
    echo "Error: No se pudo acceder al contenido del archivo, probablemente falta permisos al archivo.";exit;
}


switch ($accion) {
    case 'a':
        $res=agregarUrl($rutaArchivo, $shoppingsArray, $nombreCarpeta, $urlBuscada);
        break;
    case 'd':
        $res=borrarUrl($rutaArchivo, $shoppingsArray, $nombreCarpeta, $urlBuscada);
        break;
    case 'l':
        $res=verificarUrl($shoppingsArray, $urlBuscada);
        break;
    default:
        echo "Acción no permitida.";
        break;
}


// convierte a formato json
$respuesta=json_encode($res, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);

// devuelve la respuesta formateada
echo $respuesta;


/*
$contenidoActual = file_get_contents($rutaArchivo);
echo $contenidoActual;*/
?>
