<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="363";
require_once("includes/rsusuario.php"); 

function generar_clave_segura($longitud = 8) {
  // Conjunto de caracteres permitidos
  $mayusculas = 'ABCDEFGHIJKLMNPQRSTUVWXYZ'; // se omite la letra O para evitar confusion visual
  $minusculas = 'abcdefghijklmnopqrstuvwxyz';
  $numeros = '123456789'; // se omite el 0 para evitar confusion visual
  $simbolos = '!@#%^&*()-_=+'; // $ se excluyen para evitar conflictos con excel

  // Selecciona al menos un carácter de cada conjunto
  $clave = $mayusculas[rand(0, strlen($mayusculas) - 1)] .
           $minusculas[rand(0, strlen($minusculas) - 1)] .
           $numeros[rand(0, strlen($numeros) - 1)] .
           $simbolos[rand(0, strlen($simbolos) - 1)];
		   

  // Agrega el resto de los caracteres de forma aleatoria
  $caracteres_resto = $mayusculas . $minusculas . $numeros . $simbolos;
  $caracteres_resto = str_shuffle($caracteres_resto);
  $clave .= substr($caracteres_resto, 0, $longitud - 4);

  // Mezcla los caracteres de forma aleatoria
  $clave = str_shuffle($clave);
  
  // si el primer caracter es un simbolo
  if (preg_match('/^[^\w]+$/', $clave[0])) {
	// genera un nuevo primer caracter sin simbolo
	$primer_caracter_sin_simbolo=substr(str_shuffle($mayusculas.$minusculas.$numeros),0,1);
	// nueva clave
	$clave=$primer_caracter_sin_simbolo.substr($clave,1,$longitud-1);
  }

  return $clave;
}

$idbancardqrpref=1;


// consulta a la tabla	
$consulta="
select * 
from bancard_qr_preferencias 	
where 
idbancardqrpref = $idbancardqrpref
limit 1
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idbancardqrpref=intval($rs->fields['idbancardqrpref']);
if($idbancardqrpref == 0){
	echo "No se encontro ninguna preferencia.";
	exit;	
}

if(trim($rs->fields['usuario_nuestro']) == ''){
	$usuario_nuestro=antisqlinyeccion(generar_clave_segura(20),"textbox");
	$clave_nuestro=antisqlinyeccion(generar_clave_segura(20),"textbox");
	$prefijo_usu=antisqlinyeccion('apps/',"textbox");
	$consulta_update="
	update bancard_qr_preferencias
	set 
	usuario_nuestro = $usuario_nuestro,
	clave_nuestro = $clave_nuestro,
	prefijo_usu = $prefijo_usu
	where 
	idbancardqrpref = $idbancardqrpref
	";
	$conexion->Execute($consulta_update) or die(errorpg($conexion,$consulta_update));
	// vuelve a consultar la tabla despues de actualizar
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
}


// se puede mover esta funcion al archivo funciones_bancard_qr_preferencias.php y realizar un require_once
function bancard_qr_preferencias_edit($parametros_array){
	global $conexion;
	global $saltolinea;

	// validaciones basicas
	$valido="S";
	$errores="";
	
    
	$usuario=antisqlinyeccion($parametros_array['usuario'],"textbox");
	$clave=antisqlinyeccion($parametros_array['clave'],"textbox");
	//$prefijo_usu=antisqlinyeccion($parametros_array['prefijo_usu'],"textbox");
	//$url_genera_qr=antisqlinyeccion($parametros_array['url_genera_qr'],"textbox");
	//$url_reversa=antisqlinyeccion($parametros_array['url_reversa'],"textbox");
	$idbancardqrpref=antisqlinyeccion($parametros_array['idbancardqrpref'],"int");
	//$usuario_nuestro=antisqlinyeccion($parametros_array['usuario_nuestro'],"textbox");
	//$clave_nuestro=antisqlinyeccion($parametros_array['clave_nuestro'],"textbox");
	$codigo_comercio=antisqlinyeccion($parametros_array['codigo_comercio'],"int");
	$ambiente=antisqlinyeccion($parametros_array['ambiente'],"text");

	

	if(trim($parametros_array['usuario']) == ''){
		$valido="N";
		$errores.=" - El campo usuario no puede estar vacio.<br />";	
	}
	if(trim($parametros_array['clave']) == ''){
		$valido="N";
		$errores.=" - El campo clave no puede estar vacio.<br />";	
	}
	if(trim($parametros_array['ambiente']) == ''){
		$valido="N";
		$errores.=" - El campo ambiente no puede estar vacio.<br />";	
	}
	if(intval($parametros_array['codigo_comercio']) == 0){
		$valido="N";
		$errores.=" - El campo codigo_comercio no puede estar vacio.<br />";	
	}

	/*if(trim($prefijo_usu) == ''){
		$valido="N";
		$errores.=" - El campo prefijo_usu no puede estar vacio.<br />";	
	}

	if(trim($url_genera_qr) == ''){
		$valido="N";
		$errores.=" - El campo url_genera_qr no puede estar vacio.<br />";	
	}*/

	/*if(trim($url_reversa) == ''){
		$valido="N";
		$errores.=" - El campo url_reversa no puede estar vacio.<br />";	
	}*/
	/*if(trim($usuario_nuestro) == ''){
		$valido="N";
		$errores.=" - El campo usuario_nuestro no puede estar vacio.<br />";	
	}
	if(trim($clave_nuestro) == ''){
		$valido="N";
		$errores.=" - El campo clave_nuestro no puede estar vacio.<br />";	
	}*/
	



	// si todo es correcto actualiza
	if($valido == "S"){
/*
	prefijo_usu=$prefijo_usu,
	usuario_nuestro=$usuario_nuestro,
	clave_nuestro=$clave_nuestro
*/
		
		$consulta="
		update bancard_qr_preferencias
		set
			usuario=$usuario,
			clave=$clave,
			codigo_comercio=$codigo_comercio,
			ambiente=$ambiente
		where
			idbancardqrpref = $idbancardqrpref
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

		// sucursales
		foreach($parametros_array['sucursales'] as $idsucu => $codigo_sucursal_bancard){
			$codigo_sucursal_bancard=antisqlinyeccion($codigo_sucursal_bancard,"int");
			$idsucu=antisqlinyeccion($idsucu,"int");
			/*if($codigo_sucursal_bancard == 0){
				$codigo_sucursal_bancard='NULL';
			}*/
			if(intval($idsucu) > 0){
				$consulta="
				update sucursales
				set
					codigo_sucursal_bancard=$codigo_sucursal_bancard
				where
					idsucu = $idsucu
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			}			
		}
	
	}


	return array("errores"=>$errores,"valido"=>$valido);
}


if(isset($_POST['MM_update']) && $_POST['MM_update'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	

	// recibe parametros
	$usuario=$_POST['usuario'];
	$clave=$_POST['clave'];
	//$prefijo_usu=$_POST['prefijo_usu'];
	//$url_genera_qr=$_POST['url_genera_qr'];
	//$url_reversa=$_POST['url_reversa'];
	//$usuario_nuestro=$_POST['usuario_nuestro'];
	//$clave_nuestro=$_POST['clave_nuestro'];
	$codigo_comercio=$_POST['codigo_comercio'];
	$ambiente=$_POST['ambiente'];

	//parametros de sucursales
	$consulta="
	select idsucu, nombre, codigo_sucursal_bancard
	from sucursales 
	where 
	 estado = 1 
	order by idsucu asc
	";
	$rssuc=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	while(!$rssuc->EOF){	
		$idsucu=intval($rssuc->fields['idsucu']);
		$codigo_sucursal_bancard[$idsucu] = $_POST['codigo_sucursal_bancard_'.$idsucu];
	$rssuc->MoveNext(); }


	$parametros_array=array(
		"usuario" => $usuario,
		"clave" => $clave,
		"codigo_comercio" => $codigo_comercio,
		"ambiente" => $ambiente,
		//"prefijo_usu" => $prefijo_usu,
		//"url_genera_qr" => $url_genera_qr,
		//"url_reversa" => $url_reversa,
		//"usuario_nuestro" => $usuario_nuestro,
		//"clave_nuestro" => $clave_nuestro,
		"idbancardqrpref" => $idbancardqrpref,
		"sucursales" => $codigo_sucursal_bancard
	);
	//print_r($parametros_array);exit;

	// si todo es correcto actualiza
	if($valido == "S"){
		$res=bancard_qr_preferencias_edit($parametros_array);
		if ($res["valido"]=="S") {
			header("location: formas_pago_bancard_qr.php?ok=s");
			exit;
		}else{
			$errores.=$res["errores"];
		}
		
	}else{
		$errores.=$res["errores"];
	}


}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());

if($_GET['ok'] == 's'){
	$disabled='disabled';
}else{
	$disabled='';
}

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
<script>
function IsJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}
function registra_permiso(idintegracionbancard){
	var direccionurl='formas_pago_bancard_qr_registra.php';	
	var parametros = {
	  "idintegracionbancard"  : idintegracionbancard,
	};
	$.ajax({		  
		data:  parametros,
		url:   direccionurl,
		type:  'post',
		cache: false,
		timeout: 3000,  // I chose 3 secs for kicks: 3000
		crossDomain: true,
		beforeSend: function () {
			$("#estado_td_"+idintegracionbancard).html('Cargando...');	
			//alert('a');
		},
		success:  function (response, textStatus, xhr) {
			//alert(response);
			if(IsJsonString(response)){
				var obj = jQuery.parseJSON(response);
				if(obj.valido == 'S'){
					$("#estado_td_"+idintegracionbancard).html(obj.html_checkbox);
					var elem = $("#estado_"+idintegracionbancard);
					var idbox = "estado";
					switchery_reactivar_id(idintegracionbancard);
				}else{
					alert(obj.errores);
				}
			}else{
				alert(response);	
			}
		},
		error: function(jqXHR, textStatus, errorThrown) {
			errores_ajax_manejador(jqXHR, textStatus, errorThrown, 'error');
		}
	}).fail( function( jqXHR, textStatus, errorThrown ) {
		errores_ajax_manejador(jqXHR, textStatus, errorThrown, 'fail');
	});
	
}
function switchery_reactivar_id(idintegracionbancard){
	var elems = document.querySelector('#estado_'+idintegracionbancard);
	var switchery = new Switchery(elems);
}
</script>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Bancard QR Pantalla</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<p>
<a href="formas_pago.php" class="btn btn-sm btn-default"><span class="fa fa-reply"></span> Volver</a>
</p>
<hr />
IMPORTANTE: no basta con solo activar en esta seccion, debe solicitar a su ejecutivo de bancard tambien la activacion de la integracion.<HR />
<?php 

$consulta="
select idintegracionbancard, integracion, estado
from integracion_bancard
where
idintegracionbancard in (1,2,3)
order by integracion asc
";
$rsact=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
?>
<strong>Integraciones Activas:</strong><br />
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>
			<th>Estado</th>
			<th align="center">Integracion</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rsact->EOF){
	
$idintegracionbancard=intval($rsact->fields['idintegracionbancard']);
$estado=$rsact->fields['estado'];

?>
		<tr>
        	<td id="estado_td_<?php echo $idintegracionbancard; ?>">
			<input name="estado" id="estado_<?php echo $idintegracionbancard; ?>" type="checkbox" value="S" class="js-switch" onChange="registra_permiso(<?php echo $idintegracionbancard; ?>);" <?php if($estado==1){ echo "checked"; } ?>   >
			</td>
	

			<td align="center"><?php echo antixss($rsact->fields['integracion']); ?></td>
		</tr>
<?php $rsact->MoveNext(); } //$rsact->MoveFirst(); ?>
	  </tbody>
    </table>
</div>
<br />
<hr />

<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
</button>
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<form id="form1" name="form1" method="post" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Usuario Bancard (Clave Publica) *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input <?php echo $disabled; ?> type="text" name="usuario" id="usuario" value="<?php  if(isset($_POST['usuario'])){ echo htmlentities($_POST['usuario']); }else{ echo htmlentities($rs->fields['usuario']); }?>" placeholder="Usuario" class="form-control"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Clave Bancard (Clave Privada) *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input <?php echo $disabled; ?> type="text" name="clave" id="clave" value="<?php  if(isset($_POST['clave'])){ echo htmlentities($_POST['clave']); }else{ echo htmlentities($rs->fields['clave']); }?>" placeholder="Clave" class="form-control"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Codigo Comercio *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input <?php echo $disabled; ?> type="text" name="codigo_comercio" id="codigo_comercio" value="<?php  if(isset($_POST['codigo_comercio'])){ echo htmlentities($_POST['codigo_comercio']); }else{ echo htmlentities($rs->fields['codigo_comercio']); }?>" placeholder="Codigo comercio" class="form-control"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Ambiente *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php
// valor seleccionado
if(isset($_POST['ambiente'])){ 
	$value_selected=htmlentities($_POST['ambiente']); 
}else{
	$value_selected=$rs->fields['ambiente'];
}
// opciones
$opciones=array(
	'TESTING' => 'T',
	'PRODUCCION' => 'P'
);
// parametros
$parametros_array=array(
	'nombre_campo' => 'ambiente',
	'id_campo' => 'ambiente',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'Seleccionar...',
	'pricampo_value' => '',
	'style_input' => 'class="form-control"', 
	'acciones' => ' required="required" '.$disabled,
	'autosel_1registro' => 'S',
	'opciones' => $opciones

);

// construye campo
echo campo_select_sinbd($parametros_array);
?>	
	</div>
</div>
<div class="clearfix"></div>

<?php	
$consulta="
select idsucu, nombre, codigo_sucursal_bancard
from sucursales 
where 
 estado = 1 
order by idsucu asc
";
$rssuc=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

?>
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>

			<th align="center">Idsucu</th>
			<th align="center">Sucursal</th>


			<th align="center">Codigo sucursal bancard (branch_code)</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rssuc->EOF){
$idsucu=$rssuc->fields['idsucu'];
?>
		<tr>
			<td align="right"><?php echo formatomoneda($idsucu);  ?></td>
			<td align="left"><?php echo antixss($rssuc->fields['nombre']); ?></td>
			<td align="center"><input <?php echo $disabled; ?> type="text" name="codigo_sucursal_bancard_<?php echo $idsucu; ?>" id="codigo_sucursal_bancard_<?php echo $idsucu; ?>" value="<?php  if(isset($_POST['codigo_sucursal_bancard_'.$idsucu])){ echo htmlentities($_POST['codigo_sucursal_bancard_'.$idsucu]); }else{ echo htmlentities($rssuc->fields['codigo_sucursal_bancard']); }?>" placeholder="Codigo sucursal bancard" class="form-control"  /></td>
		</tr>
<?php 

$rssuc->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>
	
    </table>
</div>
<br />

<div class="clearfix"></div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Usuario CallBack *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input disabled type="text" name="usuario_nuestro" id="usuario_nuestro" value="<?php  if(isset($_POST['usuario_nuestro'])){ echo htmlentities($_POST['usuario_nuestro']); }else{ echo htmlentities($rs->fields['usuario_nuestro']); }?>" placeholder="Usuario nuestro" class="form-control" required="required" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Clave CallBack *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input disabled type="text" name="clave_nuestro" id="clave_nuestro" value="<?php  if(isset($_POST['clave_nuestro'])){ echo htmlentities($_POST['clave_nuestro']); }else{ echo htmlentities($rs->fields['clave_nuestro']); }?>" placeholder="Clave nuestra" class="form-control" required="required" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">URL CallBack *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input disabled type="text" name="url_callback" id="url_callback" value="<?php echo "https://".antixss($_SERVER['HTTP_HOST'])."/callback.php"; ?>" placeholder="url_callback" class="form-control" required="required" />                    
	</div>
</div>





<div class="clearfix"></div>
<br />

    <div class="form-group">
		<div class="col-md-12 col-sm-12 col-xs-12 text-center">
        <?php if($_GET['ok'] != 's'){ ?>
			<button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar</button>
		<?php }else{ ?>
			<button type="button" class="btn btn-default"  onMouseUp="document.location.href='formas_pago_bancard_qr.php'"><span class="fa fa-edit"></span> Editar</button>
		<?php } ?>
        </div>
    </div>

  <input type="hidden" name="MM_update" value="form1" />
  <input type="hidden" name="form_control" value="<?php echo htmlentities($_SESSION['form_control']); ?>">
<br />
</form>
<div class="clearfix"></div>
<br /><br />


<strong>Datos Ambiente testing:</strong><br />
Prefijo: apps/<br />
Url genera qr: https://desa.infonet.com.py:8035/external-commerce/api/0.1/commerces/233225/branches/5/selling/generate-qr-express<br />
Url reversa: https://desa.infonet.com.py:8035/external-commerce/api/0.1/commerces/233225/branches/5/selling/payments/revert/<br />
<br />
<strong>Datos Ambiente produccion:</strong><br />
Prefijo: apps/<br />
Url genera qr:  https://comercios.bancard.com.py/external-commerce/api/0.1/commerces/233225/branches/5/selling/generate-qr-express<br />
Url reversa:  https://comercios.bancard.com.py/external-commerce/api/0.1/commerces/233225/branches/5/selling/payments/revert/<br />
<br />

<strong>Para integrar QR POS y Tarjeta POS:</strong><br />
1) Solicitar la integracion al ejecutivo de bancard y una visita de un tecnico de bancar que configure la ip del POS.<br />
2) El POS de BANCARD debe estar en la misma red WIFI que la computadora de caja.<br />
3) Se debe configurar que el POS de BANCARD tenga una IP Estatica dentro del mismo rango que la computadora de caja.<br />
4) Luego de realizar los pasos del 1 al 3 comunicarse con el soporte del sistema para que configuren en cada computadora de caja la IP que puso el tecnico de Bancard en el POS.<br />
5) En gestion > formas de pago activar integra POS para las formas de pago que apliquen. <br />
6) en gestion > sucursales  activar integra POS para las sucursales que apliquen. <br />
<br />
<strong>Para integrar QR Pantalla:</strong><br />
1) Solicitar la integracion al ejecutivo de bancard.<br />
2) Ingresar en esta seccion las credenciales de usuario y clave proporcionadas por Bancard.<br />
3) Proporcionar a tu ejecutivo de Bancard la URL de tu CallBack: <strong><?php echo "https://".antixss($_SERVER['HTTP_HOST'])."/callback.php"; ?></strong>.<br />
4) En gestion > formas de pago activar integra POS para las formas de pago que apliquen.<br />
5) en gestion > sucursales  activar integra POS para las sucursales que apliquen.<br />

<hr />
<img src="img/bancard_qr_explicacion.png" class="img-thumbnail" />
<hr />

<br /><br /><br /><br /><br />

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
<link href="vendors/switchery/dist/switchery.min.css" rel="stylesheet">
<script src="vendors/switchery/dist/switchery.min.js" type="text/javascript"></script>
  </body>
</html>
