<?php

// Parámetros
//$directorio = __DIR__;  // Reemplaza con la ruta a tu directorio
$directorio = dirname(__DIR__);  // Esto obtiene el directorio padre del directorio donde está el script
$cadenaBuscada = ') as total
from productos';    // Reemplaza con la cadena que deseas buscar
$excluirDirectorios = '1 version vieja,bak,mesas - copia,savedemo,tablet - copia';    // Directorios a excluir, separados por comas
$excluirArchivos = 'gest_ventas_resto_caja_bak.php,gest_ventas_resto_caja_OR.php,1_buscador_codigo_php.php,index_bak.php';  // Archivos a excluir, separados por comas



/*
// ver ubicacion del log y tambien si esta activado o no en variables del mysql / long_query_time = 10 (segundos)
SHOW VARIABLES LIKE 'slow_query_log%';
SHOW VARIABLES LIKE 'long_query_time%';
*/





// Función para buscar una cadena en el contenido de los archivos
function buscarCadenaEnDirectorio($directorio, $cadenaBuscada, $excluirDirectorios, $excluirArchivos) {
    $resultados = [];

    // Asegúrate de que el directorio exista
    if (!is_dir($directorio)) {
        die("El directorio especificado no existe.");
    }

    // Convertir las listas de exclusión en arrays
    $excluirDirectoriosArray = array_map('trim', explode(',', $excluirDirectorios));
    $excluirArchivosArray = array_map('trim', explode(',', $excluirArchivos));

    // Crear un iterador recursivo para el directorio
    $archivos = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($directorio));

    // Recorrer los archivos en el directorio
    foreach ($archivos as $archivo) {
        $rutaArchivo = $archivo->getPathname();
        $nombreArchivo = $archivo->getFilename();

        // Comprobar si el archivo pertenece a uno de los directorios excluidos
        $excluir = false;
        foreach ($excluirDirectoriosArray as $dir) {
            if (strpos($rutaArchivo, DIRECTORY_SEPARATOR . $dir . DIRECTORY_SEPARATOR) !== false) {
                $excluir = true;
                break;
            }
        }

        // Comprobar si el archivo está en la lista de archivos a excluir
        if (in_array($nombreArchivo, $excluirArchivosArray)) {
            $excluir = true;
        }

        // Saltar el archivo si está en un directorio excluido o si es un archivo excluido
        if ($excluir) {
            continue;
        }

        // Comprobar que es un archivo y tiene extensión .php
        if ($archivo->isFile() && $archivo->getExtension() === 'php') {
            $contenido = file_get_contents($rutaArchivo);

            // Buscar la cadena en el contenido completo del archivo
            $posicion = strpos($contenido, $cadenaBuscada);

            if ($posicion !== false) {
                // Obtener la línea donde se encuentra la cadena
                $lineas = substr_count(substr($contenido, 0, $posicion), "\n") + 1;
                $resultados[] = [
                    'archivo' => $rutaArchivo,
                    'linea' => $lineas
                ];
            }
        }
    }

    return $resultados;
}


$resultados = buscarCadenaEnDirectorio($directorio, $cadenaBuscada, $excluirDirectorios, $excluirArchivos);

// Mostrar los resultados
if (empty($resultados)) {
    echo "No se encontraron coincidencias.";
} else {
    foreach ($resultados as $resultado) {
        echo "- Archivo: " . $resultado['archivo'] . " - Línea: " . $resultado['linea'] . "<br />";
    }
}

?>
