<?php 
require_once("conexion.php");
require_once("funciones.php");

function validar_asiento($parametros_array){
	
	
	global $saltolinea;
	global $conexion;
	
	$valido="S";
	$errores="";
	
	$fecha=trim($parametros_array['fecha']);
	$explicacion=trim($parametros_array['explicacion']);
	$registrado_por=intval($parametros_array['registrado_por']);
	$automatico=trim($parametros_array['automatico']);
	
	if($fecha == ''){
		$valido="N";
		$errores.="- No se indico la fecha del asiento.".$saltolinea;
	}
	if($explicacion == ''){
		$valido="N";
		$errores.="- No se indico la explicacion del asiento.".$saltolinea;
	}
	if($registrado_por == 0){
		$valido="N";
		$errores.="- No se indico el usuario que registra el asiento.".$saltolinea;
	}
	if($automatico != 'S' && $automatico != 'N'){
		$valido="N";
		$errores.="- No se indico si el asiento es manual o automatico.".$saltolinea;
	}
	
	// validar que la fecha no corresponda a un periodo fiscal cerrado
	$consulta="
	
	";
	
	
	$detalles=$parametros_array['detalles'];
	
	// sumar debe y haber y validar que coincida
	foreach($detalles as $detalle){
		$tipo=$detalle['tipo']; // debe o haber
		$idcuentacontable=intval($detalle['idcuentacontable']);
		$monto_asiento=floatval($detalle['monto_asiento']);
		if($idcuentacontable == 0){
			$valido="N";
			$errores.="- No se indico la cuenta contable.".$saltolinea;
		}
		if($monto_asiento <= 0){
			$valido="N";
			$errores.="- El monto del asiento no puede ser menor o igual a cero.".$saltolinea;
		}
		if($tipo != 'D' && $tipo != 'H'){
			$valido="N";
			$errores.="- Tipo de asiento incorrecto.".$saltolinea;
		}
		if($tipo == 'D'){
			$total_debe+=$detalle['monto_asiento'];
		}
		if($tipo == 'H'){
			$total_haber+=$detalle['monto_asiento'];
		}
		
		// validar que la cuenta contable exista en la bd
		$consulta="
		
		";
		
		
	}
	if($total_debe != $total_haber){
		$valido="N";
		$errores.="- Asiento no balancea.".$saltolinea;
	}
	//echo "Debe: ".$total_debe."<br />";
	//echo "Haber: ".$total_haber."<br />";
	
	
	
	$res=array('valido' => $valido, 'errores' => $errores);
	return $res;
}

function registrar_asiento($parametros_array){
	
	global $ahora;
	global $conexion;
	
	$fecha=antisqlinyeccion(trim($parametros_array['fecha']),"text");
	$explicacion=antisqlinyeccion(trim($parametros_array['explicacion']),"text");
	$registrado_por=antisqlinyeccion($parametros_array['registrado_por'],"int");
	$automatico=antisqlinyeccion(trim($parametros_array['automatico']),"text");
	$detalles=$parametros_array['detalles'];
	
	$periodo=date("Y",strtotime($parametros_array['fecha']));
	
	$consulta="
	select max(asiento_numero) as asiento_numero from asiento
	";
	$rsmax=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$asiento_numero=intval($rsmax->fields['asiento_numero'])+1;
	
	$consulta="
	INSERT INTO asiento
	(asiento_numero, fecha, periodo, explicacion, registrado_por, registrado_el, estado, automatico) 
	VALUES 
	($asiento_numero, $fecha, $periodo, $explicacion, $registrado_por, '$ahora', 1, $automatico)
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	
	$consulta="
	select idasiento from asiento where registrado_por = $registrado_por order by idasiento desc limit 1
	";
	$rsid=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idasiento=intval($rsid->fields['idasiento']);
	
	foreach($detalles as $detalle){
		$tipo=antisqlinyeccion($detalle['tipo'],"text"); // debe o haber
		$idcuentacontable=intval($detalle['idcuentacontable']);
		$monto_asiento=floatval($detalle['monto_asiento']);
	
		$consulta="
		INSERT INTO asiento_det
		(idasiento, tipo, idcuentacontable, monto_asiento) 
		VALUES 
		($idasiento, $tipo, $idcuentacontable, $monto_asiento)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	}
	
	$res=array('idasiento' => $idasiento, 'asiento_numero' => $asiento_numero );
	return $res; // idasiento
}



$detalles_asiento[]=array(
	'tipo' => 'D',
	'idcuentacontable' => 112,
	'monto_asiento' => 150000,


);
$detalles_asiento[]=array(
	'tipo' => 'H',
	'idcuentacontable' => 113,
	'monto_asiento' => 100000,


);
$detalles_asiento[]=array(
	'tipo' => 'H',
	'idcuentacontable' => 114,
	'monto_asiento' => 50000,


);

$parametros_array=array(
	'fecha' => '2021-01-09',
	'explicacion' => 'VENTA DE MERCADERIA',
	'registrado_por' => 1,
	'automatico' => 'N',
	'detalles' => $detalles_asiento,
);

print_r($parametros_array);

$res=validar_asiento($parametros_array);

print_r($res);
// si todo es valido
if($res['valido'] == 'S'){
	
	$res=registrar_asiento($parametros_array);
	print_r($res);
}


/*

CREATE TABLE IF NOT EXISTS `asiento` (
  `idasiento` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `asiento_numero` int(11) NOT NULL,
  `fecha` date NOT NULL,
  `periodo` int(4) NOT NULL,
  `explicacion` varchar(250) NOT NULL,
  `registrado_por` int(11) NOT NULL,
  `registrado_el` datetime NOT NULL,
  `estado` int(11) NOT NULL DEFAULT 1,
  `automatico` char(1) DEFAULT NULL COMMENT 'S: si N: no',
  PRIMARY KEY (`idasiento`),
  KEY `estado` (`estado`),
  KEY `fecha` (`fecha`),
  KEY `periodo` (`periodo`),
  KEY `asiento_numero` (`asiento_numero`),
  KEY `automatico` (`automatico`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS asiento_det (
  idasientodet bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  idasiento bigint(20) UNSIGNED NOT NULL,
  tipo char(1) NOT NULL COMMENT 'D: debe H: haber',
  idcuentacontable int(11) NOT NULL,
  monto_asiento decimal(34,4) NOT NULL,
  PRIMARY KEY (idasientodet),
  KEY idasiento (idasiento),
  KEY tipo (tipo),
  KEY idcuentacontable (idcuentacontable)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;





*/

?>