<?php 

function preciohab_json($idhab,$desde,$hasta,$pax_adul,$pax_nin){
	
	// variables globales
	global $conexion;
	global $ahora;
	global $idempresa;
	
	// inicializando variables
	$valido="S";
	$errores="";
	
	// conversiones
	$hoy=date("Y-m-d");
	$desde=date("Y-m-d",strtotime($desde));
	$hasta=date("Y-m-d",strtotime($hasta));
	
	// validaciones
	if($idhab == 0){
		$valido="N";
		$errores.="-No indico la habitacion.".$saltolinea;
	}
	if(trim($_POST['desde']) == '' or trim($_POST['hasta']) == ''){
		$valido="N";
		$errores.="-No indico las fechas desde y hasta.".$saltolinea;
	}
	if($pax_adul <= 0){
		$valido="N";
		$errores.="-No indico la cantidad de PAX adultos.".$saltolinea;	
	}
	/*if($pax_nin <= 0){
		$valido="N";
		$errores.="-No indico la cantidad de PAX niños.".$saltolinea;	
	}*/
	if(strtotime($desde) < strtotime($hoy)){
		$valido="N";
		$errores.="-La fecha desde no puede estar en el pasado.".$saltolinea;
	}
	if(strtotime($hasta) < strtotime($hoy)){
		$valido="N";
		$errores.="-La fecha hasta no puede estar en el pasado.".$saltolinea;
	}
	if(strtotime($hasta) < strtotime($desde)){
		$valido="N";
		$errores.="-La fecha hasta no puede ser menor a la fecha desde.".$saltolinea;
	}
	
	
	// errores
	if($valido == 'N'){
		$arr = array(
		'error' => $errores
		);
		$resp=json_encode($arr);
		echo $resp;
		exit;
	}
	// precios estandar
	$buscar="
	Select *, datediff('$hasta','$desde') as noches
	from ht_habitaciones 
	inner join ht_tipohab on ht_tipohab.idtipohab = ht_habitaciones.tipohab
	where 
	ht_habitaciones.estado =1 
	and ht_tipohab.estado =1 
	and ht_habitaciones.idhab = $idhab
	order by numero asc 
	limit 1
	";
	$rshab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$idhab=intval($rshab->fields['idhab']);
	$tot_noches=intval($rshab->fields['noches']);
	$prec_hab_estandar=intval($rshab->fields['precioalquiler']);
	$prec_adulto_estandar=intval($rshab->fields['adicional_persona']);
	$prec_nino_estandar=intval($rshab->fields['adicional_nino']);
	
	
	
	// buscar fecha especial
	$consulta="
	SELECT sum(precio_habitacion) as total_hab, sum(precio_adulto) as total_adul, sum(precio_nino) as total_nin, count(idhab) as total_fechas
	FROM ht_precioshab_fechaespecial
	where 
	idhab = $idhab
	and '$desde' <= fecha_especial
	and '$hasta' >= fecha_especial
	and idempresa = $idempresa
	";
	$rstar=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$total_noches_especial=intval($rstar->fields['total_fechas']);
	$prec_hab_especial=floatval($rstar->fields['total_hab']);
	$prec_adulto_especial=floatval($rstar->fields['total_adul']);
	$prec_nino_especial=floatval($rstar->fields['total_nin']);
	
	
	
	
	// calculo estandar
	$tot_noches_estandar = $tot_noches-$total_noches_especial;
	$tot_hab_estandar = $prec_hab_estandar*$tot_noches_estandar;
	$tot_adulto_estandar = $prec_adulto_estandar*$tot_noches_estandar*$pax_adul;
	$tot_nino_estandar = $prec_nino_estandar*$tot_noches_estandar*$pax_nin;
	$total_estandar = $tot_hab_estandar+$tot_adulto_estandar+$tot_nino_estandar;
	// calculo especial
	$total_noches_especial=$total_noches_especial;
	$tot_hab_especial = $prec_hab_especial;
	$tot_adulto_especial = $prec_adulto_especial*$pax_adul;
	$tot_nino_especial = $prec_nino_especial*$pax_nin;
	$total_especial = $tot_hab_especial+$tot_adulto_especial+$tot_nino_especial;
	
	// estandar + especial
	$total_sumatoria=$total_estandar+$total_especial;
	$precio_promedio_noche=$total_sumatoria/$tot_noches;
	
	if($idhab == 0){
		$arr = array(
		'error' => 'Debe indicar una habitacion valida.'
		);
		$resp=json_encode($arr);
		echo $resp;
		exit;
	}
	//
	// genera array con los datos
	$arr = array(
		'total' => $total_sumatoria, 
		'total_txt' => formatomoneda($total_sumatoria,4,'N'), 
		'precio_promedio_noche' => $precio_promedio_noche, 
		'precio_promedio_noche_txt' => formatomoneda($precio_promedio_noche,4,'N'),
		'error' => ''
	);
	
	// convierte a formato json
	$respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	
	// devuelve la respuesta formateada
	return $respuesta;

}

?>