<?php 
function valida_traslado_entre_depositos($parametros_array){
	
	global $ahora;
	global $conexion;
	global $idempresa;
	
	$valido="S";
	$errores="";
	
	
	// recibe parametros
	$iddeposito_origen=intval($parametros_array['iddeposito_origen']);
	$iddeposito_destino=intval($parametros_array['iddeposito_destino']);
	$fecha_traslado=trim($parametros_array['fecha_traslado']);
	$generado_por=intval($parametros_array['generado_por']);
	$detalles=$parametros_array['detalle'];
	$detalle_precargado=$parametros_array['detalle_precargado'];
	$idtanda=intval($parametros_array['idtanda']);
	$tfin=$idtanda;
	
	// busca en preferencias si quiere validar o no el disponible de stock
	$consulta="
	SELECT 	traslado_nostock FROM preferencias where idempresa = $idempresa
	";
	$rspref=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if($rspref->fields['traslado_nostock'] == 2){
		$valida_stock="S";
	}else{
		$valida_stock="N";	
	}
	// preferencias transferencia
	$consulta="
	select obliga_confirmar, confirma_auto, fecha_traslado_fija
	from preferencias_transfer
	limit 1
	";
	$rspreftrans=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$obliga_confirmar=$rspreftrans->fields['obliga_confirmar'];
	$confirma_auto=$rspreftrans->fields['confirma_auto'];
	$fecha_traslado_fija=$rspreftrans->fields['fecha_traslado_fija'];
	
	if($fecha_traslado_fija == 'S'){
		if(date("Y-m-d",strtotime($fecha_traslado)) != date("Y-m-d")){
			$valido="N";
			$errores.=" - Tu administracion bloqueo el permiso de carga de transferencias con una fecha diferente a hoy.<br />";	
		}
	}

	// si obliga a confirmar todo
	if($obliga_confirmar == 'S'){
		$consulta="
		select idtanda
		from tmp_transfer
		where
		idtanda = $idtanda
		and confirmado = 'N'
		limit 1
		";
		$rsnoconf=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		if(intval($rsnoconf->fields['idtanda']) > 0){
			$valido="N";
			$errores.="- Hay productos pendientes de confirmacion.".$saltolinea;	
		}
	}
	
	// valida deposito de transito
	$consulta="
	select * from gest_depositos where tiposala = 3 order by iddeposito asc limit 1
	";
	$rstran=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$iddeposito_transito=intval($rstran->fields['iddeposito']);
	if($iddeposito_transito == 0){
		$valido="N";
		$errores.="- Deposito de transito inexistente.".$saltolinea;	
	}

	
	// validaciones
	if($iddeposito_origen == $iddeposito_destino){
		$valido="N";
		$errores.="- El deposito de origen no puede ser igual al de destino.".$saltolinea;	
	}
	if($iddeposito_origen == 0){
		$valido="N";
		$errores.="- El deposito de origen no puede estar vacio.".$saltolinea;	
	}
	if($iddeposito_destino == 0){
		$valido="N";
		$errores.="- El deposito de destino no puede estar vacio.".$saltolinea;	
	}
	if(trim($fecha_traslado) == ''){
		$valido="N";
		$errores.="- No se indico la fecha de traslado.".$saltolinea;	
	}
	if(strtotime($fecha_traslado) > strtotime(date("Y-m-d"))){
		$valido="N";
		$errores.="- La fecha de traslado no puede estar en el futuro.".$saltolinea;	
	}
	
	if($detalle_precargado == 'S'){
		if($idtanda == 0){
			$valido="N";
			$errores.="- Se debe indicar el idtanda cuando es precargado.".$saltolinea;	
		}
	
		if($idtanda > 0){
			// valida que exista al menos 1 registro
			$consulta="
			select idtanda from tmp_transfer where idtanda = $idtanda limit 1
			";
			$rsex=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			if(intval($rsex->fields['idtanda']) == 0){
				$valido="N";
				$errores.="- No hay registros cargados en el carrito para el idtanda indicado.".$saltolinea;	
			}
		}
		
		// recorre los archivos a transferir en la tabla temporal
		$buscar="
		select *, (select insumos_lista.descripcion from insumos_lista where idinsumo = tmp_transfer.idproducto and idempresa = $idempresa) as insumo
		from tmp_transfer
		inner join gest_transferencias on gest_transferencias.idtanda = tmp_transfer.idtanda
		 where 
		 gest_transferencias.idtanda=$tfin 
		 and gest_transferencias.idempresa = $idempresa
		 and gest_transferencias.estado = 1
		 order by tmp_transfer.descripcion asc
		 ";
		$rsf=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		if(intval($rsf->fields['idproducto']) == 0){
			$errores.="- No existe la tanda de transferencia.<br />";
			$valido="N";
		}
		
		
		
		
		// validar produccion automatica si aplica
		$consulta="
		SELECT * 
		FROM tmp_transfer
		inner join gest_transferencias on gest_transferencias.idtanda = tmp_transfer.idtanda
		inner join produccion_automatica_traslado on 
		produccion_automatica_traslado.iddeposito_destino = gest_transferencias.destino
		and produccion_automatica_traslado.idinsumo_traslado = tmp_transfer.idproducto 
		where 
		tmp_transfer.idtanda = $idtanda
		and produccion_automatica_traslado.estado = 1
		";
		$rsval=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// genera una matriz de arrays para luego validar
		$ipa=1;
		while(!$rsval->EOF){
			$parametros_arrays[$ipa]=array(
				'idreceta' => $rsval->fields['idreceta'],
				'tipo_entrega_insumo' => 1, // siempre 1
				'resultante_real' => floatval($rsval->fields['cantidad']),
				'iddeposito' => $rsval->fields['destino'],
				'opr' => 0,
				'idtandatraslado' => $idtanda,
				'prod_auto' => 'S',
			
			);
			$ipa++;
		$rsval->MoveNext(); }
		// recorre la matriz y valida
		foreach($parametros_arrays as $parametros_array){
			$res=validar_produccion($parametros_array);
			if($res['valido'] == 'N'){
				$valido=$res['valido'];	
				$errores.=nl2br($res['errores']);
				break;
			}	
		}
			
		/// si se valida el stock disponible
		if($valida_stock == 'S'){
			
			while (!$rsf->EOF){
				
				$idinsumo_traslado=$rsf->fields['idproducto'];
				$cantidad_traslado=$rsf->fields['cantidad'];
				$iddeposito_origen=$rsf->fields['origen'];
				$nombreinsu=$rsf->fields['insumo'];
			
				// busca el disponible en stock general
				$buscar="
				Select sum(disponible)  as total_stock
				from gest_depositos_stock_gral 
				where 
				idproducto=$idinsumo_traslado 
				and estado=1 
				and iddeposito = $iddeposito_origen
				";
				$rsst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$total_stock=floatval($rsst->fields['total_stock']);
				if($cantidad_traslado > $total_stock){
					$errores.="-El disponible es menor a la cantidad que quiere transferir de $nombreinsu, quedan $total_stock y quiere transferir $cantidad_traslado.<br />";
					$valido="N";
				}
				if($total_stock <= 0){
					$errores.="-No queda disponible de $nombreinsu en stock.<br />";
					$valido="N";
				}
			
			$rsf->MoveNext(); }
			$rsf->MoveFirst(); // reinicia el recordset
			
		} // if($valida_stock == 'S'){
		
	
	}else{ // if($detalle_precargado == 'S'){
		
	// si el detalle no es precargado
		
		// recorre y valida registros	
		$totdet=0;
		foreach($detalles as $detalle){
			$totdet++;
			$idinsumo=intval($detalle['idinsumo']);
			$cantidad=floatval($detalle['cantidad']);
			$necesidad=floatval($detalle['necesidad']);
			$lote=intval($detalle['lote']);
			$vencimiento=trim($detalle['vencimiento']);
			$idinsumo_traslado=$idinsumo;
			//echo $idinsumo."-";
			if($idinsumo <= 0){
				$valido="N";
				$errores.="- No se indico el idinsumo.".$saltolinea;	
			}
			if($cantidad <= 0){
				$valido="N";
				$errores.="- La cantidad no puede ser menor o igual a cero.".$saltolinea;	
			}
			// valida que exista el insumo
			$consulta="
			select idinsumo, descripcion from insumos_lista where idinsumo = $idinsumo and estado = 'A' limit 1
			";
			$rsex=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			$insumo=$rsex->fields['descripcion'];
			if(intval($rsex->fields['idinsumo']) == 0){
				$valido="N";
				$errores.="- El articulo [$idinsumo] indicado no existe o fue borrado.".$saltolinea;	
			}
			
			/// si se valida el stock disponible
			if($valida_stock == 'S'){

				$idinsumo_traslado=$idinsumo;
				$cantidad_traslado=$cantidad;
				$iddeposito_origen=$iddeposito_origen;
				$nombreinsu=$insumo;
			
				// busca el disponible en stock general
				$buscar="
				Select sum(disponible)  as total_stock
				from gest_depositos_stock_gral 
				where 
				idproducto=$idinsumo_traslado 
				and estado=1 
				and iddeposito = $iddeposito_origen
				";
				$rsst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$total_stock=floatval($rsst->fields['total_stock']);
				if($cantidad_traslado > $total_stock){
					$errores.="-El disponible es menor a la cantidad que quiere transferir de $nombreinsu, quedan $total_stock y quiere transferir $cantidad_traslado.<br />";
					$valido="N";
				}
				if($total_stock <= 0){
					$errores.="-No queda disponible de $nombreinsu en stock.<br />";
					$valido="N";
				}

			} // if($valida_stock == 'S'){
			// validar produccion automatica si aplica
			$consulta="
			SELECT * 
			FROM produccion_automatica_traslado
			where
			produccion_automatica_traslado.iddeposito_destino = $iddeposito_destino
			and produccion_automatica_traslado.idinsumo_traslado = $idinsumo_traslado
			and produccion_automatica_traslado.estado = 1
			";
			$rsval=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			// genera una matriz de arrays para luego validar
			$ipa=1;
			while(!$rsval->EOF){
				$parametros_arrays[$ipa]=array(
					'idreceta' => $rsval->fields['idreceta'],
					'tipo_entrega_insumo' => 1, // siempre 1
					'resultante_real' => floatval($rsval->fields['cantidad']),
					'iddeposito' => $rsval->fields['destino'],
					'opr' => 0,
					'idtandatraslado' => $idtanda,
					'prod_auto' => 'S',
				
				);
				$ipa++;
			$rsval->MoveNext(); }
			// recorre la matriz y valida
			foreach($parametros_arrays as $parametros_array){
				$res=validar_produccion($parametros_array);
				if($res['valido'] == 'N'){
					$valido=$res['valido'];	
					$errores.=nl2br($res['errores']);
					break;
				}	
			}
			
			
			
		} // foreach($detalles as $detalle){
		if($totdet == 0){
			$valido="N";
			$errores.="- Debe cargar al menos 1 articulo.".$saltolinea;	
		}
		
	} // if($detalle_precargado == 'S'){
		
		
		
	
	
	$res=array("valido" => $valido, "errores" => $errores);
	
	
	return $res;
}
function registra_traslado_entre_depositos($parametros_array){
	
	

	global $conexion;
	global $ahora;
	global $idempresa;
	
	// recibe parametros
	$iddeposito_origen=intval($parametros_array['iddeposito_origen']);
	$iddeposito_destino=intval($parametros_array['iddeposito_destino']);
	$fecha_traslado=trim($parametros_array['fecha_traslado']);
	$generado_por=intval($parametros_array['generado_por']);
	$detalles=$parametros_array['detalle'];
	$detalle_precargado=$parametros_array['detalle_precargado'];
	$idtanda=intval($parametros_array['idtanda']);
	$tfin=$idtanda;
	$idusu=$generado_por;
	$fecha_transferencia=$fecha_traslado;
	$origen_modulo=intval($parametros_array['origen_modulo']);
	if($origen_modulo == 0){
		$origen_modulo=1; // 1 por defecto
	}
	
	$consulta="
	select idsucursal FROM gest_depositos where iddeposito = $iddeposito_origen limit 1
	";
	$rsdep=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idsucursal=$rsdep->fields['idsucursal'];
	$consulta="
	select * from gest_depositos where tiposala = 3 order by iddeposito asc limit 1
	";
	$rstran=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$iddeposito_transito=intval($rstran->fields['iddeposito']);
	
	// si no esta precargado el detalle
	if($detalle_precargado != 'S'){
		
		
		//buscamos el id
		$buscar="Select max(idtanda) as mayor from gest_transferencias";
		$idt=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idtanda=intval($idt->fields['mayor'])+1;
		$tfin=$idtanda;
		// genera cabecera
		$consulta="
		insert into gest_transferencias
		(idtanda,fecha_transferencia, fecha_real, generado_por, origen, destino, idempresa, idsucursal, estado, origen_modulo)
		values
		($idtanda,'$fecha_traslado', '$ahora', $generado_por, $iddeposito_origen, $iddeposito_destino, $idempresa, $idsucursal, 1, $origen_modulo)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// recorre y carga registros	
		$totdet=0;
		foreach($detalles as $detalle){
			$totdet++;
			$idinsumo=intval($detalle['idinsumo']);
			$cantidad=floatval($detalle['cantidad']);
			$necesidad=floatval($detalle['necesidad']);
			$lote=intval($detalle['lote']);
			$vencimiento=antisqlinyeccion(trim($detalle['vencimiento']),"text");
			
			// datos del insumo
			$consulta="
			select idinsumo, descripcion from insumos_lista where idinsumo = $idinsumo and estado = 'A' limit 1
			";
			$rsex=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			$insumo=$rsex->fields['descripcion'];
			
			$consulta="
			INSERT INTO tmp_transfer
			(idtanda, idproducto, descripcion, cantidad, necesidad,  horareg, lote, vto)
			values
			($idtanda, $idinsumo, '$insumo', $cantidad, $necesidad, '$ahora', $lote, $vencimiento)
			";
			//echo $consulta."<br />";
			$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			
		}
		//exit;
		
	}
	
	
	$buscar="
	select *, (select insumos_lista.descripcion from insumos_lista where idinsumo = tmp_transfer.idproducto and idempresa = $idempresa) as insumo
	from tmp_transfer
	inner join gest_transferencias on gest_transferencias.idtanda = tmp_transfer.idtanda
	 where 
	 gest_transferencias.idtanda=$tfin 
	 and gest_transferencias.estado = 1
	 order by tmp_transfer.descripcion asc
	 ";
	 //echo $buscar;exit;
	$rsf=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
	
	// trasladamos insumos
	while (!$rsf->EOF){
		
		
		
		$idinsumo_traslado=$rsf->fields['idproducto'];
		$cantidad_traslado=$rsf->fields['cantidad'];
		$iddeposito_origen=$rsf->fields['origen'];
		$iddeposito_destino=$rsf->fields['destino'];
		$nombreinsu=str_replace("'","",$rsf->fields['insumo']);
		$nombreinsu=str_replace('"',"",$nombreinsu);
		$lote=intval($rsf->fields['lote']);
		$vto=$rsf->fields['vto'];
		if(trim($vto) == ''){
		    $vto="NULL";
		}else{
		    $vto="'".date("Y-m-d",strtotime($vto))."'";
		}
		
		// campos nuevos
		$cant_ultrepo=antisqlinyeccion($rsf->fields['cant_ultrepo'],"float"); 
		$fecha_ultrepo=antisqlinyeccion($rsf->fields['fecha_ultrepo'],"text");  
		$cant_ultvta=antisqlinyeccion($rsf->fields['cant_ultvta'],"float");  
		$fecha_ultvta=antisqlinyeccion($rsf->fields['fecha_ultvta'],"text");  
		$stock_origen=antisqlinyeccion($rsf->fields['stock_origen'],"float"); 
		$stock_destino=antisqlinyeccion($rsf->fields['stock_destino'],"float"); 
		$stock_ideal_destino=antisqlinyeccion($rsf->fields['stock_ideal_destino'],"float");  
		$reposicion_sugerida=antisqlinyeccion($rsf->fields['reposicion_sugerida'],"float"); 
		$dias_quiebre=antisqlinyeccion($rsf->fields['dias_quiebre'],"int"); 
		
		$confirmado=antisqlinyeccion($rsf->fields['confirmado'],"text");  
		$confirmado_por=antisqlinyeccion($rsf->fields['confirmado_por'],"int");   
		$confirmado_el=antisqlinyeccion($rsf->fields['confirmado_el'],"text");  
		$observacion=antisqlinyeccion($rsf->fields['observacion'],"text");   
		$observacion_por=antisqlinyeccion($rsf->fields['observacion_por'],"int");   
		$observacion_el=antisqlinyeccion($rsf->fields['observacion_el'],"text");  
		
	
		// busca si existe en stock general origen cada insumo a trasladar
		$buscar="Select * 
		from gest_depositos_stock_gral 
		where 
		idproducto=$idinsumo_traslado 
		and idempresa=$idempresa 
		and estado=1 
		and iddeposito = $iddeposito_origen";
		//echo $buscar;exit;
		$rsst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		// si no existe inserta
		if (intval($rsst->fields['idproducto'])==0){
			$insertar="INSERT INTO gest_depositos_stock_gral
			(iddeposito, idproducto, disponible, tipodeposito, last_transfer, estado, descripcion, idempresa) 
			VALUES 
			($iddeposito_origen,$idinsumo_traslado,0,1,'$ahora',1,'$nombreinsu',$idempresa
			)";
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
			//movimientos_stock($idinsumo_traslado,0,$iddeposito_origen,4,'+');
		}
		// busca si existe en stock general destino cada insumo a trasladar
		$buscar="Select * 
		from gest_depositos_stock_gral 
		where 
		idproducto=$idinsumo_traslado 
		and idempresa=$idempresa 
		and estado=1 
		and iddeposito = $iddeposito_destino";
		//echo $buscar;exit;
		$rsst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		// si no existe inserta
		if (intval($rsst->fields['idproducto'])==0){
			$insertar="INSERT INTO gest_depositos_stock_gral
			(iddeposito, idproducto, disponible, tipodeposito, last_transfer, estado, descripcion, idempresa) 
			VALUES 
			($iddeposito_destino,$idinsumo_traslado,0,1,'$ahora',1,'$nombreinsu',$idempresa
			)";
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
			//movimientos_stock($idinsumo_traslado,0,$iddeposito_transito,4,'+');
		}
		// busca si existe en stock general transito cada insumo a trasladar
		$buscar="Select * 
		from gest_depositos_stock_gral 
		where 
		idproducto=$idinsumo_traslado 
		and idempresa=$idempresa 
		and estado=1 
		and iddeposito = $iddeposito_transito";
		$rsst=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		// si no existe inserta
		if (intval($rsst->fields['idproducto'])==0){
			$insertar="INSERT INTO gest_depositos_stock_gral
			(iddeposito, idproducto, disponible, tipodeposito, last_transfer, estado, descripcion, idempresa) 
			VALUES 
			($iddeposito_transito,$idinsumo_traslado,0,3,'$ahora',1,'$nombreinsu',$idempresa
			)";
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
			//movimientos_stock($idinsumo_traslado,0,$iddeposito_transito,4,'+');
		}
		
		// descontar insumo de stock general origen
		$consulta="
		UPDATE gest_depositos_stock_gral 
		SET 
		disponible=(disponible-$cantidad_traslado)
		WHERE 
		idempresa=$idempresa 
		and iddeposito=$iddeposito_origen
		and idproducto=$idinsumo_traslado
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		movimientos_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_origen,3,'-',$idtanda,$fecha_transferencia);
		
		// aumentar insumo de stock general transito
		$consulta="
		UPDATE gest_depositos_stock_gral 
		SET 
		disponible=(disponible+$cantidad_traslado)
		WHERE 
		idempresa=$idempresa 
		and iddeposito=$iddeposito_transito
		and idproducto=$idinsumo_traslado
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		movimientos_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_transito,4,'+',$idtanda,$fecha_transferencia);

		
		// inserta en tabla de traslados
		$insertar="
		insert into gest_depositos_mov
		(
		iddeposito,tipomov,deschar,idusu,origen,cantidad,cantidad_recibe,
		destino,obs,idproducto,idseriecostos,idempresa,idtanda,recibio_destino,lote,vto,
		cant_ultrepo, fecha_ultrepo, cant_ultvta, fecha_ultvta, 
		stock_origen, stock_destino, stock_ideal_destino, 
		reposicion_sugerida, dias_quiebre,
		confirmado, confirmado_por, confirmado_el,
		observacion, observacion_por, observacion_el
		)
		values
		(
		$iddeposito_origen,2,'TRANSLADO',$idusu,$iddeposito_origen,$cantidad_traslado,$cantidad_traslado,
		$iddeposito_destino,'',$idinsumo_traslado,0,$idempresa,$tfin,'N',$lote,$vto,
		$cant_ultrepo, $fecha_ultrepo, $cant_ultvta, $fecha_ultvta, 
		$stock_origen, $stock_destino, $stock_ideal_destino, 
		$reposicion_sugerida, $dias_quiebre,
		$confirmado, $confirmado_por, $confirmado_el,
		$observacion, $observacion_por, $observacion_el
		)
		";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));	
		//echo $idinsumo_traslado.'-';
		// trasladamos con costos y depositos especificos
		traslada_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_origen,$iddeposito_transito);
	
	$rsf->MoveNext(); }
	//exit;
	
	// guardamos la necesidad 
	$consulta="
	INSERT INTO gest_depositos_mov_necesidad
	(
	idtanda, idproducto, cantidad, necesidad, horareg,
	cant_ultrepo, fecha_ultrepo, cant_ultvta, fecha_ultvta, 
	stock_origen, stock_destino, stock_ideal_destino, 
	reposicion_sugerida, dias_quiebre
	) 
	select idtanda, idproducto, cantidad, necesidad, horareg,
	cant_ultrepo, fecha_ultrepo, cant_ultvta, fecha_ultvta, 
	stock_origen, stock_destino, stock_ideal_destino, 
	reposicion_sugerida, dias_quiebre
	from tmp_transfer
	where
	idtanda = $idtanda
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	$consulta="
	INSERT INTO gest_depositos_mov_necesidad
	(
	idtanda, idproducto, cantidad, necesidad, horareg,
	cant_ultrepo, fecha_ultrepo, cant_ultvta, fecha_ultvta, 
	stock_origen, stock_destino, stock_ideal_destino, 
	reposicion_sugerida, dias_quiebre
	) 
	select idtanda, idproducto, cantidad, necesidad, horareg,
	cant_ultrepo, fecha_ultrepo, cant_ultvta, fecha_ultvta, 
	stock_origen, stock_destino, stock_ideal_destino, 
	reposicion_sugerida, dias_quiebre
	from tmp_transfer_faltan
	where
	idtanda = $idtanda
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	
	// borramos tablas temporales
	$consulta="
	delete from tmp_transfer where idtanda = $idtanda
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// borramos tablas temporales
	$consulta="
	delete from tmp_transfer_faltan where idtanda = $idtanda
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	//actualizamos el costo (mejorar despues para que la funcion traiga el costeo de las tandas)
	$consulta="
	update gest_depositos_mov
	set 
	costo_unitario_art = COALESCE((select costo from insumos_lista where idinsumo = gest_depositos_mov.idproducto),0)
	WHERE
	idtanda=$tfin
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));	
	
	// si hay pedido de reposicion marcamos como enviado
	if($idpedidorepo > 0){
			
		$consulta="
		update compras_pedidos
		set
			estado = 3,
			cerrado_el='$ahora',
			cerrado_por=$idusu,
			idtandatraslado=$tfin
		where
			idpedido = $idpedidorepo
			and estado = 2
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	}
	
	// produccion automatica
	$consulta="
	SELECT * 
	FROM gest_depositos_mov
	where 
	recibio_destino = 'S' 
	and idtanda = $idtanda
	and estado = 1
	and idproducto in (
		select idinsumo_traslado 
		from produccion_automatica_traslado
		where
		iddeposito_destino = gest_depositos_mov.destino
	)
	";
	/*$rsdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	while(!$rsdet->EOF){
		
			$idinsumo_traslado=intval($rsdet->fields['idproducto']);
			// validar produccion automatica si aplica
			$consulta="
			SELECT * 
			FROM produccion_automatica_traslado
			where
			produccion_automatica_traslado.iddeposito_destino = $iddeposito_destino
			and produccion_automatica_traslado.idinsumo_traslado = $idinsumo_traslado
			and produccion_automatica_traslado.estado = 1
			";
			$rsval=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			// genera una matriz de arrays para luego validar
			$ipa=1;
			while(!$rsval->EOF){
				$idreceta=$rsval->fields['idreceta'];
				$consulta="
				select cantidad_resultante from recetas_produccion where idreceta = $idreceta limit 1
				";
				$rsrec=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				$parametros_arrays[$ipa]=array(
					'idreceta' => $rsval->fields['idreceta'],
					'tipo_entrega_insumo' => 1, // siempre 1
					'resultante_real' => floatval($rsrec->fields['cantidad_resultante']),
					'iddeposito' => $rsval->fields['destino'],
					'opr' => 0,
					'idtandatraslado' => $idtanda,
					'prod_auto' => 'S',
				
				);
				$ipa++;
			$rsval->MoveNext(); }

	}
			
	*/
	// vuelve el contador al primer registro
	reset($parametros_arrays);
	// recorre y registra la produccion
	foreach($parametros_arrays as $parametros_array){
		//print_r($parametros_array);exit;
		$res=producir($parametros_array);
		// regisrar el idproducido en table de traslados det
		
	}
	
	
	//actualizamos el cierre de transferencia
	$update="
	Update gest_transferencias 
	set 
	estado=3 
	where 
	idtanda=$tfin 
	and idempresa=$idempresa
	and estado=1 
	and origen=$iddeposito_origen 
	and destino=$iddeposito_destino
	";
	$conexion->Execute($update) or die(errorpg($conexion,$update));
	
	
	
	$res=array("valido" => $valido, "errores" => $errores, "idtanda" => $idtanda);
	return $res;
}

function recepcion_traslado_valida($parametros_array){
	
	global $conexion;
	global $ahora;
	
	$valido="S";
	$errores="";
	
	// recepcion de parametros
	$idtanda=intval($parametros_array['idtanda']);
	$idusu=intval($parametros_array['idusu']);
	
	// validaciones de parametros
	if($idtanda <= 0){
		$valido="N";
		$errores.="- No se indico la tanda.";	
	}
	if($idusu <= 0){
		$valido="N";
		$errores.="- No se indico el usuario.";	
	}
	
	// preferencias transferencia
	$consulta="
	select fecha_traslado_fija
	from preferencias_transfer
	limit 1
	";
	$rspreftrans=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$fecha_traslado_fija=$rspreftrans->fields['fecha_traslado_fija'];
	
	
	// validaciones de bd
	$consulta="
	select idtanda, fecha_transferencia
	from gest_transferencias 
	where 
	 estado = 3 
	 and idtanda = $idtanda
	limit 1
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idtanda=intval($rs->fields['idtanda']);
	$idpedidorepo=intval($rs->fields['idpedidorepo']);
	$fecha_transferencia=$rs->fields['fecha_transferencia'];
	if($idtanda <= 0){
		$valido="N";
		$errores.="- La tanda indicada no existe o su estado no es pendiente de recepcion.";	
	}
	$consulta="
	select * from gest_depositos where tiposala = 3 order by iddeposito asc limit 1
	";
	$rstran=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$iddeposito_transito=intval($rstran->fields['iddeposito']);
	if($iddeposito_transito == 0){
		$valido="N";
		$errores.="- Deposito de transito inexistente.";	
	}
	
	if($fecha_traslado_fija == 'S'){
		if(date("Y-m-d",strtotime($fecha_transferencia)) != date("Y-m-d")){
			$valido="N";
			$errores.=" - Tu administracion bloqueo el permiso de carga de transferencias con una fecha diferente a hoy.<br />";	
		}
	}
	

	$respuesta=array("valido" => $valido, "errores" => $errores);
	return $respuesta;		
}

function recepcion_traslado_registra($parametros_array){
	
	global $conexion;
	global $ahora;
	
	$idtanda=intval($parametros_array['idtanda']);
	$idusu=intval($parametros_array['idusu']);
	
	$consulta="
	select idtanda, idpedidorepo, fecha_transferencia, destino, origen
	from gest_transferencias 
	where 
	 estado = 3 
	 and idtanda = $idtanda
	limit 1
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idtanda=intval($rs->fields['idtanda']);
	$idpedidorepo=intval($rs->fields['idpedidorepo']);
	$idtanda=intval($rs->fields['idtanda']);
	$fecha_transferencia=$rs->fields['fecha_transferencia'];
	$iddeposito_destino=intval($rs->fields['destino']);
	$iddeposito_origen=intval($rs->fields['origen']);
	$idempresa=1;
	
	// deposito transito
	$consulta="
	select * from gest_depositos where tiposala = 3 order by iddeposito asc limit 1
	";
	$rstran=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$iddeposito_transito=intval($rstran->fields['iddeposito']);
	
	// recorre y mueve stock
	$consulta="
	select *
	from gest_depositos_mov 
	where 
	 idtanda = $idtanda 
	 and recibio_destino = 'N'
	 and estado = 1
	order by fechahora asc
	";
	$rsdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// recorre cuerpo y retorna a matriz las diferencias no recibidas
	while(!$rsdet->EOF){
		$idserpks=intval($rsdet->fields['idserpks']);
		$idinsumo_traslado=intval($rsdet->fields['idproducto']);
		$cantidad_traslado=floatval($rsdet->fields['cantidad']);
		$cantidad_recibe=floatval($rsdet->fields['cantidad_recibe']);
		$cantidad_new=$cantidad_recibe;
		$cantidad_old=$cantidad_traslado;
		
		if($cantidad_new > $cantidad_old){
			$diferencia=$cantidad_new-$cantidad_old;
		}
		if($cantidad_new < $cantidad_old){
			$diferencia=$cantidad_old-$cantidad_new;
		}
		$cantidad_traslado_pordif=$diferencia;
		
		// trasladar de origen a transito
		if($cantidad_new > $cantidad_old){
			
			// descontar insumo de stock general origen
			$consulta="
			UPDATE gest_depositos_stock_gral 
			SET 
			disponible=(disponible-$cantidad_traslado_pordif)
			WHERE 
			idempresa=$idempresa 
			and iddeposito=$iddeposito_origen
			and idproducto=$idinsumo_traslado
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			movimientos_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_origen,3,'-',$idtanda,$fecha_transferencia);
			
			// aumentar insumo de stock general transito
			$consulta="
			UPDATE gest_depositos_stock_gral 
			SET 
			disponible=(disponible+$cantidad_traslado_pordif)
			WHERE 
			idempresa=$idempresa 
			and iddeposito=$iddeposito_transito
			and idproducto=$idinsumo_traslado
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			movimientos_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_transito,4,'+',$idtanda,$fecha_transferencia);
			
			// trasladamos con costos y depositos especificos
			traslada_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_origen,$iddeposito_transito);
			
		}
		// devolver a origen
		if($cantidad_new < $cantidad_old){

			// descontar insumo de stock general transito
			$consulta="
			UPDATE gest_depositos_stock_gral 
			SET 
			disponible=(disponible-$cantidad_traslado_pordif)
			WHERE 
			idempresa=$idempresa 
			and iddeposito=$iddeposito_transito
			and idproducto=$idinsumo_traslado
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			movimientos_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_transito,3,'-',$idtanda,$fecha_transferencia);
			
			// aumentar insumo de stock general origen
			$consulta="
			UPDATE gest_depositos_stock_gral 
			SET 
			disponible=(disponible+$cantidad_traslado_pordif)
			WHERE 
			idempresa=$idempresa 
			and iddeposito=$iddeposito_origen
			and idproducto=$idinsumo_traslado
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			movimientos_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_origen,4,'+',$idtanda,$fecha_transferencia);
			
			// trasladamos con costos y depositos especificos
			traslada_stock($idinsumo_traslado,$cantidad_traslado_pordif,$iddeposito_transito,$iddeposito_origen);
		}

	$rsdet->MoveNext(); }
	$rsdet->MoveFirst();
	//exit;
	
	while(!$rsdet->EOF){
		
		$idserpks=intval($rsdet->fields['idserpks']);
		$idinsumo_traslado=intval($rsdet->fields['idproducto']);
		$cantidad_traslado=floatval($rsdet->fields['cantidad_recibe']);
		
		
		// descontar insumo de stock general transito
		$consulta="
		UPDATE gest_depositos_stock_gral 
		SET 
		disponible=(disponible-$cantidad_traslado)
		WHERE 
		idempresa=$idempresa 
		and iddeposito=$iddeposito_transito
		and idproducto=$idinsumo_traslado
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		movimientos_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_transito,3,'-',$idtanda,$fecha_transferencia);
		
		// aumentar insumo de stock general destino
		$consulta="
		UPDATE gest_depositos_stock_gral 
		SET 
		disponible=(disponible+$cantidad_traslado)
		WHERE 
		idempresa=$idempresa 
		and iddeposito=$iddeposito_destino
		and idproducto=$idinsumo_traslado
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		movimientos_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_destino,4,'+',$idtanda,$fecha_transferencia);
		

		
		// traslado con costo, destino y origen xq en origen se traslado el general nomas sin costo
		traslada_stock($idinsumo_traslado,$cantidad_traslado,$iddeposito_transito,$iddeposito_destino);
		
		
		$consulta="
		update gest_depositos_mov 
		set 
		 recibio_destino = 'S'
		where 
		 idtanda = $idtanda 
		 and recibio_destino = 'N'
		 and idserpks = $idserpks
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
	$rsdet->MoveNext(); }
	
	

	
	
	
	// si hay pedido de reposicion marcamos como enviado
	if($idpedidorepo > 0){
			
		$consulta="
		update compras_pedidos
		set
			estado = 3,
			cerrado_el='$ahora',
			cerrado_por=$idusu
		where
			idpedido = $idpedidorepo
			and estado = 2
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	}
	

	
	//actualizamos el cierre de transferencia
	$update="
	Update gest_transferencias 
	set 
	estado=2,
	fecha_recepcion='$ahora',
	recep_registrado_el='$ahora',
	recibido_por=$idusu
	where 
	idtanda=$idtanda
	and estado=3 
	";
	$conexion->Execute($update) or die(errorpg($conexion,$update));

	$respuesta=array("idtanda" => $idtanda);
	return $respuesta;		
}

function valida_cantidad_recibida($parametros_array){
	
	global $conexion;
	
	$valido="S";
	$errores="";
	
	// recibe parametros
	$idserpks=intval($parametros_array['idserpks']);
	$idusu=intval($parametros_array['idusu']);
	$idmotivo=intval($parametros_array['idmotivo']);
	$cantidad_recibe=floatval($parametros_array['cantidad_recibe']);
	$permite_cant_recibida_mayor_a_traslado=trim($parametros_array['permite_cant_recibida_mayor_a_traslado']);
	if($permite_cant_recibida_mayor_a_traslado != 'S'){
		$permite_cant_recibida_mayor_a_traslado='N';
	}
	
	$consulta="
	select editar_traslado , editar_traslado_recep
	from usuarios 
	where 
	idusu = $idusu
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$editar_traslado=$rs->fields['editar_traslado'];
	$editar_traslado_recep=$rs->fields['editar_traslado_recep'];
	if($editar_traslado_recep != 'S'){
		$errores.="Tu usuario no tiene permisos de edicion en la recepcion.";	
		$valido="N";
	}
		
	
	// consulta a la tabla	
	$consulta="
	select *
	from gest_depositos_mov 
	where 
	idserpks = $idserpks
	and estado = 1
	limit 1
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idserpks=intval($rs->fields['idserpks']);
	$idtanda=intval($rs->fields['idtanda']);
	if($idserpks == 0){
		$errores.="Tanda inexistente.";	
		$valido="N";	
	}
	
	
	$consulta="
	select gest_depositos_mov.idproducto, gest_depositos_mov.cantidad, gest_depositos_mov.recibio_destino,
	(select descripcion from insumos_lista where idinsumo  = gest_depositos_mov.idproducto) as producto, 
	gest_transferencias.idtanda, gest_transferencias.origen, gest_transferencias.fecha_transferencia,
	(select idmedida from insumos_lista where idinsumo  = gest_depositos_mov.idproducto) as idmedida
	from gest_depositos_mov 
	inner join gest_transferencias on gest_transferencias.idtanda = gest_depositos_mov.idtanda
	where 
	gest_transferencias.estado = 3 
	and gest_transferencias.idtanda=$idtanda
	and gest_depositos_mov.idserpks = $idserpks
	and gest_depositos_mov.estado = 1
	and gest_depositos_mov.recibio_destino = 'N'
	order by iddeposito asc
	limit 1
	";
	$rs2=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idtanda=intval($rs2->fields['idtanda']);
	$iddeposito_origen=intval($rs2->fields['origen']);
	$fecha_transferencia=$rs2->fields['fecha_transferencia'];
	$idinsumo_traslado=intval($rs2->fields['idproducto']);
	$cantidad_traslado=floatval($rs2->fields['cantidad']);
	$idmedida=intval($rs2->fields['idmedida']);
	$cantidad_old=$cantidad_traslado;
	if($idtanda == 0){	
		$errores.="Tanda finalizada, no se pudo editar.";	
		$valido="N";	
	}
	
	
	// valida deposito de transito
	$consulta="
	select * from gest_depositos where tiposala = 3 order by iddeposito asc limit 1
	";
	$rstran=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$iddeposito_transito=intval($rstran->fields['iddeposito']);
	if($iddeposito_transito == 0){	
		$errores.="Deposito de transito inexistente.";	
		$valido="N";
	}
	

	


	
	
	
	if(floatval($parametros_array['cantidad_recibe']) < 0){
		$valido="N";
		$errores.=" - El campo cantidad no puede ser negativo.".$saltolinea;	
	}
	if(intval($parametros_array['idmotivo']) <= 0){
		$valido="N";
		$errores.=" - El campo motivo no puede estar vacio.".$saltolinea;	
	}
	if(floatval($parametros_array['cantidad_recibe']) > $cantidad_traslado){
		if($permite_cant_recibida_mayor_a_traslado == 'N'){
			$valido="N";
			$errores.=" - El campo cantidad recibida no puede ser mayor a lo trasladado.".$saltolinea;	
		}
	}
	// si la medida es unitaria
	if($idmedida == 4){
		if(floatval($parametros_array['cantidad_recibe']) != intval($parametros_array['cantidad_recibe'])){
			$valido="N";
			$errores.=" - No puedes poner decimales a un articulo unitario.".$saltolinea;	
		}
	}
	
	// conversiones
	if(floatval($parametros_array['cantidad_recibe']) == $cantidad_traslado){
		$idmotivo="NULL";	
	}
	
	$res=array('valido' => $valido, 'errores' => $errores);
	return $res;
	
}

function registra_cantidad_recibida($parametros_array){
	
	global $conexion;
	global $ahora;
	
	// recibe parametros
	$idserpks=intval($parametros_array['idserpks']);
	$idusu=intval($parametros_array['idusu']);
	$idmotivo=intval($parametros_array['idmotivo']);
	$cantidad_recibe=floatval($parametros_array['cantidad_recibe']);
	
	// consulta a la tabla	
	$consulta="
	select *
	from gest_depositos_mov 
	where 
	idserpks = $idserpks
	and estado = 1
	limit 1
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idserpks=intval($rs->fields['idserpks']);
	$idtanda=intval($rs->fields['idtanda']);
	
		// aca no mueve stock recien al finalizar la recepcion mueve stock en base a las diferencias de cantidad_recibe con cantidad enviada
	$consulta="
	update gest_depositos_mov
	set
		cantidad_recibe=$cantidad_recibe,
		editado_por = $idusu,
		editado_el = '$ahora',
		idmotivo_dif=$idmotivo
	where
		idserpks = $idserpks
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	$consulta="
	select gest_depositos_mov.idproducto, gest_depositos_mov.cantidad, gest_depositos_mov.cantidad_recibe, gest_depositos_mov.recibio_destino,
	(select descripcion from insumos_lista where idinsumo  = gest_depositos_mov.idproducto) as producto, 
	gest_transferencias.idtanda, gest_transferencias.origen, gest_transferencias.fecha_transferencia
	from gest_depositos_mov 
	inner join gest_transferencias on gest_transferencias.idtanda = gest_depositos_mov.idtanda
	where 
	gest_transferencias.estado = 3 
	and gest_transferencias.idtanda=$idtanda
	and gest_depositos_mov.idserpks = $idserpks
	and gest_depositos_mov.estado = 1
	and gest_depositos_mov.recibio_destino = 'N'
	order by iddeposito asc
	limit 1
	";
	$rs2=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	//echo $consulta;
	//echo $idtanda;
	
	$cantidad_recibe=floatval($rs2->fields['cantidad_recibe']);
	$cantidad_traslado=floatval($rs2->fields['cantidad']);
	$diferencia=$cantidad_traslado-$cantidad_recibe;

	// genera array con los datos
	$arr = array(
		'idmotivo' => $idmotivo,
		'cantidad_recibe' => $cantidad_recibe,
		'cantidad_enviada' => $cantidad_traslado,
		'diferencia' => $diferencia,
		'valido' => 'S',
		'errores' => ''
	);
	return $arr;
	
}

function traslado_ticket($idtanda){
	
	global $conexion;
	global $ahora;
	global $saltolinea;
	$idempresa=1;
	
	

	
	$tanda=intval($idtanda);
	if ($tanda>0){
		//traemos la tanda anterior
		$buscar="Select *,(select usuario from usuarios where idusu=gest_transferencias.generado_por) as responsable,
		(Select descripcion from gest_depositos where iddeposito=gest_transferencias.origen) as origenc,
		(Select descripcion from gest_depositos where iddeposito=gest_transferencias.destino) as destinoc
		 from gest_transferencias where idtanda=$tanda";
		$rscabe=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			
		$fechatrans=date("d-m-Y",strtotime($rscabe->fields['fecha_transferencia']));
		
		$idgenera=intval($rscabe->fields['generado_por']);
		$origen=trim($rscabe->fields['origenc']);
		$destino=trim($rscabe->fields['destinoc']);
		$dst=intval($rscabe->fields['destino']);
		$or=intval($rscabe->fields['origen']);
		$responsable=($rscabe->fields['responsable']);
		
		//cuerpo
		$buscar="select *,(select descripcion from insumos_lista where idinsumo=gest_depositos_mov.idproducto) as descripcion
		 from gest_depositos_mov where idtanda=$tanda
		 order by descripcion asc";
		$rscuerpo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		
		
	}else{
		$error='Debe indicar n&uacute;mero de traslado.';
		
	}
	
	
	$consulta="
	select valoriza_reposicion from preferencias_transfer limit 1
	";
	$rspreftrans=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$valoriza_reposicion=$rspreftrans->fields['valoriza_reposicion'];
	if($valoriza_reposicion == 'S'){
		$mostrarcosto="S";
	}
	
	//traemos la tanda anterior
	$buscar="Select *,(select usuario from usuarios where idusu=gest_transferencias.generado_por) as responsable,
	(Select descripcion from gest_depositos where iddeposito=gest_transferencias.origen) as origenc,
	(Select descripcion from gest_depositos where iddeposito=gest_transferencias.destino) as destinoc
	 from gest_transferencias where idtanda=$tanda";
	$rscabe=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		
	$fechatrans=date("d/m/Y",strtotime($rscabe->fields['fecha_transferencia']));
	
	$idgenera=intval($rscabe->fields['generado_por']);
	$origen=trim($rscabe->fields['origenc']);
	$destino=trim($rscabe->fields['destinoc']);
	$dst=intval($rscabe->fields['destino']);
	$or=intval($rscabe->fields['origen']);
	$responsable=($rscabe->fields['responsable']);
	
	$consulta="
	select * from empresas where idempresa = $idempresa
	";
	$rsemp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$razon_social_empresa=trim($rsemp->fields['razon_social']);
	$ruc_empresa=trim($rsemp->fields['ruc']).'-'.trim($rsemp->fields['dv']);
	$direccion_empresa=trim($rsemp->fields['direccion']);
	$nombre_fantasia_empresa=trim($rsemp->fields['empresa']);
	$actividad_economica=trim($rsemp->fields['actividad_economica']);
	$telefono_empresa=trim($rsemp->fields['telefono']);
	
	$ticket="";
	$ticket.='****************************************'.$saltolinea;
	$ticket.=texto_tk(trim($nombre_fantasia_empresa),40,'S').$saltolinea;
	$ticket.=texto_tk("TRASLADO N: ".$tanda,40,'S').$saltolinea;
	$ticket.=texto_tk("FECHA: ".$fechatrans,40,'N').$saltolinea;
	$ticket.=texto_tk("ORIGEN: ".$origen,40,'N').$saltolinea;
	$ticket.=texto_tk("DESTINO: ".$destino,40,'N').$saltolinea;
	$ticket.=texto_tk("USUARIO: ".$responsable,40,'N').$saltolinea;
	$ticket.='****************************************'.$saltolinea;
	
	
	//cuerpo
	$buscar="select *,(select descripcion from insumos_lista where idinsumo=gest_depositos_mov.idproducto) as descripcion,
	(select barcode from productos inner join insumos_lista on insumos_lista.idproducto = productos.idprod_serial where idinsumo=gest_depositos_mov.idproducto) as barcode
	from gest_depositos_mov 
	where 
	idtanda=$tanda 
	and idempresa=$idempresa
	and gest_depositos_mov.estado <> 6
	order by descripcion asc";
	$rscuerpo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$ticket.='Cant    Descripcion'.$saltolinea;
	$ticket.='****************************************'.$saltolinea;
	while(!$rscuerpo->EOF){
		
		$vto=trim($rscuerpo->fields['vto']);
		if ($vto!=''){
			$vto=date("d/m/Y",strtotime($vto));
		}
		$costo=floatval($rscuerpo->fields['costo_unitario_art']);
		$subt=floatval($rscuerpo->fields['cantidad'])*$costo;
		
		$cant_acum+=$rscuerpo->fields['cantidad'];
		$subtotal_acum+=$subt;
		
		$ticket.=agregaespacio(formatomoneda($rscuerpo->fields['cantidad'],4,'N'),8).$rscuerpo->fields['descripcion'].' ['.$rscuerpo->fields['idproducto'].']'.$saltolinea;
		if(trim($rscuerpo->fields['barcode']) != ''){
			$ticket.=agregaespacio('BARCODE: '.formatomoneda($rscuerpo->fields['barcode'],4,'N'),40).$saltolinea;
		}
		if(intval($rscuerpo->fields['lote']) > 0){
			$ticket.=agregaespacio('LOTE: '.formatomoneda($rscuerpo->fields['lote'],4,'N'),40).$saltolinea;
		}
		if(trim($rscuerpo->fields['vto']) != ''){
			$ticket.=agregaespacio('VTO: '.$vto,40).$saltolinea;
		}
		if($mostrarcosto == 'S'){
			$ticket.=agregaespacio('COSTO: '.formatomoneda($costo,4,'N'),20).agregaespacio(' SUBTOTAL: '.formatomoneda($subt,4,'N'),20).$saltolinea;
		}
		$ticket.='----------------------------------------'.$saltolinea;
	
	$rscuerpo->MoveNext(); }
	
	$ticket=substr($ticket,0,-42);
	$ticket.='****************************************'.$saltolinea;
	if($mostrarcosto == 'S'){
		$ticket.=agregaespacio('CANT: '.formatomoneda($cant_acum,4,'N'),20).agregaespacio('MONTO: '.formatomoneda($subtotal_acum,4,'N'),20).$saltolinea;
	}else{
		$ticket.=agregaespacio('CANT: '.formatomoneda($cant_acum,4,'N'),40).$saltolinea;
	}
	$ticket.='****************************************'.$saltolinea;
	
	
	$ticket.=$saltolinea.$saltolinea.$saltolinea;
	$ticket.='ENVIADO POR :__________________________'.$saltolinea;
	
	$ticket.=$saltolinea.$saltolinea.$saltolinea;
	$ticket.='FIRMA :________________________________'.$saltolinea;
	
	$ticket.=$saltolinea.$saltolinea.$saltolinea;
	$ticket.='RECIBIDO POR:__________________________'.$saltolinea;
	
	$ticket.=$saltolinea.$saltolinea.$saltolinea;
	$ticket.='FIRMA :________________________________'.$saltolinea;

	
	$ticket.=$saltolinea;
	$ticket.=agregaespacio('IMPRESO EL: '.date("d/m/Y H:i:s"),40).$saltolinea;
	$ticket.='****************************************'.$saltolinea;
	
	return $ticket;
	
}
?>