<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="11";
$submodulo="201";
require_once("includes/rsusuario.php"); 

if(isset($_GET['fechacuenta'])){
	$fechacuenta=date("Y-m-d",strtotime($_GET['fechacuenta']));
}else{
	$fechacuenta=date("Y-m-d");
}


$consulta="
select *, saldo_activo_calc as saldo_activo
from (
select cuentas_clientes.idcliente, cliente.razon_social, cliente.ruc, cliente.nombre, cliente.apellido, 
sum(deuda_global) as deuda_global,
	(
		sum(deuda_global)
		-COALESCE((
		select 
		sum(cuentas_clientes_pagos.monto_abonado) 
		from cuentas_clientes_pagos
		cuentas_clientes_pagos 
		inner join cuentas_clientes_pagos_cab on cuentas_clientes_pagos_cab.idcuentaclientepagcab = cuentas_clientes_pagos.idcuentaclientepagcab
		where 
		cuentas_clientes_pagos_cab.estado = 1
		and cuentas_clientes_pagos.estado = 1
		and date(cuentas_clientes_pagos_cab.fecha_pago) <= '$fechacuenta'
		and cuentas_clientes_pagos.idcliente = cuentas_clientes.idcliente	
		),0) 
	) as saldo_activo_calc
from cuentas_clientes
inner join cliente on cliente.idcliente = cuentas_clientes.idcliente
inner join ventas on ventas.idventa = cuentas_clientes.idventa
where
cuentas_clientes.estado <> 6
and ventas.estado <> 6
and date(ventas.fecha) <= '$fechacuenta'
group by cuentas_clientes.idcliente
order by sum(saldo_activo) desc
) cuentas_retro
where
saldo_activo_calc > 0
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));


?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Estado de cuentas a Credito (Fecha Retroactiva)</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">


<?php 
$refemenu='retro';
require_once("includes/menu_estadocuenta.php"); ?>


<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
</button>
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<form id="form1" name="form1" method="get" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Fecha Estado *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="fechacuenta" id="fechacuenta" value="<?php   echo htmlentities($fechacuenta);  ?>" placeholder="Fecha Estado" class="form-control" required />                    
	</div>
</div>

<div class="clearfix"></div>
<br />

    <div class="form-group">
        <div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
	   <button type="submit" class="btn btn-default" ><span class="fa fa-search"></span> Buscar</button>
        </div>
    </div>

<br />
</form>
<div class="clearfix"></div>
<hr />


<a href="inf_estado_cuentas_credito_retro_csv.php?fechacuenta=<?php echo $fechacuenta ?>" class="btn btn-sm btn-default"><span class="fa fa-file-excel-o"></span> Descargar XLS</a>



<div class="clearfix"></div>
<br />

<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>

			<th align="center">idcliente</th>
			<th align="center">Razon Social</th>
			<th align="center">Ruc</th>
			<th align="center">Nombres</th>
			<th align="center">Apellidos</th>
			<th align="center">Saldo al <?php echo date("d/m/Y",strtotime($fechacuenta)); ?></th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ 

$saldo_activo_acum+=$rs->fields['saldo_activo'];
?>
		<tr>

			<td align="center"><?php echo intval($rs->fields['idcliente']); ?></td>
			<td align="left"><?php echo antixss($rs->fields['razon_social']);  ?></td>
			<td align="center"><?php echo antixss($rs->fields['ruc']); ?></td>
			<td align="left"><?php echo antixss($rs->fields['nombre']);  ?></td>
			<td align="left"><?php echo antixss($rs->fields['apellido']);  ?></td>

			<td align="right" style="background-color:#FFC;"><?php echo formatomoneda($rs->fields['saldo_activo']);  ?></td>
		</tr>
<?php $rs->MoveNext(); } //$rs->MoveFirst(); ?>
		<tr style="background-color:#CCC; font-weight:bold;">
			<td>
			Totales

			</td>

			<td align="right"></td>
			<td align="center"></td>
			<td align="right"></td>
            <td align="right"></td>
			<td align="right"><?php echo formatomoneda($saldo_activo_acum);  ?></td>            
			
		</tr>
	  </tbody>
    </table>
</div>
<br />



                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
