<?php 
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="11";
$submodulo="141";
require_once("includes/rsusuario.php"); 
require_once 'clases/PHPExcel.php';

set_time_limit(0);
ini_set('memory_limit','512M');

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-").'01';
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));	
}


$buscar="
	select ventas_detalles.idventa, registrado_el as 'Fecha Hora', 
	(select descripcion from productos where idprod_serial = ventas_detalles.idprod) as Producto,
	(
	select categorias.nombre 
	from categorias 
	inner join productos on productos.idcategoria = categorias.id_categoria 
	where 
	idprod_serial = ventas_detalles.idprod
	) as Categoria,
	(
	select sub_categorias.descripcion 
	from sub_categorias
	inner join productos on productos.idsubcate = sub_categorias.idsubcate 
	where 
	idprod_serial = ventas_detalles.idprod
	) as 'Sub Categoria',
	(select nombre from sucursales where sucursales.idsucu = ventas_detalles.sucursal) as Sucursal,
	pventa as 'Precio Unitario', cantidad as Cantidad, subtotal as Subtotal,
	(select usuario from usuarios where idusu = ventas.operador_pedido) as Operador,
	(select usuario from usuarios where idusu = ventas.registrado_por) as Cajero
	FROM ventas_detalles
	inner join ventas on ventas.idventa = ventas_detalles.idventa
	WHERE 
	ventas.estado <> 6
	and ventas.idempresa = $idempresa
	and date(ventas_detalles.registrado_el) >= '$desde'
	and date(ventas_detalles.registrado_el) <= '$hasta'
	ORDER by ventas.fecha desc
";
$rsvdet = $conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$rs=$rsvdet;

 $impreso=date("d/m/Y H:i:s");


	

//generando nombres de columna para excel
$Cantidad_de_columnas_a_crear=$rs->_numOfFields;  // obtiene la cantidad de columnas
$Contador=0; 
$Letra='A';
$letrasxls='';
// genera un array con las letras en base a la cantidad de columnas
while($Contador<$Cantidad_de_columnas_a_crear){ 
    $letrasxls.=",".$Letra; 
    $Contador++; 
    $Letra++; 
} 
// convierte el csv en un array
$letras_xls=$letrasxls;
$letras_xls_ar=explode(',',$letras_xls);

// inicializa el archivo Excel
		$objPHPExcel = new PHPExcel();
		// Establecer propiedades
		$objPHPExcel->getProperties()
		->setCreator("e-karú")
		->setLastModifiedBy("WEB")
		->setTitle("Listado de Ventas")
		->setSubject("XLS Listado de Ventas")
		->setDescription("Listado de Ventas")
		->setKeywords("Excel Office 2007 openxml php")
		->setCategory("Reportes");
		
	// asigna los datos de la consulta a una variable
	$array=$rs->fields;
	
	// establece la hoja activa
	$objPHPExcel->setActiveSheetIndex(0);
	$objWorksheet = $objPHPExcel->getActiveSheet();

	
	// CONSTRUYE CABECERA
	$array=$rs->fields;
	$col=0;
	$colspan=0;
	$i=0;
	foreach($array as $key=>$value){
		$i++;
		$columna=$letras_xls_ar[$i].'1';
		$objWorksheet->setCellValue($columna,$key);		
	}
	reset($array);
	
	// AUTO AJUSTA ANCHO COLUMNAS Y CAMBIA FORMATO DE LA CABECERA
	$i=0;
	foreach($array as $key=>$value){
		$i++;
		$objPHPExcel->getActiveSheet()->getColumnDimension($letras_xls_ar[$i])->setAutoSize(true);
		$objPHPExcel->getActiveSheet()->getStyle($letras_xls_ar[$i].'1')->getFont()->setSize(12)->setBold(true);	
	}
	reset($array);
	
	
	//CONSTRUYE CUERPO
	$ante=0;
	$fila=1;
	while (!$rs->EOF){
		$fila++;
		$array=$rs->fields;
		$i=0;
		foreach($array as $key=>$value){
			$i++;
			$columna=$letras_xls_ar[$i].$fila;
			$objWorksheet->setCellValue($columna,$value);		
		}
	$rs->MoveNext(); }

	

	
	/******** MAERA DEL PIE *********************/
	
	
			$current=date("YmdHis");
			$objPHPExcel->getActiveSheet()->setTitle('Listado de Ventas Detallado');
			
			// Establecer la hoja activa, para que cuando se abra el documento se muestre primero.
			
			$objPHPExcel->setActiveSheetIndex(0);
			$ile="listadoventa_det_$current.xlsx".
			
			// Se modifican los encabezados del HTTP para indicar que se envia un archivo de Excel.
			
			header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
			
			header('Content-Disposition: attachment;filename='. "'".$ile."'");
			
			header('Cache-Control: max-age=0');
			
			$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
			$objWriter->save('php://output');
			exit;	
	
	
		
?>