<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");

// Establecemos los headers para forzar la descarga del archivo CSV
header("Content-Type: text/csv; charset=utf-8");
header("Content-Disposition: attachment; filename=movimientos_".date("Ymd_His").".csv");

// Recibimos y formateamos los parámetros de fecha y hora
$desde = !empty($_GET['desde']) ? date("Y-m-d", strtotime($_GET['desde'])) : date("Y-m-") . '01';
$hasta = !empty($_GET['hasta']) ? date("Y-m-d", strtotime($_GET['hasta'])) : date("Y-m-d");

$hdesde = !empty($_GET['hdesde']) ? htmlentities($_GET['hdesde']) : '00:00';
$hhasta = !empty($_GET['hhasta']) ? htmlentities($_GET['hhasta']) : '23:59';

$desde_comp = $desde . ' ' . $hdesde . ':00';
$hasta_comp = $hasta . ' ' . $hhasta . ':59';

$idsucursal = isset($_GET['idsucu']) ? intval($_GET['idsucu']) : 0;

// Abrimos el stream de salida
$output = fopen('php://output', 'w');

// -----------------------
// SECCIÓN: RETIRO DE VALORES
// -----------------------
fputcsv($output, ['Retiro de Valores'], ';');
fputcsv($output, ['Idcaja', 'Fecha Retiro', 'Monto retirado', 'Retirado Por', 'Cajero', 'Observaciones'], ';');

$query_retiros = "
    SELECT 
        idcaja,
        fecha_retiro,
        monto_retirado,
        (SELECT usuario FROM usuarios WHERE idusu = caja_retiros.cajero) AS quienentrega,
        obs,
        (SELECT usuario FROM usuarios WHERE idusu = caja_retiros.retirado_por) AS encargado
    FROM caja_retiros
    WHERE date(fecha_retiro) BETWEEN '$desde' AND '$hasta'
      AND fecha_retiro >= '$desde_comp'
      AND fecha_retiro <= '$hasta_comp'
      AND estado = 1
      AND (idsucursal = $idsucursal OR 0 = $idsucursal)
";
$rsretiros = $conexion->Execute($query_retiros) or die(errorpg($conexion, $query_retiros));

while (!$rsretiros->EOF) {
    $fecha_retiro = ($rsretiros->fields['fecha_retiro'] != "") ? date("d/m/Y H:i:s", strtotime($rsretiros->fields['fecha_retiro'])) : "";
    fputcsv($output, [
        $rsretiros->fields['idcaja'],
        $fecha_retiro,
        number_format($rsretiros->fields['monto_retirado'], 0, ',', '.'),
        $rsretiros->fields['encargado'],
        $rsretiros->fields['quienentrega'],
        $rsretiros->fields['obs']
    ], ';');
    $rsretiros->MoveNext();
}

// Línea en blanco para separar secciones
fputcsv($output, [], ';');

// -----------------------
// SECCIÓN: REPOSICIÓN DE VALORES
// -----------------------
fputcsv($output, ['Reposicion de Valores'], ';');
fputcsv($output, ['Idcaja', 'Fecha Reposicion', 'Monto reingresado', 'Entregado Por', 'Cajero', 'Observaciones'], ';');

$query_repo = "
    SELECT 
        idcaja,
        fecha_reposicion,
        monto_recibido,
        (SELECT usuario FROM usuarios WHERE idusu = caja_reposiciones.cajero) AS quienentrega,
        obs,
        (SELECT usuario FROM usuarios WHERE idusu = caja_reposiciones.entregado_por) AS encargado
    FROM caja_reposiciones
    WHERE date(fecha_reposicion) BETWEEN '$desde' AND '$hasta'
      AND fecha_reposicion >= '$desde_comp'
      AND fecha_reposicion <= '$hasta_comp'
      AND estado = 1
      AND (idsucursal = $idsucursal OR 0 = $idsucursal)
";
$rsrepo = $conexion->Execute($query_repo) or die(errorpg($conexion, $query_repo));

while (!$rsrepo->EOF) {
    $fecha_reposicion = ($rsrepo->fields['fecha_reposicion'] != "") ? date("d/m/Y H:i:s", strtotime($rsrepo->fields['fecha_reposicion'])) : "";
    fputcsv($output, [
        $rsrepo->fields['idcaja'],
        $fecha_reposicion,
        number_format($rsrepo->fields['monto_recibido'], 0, ',', '.'),
        $rsrepo->fields['encargado'],
        $rsrepo->fields['quienentrega'],
        $rsrepo->fields['obs']
    ], ';');
    $rsrepo->MoveNext();
}

fclose($output);
exit;
?>
