<?php
/*---------------------------------------------
02/01/2024: Se agrega descarga en PDF
21/02/24: Revision
---------------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="11";
$submodulo="538";
require_once("includes/rsusuario.php");
require_once  '../clases/mpdf/vendor/autoload.php';

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-").'01';
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));
}
if(trim($_GET['hdesde']) == '' or trim($_GET['hhasta']) == ''){
	$hdesde='00:00';
	$hhasta='23:59';
}else{
	$hdesde=htmlentities($_GET['hdesde']);
	$hhasta=htmlentities($_GET['hhasta']);
}

// conversion
$desde_comp=$desde.' '.$hdesde.':00';
$hasta_comp=$hasta.' '.$hhasta.':59';

//Traemos la info solicitada
$whereadd='';

$cajer=intval($_REQUEST['cajer']);
if ($cajer > 0)
{
	$whereadd.=" and pagos_extra.idusu=$cajer";
}

$prov=intval($_REQUEST['prov']);
if ($prov > 0)
{
	$whereadd.=" and pagos_extra.idprov=$prov";
}

$idsucu=intval($_REQUEST['idsucu']);
if ($idsucu > 0)
{
	$whereadd.=" and caja_super.sucursal=$idsucu";
}
//Pagos por caja desde el cajero de la caja de recaudacion

$buscar="
Select pagos_extra.idcaja,pagos_extra.fecha,pagos_extra.factura,pagos_extra.concepto,(select nombre from proveedores where idproveedor=pagos_extra.idprov)
as proveedor,pagos_extra.monto_abonado,(select usuario from usuarios where idusu=pagos_extra.idusu) as cajero 
from pagos_extra
inner join usuarios on usuarios.idusu=pagos_extra.idusu
inner join caja_super on caja_super.idcaja = pagos_extra.idcaja
where 
date(pagos_extra.fecha) between '$desde' and '$hasta'
and pagos_extra.fecha >= '$desde_comp'
and pagos_extra.fecha <= '$hasta_comp'
and pagos_extra.estado=1
$whereadd
order by pagos_extra.idcaja desc
";
$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$clase=intval($_REQUEST['clase']);
if($clase==1){
//PDF

$html='
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<style>
pre {
  display: block;
  font-family: monospace;
  white-space: pre;
  margin: 1em 0;
  font-size:10px;
} 
*{
	margin:0px;
	padding:0px;	
}
.cabecera{
	background-color:yellow;
	color:black;
	
	
}
</style>
</head>

<body>


';


$html.="
<div style='width:90%;margin-left:auto;margin-right:auto; border:0px solid #000000; padding:5px;'>
<p></p>
<div  style='width:90%;margin-left:auto;margin-right:auto; border:1px solid #000000; padding:5px; height:120px; text-align:center;'>
<h1>Pagos por caja</h1>
Fecha desde: &nbsp; ".date("d/m/Y",strtotime($_GET['desde']))."| Fecha Hasta: ".date("d/m/Y",strtotime($_GET['hasta']))."&nbsp; | 
</div>
    <table width=\"100%\" >
	  <thead>
	
		
		<tr>
			<th align=\"center\">Id caja</th>
			<th align=\"center\">Cajero</th>
			<th align=\"center\">Fecha de pago</th>
			<th align=\"center\">Proveedor</th>
			<th align=\"center\">Factura</th>
			<th align=\"center\">Concepto</th>
			<th align=\"center\">Monto Abonado</th>
    </thead>
    <tbody>
	";
    
		$subtotal_acum=0;
		$cant_acum=0;
		while (!$rs->EOF){	
			$totalpagos=$totalpagos+floatval($rs->fields['monto_abonado']);
	

		$html.="
		<tr>
			<td align=\"center\">".$rs->fields['idcaja']."</td>
			<td align=\"center\">".$rs->fields['cajero']."</td>
			<td align=\"center\">".$rs->fields['fecha']."</td>  
			<td align=\"center\">".$rs->fields['proveedor']."</td>
			<td align=\"center\">".$rs->fields['factura']."</td>
			<td align=\"center\">".$rs->fields['concepto']."</td> 
			<td align=\"center\">".formatomoneda($rs->fields['monto_abonado'])."</td>
		</tr>";
	
	
	
	
	
      $rs->MoveNext(); 
	  } 
	  
	  
	  $ahorat=date("d/m/Y H:i:s");
	  
	  
    $html.="
	</tbody>
      <tfoot>
      
      
		<tr style='background-color:yellow;'>
            <td >Totales</td>
            <td ></td>
			<td ></td>
            <td ></td>
            <td ></td>
            <td ></td>
            <td  align=\"right\">".formatomoneda($totalpagos)."</td>
		</tr>
        </tfoot>
    
  </table>
  <hr />
  <div style='width:80%;margin-left:auto;margin-right:auto;float:left;text-align:center;'>
		Impreso el $ahorat por  $cajero
	</div>
</div>

</div>
</body>
</html>



";



$mpdf = new mPDF('','LEGAL', 0, 0, 0, 0, 0, 0);
$mpdf->SetWatermarkText('');
$mpdf->showWatermarkText = false;
$mini=date('dmYHis');
$archivopdf='tmp/pagosxcaja_'.$mini.'.pdf';
$mpdf->SetDisplayMode('fullpage');
$mpdf->shrink_tables_to_fit = 1;
$mpdf->setFooter('{PAGENO}');
$mpdf->WriteHTML($html);
$mpdf->showImageErrors = true; 
$mpdf->Output($archivopdf,'I'); // mostrar en el navegador
} else {
	//XLS
	
	
	
	
}
?>