<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");

function limpiacsv($txt) {
    $txt = trim($txt);
    $txt = str_replace(";", ",", $txt);
    return $txt;
}

$whereadd="";

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
    $desde=date("Y-m-d");
    $hasta=date("Y-m-d");
}else{
    $desde=date("Y-m-d",strtotime($_GET['desde']));
    $hasta=date("Y-m-d",strtotime($_GET['hasta']));    
}
if(trim($_GET['hdesde']) == '' or trim($_GET['hhasta']) == ''){
    $hdesde="00:00";
    $hhasta="23:59";
}else{
    $hdesde=date("H:i",strtotime($_GET['hdesde']));
    $hhasta=date("H:i",strtotime($_GET['hhasta']));    
}
$desde_completo=$desde." ".$hdesde.':00';
$hasta_completo=$hasta." ".$hhasta.':59';

$whereadd.=" 
and date(mesas_atc.fecha_inicio) >= '$desde_completo'
and date(mesas_atc.fecha_inicio) <= '$hasta_completo'
";

if(intval($_GET['suc']) > 0){
    $idsuc=intval($_GET['suc']);
    $whereadd.=" and mesas_atc.idsucursal = $idsuc ";
}
if(intval($_GET['mpago']) > 0){
    $mpago=intval($_GET['mpago']);
    $whereadd.=" and mesas_atc_propinas.mediopago = $mpago ";
}


// Consulta para obtener los datos
$consulta = "
SELECT 
    mesas_atc.idatc, 
    sucursales.nombre as sucursal, sucursales.idsucu,
    mesas.numero_mesa, mesas.idmesa, 
    salon.nombre as salon, salon.idsalon,
    u_mozo.usuario as mozo, mesas_atc_propinas.idmozo,
    mesas_atc_propinas.monto_propina, 
    formas_pago.descripcion as formapago,
    formas_pago.idforma as idformapago, 
    u_registra.usuario as registrado_por_txt,
    mesas_atc_propinas.registrado_por, 
    mesas_atc_propinas.registrado_el,
    mesas_atc.fecha_inicio as fecha_apertura,
    (SELECT fecha FROM ventas WHERE estado <> 6 AND idatc = mesas_atc.idatc ORDER BY idventa ASC LIMIT 1) as fecha_venta
FROM 
    mesas_atc_propinas
INNER JOIN mesas_atc ON mesas_atc.idatc = mesas_atc_propinas.idatc
INNER JOIN mesas ON mesas.idmesa = mesas_atc.idmesa
INNER JOIN salon ON salon.idsalon = mesas.idsalon
INNER JOIN formas_pago ON formas_pago.idforma = mesas_atc_propinas.mediopago
INNER JOIN sucursales ON sucursales.idsucu = mesas_atc.idsucursal
LEFT JOIN usuarios u_mozo ON u_mozo.idusu = mesas_atc_propinas.idmozo
INNER JOIN usuarios u_registra ON u_registra.idusu = mesas_atc_propinas.registrado_por
WHERE mesas_atc.estado <> 6
$whereadd
ORDER BY mesas_atc.idatc ASC
";

$rs = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

$impreso = date("Ymd_His");
$filename = "propinas_manual_$impreso.csv";

// Cabecera para la descarga
header('Content-Type: text/csv; charset=UTF-8');
header("Content-Disposition: attachment; filename=$filename");

// Abrimos la salida estándar para generar el CSV
$salida = fopen('php://output', 'w');

// Escribir encabezados
$headers = [
    "Atc", "Sucursal", "Mesa", "Salon", "Mozo", "Monto Propina",
    "Forma de Pago", "Registrado por", "Registrado el",
    "Fecha Apertura Mesa", "Fecha Primera Venta"
];
fputcsv($salida, $headers, ';');

// Escribir datos en el archivo CSV
while (!$rs->EOF) {
    fputcsv($salida, [
        intval($rs->fields['idatc']),
        limpiacsv($rs->fields['sucursal'] . " [" . intval($rs->fields['idsucu']) . "]"),
        limpiacsv($rs->fields['numero_mesa'] . " [" . intval($rs->fields['idmesa']) . "]"),
        limpiacsv($rs->fields['salon'] . " [" . intval($rs->fields['idsalon']) . "]"),
        limpiacsv(intval($rs->fields['idmozo']) > 0 ? $rs->fields['mozo'] . " [" . intval($rs->fields['idmozo']) . "]" : "NO ASIGNADO"),
        limpiacsv(round($rs->fields['monto_propina'])),
        limpiacsv($rs->fields['formapago'] . " [" . intval($rs->fields['idformapago']) . "]"),
        limpiacsv($rs->fields['registrado_por_txt'] . " [" . intval($rs->fields['registrado_por']) . "]"),
        $rs->fields['registrado_el'] ? date("d/m/Y H:i:s", strtotime($rs->fields['registrado_el'])) : "",
        $rs->fields['fecha_apertura'] ? date("d/m/Y H:i:s", strtotime($rs->fields['fecha_apertura'])) : "",
        $rs->fields['fecha_venta'] ? date("d/m/Y H:i:s", strtotime($rs->fields['fecha_venta'])) : ""
    ], ';');

    $rs->MoveNext();
}

// Cerrar el flujo de salida
fclose($salida);
exit;
?>
