<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");

header("Content-Type: application/vnd.ms-excel");
header("Content-Disposition: attachment; filename=propinas_manual_" . date("Ymd_His") . ".xls");
header("Pragma: no-cache");
header("Expires: 0");

function limpiacsv($txt) {
    return trim(str_replace(";", ",", $txt));
}

$whereadd = "";

if (trim($_GET['desde']) == '' || trim($_GET['hasta']) == '') {
    $desde = date("Y-m-d");
    $hasta = date("Y-m-d");
} else {
    $desde = date("Y-m-d", strtotime($_GET['desde']));
    $hasta = date("Y-m-d", strtotime($_GET['hasta']));
}

if (trim($_GET['hdesde']) == '' || trim($_GET['hhasta']) == '') {
    $hdesde = "00:00";
    $hhasta = "23:59";
} else {
    $hdesde = date("H:i", strtotime($_GET['hdesde']));
    $hhasta = date("H:i", strtotime($_GET['hhasta']));
}

$desde_completo = $desde . " " . $hdesde . ':00';
$hasta_completo = $hasta . " " . $hhasta . ':59';

$whereadd .= " 
AND mesas_atc.fecha_inicio >= '$desde_completo'
AND mesas_atc.fecha_inicio <= '$hasta_completo'
";

if (intval($_GET['suc']) > 0) {
    $idsuc = intval($_GET['suc']);
    $whereadd .= " AND mesas_atc.idsucursal = $idsuc ";
}
if (intval($_GET['mpago']) > 0) {
    $mpago = intval($_GET['mpago']);
    $whereadd .= " AND mesas_atc_propinas.mediopago = $mpago ";
}

$consulta = "
SELECT 
    mesas_atc.idatc, 
    sucursales.nombre AS sucursal, sucursales.idsucu,
    mesas.numero_mesa, mesas.idmesa, 
    salon.nombre AS salon, salon.idsalon,
    u_mozo.usuario AS mozo, mesas_atc_propinas.idmozo,
    mesas_atc_propinas.monto_propina, 
    formas_pago.descripcion AS formapago,
    formas_pago.idforma AS idformapago, 
    u_registra.usuario AS registrado_por_txt,
    mesas_atc_propinas.registrado_por, 
    mesas_atc_propinas.registrado_el,
    mesas_atc.fecha_inicio AS fecha_apertura,
    formas_pago.descripcion as mediopagochar,
    mesas_atc_propinas.registrado_el as fechareg,
    (SELECT fecha FROM ventas WHERE estado <> 6 AND idatc = mesas_atc.idatc ORDER BY idventa ASC LIMIT 1) AS fecha_venta
FROM 
    mesas_atc_propinas
INNER JOIN mesas_atc ON mesas_atc.idatc = mesas_atc_propinas.idatc
INNER JOIN mesas ON mesas.idmesa = mesas_atc.idmesa
INNER JOIN salon ON salon.idsalon = mesas.idsalon
INNER JOIN formas_pago ON formas_pago.idforma = mesas_atc_propinas.mediopago
INNER JOIN sucursales ON sucursales.idsucu = mesas_atc.idsucursal
LEFT JOIN usuarios u_mozo ON u_mozo.idusu = mesas_atc_propinas.idmozo
INNER JOIN usuarios u_registra ON u_registra.idusu = mesas_atc_propinas.registrado_por
WHERE mesas_atc.estado <> 6
$whereadd
ORDER BY mesas_atc.idatc ASC
";

$rs = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

echo "<table border='1'>";
echo "<tr>
        <th>Sucursal</th>
        <th>Mesa</th>
        <th>ATC</th>
        <th>Mozo</th>
        <th>Fecha</th>
        <th>Medio pago</th>
        <th>Monto Propina</th>
        <th>Descuentos (IVA+Comisiones,etc)</th>
        <th>Monto Propina Global Neto</th>
        <th>Monto Propina Distribuido</th>
        <th>Registrado por</th>
      </tr>";

while (!$rs->EOF) {

    $total_propina_mesa = intval($rs->fields['monto_propina']);
    $total_propina_mesa_orig = intval($rs->fields['monto_propina']);
    $total_comision = $total_propina_mesa * $por_comision /100;

    echo "<tr>
            <td>" . limpiacsv($rs->fields['sucursal'] . " [" . intval($rs->fields['idsucu']) . "]") . "</td>
            <td>" . limpiacsv($rs->fields['numero_mesa']) . "</td>
            <td>" . intval($rs->fields['idatc']) . "</td>
            <td>" . (intval($rs->fields['idmozo']) > 0 ? limpiacsv($rs->fields['mozo'] . " [" . intval($rs->fields['idmozo']) . "]") : "NO ASIGNADO") . "</td>
            <td>" . limpiacsv(date("d/m/Y H:i:s",strtotime($rs->fields['fechareg']))) . "</td>
            <td>" . limpiacsv($rs->fields['mediopagochar']) . "</td>
            <td>" . round($rs->fields['monto_propina']) . "</td>
            <td>" . formatomoneda($total_propina_mesa_orig,0) . "</td>
            <td>" . formatomoneda($total_comision,2,'N'). " (" . formatomoneda($por_comision,2,'N') . " %) </td>
            <td>" . formatomoneda($total_propina_mesa,0) . "</td>
            <td>" . limpiacsv($rs->fields['registrado_por_txt']) . "</td>
          </tr>";

    $rs->MoveNext();
}

echo "</table>";
exit;
?>
