<?php

require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="11";
$submodulo="75";
require_once("includes/rsusuario.php"); 

if(file_exists('../clases/PHPExcel.php')){
	require_once '../clases/PHPExcel.php';
}else if(file_exists('clases/PHPExcel.php')){
	require_once 'clases/PHPExcel.php';
}else{
	require_once '../../clases/PHPExcel.php';	
}

// Verifica si los datos han sido enviados
if (!isset($_POST['datos_excel'])) {
    die("No hay datos para exportar.");
}

// Deserializar los datos
$datos_sucursales = unserialize(base64_decode($_POST['datos_excel']));

if (!isset($_POST['datos_excel'])) {
    die("No hay datos para exportar.");
}

$datos_sucursales = unserialize(base64_decode($_POST['datos_excel']));

if (!$datos_sucursales || empty($datos_sucursales)) {
    die("Error al procesar los datos.");
}

$objPHPExcel = new PHPExcel();
$objPHPExcel->setActiveSheetIndex(0);
$sheet = $objPHPExcel->getActiveSheet();

// Encabezados
$sheet->setCellValue('A1', 'Sucursal');
$sheet->setCellValue('B1', 'Categoria');
$sheet->setCellValue('C1', 'TK Prom.');
$sheet->setCellValue('D1', 'Ventas');
$sheet->setCellValue('E1', 'Total');
$sheet->setCellValue('F1', '%');

$sheet->getStyle("A1:F1")->getFont()->setBold(true);
$sheet->getStyle("A1:F1")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

$fila = 2; // Comenzar en la segunda fila
$sucursal_actual = "";
$total_global = 0;
$fila_sucursal_inicial = $fila; // Para identificar el inicio de cada sucursal

foreach ($datos_sucursales as $row) {
    $sucursal = $row['sucursal'];
    $sucursal_nombre = $row['sucursal_nombre'];
    $categoria = $row['canal'] ?: "Sin Datos";
    $cantidad = $row['cantidad'];
    $total = $row['total'];
    
    $tk_prom = ($cantidad > 0) ? round($total / $cantidad, 0) : 0;

    if ($sucursal_actual != $sucursal) {
        if ($sucursal_actual != "") {
            // Agregar Total Sucursal con SUM en Excel
            $inicio_fila_sucursal = $fila_sucursal_inicial + 1;
            $fin_fila_sucursal = $fila - 1;

            $fila++;
            $sheet->setCellValue("D$fila", "Total Sucursal:");

            if ($fin_fila_sucursal >= $inicio_fila_sucursal) {
                $sheet->setCellValue("E$fila", "=SUM(E{$inicio_fila_sucursal}:E{$fin_fila_sucursal})");
            } else {
                $sheet->setCellValue("E$fila", 0);
            }
            
            $sheet->setCellValue("F$fila", "100%");
            $sheet->getStyle("D$fila:F$fila")->getFont()->setBold(true);
            $fila++;
        }

        // Nueva sucursal
        $sucursal_actual = $sucursal;
        $fila_sucursal_inicial = $fila;

        $sheet->setCellValue("A$fila", "Sucursal: $sucursal_nombre");
        $sheet->mergeCells("A$fila:F$fila");
        $sheet->getStyle("A$fila")->getFont()->setBold(true);
        $fila++;
    }

    // Insertar fila de datos
    $sheet->setCellValue("A$fila", $sucursal);
    $sheet->setCellValue("B$fila", $categoria);
    $sheet->setCellValue("C$fila", "Gs. $tk_prom");
    $sheet->setCellValue("D$fila", $cantidad);
    $sheet->setCellValue("E$fila", round($total));
    $fila++;
}

// Última sucursal - Agregar Total con SUM
$inicio_fila_sucursal = $fila_sucursal_inicial + 1;
$fin_fila_sucursal = $fila - 1;

$fila++;
$sheet->setCellValue("D$fila", "Total Sucursal:");
if ($fin_fila_sucursal >= $inicio_fila_sucursal) {
    $sheet->setCellValue("E$fila", "=SUM(E{$inicio_fila_sucursal}:E{$fin_fila_sucursal})");
} else {
    $sheet->setCellValue("E$fila", 0);
}
$sheet->setCellValue("F$fila", "100%");
$sheet->getStyle("D$fila:F$fila")->getFont()->setBold(true);

// Ajustar tamaño de columnas
foreach (range('A', 'F') as $col) {
    $sheet->getColumnDimension($col)->setAutoSize(true);
}

// Configurar encabezados para descargar el archivo
header('Content-Type: application/vnd.ms-excel');
header('Content-Disposition: attachment; filename="desglose_sucursales.xls"');
header('Cache-Control: max-age=0');

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
$objWriter->save('php://output');
exit;