<?php
/*-------------------------------------
26/12/2023: Se agrega busqueda por OC
15/10/2024: Se incorpora uso de Multi-moneda
-----------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="11";
$submodulo="302";
require_once("includes/rsusuario.php"); 

$buscar="Select usa_multi_moneda from preferencias_caja limit 1";
$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$usa_multi_moneda=trim($rs->fields['usa_multi_moneda']);

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-d");
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));	
}
if(trim($_GET['hdesde']) == '' or trim($_GET['hhasta']) == ''){
	$hdesde="00:00";
	$hhasta="23:59";
}else{
	$hdesde=date("H:i",strtotime($_GET['hdesde']));
	$hhasta=date("H:i",strtotime($_GET['hhasta']));	
}
$desde_completo=$desde." ".$hdesde.':00';
$hasta_completo=$hasta." ".$hhasta.':59';



$whereadd="
 and date(ventas.fecha) >= '$desde'
 and date(ventas.fecha) <= '$hasta'
 and ventas.fecha >= '$desde_completo' 
 and ventas.fecha <= '$hasta_completo' 
";

if(($_GET['cj']) > 0){
	$idcaja=intval($_GET['cj']);
	$whereadd.=" and ventas.idcaja = $idcaja";
	
}
if(($_GET['idsucu']) > 0){
	$idsuc=intval($_GET['idsucu']);
	$whereadd.=" and ventas.sucursal = $idsuc";
	
}
if(($_GET['idcliente']) > 0){
	$idcliente=intval($_GET['idcliente']);
	$whereadd.=" and ventas.idcliente = $idcliente";
	
}
if(($_GET['numero_oc']) > 0){
	$ocnum=intval($_GET['numero_oc']);
	$whereadd.=" and ventas.ocnumero = $ocnum";
	
}
if(trim($_GET['idsucu']) == 'ss'){
	
	$consulta="
	select idsucu 
	from sucursales 
	where 
	estado = 1 
	and matriz = 'N'
	";
	$rssucufil=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$sucu_or_add="and ( ".$saltolinea;
	$i=0;
	while(!$rssucufil->EOF){
		$i++;
		$idsuc=intval($rssucufil->fields['idsucu']);
		if($i == 1){
			$sucu_or_add.=" ventas.sucursal = $idsuc ".$saltolinea;
		}else{
			$sucu_or_add.=" or ventas.sucursal = $idsuc ".$saltolinea;	
		}
	$rssucufil->MoveNext(); }
	$sucu_or_add.=" ) ".$saltolinea;
	$whereadd=$sucu_or_add;
	
}


if(($_GET['idproducto']) > 0){
	$idproducto=intval($_GET['idproducto']);
	$whereadd.=" and (select ventas_detalles.idprod from ventas_detalles where idventa = ventas.idventa and ventas_detalles.idprod = $idproducto limit 1) = $idproducto";
	
}
if(($_GET['cajer']) > 0){
	$cajer=intval($_GET['cajer']);
	$whereadd.=" and ventas.registrado_por=$cajer";
	
}
if(($_GET['idcanal']) > 0){
	$idcanal=intval($_GET['idcanal']);
	$whereadd.=" and ventas.idcanal = $idcanal ";
	
}

// estos dos sobrescriben todos los filtros
if(($_GET['factura']) != ''){
	$factura=antisqlinyeccion($_GET['factura'],"text");
	$whereadd=" and ventas.factura = $factura";
	
}
if(($_GET['idventa']) > 0){
	$idventa=intval($_GET['idventa']);
	$whereadd=" and ventas.idventa = $idventa";
	
}


// no sobrescribir este filtro
if(intval($_GET['estado']) == 6){
	$whereadd.=" and estado = 6 ";
}else{
	$whereadd.=" and estado <> 6 ";
}

// no sobrescribir este filtro
if(intval($_GET['condicion']) == 0){
	$whereadd.="  ";
}else{
	$condvta=intval($_GET['condicion']);
	$whereadd.=" and ventas.tipo_venta= $condvta ";
}
if(trim($_GET['desde']) != ''){
	$consulta="
	select *,
	(select sucursales.nombre from sucursales where sucursales.idsucu = ventas.sucursal) as sucursal,
	CASE WHEN tipo_venta = 1 then 'CONTADO' ELSE 'CREDITO' END as condicion,
	(select canal from canal where canal.idcanal = ventas.idcanal) as canal
	from ventas 
	where 
	 estado is not null 
	$whereadd
	order by fecha asc
	limit 3000
	";
	

	
	
	
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
}

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
<script>
function busca_cliente(){
	var direccionurl='busqueda_cliente.php';		
	var parametros = {
	  "m" : '1'		  
	};
	$.ajax({		  
		data:  parametros,
		url:   direccionurl,
		type:  'post',
		beforeSend: function () {
			$('#cuadro_pop').modal('show');
			$("#myModalLabel").html('Busqueda de Cliente');
			$("#modal_cuerpo").html('Cargando...');				
		},
		success:  function (response) {
			$("#modal_cuerpo").html(response);
		}
	});
	
}
function busca_cliente_res(tipo){
	var ruc = $("#ruc").val();
	var razon_social = $("#razon_social").val();
	if(tipo == 'ruc'){
		razon_social = '';
		$("#razon_social").val('');
	}
	if(tipo == 'razon_social'){
		ruc = '';
		$("#ruc").val('');
	}
	var direccionurl='busqueda_cliente_res.php';		
	var parametros = {
	  "ruc"            : ruc,
	  "razon_social"   : razon_social
	};
	$.ajax({		  
		data:  parametros,
		url:   direccionurl,
		type:  'post',
		beforeSend: function () {
			$("#busqueda_cli").html('Cargando...');				
		},
		success:  function (response) {
			$("#busqueda_cli").html(response);
		}
	});
}
function seleccionar_item(idcliente,descricion){
	$("#idcliente").val(idcliente);
	$('#cuadro_pop').modal('hide');
}
</script>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>

            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Informe: B&uacute;squeda de Ventas</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
<?php 
$refemenu="bus";
require_once("includes/menu_venta_graf.php"); ?>
<div class="clearfix"></div>
<hr />

<form id="form1" name="form1" method="get" action="">
  <div class="alert alert-info">
					<span class="fa fa-info-circle"></span>&nbsp;Establezca los filtros disponibles para obtener el reporte en pantalla.
					<?php if($usa_multi_moneda=='S'){ ?>
					El uso de multi-moneda se encuentra activo. 
					<?php } ?>
					</div>
<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Desde *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="desde" id="desde" value="<?php  echo $desde; ?>" placeholder="Desde" class="form-control" required />                    

	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Hasta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="hasta" id="hasta" value="<?php echo $hasta; ?>" placeholder="Hasta" class="form-control" required />                    

	</div>
</div>


<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Hora Desde *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="time" name="hdesde" id="hdesde" value="<?php  echo $hdesde; ?>" placeholder="hora desde" class="form-control" required />                    

	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Hora Hasta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="time" name="hhasta" id="hhasta" value="<?php echo $hhasta; ?>" placeholder="hora hasta" class="form-control" required />                    

	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Sucursal *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php 
// consulta
$consulta="
SELECT idsucu, nombre
FROM sucursales
where
estado = 1
order by nombre asc
 ";

// valor seleccionado
if(isset($_GET['idsucu'])){ 
	$value_selected=htmlentities($_GET['idsucu']); 
}else{
	$value_selected=htmlentities($rs->fields['idsucu']);
}

// parametros
$parametros_array=array(
	'nombre_campo' => 'idsucu',
	'id_campo' => 'idsucu',
	
	'nombre_campo_bd' => 'nombre',
	'id_campo_bd' => 'idsucu',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'TODAS',
	'pricampo_value' => '',
	'style_input' => 'class="form-control"', 
	'acciones' => '  ',
	'autosel_1registro' => 'S'

);

// construye campo
echo campo_select($consulta,$parametros_array);

?>
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Contiene Producto </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<?php 
	// consulta
    $consulta="
    SELECT idprod_serial as idproducto, descripcion
    FROM productos
    where
    borrado = 'N'
    order by descripcion asc
     ";
    
    // valor seleccionado
    if(isset($_GET['idproducto'])){ 
        $value_selected=htmlentities($_GET['idproducto']); 
    }else{
        //$value_selected=htmlentities($rs->fields['idproducto']);
    }
    
    // parametros
    $parametros_array=array(
        'nombre_campo' => 'idproducto',
        'id_campo' => 'idproducto',
        
        'nombre_campo_bd' => 'descripcion',
        'id_campo_bd' => 'idproducto',
        
        'value_selected' => $value_selected,
        
        'pricampo_name' => 'TODOS',
        'pricampo_value' => '',
        'style_input' => 'class="form-control"', 
        'acciones' => '  ',
        'autosel_1registro' => 'S'
    
    );
    
    // construye campo
    echo campo_select($consulta,$parametros_array);
	?>
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Canal </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<?php 
	// consulta
    $consulta="
    SELECT idcanal, canal
    FROM canal
    order by canal asc
     ";
    
    // valor seleccionado
    if(isset($_GET['idcanal'])){ 
        $value_selected=htmlentities($_GET['idcanal']); 
    }else{
        //$value_selected=htmlentities($rs->fields['idproducto']);
    }
    
    // parametros
    $parametros_array=array(
        'nombre_campo' => 'idcanal',
        'id_campo' => 'idcanal',
        
        'nombre_campo_bd' => 'canal',
        'id_campo_bd' => 'idcanal',
        
        'value_selected' => $value_selected,
        
        'pricampo_name' => 'TODOS',
        'pricampo_value' => '',
        'style_input' => 'class="form-control"', 
        'acciones' => '  ',
        'autosel_1registro' => 'S'
    
    );
    
    // construye campo
    echo campo_select($consulta,$parametros_array);
	?>
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Factura </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="factura" id="factura" value="<?php  if(isset($_GET['factura'])){ echo htmlentities($_GET['factura']); }?>" placeholder="Factura" class="form-control"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Idventa </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="idventa" id="idventa" value="<?php  if(isset($_GET['idventa'])){ echo htmlentities($_GET['idventa']); } ?>" placeholder="Idventa" class="form-control"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Cod Cliente </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="idcliente" id="idcliente" value="<?php  if(isset($_GET['idcliente'])){ echo htmlentities($_GET['idcliente']); } ?>" placeholder="Codigo de Cliente" class="form-control" readonly onClick="busca_cliente();"  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Estado </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php 


// valor seleccionado
if(isset($_GET['estado'])){ 
	$value_selected=htmlentities($_GET['estado']); 
}else{
	$value_selected=1;
}
// opciones
$opciones=array(
	'Ventas Vigentes' => '1',
	'Ventas Anuladas' => '6'
);
// parametros
$parametros_array=array(
	'nombre_campo' => 'estado',
	'id_campo' => 'estado',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'Seleccionar...',
	'pricampo_value' => '',
	'style_input' => 'class="form-control"', 
	'acciones' => ' required="required" ',
	'autosel_1registro' => 'S',
	'opciones' => $opciones

);

// construye campo
echo campo_select_sinbd($parametros_array);


?>
	</div>
</div>
<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Cajero </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php 
$buscar="Select * from usuarios where estado <> 6 order by usuario asc ";
$rslc=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
?>
	<select name="cajer" id="cajer" class="form-control">
		<option value="">Todos</option>
		<?php while (!$rslc->EOF){ ?>
		<option value="<?php echo $rslc->fields['idusu'] ?>"<?php  if($_GET['cajer']==$rslc->fields['idusu']){?> selected="selected" <?php } ?>><?php echo $rslc->fields['usuario'] ?></option>
		
		<?php $rslc->MoveNext();} ?>
	
	</select>
	</div>
</div>
<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Condicion </label>
	<div class="col-md-9 col-sm-9 col-xs-12">

	<select name="condicion" id="condicion" class="form-control">
		<option value="">Todos</option>
		<option value="1"<?php  if($_GET['condicion']==1){?> selected="selected" <?php } ?>>CONTADO</option>
		<option value="2"<?php  if($_GET['condicion']==2){?> selected="selected" <?php } ?>>CREDITO</option>
		
	
	</select>
	</div>
</div>
<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Numero OC </label>
	<div class="col-md-9 col-sm-9 col-xs-12">

	<input type="text" class="form-control" name="numero_oc" id="numero_oc" value="<?php echo $_REQUEST['numero_oc']; ?>" />
	</div>
</div>
<div class="clearfix"></div>
<br />


    <div class="form-group">
        <div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-5">
	   <button type="submit" class="btn btn-default" ><span class="fa fa-search"></span> Filtrar ventas</button>

        </div>
    </div>


<br />
</form>        
<div class="clearfix"></div>
<br />
<?php if(trim($_GET['desde']) != ''){?>
<hr />
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>
			<th></th>
			<th align="center">Idventa</th>
			<th align="center">Fecha</th>
			<th align="center">Factura</th>
			<th align="center">Razon social</th>
			<th align="center">Ruc</th>
			<th align="center">Canal</th>
			<th align="center">Condicion</th>
			<th align="center">Total sin Desc</th>
			<th align="center">Descneto</th>
			<th align="center">Total venta</th>
			<?php if($usa_multi_moneda=='S'){ ?>
			<th align="center">Total venta otra moneda</th>
			<?php } ?>
			<th align="center">Sucursal</th>
			
			
		</tr>
	  </thead>
	  <tbody>
<?php 

$st=0;
while(!$rs->EOF){ 
$tdesc=$tdesc+floatval($rs->fields['descneto']);
$st=$st+floatval($rs->fields['total_venta']);
$stcob=$stcob+floatval($rs->fields['totalcobrar']);
$stom=$stom+floatval($rs->fields['subtotal_otra_moneda']);
?>
		<tr>
			<td>
				
				<div class="btn-group">
					<a href="informe_venta_graf_det.php?id=<?php echo $rs->fields['idventa']; ?>" class="btn btn-sm btn-default" title="Detalle" data-toggle="tooltip" data-placement="right"  data-original-title="Detalle"><span class="fa fa-search"></span></a>
				</div>

			</td>
			<td align="center"><?php echo antixss($rs->fields['idventa']); ?></td>
			<td align="center"><?php if($rs->fields['fecha'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['fecha'])); }  ?></td>
			<td align="center"><?php echo antixss($rs->fields['factura']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['razon_social']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['ruc']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['canal']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['condicion']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['total_venta']); ?></td>
			<td align="center"><?php echo intval($rs->fields['descneto']); ?></td>
			<td align="center"><?php echo formatomoneda($rs->fields['totalcobrar']); ?></td>

			<?php if($usa_multi_moneda=='S'){ ?>
			<td align="center"><?php echo formatomoneda($rs->fields['subtotal_otra_moneda'],2,'S'); ?></td>
			<?php } ?>
			
			<td align="center"><?php echo antixss($rs->fields['sucursal']); ?></td>
			
			
		</tr>
<?php $rs->MoveNext(); } //$rs->MoveFirst(); ?>
		<tr>
			<?php if($usa_multi_moneda!='S'){ ?>
				<td colspan="8" align="right"><strong>Totales: </strong></td>
				<td align="center"><?php echo formatomoneda($st,4,'N') ?></td>
				<td align="center"><?php echo formatomoneda($tdesc,4,'N') ?></td>
				<td align="center"><?php echo formatomoneda($stcob,4,'N') ?></td>
				<td></td>
			<?php } else { ?>
				<td colspan="8" align="right"><strong>Totales: </td>
				<td align="center"><?php echo formatomoneda($st,4,'N') ?></strong></td>
				<td></td>
				<td></td>
				<td align="center"><?php echo formatomoneda($stom,2,'S') ?></strong></td>
			<?php } ?>
		</tr>
	  </tbody>
    </table>
</div>
<br />
 <?php } ?>
 
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
           
            
            
          </div>
        </div>
        <!-- /page content -->
        
<!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="cuadro_pop">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">

            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span>
              </button>
              <h4 class="modal-title" id="myModalLabel">Titulo</h4>
            </div>

            <div class="modal-body" id="modal_cuerpo">
            	Cuerpo
            </div>

            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>

        </div>
    </div>
</div>
<!-- POPUP DE MODAL OCULTO -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
