<?php 
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="11";
$submodulo="302";
require_once("includes/rsusuario.php"); 

// automentar el timpo de ejecucion del script
set_time_limit(600); // 600 = 10 minutos

// para mostrar errores por ejemplo el de falta de memoria en vez de mostarr un error 500 y no saber el problema
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);

// para evitar el error 500 por falta de memoria
//ini_set('memory_limit', '-1');
ini_set('memory_limit', '1024M'); // 1 gb

function limpiacsv($txt){
	global $saltolinea;
	$txt=trim($txt);
	$txt=str_replace(";",",",$txt);
	return utf8_decode($txt);
}

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-").'01';
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));	
}


if(fecha_dif_dias($desde,$hasta) > 366){
	echo "Debes seleccionar un rango de fecha que no supere 365 dias.";
	exit;
}


$idsucu=intval($_GET['idsucu']);
if($idsucu > 0){
	$whereadd.=" and ventas.sucursal = $idsucu ";	
}
if(intval($_GET['condicion']) == 0){
	$whereadd.="  ";
}else{
	$condvta=intval($_GET['condicion']);
	$whereadd.=" and ventas.tipo_venta= $condvta ";
}

$buscar="
select ventas_detalles.idventa, ventas.fecha as 'Fecha Hora Venta', 
(
	select  tmp_ventares_cab.fechahora 
    from tmp_ventares 
    inner join tmp_ventares_cab on tmp_ventares_cab.idtmpventares_cab = tmp_ventares.idtmpventares_cab
    WHERE
    tmp_ventares.idventatmp = ventas_detalles.idventatmp
    union all 
	select  tmp_ventares_cab.fechahora 
    from tmp_ventares_bak 
    inner join tmp_ventares_cab on tmp_ventares_cab.idtmpventares_cab = tmp_ventares_bak.idtmpventares_cab
    WHERE
    tmp_ventares_bak.idventatmp = ventas_detalles.idventatmp
    order by fechahora asc
	limit 1
) as 'Fecha Hora Comanda',
	CASE WHEN 
		LENGTH(ventas.factura) = 13
	THEN
		CONCAT(SUBSTRING(ventas.factura,1,3),'-',SUBSTRING(ventas.factura,4,3),'-',SUBSTRING(ventas.factura,7,7))
	ELSE
		ventas.factura
	END as Factura,
	CASE WHEN 
		tipo_venta = 1
	THEN 
		'CONTADO'
	ELSE
		'CREDITO'
	END as Condicion_Venta,
(select idinsumo from insumos_lista where idproducto = productos.idprod_serial) as Codart,
ventas_detalles.idprod as Codprod,
productos.idprodexterno as Codext,
productos.barcode as Codbarra,
productos.descripcion as Producto,
(
select categorias.nombre 
from categorias 
inner join productos on productos.idcategoria = categorias.id_categoria 
where 
idprod_serial = ventas_detalles.idprod
) as Categoria,
(
select sub_categorias.descripcion 
from sub_categorias
inner join productos on productos.idsubcate = sub_categorias.idsubcate 
where 
idprod_serial = ventas_detalles.idprod
) as 'Sub Categoria',
(select nombre from sucursales where sucursales.idsucu = ventas.sucursal) as Sucursal,
(select descripcion from gest_depositos where iddeposito = ventas.iddeposito) as Deposito,
(select sucursal from sucursal_cliente where sucursal_cliente.idsucursal_clie = ventas.idsucursal_clie) as Sucursal_cliente,
REPLACE(pventa,'.',',') as 'Precio Unitario', 
REPLACE(cantidad,'.',',') as Cantidad, 
REPLACE(subtotal,'.',',') as Subtotal,

REPLACE(ventas_detalles.descuento/cantidad,'.',',') as 'Descuento Unitario',
REPLACE(ventas_detalles.descuento,'.',',') as 'Descuento Subtotal',
REPLACE(ventas_detalles.subtotal_sindesc,'.',',') as 'Subtotal sin descuento',
REPLACE(subtotal/cantidad,'.',',') as 'PU Descontado', 
REPLACE(ventas_detalles.descuento/ventas_detalles.subtotal_sindesc*100,'.',',') as Descuento_porc,


REPLACE(costo,'.',',') as Costo_unitario,
REPLACE(subtotal_costo,'.',',') as Subtotal_costo,

REPLACE(subtotal-subtotal_costo,'.',',') as margen_bruto,

REPLACE(CASE WHEN 
	(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
THEN
 	(Select sum(gravadoml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet and iva_porc_col=0)
ELSE
	(Select sum(subtotal) as subtotal from ventas_detalles where idventadet=ventas_detalles.idventadet and iva=0)
END,'.',',') as exenta,
REPLACE((Select sum(gravadoml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet and iva_porc_col > 0),'.',',') as gravadas,
REPLACE((Select sum(ivaml) as subtotal from ventas_detalles_impuesto where idventadet=ventas_detalles.idventadet),'.',',') as ivaml,

REPLACE(productos.cantidad_referencial,'.',',') as cantidad_referencial_unit,
REPLACE(ventas_detalles.cantidad*productos.cantidad_referencial,'.',',')  as cantidad_referencial_total,
(select nombre from medidas where id_medida = productos.idmedida_referencial) as medida_referencial,
(
	select usuarios.usuario 
	from usuarios
	inner join tmp_ventares_bak on tmp_ventares_bak.usuario = usuarios.idusu
	where 
	tmp_ventares_bak.idventatmp  = ventas_detalles.idventatmp
	UNION
	select usuarios.usuario 
	from usuarios
	inner join tmp_ventares on tmp_ventares.usuario = usuarios.idusu
	where 
	tmp_ventares.idventatmp  = ventas_detalles.idventatmp
) as Operador_producto,
(select usuario from usuarios where idusu = ventas.operador_pedido) as Operador_pedido,
(select usuario from usuarios where idusu = ventas.registrado_por) as Cajero,
ventas.idcliente,
CONCAT(ventas.ruc) as ruc,
(select documento from cliente where idcliente = ventas.idcliente)  as documento,
ventas.razon_social,
(
select proveedores.nombre 
from proveedores 
inner join insumos_lista on insumos_lista.idproveedor = proveedores.idproveedor
inner join productos on productos.idprod_serial = insumos_lista.idproducto
where
productos.idprod_serial = ventas_detalles.idprod
) as proveedor,
	CONCAT(ELT(WEEKDAY(fecha)+1, 
    'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo')) AS dia_semana,
(select canal from canal where idcanal = ventas.idcanal) as canal,
(select canal_venta from canal_venta where idcanalventa = ventas.idcanalventa) as canal_venta,
(select motorista from motoristas where idmotorista = ventas.idmotorista) as motorista,
(select numero_mesa from mesas where idmesa = ventas.idmesa) as mesa,
(select salon.nombre from mesas inner join salon on salon.idsalon = mesas.idsalon where idmesa = ventas.idmesa) as salon,
CASE WHEN
ventas_detalles.idlistaprecio IS NULL
THEN
	'NORMAL'
ELSE
	(select lista_precios_venta.lista_precio from lista_precios_venta where idlistaprecio = ventas_detalles.idlistaprecio) 
END as lista_precio,
(select nomape from vendedor where idvendedor = ventas.vendedor) as vendedor,
dark_kitchen.nombre_marca as dark_kitchen,
(select observacion  from tmp_ventares_cab where idventa = ventas.idventa limit 1) as observacion,
ventas.excluye_repven as ven_excluye_reporte, 
productos.excluye_reporteventa as prod_excluye_reporte
FROM ventas_detalles
inner join ventas on ventas.idventa = ventas_detalles.idventa
inner join productos on productos.idprod_serial = ventas_detalles.idprod
left join dark_kitchen on dark_kitchen.iddarkkitchen = ventas.iddarkkitchen
WHERE 
ventas.estado <> 6
and date(ventas.fecha) >= '$desde'
and date(ventas.fecha) <= '$hasta'
$whereadd
ORDER by ventas.fecha asc, ventas.factura asc
";
//echo $buscar;//and ventas.idventa in( 96488,96489,96490,96491,96492,96493)
$rs = $conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

//$rs=$rsvdet;

$datos="";


	

//generando nombres de columna para excel
//$Cantidad_de_columnas_a_crear=$rs->_numOfFields;  // obtiene la cantidad de columnas



	// asigna los datos de la consulta a una variable
	//$array=$rs->fields;
	
	// CONSTRUYE CABECERA
	$array=$rs->fields;
	foreach($array as $key=>$value){
		$i++;
		$datos.=limpiacsv($key).';';
	}
	reset($array);
	$datos.=$saltolinea;





$impreso=date("d/m/Y H:i:s");

header('Content-Description: File Transfer');
header('Content-Type: application/force-download');
header('Content-Disposition: attachment; filename=venta_detalle_'.$impreso.'.csv');
	
echo $datos;


//CONSTRUYE CUERPO
//$ante=0;
$fila=1;
while (!$rs->EOF){
	$fila++;
	$array=$rs->fields;
	$i=0;
	foreach($array as $key=>$value){
		$i++;
		echo limpiacsv($value).';';
	}
	echo $saltolinea;
$rs->MoveNext(); }


exit; 		
?>