<?php
/*----------------------------------------------------------------
SC:  muestra pedidos
pendientes de envio para logistica
FCH: 17/02/2021
---------------------------------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="6";
$submodulo="373";

require_once("includes/rsusuario.php"); 

$limite="limit 30";

$buscar="Select idcabezaunico,idpedido_referencia,obs,fecha_registro,
	(CASE
		WHEN idtipopedido=1 THEN 'PEDIDOS'
		
		WHEN  idtipopedido=2 
		THEN (Select confeccionado_por from compras_pedidos where idpedido=logistica_pedidos.idpedido_referencia)
	END) as quienpide,
	(CASE
		WHEN idtipopedido=1 THEN 'PEDIDOS'
		
		WHEN  idtipopedido=2 
		THEN (Select fecha_entrega from compras_pedidos where idpedido=logistica_pedidos.idpedido_referencia)
	END) as fechapara,
	(CASE
		WHEN idtipopedido=1 THEN 'PEDIDOS'
		
		WHEN  idtipopedido=2 
		THEN (Select obs from compras_pedidos where idpedido=logistica_pedidos.idpedido_referencia)
	END) as obspedidooriginal,
	(CASE
		WHEN idtipopedido=1 THEN 'PEDIDOS'
		
		WHEN  idtipopedido=2 
		THEN 'COMPRAS'
	END) as origeninterno
from logistica_pedidos 
where estado_orden=1 order by idcabezaunico desc $limite";
$rg=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$tdatos=$rg->RecordCount();


?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Pedidos Pendientes Verificaci&oacute;n /  Entrega</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					<?php if ($tdatos > 0){?>
						<table class="table table-bordered">
							<thead>
							<tr>
								<th>Acciones</th>
								<th>Id &Uacute;nico</th>
								<th>Fecha Acopio</th>
								<th>Solicitado Or. por</th>
								<th>Origen Int. Pedido</th>
								<th>Fecha para pedido</th>
							</tr>
							</thead>
							<tbody>
							<?php while (!$rg->EOF){?>
							<tr>
							<th scope="row"><a href="javascript:void(0);" onClick="mostrar(<?php echo $rg->fields['idcabezaunico'] ?>);"><span class="fa fa-search"></span></a>&nbsp;&nbsp;</th>
								<td><?php echo $rg->fields['idcabezaunico'] ?></td>
								<td><?php echo date("d/m/Y H:i:s",strtotime($rg->fields['fecha_registro'])); ?></td>
								<td><?php echo $rg->fields['quienpide'] ?></td>
								<td><?php echo $rg->fields['origeninterno'] ?></td>
								<td><?php echo date("d/m/Y H:i:s",strtotime($rg->fields['fechapara'])); ?></td>
							</tr>
							<?php $rg->MoveNext();}?>
							</tbody>
							</table>		



					<?php } ?>

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->
		<div class="modal fade" id="acciones"  role="dialog" aria-labelledby="titulo" aria-hidden="true" >
			<div class="modal-dialog modal-dialog-centered" role="document" >
			  <div class="modal-content" style="width: 800px;">

				<!-- Modal Header -->
				<div class="modal-header">
					
					<span  id="variadotit" style="font-weight:bold;"></span>
				   <button type="button" class="close" data-dismiss="modal"></button>
				</div>

				<!-- Modal body -->
				<div class="modal-body" id="acciones_cuerpo" style="min-height:250px; overflow-y: scroll">
				  
                  
				</div>
					
				<!-- Modal footer -->
				<div class="modal-footer">
				 
                
				</div>

			  </div>
			</div>
		  </div>
        <!-- footer content -->
		  <script>
			  function mostrar(idunico){
				  var parametros = {
							"idu" : idunico
					};
					$.ajax({
							data:  parametros,
							url:   'log_envia_pedidos_mini.php',
							type:  'post',
							beforeSend: function () {
								 
							},
							success:  function (response) {
									$("#acciones_cuerpo").html(response);
							}
					});
					$("#variadotit").html("Verificando pedido - Logistica");
					$("#acciones").modal("show");
			  }
		  
		  </script>
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
