<?php
require_once('includes/conexion.php');
require_once('includes/funciones.php');

function login($parametros_array){
	global $conexion;
	global $ahora;

	// obtiene ip real
	$ipreal=ip_real();
 
	// variables externas
	$usuariologin=strtoupper(trim($parametros_array['nombre']));
	$clave=trim($parametros_array['clave']);
	$lt=floatval($parametros_array['lt']);
	$lg=floatval($parametros_array['lg']);
	
	
	
	// inicializando variables bandera
	$valido="S";
	$valido_pri="S";
	$errores="";
	
	// validaciones
	if(trim($parametros_array['clave']) == ''){
		 $errores.="Clave no puede estar Vacia.\n";
		 $valido_pri="N";
		 $valido="N";
	 }
	 if(trim($parametros_array['nombre']) == ''){
		 $errores.="Usuario no puede estar Vacio.\n";
		 $valido_pri="N";
		 $valido="N";
	 }
	 // conversiones
	$clave=md5($clave);
	// si las pasa las validaciones basicas
	if($valido_pri == "S"){  
		//Limpiar antes de acceder
		$usuariologin=antisqlinyeccion($usuariologin,'text');
		$clave=antisqlinyeccion($clave,'clave','N');
		// busca si existe en bd
		$buscar="Select * from usuarios where usuario=$usuariologin and clave=$clave";
		$rsu = $conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idusuario_login=intval($rsu->fields['idusu']);
		$encontrado=$rsu->RecordCount();
		// si existe
		if(intval($rsu->fields['idusu']) > 0){
			// valida que no este bloqueado
			if($rsu->fields['bloqueado'] == 'S'){
				$errores.="- Usuario Bloqueado! Su usuario fue bloqueado por muchos intentos fallidos de iniciar sesion,
				 favor contacte con la administracion.\n";
				$valido="N";
			}
			// valida que este activo
			if(intval($rsu->fields['estado']) != 1){
				$errores.="- Tu usuario fue desactivado por la administracion.\n";
				$valido="N";
			}
			
			$iduserlogin=intval($rsu->fields['idusu']);
			$empresa=intval($rsu->fields['idempresa']);
			$idsucursal=intval($rsu->fields['sucursal']);
			
			
			//Comprobamos que su licencia sea valida si no, no dejamos seguir
			$buscar="select * from empresas where idempresa=$empresa";
			$dt=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$tipolice=intval($dt->fields['tipo_sistema']);
			$licenciavalida=trim($dt->fields['licencia_valida']);
			if ($licenciavalida=='N'){
				$errores.="- Tu licencia ha caducado o no es valida.\n";
				$valido="N";
			}
			//Validar  que posea al menos un modulo permitido
			$total=intval(consultar_permisos($iduserlogin,$empresa));
			if ($total==0){
				$errores.="- Tu usuario no tiene permisos a ningun modulo.\n";
				$valido="N";
			}
			
		}
		// si no se encuentra usuario con esa clave y usuario
		if(intval($rsu->fields['idusu']) == 0){
			$errores.="- Usuario o Clave incorrecta.\n";
			$valido="N";
		}
		
		// si todo es valido 
		if($valido == 'S'){
			
			// inicia la sesion
			if(!isset($_SESSION)){
				session_start();
			}
			
			// registra logueo
			$nombre_host = antisqlinyeccion(gethostbyaddr($_SERVER["REMOTE_ADDR"]),"text");
			$agente=antisqlinyeccion($_SERVER['HTTP_USER_AGENT'],"text");
			$idusu=$rsu->fields['idusu'];
			$ip=$_SERVER['REMOTE_ADDR'];
			$ahora=date("Y-m-d H:i:s");
			$latitud=antisqlinyeccion(floatval($parametros_array['lt']),"text");
			$longitud=antisqlinyeccion(floatval($parametros_array['lg']),"text");
			$consulta="
			INSERT INTO usuarios_accesos
			(idusuario, ip, ip_real, fechahora, latitud, longitud, hostname, agente)
			 VALUES
			 ($idusu,'$ip','$ipreal','$ahora',$latitud,$longitud, $nombre_host, $agente)
			 ";
			 $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			
			// inicia sesiones
			session_regenerate_id(true);
			$_SESSION['idusuario'] = $rsu->fields['idusu'];
			$_SESSION['idempresa'] = $empresa;
			$_SESSION['licencia'] =  $tipolice;
			$_SESSION['idsucursal'] =  $idsucursal;
			$_SESSION['agente'] = $_SERVER['HTTP_USER_AGENT'];
			$_SESSION['real'] = $ipreal;
			$_SESSION['usuariologin']= $parametros_array['nombre'];
			if(!isset($_SESSION["timeout"])){
    			 $_SESSION['timeout'] = time();
  			}
			 // crea cockie que expira en 1 anho
			 $cempresa=md5($empresa);
			 setcookie("cempresa",$cempresa,time()+(1*365*24*60*60));
			
		
		// si no es valido
		}else{ // if($valido == 'S'){
			
			//busca si existe el usuario
			$buscar="Select * from usuarios where usuario=$usuariologin";
			$rsu2 = $conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$iduserloginex=intval($rsu2->fields['idusu']);
			$ip=antisqlinyeccion($_SERVER['REMOTE_ADDR'],'text');
			$ipreal=antisqlinyeccion($ipreal,'text');
			$nombre_host = antisqlinyeccion(gethostbyaddr($_SERVER["REMOTE_ADDR"]),"text");
			$agente=antisqlinyeccion($_SERVER['HTTP_USER_AGENT'],"text");
			$latitud=antisqlinyeccion(floatval($parametros_array['lt']),"text");
			$longitud=antisqlinyeccion(floatval($parametros_array['lg']),"text");
			// registra el intento
			$consulta="
			INSERT INTO intentos
			(fecha, fechahora, estado, ip, ip_real, idusuario, usuario_campo, hostname, agente, latitud, longitud) 
			VALUES
			('$ahora','$ahora','A',$ip,$ipreal,$iduserloginex,$usuariologin,$nombre_host, $agente, $latitud, $longitud)
			";
			$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			// si existe el usuario
			if($iduserloginex > 0){
				// consulta los intentos en la fecha actual
				$ahorad=date("Y-m-d");
				$consultaintentos="
				select  count(*) as totalintentos
				from intentos
				where
				estado = 'A'
				and fecha = '$ahorad'
				and idusuario = $iduserloginex
				";
				$row_intentos = $conexion->Execute($consultaintentos) or die(errorpg($conexion,$consultaintentos));
				// si hay mas de 5 intentos fallidos en la fecha, bloquear
				if(intval($row_intentos->fields['totalintentos']) >= 5){
					$consultablock="
					update usuarios set bloqueado = 'S' where idusu = $iduserloginex
					";
					$conexion->Execute($consultablock) or die(errorpg($conexion,$consultablock));
					$errores="- Usuario Bloqueado! Su usuario fue bloqueado por muchos intentos fallidos de iniciar sesion, favor contacte con la administracion.\n";
					$status=0;
					$valido='N';
				}
			} // if($iduserloginex > 0){
				
		} // if($valido == 'S'){
	
	
	} // if($valido_pri == "S"){  
	
	
	if($valido == 'S'){
		$status=200;
	}else{
		$status=0;
		$idusuario_login=0;
	}
	$respuesta=array('valido' => $valido, 'errores' => $errores, 'idusuario' => $idusuario_login);
		
	

	
	// convierte a formato json
	//$respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	
	return $respuesta;
}

//print_r($_POST);

$valido="S";
$errores="";

$parametros_array=array(
	'nombre' => $_POST['nombre'],
	'clave' => $_POST['clave'],
	'lt' => $_POST['lt'],
	'lg' => $_POST['lg']
);

$res=login($parametros_array);
$valido=$res['valido'];
if($valido != 'S'){
	$errores.=$res['errores'];
	$valido='N';
}
//print_r($res);exit;
if($valido == 'S'){
	//header("location: index_new.php");
	$respuesta=json_encode($res, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	echo $respuesta;
	exit;
}else{
	$respuesta=json_encode($res, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	echo $respuesta;
	exit;
}

?>