<?php 
/*--------------------------

07/07/23
----------------------------*/
require_once("includes/conexion.php");
//require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="10";
$submodulo="690"; //Produccion
require_once("includes/rsusuario.php"); 

function convertir_a_letras($numero) {
    $base = 26;
    $letras = range('A', 'Z');
    $resultado = '';
    
    while ($numero > 0) {
        $resto = ($numero - 1) % $base;
        $resultado = $letras[$resto] . $resultado;
        $numero = floor(($numero - 1) / $base);
    }
    
    return $resultado;
}

if(file_exists('../clases/PHPExcel.php')){
	require_once '../clases/PHPExcel.php';
}else if(file_exists('../../clases/PHPExcel.php')){
	require_once '../../clases/PHPExcel.php';	
}else{
	require_once 'clases/PHPExcel.php';
}

$consulta="select documento, nombres, apellidos, fecha_nac, ruc, razon_social, telefono, celular, email, direccion
from med_pacientes
where 
estado = 1";

$rsm=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$total=$rsm->RecordCount();
$Cantidad_de_columnas_a_crear=11;

$Contador=0; 
$Letra='A';
$letrasxls='';
// genera un array con las letras en base a la cantidad de columnas
while($Contador<$Cantidad_de_columnas_a_crear){ 
    $letrasxls.=",".convertir_a_letras($Contador); 
    $Contador++; 
    $Letra++; 
} 

// convierte el csv en un array
$letras_xls=str_replace(',,', '', $letrasxls);
$letras_xls_ar=explode(',',$letras_xls);

$columnas_mostrar = ['documento', 'nombres', 'apellidos', 'fecha_nac', 'ruc', 'razon_social', 'telefono', 'celular', 'email', 'direccion'];
$columnas_mostrar_label = ['Documento', 'Nombres', 'Apellidos', 'Fecha de nacimiento', 'RUC', 'Razon social', 'Telefono', 'Celular', 'Email', 'Direccion'];

// inicializa el archivo Excel
		$objPHPExcel = new PHPExcel();
		// Establecer propiedades
		$objPHPExcel->getProperties()
		->setCreator("e-karu")
		->setLastModifiedBy("WEB")
		->setTitle("Pacientes")
		->setSubject("XLS de pacientes")
		->setDescription("Registro de pacientes")
		->setKeywords("Excel Office 2007 openxml php")
		->setCategory("Reportes");
		
	// asigna los datos de la consulta a una variable
	$array=$rsm->fields;
	
	// establece la hoja activa
	$objPHPExcel->setActiveSheetIndex(0);
	$objWorksheet = $objPHPExcel->getActiveSheet();

	
	// CONSTRUYE CABECERA
	$array=$rsm->fields;
	$col=0;
	$colspan=0;
	$i=0;
	foreach($array as $key=>$value){

		$columna=$letras_xls_ar[$i].'1';

		if(in_array($key, $columnas_mostrar)){

			$posicion_nombre_columna = array_search($key, $columnas_mostrar);
			$objWorksheet->setCellValue($columna,$columnas_mostrar_label[$posicion_nombre_columna]);	
			$i++;	

		}
	}

	reset($array);
	
	// AUTO AJUSTA ANCHO COLUMNAS Y CAMBIA FORMATO DE LA CABECERA
	$i=0;
	foreach($array as $key=>$value){

		if(in_array($key, $columnas_mostrar)){
			
			$objPHPExcel->getActiveSheet()->getColumnDimension($letras_xls_ar[$i])->setAutoSize(true);
			$objPHPExcel->getActiveSheet()->getStyle($letras_xls_ar[$i].'1')->getFont()->setSize(12)->setBold(true);
			$i++;	
		}

	}
	reset($array);

	//CONSTRUYE CUERPO
	$ante=0;
	$fila=1;
	while (!$rsm->EOF){
		$fila++;
		$array=$rsm->fields;
		$i=0;
		foreach($array as $key=>$value){

			if(in_array($key, $columnas_mostrar)){

				$columna=$letras_xls_ar[$i].$fila;
				$objWorksheet->setCellValue($columna,strval($value));
				$i++;	
			}
		}
	$rsm->MoveNext(); }

	/******** MAERA DEL PIE *********************/
	
	
	$current=date("YmdHis");
	$objPHPExcel->getActiveSheet()->setTitle('Registro de pacientes');
	
	// Establecer la hoja activa, para que cuando se abra el documento se muestre primero.
	
	$objPHPExcel->setActiveSheetIndex(0);
	$ile="pacientes_$current.xlsx".
	
	// Se modifican los encabezados del HTTP para indicar que se envia un archivo de Excel.
	
	header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
	
	header('Content-Disposition: attachment;filename='.$ile);
	
	header('Cache-Control: max-age=0');
	
	$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
	$objWriter->save('php://output');
	exit;	
	

?>