<?php 
/*----------------------
01/11/2023: SOLO REV.
14/10/2024: Se sube a todos reparacion de descuento doble
---------------------*/
function seg_a_dhms($seg) { 
    $d = floor($seg / 86400); 
    $h = floor(($seg - ($d * 86400)) / 3600); 
    $m = floor(($seg - ($d * 86400) - ($h * 3600)) / 60); 
    $s = $seg % 60;
	if ($d > 0){
		$add1="$d Días,";
	}
	if ($h >0){
		$add2="$h horas,";
	}
	if ($m > 0){
		$add3="$m minutos,";
	}
	$texto="$add1 $add2 $add3".$s." segundo(s)";
    return $texto;
 }

function verificardocumento($parte1,$parte2,$numero){

	 $cab=trim($parte1).trim($parte2);
	 $limite=7;
	 $medio='';
	 $final=$numero;
	 $cantf=strlen($final);
	 $dif=($limite-$cantf);
	 if ($dif > 0) {
	    for ($i = 1;$i<=$dif;$i++) {
		  $medio=$medio.'0';
		
		}
		//al finalizar el for, le metemos a completar como debe ser
		$compuesto=$cab.$medio.$final;
	  } else {
	  // no habian diferencias
		$compuesto=$cab.$final;
	  }
	  $documentom=$compuesto;
	  return $documentom;
}

function comprobar_caja($array_entrada){
	global $conexion;
	
	$cajeroid=$array_entrada["idcajero"];
	$sucursalid=$array_entrada["sucursalid"];
	
	//Comprobar apertura de caja en fecha establecida
	$buscar="Select * from caja_super where estado_caja=1 and cajero=$cajeroid and sucursal = $sucursalid and tipocaja=1 order by fecha desc limit 1";
	
	$rscaja=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$idcaja=intval($rscaja->fields['idcaja']);
	$estadocaja=intval($rscaja->fields['estado_caja']);
	$idcaja_compartida=intval($rscaja->fields['idcaja_compartida']);
	if($idcaja_compartida > 0){
		$idcaja=$idcaja_compartida;
	}
	if ($idcaja==0){
		$errores.="- La caja debe estar abierta para poder realizar una venta.";
		$valido="N";
	}
	if ($estadocaja==3){
		$errores.="- La caja debe estar abierta para poder realizar una venta.";
		$valido="N";
	}
	if ($valido!='N'){
		return $idcaja;
		
	} else {
		return 0;
	}
	
	
	
}

function comprobar_permisos_cajero($array_entrada){
	global $conexion;
	$idempresa=$array_entrada["empresaid"];
	$cajeroid=$array_entrada["idcajero"];
	$sucursalid=$array_entrada["sucursalid"];
	
	$consulta="
		SELECT *, (SELECT fechahora FROM usuarios_accesos where idusuario = usuarios.idusu order by fechahora desc limit 1) as ultacceso,
		(select nombre from sucursales where idsucu=usuarios.sucursal ) as sucuchar
		FROM usuarios
		where
		estado = 1
		and sucursal= $sucursalid
		and idusu in (select idusu from modulo_usuario where estado = 1 and submodulo = 22)
		and idusu=$cajeroid
		order by usuario asc
		";
		$rsccajacon=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		if (intval($rsccajacon->fields['idusu'])>0){
			$permitecobrar='S';
		} else {
			$permitecobrar='N';

		}
		return $permitecobrar;
}

function buscar_idcaja($cajero){
	global $conexion;
	$buscar="Select * from caja_super where estado_caja=1 and cajero=$cajero and tipocaja = 1";
	$rscaja=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
	$idcaja=intval($rscaja->fields['idcaja']);
	$idcaja_compartida=intval($rscaja->fields['idcaja_compartida']);
	if($idcaja_compartida > 0){
		$idcaja=$idcaja_compartida;
	}
	
	return $idcaja;
}
function crear_cuenta_adh($idcta,$idadherente,$totalvendido,$idusu,$idempresa,$idventa){
	global $conexion;
	
	//datos del adherente
	$buscar="Select * from adherentes where idadherente=$idadherente";
	$rsad=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$idcliente=$rsad->fields['idcliente'];
	$buscar="Select saldo_sobregiro from cliente where idcliente=$idcliente";
	$rssob=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	
	$consulta="
	INSERT INTO adherente_estadocuenta 
	( fechahora, fechasola, tipomov, idcliente, idadherente, idserviciocom, monto, idventa, idpago, idcta, idempresa, idpagodiscrim)
	SELECT registrado_el as fechahora, date(registrado_el) as fechasola, 'D' as tipomov, idcliente, idadherente,
	 idserviciocom, deuda_global as monto, idventa, NULL as idpago, idcta, idempresa , NULL as idpagodiscrim
	from cuentas_clientes 
	where 
	idcta = $idcta
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	$saldosobregiro_tit=intval($rssob->fields['saldo_sobregiro']);
	$saldosobregiro_posconsumo_tit=$saldosobregiro_tit-$totalvendido;

	
	// actualizar el saldo de sobregiro
	$consulta="
	update cliente 
	set 
	saldo_sobregiro = $saldosobregiro_posconsumo_tit
	where 
	idcliente = $idcliente 
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
	
}
function validar_adherente($idadherente,$totalcobrar,$idempresa,$idmesa){
	
	global $conexion;
 	$mesactu=date("m");
 	$anoactu=date("Y");
	
	//datos del adherente
	$buscar="Select * from adherentes where idadherente=$idadherente";
	$rsad=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	
	
	// busca el consumo del mes actual del adherente del cliente (solo ventas credito)
	$buscar="
	Select sum(totalcobrar) as consumo_mes
	from ventas 
	where 
	idadherente=$idadherente 
	and MONTH(fecha) = $mesactu
	and YEAR(fecha) = $anoactu
	and tipo_venta = 2
	";
	$rsvconsumo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		
	// variables necesarias para el calculo
	$maxmensual_adh=intval($rsad->fields['maximo_mensual']);
	$lineasobregiro_adh=intval($rsad->fields['linea_sobregiro']);
	$saldosobregiro_adh=intval($rsad->fields['disponible']);
	$saldomensual_adh=$maxmensual_adh-intval($rsvconsumo->fields['consumo_mes']);
	$saldosobregiro_posconsumo_adh=intval($saldosobregiro_adh)-intval($totalcobrar);
	// si el consumo a registrar supera el saldo disponible de la linea de credito
	if($totalcobrar > $saldosobregiro_adh){
		$valido='N';
		$errores.='- La venta que intentas realizar supera la linea disponible del adherente.'.$maxmensual_adh.'<br />';
	}
	// si el consumo a registrar supera el saldo de maximo mensual
	if($totalcobrar > $saldomensual_adh){
		$valido='N';
		$errores.='- La venta que intentas realizar supera el maximo mensual permitido para el adherente.<br />';
	}		
	
	if ($errores==''){
		$seguir='S';
	} else {
		$seguir=$errores;
	}
	return $seguir;
}

/*-------------------REGISTROS DE VENTA----------------------------------------*/
function registrarventa($array_entrada){
		global $conexion;
		global $idterminal_pc;
		global $idtipodesc_depo;
		global $facturador_electronico;
		global $slot_firma;
		global $tipo_documento_set;
		global $obj_electro;
		global $ahora;
		
		//$facturador_electronico='S';
	
		//print_r($array_entrada);exit;
		
		$idatc=$array_entrada['idatc']; //ATC de la mesa
		$idatcdet=intval($array_entrada['idatcdet']); //ATCdet de la mesa
		$idmesa=$array_entrada['idmesa']; //Id de la mesa						   
		$idcliente=intval($array_entrada['idcliente']);//Id del cliente seleccionado para la venta
		$idadherente=intval($array_entrada['idadherente']);
		$diplomatico=substr($array_entrada['diplomatico'],0,1);
		//$descuento=floatval($array_entrada['descuento']);
		$motivo_descuento=trim($array_entrada['motivo_descuento']);
		$idmotivo_descuento=intval($array_entrada['idmotivo_descuento']);
		$idsucursal_clie=intval($array_entrada['idsucursal_clie']);
		$idvendedor=intval($array_entrada['idvendedor']);
		$facturanum=trim($array_entrada['facturanum']);	
		$tipoventa=$array_entrada['formaventa'];//de contado u credito segun corresponda
		$cajeroid=$array_entrada['idcajero']; //Id del cajero que cobra
		$idusu=$cajeroid;
		$idsucursal=$array_entrada['sucursalid']; //id de la sucursal de la venta
		$clasevta=intval($tipoventa);
		if(trim($facturanum) != ''){
			$ticketofactura="FAC";
		}else{
			$ticketofactura="TK";
		}
		$consumo=trim($array_entrada['consumo']);
		if($consumo == 'S'){
			$idtipotran=2;
		}else{
			$idtipotran=1;
		}
		$idventa_consumo=intval($array_entrada['idventa_consumo']);
		$idmozo=intval($array_entrada['mozoid']);//Id del mozo solo para uso con canal mesa
		
		$whereadd_deu='';
		$whereadd_pag='';
		$whereadd_des='';
		$whereadd_pro='';
		$whereadd_ven='';
		if(intval($idatcdet) > 0){
			$whereadd_deu.=' and tmp_ventares.idatcdet = '.$idatcdet;
			$whereadd_pag.=' and mesas_cobros_deta.idatcdet = '.$idatcdet;
			$whereadd_des.=' and mesas_descuentos_facturas.idatcdet = '.$idatcdet;
			$whereadd_pro.=' and mesas_atc_propinas.idatcdet = '.$idatcdet;
			$whereadd_ven.=' and ventas.idatcdet = '.$idatcdet;
		}
	
		$consulta="
		select sum(monto_descuento) as monto_descuento 
		from mesas_descuentos_facturas 
		where 
		idatc = $idatc 
		and estado = 1 
		$whereadd_des 
		limit 1
		";
		$rsdescfac=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$descuento=floatval($rsdescfac->fields['monto_descuento']);
		
		// si envio idatcdet
		if($idatcdet > 0){
			
			// si no especificoc el tipo de separacion separa por producto
			$consulta="
			update mesas_atc set tipo_separacuenta = 'P'  where idatc = $idatc and tipo_separacuenta is null
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			
			// busca que tipo de separacion usara
			$consulta="
			select tipo_separacuenta, idmesa from mesas_atc where idatc = $idatc limit 1
			";
			$rsatc=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$tipo_separacuenta=$rsatc->fields['tipo_separacuenta']; // M: monto P: producto
			$idmesa=$rsatc->fields['idmesa'];
			if($tipo_separacuenta == ''){
				$valido='N';
				$errores.='- No se definio el tipo de separacion de cuenta si es por producto o monto.'.$saltolinea;
				echo $errores;exit;
			}
			
			// actualizar los atc de Detalle
			/*$consulta="
			update tmp_ventares 
			set 
			idatc = $idatc
			where
			tmp_ventares.idventa is null
			and tmp_ventares.idtmpventares_cab in (
				select tmp_ventares_cab.idtmpventares_cab 
				from tmp_ventares_cab 
				where 
				tmp_ventares_cab.idatc = $idatc
			)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));*/
			
			// separacion por producto
			if($tipo_separacuenta == 'P'){
				//filtro para tmp_ventares
				$whereadd_detped=" and tmp_ventares.idatcdet = $idatcdet ";
				
				// busca si hay descuentos en el atc
				$consulta="
				select idatc from mesas_descuentos_facturas where idatc = $idatc limit 1
				";
				$rsdescdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$idatc_desc_ex=intval($rsdescdet->fields['idatc']);
				// si hay descuento
				if($idatc_desc_ex > 0){
					// busca si hay alguno sin atcdet con monto mayor a 0
					$consulta="
					select idatc from mesas_descuentos_facturas where idatc = $idatc and idatcdet is null and monto_descuento > 0 limit 1
					";
					$rsdescdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$idatc_desc_ex2=intval($rsdescdet->fields['idatc']);
					if($idatc_desc_ex2 > 0){
						$valido='N';
						$errores.='- Hay descuentos que no tienen subcuenta asignada, asignelo antes de proceder.'.$saltolinea;
						echo $errores;exit;
					}
					
				}
				// suma descuentos del atcdet
				$consulta="
				select sum(monto_descuento) as monto_descuento_atcdet from mesas_descuentos_facturas where idatcdet = $idatcdet
				";
				$rsdescdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$monto_descuento_atcdet=floatval($rsdescdet->fields['monto_descuento_atcdet']);
				$descuento=floatval($monto_descuento_atcdet);
				// suma detalle del ATCdet
				$consulta="
				select sum(subtotal) as subtotal_atcdet from tmp_ventares where idatcdet = $idatcdet
				";
				$rsmonto_atcdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$subtotal_atcdet=floatval($rsmonto_atcdet->fields['subtotal_atcdet']);
				// valida que  el descuento no supere el monto
				if($monto_descuento_atcdet > $subtotal_atcdet){
					$valido='N';
					$errores.='- El descuento no puede ser superior al monto de la subcuenta.'.$saltolinea;
					echo $errores;exit;
				}
				
				//valida que no haya productos en la mesa sin atcdet asignado
				$consulta="
				select idventatmp 
				from tmp_ventares 
				where  
				idatcdet is null 
				and borrado = 'N'
				and tmp_ventares.idtmpventares_cab in (
					select tmp_ventares_cab.idtmpventares_cab 
					from tmp_ventares_cab 
					where 
					tmp_ventares_cab.idatc = $idatc
				)
				limit 1
				";
				$rsatcdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$idventatmp_prod_ex=intval($rsatcdet->fields['idventatmp']);
				if($idventatmp_prod_ex > 0){
					$valido='N';
					$errores.='- Hay productos en la mesa que no tienen subcuenta asignada, asignelas.'.$saltolinea;
					echo $errores;exit;
				}
				
				
				// INICIA LA SEPARACION //
				// generar nueva cabecera con idmesatemp sin finalizar (en el modulo de ventas se usara este campo para reemplazar al idmesa)
				$consulta="
				INSERT INTO tmp_ventares_cab
				(razon_social, ruc, monto, idusu, fechahora, idsucursal, idempresa,idcanal,delivery,idmesa,idatc,
				idatc_anter, idmesa_anter, cocinado, retirado, finalizado, chapa, observacion) 
				VALUES 
				('SIN NOMBRE', 'X', 0, $cajeroid, '$ahora', $idsucursal, 1,4,'N',$idmesa,$idatc,
				NULL, NULL, 'S', 'S', 'N', NULL, 'SEPARA CUENTA POR PRODUCTO')
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				// buscar ultimo id insertado
				$consulta="
				select idtmpventares_cab
				from tmp_ventares_cab
				where
				idatc = $idatc
				and estado = 1
				order by idtmpventares_cab desc
				limit 1
				";
				$rscab = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$idtmpventares_cab_new=$rscab->fields['idtmpventares_cab'];
				
				$consulta="
				select tmp_ventares.idventatmp, tmp_ventares.idtmpventares_cab
				from tmp_ventares 
				where 
				tmp_ventares.idtmpventares_cab in (
					select tmp_ventares_cab.idtmpventares_cab 
					from tmp_ventares_cab 
					where 
					tmp_ventares_cab.idatc = $idatc
				)
				and tmp_ventares.idatcdet = $idatcdet
				order by tmp_ventares.idventatmp asc
				";
				$rsdet = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				while(!$rsdet->EOF){
					$idventatmp=$rsdet->fields['idventatmp'];
					$idtmpventares_cab_ant=$rsdet->fields['idtmpventares_cab'];
					$consulta="
					INSERT INTO log_mov_mesa
					(idventatmp, idtmpventares_cab_ant, idtmpventares_cab_new, idatc_ant, idatc_new, idmesa_ant, idmesa_new, accion, 
					registrado_por, registrado_el) 
					VALUES
					($idventatmp, $idtmpventares_cab_ant, $idtmpventares_cab_new, $idatc, $idatc, $idmesa, $idmesa, 'P', 
					$idusu, '$ahora') 
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					
					$consulta="
					update tmp_ventares 
					set 
					idtmpventares_cab = $idtmpventares_cab_new,
					idmesa = $idmesa
					where
					idventatmp = $idventatmp
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					
					
				$rsdet->MoveNext(); }
				
				
				// marca como finalizado el destino
				$consulta="
				update tmp_ventares_cab
				set 
				finalizado='S'
				where
				idtmpventares_cab = $idtmpventares_cab_new
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				// anula las cabeceras sin monto
				$consulta="
				update tmp_ventares_cab
				set 
				estado = 6
				where
				idatc = $idatc
				and idtmpventares_cab not in 
				(
					SELECT idtmpventares_cab 
					from tmp_ventares 
					where 
					borrado = 'N' 
					and idtmpventares_cab is not null 
					group by idtmpventares_cab
				)
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				
				// actualiza monto de todas las cabeceras del atc
				$consulta="
				update tmp_ventares_cab 
				set 
				monto = (
							COALESCE
							(
								(
									select sum(subtotal) as total_monto
									from tmp_ventares
									where
									tmp_ventares.borrado = 'N'
									and tmp_ventares.borrado_mozo = 'N'
									and tmp_ventares.idtmpventares_cab = tmp_ventares_cab.idtmpventares_cab
								)
							,0)
							
						)
				WHERE
				idatc = $idatc
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				//Logueamos el evento en la tabla
				$insertar="Insert into log_mesas_interact
				(idmesa_origen,	idmesa_dest,mov_generado_por,mov_reg_el,tipo_mov,idatc_orig,idatc_dest,idmozo,script)
				values
				($idmesa,$idmesa,$idusu,'$ahora',4,$idatc,NULL,0,'mini_funciones_nuevo.php')";
				$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
		
				
			} // if($tipo_separacuenta == 'P'){
			
			// separacion por monto
			if($tipo_separacuenta == 'M'){
				
				
			}
			
			
		}
		
		

	
		//*************  VALIDACIONES si es facturador electronico ****************/
		if($facturador_electronico == 'S'){
			// si es factura
			if($ticketofactura == 'FAC'){
				$consulta="
				select email, borrable, direccion, numero_casa, idtipooperacionset
				from cliente 
				where 
				idcliente = $idcliente 
				limit 1
				";
				$rscli = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$borrable=trim($rscli->fields['borrable']);
				$idtipooperacionset=trim($rscli->fields['idtipooperacionset']);
				// si no es el cliente generico
				/*if($borrable == 'S'){
					if(trim($rscli->fields['email']) == ''){
						$valido='N';
						$errores.='- El email no puede estar vacio cuando es una factura electronica.<br />';	
					}
					if(trim($rscli->fields['direccion']) != ''){
						if(intval($rscli->fields['numero_casa']) == 0){
							$valido='N';
							$errores.='- El numero de casa no puede estar vacio cuando hay un domicilio cargado.<br />';
						}
						if(intval($rscli->fields['numero_casa']) < 100){
							$valido='N';
							$errores.='- El numero de casa no puede ser menor a 111.<br />';
						}

					}

				} // if($borrable == 'S'){*/
			} // if($ticketofactura == 'FAC'){
		} // if($facturador_electronico == 'S'){
		//*************  VALIDACIONES si es facturador electronico ****************/

		
		// descuento por cliente
		/*$consulta="
		select porce_desc from cliente where idcliente = $idcliente limit 1
		";
		$rscli = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		if(floatval($rscli->fields['porce_desc']) > 0){
			$consulta="
			select sum(monto) as monto
			from  tmp_ventares_cab 
			where  
			finalizado='S' 
			and registrado='N' 
			and estado=1 
			and idmesa = $idmesa 
			and idatc=$idatc
			";
			$rsmont=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$montototalprod=intval($rsmont->fields['monto']);
			
			$descuento=round($montototalprod*($rscli->fields['porce_desc']/100),0);
			$motivo_descuento="'DESCUENTO CLIENTE'";
		}
		$descuento_sobre_factura=$descuento; // por que abajo se vuelve a usar la variable en descuento por producto
		*/
		if(floatval($descuento) > 0){
			// busca si existe el producto descuento debe estar borrado
			$consulta="
			select idprod_serial from productos where idtipoproducto = 8 limit 1
			";
			$rsdesc=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idproducto_descuento=intval($rsdesc->fields['idprod_serial']);
			// si no existe crea
			if($idproducto_descuento == 0){	
				$valido='N';
				$errores.='- No existe el articulo descuento, ingrese a productos y se creara automaticamente.'.$saltolinea;
				echo $errores;exit;
			}
		}
		
		if ($idadherente > 0){
			//Cuando es mesa, tomaremos el idservicio con saldo mas alto para cargarle en forma automatica
			//hasta poder ver si es conveniente o no, colocarle un select de servicios otra vez
			//ya que mesas es mas para restó que cantina	
			$buscar="Select max(adherentes_servicioscom.disponibleserv) as dispo from adherentes_servicioscom
			where idadherente=$idadherente";
			
			$rsmay=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
			$dispo=intval($rsmay->fields['dispo']);
			$buscar="Select idserviciocom from  adherentes_servicioscom
			where idadherente=$idadherente and disponibleserv=$dispo";
			$rsmay=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
			$idservcom=intval($rsmay->fields['idserviciocom']);
		}
		//echo $idservcom;exit;
		$continuar=1;//se saclo la validacon de adherente de aca, se hace antes de llegar a registrar venta, en cerrar mesa
		
	if ($continuar==1){
		$idservcom=intval($idservcom);//Asi si  no hay, envia cero y asigna al titular el consumo
		
		//-----------------------------CLIENTE------------//
		//Buscamos los datos del cliente
		$buscar="Select * from cliente where idcliente=$idcliente";
		$rscliente=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
		$ruccliente=trim($rscliente->fields['ruc']);
		$razonsoc=trim($rscliente->fields['razon_social']);
		$idcliente=intval($rscliente->fields['idcliente']);
		if($idcliente == 0){
			echo "No se indico el cliente.";exit;	
		}
		
		//-----------------------------CLIENTE------------//
		
		$clasevta=$array_entrada['formaventa'];//Si es Credito o contado
		//$tipoventa=$clasevta;
		if ($clasevta==2){
			//CRED
			$esta=1;//X Cobrar
			$crearcuenta=1;
		} else {
			//CONT
			$esta=2;//Cobrado
			$crearcuenta=0;
		}
		
		//Buscar id de caja del cajero
		$idcaja=buscar_idcaja($cajeroid);

		if ($idcaja==0){
			//ERROR
			echo 'error';exit;
		}
		
		$idempresa=$array_entrada['empresaid']; //id de la empresa
		$tipofactura=trim($array_entrada['tipofactura']);//Simple o compuesta'
		$tipofactura='S';
	
		$iddeposito=$array_entrada['iddeposito']; //Deposito del cual se descuenta
		$tipofacturacion=intval($array_entrada['tipofacturacion']);//Para saber si es factura diplo o normal
		$tipoimpresion=$array_entrada['textoimpresion']; //Si es tradicional por productos o agrupado x consumision
		$detalle_agrupado="N";
		if ($tipoimpresion==1){
			//normal
			$agr='N';
			$detalle_agrupado="N";
		}
		if ($tipoimpresion==2){
			//agrupado
			$agr='S';
			$detalle_agrupado="S";
		}
		
	
	
		$fac_suc=intval($array_entrada['sucursalfc']);
		$fac_pexp=intval($array_entrada['pefc']);
		$factura=intval($array_entrada['facturanum']); //Numero de factura emitido o a ser asignada
		$factura_suc=intval($fac_suc);
        $factura_pexp=intval($fac_pexp);
		if($idadherente > 0){
			$factura=0;
			$factura_suc=0;
			$factura_pexp=0;
			$fac_suc=0;
			$fac_pexp=0;
		}
	
	
		$recibo=$array_entrada['recibonum']; //Numero de recibo emitido o a ser asignada NO aplica si es auto impresor
		// preferencias
		$consulta="SELECT * FROM preferencias WHERE  idempresa = 1 ";
		$rspref=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$ventas_nostock=trim($rspref->fields['ventas_nostock']);
		$mueve_stock=trim($rspref->fields['mueve_stock']);
		$autoimpresor=trim($rspref->fields['autoimpresor']);
		$ventacaj_impcocina=trim($rspref->fields['ventacaj_impcocina']);
		if ($factura==0){
			$recibo='';
			//generar num recibo si no es auto impresor
			
		} else {
			
			$factura_suc=intval($factura_suc);
			$factura_pexp=intval($factura_pexp);
			$ahorad=date("Y-m-d",strtotime($ahora));
			$consulta="
			SELECT tipoimpreso 
			FROM facturas 
			where 
			estado = 'A'
			and valido_hasta >= '$ahorad'
			and valido_desde <= '$ahorad'
			and sucursal = $factura_suc
			and punto_expedicion = $factura_pexp
			and idtipodocutimbrado = 1
			order by fin desc
			limit 1
			";
			$rstipoimpre=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			if(trim($rstipoimpre->fields['tipoimpreso']) != ''){
				if(trim($rstipoimpre->fields['tipoimpreso']) == 'AUT'){
					$autoimpresor="S";
				}
				if(trim($rstipoimpre->fields['tipoimpreso']) == 'PRE'){
					$autoimpresor="N";	
				}
			}

			//tiene factura, completar los digitos
			if($autoimpresor == 'S'){
			    // omite la factura escrita y fuerza la que debe ser segun bd
				$proxfactura=prox_factura_auto($factura_suc,$factura_pexp,$idempresa);
				$factura=$proxfactura;
			}else{
				$proxfactura=$factura;

			}
			$timbradodatos=timbrado_tanda($factura_suc,$factura_pexp,$idempresa,$proxfactura);
			
			$facturafinal=antisqlinyeccion(trim(agregacero($factura_suc,3).agregacero($factura_pexp,3).agregacero($proxfactura,7)),'text');
			$fac_nro=$proxfactura;
			$fac_suc=$factura_suc;
			$fac_pexp=$factura_pexp;
			$idtandatimbrado=$timbradodatos['idtanda'];
			$timbrado=$timbradodatos['timbrado'];
			$valido_hasta=$timbradodatos['valido_hasta'];
			$valido_desde=$timbradodatos['valido_desde'];
			$inicio_timbrado=$timbradodatos['inicio'];
			$fin_timbrado=$timbradodatos['fin'];
			if(intval($idtandatimbrado) == 0){
				$valido='N';
				$errores.='- No existe tanda de timbrado para este punto de expedicion.<br />';
			}

			
			$facturafinal=verificardocumento($fac_suc,$fac_pexp,$factura);
			$recibo='';
		}
		
		if($valido == 'N'){
		    echo $errores;
		    exit;
		}
		
		$consulta="
		update tmp_ventares_cab 
			set 
			monto = (
						COALESCE
						(
							(
								select sum(subtotal) as total_monto
								from tmp_ventares
								where
								tmp_ventares.idsucursal = tmp_ventares_cab.idsucursal
								and tmp_ventares.borrado = 'N'
								and tmp_ventares.borrado_mozo = 'N'
								and tmp_ventares.idtmpventares_cab = tmp_ventares_cab.idtmpventares_cab
							)
						,0)
						
					)
			WHERE
			idatc = $idatc
			and idventa is null
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		


		//Total de la venta: Cuando hay un descuento sobre la factura y en tmpventares NO hay ya que el dato esta en la tabla de descuentos sobre mesas ver tabla nueva)
		/*$buscar="
		Select 
		sum(monto) as total,
		sum(delivery_costo) as delivery_costo,
		(
			select sum(descuento) as descuento 
			from tmp_ventares 
			where 
			idtmpventares_cab=tmp_ventares_cab.idtmpventares_cab 
			and idatc=$idatc 
			and finalizado='S' 
			and registrado='N' 	
			and estado=1 
			$whereadd_detped 
		) as descuento
		from  tmp_ventares_cab 
		where  
		finalizado='S' 
		and registrado='N' 
		and estado=1 
		and tmp_ventares_cab.idsucursal = $idsucursal
		and idmesa = $idmesa 
		and idatc=$idatc";*/
		$buscar="
		select 
		sum(subtotal) as total,
		0 as descuento,
		0 as delivery_costo
		from tmp_ventares
		where
		tmp_ventares.finalizado='S' 
		and tmp_ventares.registrado='N' 	
		and tmp_ventares.borrado = 'N'
		$whereadd_detped 
		and tmp_ventares.idtmpventares_cab in (
			select tmp_ventares_cab.idtmpventares_cab
			from tmp_ventares_cab
			where  
			tmp_ventares_cab.finalizado='S' 
			and tmp_ventares_cab.registrado='N' 
			and tmp_ventares_cab.estado=1 
			and tmp_ventares_cab.idsucursal = $idsucursal
			and tmp_ventares_cab.idmesa = $idmesa 
			and tmp_ventares_cab.idatc=$idatc
		)
		";
		//exit;
		$rsmo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$totalvendido=floatval($rsmo->fields['total']);
		$totalvendido_orig=floatval($rsmo->fields['total']); // no agregar ningun descuuento ni modificar por ningun motivo
		//floatval($rsmo->fields['total'])+
		$totalvendido_deldesc=floatval($rsmo->fields['descuento']);
		$totalvendido=$totalvendido-$totalvendido_deldesc;
		$totalvendidoglob=floatval($rsmo->fields['total']);
		
		// busca si algun detalle tiene diplomatico
		$consulta="
		select idventatmp
		FROM tmp_ventares
		where  
		borrado='N' 
		$whereadd_detped2
		and idtmpventares_cab in 
							(
							SELECT idtmpventares_cab 
							FROM tmp_ventares_cab 
							where 
							idatc=$idatc 
							and finalizado = 'S' 
							and registrado = 'N' 
							and estado = 1
							and idsucursal = $idsucursal
							)
		and diplo = 'S'
		limit 1
		";
		$rsdet_dip=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// encontro 1 producto diplomatico
		if(intval($rsdet_dip->fields['idventatmp']) > 0){
			if($diplomatico != 'S'){
				$valido='N';
				$errores.='- Hay productos asignados como diplomaticos debes poner la forma de facturacion diplomatica para cerrar la mesa..'.$saltolinea;
				echo $errores;exit;	
			}
			// busca si hay algun producto que no sea diplomatico
			$consulta="
			select idventatmp
			FROM tmp_ventares
			where  
			borrado='N' 
			$whereadd_detped2
			and idtmpventares_cab in 
								(
								SELECT idtmpventares_cab 
								FROM tmp_ventares_cab 
								where 
								idatc=$idatc 
								and finalizado = 'S' 
								and registrado = 'N' 
								and estado = 1
								and idsucursal = $idsucursal
								)
			and (diplo = 'N' or diplo is null)
			limit 1
			";
			$rsdet_nodip=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			if(intval($rsdet_nodip->fields['idventatmp']) > 0){
				$valido='N';
				$errores.='- Hay productos asignados como diplomaticos mezclados con productos no asignados, asigne todos o desasigne todos en el boton [Adm Mesa] > aplicar diplomatico o revertir diplomatico.'.$saltolinea;
				echo $errores;exit;	
			}
		}
		
		// valida que tenga al menos 1 producto en su detalle
		$consulta="
		select idventatmp
		FROM tmp_ventares
		where  
		borrado='N' 
		$whereadd_detped
		and idtmpventares_cab in 
							(
							SELECT idtmpventares_cab 
							FROM tmp_ventares_cab 
							where 
							idatc=$idatc 
							and finalizado = 'S' 
							and registrado = 'N' 
							and estado = 1
							and idsucursal = $idsucursal
							)
		limit 1
		";
		$rsdet_ex=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		if(intval($rsdet_ex->fields['idventatmp']) == 0){
			$valido='N';
			$errores.='- No se  puedee cerrar la venta por que el ATC ['.$idatc .'] no contiene ningun producto cargado.'.$saltolinea;
			echo $errores;exit;	
		}
			
		$idcanal=4;//Por defecto para ventas x mesas
		$iva10=0;//se hacen en base al detalle
		$tventa5=0;//se hacen en base al detalle
		$iva5=0;//se hacen en base al detalle
		$tventaex=0;//se hacen en base al detalle
		$mediopago=3;//MIXTO X DEFECTO
		$operador_pedido=0;//se hacen en base al detalle
		$idzona=0;
		$vuelto=0;
		//$motivo_descuento=0;
		//$descuento=0;
		$delivery_costo=0;$vuelto=0;$idclientedel=0;$iddomicilio=0;$pedido=0;
		
		$descuento_sobre_factura=$descuento;
		
		if($totalvendidoglob < $descuento_sobre_factura){
			$totalvendidoglob_txt=formatomoneda($totalvendidoglob);
			$descuento_sobre_factura_txt=formatomoneda($descuento_sobre_factura);
			$valido='N';
			$errores.="- El descuento ($descuento_sobre_factura_txt) no puede superar el monto de la factura ($totalvendidoglob_txt).<br />";
			echo $errores;exit;	
		}

		
		// si la venta es a credito
		if($tipoventa == 2){
		
			$totalcobrar=$totalvendido-$descuento;//Aca se usa solo para controlaar los saldos de sobregiro y consumo mes
			
			// si tiene permitido operar a credito
			if($rscliente->fields['permite_acredito'] != 'S'){
				$valido='N';
				$errores.='- El cliente seleccionado no tiene permitido operar a credito.<br />';
			}
			// periodo actual
			$mesactu=date("m");
			$anoactu=date("Y");
			// busca el consumo del mes actual del cliente (solo ventas credito)
			$buscar="
			Select sum(totalcobrar) as consumo_mes
			from ventas 
			where 
			idcliente=$idcliente 
			and MONTH(fecha) = $mesactu
			and YEAR(fecha) = $anoactu
			and tipo_venta = 2
			";
			$rsvconsumo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			// variables necesarias para el calculo
			$maxmensual_tit=intval($rscliente->fields['max_mensual']);
			$lineasobregiro_tit=intval($rscliente->fields['linea_sobregiro']);
			$saldosobregiro_tit=intval($rscliente->fields['saldo_sobregiro']);
			$saldomensual_tit=$maxmensual_tit-intval($rsvconsumo->fields['consumo_mes']);
			$saldosobregiro_posconsumo_tit=intval($saldosobregiro_tit)-intval($totalcobrar);
			// si el consumo a registrar supera el saldo disponible de la linea de credito
			if($totalcobrar > $saldosobregiro_tit){
				$valido='N';
				$errores.='- La venta que intentas realizar supera la linea disponible del cliente.<br />';
			}
			// si el consumo a registrar supera el saldo de maximo mensual
			if($totalcobrar > $saldomensual_tit){
				$valido='N';
				$errores.='- La venta que intentas realizar supera el maximo mensual permitido para el cliente.<br />';
			}
			
			
			
			// valida linea adherente
			/*if($idadherente > 0){
				// busca el consumo del mes actual del adherente del cliente (solo ventas credito)
				$buscar="
				Select sum(totalcobrar) as consumo_mes
				from ventas 
				where 
				idadherente=$idadherente 
				
				and MONTH(fecha) = $mesactu
				and YEAR(fecha) = $anoactu
				and tipo_venta = 2
				";
				$rsvconsumo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				// variables necesarias para el calculo
				$maxmensual_adh=intval($rsad->fields['maximo_mensual']);
				$lineasobregiro_adh=intval($rsad->fields['linea_sobregiro']);
				$saldosobregiro_adh=intval($rsad->fields['disponible']);
				$saldomensual_adh=$maxmensual_adh-intval($rsvconsumo->fields['consumo_mes']);
				$saldosobregiro_posconsumo_adh=intval($saldosobregiro_adh)-intval($totalcobrar);
				// si el consumo a registrar supera el saldo disponible de la linea de credito
				if($totalcobrar > $saldosobregiro_adh){
					$valido='N';
					$errores.='- La venta que intentas realizar supera la linea disponible del adherente.<br />';
				}
				// si el consumo a registrar supera el saldo de maximo mensual
				if($totalcobrar > $saldomensual_adh){
					$valido='N';
					$errores.='- La venta que intentas realizar supera el maximo mensual permitido para el adherente.<br />';
				}
				
				// si tiene pedido
				if($pedido > 0){
					$whereaddproh=" and idtmpventares_cab = $pedido ";
				}else{
					$whereaddproh=" and idtmpventares_cab is null ";
				}
				// Busca si el carrito contiene alimentos prohibidos
				$consulta="
				select idproducto, (select descripcion from productos where idprod_serial = tmp_ventares.idproducto) as producto
				from tmp_ventares 
				where 
				borrado = 'N' 
				and registrado = 'N'
				
				and usuario = $idusu
				$whereaddproh
				and idproducto in (
									select idproducto 
									from adherentes_prohibidos
									where
									idadherente = $idadherente
									and estado <> 6
									
								  )
				limit 10
				";
				$rsproh=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				// si encontro productos prohibidos
				if(intval($rsproh->fields['idproducto']) > 0){
					//$errores="si:".$consulta;
					$valido='N';
					$errores.='- La venta que intentas realizar contiene productos prohibidos. ';
					$errores.="Prohibidos: ";
					$prodprohibidos="";
					while(!$rsproh->EOF){
						$prodprohibidos.=strtolower($rsproh->fields['producto']).", ";
					$rsproh->MoveNext(); }
					$errores.=substr(trim($prodprohibidos),0,-1);
					$errores.=".<br />";
				}
				
				
				
				// si usa servicio de comida
				if($idservcom > 0){
					
					
					// ALIMENTOS NO ASIGNADOS AL SERVICIO DE COMIDA //
					// si tiene pedido
					if($pedido > 0){
						$whereaddproh=" and idtmpventares_cab = $pedido ";
					}else{
						$whereaddproh=" and idtmpventares_cab is null ";
					}
					// Busca si el carrito contiene alimentos no asignados a ese servicio
					$consulta="
					select idproducto, (select descripcion from productos where idprod_serial = tmp_ventares.idproducto) as producto
					from tmp_ventares 
					where 
					borrado = 'N' 
					and registrado = 'N'
					
					and usuario = $idusu
					$whereaddproh
					and idproducto not in (
										select idproducto 
										from producto_serviciocom
										where
										idserviciocom = $idservcom
										
									  )
					limit 10
					";
					$rsprohser=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
							
					// si encontro productos prohibidos
					if(intval($rsprohser->fields['idproducto']) > 0){
						//$errores="si:".$consulta;
						$valido='N';
						$errores.='- La venta que intentas realizar contiene productos no asignados al servicio seleccionado. ';
						$errores.="Productos: ";
						$prodprohibidos="";
						while(!$rsprohser->EOF){
							$prodprohibidos.=strtolower($rsprohser->fields['producto']).", ";
						$rsprohser->MoveNext(); }
						$errores.=substr(trim($prodprohibidos),0,-1);
						$errores.=".<br />";
					}
					
					// lineas maximas por servicio	
					$buscar="
					Select * from adherentes 
					inner join adherentes_servicioscom on adherentes_servicioscom.idadherente = adherentes_servicioscom.idadherente
					where 
					adherentes.idadherente=$idadherente 
					
					and adherentes_servicioscom.idserviciocom = $idservcom
					and adherentes_servicioscom.idadherente = $idadherente 
					";
					$rsadcom=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
					
					// busca el consumo del mes actual del servicio de comida del adherente del cliente (solo ventas credito)
					$buscar="
					Select sum(totalcobrar) as consumo_mes
					from ventas 
					where 
					idadherente=$idadherente 
					and idserviciocom = $idservcom
					and idempresa=$idempresa 
					and MONTH(fecha) = $mesactu
					and YEAR(fecha) = $anoactu
					and tipo_venta = 2
					";
					$rsvconsumoscom=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
					
					// variables necesarias para el calculo
					$maxmensual_adhscom=intval($rsadcom->fields['maximo_mensual']);
					$lineasobregiro_adhscom=intval($rsadcom->fields['linea_sobregiro']);
					$saldosobregiro_adhscom=intval($rsadcom->fields['disponibleserv']);
					$saldomensual_adhscom=$maxmensual_adhscom-intval($rsvconsumoscom->fields['consumo_mes']);
					$saldosobregiro_posconsumo_adhscom=intval($saldosobregiro_adhscom)-intval($totalcobrar);
					// si el consumo a registrar supera el saldo disponible de la linea de credito
					if($totalcobrar > $saldosobregiro_adhscom){
						$valido='N';
						$errores.='- La venta que intentas realizar supera la linea disponible del adherente para este servicio.<br />';
					}
					// si el consumo a registrar supera el saldo de maximo mensual
					if($totalcobrar > $saldomensual_adhscom){
						$valido='N';
						$errores.='- La venta que intentas realizar supera el maximo mensual permitido para el adherente para este servicio.<br />';
					}
					
				} // if($idservcom > 0){
			
				
			} // if($idadherente > 0){ */
			
			if($valido == 'N'){
				echo $errores;
				exit;
			}
					
			
		} // if($tipoventa == 2){
		
		//Track ID
		$tcid=$idsucursal.$idusu;
		$v=date('YmdHis');
		$tcid=$tcid.$v;
		$ahora=date("Y-m-d H:i:s");
		$tk=0;
	


	
		if ($tipofactura=='S'){
			//Registrar la venta simple
			/*$buscar="
			select sum()
			SELECT sum(monto) as monto 
			FROM tmp_ventares_cab 
			where 
			idatc=$idatc 
			and finalizado = 'S' 
			and registrado = 'N' 
			and estado = 1 
			and idsucursal = $idsucursal
			";
			$rscab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
			
			$buscar="
			SELECT *
			FROM tmp_ventares_cab 
			where 
			idatc=$idatc 
			and finalizado = 'S' 
			and registrado = 'N' 
			and estado = 1 
			
			and idsucursal = $idsucursal
			order by idtmpventares_cab asc
			limit 1
			";
			$rscabpri=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));*/	
			
			$whereadd_depo="";
			// si el descuento stock es producto sucursal
			if($idtipodesc_depo == 2){
				$whereadd_depo="
				(select iddeposito from producto_deposito where idsucursal = $idsucursal and idproducto = tmp_ventares.idproducto ) as iddeposito_det,
				";
			}
			// si el descuento stock es producto terminal
			if($idtipodesc_depo == 3){
				$idterminal_pc=intval($idterminal_pc);
				$whereadd_depo="
				(select iddeposito from producto_deposito_terminal where idterminal = $idterminal_pc and idproducto = tmp_ventares.idproducto ) as iddeposito_det,
				";
			}
			
			
			$consulta_det_ped="
			SELECT *,
			$whereadd_depo
			idventatmp
			FROM tmp_ventares 
			where  
			borrado='N' 
			$whereadd_detped
			and idtmpventares_cab in 
								(
								SELECT idtmpventares_cab 
								FROM tmp_ventares_cab 
								where 
								idatc=$idatc 
								and finalizado = 'S' 
								and registrado = 'N' 
								and estado = 1
								
								and idsucursal = $idsucursal
								)
			";
			$rsdet=$conexion->Execute($consulta_det_ped) or die(errorpg($conexion,$consulta_det_ped));
			// el where debe ser igual al de arriba
			$consulta_mayor="
			select idventatmp, subtotal
			FROM tmp_ventares
			where  
			borrado='N' 
			$whereadd_detped
			and idtmpventares_cab in 
								(
								SELECT idtmpventares_cab 
								FROM tmp_ventares_cab 
								where 
								idatc=$idatc 
								and finalizado = 'S' 
								and registrado = 'N' 
								and estado = 1
								
								and idsucursal = $idsucursal
								)
			order by subtotal desc
			limit 1
			";
			// el where tambien debe ser igual al de arriba
			$consulta_suma="
			select sum(subtotal) as totalcobrar
			FROM tmp_ventares
			where  
			borrado='N' 
			$whereadd_detped
			and idtmpventares_cab in 
								(
								SELECT idtmpventares_cab 
								FROM tmp_ventares_cab 
								where 
								idatc=$idatc 
								and finalizado = 'S' 
								and registrado = 'N' 
								and estado = 1
								and idsucursal = $idsucursal
								)
			";
			$rsdet_sum=$conexion->Execute($consulta_suma) or die(errorpg($conexion,$consulta_suma));
			$totalcobrar=$rsdet_sum->fields['totalcobrar'];
			
			// si es con factura
			if($factura > 0){
				$monto_factura=floatval($totalcobrar-$descuento_sobre_factura);
				if($monto_factura <= 0){
					echo "No se puede facturar con monto cero, en vez de eso, realiza un ticket interno.".$monto_factura;
					exit;
				}
			}

			///**** PRORRATEAR DESCUENTO PARA FACTURACION ELECTRONICA ****////
			if($facturador_electronico == 'S'){
			
				if($descuento_sobre_factura > 0){
					$total_venta_sindesc=$totalcobrar;
					$descuento_porc_prorat=($descuento_sobre_factura/$total_venta_sindesc)*100;
					$total_descontado=$totalcobrar-$descuento_sobre_factura;
					
					$subtotal_new_acum=0;
					while (!$rsdet->EOF){
						$idventatmp=intval($rsdet->fields['idventatmp']);
						$subtotal_old=floatval($rsdet->fields['subtotal']);
						$subtotal_new=round($subtotal_old-(($subtotal_old*$descuento_porc_prorat)/100),0);
						$subtotal_new_acum+=$subtotal_new;
						$consulta="
						update tmp_ventares 
						set 
						subtotal_orig = $subtotal_old, 
						subtotal = $subtotal_new
						where
						idventatmp = $idventatmp
						";
						
						$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
						
						
					$rsdet->MoveNext(); }
					$rsdet->MoveFirst(); 
					
					// si la sumatoria de los nuevos subtotales es menor al total de la factura ya descontado
					if($subtotal_new_acum < $total_descontado){
						$diferencia=$total_descontado-$subtotal_new_acum;
						// busca el producto mas caro
						$rsmaxtmp=$conexion->Execute($consulta_mayor) or die(errorpg($conexion,$consulta_mayor));
						$idventatmp_mascaro=$rsmaxtmp->fields['idventatmp'];
						$subtotal_mascaro=$rsmaxtmp->fields['subtotal'];
						$subtotal_ajustado=$subtotal_mascaro+$diferencia;
						$consulta="
						update tmp_ventares set subtotal=$subtotal_ajustado where idventatmp = $idventatmp_mascaro
						";
						
						$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
						
					}
					// si la sumatoria de los nuevos subtotales es mayor al total de la factura ya descontado
					if($subtotal_new_acum > $total_descontado){
						$diferencia=$subtotal_new_acum-$total_descontado;
						// busca el producto mas caro
						$rsmaxtmp=$conexion->Execute($consulta_mayor) or die(errorpg($conexion,$consulta_mayor));
						$idventatmp_mascaro=$rsmaxtmp->fields['idventatmp'];
						$subtotal_mascaro=$rsmaxtmp->fields['subtotal'];
						$subtotal_ajustado=$subtotal_mascaro-$diferencia;
						$consulta="
						update tmp_ventares set subtotal=$subtotal_ajustado where idventatmp = $idventatmp_mascaro
						";
						$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					}
					// volver a ejecutar el det luego de las actualizaciones
					$rsdet=$conexion->Execute($consulta_det_ped) or die(errorpg($conexion,$consulta_det_ped));
				}
			
			}
			///**** PRORRATEAR DESCUENTO PARA FACTURACION ELECTRONICA ****////

			if($factura > 0){
				if($autoimpresor == 'S'){
					$factura=prox_factura_auto($factura_suc,$factura_pexp,$idempresa);
					$facturafinal=trim(agregacero($factura_suc,3).agregacero($factura_pexp,3).agregacero($proxfactura,7));
				}
				$facturafinal=trim(reservarfactura($factura_suc,$factura_pexp,$factura,$autoimpresor,$idempresa));
			}else{
				$facturafinal="";
			}
			

			// datos timbrado 
			$idtandatimbrado=antisqlinyeccion($idtandatimbrado,"int");
			$timbrado=antisqlinyeccion($timbrado,"int");
			$factura_suc=antisqlinyeccion($factura_suc,"int");
			$factura_pexp=antisqlinyeccion($factura_pexp,"int");
			

			if ($totalvendido<0){
				$totalvendido=0;
			}
			
			$ruc_part=explode('-',$ruccliente);
			$ruchacienda=intval($ruc_part[0]);
			$dv=intval($ruc_part[1]);
			
			//si no envio sucursal del cliente
			if(intval($idsucursal_clie) == 0){
				$consulta="
				select idsucursal_clie 
				from sucursal_cliente 
				where 
				idcliente = $idcliente 
				and estado = 1 
				order by idsucursal_clie asc 
				limit 1
				";	
				$rssuccli=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$idsucursal_clie=antisqlinyeccion($rssuccli->fields['idsucursal_clie'],"int");
			}
		

			/*---------------------VENTAS*------------------------*/
			if($diplomatico == 'S'){
				$carnet_diplomatico=$ruccliente;
				//$ruchacienda=substr($ruchacienda,0,10);
			}
			$ruchacienda=substr($ruchacienda,0,10);
			$dv=intval(substr($dv,0,1));
			$idsalida=antisqlinyeccion($idventa_consumo,"int");
			$facturafinal=str_replace("'","",$facturafinal);
			$facturafinal=antisqlinyeccion(trim($facturafinal),"text");
			$insertar="
			Insert into ventas
			(
			idadherente,idserviciocom,fecha,idcliente,tipo_venta,idempresa,sucursal,factura,recibo,
			ruchacienda,dv,total_venta,idtransaccion,trackid,registrado_por,totaliva10,totaliva5,texe,
			idpedido,otrosgs,descneto,deliv,totalcobrar,tipoimpresion,vendedor,total_cobrado,estado,obs,idmesa,
			idcanal,idcaja,idzona,operador_pedido,formapago,vuelto,recibido,idclientedel,iddomicilio,
			idtandatimbrado,factura_sucursal,factura_puntoexpedicion,timbrado,ruc,
			iddeposito,diplomatico,carnet_diplomatico,detalle_agrupado,
			idsucursal_clie, idtipotran, idsalida,idmotivodescuento,idatc,idatcdet
			)
			VALUES
			(
			$idadherente,$idservcom,'$ahora',$idcliente,$clasevta,$idempresa,$idsucursal,$facturafinal,NULL,
			$ruchacienda,$dv,$totalvendido_orig,0,$tcid,$cajeroid,$iva10,$iva5,$tventaex,
			$pedido,$delivery_costo,$descuento,'',$totalvendido,1,$idvendedor,$totalvendido,1,NULL,$idmesa,
			$idcanal, $idcaja,0,$idmozo,3,0,0,$idclientedel,$iddomicilio,
			$idtandatimbrado,$factura_suc,$factura_pexp,$timbrado,'$ruccliente',
			$iddeposito,'$diplomatico','$carnet_diplomatico','$detalle_agrupado',
			$idsucursal_clie, $idtipotran, $idsalida,$idmotivo_descuento,$idatc,$idatcdet
			)
			";
			//echo $idcaja.$insertar;exit;
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
 			//Traemos el id de la venta
			$buscar="Select max(idventa) as mayor from ventas where  registrado_por = $cajeroid";
			$rsm=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$idventa=intval($rsm->fields['mayor']);
			
			//si es del gobierno y no tiene licitacion
			if($idtipooperacionset == 3){
				$consulta="
				INSERT INTO `ventas_comp_pub`
				(`idventa`, `modalidad`, `entidad`, `ano`, `secuencia`, `fecha_emision_cod_contrata`) 
				VALUES 
				($idventa,11,11111,11,1111111,'$fecha_venta')
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				/* GENERAR MASIVO RETROACTIVO
				INSERT IGNORE INTO `ventas_comp_pub` 
				(`idventa`, `modalidad`, `entidad`, `ano`, `secuencia`, `fecha_emision_cod_contrata`) 
				select idventa, 11,11111,11,1111111, fecha from ventas where idtipooperacionset = 3;
				*/
			}
				
			//Crear cuenta de credito
			if ($crearcuenta==1){
				//$idcta=crear_cuenta_credito($idventa,$idadherente,$idservcom);
			} 
			while (!$rsdet->EOF){
				$idprod=trim($rsdet->fields['idproducto']);
				$buscar="Select idprod,tipoiva,idmedida,idtipoiva from productos where idprod_serial=$idprod";
				$rsfg=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$codigoproducto=antisqlinyeccion($rsfg->fields['idprod'],'text');
				$tipoiva=intval($rsfg->fields['tipoiva']); // alicuota
				$idtipoiva=intval($rsfg->fields['idtipoiva']);
				$idmedida=intval($rsfg->fields['idmedida']);
				//CANTIDAD DE PRODUCTO FINAL VENDIDO
				$cantidad=floatval($rsdet->fields['cantidad']);
				//PRECIO DE VENTA DE PRODUCTO FINAL VENDIDO
				$precioventa=floatval($rsdet->fields['precio']);
				$subtotal=floatval($rsdet->fields['subtotal']);
				$idventatmp=intval($rsdet->fields['idventatmp']);
				$idprod1=antisqlinyeccion($rsdet->fields['idprod_mitad1'],'int');
				$idprod2=antisqlinyeccion($rsdet->fields['idprod_mitad2'],'int');
				$combo=antisqlinyeccion($rsdet->fields['combo'],'text');
				$combo_es=$rsdet->fields['combo'];
				$combinado=antisqlinyeccion($rsdet->fields['combinado'],'text');
				$combinado_es=$rsdet->fields['combinado'];
				$idtipoproducto=$rsdet->fields['idtipoproducto'];
				$descuento=floatval($rsdet->fields['descuento']);//OJO ESTA VARIABLE TRAE EL VALOR DEL DESCUENTO DE ARRIVA, ACA SE ESTA SOBREESCRIBIENDO
				$utilidadprox=0;
				$disponible=0;$menor=0;$costobase=0;
				$iddeposito_det=intval($rsdet->fields['iddeposito_det']);
				$subtotal_orig=floatval($rsdet->fields['subtotal_orig']);
				if($subtotal_orig > 0){
					$descuento_prorrateado=$subtotal_orig-$subtotal;
				}else{
					$descuento_prorrateado=0;
				}
				
				// si el producto no tiene asignado un deposito de descuento de stock, descuenta del deposito por defecto
				if($iddeposito_det == 0){
					$iddeposito_det=$iddeposito;
				}

				if($diplomatico != 'S'){
					// calcular base imponible
					$consulta="
					select idtipoiva, iva_porc, iva_describe, iguala_compra_venta, estado, hab_compra, hab_venta,
					id_forma_afectacion_tributaria_iva
					from tipo_iva 
					where
					idtipoiva = $idtipoiva
					";
					$rsbimp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$iva_porc=floatval($rsbimp->fields['iva_porc']); // alicuota
					$subtotal_monto_iva=calcular_iva($iva_porc,$subtotal);
					$base_imponible=$subtotal-$subtotal_monto_iva;
					$id_forma_afectacion_tributaria_iva=intval($rsbimp->fields['id_forma_afectacion_tributaria_iva']);
				}else{
					$iva_porc=0; // alicuota
					$subtotal_monto_iva=calcular_iva($iva_porc,$subtotal);
					$base_imponible=$subtotal-$subtotal_monto_iva;
					$tipoiva=0;
					$idtipoiva=3;
					$id_forma_afectacion_tributaria_iva=3; // 2 exonerado tabla forma_afectacion_tributaria_iva
				}
				
				
				//Manejo en Base a receta: el id de producto en la tabla de costo individual, es el que se debe usar .
				//Insertamos en Venta Detalle Como el manej es x receta, no hacer caso de las  columnas disponibles ni menor
				$insertar="
				Insert into ventas_detalles 
				(
				idventatmp,cantidad,pventa,subtotal,idventa,idemp,sucursal,idprod,costo,utilidad,iva,registrado_el,descuento,
				idprod_mitad1,idprod_mitad2,existencia,serialcostos,
				base_imponible,idtipoiva,subtotal_monto_iva,iddeposito_det,
				id_forma_afectacion_tributaria_iva,descuento_prorrateado
				)
				values
				(
				$idventatmp,$cantidad,$precioventa,$subtotal,$idventa,$idempresa,$idsucursal,'$idprod',$costobase,
				$utilidadprox,$tipoiva,'$ahora',$descuento,$idprod1,$idprod2,$disponible,$menor,
				$base_imponible,$idtipoiva,$subtotal_monto_iva,$iddeposito_det,
				$id_forma_afectacion_tributaria_iva,$descuento_prorrateado
				)
				";
				$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
				
				
				//traemos el id de ventas detalles insertado para usar en ventas_detalles de la receta
				$buscar="Select  max(idventadet) as mayor from ventas_detalles where idventa=$idventa and idprod='$idprod'";
				$rsmayor=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$mayorid=intval($rsmayor->fields['mayor']);
				$mi=$mayorid;
				$idventadet=$mayorid;

				if($diplomatico != 'S'){
					$consulta="
					SELECT 
					idtipoiva, iva_porc, monto_porc, exento 
					FROM tipo_iva_detalle 
					WHERE 
					idtipoiva = $idtipoiva
					";
					$rsivadet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

					while(!$rsivadet->EOF){
						
						$gravadoml=$base_imponible*($rsivadet->fields['monto_porc']/100);
						$ivaml=$gravadoml*($rsivadet->fields['iva_porc']/100);
						$exento=$rsivadet->fields['exento'];
						$iva_porc_col=$rsivadet->fields['iva_porc'];
						$monto_col=$gravadoml+$ivaml;
						
						//ventas_detalles_impuesto
						$consulta="
						INSERT INTO ventas_detalles_impuesto
						(idventadet, idventa, idproducto, idtipoiva, iva_porc_col, monto_col,
						gravadoml,  ivaml,  exento) 
						VALUES 
						($idventadet, $idventa, $idprod, $idtipoiva, $iva_porc_col, $monto_col,
						$gravadoml,  $ivaml,  '$exento'
						)
						";
						$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
						
					$rsivadet->MoveNext(); }
				
				}else{
						//ventas_detalles_impuesto
						$monto_col=$subtotal;
						$consulta="
						INSERT INTO ventas_detalles_impuesto
						(idventadet, idventa, idproducto, idtipoiva, iva_porc_col, monto_col,
						gravadoml,  ivaml,  exento) 
						VALUES 
						($idventadet, $idventa, $idprod, 3, 0, $monto_col,
						0,  0,  'S'
						)
						";
						$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				}
		
			
				//Paso 1): Traer la receta del producto
				$buscar="Select * from recetas where idproducto='$idprod' ";
			
				$rsre=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$idreceta=intval($rsre->fields['idreceta']);
				// si tiene receta
				if ($idreceta > 0){
					//Lista de componenentes de la receta
					$buscar="Select idreceta,idprod,ingrediente,cantidad,insumos_lista.idinsumo,costo,idmedida,tipoiva,
					insumos_lista.mueve_stock as mueve_stock_ins
					 from recetas_detalles 
					 inner join ingredientes on ingredientes.idingrediente=recetas_detalles.ingrediente
					 inner join insumos_lista on insumos_lista.idinsumo=ingredientes.idinsumo
					 where 
					 recetas_detalles.idprod=$idprod
					
					 and recetas_detalles.idreceta=$idreceta
					 
					 and ingredientes.idingrediente not in (
					 										select tmp_ventares_sacado.idingrediente 
															from tmp_ventares_sacado
															where
															tmp_ventares_sacado.idventatmp = $idventatmp
															and tmp_ventares_sacado.idproducto = $idprod
															)
					 ";
					$rsrecu=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
					
					while (!$rsrecu->EOF){
						
						
						$ir=intval($rsrecu->fields['idreceta']);
						$in=intval($rsrecu->fields['ingrediente']);
						$pp=intval($rsrecu->fields['idprod']);
						$insu=intval($rsrecu->fields['idinsumo']);
						$idmedida_med=$rsrecu->fields['idmedida'];
						$mueve_stock_ins=trim($rsrecu->fields['mueve_stock_ins']);
						/*if ($idmedida_med==4){
							//es unitario, tomamos la cantidad de la receta
							$cant=floatval($rsrecu->fields['cantidad'])*floatval($cantidad);
						} else {
							//cantidad vendida
							$cant=floatval($cantidad);
						}*/
						if(floatval($rsrecu->fields['cantidad']) > 0){
						    // cantidad receta por cantidad vendida
						    $cant=floatval($rsrecu->fields['cantidad'])*floatval($cantidad);
						}else{
						    // cantidad receta es cero entonces cantidad vendida
						    $cant=floatval($cantidad);
						}
						
						// descuenta stock general
						if($mueve_stock != 'N' && $mueve_stock_ins != 'N'){
							descontar_stock_general($insu,$cant,$iddeposito_det);
							$costo_insumo_utilizado=descuenta_stock_vent($insu,$cant,$iddeposito_det);
							movimientos_stock($insu,$cant,$iddeposito_det,2,'-',$idventa,$ahora);
							
							// costo unitario promedio de los insumos utilizados
							$costo_insumo_unitario=round($costo_insumo_utilizado/$cant,4);
							// costo del insumo actual utilizado
							$costo_acum_insu[$insu]=$costo_insumo_utilizado;
							// costo acumulado de todos los insumos
							$costo_acumulado+=$costo_insumo_utilizado;
						}else{
							$costo_insumo_utilizado=0;
							//$costo_acum_insu[$insu]=$costo_insumo_utilizado;
							$costo_insumo_unitario=0;
							$costo_acumulado=0;	
						}
						if(is_nan($costo_insumo_unitario)){
							$costo_insumo_unitario=0;    
						}
						if(is_nan($costo_insumo_utilizado)){
							$costo_insumo_utilizado=0;    
						}
						
						
						$insertar="Insert into venta_receta
						(idventa,idventadet,idprod,idingrediente,idinsumo,cantidad,idmedida,costo,costo_unitario,fechahora)
						values
						($idventa,$idventadet,'$pp',$in,$insu,$cant,$idmedida_med,$costo_insumo_utilizado,$costo_insumo_unitario,'$ahora')";
						$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
							

						
						$rsrecu->MoveNext();
					}
					
					$consulta="
					update ventas_detalles 
					set 
					subtotal_costo = COALESCE((
									select sum(costo) 
									from venta_receta 
									where 
									idventadet = ventas_detalles.idventadet
									),0)
					WHERE
					idventadet = $idventadet
					and idventa = $idventa
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$consulta="
					update ventas_detalles 
					set 
					costo = COALESCE(subtotal_costo/cantidad,0)
					WHERE
					idventadet = $idventadet
					and idventa = $idventa
					and cantidad > 0
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$consulta="
					update ventas_detalles 
					set 
					utilidad = subtotal-subtotal_costo
					WHERE
					idventadet = $idventadet
					and idventa = $idventa
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				}
				
				// si es un combinado
				if($combinado_es == 'S'){
					if($idprod1 > 0 && $idprod2 > 0){
						$prod_1=$idprod1;
						$prod_2=$idprod2;
						$produ_comb=$prod_1.','.$prod_2;
						$produ_comb_ar=explode(",",$produ_comb);
						$totalmitades=count($produ_comb_ar);
						$i=1;
						foreach($produ_comb_ar as $productos_ind){
				
							
							
							$idprod_combi=$productos_ind;
						
							//Paso 1): Traer la receta del producto
							$buscar="Select * from recetas where idproducto='$idprod_combi' ";
							$rsre=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
							$idreceta=intval($rsre->fields['idreceta']);
							
							// si tiene receta
							if ($idreceta > 0){
								
								//Lista de componenentes de la receta
								$buscar="Select idreceta,idprod,ingrediente,cantidad,insumos_lista.idinsumo,costo,idmedida,tipoiva,
								 insumos_lista.mueve_stock as mueve_stock_ins
								 from recetas_detalles 
								 inner join ingredientes on ingredientes.idingrediente=recetas_detalles.ingrediente
								 inner join insumos_lista on insumos_lista.idinsumo=ingredientes.idinsumo
								 where 
								 recetas_detalles.idprod=$idprod_combi
								 and recetas_detalles.idreceta=$idreceta
								
								 and ingredientes.idingrediente not in (
																		select tmp_ventares_sacado.idingrediente 
																		from tmp_ventares_sacado
																		where
																		tmp_ventares_sacado.idventatmp = $idventatmp
																		and tmp_ventares_sacado.idproducto = $idprod_combi
																		)
								 ";
								$rsrecu=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
								
								

								
								
								//Mayor ID serial detallep producto
								$buscar="Select  max(idventadet) as mayor from ventas_detalles where idventa=$idventa and idprod='$idprod_combi'";
								$rsmayorid=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
							   
								$mi=intval($rsmayorid->fields['mayor']);
								while (!$rsrecu->EOF){
									
									
									
									$ir=intval($rsrecu->fields['idreceta']);
									$in=intval($rsrecu->fields['ingrediente']);
									$pp=intval($rsrecu->fields['idprod']);
									$insu=intval($rsrecu->fields['idinsumo']);
									$ca=floatval($rsrecu->fields['cantidad']/$totalmitades);
									$co=floatval($rsrecu->fields['costo']);
									$med=intval($rsrecu->fields['idmedida']);
									$va=intval($rsrecu->fields['tipoiva']);
									$mueve_stock_ins=trim($rsrecu->fields['mueve_stock_ins']);
									
									// descuenta stock general
									if($mueve_stock != 'N' && $mueve_stock_ins != 'N'){
										descontar_stock_general($insu,$ca,$iddeposito);
										$costo_insumo_utilizado=descuenta_stock_vent($insu,$ca,$iddeposito);
										movimientos_stock($insu,$ca,$iddeposito,2,'-',$idventa,$ahora);
										// costo unitario promedio de los insumos utilizados
										$costo_insumo_unitario=round($costo_insumo_utilizado/$ca,4);
										// costo del insumo actual utilizado
										$costo_acum_insu[$insu]=$costo_insumo_utilizado;
										// costo acumulado de todos los insumos
										$costo_acumulado+=$costo_insumo_utilizado;
									}else{
										$costo_insumo_utilizado=0;
										//$costo_acum_insu[$insu]=$costo_insumo_utilizado;
										$costo_insumo_unitario=0;
										$costo_acumulado=0;	
									}
									if(is_nan($costo_insumo_unitario)){
										$costo_insumo_unitario=0;    
									}
									if(is_nan($costo_insumo_utilizado)){
										$costo_insumo_utilizado=0;    
									}
									
									//------------VENTA RECETA
									$insertar="Insert into venta_receta
									(idventa,idventadet,idprod,idingrediente,idinsumo,cantidad,idmedida,costo,fechahora)
									values
									($idventa,$mi,'$pp',$in,$insu,$ca,$med,$costo_insumo_utilizado,'$ahora')";
									$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
									
									$rsrecu->MoveNext();
								}
								
							}

							$i++;
						} //foreach($produ_comb_ar as $productos_ind){
						
					}			
				}
				
				//si es un combo 
				if($combo_es == 'S'){
					
					$whereadd_depo_comb="";
					// si el descuento stock es producto sucursal
					if($idtipodesc_depo == 2){
						$whereadd_depo_comb="
						,(select iddeposito from producto_deposito where idsucursal = $idsucursal and idproducto = tmp_combos_listas.idproducto ) as iddeposito_det
						";
					}
					// si el descuento stock es producto terminal
					if($idtipodesc_depo == 3){
						$idterminal_pc=intval($idterminal_pc);
						$whereadd_depo_comb="
						,(select iddeposito from producto_deposito_terminal where idterminal = $idterminal_pc and idproducto = tmp_combos_listas.idproducto ) as iddeposito_det
						";
					}
					
					// busca los productos que componen el combo
					$idprod_princ=$idprod;
					$consulta="
					select * 
					$whereadd_depo_comb
					from tmp_combos_listas
					where
					tmp_combos_listas.idventatmp = $idventatmp
					and tmp_combos_listas.idsucursal = $idsucursal
					";
					$rsgrupos=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					
					
					while (!$rsgrupos->EOF){ 
						
						$idprod_combo=$rsgrupos->fields['idproducto'];
						$iddeposito_det=intval($rsgrupos->fields['iddeposito_det']);
						$cant_componente_combo=floatval($rsgrupos->fields['cant_real']);											  														   
						// si el producto no tiene asignado un deposito de descuento de stock, descuenta del deposito por defecto
						if($iddeposito_det == 0){
							$iddeposito_det=$iddeposito;
						}
					
						$idprod_combo=$rsgrupos->fields['idproducto'];
						
						//Paso 1): Traer la receta del producto
						$buscar="Select * from recetas where idproducto='$idprod_combo' ";
						$rsre=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						$idreceta=intval($rsre->fields['idreceta']);
						
						// si tiene receta
						if ($idreceta > 0){
							
							//Lista de componenentes de la receta
							$buscar="Select idreceta,idprod,ingrediente,cantidad,insumos_lista.idinsumo,costo,idmedida,tipoiva,
							 insumos_lista.mueve_stock as mueve_stock_ins
							 from recetas_detalles 
							 inner join ingredientes on ingredientes.idingrediente=recetas_detalles.ingrediente
							 inner join insumos_lista on insumos_lista.idinsumo=ingredientes.idinsumo
							 where 
							 recetas_detalles.idprod=$idprod_combo
							 and recetas_detalles.idreceta=$idreceta
							 
							 
							 and ingredientes.idingrediente not in (
																	select tmp_ventares_sacado.idingrediente 
																	from tmp_ventares_sacado
																	where
																	tmp_ventares_sacado.idventatmp = $idventatmp
																	and tmp_ventares_sacado.idproducto = $idprod_combo
																	)
							 ";
							$rsrecu=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
							
							//Mayor ID serial detallep producto
							/*$buscar="Select  max(idventadet) as mayor from ventas_detalles where idventa=$idventa and idprod='$idprod_combo'";
							$rsmayorid=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));*/
						   
							$mi=intval($rsmayorid->fields['mayor']);
							$mi=$idventadet;
							while (!$rsrecu->EOF){
								
								
								$ir=intval($rsrecu->fields['idreceta']);
								$in=intval($rsrecu->fields['ingrediente']);
								$pp=intval($rsrecu->fields['idprod']);
								$insu=intval($rsrecu->fields['idinsumo']);
								$ca=floatval($rsrecu->fields['cantidad'])*$cantidad*$cant_componente_combo;
								$co=floatval($rsrecu->fields['costo']);
								$med=intval($rsrecu->fields['idmedida']);
								$va=intval($rsrecu->fields['tipoiva']);
								$mueve_stock_ins=trim($rsrecu->fields['mueve_stock_ins']);
								
								// descuenta stock general
								if($mueve_stock != 'N' && $mueve_stock_ins != 'N'){
									descontar_stock_general($insu,$ca,$iddeposito_det);
									$costo_insumo_utilizado=descuenta_stock_vent($insu,$ca,$iddeposito_det);
									movimientos_stock($insu,$ca,$iddeposito_det,2,'-',$idventa,$ahora);
									// costo unitario promedio de los insumos utilizados
									$costo_insumo_unitario=round($costo_insumo_utilizado/$ca,4);
									// costo del insumo actual utilizado
									$costo_acum_insu[$insu]=$costo_insumo_utilizado;
									// costo acumulado de todos los insumos
									$costo_acumulado+=$costo_insumo_utilizado;
								}else{
									$costo_insumo_utilizado=0;
									//$costo_acum_insu[$insu]=$costo_insumo_utilizado;
									$costo_insumo_unitario=0;
									$costo_acumulado=0;	
								}
								if(is_nan($costo_insumo_unitario)){
									$costo_insumo_unitario=0;    
								}
								if(is_nan($costo_insumo_utilizado)){
									$costo_insumo_utilizado=0;    
								}
								//------------VENTA RECETA
								$insertar="Insert into venta_receta
								(idventa,idventadet,idprod,idingrediente,idinsumo,cantidad,idmedida,costo,fechahora)
								values
								($idventa,$mi,'$pp',$in,$insu,$ca,$med,$costo_insumo_utilizado,'$ahora')";
								$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
								
								$rsrecu->MoveNext();
							}
							
							
						}
						
					$rsgrupos->MoveNext(); }
				
				}
				// si es combinado extendido (logica parecida a combo)
				if($idtipoproducto == 4){
					
					$whereadd_depo_combi="";
					// si el descuento stock es producto sucursal
					if($idtipodesc_depo == 2){
						$whereadd_depo_combi="
						,(select iddeposito from producto_deposito where idsucursal = $idsucursal and idproducto = tmp_combinado_listas.idproducto_partes ) as iddeposito_det
						";
					}
					// si el descuento stock es producto terminal
					if($idtipodesc_depo == 3){
						$idterminal_pc=intval($idterminal_pc);
						$whereadd_depo_combi="
						,(select iddeposito from producto_deposito_terminal where idterminal = $idterminal_pc and idproducto = tmp_combinado_listas.idproducto_partes ) as iddeposito_det
						";
					}
					
					// busca los productos que componen el combinado
					$consulta="
					select * 
					$whereadd_depo_combi
					from tmp_combinado_listas
					where
					tmp_combinado_listas.idventatmp = $idventatmp 
					and tmp_combinado_listas.idsucursal = $idsucursal
					";
					$rsgrupos=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$totalmitades_ex=intval($rsgrupos->recordCount());
					
					// recorre cada producto
					while (!$rsgrupos->EOF){ 
					
						$idproducto_partes=$rsgrupos->fields['idproducto_partes'];
						$idprod_combo=$idproducto_partes;
						$iddeposito_det=intval($rsgrupos->fields['iddeposito_det']);
						if($iddeposito_det == 0){
							$iddeposito_det=$iddeposito;
						}
						
						//Paso 1): Traer la receta del producto
						$buscar="Select * from recetas where idproducto='$idproducto_partes' ";
						$rsre=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						$idreceta=intval($rsre->fields['idreceta']);
						
						// si tiene receta
						if ($idreceta > 0){
							
							//Lista de componenentes de la receta
							$buscar="Select idreceta,idprod,ingrediente,cantidad,insumos_lista.idinsumo,costo,idmedida,tipoiva,
							insumos_lista.mueve_stock as mueve_stock_ins
							 from recetas_detalles 
							 inner join ingredientes on ingredientes.idingrediente=recetas_detalles.ingrediente
							 inner join insumos_lista on insumos_lista.idinsumo=ingredientes.idinsumo
							 where 
							 recetas_detalles.idprod=$idproducto_partes
							 and recetas_detalles.idreceta=$idreceta


							 and ingredientes.idingrediente not in (
																	select tmp_ventares_sacado.idingrediente 
																	from tmp_ventares_sacado
																	where
																	tmp_ventares_sacado.idventatmp = $idventatmp
																	and tmp_ventares_sacado.idproducto = $idproducto_partes
																	)
							 ";
							$rsrecu=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
							
							//Mayor ID serial detallep producto
							$buscar="Select  max(idventadet) as mayor from ventas_detalles where idventa=$idventa and idprod='$idproducto_partes'";
							$rsmayorid=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						   
							$mi=intval($rsmayorid->fields['mayor']);
							while (!$rsrecu->EOF){
								
								
								$ir=intval($rsrecu->fields['idreceta']);
								$in=intval($rsrecu->fields['ingrediente']);
								$pp=intval($rsrecu->fields['idprod']);
								$insu=intval($rsrecu->fields['idinsumo']);
								$ca=floatval($rsrecu->fields['cantidad']/$totalmitades_ex);
								$co=floatval($rsrecu->fields['costo']);
								$med=intval($rsrecu->fields['idmedida']);
								$va=intval($rsrecu->fields['tipoiva']);
								$mueve_stock_ins=trim($rsrecu->fields['mueve_stock_ins']);
								
								// descuenta stock general
								if($mueve_stock != 'N' && $mueve_stock_ins != 'N'){
									descontar_stock_general($insu,$ca,$iddeposito_det);
									$costo_insumo_utilizado=descuenta_stock_vent($insu,$ca,$iddeposito_det);
									movimientos_stock($insu,$ca,$iddeposito_det,2,'-',$idventa,$ahora);
									// costo unitario promedio de los insumos utilizados
									$costo_insumo_unitario=round($costo_insumo_utilizado/$ca,4);
									// costo del insumo actual utilizado
									$costo_acum_insu[$insu]=$costo_insumo_utilizado;
									// costo acumulado de todos los insumos
									$costo_acumulado+=$costo_insumo_utilizado;
								}else{
									$costo_insumo_utilizado=0;
									//$costo_acum_insu[$insu]=$costo_insumo_utilizado;
									$costo_insumo_unitario=0;
									$costo_acumulado=0;	
								}
								if(is_nan($costo_insumo_unitario)){
									$costo_insumo_unitario=0;    
								}
								if(is_nan($costo_insumo_utilizado)){
									$costo_insumo_utilizado=0;    
								}
								//------------VENTA RECETA
								$insertar="Insert into venta_receta
								(idventa,idventadet,idprod,idingrediente,idinsumo,cantidad,idmedida,costo,fechahora)
								values
								($idventa,$idventadet,'$pp',$in,$insu,$ca,$med,$costo_insumo_utilizado,'$ahora')";
								$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
								
								$rsrecu->MoveNext();
							}
							
							
						}
						
					$rsgrupos->MoveNext(); }
					

				}

				
				//Sumar todos los costos de venta receta y updatear el costo global en detalles de la venta y utilidad
				
				$consulta="
				update  venta_receta 
				set 
				costo_unitario = costo/cantidad
				where
				idventadet = $idventadet
				and idventa = $idventa
				and cantidad > 0
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$consulta="
				update ventas_detalles 
				set 
				subtotal_costo = COALESCE((
								select sum(costo) 
								from venta_receta 
								where 
								idventadet = ventas_detalles.idventadet
								),0)
				WHERE
				idventadet = $idventadet
				and idventa = $idventa
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$consulta="
				update ventas_detalles 
				set 
				costo = COALESCE(subtotal_costo/cantidad,0)
				WHERE
				idventadet = $idventadet
				and idventa = $idventa
				and cantidad > 0
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				$consulta="
				update ventas_detalles 
				set 
				utilidad = subtotal-subtotal_costo
				WHERE
				idventadet = $idventadet
				and idventa = $idventa
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				
				$rsdet->MoveNext();
			}
			
			// prorratear descuento
			/*if($facturador_electronico == 'S'){
				if($descuento_sobre_factura > 0 && $idproducto_descuento > 0){
					$descuento_negativo=$descuento_sobre_factura*-1;
					//echo $descuento_negativo.'a';exit;
					//$year_det_f=date("Y");
					// insertar 1 registro en ventas detalles
					$consulta="
					INSERT INTO ventas_detalles
					(
					pventa, cantidad, subtotal, idventa, idemp, sucursal, idprod, pchar, 
					retirado_por, costo, subtotal_costo, utilidad, idtipoiva, iva, base_imponible,
					registrado_el, descuento, subtotal_sindesc, descuento_porc, subtotal_monto_iva,
					idprod_mitad1, idprod_mitad2, existencia, serialcostos,
					subtotal_monto_iva_excluido_diplomatico, iva_excluido_diplomatico,
					subtotal_anterior_diplomatico, pventa_anterior_diplomatico,
					pventa_monto_iva_anterior, cortesia, rechazo, idmotivorecha,
					idventatmp
					)	    
					VALUES 
					(
					$descuento_negativo, 1, $descuento_negativo, $idventa, 1, $idsucursal, $idproducto_descuento, NULL,
					NULL, 0, 0, $descuento_negativo, 0, 0, 0,
					'$ahora', 0, $descuento_negativo, 0, 0,
					NULL, NULL, 0, 0,
					0, NULL,
					0, 0,
					0, NULL, NULL, NULL,
					NULL
					)
					";
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

					$consulta="
					select idventadet from ventas_detalles where idventa = $idventa order by idventadet desc limit 1 
					";
					$rsvdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
					$idventadet=$rsvdet->fields['idventadet'];

					$parametros_array=array(
						'idventa' => $idventa,
						'descuento' => $descuento_sobre_factura,

					);
					$res=prorratear_descuento_impuesto($parametros_array);
					//print_r($res);exit;
					// insertar en ventas detalles impuesto

					foreach($res as $key => $value){
						$iva_porc=$key;

						$monto_iva=$value['monto_iva'];
						$monto_col=$value['monto_columna'];
						$gravadoml=$monto_col-$monto_iva;
						if($iva_porc == 0){
							$exento='S';
						}else{
							$exento='N';	
						}
						if(floatval($monto_col) <> 0){
							$consulta="
							INSERT INTO ventas_detalles_impuesto
							(idventadet, idventa, idproducto, idtipoiva, iva_porc_col, monto_col, gravadoml,
							 ivaml, exento) 
							VALUES 
							($idventadet, $idventa, $idproducto_descuento, 4, $iva_porc, $monto_col, $gravadoml,
							 $monto_iva,  '$exento')
							";
							//echo $consulta;exit;
							$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
						}

					}

				} /// if($descuento > 0 && $idproducto_descuento > 0){
			}*/ // if($facturador_electronico == 'S'){
	
	} //de continuar=1		
			
	// prorratear descuento
	if($facturador_electronico != 'S'){
		if($descuento_sobre_factura > 0 && $idproducto_descuento > 0){
			$descuento_negativo=$descuento_sobre_factura*-1;
			//$year_det_f=date("Y");
			$texto_descuento="NULL";
			if(trim($pchar_descuento) != ''){
				$texto_descuento=trim($pchar_descuento);
			}

			// insertar 1 registro en ventas detalles
			$consulta="
			INSERT INTO ventas_detalles
			(
			pventa, cantidad, subtotal, idventa, idemp, sucursal, idprod, pchar, 
			retirado_por, costo, subtotal_costo, utilidad, idtipoiva, iva, base_imponible,
			registrado_el, descuento, subtotal_sindesc, descuento_porc, subtotal_monto_iva,
			idprod_mitad1, idprod_mitad2, existencia, serialcostos,
			subtotal_monto_iva_excluido_diplomatico, iva_excluido_diplomatico,
			subtotal_anterior_diplomatico, pventa_anterior_diplomatico,
			pventa_monto_iva_anterior, cortesia, rechazo, idmotivorecha,
			idventatmp
			)	    
			VALUES 
			(
			$descuento_negativo, 1, $descuento_negativo, $idventa, 1, $idsucursal, $idproducto_descuento, $texto_descuento,
			NULL, 0, 0, $descuento_negativo, 0, 0, 0,
			'$ahora', 0, $descuento_negativo, 0, 0,
			NULL, NULL, 0, 0,
			0, NULL,
			0, 0,
			0, NULL, NULL, NULL,
			NULL
			)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

			$consulta="
			select idventadet from ventas_detalles where idventa = $idventa order by idventadet desc limit 1 
			";
			$rsvdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idventadet=$rsvdet->fields['idventadet'];

			$parametros_array=array(
				'idventa' => $idventa,
				'descuento' => $descuento_sobre_factura,

			);
			$res=prorratear_descuento_impuesto($parametros_array);
			//print_r($res);exit;
			// insertar en ventas detalles impuesto

			foreach($res as $key => $value){
				$iva_porc=$key;

				$monto_iva=$value['monto_iva'];
				$monto_col=$value['monto_columna'];
				$gravadoml=$monto_col-$monto_iva;
				if($iva_porc == 0){
					$exento='S';
				}else{
					$exento='N';	
				}
				if(floatval($monto_col) <> 0){
					$consulta="
					INSERT INTO ventas_detalles_impuesto
					(idventadet, idventa, idproducto, idtipoiva, iva_porc_col, monto_col, gravadoml,
					 ivaml, exento) 
					VALUES 
					($idventadet, $idventa, $idproducto_descuento, 4, $iva_porc, $monto_col, $gravadoml,
					 $monto_iva,  '$exento')
					";
					//echo $consulta;exit;
					$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				}

			}

		} /// if($descuento > 0 && $idproducto_descuento > 0){
	} // if($facturador_electronico != 'S'){	
}
		//-----------------------FACTURA MULTIPLE--------------------------------//
		if ($tipofactura=='M'){
			//Registrar la venta multiple
			$pr=1;
			
			
		} else {
				$pr=0;
		}
		// updates para factura
		$consulta="
		UPDATE `ventas_detalles` set subtotal_monto_iva=(subtotal-((subtotal)/(1+iva/100))) where idventa = $idventa;
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		
		/*$consulta="
		update ventas_detalles set subtotal_sindesc = subtotal-descuento where idventa = $idventa;
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 
		$consulta="
		update ventas_detalles set descuento_porc = ((descuento/subtotal)*100) where subtotal > 0 and descuento > 0 and idventa = $idventa;
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));*/
		
		
		$consulta="
		update ventas_detalles set subtotal_sindesc = subtotal+descuento where idventa = $idventa;
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta)); 
		$consulta="
		update ventas_detalles set descuento_porc = ((descuento/subtotal_sindesc)*100) where idventa = $idventa and descuento > 0 and subtotal_sindesc > 0;
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		
		// verifica que tenga razon social
		$consulta="select razon_social from ventas where idventa = $idventa;";
		$rsrz=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// si no tiene asigna
		if(trim($rsrz->fields['razon_social']) == ''){
			$consulta="
			update ventas set 
			razon_social = (select cliente.razon_social from cliente where cliente.idcliente = ventas.idcliente limit 1) 
			where 
			idventa = $idventa;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}




		
    //Aca se cambia por valores positivos, ya que el total de la venta debe ser neta sin el descuento, el total a cobrar si debe ser con el descuento, almacenado en la columna descneto)
	$consulta="
	update ventas set total_venta = coalesce((select sum(subtotal) from ventas_detalles where idventa = ventas.idventa and subtotal > 0 ),0) WHERE idventa = $idventa
	";
	//$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	//Si el articulo descuento ya existe en ventas_detalles generado con el valor negativo a descontarse por desc en FACTURAS, NO SE PUEDE VOLVER A DESCONTARLE EL DESCUENTO EN LA CABECERA
	$buscar="Select count(*) as total from ventas_detalles where subtotal < 0 and idventa=$idventa";
	$rsc=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	if(floatval($rsc->fields['total'])==0){
		//Solo si no hay articulo descuento en el cuerpo
		$consulta="
		update ventas set totalcobrar = COALESCE(total_venta,0)-COALESCE(descneto,0), total_cobrado=COALESCE(total_venta,0)-COALESCE(descneto,0) where idventa = $idventa
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	}
	
	
	//	total_venta=COALESCE((select sum(subtotal) from ventas_detalles inner join productos on productos.idprod_serial = ventas_detalles.idprod   where ventas_detalles.idventa = ventas.idventa and productos.idtipoproducto <> 8 ),0)
	$consulta="
	update ventas set 
	monto_iva = 
	COALESCE(( select sum(subtotal_monto_iva) from ventas_detalles where ventas_detalles.idventa = ventas.idventa ),0),
	totalcobrar=COALESCE((select sum(subtotal) from ventas_detalles  where ventas_detalles.idventa = ventas.idventa ),0),
	total_cobrado=COALESCE((select sum(subtotal) from ventas_detalles  where ventas_detalles.idventa = ventas.idventa ),0)
	where
	idventa = $idventa;
	;
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

			
	$consulta="
	select tipo_venta, idadherente, idserviciocom  from  ventas where idventa = $idventa
	";
	$rscta=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$tipo_venta=intval($rscta->fields['tipo_venta']);
	$idadherente=intval($rscta->fields['idadherente']);
	$idserviciocom=intval($rscta->fields['idserviciocom']);
	// se pone aca al final despues de toddos los calculos de descuento cuando ya esta todo bien
	if ($tipo_venta==2){
		$idcta=crear_cuenta_credito($idventa,$idadherente,$idserviciocom);
	}
	// busca la cuenta a credito
	/*$consulta="
	select idcta from  cuentas_clientes where idventa = $idventa
	";
	$rscta=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idcta=intval($rscta->fields['idcta']);
	// si hay
	if($idcta > 0){
		// actualiza montos en base a ventas
		$consulta="
		update cuentas_clientes 
		set 
		deuda_global = COALESCE((select (totalcobrar) from ventas where idventa = cuentas_clientes.idventa),0),
		saldo_activo = COALESCE((select (totalcobrar) from ventas where idventa = cuentas_clientes.idventa),0)
		 where 
		 idcta = $idcta
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// actualiza detalle
		$consulta="
		update cuentas_clientes_det
		set 
		monto_cuota = COALESCE((select (deuda_global) from cuentas_clientes where idcta = cuentas_clientes_det.idcta),0),
		saldo_cuota = COALESCE((select (deuda_global) from cuentas_clientes where idcta = cuentas_clientes_det.idcta),0)
		 where 
		 idcta = $idcta
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	}*/
																										
																									   
		
					
   
																	
	//Registramos los pagaos de la venta
	if ($crearcuenta<>1 && $totalvendido > 0){
		$idpago=registrar_pagos($idventa,$tipofactura);		
	}
	
	// busca si es pago mixto
	$consulta="select count(*) as total from gest_pagos where gest_pagos.estado <> 6 and idventa = $idventa";
	$rsmixto=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if($rsmixto->fields['total'] > 1){
	   $consulta="
        update ventas 
        set 
        ventas.formapago = 3
        WHERE 
        idventa = $idventa
        ";
        $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	}else{
        $consulta="
        update ventas 
        set 
        ventas.formapago = COALESCE((select medio_pago from gest_pagos where idventa = ventas.idventa and estado <> 6 order by idpago asc limit 1),0)
        WHERE 
        idventa = $idventa
        ";
        $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	}
	
	// corrige diferencias en pagos si hay
	$consulta="
	INSERT INTO `gest_pagos`
	(
	  `idcaja`, `idtipocajamov`, `tipomovdinero`, `idcliente`, `fecha`, `medio_pago`, `total_cobrado`, `chequenum`, `banco`, `factura`,
	 `recibo`, `tickete`, `estado`, `ruc`, `tipo_pago`, `idempresa`, `sucursal`, `efectivo`, `codtransfer`, `montotransfer`, `montocheque`, 
	 `cajero`, `fechareal`, `idventa`, `anulado_el`, `anulado_por`, `montovale`, `idpedido`, `idmesa`, `montotarjeta`, `idnotacred`,
	 `monto_notacred`, `numtarjeta`, `tipotarjeta`, `vueltogs`, `delivery`, `rendido`, `fec_rendido`, `obs`, `reimpresofc`, 
	 `idcuentaclientepagcab`
	)

	select idcaja, 1, 'E', ventas.idcliente, ventas.fecha, ventas.formapago, ventas.totalcobrar, NULL, NULL, ventas.factura, 
	NULL, NULL, ventas.estado, ventas.ruc, 1, 1, ventas.sucursal, 0,0,0,0,
	ventas.registrado_por, fecha, idventa,  NULL,  NULL, 0, ventas.idpedido, ventas.idmesa, 0, NULL,
	0,0,1,0, 0, 'S', ventas.fecha,  NULL,  NULL,
	 NULL
	from ventas 
	where estado <> 6 
	and tipo_venta = 1 
	and idventa not in (select idventa from gest_pagos where estado <> 6 and idventa is not null)
	and totalcobrar > 0
	and idventa = $idventa
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	INSERT INTO `gest_pagos_det`
	(`idpago`, `monto_pago_det`, `idformapago`) 
	select idpago, gest_pagos.total_cobrado, gest_pagos.medio_pago
	from gest_pagos 
	where 
	estado <> 6 
	and idpago not in (select idpago from  gest_pagos_det where idpago is not null)
	and gest_pagos.idventa = $idventa;
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$consulta="
	update gest_pagos_det set idformapago = 1 where idformapago = 0;
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// si es consumo no afecta caja
	if($idtipotran == 2){
		// los consumos no afectan  caja
		$consulta="
		update gest_pagos set estado = 6 where idventa = $idventa
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		//echo "entro";
	}
	
//Facturacion de Anticipos vinculacion con eventos
	//Consultamos si se aplico un descuento de una factura de anticipo de evento a la mesa.


	$buscar="Select idventa_anticipo from mesas_descuentos_facturas where idatc=$idatc and idventa_anticipo>0";
			$descuentosmesasanticipo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	        $idventaanticipo=floatval($descuentosmesasanticipo->fields['idventa_anticipo']);

		//Actualizamos los datos del evento en caso que se haya aplicado una factura como descuento
		if($idventaanticipo>0){

			//Obtenemos el total de la venta para poder aplicar al evento
			$buscar="Select total_venta  from ventas where idventa=$idventa";
			$rsven1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$totalventa=intval($rsven1->fields['total_venta']);

			//Obtenemos el idevento de la factura inicial.
			$buscar="Select idevento  from ventas_pedidos_eventos where idventa=$idventaanticipo";
			$rsven1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
			$ideventoaprincipal=intval($rsven1->fields['idevento']);
			

			$consulta="
			INSERT INTO 
			ventas_pedidos_eventos
			(idevento, idventa, monto_aplicado) 
			Values($ideventoaprincipal, $idventa, $totalventa);
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
            //asignamos la bandera para que no se pueda traer nuevamente esa factura para poder aplicar
            $buscar="update ventas set aplicado_anticip_fac = 1,idatc_anticip_fac =$idventa  where idventa=$idventaanticipo";
			$rsven1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
            //Actualizamos el evento con el monto de lo consumido en Mesas
            $buscar="update pedidos_eventos set monto_consumo = $totalventa,fecha_cierre =Now()  where regid=$ideventoaprincipal";
			$rsven1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
            

		}
	
	
	//Marcamos los pedidos

	marcarpedidos($idventa,$tipofactura,$pr,$idatcdet);


}
function registrar_pagos($idventa,$tipofactura){
	global $conexion;
	$ahora=date("Y-m-d H:i:s");
	global $idusu;
	$buscar="Select * from ventas where idventa=$idventa";
	$rsv=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$vendedor=intval($rsv->fields['registrado_por']);
	$idcliente=intval($rsv->fields['idcliente']);
	$factura=antisqlinyeccion($rsv->fields['factura'],'text');
	$recibo=antisqlinyeccion($rsv->fields['recibo'],'text');
	$ruc=trim($rsv->fields['ruc']);
	$idatc=intval($rsv->fields['idatc']);
	$idatcdet=intval($rsv->fields['idatcdet']);
	$idcaja=intval($rsv->fields['idcaja']);
	$idmesa=intval($rsv->fields['idmesa']);
	$idempresa=intval($rsv->fields['idempresa']);
	$idsucursal=intval($rsv->fields['idsucursal']);
	$totalcobrar=intval($rsv->fields['totalcobrar']);
	$idventa=intval($rsv->fields['idventa']);
	$tipoventa=1;
	
	$whereadd_pag='';
	if($idatcdet > 0){
		$whereadd_pag.=" and mesas_cobros_deta.idatcdet = $idatcdet ";
	}
	
	$buscar="
	Select * 
	from mesas_cobros_deta 
	where 
	idatc=$idatc 
	and estadopago=1 
	$whereadd_pag 
	" ;
	$rsmeco=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tpagos=$rsmeco->RecordCount();
	$tipotarjeta=0;
	$tefectivo=0;
	$tdebito=0;
	$tcredito=0;
	$transfer=0;
	
	// si no se registro el cobro
	if(intval($rsmeco->fields['idatc']) == 0){
		// registra como efectivo
		$consulta="
		INSERT INTO mesas_cobros_deta
		(idformapago, montoabonado, vueltogs, estadopago, idcliente, idatc, idatcdet,
		registrado_el, registrado_por, anulado_el, anulado_por, idventa) 
		VALUES
		(1, $totalcobrar, 0, 1, $idcliente, $idatc, $idatcdet,
		'$ahora', $idusu, NULL, NULL, $idventa)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// vuelve a consultar la tabla
		$rsmeco=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	}

	
	while (!$rsmeco->EOF){
		
		$mediopago=intval($rsmeco->fields['idformapago']);
		
		if ($mediopago==1){
			$tefectivo=$tefectivo+floatval($rsmeco->fields['montoabonado']);
			$tipotarjeta=0;
		}
		
		if ($mediopago==2){
			$tcredito=$tcredito+floatval($rsmeco->fields['montoabonado']);
			$tipotarjeta=1;
		}
		if ($mediopago==3){
			//$tcredito=$tcredito+floatval($rsmeco->fields['montoabonado']);
		}
		if ($mediopago==4){
			$tipotarjeta=2;
			$tdebito=$tdebito+floatval($rsmeco->fields['montoabonado']);
		}
		/*if ($mediopago==5){
			$cheque=$transfer+floatval($rsmeco->fields['montoabonado']);
			$tipotarjeta=0;
		}*/
		if ($mediopago==6){
			$transfer=$transfer+floatval($rsmeco->fields['montoabonado']);
			$tipotarjeta=0;
		}

		$rsmeco->MoveNext();
		
	}
	$vuelto=0;
	$delivery_costo=0;
	$pedido=0;
	//$totalcobrar=$transfer+$tdebito+$tcredito+$tefectivo;
	$numcheque=0;
	$montocheque=0;
	$banco=0;$numtarjeta=0;$tarjeta=0;$numerotrans=0;
	$totaltarjeta=floatval($tdebito)+floatval($tcredito);
	if($tpagos>1){
		$mediopago=3;
	}
	



	// busca si tiene anticipos
	$consulta="
	select sum(mesas_cobros_deta.montoabonado) as total_anticip, formas_pago.anticipo
	from mesas_cobros_deta
	inner join formas_pago on formas_pago.idforma = mesas_cobros_deta.idformapago
	where
	idatc=$idatc 
	$whereadd_pag
	and estadopago=1
	and mesas_cobros_deta.montoabonado > 0
	and formas_pago.anticipo = 'S'
	and idpago_afavor is not null
	limit 1
	";
	$rsanticip=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
	$anticipo_ex=$rsanticip->fields['anticipo'];
	$total_anticip=floatval($rsanticip->fields['total_anticip']);
	$totalcobrar_pag=floatval($totalcobrar-$total_anticip);
	
	if($totalcobrar_pag > 0){

		$insertar="
		Insert into gest_pagos
		(idventa,idcliente,fecha,medio_pago,total_cobrado,chequenum,banco,numtarjeta,
		factura,recibo,tickete,ruc,tipo_pago,idempresa,sucursal,efectivo,codtransfer,montotransfer,
		montocheque,cajero,vueltogs,idpedido,delivery,idmesa,idcaja,tipotarjeta,montotarjeta,rendido,
		idtipocajamov,tipomovdinero )
		values
		($idventa,$idcliente,'$ahora',$mediopago,$totalcobrar_pag,$numcheque,$banco,$numtarjeta,
		$factura,$recibo,'','$ruc',$tipoventa,$idempresa,$idsucursal,$tefectivo,
		$numerotrans,$transfer,
		$montocheque,$vendedor,$vuelto,$pedido,$delivery_costo,$idmesa,$idcaja,$tipotarjeta,$totaltarjeta,'S',
		1,'E' )
		";
		$conexion->Execute($insertar) or die (errorpg($conexion,$insertar));
		
			
		$buscar="Select * from gest_pagos where idventa=$idventa order by idpago desc limit 1";
		$rsp=$conexion->Execute($buscar) or die (errorpg($conexion,$buscar));
		$idpago=intval($rsp->fields['idpago']);
		/* rellenar masivo pero sin vincular a gest_pagos solo para registros muy viejos ffunciona
		INSERT INTO `ventas_reg_adicionales`
		(`idventa`, `monto_abonado`, `valor_adicional`, `registrado_el`, `registrado_por`, `anulado_el`, `anulado_por`,  `estado`, idcobser) 
		select 
		mesas_cobros_deta.idventa, mesas_cobros_deta.montoabonado, mesas_cobros_deta.otros_valores, mesas_cobros_deta.registrado_el, mesas_cobros_deta.registrado_por, NULL, NULL, 1, idcobser
		from mesas_cobros_deta
		where 
		mesas_cobros_deta.estadopago <> 6
		and mesas_cobros_deta.idcobser not in (select idcobser from ventas_reg_adicionales where idcobser is not null)
		and mesas_cobros_deta.otros_valores is not null;
		
		UPDATE ventas_reg_adicionales
		SET ventas_reg_adicionales.idpagodet = (
			SELECT gest_pagos_det.idpagodet
			FROM mesas_cobros_deta
			INNER JOIN gest_pagos_det 
				ON gest_pagos_det.idcobser = mesas_cobros_deta.idcobser
			WHERE mesas_cobros_deta.idcobser = ventas_reg_adicionales.idcobser
		)
		WHERE ventas_reg_adicionales.idpagodet IS NULL
		AND EXISTS (
			SELECT 1
			FROM mesas_cobros_deta
			INNER JOIN gest_pagos_det 
				ON gest_pagos_det.idcobser = mesas_cobros_deta.idcobser
			WHERE mesas_cobros_deta.idcobser = ventas_reg_adicionales.idcobser
		);
		*/

		$consulta="
		select mesas_cobros_deta.*, formas_pago.idformapago_set, formas_pago.anticipo
		from mesas_cobros_deta
		inner join formas_pago on formas_pago.idforma = mesas_cobros_deta.idformapago
		where
		idatc=$idatc 
		and estadopago=1
		and mesas_cobros_deta.montoabonado > 0
		and formas_pago.anticipo = 'N'
		and idpago_afavor is null
		$whereadd_pag
		order by idcobser asc
		";
		$rscarcobven=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
		while(!$rscarcobven->EOF){
			$monto_pago_det=$rscarcobven->fields['montoabonado'];
			$idformapago=$rscarcobven->fields['idformapago'];
			$anticipo=$rscarcobven->fields['anticipo'];
			$idcobser=$rscarcobven->fields['idcobser'];
			$otros_valores=antisqlinyeccion($rscarcobven->fields['otros_valores'],"text");
			$consulta="
			INSERT INTO gest_pagos_det
			(idpago, monto_pago_det, idformapago, idcobser) 
			values
			($idpago,$monto_pago_det,$idformapago, $idcobser)
			";
			$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			//obtiene ultimo id insertado
			$consulta="
			select idpagodet 
			from gest_pagos_det 
			where 
			idpago = $idpago 
			order by idpagodet desc
			limit 1
			";
			$rspagdetmax=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idpagodet=intval($rspagdetmax->fields['idpagodet']);
			// forma pago set tarjeta credito y debito
			if($rscarcobven->fields['idformapago_set'] == 3 or $rscarcobven->fields['idformapago_set'] == 4){
				$iddenominaciontarjeta=intval($rscarcobven->fields['iddenominaciontarjeta']);
				$consulta=" 
				insert into gest_pagos_det_datos
				(idpagodet,id_denominacion_tarjeta)
				values
				($idpagodet,$iddenominaciontarjeta)
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			}
			// cheque
			if($rscarcobven->fields['idformapago_set'] == 2){
				// numero cheque y banco
				$idbanco=intval($rscarcobven->fields['idbanco']);
				$numcheque=antisqlinyeccion(agregacero(substr($rscarcobven->fields['cheque_numero'],0,8),8),"text");
				$consulta=" 
				insert into gest_pagos_det_datos
				(idpagodet,idbanco,cheque_numero,id_denominacion_tarjeta)
				values
				($idpagodet,$idbanco,$numcheque,NULL)
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

			}
			// vouchers
			if(trim($rscarcobven->fields['otros_valores']) != ''){
				$consulta="
				INSERT INTO `ventas_reg_adicionales`
				(`idventa`, `monto_abonado`, `valor_adicional`, `registrado_el`, `registrado_por`, `anulado_el`, `anulado_por`,  `estado`, idcobser, idpagodet) 
				VALUES
				($idventa, $monto_pago_det, $otros_valores, '$ahora', $idusu, NULL, NULL, 1, $idcobser, $idpagodet)
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			}
		$rscarcobven->MoveNext(); }
		
		$consulta="
		update gest_pagos 
		set 
		efectivo = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 1),0),
		montotarjeta = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and (gest_pagos_det.idformapago = 2 or idformapago = 4)),0),
		montotransfer = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 6),0),
		montocheque = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 5),0)
		where
		idpago = $idpago
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
	} // if($totalcobrar_pag > 0){
	
	// si tiene anticipo
	if($anticipo_ex == 'S'){
		

		$insertar="
		Insert into gest_pagos
		(idventa,idcliente,fecha,medio_pago,total_cobrado,chequenum,banco,numtarjeta,
		factura,recibo,tickete,ruc,tipo_pago,idempresa,sucursal,efectivo,codtransfer,montotransfer,
		montocheque,cajero,vueltogs,idpedido,delivery,idmesa,idcaja,tipotarjeta,montotarjeta,rendido,
		idtipocajamov,tipomovdinero )
		values
		($idventa,$idcliente,'$ahora',$mediopago,$total_anticip,$numcheque,$banco,$numtarjeta,
		$factura,$recibo,'','$ruc',$tipoventa,$idempresa,$idsucursal,$tefectivo,
		$numerotrans,$transfer,
		$montocheque,$vendedor,$vuelto,$pedido,$delivery_costo,$idmesa,$idcaja,$tipotarjeta,$totaltarjeta,'S',
		1,'N' )
		";
		$conexion->Execute($insertar) or die (errorpg($conexion,$insertar));
		
			
		$buscar="Select * from gest_pagos where idventa=$idventa order by idpago desc limit 1";
		$rsp=$conexion->Execute($buscar) or die (errorpg($conexion,$buscar));
		$idpago=intval($rsp->fields['idpago']);

		$consulta="
		select mesas_cobros_deta.*, formas_pago.idformapago_set, formas_pago.anticipo
		from mesas_cobros_deta
		inner join formas_pago on formas_pago.idforma = mesas_cobros_deta.idformapago
		where
		idatc=$idatc 
		$whereadd_pag
		and estadopago=1
		and mesas_cobros_deta.montoabonado > 0
		and formas_pago.anticipo = 'S'
		and idpago_afavor is not null
		order by idcobser asc
		";
		$rscarcobven=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
		while(!$rscarcobven->EOF){
			$monto_pago_det=$rscarcobven->fields['montoabonado'];
			$idformapago=$rscarcobven->fields['idformapago'];
			$anticipo=$rscarcobven->fields['anticipo'];
			$consulta="
			INSERT INTO gest_pagos_det
			(idpago, monto_pago_det, idformapago) 
			values
			($idpago,$monto_pago_det,$idformapago)
			";
			$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));
			//obtiene ultimo id insertado
			$consulta="
			select idpagodet 
			from gest_pagos_det 
			where 
			idpago = $idpago 
			order by idpagodet desc
			limit 1
			";
			$rspagdetmax=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idpagodet=intval($rspagdetmax->fields['idpagodet']);
			if($anticipo == 'S'){
				$idpago_afavor=intval($rscarcobven->fields['idpago_afavor']);
				$consulta=" 
				insert into gest_pagos_det_datos
				(idpagodet,idpago_afavor)
				values
				($idpagodet,$idpago_afavor)
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			}
			$idpago_afavor_csv.=$idpago_afavor.',';
			
		$rscarcobven->MoveNext(); }
		
		$idpago_afavor_csv=substr($idpago_afavor_csv,0,-1);
		

		
		$consulta="
		update gest_pagos 
		set 
		efectivo = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 1),0),
		montotarjeta = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and (gest_pagos_det.idformapago = 2 or idformapago = 4)),0),
		montotransfer = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 6),0),
		montocheque = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 5),0)
		where
		idpago = $idpago
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// actualizar saldos de anticipo
		$idpago_afavor_ar=explode(',',$idpago_afavor_csv);
		foreach($idpago_afavor_ar as $idpago_afavor){
			
			$parametros_array=array(
				'idpago_afavor' => $idpago_afavor
			);
			actualiza_saldo_anticipo($parametros_array);
			
		}
		
	} // if($anticipo_ex == 'S'){
		
	// busca si hay propinas que afectan caja y  que no son facturados para no duplicar
	/*$consulta_propinas="
	select `idatc`, `monto_propina`, `registrado_por`, `registrado_el`, `propreg`, `mediopago`, `afecta_caja`
	from mesas_atc_propinas 
	where 
	afecta_caja = 'S' 
	and propreg not in (select propreg from mesas_cobros_deta where estadopago <> 6)
	and idatc = $idatc
	";
	$rsprop=$conexion->Execute($consulta_propinas) or die (errorpg($conexion,$consulta_propinas));
	// si hay propinas que deben afectar caja
	if(intval($rsprop->fields['idatc']) > 0){
	
		// montos globales para cabecera
		$consulta_tot="
		WITH consulta_propinas_glob AS (
			$consulta_propinas
		)
		select sum(monto_propina) as total
		from consulta_propinas_glob
		";
		$rstotal=$conexion->Execute($consulta_tot) or die(errorpg($conexion,$consulta_tot));
		$total_monto_propina=$rstotal->fields['total'];
		
		// genera cabecera
		$insertar="
		Insert into gest_pagos
		(idventa,idcliente,fecha,medio_pago,total_cobrado,chequenum,banco,numtarjeta,
		factura,recibo,tickete,ruc,tipo_pago,idempresa,sucursal,efectivo,codtransfer,montotransfer,
		montocheque,cajero,vueltogs,idpedido,delivery,idmesa,idcaja,tipotarjeta,montotarjeta,rendido,
		idtipocajamov,tipomovdinero )
		values
		($idventa,NULL,'$ahora',$mediopago,$total_monto_propina,NULL,NULL,NULL,
		NULL,NULL,'','',0,1,$idsucursal,$total_monto_propina,
		0,0,
		0,0,0,0,0,$idmesa,$idcaja,1,0,'S',
		14,'E' )
		";
		$conexion->Execute($insertar) or die (errorpg($conexion,$insertar));
		// obtiene la cabecera insertada
		$buscar="Select * from gest_pagos where idventa=$idventa order by idpago desc limit 1";
		$rsp=$conexion->Execute($buscar) or die (errorpg($conexion,$buscar));
		$idpago=intval($rsp->fields['idpago']);
			
		// recorre detalle y registra en caja como tipo de movimiento propina
		while(!$rsprop->EOF){
			$mediopago=$rsprop->fields['mediopago'];
			$monto_propina=$rsprop->fields['monto_propina'];

		$rsprop->MoveNext(); }
		
		// actualiza cabecera con montos de detalle
		$consulta="
		update gest_pagos 
		set 
		efectivo = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 1),0),
		montotarjeta = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and (gest_pagos_det.idformapago = 2 or idformapago = 4)),0),
		montotransfer = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 6),0),
		montocheque = COALESCE((select sum(gest_pagos_det.monto_pago_det) from gest_pagos_det where idpago = gest_pagos.idpago and gest_pagos_det.idformapago = 5),0)
		where
		idpago = $idpago
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	} // if(intval($rsprop->fields['idatc']) > 0){
	*/
	$pr=0;
		
		

	
	return $idpago;
	// escribe en el log
//$file = fopen("log_funciones.txt", "a+");
//fwrite($file, $insertar);
//fclose($file);
	
}
function marcarpedidos($idventa,$tipofactura,$pr,$idatcdet=0){
		// escribe en el log
//$file = fopen("log_funciones.txt", "a+");
//fwrite($file, "Marcando pedidos");
//fclose($file);
	global $conexion;
	global $facturador_electronico;
	global $slot_firma;
	global $tipo_documento_set;
	global $obj_electro;
	global $ahora;
	
	
	$ahora=date("Y-m-d H:i:s");
	$buscar="Select * from ventas where idventa=$idventa";
	$rsv=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$vendedor=intval($rsv->fields['registrado_por']);
	$idusu=$vendedor;
	$idcliente=intval($rsv->fields['idcliente']);
	$idatc=intval($rsv->fields['idatc']);
	$idmesa=intval($rsv->fields['idmesa']);
	$idempresa=intval($rsv->fields['idempresa']);
	$idsucursal=intval($rsv->fields['sucursal']);
	$factura=trim($rsv->fields['factura']);
	$idtipotran=intval($rsv->fields['idtipotran']);
	if(trim($factura) != ''){
		$ticketofactura="FAC";
	}else{
		$ticketofactura="TK";
	}
	

	$whereadd_deu='';
	$whereadd_pag='';
	$whereadd_des='';
	$whereadd_pro='';
	$whereadd_ven='';
	$whereadd_detped='';
	if(intval($idatcdet) > 0){
		$whereadd_deu.=' and tmp_ventares.idatcdet = '.$idatcdet;
		$whereadd_pag.=' and mesas_cobros_deta.idatcdet = '.$idatcdet;
		$whereadd_des.=' and mesas_descuentos_facturas.idatcdet = '.$idatcdet;
		$whereadd_pro.=' and mesas_atc_propinas.idatcdet = '.$idatcdet;
		$whereadd_ven.=' and ventas.idatcdet = '.$idatcdet;
		$whereadd_detped=" and tmpventares.idatcdet = $idatcdet ";
	}
	
	if ($tipofactura=='S'){
		//$file = fopen("log_funciones.txt", "a+");
//fwrite($file, "factura simple");
//fclose($file);
		//Uso de la mesa y datos de grupo mesa
		$buscar="
		select 
		fecha_inicio-now() as raro,
		TIME_TO_SEC(TIMEDIFF(now(),fecha_inicio)) diferencia_segundos,
		(TIME_TO_SEC(TIMEDIFF(now(),fecha_inicio))/60) as dif_minutos,
		idgrupomesa 
		from mesas_atc 
		where 
		idatc=$idatc
		";
		$rscalculo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$tsegundos=intval($rscalculo->fields['diferencia_segundos']);
		$idgrupomesa=intval($rscalculo->fields['idgrupomesa']);

		$seg=$tsegundos;
		$d = floor($seg / 86400); 
		$h = floor(($seg - ($d * 86400)) / 3600); 
		$m = floor(($seg - ($d * 86400) - ($h * 3600)) / 60); 
		$s = $seg % 60;

		
		
		// verifica si ya se registro la ocupacion
		$consulta="
		select unseratcmesa from mesas_ocupacion where idatc = $idatc
		";
		$rsocu=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idocu=intval($rsocu->fields['unseratcmesa']);
		// si aun no se registro para este atc
		if($idocu  == 0){
			//Registramos la ocupacion de la mesa 
			$insertar="
			Insert into mesas_ocupacion 
			(idatc,horas,minutos,segundos,registrado_por,registrado_el) 
			values 
			($idatc,$h,$m,$s,$idusu,'$ahora')
			";
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
		}else{
			// actualizamos el tiempo de ocupacion
			$update="
			update mesas_ocupacion
			set
			horas=$h,
			minutos=$m,
			segundos=$s,
			registrado_por=$idusu,
			registrado_el='$ahora'
			where
			unseratcmesa = $idocu
			";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
		}
//$file = fopen("log_funciones.txt", "w+");
		//fwrite($file,  $update);
		//fclose($file);
		

		//Marcamos los detalles del cobro 
		$update="
		Update mesas_cobros_deta 
		set 
		idcliente=$idcliente,
		idventa=$idventa 
		where 
		idatc=$idatc
		$whereadd_pag
		";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		
		

		// si no  hay idatcdet  (subcuenta) cierra directo el atc
		if($idatcdet == 0){
			//Cerramos el ATC
			$update="Update mesas_atc set estado=3 where idatc=$idatc";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
		}else{
			// cierra el detalle
			$update="Update mesas_atc_det set estado=3 where idatcdet=$idatcdet";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
			
			// busca si queda pedidos no facturados (idventa null) y con idatcdet diferente al actual (abajo recien se marca con idventa)
			$consulta="
			select idventatmp 
			from tmp_ventares 
			where 
			tmp_ventares.idtmpventares_cab in (
				select tmp_ventares_cab.idtmpventares_cab 
				from tmp_ventares_cab 
				where 
				tmp_ventares_cab.idatc = $idatc
			)
			and idatcdet <> $idatcdet
			and idventa is null
			and borrado = 'N'
			limit 1
			";
			$rsdetquedan=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$idventatmp_detquedan=intval($rsdetquedan->fields['idventatmp']);
			// si ya no queda nada 
			if($idventatmp_detquedan == 0){
				//Cerramos el ATC
				$update="Update mesas_atc set estado=3 where idatc=$idatc";
				$conexion->Execute($update) or die(errorpg($conexion,$update));
			}
		}
		
		
		// busca si el atc ya se cerro completo o aun hay Productos
		$consulta="
		select idatc from mesas_atc where estado = 3 and idatc = $idatc
		";
		$rsatccierra=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idatc_cierra=intval($rsatccierra->fields['idatc']);
		$atc_cerrado='N';
		if($idatc_cierra > 0){
			$atc_cerrado='S';
		}
		
		// solo si se cerro el atc completo
		if($atc_cerrado == 'S'){
			$consulta="
			select rendir_mesa from mesas_preferencias limit 1
			";
			$rsprefmes=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$rendir_mesa=$rsprefmes->fields['rendir_mesa'];
			
			if($rendir_mesa == 'S'){
				// cambiar estado de mesa a 8 (Pendiente rendicion), solo si el atc ya esta cerrado
				$updatev="
				update mesas 
				set 
				estado_mesa=8
				where 
				idmesa=$idmesa 
				and idmesa in (select idmesa from mesas_atc where idatc = $idatc and estado = 3)
				";
				$conexion->Execute($updatev) or die(errorpg($conexion,$updatev));

			}else{
				// cambiar estado de mesa a libre, solo si el atc ya esta cerrado
				$updatev="
				update mesas 
				set 
				estado_mesa=1 
				where 
				idmesa=$idmesa 
				and idmesa in (select idmesa from mesas_atc where idatc = $idatc and estado = 3)
				";
				$conexion->Execute($updatev) or die(errorpg($conexion,$updatev));
			}
		
		

		

			//Si la mesa tiene un grupo, todas se marcan
			if ($idgrupomesa > 0){
				//hacer update de las mesas con el estado 1
				$update="Update mesas_atc_grupos_cab set estadogrupo=3 where idgrupomesa=$idgrupomesa";
				$conexion->Execute($update) or die(errorpg($conexion,$update));
				//Marcamos los componentes
				$update="Update mesas_atc_grupo_deta set estado=3 where idgrupomesa=$idgrupomesa";
				$conexion->Execute($update) or die(errorpg($conexion,$update));
				//liberar mesas del  grupo
				$buscar="Select * from  mesas_atc_grupo_deta where idgrupomesa=$idgrupomesa";
				$marcar=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				while (!$marcar->EOF){
					$idmlocal=$marcar->fields['idmesa'];
					$update="Update mesas set  estado_mesa=1,agrupado_con=NULL,idmozo_abrio=NULL where idmesa=$idmlocal";
					$conexion->Execute($update) or die(errorpg($conexion,$update));

					$marcar->MoveNext();
				}

			}
			//$file = fopen("log_funciones.txt", "w+");
			//fwrite($file,  "Clase impresion: ".$clasedoc);
			//fclose($file);
			/*
			delete FROM `mesas_atc_grupos_cab` where idatc not in  (select idatc from mesas_atc where mesas_atc.estado = 1);
			delete FROM `mesas_atc_grupo_deta` where idatc not in  (select idatc from mesas_atc where mesas_atc.estado = 1);
			update mesas set agrupado_con = NULL where mesas.idmesa not in (select mesas_atc.idmesa from mesas_atc where mesas_atc.estado = 1);
			*/
			
		
		
		
			// desagrupar mesas
			$idatc=intval($idatc);
			$consulta="
			update mesas 
			set 
			estado_mesa=1,
			agrupado_con=NULL,
			idmozo_abrio=NULL 
			where 
			mesas.idmesa in (select mesas_atc_grupo_deta.idmesa from mesas_atc_grupo_deta where idatc = $idatc);
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			//	echo $consulta;exit;
			$consulta="
			delete FROM `mesas_atc_grupos_cab` where idatc = $idatc;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$consulta="
			delete FROM `mesas_atc_grupo_deta` where idatc = $idatc;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$consulta="
			delete from tmp_mesitasele  where idatc = $idatc;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			
		
		} // if($atc_cerrado == 'S'){
		
		// busca si la venta  fue al contado y si tiene pagos registrados
		$consulta="
		select idventa 
		from ventas 
		where 
		ventas.tipo_venta = 1 
		and estado <> 6 
		and idventa not in (select idventa from gest_pagos where estado <> 6)
		and idtipotran = 1
		and idventa = $idventa
		";
		$rsval=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// si por algun motivo no tiene pagos
		if(intval($rsval->fields['idventa']) > 0){
			// corrige diferencias en pagos si hay
			$consulta="
			INSERT INTO `gest_pagos`
			(
			  `idcaja`, `idtipocajamov`, `tipomovdinero`, `idcliente`, `fecha`, `medio_pago`, `total_cobrado`, `chequenum`, `banco`, `factura`,
			 `recibo`, `tickete`, `estado`, `ruc`, `tipo_pago`, `idempresa`, `sucursal`, `efectivo`, `codtransfer`, `montotransfer`, `montocheque`, 
			 `cajero`, `fechareal`, `idventa`, `anulado_el`, `anulado_por`, `montovale`, `idpedido`, `idmesa`, `montotarjeta`, `idnotacred`,
			 `monto_notacred`, `numtarjeta`, `tipotarjeta`, `vueltogs`, `delivery`, `rendido`, `fec_rendido`, `obs`, `reimpresofc`, 
			 `idcuentaclientepagcab`
			)

			select idcaja, 1, 'E', ventas.idcliente, ventas.fecha, ventas.formapago, ventas.totalcobrar, NULL, NULL, ventas.factura, 
			NULL, NULL, ventas.estado, ventas.ruc, 1, 1, ventas.sucursal, 0,0,0,0,
			ventas.registrado_por, fecha, idventa,  NULL,  NULL, 0, ventas.idpedido, ventas.idmesa, 0, NULL,
			0,0,1,0, 0, 'S', ventas.fecha,  NULL,  NULL,
			 NULL
			from ventas 
			where estado <> 6 
			and tipo_venta = 1 
			and idventa not in (select idventa from gest_pagos where estado <> 6 and idventa is not null)
			and totalcobrar > 0
			and idventa = $idventa
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$consulta="
			INSERT INTO `gest_pagos_det`
			(`idpago`, `monto_pago_det`, `idformapago`) 
			select idpago, gest_pagos.total_cobrado, gest_pagos.medio_pago
			from gest_pagos 
			where 
			estado <> 6 
			and idpago not in (select idpago from  gest_pagos_det where idpago is not null)
			and gest_pagos.idventa = $idventa;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			$consulta="
			update gest_pagos_det set idformapago = 1 where idformapago = 0;
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}
		
		//marcamos los pedidos detalle
		$update="
		update tmp_ventares 
		set
		registrado='S',
		idventa=$idventa 
		where
		idventatmp in (select idventatmp from ventas_detalles where idventa = $idventa and idventatmp is not null)
		";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		
		// marcamos los pedidos en cabecera 
		//idventa = 0, ahora una cabecera de pedido puede tener varios idventa si se separo la cuenta, entonces se usa los idventa de su detalle
		$update="
		update tmp_ventares_cab 
		set
		registrado='S',
		idventa=$idventa ,
		estado=3 
		where 
		registrado='N'
		and idtmpventares_cab in (select idtmpventares_cab from tmp_ventares where idventa = $idventa and idventa is not null)
		";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		// marcamos la cabecera solamente si no quedo ningun detalle sin registrar
		/*$update="
		update tmp_ventares_cab
		set
		registrado='S',
		idventa=0,
		estado=3 
		where
		registrado='N'
		// tiene al menos 1 detalle registrado 
		and idtmpventares_cab in (
			select tmp_ventares.idtmpventares_cab 
			from tmp_ventares 
			where 
			tmp_ventares.idventa = $idventa 
			and tmp_ventares.idventa is not null
		)
		// no quedo ni un solo detalle sin registrar 
		and idtmpventares_cab not in (
			select tmp_ventares.idtmpventares_cab 
			from tmp_ventares 
			where 
			tmp_ventares.borrado = 'N'
			and tmp_ventares.idventa is null
			and tmp_ventares.idatc = $idatc
		)
		";
		$conexion->Execute($update) or die(errorpg($conexion,$update));*/
		
		
		// asigna las propinas a una caja
		$consulta="
		update mesas_atc_propinas
		set 
		cobrado = 'S',
		idventa=$idventa,
		idcaja = (
					select 
					idcaja 
					from ventas 
					where 
					idventa = $idventa 
				)
		where
		idventa is null
		and idatc = $idatc
		$whereadd_pro
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// si la propina asignada no tenia atc det asigna
		$consulta="
		update mesas_atc_propinas 
		set 
		idatcdet = (select idatcdet from ventas where idventa = $idventa)
		where 
		idventa = $idventa
		and (idatcdet is null or idatcdet = 0)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// si todo fue correcto
		$consulta="
		update ventas set finalizo_correcto = 'S' where idventa = $idventa
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// genera factura electronica si todo finalizo correcto
		if($facturador_electronico == 'S'){
			if($ticketofactura == 'FAC'){
				// GENERAR DOCUMENTO ELECTRONICO
				$parametros_array=array(
					'idventa' => $idventa,
					'iddocumentoelectronico' => 1
				);
				genera_documento_electronico($parametros_array);
			}
		}

		

		
		// si hay integracion con pegasus
		$consulta="
		select integracion_pegasus from sucursales where idsucu = $idsucursal
		";
		$rssuc=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		if($rssuc->fields['integracion_pegasus'] == 'S'){
			require_once("pegasus.php");
			$parametros_array=array(
				'idventa' => $idventa
			);
			$res=pedido_pegasus($parametros_array);
			if($res['valido'] != 'S'){
				header("location: pegasus_error.php?id=".$idventa);
				exit;
			}
		}
		

		if ($clasedoc==2){
			
			
			header("location: ../script_central_impresion.php?tk=2&clase=1&modventa=4&v=$idventa&mm=99&pr=$pr");
			exit;
		} else {

			if($factura == ''){
				$tk=0;
			}else{
				$tk=1;	
			}
			header("location: ../script_central_impresion.php?tk=$tk&modventa=4&v=$idventa&mm=99&pr=$pr");
			exit;
		}
		
		
		
		
	}
	
	
	
}
function llenardc($parte1,$parte2,$numero){
	  $documentom=agregacero($parte1,3).agregacero($parte2,3).agregacero($numero,7);
	  return $documentom;
}

function reservarfactura($fac_suc,$fac_pexp,$factura,$autoimpresor,$idempresa){
	global $conexion;
	//echo $autoimpresor;
	//exit;
	$fccompuesta=llenardc($fac_suc,$fac_pexp,$factura);
	if($autoimpresor!='S'){
		//echo $factura;exit;
		//echo 'f'.$fac_suc;
	//	exit;
		
		//echo $fccompuesta;
		//exit;
		$numfac=intval($factura);
		
		$ano=date("Y");
		// busca si existe algun registro
		$buscar="Select max(numfac) as mayor from lastcomprobantes where idsuc=$fac_suc and pe=$fac_pexp ";
		$rsfactura=$conexion->Execute($buscar) or die(errorpg( $conexionpg,$buscar));
		$maxnfac=intval(($rsfactura->fields['mayor'])+1);
		
		if($maxnfac < 1){
			$consulta="
			INSERT INTO lastcomprobantes
			(idsuc, factura, numfac, recibo, numrec, tickete, numtk, ano, pe, numcheque, secuencia_cancela, 
			numhoja, hojalevante, idempresa) 
			VALUES
			($fac_suc, '$fccompuesta', $numfac, NULL, 0, NULL, 0, $ano, $fac_pexp, NULL, 
			NULL, 0, '', 1)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}else{
			$consulta="
			update lastcomprobantes
			set 
			numfac = $maxnfac,
			factura = '$fccompuesta'
			where
			
			idsuc=$fac_suc
			and pe=$fac_pexp
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}	
	}
	// si es autoimpresor
	if($autoimpresor == 'S'){
	    //echo "a";
	   // exit;
		$ano=date("Y");
		// busca si existe algun registro
		$buscar="
		Select max(numfac) as mayor 
		from lastcomprobantes 
		where 
		idsuc=$fac_suc 
		and pe=$fac_pexp 
		and idempresa=$idempresa";
		$rsfactura=$conexion->Execute($buscar) or die(errorpg( $conexionpg,$buscar));
		$maxnfac=intval(($rsfactura->fields['mayor'])+1);
		if($maxnfac < 1){
			$consulta="
			INSERT INTO lastcomprobantes
			(idsuc, factura, numfac, recibo, numrec, tickete, numtk, ano, pe, numcheque, secuencia_cancela, 
			numhoja, hojalevante, idempresa) 
			VALUES
			($fac_suc, $factura, $maxnfac, NULL, 0, NULL, 0, $ano, $fac_pexp, NULL, 
			NULL, 0, '', 1)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}else{
			$consulta="
			update lastcomprobantes
			set 
			numfac = $maxnfac,
			factura = '$fccompuesta'
			where
			idempresa = 1
			and idsuc=$fac_suc
			and pe=$fac_pexp
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		}
	}
			
	
	return $fccompuesta;
	
	
	
	
	
}

function crear_cuenta_credito($idventa,$idadherente=0,$idservcom=0){
	//Crear cuenta si es credito
	global $conexion;
	$buscar="Select * from ventas where idventa=$idventa";
	$rsv=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));		
	$idempresa=intval($rsv->fields['idempresa']);
	$idsucursal=intval($rsv->fields['sucursal']);
	$idcliente=intval($rsv->fields['idcliente']);
	//Con el id del cliente, traemos la linea de sobregiro 
	$buscar="Select * from cliente where idcliente=$idcliente";
	$rscliente=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
	
	
	$totalcobrar=floatval($rsv->fields['totalcobrar']);
	$ahora=date("Y-m-d H:i:s");
	$vendedor=intval($rsv->fields['registrado_por']);

		
	
	
	//Generamos la cuenta
	$insertar="
	Insert into cuentas_clientes 
	(idempresa,sucursal,deuda_global,saldo_activo,idcliente,estado,registrado_el,registrado_por,idventa,idadherente,idserviciocom,prox_vencimiento)
	values
	($idempresa,$idsucursal,$totalcobrar,$totalcobrar,$idcliente,1,'$ahora',$vendedor,$idventa,$idadherente,$idservcom,'$ahora')
	";
	$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));

	//Credito
	$buscar="Select max(idcta) as mayor from cuentas_clientes ";
	$rs1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$mayor=intval($rs1->fields['mayor']	);

	$insertar="
	INSERT INTO cuentas_clientes_det
	(idcta, nro_cuota, vencimiento, monto_cuota, cobra_cuota, quita_cuota, saldo_cuota, fch_ult_pago, fch_cancela, dias_atraso, dias_pago, dias_comb, estado) 
	select cuentas_clientes.idcta, 1, '$ahora', cuentas_clientes.deuda_global, 0, 0, cuentas_clientes.saldo_activo, NULL, NULL, 0, 0, 0, 1
	from cuentas_clientes
	where 
	estado = 1
	and idcta = $mayor
	";
	$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));

	$consulta="
	INSERT INTO adherente_estadocuenta 
	( fechahora, fechasola, tipomov, idcliente, idadherente, idserviciocom, monto, idventa, idpago, idcta, idempresa, idpagodiscrim)
	SELECT registrado_el as fechahora, date(registrado_el) as fechasola, 'D' as tipomov, idcliente, idadherente,
	 idserviciocom, deuda_global as monto, idventa, NULL as idpago, idcta, idempresa , NULL as idpagodiscrim
	from cuentas_clientes 
	where 
	idcta = $mayor
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// actualizar el saldo de sobregiro
	$consulta="
	update cliente 
	set 
	saldo_sobregiro = $saldosobregiro_posconsumo_tit
	where 
	idcliente = $idcliente 
	";
	//$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	actualiza_saldos_clientes($idcliente,$idadherente,$idservcom);

	//ahora el idservicom
	if ($idadherente > 0){
		$update="Update adherentes_servicioscom set disponibleserv=disponibleserv-$totalcobrar where idadherente=$idadherente";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		
		$update="update adherentes set disponible=disponible-$totalcobrar where idadherente=$idadherente";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
	}					  
	return $mayor;

}

?>