<?php 
/*
ALTER TABLE `sucursales` ADD `integracion_pegasus` CHAR(1) NOT NULL DEFAULT 'N';
INSERT INTO `app` (`idapp`, `app`, `estado`) VALUES ('8', 'PEGASUS', '1');
CREATE TABLE IF NOT EXISTS `app_integra_log` (
  `idapilog` int(11) NOT NULL AUTO_INCREMENT,
  `idapp` int(11) NOT NULL,
  `idpedido` int(11) DEFAULT NULL,
  `json_log` longtext DEFAULT NULL,
  `json_log_resp` longtext DEFAULT NULL,
  `valido` char(1) DEFAULT NULL,
  `registrado_el` datetime NOT NULL,
  PRIMARY KEY (`idapilog`),
  KEY `idapp` (`idapp`),
  KEY `valido` (`valido`),
  KEY `idpedido` (`idpedido`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;
*/
function pedido_pegasus($parametros_array){
	global $conexion;
	global $ahora;
	
	$idventa=$parametros_array['idventa'];
	
	// cabecera
	$consulta="
	select ventas.idventa, ventas.fecha, mesas.numero_mesa
	from ventas
	inner join mesas on mesas.idmesa = ventas.idmesa
	where
	idventa = $idventa
	";
	$rscab=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	// detalle
	$consulta="
	select idprod, sum(cantidad) as cantidad, sum(subtotal) as subtotal, sum(subtotal)/sum(cantidad) as precio_unitario,
	(select idprodexterno from productos where idprod_serial = ventas_detalles.idprod) as idprodexterno
	from ventas_detalles
	where
	idventa = $idventa
	group by idprod
	";
	$rsdet=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$subtotal_acum=0;
	$i=0;
	while(!$rsdet->EOF){
		$detalles[$i]['cod_producto'] = $rsdet->fields['idprodexterno'];
		$detalles[$i]['cantidad'] = $rsdet->fields['cantidad'];
		$detalles[$i]['precio'] = $rsdet->fields['precio_unitario'];
		$subtotal=$rsdet->fields['subtotal'];
		$subtotal_acum+=$subtotal;
		$i++;
	$rsdet->MoveNext(); }

	
	$cabecera=array(
			"pedido_nro" => $rscab->fields['idventa'],
			"fecha_hora" => $rscab->fields['fecha'],
			"mesa_nro" =>  $rscab->fields['numero_mesa'],
			"cod_mozo" => 1,
			"monto_total" => $subtotal_acum,
			"detalles" => $detalles
	);
	$json_postdata=json_encode($cabecera, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	
	$json_log_ins=antisqlinyeccion($json_postdata,"clave");
	$consulta="
	insert into app_integra_log
	(idapp, idpedido, json_log, json_log_resp, valido, registrado_el)
	values
	(8, $idventa, $json_log_ins, NULL, 'N', '$ahora')
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	// obtener id insertado
	$consulta="
	select max(idapilog) as idapilog from app_integra_log where idpedido = $idventa
	";
	$rslogpri=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idapilog=intval($rslogpri->fields['idapilog']);
	
	// envia el pedido
	$curl = curl_init();
	$postdata = array(
		'pedido'=>$json_postdata,
	);
	curl_setopt_array($curl, 
		array(
			CURLOPT_URL => "http://181.40.19.37:8898/api_restaurant_bastos/rest.php?method=crearPedido",
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => "",
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 5,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => "POST",
			CURLOPT_POSTFIELDS => $postdata,
			CURLOPT_HTTPHEADER => array(
			"Authorization: Basic d6CbWihgPaxmosKTVqm8gDjUxo6MUXcPeP8QBqUi5b5Kp34ipDA5M9wjFkUydGsR"
		),
	));
	$response = curl_exec($curl);
	$err = curl_error($curl);
	curl_close($curl);
	
	
	// si es un error de conexion
	if ($err) {
		$res="cURL Error #:" . $err;
		$valido='N';
	// si no hubo error de conexion
	} else {
		$res=$response;
		
		$respuesta=json_decode($response,true);
		$status=$respuesta['status'];
		if($status == 'error'){
			$valido='N';
		}else{
			$valido='S';
		}
		
	}
	

	
	// de acuerdo a la respuesta ver si es valido o no
	
	
	$json_log_resp_ins=antisqlinyeccion($res,"clave");
	
	// guarda respuesta
	$consulta="
	update app_integra_log
	set
	json_log_resp = $json_log_resp_ins,
	valido = '$valido'
	where
	idapilog = $idapilog
	";
	$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	
	
	$retorno=array(
		'valido' => $valido,
		'json' => 'ERROR DEL SISTEMA PEGASUS: '.$res
	);
	
	return $retorno;
	
}
/*
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
require_once("../includes/funciones_stock.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="216";
require_once("../includes/rsusuario.php");

$idventa=10197;
$parametros_array=array(
	'idventa' => $idventa
);
$res=pedido_pegasus($parametros_array);

if($res['valido'] != 'S'){
	print_r($res['json']);
	exit;
}
*/

/*
$json='
{
	"pedido_nro": 123,
	"fecha_hora": "2022-10-17 13:35:00",
	"mesa_nro": 20,
	"cod_mozo": 1,
	"monto_total": 38000,
	"detalles": [
		{
			"cod_producto": "139",
			"cantidad": 2,
			"precio": 5000
		},
		{
			"cod_producto": "102",
			"cantidad": 4,
			"precio": 7000
		}
	]
}
';

$postdata = array(
	'pedido'=>$json,
);
*/






?>