<?php
/*------------------------------------------
16/05/2024 Solo revision.
-----------------------------------------*/
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="216";
require_once("../includes/rsusuario.php"); 


require_once("../includes/funciones_mesas.php");

$idatc=intval($_GET['idatc']);

// mesa origen
$consulta="
select *, 
	(
		select numero_mesa 
		from mesas 
		where 
		mesas.idmesa = mesas_atc.idmesa
	) as numero_mesa,
	(
		SELECT salon.nombre as salon
		FROM mesas 
		inner join salon on salon.idsalon = mesas.idsalon
		where 
		mesas.idmesa = mesas_atc.idmesa
	) as salon
from mesas_atc 
where 
idatc = $idatc 
and estado <> 6 
and estado <> 3 
and idsucursal = $idsucursal 
order by idatc desc 
limit 1
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idmesa=intval($rs->fields['idmesa']);
$idatc=intval($rs->fields['idatc']);
if(intval($idatc) == 0){
    echo "- ATC no permitido para tu sucursal.";
    exit;
}



$consulta="
select vaciar_mesa_idmotivo, permite_vaciar_mesa
from mesas_preferencias
limit 1
";
$rsprefm=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$permite_vaciar_mesa=trim($rsprefm->fields['permite_vaciar_mesa']);
$vaciar_mesa_idmotivo=intval($rsprefm->fields['vaciar_mesa_idmotivo']);
if($permite_vaciar_mesa != 'S'){
    echo "- Esta accion fue bloqueada por el administrador de tu local.";
    exit;
}
if($vaciar_mesa_idmotivo == 0){
    echo "- No se definio un motivo para el vaciado de mesas.";
    exit;
}

$consulta="
select idmotivoborra, descripcion
from motivos_eliminar_productos_pedidos
where
idmotivoborra = $vaciar_mesa_idmotivo
and estado = 1
";
$rsmotiv=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$vaciar_mesa_idmotivo=intval($rsmotiv->fields['idmotivoborra']);
$vaciar_mesa_motivo=antixss($rsmotiv->fields['descripcion']);
if($vaciar_mesa_idmotivo == 0){
    echo "- El Motivo definido para vaciar mesa no existe o fue anulado.";
    exit;
}

//Comprobar apertura de caja	
$parametros_caja_new=array(
	'idcajero' => $idusu,
	'idsucursal' => $idsucursal,
	'idtipocaja' => 1
);
$res_caja=caja_abierta_new($parametros_caja_new);
$idcaja=intval($res_caja['idcaja']);
if ($idcaja==0){
	echo "<br /><br />Debes tener una caja abierta para borrar un producto.<br /><br />";
	exit;	
}


$consulta="
select idvaciamesapermite
from mesas_vaciar_permite
where
idmesa = $idmesa
and estado = 1
";
$rsvac=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idvaciamesapermite=intval($rsvac->fields['idvaciamesapermite']);
/// validar si permite
if ($idvaciamesapermite==0){
	echo "<br />- La mesa seleccionada no tiene permisos para ser vaciada.<br /><br />";
	exit;	
}





if(isset($_POST['MM_update']) && $_POST['MM_update'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots

	$valido='S';
	$errores='';
	

	$idatc=intval($_GET['idatc']);
	//$liberarmesa=intval($_POST['ocliberamesa']);
	
	// busca todos los productos de la Mesa
	$consulta="
	select tmp_ventares.idventatmp, tmp_ventares.idtmpventares_cab
	from tmp_ventares 
	inner join productos on tmp_ventares.idproducto = productos.idprod_serial
	where 
	tmp_ventares.idtmpventares_cab in ( 
										select idtmpventares_cab 
										from tmp_ventares_cab 
										where idsucursal = $idsucursal 
										and finalizado = 'S' 
										and registrado = 'N' 
										and idatc=$idatc 
										and idatc > 0
										and estado = 1 
										)
	and tmp_ventares.borrado = 'N' 
	and tmp_ventares.idsucursal = $idsucursal 
	order by  idventatmp asc
	";
	$rsproductosmesa=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$i=0;
	//echo $consulta;exit;
	// recorre y valida
	while(!$rsproductosmesa->EOF){

		// parametros para la funcion borrar productos
		$parametros_array=array(
			'idventatmp' => $rsproductosmesa->fields['idventatmp'],
			'idprod' => '',
			'idtmpventares_cab' => '',
			'idatc' => $idatc,
			'rechazo' => '',
			'idmotivorecha' => '',
			'idmotivo_elimina'=> $vaciar_mesa_idmotivo,
			'cod' => $_POST['cod'],
			'idcaja' => $idcaja,
			'registrado_por' => $idusu, // cajero, si envio codigo la funcion reemplazara por el propietario del codigo
			'idsucursal' => $idsucursal,
		);
		//print_r($parametros_array);exit;
		// valida los parametros
		$res=validar_borrar_producto_pedido($parametros_array);
		//print_r($res);exit;
		if($res['valido'] != 'S'){
			$valido='N';
			$errores.=nl2br($res['errores']);
			break;
		}else{
			$parametros_array_glob[$i]=$parametros_array;
		}

		$i++;
		
	$rsproductosmesa->MoveNext();  }
	
	//echo $valido;
	//echo $errores;
	
	//print_r($parametros_array_glob);exit;

	
	// validaciones primarias
	if($valido == "S"){
		
		
		foreach($parametros_array_glob as $parametros_array_prod){
			
			// registra el borrado
			$res=registrar_borrar_producto_pedido($parametros_array_prod);
			//print_r($parametros_array_prod);echo "<hr />";
			$usu_borra_cod=0;	
			//Registrar LOG
			if($_POST['cod']!=''){
				//buscamos el codigo
				$codigo=md5(trim($_POST['cod']));
				$consulta=" select *
				from codigos_borraped 
				where 
				codigo = '$codigo'
				and estado = 1
				and registrado_por in (select idusu from usuarios where estado = 1)
				limit 1
				";
				$rscod=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				if(intval($rscod->fields['idusuario']) >0){
					$usu_borra_cod=intval($rscod->fields['idusuario']);
				} 
				
				
			}
			//convertimos el atc a numero
			$idatc=intval($parametros_array_prod['idatc']);
			$idventatmp=intval($parametros_array_prod['idventatmp']);
			$clasechar="BORRAR";
			$cc=substr($clasechar,0,2);
			$idtmpventares_cab=intval($parametros_array_prod['idtmpventares_cab']);
			$insertar="
			Insert into mesas_acciones_log 
			(fechahora,id_usuario,id_usu_pin,accion,clase,idatc,idmesa,porcen,monto,idtmpventares,idtmpventares_cab) 
			values 
			('$ahora',$idusu,$usu_borra_cod,'$clasechar - IDTMP:$idventatmp ',' $cc',$idatc,0,0,0,$idventatmp,$idtmpventares_cab)";
			$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
			
			
			
			// si hay mensaje muestra
			//echo antixss($res['mensaje']);

			
		}
		
		//echo "ahora liberar";
		//exit;
		// parametros libera mesa
		$parametros_array['idatc'] = $idatc;
		$parametros_array['idsucursal'] = $idsucursal;
		$parametros_array['idusu'] = $idusu;
		
		
		
		// validar libera mesa
		$res=liberar_mesa_valida($parametros_array);
		$valido=$res['valido'];
		$errores.=$res['errores'];
		

		
		if ($res["valido"]=="S") {
			$res=liberar_mesa_registra($parametros_array);
			//print_r($res);exit;
			//Por ultimo recargamos
			header("location: ventas_salon.php");
			exit;
		}else{
			$errores=$res["errores"];
		}
	}
	
}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());



?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
	  
<style>
.modal-dialog {
	margin-top: 0;
	margin-bottom: 0;
	height: 100vh;
	display: -webkit-box;
	display: -webkit-flex;
	display: -ms-flexbox;
	display: flex;
	-webkit-box-orient: vertical;
	-webkit-box-direction: normal;
	-webkit-flex-direction: column;
	-ms-flex-direction: column;
	flex-direction: column;
	-webkit-box-pack: center;
	-webkit-justify-content: center;
	-ms-flex-pack: center;
	justify-content: center;
}

.modal.fade .modal-dialog {
	-webkit-transform: translate(0, -100%);
	transform: translate(0, -100%);
}
.modal.in .modal-dialog {
	-webkit-transform: translate(0, 0);
	transform: translate(0, 0);
}
.contador{
	width:20px;
	height:20px;	
	position:absolute;
	font-size:16px;
	font-weight:bold;
	border:1px solid #000000;
	background-color:#CCC;
	text-align:center;
	margin:0px;
	float:left;

}
</style>
  </head>
<!-- CUERPO / BODY -->
  <body class="nav-md">
    	<div class="container body">
			<div class="main_container">
				<!-- top navigation -->
       		   <?php //require_once("includes/menu_top_gen.php"); ?>
        		<!-- /top navigation -->
        		<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
            			
            				<div class="clearfix"></div>
                  			<!-- SECCION -->
			       				<div class="row">
              						<div class="col-md-12 col-sm-12 col-xs-12">
                						<div class="x_panel">
											  <div class="x_title">
												  	<?php 
														// crea imagen
														$img="../gfx/empresas/emp_".$idempresa.".png";	 
														if(!file_exists($img)){
															$img="../gfx/empresas/emp_0.png";
														}
													?>
												 <?php require_once("cabecera_ppal.php"); ?>
										  
												  
												  
												  
												 <form id="formu01" action="ventas_salon.php" method="post">
												  	   <input type="hidden" name="ocsalon" id="ocsalon" value="0" />
													  <input type="hidden" name="occantidad" id="occantidad" value="0" />
													  <input type="hidden" name="ocserial" id="ocserial" value="0" />
												  </form>											  
												  
											 
												
											  </div>
                  							  <div class="x_content">
					  									

												  		

                  								</div>
                							</div>
              							</div>
            						</div>
									<!-- ROW--->
           							<div class="clearfix"></div>
                  					<!-- Mesas del Sistema -->
           							<div class="row" id="mesascomponen" >
										<div class="col-md-12 col-sm-12 col-xs-12">
											<div class="x_panel">
												  <div class="x_title">
													<h2><i class="fa fa-arrow-circle-o-right"></i>Vaciar Mesa <small id="minitextomesas"></small></h2>
													<div align="center">
												  	<a href="ventas_salon.php"><i class="fa fa-home fa-2x">&nbsp;Regresar</i></a>
													</div>  
											 
													<div class="clearfix"></div>
												  </div>
												  <div class="x_content" id="minimesas">




<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<div class="alert alert-warning alert-dismissible fade in" role="alert">
Cuidado! se <strong>BORRARAN TODOS</strong> los productos de la mesa y se volvera a poner la mesa como libre.
</div>
<hr />
<form id="form1" name="form1" method="post" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Mesa numero *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="numero_mesa" id="numero_mesa" value="<?php echo $rs->fields['numero_mesa']; ?>" placeholder="numero_mesa" class="form-control" required="required" readonly="readonly" disabled="disabled" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Salon *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="salon" id="salon" value="<?php echo $rs->fields['salon']; ?>" placeholder="salon" class="form-control" required="required" readonly="readonly" disabled="disabled" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Motivo *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="salon" id="salon" value="<?php echo $vaciar_mesa_motivo; ?>" placeholder="salon" class="form-control" required="required" readonly="readonly" disabled="disabled" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Codigo Autorizacion *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="password" name="cod" id="cod" value="" placeholder="Codigo borrar pedidos" class="form-control" required="required" />                    
	</div>
</div>


<div class="clearfix"></div>
<br />

    <div class="form-group">
        <div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
	   <button type="submit" class="btn btn-danger" ><span class="fa fa-trash-o"></span> BORRAR TODO</button>
	   <button type="button" class="btn btn-primary" onMouseUp="document.location.href='ventas_salon.php'"><span class="fa fa-ban"></span> Cancelar</button>
        </div>
    </div>


  <input type="hidden" name="MM_update" value="form1" />
  <input type="hidden" name="form_control" value="<?php echo antixss($_SESSION['form_control']); ?>">
<br />
</form>
<div class="clearfix"></div>
<br /><br />

 

 												  </div>
												 
											</div>
										</div>
										

								   </div>
			 						<div class="clearfix"></div>
                  					
          				</div>
          		</div>
				
			
<!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
        
            <div class="modal-header">
            	<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
           		<h4 class="modal-title" id="modal_titulo">Titulo</h4>
            </div>
            <div class="modal-body" id="modal_cuerpo">
            	Contenido...
            </div>
            <div class="modal-footer" id="modal_pie">
            	<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>
        
        </div>
    </div>
</div>
<!-- POPUP DE MODAL OCULTO -->		
			
			
			
	  </div> <!-- /body container -->  
	   
        <!-- Impresiones y reimpresiones -->     
		<div style="display: none" id="reimprimebox"></div>
              
       
        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
	<?php require_once("includes/footer_gen.php"); ?>
       	<script src="../js/shortcut.js"></script>
		<script src="../js/ventas_mesas_nueva.js?nc=<?php echo date("YmdHis"); ?>"></script>
  </body>
</html>
