<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="2";
require_once("includes/rsusuario.php"); 

// agrupar trae registros solamente desde el 03/09/2024 antes no se registraba el log



function accion_mov_mesa($accion){
	if($accion == 'A'){
		$res='AGRUPAR MESA';
	}else if($accion == 'M'){
		$res='MUDAR MESA';
	}else if($accion == 'S'){
		$res='SEPARAR CUENTA';
	}else{
		$res='NO ESPECIFICADO';
	}
	return $res;
}



$consulta="
select 
log_mov_mesa.*, tpmv.borrado as borrado, tpmv.borrado_mozo_el as borrado_mozo_el, usbor.usuario as borrado_mozo_por_txt, 
productos.descripcion as producto, productos.idprod_serial,
usuarios.usuario as registrado_por_txt,
mant.numero_mesa as numero_mesa_ant,
mnew.numero_mesa as numero_mesa_new

from log_mov_mesa 
inner join 
(
	select idventatmp, idproducto, borrado, borrado_mozo_el, borrado_mozo_por from tmp_ventares where  finalizado = 'S'
	union all
	select idventatmp, idproducto, borrado, borrado_mozo_el, borrado_mozo_por from tmp_ventares_bak where  finalizado = 'S'
) tpmv on log_mov_mesa.idventatmp = tpmv.idventatmp
inner join productos on productos.idprod_serial = tpmv.idproducto
inner join usuarios on usuarios.idusu = log_mov_mesa.registrado_por
inner join mesas mant on mant.idmesa = log_mov_mesa.idmesa_ant
inner join mesas mnew on mnew.idmesa = log_mov_mesa.idmesa_new
left join usuarios usbor on usbor.idusu = tpmv.borrado_mozo_por
where
DATE(log_mov_mesa.registrado_el) >= DATE_SUB(CURDATE(), INTERVAL 10 DAY)
order by idlog desc
";
//$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

/******** PAGINACION **********/
	//Limito la busqueda
	$TAMANO_PAGINA = 20;
	
	$consulta_tot="
	WITH consulta_a_paginar AS (
		$consulta
	)
	select count(*) as total
	from consulta_a_paginar
	";
	$rstotal=$conexion->Execute($consulta_tot) or die(errorpg($conexion,$consulta_tot));
	$num_total_registros=$rstotal->fields['total'];
	$nropagina = intval($_GET["pagina"]);
	//examino la página a mostrar y el inicio del registro a mostrar
	if ($nropagina == 0) {
	   $inicio = 0;
	   $nropagina = 1;
	} else {
	   $inicio = ($nropagina - 1) * $TAMANO_PAGINA;
	}
	//calculo el total de páginas
	$total_paginas = ceil($num_total_registros / $TAMANO_PAGINA);
	// volver a consultar pero agregar los limites
	$limite=" 
	Limit $inicio, $TAMANO_PAGINA
	";
	// ejecutar despues de la paginacion
	$consulta_paginada=$consulta.$limite;
	$rs=$conexion->Execute($consulta_paginada) or die(errorpg($conexion,$consulta_paginada));
/******** PAGINACION **********/



?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Movimientos de Comandas de Mesa</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
</button>
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<?php 
$refemenu='ult';
require_once("includes/menu_mov_mesa.php");?>

<strong>Viendo Movimientos (Ult 30 dias):</strong>
<div class="clearfix"></div>
<?php if ($total_paginas > 1) { ?>
<ul class="pagination">
<?php 
$parametros_array['get_excluye'] = 'sf,pagina';
$parametros_array['primer_parametro_fijo'] = 'S';
$url_add=parametros_url($parametros_array);
$nombre_script = basename($_SERVER['SCRIPT_NAME']);
if($url_add != ''){
	$url=$nombre_script."?sf=n".$url_add;
}else{
	$url=$nombre_script."?sf=s";	
}
if ($total_paginas > 1) {
	if ($nropagina != 1){
		echo '<li><a href="'.$url.'&pagina='.($nropagina-1).'">&laquo;</a></li>';
	}
	for ($i=1;$i<=$total_paginas;$i++) {
		if ($nropagina == $i){
			//si muestro el índice de la página actual, no coloco enlace
			echo '<li class="active" style="background-color:#FE980F; color:#FFF;"><a href="'.$url.'">'.$nropagina.'</a></li>';
		}else{
			//si el índice no corresponde con la página mostrada actualmente,
			//coloco el enlace para ir a esa página
			echo '<li><a href="'.$url.'&pagina='.$i.'">'.$i.'</a></li>';
		}
	}
	if ($nropagina != $total_paginas){
		echo '<li><a href="'.$url.'&pagina='.($nropagina+1).'">&raquo;</a></li>';
	}
}
?>
</ul>
<div class="clearfix"></div>

<?php } ?>
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>

			<th align="center">Idventatmp</th>
			<th align="center">Producto</th>
			<th align="center">Idpedido Anterior</th>
			<th align="center">Idpedido Nuevo</th>
			<th align="center">Idatc Anterior</th>
			<th align="center">Idatc Nuevo</th>
			<th align="center">Nro Mesa Anterior</th>
			<th align="center">Nro Mesa Nuevo</th>
			<th align="center">Movimiento</th>
			<th align="center">Mov registrado por</th>
			<th align="center">Mov registrado el</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ ?>
		<tr>

				<td align="center"><?php echo intval($rs->fields['idventatmp']); ?> 
				<?php if($rs->fields['borrado'] == 'S'){ ?>
				<br /><span style="color:red;"><strong>Borrado el:</strong><br /> <?php if($rs->fields['borrado_mozo_el'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['borrado_mozo_el'])); }  ?></span>
				<br /><span style="color:red;"><strong>Borrado por:</strong><br /> <?php echo antixss($rs->fields['borrado_mozo_por_txt']); ?></span>
				<?php } ?></td>
				<td align="center"><?php echo antixss($rs->fields['producto']); ?> [<?php echo antixss($rs->fields['idprod_serial']); ?>]</td>
				<td align="center"><?php echo intval($rs->fields['idtmpventares_cab_ant']); ?> <a href="movimientos_mesa.php?idpedido=<?php echo intval($rs->fields['idtmpventares_cab_ant']); ?>&MM_search=form1" class="btn btn-sm btn-default"><span class="fa fa-search"></span></a></td>
				<td align="center"><?php echo intval($rs->fields['idtmpventares_cab_new']); ?> <a href="movimientos_mesa.php?idpedido=<?php echo intval($rs->fields['idtmpventares_cab_new']); ?>&MM_search=form1" class="btn btn-sm btn-default"><span class="fa fa-search"></span></a></td>
				<td align="center"><?php echo intval($rs->fields['idatc_ant']); ?></td>
				<td align="center"><?php echo intval($rs->fields['idatc_new']); ?></td>
				<td align="center"><?php echo intval($rs->fields['numero_mesa_ant']); ?></td>
				<td align="center"><?php echo intval($rs->fields['numero_mesa_new']); ?></td>
				<td align="center"><?php echo accion_mov_mesa($rs->fields['accion']); ?></td>
				<td align="center"><?php echo antixss($rs->fields['registrado_por_txt']); ?></td>
				<td align="center"><?php if($rs->fields['registrado_el'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['registrado_el'])); }  ?></td>
		</tr>
<?php 

$rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>

    </table>
</div>
<div class="clearfix"></div>

<?php if ($total_paginas > 1) { ?>
<ul class="pagination">
<?php 
$parametros_array['get_excluye'] = 'sf,pagina';
$parametros_array['primer_parametro_fijo'] = 'S';
$url_add=parametros_url($parametros_array);
$nombre_script = basename($_SERVER['SCRIPT_NAME']);
if($url_add != ''){
	$url=$nombre_script."?sf=n".$url_add;
}else{
	$url=$nombre_script."?sf=s";	
}
if ($total_paginas > 1) {
	if ($nropagina != 1){
		echo '<li><a href="'.$url.'&pagina='.($nropagina-1).'">&laquo;</a></li>';
	}
	for ($i=1;$i<=$total_paginas;$i++) {
		if ($nropagina == $i){
			//si muestro el índice de la página actual, no coloco enlace
			echo '<li class="active" style="background-color:#FE980F; color:#FFF;"><a href="'.$url.'">'.$nropagina.'</a></li>';
		}else{
			//si el índice no corresponde con la página mostrada actualmente,
			//coloco el enlace para ir a esa página
			echo '<li><a href="'.$url.'&pagina='.$i.'">'.$i.'</a></li>';
		}
	}
	if ($nropagina != $total_paginas){
		echo '<li><a href="'.$url.'&pagina='.($nropagina+1).'">&raquo;</a></li>';
	}
}
?>
</ul>
<div class="clearfix"></div>

<?php } ?>

<div class="clearfix"></div>
<br /><br />					  
					  
					  
					  
					  
					  
					  
					  
					  

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            

            
            
            
          </div>
        </div>
        <!-- /page content -->
		  
        <!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
        
            <div class="modal-header">
            	<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
           		<h4 class="modal-title" id="modal_titulo">Titulo</h4>
            </div>
            <div class="modal-body" id="modal_cuerpo">
            	Contenido...
            </div>
            <div class="modal-footer" id="modal_pie">
            	<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>
        
        </div>
    </div>
</div>
        <!-- POPUP DE MODAL OCULTO -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
