<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "699";
require_once("../includes/rsusuario.php");

$consulta="
select profesionales_servicios.idprofserv, concat(profesionales.nombres, ' ', profesionales.apellidos) as nombre_profesional,
productos.descripcion as nombre_producto,
(select nombre from sucursales where profesionales_servicios.idsucursal = sucursales.idsucu) as idsucursal_txt,
(select usuario from usuarios where profesionales_servicios.registrado_por = usuarios.idusu) as registrado_por_txt
from profesionales_servicios 
left join profesionales on profesionales.idprofe = profesionales_servicios.idprofesional
left join productos ON productos.idprod = profesionales_servicios.idproducto
where 
 profesionales_servicios.estado = 1 
order by profesionales_servicios.idprofserv asc
";
//$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

/******** PAGINACION **********/
	//Limito la busqueda
	$TAMANO_PAGINA = 500;
	
	$consulta_tot="
	WITH consulta_a_paginar AS (
		$consulta
	)
	select count(*) as total
	from consulta_a_paginar
	";
	$rstotal=$conexion->Execute($consulta_tot) or die(errorpg($conexion,$consulta_tot));
	$num_total_registros=$rstotal->fields['total'];
	$nropagina = intval($_GET["pagina"]);
	//examino la página a mostrar y el inicio del registro a mostrar
	if ($nropagina == 0) {
	   $inicio = 0;
	   $nropagina = 1;
	} else {
	   $inicio = ($nropagina - 1) * $TAMANO_PAGINA;
	}
	//calculo el total de páginas
	$total_paginas = ceil($num_total_registros / $TAMANO_PAGINA);
	// volver a consultar pero agregar los limites
	$limite=" 
	Limit $inicio, $TAMANO_PAGINA
	";
	// ejecutar despues de la paginacion
	$consulta_paginada=$consulta.$limite;
	$rs=$conexion->Execute($consulta_paginada) or die(errorpg($conexion,$consulta_paginada));
/******** PAGINACION **********/

?>

<!DOCTYPE html>

<head>
    <?php require_once("../includes/head_gen.php"); ?>
</head>

<body class="nav-md">
    <div class="container body">
        <div class="main_container">
            <?php require_once("../includes/menu_gen.php"); ?>

            <!-- top navigation -->
            <?php require_once("../includes/menu_top_gen.php"); ?>
            <!-- /top navigation -->

            <!-- page content -->
            <div class="right_col" role="main">
                <div class="">
                    <div class="page-title">
                    </div>
                    <div class="clearfix"></div>
                    <?php require_once("../includes/lic_gen.php"); ?>

                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="x_panel">
                                <div class="x_content">

                                <p>
                        <a href="asignar_servicios_profesionales_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar</a>
                    </p>
                    <hr />


                                    
                    <?php if ($total_paginas > 1) { ?>
                    <ul class="pagination">
                    <?php 
                    $parametros_array['get_excluye'] = 'sf,pagina';
                    $parametros_array['primer_parametro_fijo'] = 'S';
                    $url_add=parametros_url($parametros_array);
                    $nombre_script = basename($_SERVER['SCRIPT_NAME']);
                    if($url_add != ''){
                        $url=$nombre_script."?sf=n".$url_add;
                    }else{
                        $url=$nombre_script."?sf=s";	
                    }
                    if ($total_paginas > 1) {
                        if ($nropagina != 1){
                            echo '<li><a href="'.$url.'&pagina='.($nropagina-1).'">&laquo;</a></li>';
                        }
                        for ($i=1;$i<=$total_paginas;$i++) {
                            if ($nropagina == $i){
                                //si muestro el índice de la página actual, no coloco enlace
                                echo '<li class="active" style="background-color:#FE980F; color:#FFF;"><a href="'.$url.'">'.$nropagina.'</a></li>';
                            }else{
                                //si el índice no corresponde con la página mostrada actualmente,
                                //coloco el enlace para ir a esa página
                                echo '<li><a href="'.$url.'&pagina='.$i.'">'.$i.'</a></li>';
                            }
                        }
                        if ($nropagina != $total_paginas){
                            echo '<li><a href="'.$url.'&pagina='.($nropagina+1).'">&raquo;</a></li>';
                        }
                    }
                    ?>
                    </ul>
                    <div class="clearfix"></div>
                    <br />
                    <?php } ?>


                    <div class="table-responsive">
                        <table width="100%" class="table table-bordered jambo_table bulk_action">
                        <thead>
                            <tr>
                                <th></th>
                                <th align="center">Profesional</th>
                                <th align="center">Servicio</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php while(!$rs->EOF){ ?>
                                <tr>
                                    <td>
                                        
                                        <div class="btn-group">
                                            <a href="asignar_servicios_profesionales_edit.php?id=<?php echo $rs->fields['idprofserv']; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right"  data-original-title="Editar"><span class="fa fa-edit"></span></a>
                                            <a href="asignar_servicios_profesionales_del.php?id=<?php echo $rs->fields['idprofserv']; ?>" class="btn btn-sm btn-default" title="Borrar" data-toggle="tooltip" data-placement="right"  data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
                                        </div>

                                    </td>
                                    <td align="center"><?php echo antixss($rs->fields['nombre_profesional']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['nombre_producto']); ?></td>
                                </tr>
                        <?php 
                        $comision_porc_acum+=$rs->fields['comision_porc'];

                        $rs->MoveNext(); } //$rs->MoveFirst(); ?>
                        </tbody>
                        
                        </table>
                    </div>
                    <br />


                                    
                    <?php if ($total_paginas > 1) { ?>
                    <ul class="pagination">
                    <?php 
                    $parametros_array['get_excluye'] = 'sf,pagina';
                    $parametros_array['primer_parametro_fijo'] = 'S';
                    $url_add=parametros_url($parametros_array);
                    $nombre_script = basename($_SERVER['SCRIPT_NAME']);
                    if($url_add != ''){
                        $url=$nombre_script."?sf=n".$url_add;
                    }else{
                        $url=$nombre_script."?sf=s";	
                    }
                    if ($total_paginas > 1) {
                        if ($nropagina != 1){
                            echo '<li><a href="'.$url.'&pagina='.($nropagina-1).'">&laquo;</a></li>';
                        }
                        for ($i=1;$i<=$total_paginas;$i++) {
                            if ($nropagina == $i){
                                //si muestro el índice de la página actual, no coloco enlace
                                echo '<li class="active" style="background-color:#FE980F; color:#FFF;"><a href="'.$url.'">'.$nropagina.'</a></li>';
                            }else{
                                //si el índice no corresponde con la página mostrada actualmente,
                                //coloco el enlace para ir a esa página
                                echo '<li><a href="'.$url.'&pagina='.$i.'">'.$i.'</a></li>';
                            }
                        }
                        if ($nropagina != $total_paginas){
                            echo '<li><a href="'.$url.'&pagina='.($nropagina+1).'">&raquo;</a></li>';
                        }
                    }
                    ?>
                    </ul>
                    <div class="clearfix"></div>

                    <?php } ?>


                    <div class="clearfix"></div>
                    <br /><br />

                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- /page content -->
            <?php require_once("../includes/pie_gen.php"); ?>
            <!-- /footer content -->
        </div>
    </div>
    <?php require_once("../includes/footer_gen.php"); ?>
</body>

</html>
