<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");

if (!isset($_POST['idprofesional']) || empty($_POST['idprofesional'])) {
    echo "<p>Error: No se ha proporcionado un ID de profesional.</p>";
    exit;
}

$idprofesional = intval($_POST['idprofesional']); 

$consulta = "
SELECT p.idprod_serial, p.descripcion, productos_sucursales.precio as p1,
       pr.nombres, pr.apellidos
FROM productos p
INNER JOIN productos_sucursales ON productos_sucursales.idproducto = p.idprod_serial
INNER JOIN profesionales_servicios ps ON ps.idproducto = p.idprod_serial
INNER JOIN profesionales pr ON ps.idprofesional = pr.idprofe
WHERE p.idtipoproducto = 7 
AND p.borrado = 'N' 
AND productos_sucursales.activo_suc = 1
AND ps.idprofesional = ?
";

$stmt = $conexion->Prepare($consulta);
$rsprofesional = $conexion->Execute($stmt, [$idprofesional]) or die(errorpg($conexion, $consulta));



if ($rsprofesional->RecordCount() == 0) {
    echo "<p>No se encontraron servicios para este profesional.</p>";
    exit;
}
?>

<div style="width: 100%; overflow-y: auto; overflow-x: auto;">
    <table width="100%" class="table table-bordered">
        <thead>
            <tr>
                <th width="60%">Servicio</th>
                <th width="30%">Profesional</th>
                <th width="10%">Cant.</th>
                <th width="30%">Precio</th>
            </tr>
        </thead>
        <tbody>
            <?php while (!$rsprofesional->EOF) { ?>
                <tr>
                    <td><?php echo htmlspecialchars($rsprofesional->fields['descripcion']); ?></td>
                    <td><?php echo htmlspecialchars($rsprofesional->fields['nombres'] . ' ' . $rsprofesional->fields['apellidos']); ?></td>
                    <td><input  type="text" name="can_<?php echo $rsproducto->fields['idprod_serial']; ?>" id="can_<?php echo $rsproducto->fields['idprod_serial']; ?>" value="" size="1" onKeyUp="seleccionar(<?php echo $rsproducto->fields['idprod_serial']; ?>,this.value)" />
                    <a id="enla_<?php echo $rsproducto->fields['idprod_serial']; ?>" <?php echo $enla; ?>></a></td>
                    <td><input type="hidden" name="preciolis_<?php echo $rsproducto->fields['idprod_serial']; ?>" id="preciolis_<?php echo $rsproducto->fields['idprod_serial']; ?>" value="<?php echo $rsproducto->fields['p1']; ?>" />
                        <?php echo formatomoneda($rsproducto->fields['p1']); ?>
                    <?php //echo $rsproducto->fields['idtipoproducto']?></td>
                </tr>
            <?php $rsprofesional->MoveNext(); } ?>
        </tbody>
    </table>
</div>