<?php 
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// Modulo y submodulo respectivamente
$modulo="17";
$submodulo="91";
require_once("includes/rsusuario.php");

$idreceta_detalleprod=intval($_POST['idreceta_detalleprod']);
 

$consulta="
SELECT *, (select nombre as medida_obj from medidas where medidas.id_medida = recetas_produccion.medida ) as medida_obj,
recetas_produccion.nombre as receta, recetas_detalles_produccion.rendimiento_porc as rendimiento_porc
FROM recetas_produccion
inner join recetas_detalles_produccion on recetas_detalles_produccion.idreceta = recetas_produccion.idreceta
inner join insumos_lista on insumos_lista.idinsumo = recetas_detalles_produccion.idinsumo
inner join medidas on medidas.id_medida = insumos_lista.idmedida
where 
recetas_detalles_produccion.idreceta_detalleprod = $idreceta_detalleprod
and recetas_produccion.estado <> 6
and recetas_produccion.cantidad_resultante > 0
order by idreceta_detalleprod asc
";
$rsrec=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idreceta=$rsrec->fields['idreceta'];

// guardar cambios
if($_POST['guardar'] == 'S'){
	
	// recibe parametros
	$cantidad=antisqlinyeccion($_POST['cantidad'],"float");
	$cantidad_neta=antisqlinyeccion($_POST['cantidad_neta'],"float");
	$rendimiento_porc=antisqlinyeccion($_POST['rendimiento_porc'],"float");
	$comentario_ing=antisqlinyeccion($_POST['comentario_ing'],"text");
	
	// validaciones basicas
	$valido="S";
	$errores="";




	if(floatval($_POST['cantidad']) <= 0){
		$valido="N";
		$errores.=" - El campo cantidad no puede ser cero o nulo.<br />";	
	}
	if(floatval($_POST['cantidad_neta']) <= 0){
		$valido="N";
		$errores.=" - El campo cantidad neta no puede ser cero o negativo.<br />";	
	}
	if(floatval($_POST['rendimiento_porc']) <= 0){
		$valido="N";
		$errores.=" - El campo rendimiento no puede ser cero o negativo.<br />";	
	}
	
	// conversiones por seguridad
	$rendimiento_porc=(100*floatval($_POST['cantidad_neta']))/floatval($_POST['cantidad']);
	if(floatval($rendimiento_porc) <= 0){
		$valido="N";
		$errores.=" - El campo rendimiento no puede ser cero o negativo.<br />";	
	}
	
	// si todo es correcto inserta
	if($valido == "S"){
		
		//actualizar fecha de ultima modificacion
		$update="
		update recetas_produccion 
		set
			 ultimo_cambio = '$ahora', 
			 ultimo_cambio_por=$idusu 
		 where 
			idreceta=$idreceta 
		";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		
		$consulta="
		update recetas_detalles_produccion
		set
			cantidad=$cantidad,
			rendimiento_porc=$rendimiento_porc,
			cantidad_neta=$cantidad_neta,
			comentario_ing=$comentario_ing
		where
			idreceta_detalleprod = $idreceta_detalleprod
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// genera array con los datos
		$arr = array(
		'valido' => $valido,
		'errores' => $errores
		);
	
	}
	if($valido == "N"){
		// genera array con los datos
		$arr = array(
		'valido' => $valido,
		'errores' => $errores
		);
	}
	

	
	//print_r($arr);
	
	// convierte a formato json
	$respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
	
	// devuelve la respuesta formateada
	echo $respuesta;
	exit;
	
	
}





?>
<div class="alert alert-danger alert-dismissible fade in" role="alert" id="error_box" style="display:none;">
<strong>Errores:</strong><br />
<span id="error_box_msg"><?php echo $errores; ?></span>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Ingrediente *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
     <input type="text" name="medidac" id="medidac" value="<?php echo $rsrec->fields['descripcion'] ?>" placeholder="" class="form-control" disabled  />             
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Medida *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="medidac" id="medidac" value="<?php echo $rsrec->fields['medida_obj'] ?>" placeholder="" class="form-control" disabled  />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Cantidad Bruta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="cantidad" id="cantidad_1" value="<?php  if(isset($_POST['cantidad'])){ echo htmlentities($_POST['cantidad']); }else{ echo floatval($rsrec->fields['cantidad']); }?>" placeholder="Cantidad Bruta" class="form-control" required onKeyUp="calcular_neto(1);" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Cantidad Neta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="cantidad_neta" id="cantidad_neta_1" value="<?php  if(isset($_POST['cantidad_neta'])){ echo htmlentities($_POST['cantidad_neta']); }else{ echo floatval($rsrec->fields['cantidad_neta']); }?>" placeholder="Cantidad Neta" class="form-control" required onKeyUp="calcular_bruto(1);" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">% Rendimiento *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="rendimiento_porc" id="rendimiento_porc_1" value="<?php  if(isset($_POST['rendimiento_porc'])){ echo htmlentities($_POST['rendimiento_porc']); }else{ echo floatval($rsrec->fields['rendimiento_porc']); }?>" placeholder="Rendimiento" class="form-control" required onKeyUp="calcular_neto(1);" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Observacion </label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="comentario_ing" id="comentario_ing_1" value="<?php  if(isset($_POST['comentario_ing'])){ echo htmlentities($_POST['comentario_ing']); }else{ echo htmlentities($rsrec->fields['comentario_ing']); }?>" placeholder="Observacion" class="form-control"  />                    
	</div>
</div>
<div class="clearfix"></div>
<br />

    <div class="form-group">
        <div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
	   <button type="button" class="btn btn-success" onMouseUp="guardar(<?php echo $idreceta_detalleprod; ?>);" ><span class="fa fa-check-square-o"></span> Registrar</button>

        </div>
    </div>

<div class="clearfix"></div>
<br /><br />