<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="696";
require_once("includes/rsusuario.php"); 

/*
asignar masivo  idventa
update mesas_atc_propinas 
set 
idventa = (select idventa from ventas where ventas.idatc = mesas_atc_propinas.idventa) 
where 
idatcdet is null 
and idventa is null
*/


$idventa=intval($_GET['idventa']);
if($idventa==0){
	header("location: propinas_posterior.php");
	exit;
}

$consulta="
select 
mesas_atc.idatc, mesas_atc.fecha_inicio as apertura_mesa, sucursales.nombre as sucursal,
 mesas.numero_mesa, salon.nombre as salon,
CASE WHEN
	mesas_atc.estado = 1
THEN 
	'ABIERTO'
ELSE
	'CERRADO'
END as estado_txt,
ventas.idatcdet,
mesas_atc_det.nombre_atc as subcuenta,
ventas.idventa, ventas.factura, ventas.ruc, ventas.razon_social,
ventas.fecha, ventas.idcaja
from mesas_atc 
inner join sucursales on sucursales.idsucu = mesas_atc.idsucursal
inner join mesas on mesas.idmesa = mesas_atc.idmesa
inner join salon on salon.idsalon = mesas.idsalon
inner join ventas on ventas.idatc = mesas_atc.idatc
left join mesas_atc_det on mesas_atc_det.idatcdet = ventas.idatcdet
where
mesas_atc.estado <> 6
and ventas.idventa = $idventa
and ventas.estado <> 6
";
$rs = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$idventa=intval($rs->fields['idventa']);
$idatc=intval($rs->fields['idatc']);
$idatcdet=intval($rs->fields['idatcdet']);
$idatcdet_sql=antisqlinyeccion($rs->fields['idatcdet'],"int");
$idcaja=intval($rs->fields['idcaja']);
if($idventa==0){
	header("location: propinas_posterior.php");
	exit;
}

if(isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	

	// recibe parametros
	$monto_propina=antisqlinyeccion($_POST['monto_propina'],"text");
	$idforma=antisqlinyeccion($_POST['idforma'],"int");
	$idmozo_propina=antisqlinyeccion($_POST['idmozo_propina'],"int");
	$estado=1;


	// valida que la caja este abierta
	$consulta="
	select idcaja from caja_super where idcaja = $idcaja and estado_caja = 1 limit 1
	";
	$rscaj=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if(intval($rscaj->fields['idcaja']) == 0){
		$valido='N';
		$errores="- No se puede registrar la propina por que la caja [$idcaja] a la que esta vinculada la venta ya fue cerrada.";
	}


	if($valido == 'S'){
		// registrar si todo es valido
		$consulta="
		INSERT INTO mesas_atc_propinas
		(
		idatc, idatcdet, monto_propina, registrado_por, registrado_el, 
		 mediopago, afecta_caja, idconfirmapago_apppos, idmozo, idcaja, cobrado,
		 idventa, estado_prop, carga_posterior
		 ) 
		 VALUES 
		 (
		 $idatc,$idatcdet_sql,$monto_propina,$idusu,'$ahora',
		 $idforma,'N',NULL,$idmozo_propina,$idcaja,'S',
		 $idventa,1,'S'
		 )
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	
		header("location: propinas_posterior_det.php?idventa=".$idventa);
		exit;


	}
	
}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());



?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>

  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Propinas Posterior</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<p><a href="propinas_posterior.php" class="btn btn-sm btn-default"><span class="fa fa-reply"></span> Volver</a></p>
<hr />
<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
</button>
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>


<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>

			<th align="center">Idtc</th>
			<th align="center">Subcuenta</th>
			<th align="center">Idventa</th>
			<th align="center">Factura</th>
			<th align="center">Cliente</th>
			<th align="center">Apertura</th>
			<th align="center">Cierre</th>
			<th align="center">Sucursal</th>
			<th align="center">Salon</th>
			<th align="center">Numero Mesa</th>
			<th align="center">Estado</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ ?>
		<tr>

			<td align="center"><?php echo intval($rs->fields['idatc']); ?></td>
			<td align="center"><?php if(intval($rs->fields['idatcdet']) > 0){ echo antixss($rs->fields['subcuenta']); ?> [<?php echo intval($rs->fields['idatcdet']); ?>]<?php } ?></td>
			<td align="center"><?php  echo intval($rs->fields['idventa']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['factura']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['razon_social']); ?> | <?php echo antixss($rs->fields['ruc']); ?></td>
			<td align="center"><?php if($rs->fields['apertura_mesa'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['apertura_mesa'])); }  ?></td>
			<td align="center"><?php if($rs->fields['fecha'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['fecha'])); }  ?></td>
			<td align="center"><?php echo antixss($rs->fields['sucursal']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['salon']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['numero_mesa']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['estado_txt']); ?></td>
		</tr>
<?php 

$rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>
    </table>
</div>
<br />	
Propinas cargados posteriores al cierre de mesa, estas propinas no seran facturadas ya que la factura por la mesa ya fue emitida.
<hr />
<form id="form1" name="form1" method="post" action="">



<div class="clearfix"></div>
<br />

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Monto Propina *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input  type="text" name="monto_propina" id="monto_propina" value="<?php  if(isset($_POST['monto_propina'])){ echo htmlentities($_POST['monto_propina']); }else if(trim($rs->fields['monto_propina']) != ''){ echo htmlentities($rs->fields['monto_propina']); } ?>" placeholder="Monto Propina" class="form-control" required="required" />
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Forma de Pago *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php

// consulta
$consulta="
select idforma, descripcion
from formas_pago 
where 
estado=1 
and idforma <>  7 
and idforma <> 8
order by descripcion asc
";

// valor seleccionado
if(isset($_POST['idforma'])){ 
	$value_selected=htmlentities($_POST['idforma']); 
}else{
	$value_selected='';
}

// parametros
$parametros_array=array(
	'nombre_campo' => 'idforma',
	'id_campo' => 'idforma',
	
	'nombre_campo_bd' => 'descripcion',
	'id_campo_bd' => 'idforma',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'Seleccionar...',
	'pricampo_value' => '', 
	'style_input' => 'class="form-control"', 
	'acciones' => ' required="required" ',
	'autosel_1registro' => 'S',
	//'opciones_extra' => $opciones_extra,

);

// construye campo
echo campo_select($consulta,$parametros_array);

?>
	
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Mozo Propina  *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
<?php 
// consulta
$consulta="
SELECT idusu as idmozo_propina, usuario
FROM usuarios
where
estado = 1
and soporte = 0
order by usuario asc
 ";


// valor seleccionado
if(intval($_POST['idmozo_propina']) > 0){ 
	$value_selected=htmlentities($_POST['idmozo_propina']); 
}else{
	$value_selected=$idusu_abremesa;
}

// parametros
$parametros_array=array(
	'nombre_campo' => 'idmozo_propina',
	'id_campo' => 'idmozo_propina',
	
	'nombre_campo_bd' => 'usuario',
	'id_campo_bd' => 'idmozo_propina',
	
	'value_selected' => $value_selected,
	
	'pricampo_name' => 'Seleccionar...',
	'pricampo_value' => '',
	'style_input' => 'class="form-control"', 
	'acciones' => '  ',
	'autosel_1registro' => 'S',
	//'opciones_extra' => $opciones_extra,

);

// construye campo
echo campo_select($consulta,$parametros_array);

?>
	
	(solo para asignacion por pago)
	</div>
</div>

<div class="clearfix"></div>
<br />

    <div class="form-group">
		<div class="col-md-12 col-sm-12 col-xs-12 text-center">
        
	   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar</button>
	   
	   
        </div>
    </div>

  <input type="hidden" name="MM_insert" value="form1" />
  <input type="hidden" name="form_control" value="<?php echo htmlentities($_SESSION['form_control']); ?>">
<br />
</form>
<div class="clearfix"></div>
<br /><br />

<hr />
<strong>Propinas Cargadas:</strong>
<?php
		
		
$consulta="
select mesas_atc_propinas.*, usuarios.usuario as mozo,
(select usuario from usuarios where mesas_atc_propinas.registrado_por = usuarios.idusu) as registrado_por_txt
from mesas_atc_propinas
left join usuarios on usuarios.idusu = mesas_atc_propinas.idmozo
where 
 mesas_atc_propinas.estado_prop = 1 
 and mesas_atc_propinas.idventa = $idventa
order by mesas_atc_propinas.registrado_el desc
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));


?>

<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>
			<th></th>

			<th align="center">Monto propina</th>
			<th align="center">Forma pago</th>
			<th align="center">Afecta caja</th>
			<th align="center">Mozo*</th>
			<th align="center">Idcaja</th>


			<th align="center">Carga posterior</th>
			<th align="center">Registrado por</th>
			<th align="center">Registrado el</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ ?>
		<tr>
			<td>
				<?php if($rs->fields['carga_posterior'] == 'S'){ ?>
				<div class="btn-group">
					<a href="propinas_posterior_del.php?idprop=<?php echo intval($rs->fields['propreg']); ?>" class="btn btn-sm btn-default" title="Borrar" data-toggle="tooltip" data-placement="right"  data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
				</div>
				<?php } ?>

			</td>

				<td align="right"><?php echo formatomoneda($rs->fields['monto_propina']);  ?></td>


				<td align="center"><?php echo antixss($rs->fields['mediopago']); ?></td>
				<td align="center"><?php echo antixss($rs->fields['afecta_caja']); ?></td>

				<td align="center"><?php echo antixss($rs->fields['mozo']); ?> [<?php echo intval($rs->fields['idmozo']); ?>]</td>
				<td align="center"><?php echo intval($rs->fields['idcaja']); ?></td>

				<td align="center"<?php if($rs->fields['carga_posterior'] == "S"){ ?>style="color:red;font-weight:bold;"<?php } ?>><?php echo siono($rs->fields['carga_posterior']); ?></td>
				<td align="center"><?php echo antixss($rs->fields['registrado_por_txt']); ?></td>
				<td align="center"><?php if($rs->fields['registrado_el'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['registrado_el'])); }  ?></td>
		</tr>
<?php 
$monto_propina_acum+=$rs->fields['monto_propina'];

$rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>

	  <tfoot>
		<tr>
			<td>Totales</td>
			<td align="right"><?php echo formatomoneda($monto_propina_acum); ?></td>
				<td></td>
				<td></td>
				
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>


		</tr>
	  </tfoot>
	  
    </table>
</div>
<br />

<strong>*Mozo:</strong> solo para el reporte de asignacion por pago, los demas reportes omitiran este mozo y asignaran otro segun el criterio de cada reporte.


<div class="clearfix"></div>

<br /><br />

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            

            
            
            
          </div>
        </div>
        <!-- /page content -->
		
        <!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
        
            <div class="modal-header">
            	<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
           		<h4 class="modal-title" id="modal_titulo">Titulo</h4>
            </div>
            <div class="modal-body" id="modal_cuerpo">
            	Contenido...
            </div>
            <div class="modal-footer" id="modal_pie">
            	<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>
        
        </div>
    </div>
</div>
        <!-- POPUP DE MODAL OCULTO -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
