<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="37";
$submodulo="528";
$dirsup="S";
require_once("../includes/rsusuario.php"); 




$consulta="
select * 
from (
    select 
    idclientepulsera, nombre, apellido,
    (select count(idpulsera) from pulseras where idclientepulsera = vta_pulseras.idclientepulsera and estado = 1)  as total_pulseras_abiertas,  
    (select count(idpulsera) from pulseras where idclientepulsera = vta_pulseras.idclientepulsera and estado = 2)  as total_pulseras_cerradas,  
    (select count(idpulsera) from pulseras where idclientepulsera = vta_pulseras.idclientepulsera and estado <> 6)  as total_pulseras,  
    sum(pulsera_entrada) as pulsera_entrada,
    sum(pulsera_cargas) as pulsera_cargas, 
    sum(pulsera_consumos) as pulsera_consumos,
    sum(pulsera_bajas) as pulsera_bajas,
    sum(pulsera_saldo) as pulsera_saldo,
    (
        select 
        CASE WHEN 
            pulseras.estado = 1
        THEN
            'ABIERTO'
        ELSE
            'CERRADO'
        END AS estado_pulsera
        from pulseras 
        where 
        idpulsera = max(vta_pulseras.idpulsera)
    ) as estado_pulsera
    from (
        select pulseras.idpulsera,  pulseras.idclientepulsera, clipul.nombre, clipul.apellido,
            pulseras.pulsera_cargas, pulseras.pulsera_consumos, pulseras.pulsera_bajas,
            pulseras.pulsera_saldo, pulseras.estado,
        CASE WHEN 
            pulseras.estado = 1
        THEN
            'ABIERTO'
        ELSE
            'CERRADO'
        END AS estado_pulsera, 
        (select sum(monto) as monto from pulseras_transacciones where idpulsera = pulseras.idpulsera and idtipotranspulsera=6 and estado = 1) as pulsera_entrada,
        clifac.razon_social as cliente_factura, clipul.razon_social as cliente_pulsera
        from pulseras 
        inner join  usuarios on usuarios.idusu = pulseras.abierto_por
        inner join cliente clipul on clipul.idcliente = pulseras.idclientepulsera
        inner join cliente clifac on clifac.idcliente = pulseras.idclientefactura
        where 
        pulseras.estado <> 6
		and pulsera_saldo >= 0 
    ) vta_pulseras
    group by idclientepulsera  
    ORDER BY `estado_pulsera` ASC
) as vta_consaldo
where
vta_consaldo.pulsera_saldo > 0
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("../includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("../includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("../includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("../includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Reporte de Pulseras</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<?php $refemenu='cli'; ?>		
<div class="btn-group">

<button class="btn btn-sm btn-<?php if($refemenu == 'gen'){ ?>primary<?php }else{ ?>default<?php } ?>" type="button" 
onmouseup="document.location.href='informe_pulseras.php'"><span class="fa fa-search"></span> General</button>


<button class="btn btn-sm btn-<?php if($refemenu == 'cli'){ ?>primary<?php }else{ ?>default<?php } ?>" type="button" 
onmouseup="document.location.href='informe_pulseras_por_cliente.php'"><span class="fa fa-search"></span> Clientes con saldo</button>


<br /> 
</div>  
<hr /> 
					

  
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>
			<th align="center">idcliente pulsera</th>
			<th align="center">Cliente</th>
			<th align="center">Abiertas</th>
			<th align="center">Cerradas</th>
            <th align="center">Total Pulseras</th>
			<th align="center">Saldo</th>
            <th align="center">Estado</th>
		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ ?>
		<tr>
			<td align="center"><?php echo antixss($rs->fields['idclientepulsera']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['nombre']); ?> <?php echo antixss($rs->fields['apellido']); ?></td>
			<td align="right"><?php echo formatomoneda($rs->fields['total_pulseras_abiertas']);  ?></td>
			<td align="right"><?php echo formatomoneda($rs->fields['total_pulseras_cerradas']);  ?></td>
			<td align="right"><?php echo formatomoneda($rs->fields['total_pulseras']);  ?></td>
			<td align="right"><?php echo formatomoneda($rs->fields['pulsera_saldo']);  ?></td>
			<td align="right"><?php echo antixss($rs->fields['estado_pulsera']);  ?></td>


		</tr>
<?php 
$total_pulseras_abiertas_acum+=$rs->fields['total_pulseras_abiertas'];
$total_pulseras_cerradas_acum+=$rs->fields['total_pulseras_cerradas'];
$total_pulseras_acum+=$rs->fields['total_pulseras'];
$pulsera_saldo_acum+=$rs->fields['pulsera_saldo'];


$rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>
	  <tfoot>
		<tr>
			<td>Totales</td>

			<td></td>

			<td align="right"><?php echo formatomoneda($total_pulseras_abiertas_acum); ?></td>
			<td align="right"><?php echo formatomoneda($total_pulseras_cerradas_acum); ?></td>
			<td align="right"><?php echo formatomoneda($total_pulseras_acum); ?></td>
			<td align="right"><?php echo formatomoneda($pulsera_saldo_acum); ?></td>
            <td></td>

		</tr>
	  </tfoot>
    </table>
</div>
<br />	

<div class="clearfix"></div>
<br /><br />	  

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            

            
            
            
          </div>
        </div>
        <!-- /page content -->
		  
        <!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
        
            <div class="modal-header">
            	<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
           		<h4 class="modal-title" id="modal_titulo">Titulo</h4>
            </div>
            <div class="modal-body" id="modal_cuerpo">
            	Contenido...
            </div>
            <div class="modal-footer" id="modal_pie">
            	<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>
        
        </div>
    </div>
</div>
        <!-- POPUP DE MODAL OCULTO -->

        <!-- footer content -->
		<?php require_once("../includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("../includes/footer_gen.php"); ?>
  </body>
</html>
