<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="28";
$submodulo="317";
require_once("includes/rsusuario.php"); 

if(trim($_GET['desde']) == '' or trim($_GET['hasta']) == ''){
	$desde=date("Y-m-").'01';
	$hasta=date("Y-m-d");
}else{
	$desde=date("Y-m-d",strtotime($_GET['desde']));
	$hasta=date("Y-m-d",strtotime($_GET['hasta']));	
}


$consulta="
select *,
(select usuario from usuarios where registro_comensales.registrado_por = usuarios.idusu) as registrado_por,
(select usuario from usuarios where registro_comensales.borrado_por = usuarios.idusu) as borrado_por,
CASE WHEN 
	idatc is not null
THEN
	(
	SELECT CONCAT('Mesa:',mesas.numero_mesa,' | Abierta el: ',DATE_FORMAT(mesas_atc.fecha_inicio,'%d/%m/%Y %H:%i'),' hs.') as descripcion
	FROM mesas_atc 
	inner join mesas on mesas.idmesa = mesas_atc.idmesa 
	WHERE 
	mesas_atc.idatc = registro_comensales.idatc
	) 
ELSE
	(
	SELECT CONCAT('Mesa: ',mesas.numero_mesa,' | Salon: ',salon.nombre)  as descripcion
	FROM mesas
	inner join salon on salon.idsalon = mesas.idsalon 
	where
	idmesa = registro_comensales.idmesa
	) 
END as datos_mesa
from registro_comensales 
where 
 estado = 1 
 AND date(registrado_el) >= '$desde'
 AND date(registrado_el) <= '$hasta'
order by registrado_el desc
limit 10000
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));



?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php //require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Registro de Comensales Reporte</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<p>
<a href="https://www.mspbs.gov.py/dependencias/portal/adjunto/f5dbd5-20200611ProtocoloServiciodeGastonomia.pdf" target="_blank" class="btn btn-sm btn-default"><span class="fa fa-file-pdf-o"></span> Protocolo Ministerio</a>
<a href="registro_comensales_aviso.php"  class="btn btn-sm btn-default"><span class="fa fa-file-pdf-o"></span> Ejemplo Aviso Cliente</a>
<a href="registro_comensales_imp_qr.php"  class="btn btn-sm btn-default"><span class="fa fa-file-pdf-o"></span> QR Entrada Local</a>
</p>
<hr />

<form id="form1" name="form1" method="get" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Desde *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="desde" id="desde" value="<?php  echo $desde; ?>" placeholder="Desde" class="form-control" required />                    

	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Hasta *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="date" name="hasta" id="hasta" value="<?php echo $hasta; ?>" placeholder="Hasta" class="form-control" required />                    

	</div>
</div>


<div class="clearfix"></div>
<br />


    <div class="form-group">
        <div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-5">
	   <button type="submit" class="btn btn-default" ><span class="fa fa-search"></span> Filtrar</button>

        </div>
    </div>


<br />
</form>        
<div class="clearfix"></div>
  <hr />
  <a href="registro_comensales_csv.php?desde=<?php echo $desde; ?>&hasta=<?php echo $hasta; ?>"  class="btn btn-sm btn-default"><span class="fa fa-file-excel-o"></span> Descargar</a>
  <br /> 
<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
	  <thead>
		<tr>
			<th></th>
			<th align="center">Nombres</th>
			<th align="center">Apellidos</th>
			<th align="center">Telefono</th>
            <th align="center">Direccion</th>
			<th align="center">Documento</th>
            <th align="center">Mesa Asignada</th>
			<th align="center">Observacion</th>
			<th align="center">Registrado el</th>
			<th align="center">Registrado por</th>

		</tr>
	  </thead>
	  <tbody>
<?php while(!$rs->EOF){ ?>
		<tr>
			<td>
				
				<div class="btn-group">
					<a href="registro_comensales_edit.php?id=<?php echo $rs->fields['idregcomensales']; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right"  data-original-title="Editar"><span class="fa fa-edit"></span></a>
					<a href="registro_comensales_del.php?id=<?php echo $rs->fields['idregcomensales']; ?>" class="btn btn-sm btn-default" title="Borrar" data-toggle="tooltip" data-placement="right"  data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
				</div>

			</td>
			<td align="center"><?php echo antixss($rs->fields['nombre']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['apellido']); ?></td>
			<td align="center">0<?php echo antixss($rs->fields['telefono']); ?></td>
            <td align="center"><?php echo antixss($rs->fields['direccion']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['documento']); ?></td>
            <td align="center"><?php echo antixss($rs->fields['datos_mesa']); ?></td>
			<td align="center"><?php echo antixss($rs->fields['observacion']); ?></td>
			<td align="center"><?php if($rs->fields['registrado_el'] != ""){ echo date("d/m/Y H:i:s",strtotime($rs->fields['registrado_el'])); }  ?></td>
			<td align="center"><?php echo antixss($rs->fields['registrado_por']); ?></td>

		</tr>
<?php $rs->MoveNext(); } //$rs->MoveFirst(); ?>
	  </tbody>
    </table>
</div>
<br />


                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
