<?php

require_once("../includes/funciones.php");
require_once("../includes/conexion.php");

class rrhhAPIMarcaciones {

    private static $apitoken = "267e855d-4323-4e85-b44a-57c460d71d23";
    private $msg;

    // Verificar si el token de acceso es válido antes de procesar la solicitud
    private function verificarToken($token) {
        
        // Aquí, debes comparar el token recibido con el token almacenado en el servidor
        return $token === self::$apitoken;

    }

    private function calcularHoraFinal($horario) {
        // Crear un objeto DateTime a partir del horario dado
        $fecha = new DateTime($horario);
        
        // Obtener los minutos de la hora
        $minutos = (int)$fecha->format('i');
        
        // Determinar la hora final
        if ($minutos >= 15) {
            // Si los minutos son 30 o más, establecer los minutos en 00 y agregar una hora
            $fecha->setTime((int)$fecha->format('H') + 1, 0);
        } else {
            // Si los minutos son menos de 30, establecer los minutos en 00
            $fecha->setTime((int)$fecha->format('H'), 0);
        }
        
        return $fecha->format('H:i');
      }

    private function obtieneNumeroDia($nroDia){

        switch ($nroDia) {
            case 7:
                $diaCorrespondiente = 1;
                break;
            case 6:
                $diaCorrespondiente = 7;
                break;
            case 5:
                $diaCorrespondiente = 6;
                break;
            case 4:
                $diaCorrespondiente = 5;
                break;
            case 3:
                $diaCorrespondiente = 4;
                break;
            case 2:
                $diaCorrespondiente = 3;
                break;
            case 1:
                $diaCorrespondiente = 2;
                break;
            default:
                echo "Día no válido";
                break;
        }

        return $diaCorrespondiente;

    }

    public function almacenaMarcacionFuncionario($datos){

        // Comprobar si la solicitud es una solicitud POST con JSON
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {

            // Verificar el token
            if ($this->verificarToken($datos['token'])) {

                // Genera la marcacion del usuario
                global $conexion;
                global $ahora;
                
                $ci=antisqlinyeccion($datos['funcionario'], "text");
                $numeroDeDia = date('N'); //1 Lunes, 2 Martes, 3 Miercoles, 4 Jueves, 5 Viernes, 6 Sabado, 7 Domingo
                $diaCorrespondiente = intval($this->obtieneNumeroDia($numeroDeDia));
                
                $buscar="Select * from rrhh_funcionarios where cedula=$ci";
                $rsu=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

                //traemos el tipo de regla del funcionario (tabla)
                #$tiporegla=intval($rsu->fields['idregla']);
                $idfuncionario=intval($rsu->fields['id']);

                //Trae el horario diario del funcionario
                $buscar="Select * from rrhh_horarios_funcionarios where id_funcionario=$idfuncionario and id_dia_laboral = $diaCorrespondiente and estado = 1";
                $rsu_horarios_funcionarios=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
            
                // Selecciona el periodo abierto actual
                $consulta="select id, activo, estado from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0";
                $rsperiodo = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
                $periodoActivoRows = $rsperiodo->recordCount();
                $id_periodo=antisqlinyeccion($rsperiodo->fields['id'], "int");

                //if ($periodoActivoRows > 0){

                    if ($idfuncionario > 0){
                            
                            $monto_hora_extra = 0;
                            $monto_descuento = 0;
                            #$idhorario=intval($rsu->fields['idhorario']);
                            //Segun el tipo de horario, buscamos los descuentos
                            $buscar="Select * from rrhh_reglas where id=1";
                            $rsreg=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
                            //Obtenemos la frecuencia y valor del principal a descontar
                            #$frecuencia=intval($rsreg->fields['frecuencia']);
                            #$valor=intval($rsreg->fields['descontargs']);
                            
                
                            # Si la hora del funcionario esta aclarado en la ficha del mismo, pisa el horario por defecto de las reglas
                            # Tiene en cuenta horario nocturno y dias libres
                
                            $hora_entrada_funcionario = (isset($rsu_horarios_funcionarios->fields['hora_entrada']) && isset($rsu_horarios_funcionarios->fields['hora_salida'])) ? strtotime($rsu_horarios_funcionarios->fields['hora_entrada']) :
                            (($rsu->fields['turno_nocturno'] == 0) ? strtotime($rsreg->fields['hora_entrada_horario_diurno']) : strtotime($rsreg->fields['hora_entrada_horario_nocturno']));
                            
                            $hora_entrada_funcionario_aux = $hora_entrada_funcionario;

                            $hora_salida_funcionario = (isset($rsu_horarios_funcionarios->fields['hora_entrada']) && isset($rsu_horarios_funcionarios->fields['hora_salida'])) ? strtotime($rsu_horarios_funcionarios->fields['hora_salida']) : (($rsu->fields['turno_nocturno'] == 0) ? strtotime($rsreg->fields['hora_salida_horario_diurno']) : strtotime($rsreg->fields['hora_salida_horario_nocturno']));

                            $hora_actual = date('H:i');
                            $hora_actual_dt = new DateTime($hora_actual);

                            // La hora computo entrada por defecto va a ser la hora de ingreso del funcionario
                            $hora_computo = date('H:i', $hora_entrada_funcionario);

                            // La hora computo salida por defecto va a ser la hora de ingreso del funcionario
                            $hora_computo_salida = date('H:i', $hora_salida_funcionario);


                            if($datos['tipo'] == 1){ // La hora a marcar es entrada
                
                                // Verifica que no haya marcaciones de entrada ya registradas en el mismo dia
                                $buscarmarcaciones="SELECT idseria 
                                FROM gest_registros 
                                WHERE id_funcionario = $idfuncionario
                                    AND fechahora >= CURDATE() 
                                    AND fechahora < DATE_ADD(CURDATE(), INTERVAL 1 DAY) 
                                    AND tipo = 1;";
                                $rsmarcaciones=$conexion->Execute($buscarmarcaciones) or die(errorpg($conexion,$buscarmarcaciones));
                                $rsmarcacionesCount = $rsmarcaciones->recordCount();

                                if($rsmarcacionesCount == 0){
                                    
                                    // Calcula si el usuario va a tener descuento por llegada tardia
                                    if($hora_entrada_funcionario>$hora_actual){
                    
                                        // Calcula si aplica el descuento
                                        $minutos_tolerancia = $rsreg->fields['minutos_tolerancia'];
                                        $hora_entrada_funcionario = new DateTime(date('H:i', $hora_entrada_funcionario));
                    
                                        $diferencia = $hora_actual_dt->diff($hora_entrada_funcionario);
                                        $minutos = $diferencia->h * 60 + $diferencia->i;
                                        $segundos = $diferencia->s;
                    
                                        if($minutos>$minutos_tolerancia){ // Si es que paso el tiempo de tolerancia, aplica el descuento

                                            # Si el funcionario esta marcado como no descontar por llegada tardia, no se le descuenta

                                            $aplica_descuento_llegada_tardia = intval($rsu->fields['descuenta_llegada_tardia']);

                                            if($aplica_descuento_llegada_tardia == 1){

                                                # Calcula cuanto tiempo tardo en marcar desde su hora de entrada
                                                $hora_actual = time();
                                                $segundos_pasados = $hora_actual - $hora_entrada_funcionario_aux; // Calcula los segundos transcurridos.
                                                $horas_pasadas = floor($segundos_pasados / 3600); // Convierte segundos a horas (1 hora = 3600 segundos).
                                                $horas_pasadas_calculo_descuento = $horas_pasadas + 1; //Le suma 1 ya que si paso una hora, debe multiplicarse por 2 el descuento

                                                $monto_descuento = $rsreg->fields['monto_descuento_ingreso_tardio'] * round($horas_pasadas_calculo_descuento);
                                                $rsu->fields['turno_nocturno'] = ($monto_descuento>0)?$monto_descuento:0;

                                            }else{

                                                $monto_descuento = 0;

                                            }

                                            // Tambien recalcula la hora computo
                                            //$hora_computo = date('H:i', strtotime($rsu_horarios_funcionarios->fields['hora_entrada']. ' +1 hour'));
                                            $hora_formateada_actual = date("H:i");  // Hora actual formateada/ Extraer solo la hora
                                            $hora_computo = $this->calcularHoraFinal($hora_formateada_actual);  // Sumar una hora y formatear a H:00 a H:00

                    
                                        }
                    
                                    }

                                    $cual = intval($datos['tipo']);

                                    $insertar="Insert into gest_registros 
                                    (id_funcionario, documento,tipo,ipreal,descuento,total_minutos,total_frecuencias,fechahora, hora_computo,
                                    monto_hora_extra, id_periodo)
                                    values 
                                    ($idfuncionario,$ci,$cual,'',$monto_descuento,0,0,'$ahora', '$hora_computo',0, $id_periodo)
                                    ";
                                    $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
            
                                    $this->msg = 'Se marco correctamente la entrada de '.$rsu->fields['nombres'].' '.$rsu->fields['apellidos']; 

                                }else{

                                    header('Content-Type: application/json');
                                    echo json_encode(array('success' => false, 'msg' => 'Ya existe una marcacion de entrada en el dia de '.$rsu->fields['nombres'].' '.$rsu->fields['apellidos']));
                                    die();

                                }
                
                            }else{ // La hora es salida

                                // Verifica que no haya marcaciones de entrada ya registradas en el mismo dia
                                $buscarmarcaciones="SELECT idseria 
                                FROM gest_registros 
                                WHERE id_funcionario = $idfuncionario
                                    AND fechahora >= CURDATE() 
                                    AND fechahora < DATE_ADD(CURDATE(), INTERVAL 1 DAY) 
                                    AND tipo = 2;";
                                $rsmarcaciones=$conexion->Execute($buscarmarcaciones) or die(errorpg($conexion,$buscarmarcaciones));
                                $rsmarcacionesCount = $rsmarcaciones->recordCount();

                                if($rsmarcacionesCount == 0){

                                    // Calcula si el usuario va a tener ganancia por hora extra
                                    if($hora_actual>$hora_salida_funcionario){
                    
                                        // Calcula si aplica o no las horas extras
                                        $minutos_hora_extra = $rsreg->fields['minuto_consideracion_hora_extra'];
                                        $hora_salida_funcionario = new DateTime(date('H:i', $hora_salida_funcionario));
                    
                                        $diferencia = $hora_actual_dt->diff($hora_salida_funcionario);
                    
                                        $minutos = $diferencia->h * 60 + $diferencia->i;
                    
                                        if($minutos>=$minutos_hora_extra){ // Si los minutos extra fue mayor igual a el minimo establecido, aplica el pago extra
                    
                                            // Divide la cantidad de minutos extra por la regla de minutos extra para conocer si se paga el doble, etc.
                                            $division = floor($minutos/$minutos_hora_extra);
                                            // Multiplica el monto por hora extra cumplida
                    
                                            // Calcula el salario diario del funcionario
                                            $rest_division_salario_mes = round($rsu->fields['salario']/30);
                                            $rest_division_salario_dia = round($rest_division_salario_mes/8);
                    
                                            if($rsu->fields['turno_nocturno'] == 0){ // Si es que el horario del funcionario es diurno
                    
                                                $monto_hora_extra = $division*($rest_division_salario_dia*($rsreg->fields['tasa_pago_hora_extra_diurno']/100));
                    
                                            }else{ // Si el horario del funcionario es nocturno
                    
                                                $monto_hora_extra = $division*($rest_division_salario_dia*($rsreg->fields['tasa_pago_hora_extra_nocturno']/100));
                    
                                            }
                                        }
                    
                                    }

                                    // Calcula pago extra por horario nocturno
                                    if($rsu->fields['turno_nocturno'] == 1){

                                        // Calcula el salario diario del funcionario
                                        $rest_division_salario_mes = round($rsu->fields['salario']/30);
                                        $rest_division_salario_dia = round($rest_division_salario_mes/8);
                        
                                        $monto_extra_nocturno = ($rsreg->fields['tasa_pago_horario_nocturno']/100)*$rest_division_salario_dia;
                                        $monto_hora_extra = $monto_hora_extra + $monto_extra_nocturno;
                                        $monto_hora_extra = ($monto_hora_extra>0)?$monto_hora_extra:0;
                        
                                    }

                                    $cual = intval($datos['tipo']);

                                    // Calcula la hora de computo
                                    if($ahora>$hora_entrada_funcionario){

                                        //$hora_computo_salida = date('H:i', strtotime($rsu_horarios_funcionarios->fields['hora_salida']));
                                        $hora_formateada_actual = date("H:i");  // Hora actual formateada/ Extraer solo la hora
                                        $hora_computo_salida = $this->calcularHoraFinal($hora_formateada_actual);  // Sumar una hora y formatear a H:00 a H:00
            

                                    }

                                    $insertar="Insert into gest_registros 
                                    (id_funcionario, documento,tipo,ipreal,descuento,total_minutos,total_frecuencias,fechahora,hora_computo, 
                                    monto_hora_extra, id_periodo)
                                    values 
                                    ($idfuncionario,$ci,$cual,'',0,0,0,'$ahora', '$hora_computo_salida', $monto_hora_extra, $id_periodo)
                                    ";
                                    $conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
            
                                    $this->msg = 'Se marco correctamente la salida de '.$rsu->fields['nombres'].' '.$rsu->fields['apellidos']; 

                                }else{

                                    header('Content-Type: application/json');
                                    echo json_encode(array('success' => false, 'msg' => 'Ya existe una marcacion de salida en el dia de '.$rsu->fields['nombres'].' '.$rsu->fields['apellidos']));
                                    die();

                                }
                
                            }
                    
                    }else{
                
                        $this->msg = 'El funcionario no existe, no se marcó la asistencia';        
                        
                    }

                    // El token es válido, procesa los datos del JSON aquí
                    // Por ejemplo, aquí simplemente devolveremos el JSON recibido
                    header('Content-Type: application/json');
                    echo json_encode(array('success' => true, 'msg' => $this->msg));

                /*}else{

                    header('Content-Type: application/json');
                    echo json_encode(array('success' => false, 'msg' => 'No existe un periodo activo, no se marcó la asistencia'));
                    die();

                }*/

            } else {

                // El token no es válido
                header('HTTP/1.1 401 Unauthorized');
                echo json_encode(array('success' => false, 'msg' => 'Acceso no autorizado'));

            }

        } else {

            // Método de solicitud incorrecto o el contenido no es JSON
            header('HTTP/1.1 400 Bad Request');
            echo json_encode(array('success' => false, 'msg' => 'Solicitud incorrecta'));

        }

    }

}

// Leer el JSON enviado
$data = json_decode(file_get_contents('php://input'), true);
$objMarcaciones = new rrhhAPIMarcaciones();

$objMarcaciones->almacenaMarcacionFuncionario($data);