<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo="1";
$submodulo="2";
require_once("../includes/rsusuario.php"); 

$consulta="
SELECT 
    *
FROM
    (SELECT 
        form1.id,
            form1.id_funcionario,
            (SELECT 
                    CONCAT(nombres, ' ', apellidos)
                FROM
                    rrhh_funcionarios
                WHERE
                    id = form1.id_funcionario) AS nombre_funcionario,
            form1.nombre_institucion,
            form1.ano_culminacion,
            form1.bachillerato_obtenido as titulo_obtenido,
            form1.registrado_el,
            1 AS tipo_formacion
    FROM
        rrhh_formacion_secundaria form1
    WHERE estado = 1
    UNION ALL SELECT 
        form2.id,
            form2.id_funcionario,
            (SELECT 
                    CONCAT(nombres, ' ', apellidos)
                FROM
                    rrhh_funcionarios
                WHERE
                    id = form2.id_funcionario) AS nombre_funcionario,
            form2.nombre_universidad AS nombre_institucion,
            form2.ano_culminacion,
            form2.titulo_obtenido as titulo_obtenido,
            form2.registrado_el,
            2 AS tipo_formacion
    FROM
        rrhh_formacion_universitaria form2 
    WHERE estado = 1
    UNION ALL SELECT 
        form3.id,
            form3.id_funcionario,
            (SELECT 
                    CONCAT(nombres, ' ', apellidos)
                FROM
                    rrhh_funcionarios
                WHERE
                    id = form3.id_funcionario) AS nombre_funcionario,
            form3.institucion AS nombre_institucion,
            form3.ano_culminacion,
            form3.titulo_obtenido as titulo_obtenido,
            form3.registrado_el,
            3 AS tipo_formacion
    FROM
        rrhh_formacion_tecnica form3 
    WHERE estado = 1
UNION ALL SELECT 
        form4.id,
            form4.id_funcionario,
            (SELECT 
                    CONCAT(nombres, ' ', apellidos)
                FROM
                    rrhh_funcionarios
                WHERE
                    id = form4.id_funcionario) AS nombre_funcionario,
            form4.nombre_institucion,
            form4.ano_culminacion,
            form4.titulo_obtenido as titulo_obtenido,
            form4.registrado_el,
            4 AS tipo_formacion
    FROM
        rrhh_formacion_post_universitaria form4
    WHERE estado = 1) AS todo
ORDER BY registrado_el DESC
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

?>
<!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("../includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("../includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("../includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			      <?php require_once("../includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Formaci&oacute;n acad&eacute;mica de funcionarios</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
                    <div class="btn-group">
                      <a href="rrhh_formacion_funcionarios_secundaria_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar bachillerato</a>
                      <a href="rrhh_formacion_funcionarios_universidad_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar estudio universitario</a>
                      <a href="rrhh_formacion_funcionarios_tecnico_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar estudio t&eacute;cnico</a>
                      <a href="inventario_pagares_listado_pagares.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar estudio post universitario</a>
                    </div>
                    <hr />
                    <div class="table-responsive">
                        <table width="100%" class="table table-bordered jambo_table bulk_action">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th align="center">Funcionario</th>
                                    <th align="center">Instituci&oacute;n</th>
                                    <th align="center">Fecha de culminaci&oacute;n</th>
                                    <th align="center">T&iacute;tulo obtenido</th>
                                    <th align="center">Tipo de formaci&oacute;n</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php while(!$rs->EOF){ ?>
                                <tr>
                                    <td>
                                      <div class="btn-group"> 
                                        <?php if($rs->fields['tipo_formacion'] == 1){ ?>                                       
                                          <a href="rrhh_funcionarios_det.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Detalle" data-toggle="tooltip" data-placement="right"  data-original-title="Detalle"><span class="fa fa-search"></span></a>
                                          <a href="rrhh_formacion_funcionarios_secundaria_edit.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right"  data-original-title="Editar"><span class="fa fa-edit"></span></a>
                                          <a href="rrhh_formacion_funcionarios_secundaria_del.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="" data-toggle="tooltip" data-placement="right" data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
                                        <?php }else if($rs->fields['tipo_formacion'] == 2){ ?>
                                          <a href="rrhh_funcionarios_det.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Detalle" data-toggle="tooltip" data-placement="right"  data-original-title="Detalle"><span class="fa fa-search"></span></a>
                                          <a href="rrhh_formacion_funcionarios_universidad_edit.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right"  data-original-title="Editar"><span class="fa fa-edit"></span></a>
                                          <a href="rrhh_formacion_funcionarios_universidad_del.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="" data-toggle="tooltip" data-placement="right" data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
                                        <?php }else if($rs->fields['tipo_formacion'] == 3){ ?>
                                          <a href="rrhh_funcionarios_det.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Detalle" data-toggle="tooltip" data-placement="right"  data-original-title="Detalle"><span class="fa fa-search"></span></a>
                                          <a href="rrhh_formacion_funcionarios_tecnico_edit.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right"  data-original-title="Editar"><span class="fa fa-edit"></span></a>
                                          <a href="rrhh_formacion_funcionarios_tecnico_del.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="" data-toggle="tooltip" data-placement="right" data-original-title="Borrar"><span class="fa fa-trash-o"></span></a>
                                        <?php } ?>
                                      </div>
                                    </td>                                    
                                    <td align="center"><?php echo antixss($rs->fields['nombre_funcionario']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['nombre_institucion']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['ano_culminacion']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['titulo_obtenido']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['tipo_formacion']); ?></td>
                                </tr>
                                <?php 
                                    $rs->MoveNext(); } //$rs->MoveFirst(); ?>
                            </tbody>
                        </table>
                    </div>
                    <br /><br />
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION -->
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("../includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("../includes/footer_gen.php"); ?>
  </body>
</html>
