<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo="18";
$submodulo="97";
// Directorio destino de las imagenes de perfil
$destino = '../gfx/usuarios/';
require_once("../includes/rsusuario.php"); 

$consulta="
select *,
(select usuario from usuarios where rf.registrado_por = usuarios.idusu) as registrado_por,
(select usuario from usuarios where rf.borrado_por = usuarios.idusu) as borrado_por
from rrhh_funcionarios rf
where 
 rf.estado <> 6 
order by rf.registrado_el asc
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

?>
<!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("../includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("../includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("../includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			      <?php require_once("../includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Listado de funcionarios</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
                    <div class="col-xs-12" style="padding-right:0;padding-left:0;">
                      <div class="col-md-1" style="padding-right:0;padding-left:0;">
                      <p><a href="rrhh_funcionarios_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar</a></p>
                      </div>
                      <div class="col-md-1" style="padding-right:0;padding-left:0;">
                        <button type="button" class="btn btn-sm btn-info recalcular-vacaciones" onclick="importar_funcionarios()">
                            <span class="fa fa-refresh"></span> Importar funcionarios de versi&oacute;n anterior
                        </button>
                      </div>
                    </div>
                    <hr />
                    <div class="table-responsive">
                        <table width="100%" class="table table-bordered jambo_table bulk_action">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th></th>
                                    <th align="center">Nombres</th>
                                    <th align="center">Apellidos</th>
                                    <th align="center">Cedula</th>
                                    <th align="center">Fecha ingreso</th>
                                    <th align="center">Fecha salida</th>
                                    <th align="center">Celular</th>
                                    <th align="center">Estado</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php while(!$rs->EOF){ ?>
                                <tr>
                                    <td>
                                        
                                        <div class="btn-group">
                                            <a href="rrhh_funcionarios_edit.php?id=<?php echo $rs->fields['id']; ?>" class="btn btn-sm btn-default" title="Detalle" data-toggle="tooltip" data-placement="right"  data-original-title="Detalle"><span class="fa fa-search"></span></a>
                                        </div>

                                    </td>
                                    <td align="center"><img src="<?php echo ($rs->fields['imagen_perfil'] =='')?antixss($destino.'avatar_2x.png'):antixss($destino.$rs->fields['imagen_perfil']); ?>" style="width: 50px; height: 50px;" id="avatar" class="img-circle img-thumbnail" alt="avatar"></td>
                                    <td align="center"><?php echo antixss($rs->fields['nombres']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['apellidos']); ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['cedula']); ?></td>
                                    <td align="center"><?php if($rs->fields['fecha_ingreso'] != ""){ echo date("d/m/Y",strtotime($rs->fields['fecha_ingreso'])); }  ?></td>
                                    <td align="center"><?php if($rs->fields['fecha_salida'] != ""){ echo date("d/m/Y",strtotime($rs->fields['fecha_salida'])); }  ?></td>
                                    <td align="center"><?php echo antixss($rs->fields['celular']); ?></td>
                                    <td align="center"><?php echo (antixss($rs->fields['estado'])==1)?'Activo':'Inactivo'; ?></td>
                                </tr>
                                <?php 
                                    $rs->MoveNext(); } //$rs->MoveFirst(); ?>
                            </tbody>
                        </table>
                    </div>
                    <br /><br />
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION -->
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("../includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("../includes/footer_gen.php"); ?>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jquery-confirm/3.3.2/jquery-confirm.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-confirm/3.3.2/jquery-confirm.min.js"></script>
    <script>
      function importar_funcionarios(){

        $.confirm({
            title: "Importar funcionarios",
            content: "¿Desea recalcular importar los funcionarios de la versi&oacute;n anterior?",
            buttons: {
                confirm: {
                    text: "Importar",
                    action: function() {
                      $.ajax({
                        url: "rrhh_importar_funcionarios_version_anterior.php",
                        method: "POST",
                        dataType: "json",
                        data: {
                          'MM_insert': 'IMPORTAR_FUNCIONARIOS',
                        },
                        success: function(response) {

                          if(response.estado == 'success'){
    
                            location.reload();

                          }else{

                            alert(response.msg);

                          }

                        },
                        error: function(xhr, status, error) {
                          // Manejar errores de la solicitud AJAX
                          alert("Error al importar funcionarios: " + error);
                        }
                      });
                  }
                },
                cancel: {
                    text: "Cancelar",
                    action: function() {}
                }
            }
        });

      }
    </script>
  </body>
</html>
