<?php

require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="18";
$submodulo="587";
require_once("../includes/rsusuario.php");

//-------------------------------------------------------------------------------------------------
//********************** REGISTRA SALARIOS DE FUNCIONARIOS DEL PERIODO ****************************
//-------------------------------------------------------------------------------------------------
if(isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'GENERAR_SALARIO_FUNCIONARIOS'){

  $registrado_por=$idusu;
  
  // Obtiene los datos del periodo actual
  $consulta="SELECT id, mes, ano, fecha_inicio, fecha_fin FROM rrhh_periodos where activo =1 and estado =1 and cerrado = 0";
  $rsperiodos = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

  $id_periodo=antisqlinyeccion($rsperiodos->fields['id'], "int");
 
  $reglas="select porcentaje_ips_empleado from rrhh_reglas where id = 1";
  $rsreglas=$conexion->Execute($reglas) or die(errorpg($conexion,$reglas));

  $fecha_inicio=antisqlinyeccion($rsperiodos->fields['fecha_inicio'].' 00:00:00',"text");
  $fecha_fin=antisqlinyeccion($rsperiodos->fields['fecha_fin'].' 23:59:59',"text");
  $porcentaje_ips_funcionario=antisqlinyeccion($rsreglas->fields['porcentaje_ips_empleado'], "double");

  // Si hay salarios generados del periodo actual y ocurrio un error, borrar todos los creados anteriormente
  $reinicio_salarios="delete from rrhh_salarios_generados where id_periodo = $id_periodo";
  $conexion->Execute($reinicio_salarios) or die(errorpg($conexion,$reinicio_salarios));

  // Obtiene el salario final por cada funcionario
  $consulta="select *,
            (select
                    sum(monto_hora_extra)
                from
                    gest_registros
                where
                estado = 1
                    and id_funcionario = todo.id
                    and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)) as monto_horas_extras,
            case
                when (todo.fecha_ingreso_ips is null) then 0
                when (todo.fecha_ingreso_ips is not null
                    and todo.salario_ips <> 0
                    and todo.salario_descuento_ips_con_permisos_no_ips = todo.salario) then ((todo.salario_ips) * ($porcentaje_ips_funcionario / 100))
                when (todo.fecha_ingreso_ips is not null
                    and todo.salario_ips <> 0
                    and todo.salario <> todo.salario_descuento_ips_con_permisos_no_ips) then ((todo.salario_descuento_ips_con_permisos_no_ips)  * ($porcentaje_ips_funcionario / 100))
                when todo.fecha_ingreso_ips is not null
                and todo.salario_ips <> 0
                and (todo.salario_descuento_ips_con_permisos_no_ips is null)
                and total_permisos_mes is not null then ((todo.salario) * ($porcentaje_ips_funcionario / 100))
                else (todo.salario * ($porcentaje_ips_funcionario / 100))
            end as monto_ips
            from (select rrhhfunc.*,
            (
                SELECT 
                    SUM(DATEDIFF(fecha_permiso_fin, fecha_permiso_inicio) + 1) AS total_dias_permiso
                FROM 
                    rrhh_funcionarios_permisos
                WHERE 
                    id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0) 
                AND estado = 1
                AND idfunci = rrhhfunc.id
                GROUP BY 
                    idfunci

            ) as total_permisos_mes,
(
  select 
      case
          when rrhhfunc.salario_ips is null then rrhhfunc.salario - 
          (
              select sum((rrhhfunc.salario / 30) * (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1))
              from rrhh_funcionarios_permisos fp 
              join rrhh_permisos_tipos tp on fp.id_tipo_permiso = tp.id 
              where fp.estado = 1 
              and tp.permiso_ips = 1 
              and fp.idfunci = rrhhfunc.id 
              and id_periodo = (
                  select id 
                  from rrhh_periodos 
                  where estado = 1 and activo = 1 and cerrado = 0
              ) 
              and DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) >= 1
          )
          when rrhhfunc.salario_ips is not null then rrhhfunc.salario_ips - 
          (
              select sum((rrhhfunc.salario_ips / 30) * (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1))
              from rrhh_funcionarios_permisos fp 
              join rrhh_permisos_tipos tp on fp.id_tipo_permiso = tp.id 
              where fp.estado = 1 
              and tp.permiso_ips = 1 
              and fp.idfunci = rrhhfunc.id 
              and id_periodo = (
                  select id 
                  from rrhh_periodos 
                  where estado = 1 and activo = 1 and cerrado = 0
              ) 
              and DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) >= 1
          )
          else 0
      end
) as salario_descuento_ips,
(
  select 
      case
          when rrhhfunc.salario_ips is null then rrhhfunc.salario - 
          (
              select sum((rrhhfunc.salario / 30) * (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1))
              from rrhh_funcionarios_permisos fp 
              join rrhh_permisos_tipos tp on fp.id_tipo_permiso = tp.id 
              where fp.estado = 1 
              and ((tp.permiso_ips = 1 and DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) >= 1) or (tp.permiso_ips = 0 and (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1) = 1))
              and fp.idfunci = rrhhfunc.id 
              and id_periodo = (
                  select id 
                  from rrhh_periodos 
                  where estado = 1 and activo = 1 and cerrado = 0
              )
          )
          when rrhhfunc.salario_ips is not null then rrhhfunc.salario_ips - 
          (
              select sum((rrhhfunc.salario_ips / 30) * (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1))
              from rrhh_funcionarios_permisos fp 
              join rrhh_permisos_tipos tp on fp.id_tipo_permiso = tp.id 
              where fp.estado = 1 
              and ((tp.permiso_ips = 1 and DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) >= 1) or (tp.permiso_ips = 0 and (DATEDIFF(fp.fecha_permiso_fin, fp.fecha_permiso_inicio) + 1) = 1))
              and fp.idfunci = rrhhfunc.id 
              and id_periodo = (
                  select id 
                  from rrhh_periodos 
                  where estado = 1 and activo = 1 and cerrado = 0
              )
          )
          else 0
      end
) as salario_descuento_ips_con_permisos_no_ips,
            (select sum(monto) 
            from rrhh_extras 
            where id_funcionario = rrhhfunc.id and suma_salario = 1  and estado = 1
            and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)) as monto_extras_suma,
            (select sum(monto) 
            from rrhh_extras 
            where id_funcionario = rrhhfunc.id and suma_salario = 2 and estado = 1
            and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)) as monto_extras_no_suma,
            (select
                    sum(descuento)
                from
                    gest_registros
                where
                estado = 1
                    and id_funcionario = rrhhfunc.id
                and (fechahora >= (select fecha_inicio from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)
                and fechahora <= (select fecha_fin from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0))
                ) as descuentos,
            (select
                    sum(rrhhpermitipo.montodes)
                from
                    rrhh_funcionarios_permisos rrhhpermi
                left join rrhh_permisos_tipos rrhhpermitipo on rrhhpermitipo.id = rrhhpermi.id_tipo_permiso
                where
                rrhhpermi.estado = 1
                    and idfunci = rrhhfunc.id
                    and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)) as descuentos_permisos,
            (select
                    sum(monto)
                from
            rrhh_descuentos_funcionarios
                where
                    id_funcionario = rrhhfunc.id
                    and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)
                and estado=1) as descuentos_funcionarios,
            (select
                    sum(monto)
                from
            rrhh_anticipos
                where 
                    id_funcionario = rrhhfunc.id
                    and id_periodo = (select id from rrhh_periodos where estado = 1 and activo = 1 and cerrado = 0)
                and estado=1) as anticipos_funcionarios
            from rrhh_funcionarios rrhhfunc
            where estado = 1
            $where_filtro) as todo
            order by todo.id asc";
    
  $rsgeneracion = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
  
    // Obtiene la cantidad de dias que el empleado lleva en la empresa para el periodo actual
    $buscar_dias_trabajados_funcionario="SELECT 
        f.id as id_funcionario,
        p.id AS id_periodo,
        GREATEST(p.fecha_inicio, f.fecha_ingreso) AS fecha_inicio_trabajo,
        LEAST(p.fecha_fin, CURRENT_DATE()) AS fecha_fin_trabajo,
        DATEDIFF(
            LEAST(p.fecha_fin, CURRENT_DATE()), 
            GREATEST(p.fecha_inicio, f.fecha_ingreso)
        ) + 1 AS dias_trabajados
    FROM 
        rrhh_funcionarios f
    JOIN 
        rrhh_periodos p
    ON 
        f.fecha_ingreso <= p.fecha_fin
    WHERE 
        f.fecha_ingreso <= p.fecha_fin
        AND GREATEST(p.fecha_inicio, f.fecha_ingreso) <= LEAST(p.fecha_fin, CURRENT_DATE())
        AND p.estado = 1 and p.activo = 1 and p.cerrado = 0
        AND f.estado = 1";
    $rs_dias_trabajados=$conexion->Execute($buscar_dias_trabajados_funcionario) or die(errorpg($conexion,$buscar_dias_trabajados_funcionario));

  // Genera el salario por cada funcionario
  $sqlinsercionsalarios = '';

  while(!$rsgeneracion->EOF){

    $rs_dias_trabajados->MoveFirst();
    while(!$rs_dias_trabajados->EOF){

      if($rs_dias_trabajados->fields['id_funcionario'] == $rsgeneracion->fields['id']){

        $dias_trabajados = intval($rs_dias_trabajados->fields['dias_trabajados']);

      }

      $rs_dias_trabajados->MoveNext();

    }


    $id_funcionario=antisqlinyeccion($rsgeneracion->fields['id'], "int");

    if($dias_trabajados>=30) {

        $salario= (intval($rsgeneracion->fields['salario_descuento_ips']) == 0) ? intval($rsgeneracion->fields['salario']) : intval($rsgeneracion->fields['salario_descuento_ips']);
          
        $base_salario = (intval($rsgeneracion->fields['salario_descuento_ips']) == 0)
            ? $rsgeneracion->fields['salario']
            : intval($rsgeneracion->fields['salario_descuento_ips']);
        
        $suma_extras = intval($rsgeneracion->fields['monto_extras_suma']) + intval($rsgeneracion->fields['monto_horas_extras']);
        $resta_descuentos = intval($rsgeneracion->fields['monto_ips']) + intval($rsgeneracion->fields['descuentos'])
            + intval($rsgeneracion->fields['descuentos_permisos']) + intval($rsgeneracion->fields['descuentos_funcionarios'])
            + intval($rsgeneracion->fields['anticipos_funcionarios']);
        
        $salario_cobrar = $base_salario + $suma_extras - $resta_descuentos;


        $salario_a_cobrar_neto= $salario_cobrar + intval($rsgeneracion->fields['monto_extras_no_suma']) ;

    }else{

        $salario= intval(round(($rs->fields['salario']/30)*$dias_trabajados));
        $salario_cobrar=antisqlinyeccion((intval(round(($rs->fields['salario']/30)*$dias_trabajados)) + intval($rsgeneracion->fields['monto_extras_suma']) + intval($rsgeneracion->fields['monto_horas_extras'])) - (intval($rsgeneracion->fields['monto_ips']) + intval($rsgeneracion->fields['descuentos']) + intval($rsgeneracion->fields['descuentos_permisos']) + intval($rsgeneracion->fields['descuentos_funcionarios'] + intval($rsgeneracion->fields['anticipos_funcionarios']))), "int");
        $salario_a_cobrar_neto=intval(round(($rs->fields['salario']/30)*$dias_trabajados) + $rsgeneracion->fields['salario_descuento_ips']) + intval($rsgeneracion->fields['monto_extras_no_suma']) + intval($rsgeneracion->fields['monto_extras']) + intval($rsgeneracion->fields['monto_horas_extras']) - (intval($rsgeneracion->fields['monto_ips']) + intval($rsgeneracion->fields['descuentos']) + intval($rsgeneracion->fields['descuentos_permisos']) + intval($rsgeneracion->fields['descuentos_funcionarios'] + intval($rsgeneracion->fields['anticipos_funcionarios']) + intval($rsgeneracion->fields['monto_extras_suma'])));

    }

    $extras= intval($rsgeneracion->fields['monto_extras_suma']);
    $extras_no_suma= intval($rsgeneracion->fields['monto_extras_no_suma']);
    $horas_extras= intval($rsgeneracion->fields['monto_horas_extras']);
    $ips= intval($rsgeneracion->fields['monto_ips']);
    $descuentos= intval($rsgeneracion->fields['descuentos_funcionarios']);
    $descuentos_llegadas_tardias= intval($rsgeneracion->fields['descuentos']);
    $descuentos_permisos= intval($rsgeneracion->fields['descuentos_permisos']);
    $anticipos= intval($rsgeneracion->fields['anticipos_funcionarios']);
    $fecha_generacion = date('Y-m-d H:i:s');

    $sqlinsercionsalarios = "insert into rrhh_salarios_generados (id_funcionario, id_periodo, salario, extras, extras_no_suma, 
                                horas_extras, ips, descuentos, descuentos_llegadas_tardias, descuentos_permisos, anticipos, salario_a_cobrar, 
                                salario_a_cobrar_neto, fecha_generacion) 
                                values ($id_funcionario, $id_periodo, $salario, $extras, $extras_no_suma, $horas_extras, $ips, $descuentos,
                                $descuentos_llegadas_tardias, $descuentos_permisos, $anticipos, $salario_cobrar, $salario_a_cobrar_neto, '$fecha_generacion');";
                                
    $conexion->Execute($sqlinsercionsalarios) or die(errorpg($conexion,$sqlinsercionsalarios));

    $rsgeneracion->MoveNext();

  }

  // Cierra el periodo

  $update="UPDATE rrhh_periodos SET activo = 0, cerrado = 1, cerrado_por = $idusu, cerrado_el='$ahora' WHERE id=$id_periodo";
  $conexion->Execute($update) or die(errorpg($conexion,$update));

  // genera array con los datos
	$arr = array(
    'estado' => 'success',
    'msg' => 'Los salarios han sido creados'
  );
  
  // convierte a formato json
  $respuesta=json_encode($arr, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
  
  // devuelve la respuesta formateada
  echo $respuesta;

}