<?php

require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo="18";
//$submodulo="604";
$submodulo="648"; //Produccion
$destino = '../gfx/usuarios/';
require_once("../includes/rsusuario.php"); 

if(file_exists('../clases/mpdf/vendor/autoload.php')){
	require_once('../clases/mpdf/vendor/autoload.php');
} else {
	if (file_exists('../../clases/mpdf/vendor/autoload.php')){
    require_once('../../clases/mpdf/vendor/autoload.php');
	} else {
		require_once('../../../clases/mpdf/vendor/autoload.php');
	}
}

$id=intval($_GET['id_funcionario']);
$idperiodo=intval($_GET['id_periodo']);
$idfuncionario=intval($_GET['id_funcionario']);
if($id == 0){
	header("location: rrhh_generacion_salarios.php");
	exit;	
}

// Obtiene los datos del funcionario
$buscar="SELECT id, nombres, apellidos, id_sucursal, cedula, celular, telefono, correo_electronico, direccion, ciudad, sexo, fecha_nacimiento, profesion, id_puesto, estado_civil, salario, hora_ingreso, hora_salida, estado, imagen_perfil, observaciones, fecha_ingreso, fecha_ingreso_ips, fecha_salida, tipo_contrato, registrado_el, registrado_por, borrado_por, borrado_el, turno_nocturno
         FROM rrhh_funcionarios
         WHERE id = $id";
$rs_funcionario=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$consulta="select id, mes, ano, fecha_inicio, fecha_fin from rrhh_periodos where id = $idperiodo";
$rsperiodos=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$countrsperiodo = $rsperiodos->recordCount();

$reglas="select porcentaje_ips_empleado from rrhh_reglas where id = 1";
$rsreglas=$conexion->Execute($reglas) or die(errorpg($conexion,$reglas));

$fecha_inicio=antisqlinyeccion($rsperiodos->fields['fecha_inicio'].' 00:00:00',"text");
$fecha_fin=antisqlinyeccion($rsperiodos->fields['fecha_fin'].' 23:59:59',"text");
$porcentaje_ips_funcionario=antisqlinyeccion($rsreglas->fields['porcentaje_ips_empleado'], "double");

$consultaempresa="select empresa, direccion, ruc, razon_social from empresas where idempresa = 1";
$datosempresa=$conexion->Execute($consultaempresa) or die(errorpg($conexion,$consultaempresa));


//Toma el resumen del salario
$consulta="
select * from rrhh_salarios_generados where id_periodo = $idperiodo and id_funcionario = $idfuncionario and estado = 1";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$mpdf = new \mPDF();

$monto_cobro_final = $rs->fields['salario_a_cobrar_neto'];

// Definir contenido HTML
$html = '
<!DOCTYPE html>
<html lang="es">
<head>
  <meta charset="UTF-8">
  <title>Liquidación de Salarios</title>
  <style>
    h4 { text-align: center; }
    table { border-collapse: collapse; }
    th, td, th { border: 1px solid #ddd; padding: 5px; font-size: 14px !important; }
  </style>
</head>
<body>
  <h4>LIQUIDACION DE SALARIOS</h4>
  <br />
  <b>N.L: '.$rs->fields['id_funcionario'].'</b>
  <br /><b>L..S. N.: '.$rs->fields['id'].'</b>
  <br />
  <br /><b>Empresa:</b> '.$datosempresa->fields['razon_social'].'      RUC: '.$datosempresa->fields['ruc'].'
  <br /><b>Nombre y apellido:</b> '.antixss($rs_funcionario->fields['nombres'].' '.$rs_funcionario->fields['apellidos']).' 
  <br /><b>Cédula:</b> '.antixss($rs_funcionario->fields['cedula']).'
  <br /><b>Periodo de pago:</b> '.antixss(mesespanol(intval($rsperiodos->fields['mes']))).'/'.$rsperiodos->fields['ano'].'
  <p></p>
  <table>
    <thead>
      <tr>
        <th>Salario Base</th>
        <th>Ingresos extras</th>
        <th>Ingresos extras (No suma al salario)</th>
        <th>Horas extras</th>
        <th>IPS</th>
        <th>Descuentos (Llegadas tardías)</th>
        <th>Descuentos (por Permisos)</th>
        <th>Otros descuentos</th>
        <th>Anticipos</th>
        <th>Total a cobrar</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>'.number_format(intval($rs->fields['salario']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['extras']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['extras_no_suma']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['horas_extras']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['ips']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos_llegadas_tardias']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos_permisos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['anticipos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($monto_cobro_final), 0, ',', '.').'</td>
      </tr>
      </tbody>
  </table>
  
  <br />

  <h4>LIQUIDACION DE SALARIOS</h4>
  <br />
  <b>N.L: '.$rs->fields['id_funcionario'].'</b>
  <br /><b>L..S. N.: '.$rs->fields['id'].'</b>
  <br />
  <br /><b>Empresa:</b> '.$datosempresa->fields['razon_social'].'      RUC: '.$datosempresa->fields['ruc'].'
  <br /><b>Nombre y apellido:</b> '.antixss($rs_funcionario->fields['nombres'].' '.$rs_funcionario->fields['apellidos']).' 
  <br /><b>Cédula:</b> '.antixss($rs_funcionario->fields['cedula']).'
  <br /><b>Periodo de pago:</b> '.antixss(mesespanol(intval($rsperiodos->fields['mes']))).'/'.$rsperiodos->fields['ano'].'
  <p></p>
  <table>
    <thead>
      <tr>
        <th>Salario Base</th>
        <th>Ingresos extras</th>
        <th>Ingresos extras (No suma al salario)</th>
        <th>Horas extras</th>
        <th>IPS</th>
        <th>Descuentos (Llegadas tardías)</th>
        <th>Descuentos (por Permisos)</th>
        <th>Otros descuentos</th>
        <th>Anticipos</th>
        <th>Total a cobrar</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>'.number_format(intval($rs->fields['salario']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['extras']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['extras_no_suma']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['horas_extras']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['ips']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos_llegadas_tardias']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos_permisos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['descuentos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($rs->fields['anticipos']), 0, ',', '.').'</td>
        <td>'.number_format(intval($monto_cobro_final), 0, ',', '.').'</td>
      </tr>
      </tbody>
  </table>

</body>
</html>';

// Write HTML content to PDF
$mpdf->WriteHTML($html);
$mpdf->showWatermarkText = 0;
// Set headers to force download
header('Content-Description: File Transfer');
header('Content-Type: application/octet-stream');
header('Content-Disposition: attachment; filename="salario_'.antixss(mesespanol(intval($rsperiodos->fields['mes']))).'/'.$rsperiodos->fields['ano'].'_'.uniqid().'.pdf"'); 
header('Content-Length: ' . strlen($mpdf->Output('', 'S'))); // Get PDF content length

// Generate and download the PDF
$mpdf->Output('"salario_'.antixss(mesespanol(intval($rsperiodos->fields['mes']))).'/'.$rsperiodos->fields['ano'].'_'.uniqid().'.pdf"', 'D'); // 'D' for download


