<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo="18";
$submodulo="585";
require_once("../includes/rsusuario.php");

// Obtiene todas las vacaciones de los funcionarios
$consulta="SELECT fv.fecha_inicio, fv.fecha_fin, concat(f.nombres, ' ', f.apellidos) as funcionario
           FROM rrhh_funcionarios_vacaciones fv 
           JOIN rrhh_funcionarios f ON f.id = fv.idfunci
           AND fv.estado = 1";
$rs_vacaciones=$conexion->Execute($consulta) or die (errorpg($conexion,$consulta));

?>
<!DOCTYPE html>
<html lang="es">
  <head>
	<?php require_once("../includes/head_gen.php"); ?>
  <!-- FullCalendar -->
  <link href="../vendors/fullcalendar/dist/fullcalendar.min.css" rel="stylesheet">
  <link href="../vendors/fullcalendar/dist/fullcalendar.print.css" rel="stylesheet" media="print">
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("../includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("../includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			            <?php require_once("../includes/lic_gen.php");?>
            
                    <!-- SECCION -->
                    <div class="row">
                      <div class="col-md-12 col-sm-12 col-xs-12">
                        <div class="x_panel">
                        <div class="x_title">
                            <h2>Estado de vacaciones por funcionario</h2>
                            <ul class="nav navbar-right panel_toolbox">
                              <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                              </li>
                            
                            </ul>
                            <div class="clearfix"></div>
                          </div>
                          <div class="x_content">
                            <div class="col-xs-2 " id="menutab">
          
                      <ul class="nav nav-tabs tabs-left">
                      <li class="">
                        <a href="rrhh_vacaciones.php" id="ct" aria-expanded="false">Estado por funcionario</a>
                      </li>
                      <li class="active">
                        <a href="rrhh_vacaciones_agendamientos.php" id="ct" aria-expanded="false">Agendamientos</a>
                      </li>
                      <li class="">
                        <a href="rrhh_vacaciones_registradas.php" id="dfunc" aria-expanded="false">Registrados</a>
                      </li>						
                      </ul>
                    </div>
                  	<!---------------------------TABS-------------------------------------->
                    <br />
                    <div class="table-responsive">
                      <div id='calendar'>
                    </div>
                    <br />
                    <!---------------------------TABS-------------------------------------->
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION -->
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("../includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
    <?php require_once("../includes/footer_gen.php"); ?>
    <script src="../vendors/fullcalendar/dist/fullcalendar.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/js/bootstrap-select.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jquery-confirm/3.3.2/jquery-confirm.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-confirm/3.3.2/jquery-confirm.min.js"></script>
    <script>
      function recalcular_vacaciones(idfuncionario, idperiodo){

        $.confirm({
            title: "Recalcular vacaciones del funcionario",
            content: "¿Desea recalcular las vacaciones del funcionario? Esta acción no se podrá volver atrás",
            buttons: {
                confirm: {
                    text: "Regenerar",
                    action: function() {
                      $.ajax({
                        url: "rrhh_recalcular_vacaciones.php",
                        method: "POST",
                        dataType: "json",
                        data: {
                          'MM_insert': 'RECALCULAR_VACACIONES',
                          'idfuncionario': idfuncionario,
                          'idperiodo': idperiodo
                        },
                        success: function(response) {

                          if(response.estado == 'success'){
    
                            location.reload();

                          }else{

                            alert(response.msg);

                          }

                        },
                        error: function(xhr, status, error) {
                          // Manejar errores de la solicitud AJAX
                          alert("Error al recalcular las vacaciones: " + error);
                        }
                      });
                  }
                },
                cancel: {
                    text: "Cancelar",
                    action: function() {}
                }
            }
        });

      }
    </script>
    <script>
        /* CALENDAR */ 
        function  init_calendar() {
          if( typeof ($.fn.fullCalendar) === 'undefined'){ return; }
            
          var date = new Date(),
            d = date.getDate(),
            m = date.getMonth(),
            y = date.getFullYear(),
            started,
            categoryClass;

          var calendar = $('#calendar').fullCalendar({
            locale: 'es',
            header: {
            left: 'prev,next',
            center: 'title',
            right: 'agendaDay,listMonth,agendaWeek,month'
            },
            defaultView: 'month',
            selectable: true,
            selectHelper: true,
            hour12: false,
            firstHour: 8,
            slotMinutes: 30,
            
            defaultEventMinutes: 120,
            
            
            dayNames: ['Domingo', 'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado'],
            dayNamesShort: ['Dom','Lun','Mar','Mie','Jue','Vie','Sáb'],
            monthNamesShort: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
            monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
            buttonText: {
                today:    'Hoy',
                month:    'Mes',
                week:     'Semana',
                day:      'Día',
                list:     'Lista'
            },

            select: function(start, end, allDay) {
            $('#fc_create').click();

            started = start;
            ended = end;

            $(".antosubmit").on("click", function() {
              var title = $("#title").val();
              if (end) {
              ended = end;
              }

              categoryClass = $("#event_type").val();

              if (title) {
              calendar.fullCalendar('renderEvent', {
                title: title,
                start: started,
                end: end,
                allDay: allDay
                },
                true // make the event "stick"
              );
              }

              $('#title').val('');

              calendar.fullCalendar('unselect');

              $('.antoclose').click();

              return false;
            });
            },
            
            
            editable: false,
            
            // se usa si editable es true, y hace la accion que queremos al editar el inicio del evento
            eventDrop: function(event, delta, revertFunc) {
          
            },
            // se usa si editable es true, y hace la accion que queremos al editar la duraccion del evento
            eventResize: function(event, delta, revertFunc) {
          
            },

            events: [

              <?php 
              
                while(!$rs_vacaciones->EOF){

                  $y_ini=date("Y",strtotime($rs_vacaciones->fields['fecha_inicio']));
                  $m_ini=date("m",strtotime($rs_vacaciones->fields['fecha_inicio']))-1;
                  $d_ini=date("d",strtotime($rs_vacaciones->fields['fecha_inicio']));
                  $h_ini=date("H",strtotime($rs_vacaciones->fields['fecha_inicio']));
                  $i_ini=date("i",strtotime($rs->fields['fecha_inicio']));
                  
                  $y_fin=date("Y",strtotime($rs_vacaciones->fields['fecha_fin']));
                  $m_fin=date("m",strtotime($rs_vacaciones->fields['fecha_fin']))-1;
                  $d_fin=date("d",strtotime($rs_vacaciones->fields['fecha_fin']))+1;
                  $h_fin=date("H",strtotime($rs_vacaciones->fields['fecha_fin']));
                  $i_fin=date("i",strtotime($rs_vacaciones->fields['fecha_fin']));

              ?>

                  {
                    title: '<?php echo $rs_vacaciones->fields['funcionario'] ?>',
                    description: '<?php echo $rs_vacaciones->fields['funcionario']; ?>',
                    start: new Date(<?php echo $y_ini ?>, <?php echo $m_ini ?>, <?php echo $d_ini ?>),
                    end: new Date(<?php echo $y_fin ?>, <?php echo $m_fin ?>, <?php echo $d_fin ?>),
                    url: '#',
                    backgroundColor: 'green',
                        borderColor: 'green',
                    color: 'red',
                  },

              <?php

                  $rs_vacaciones->MoveNext();

                }

              ?>

            ]

          });
          
        };

        $( document ).ready(function() {
          init_calendar();
        });
    </script>
  </body>
</html>
