<?php 
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="18";
$submodulo="281";
require_once("includes/rsusuario.php");
require_once("includes/num2letra.php");


function nombre_dia($fecha){
   $fechats = strtotime($fecha); //pasamos a timestamp

//el parametro w en la funcion date indica que queremos el dia de la semana
//lo devuelve en numero 0 domingo, 1 lunes,....
switch (date('w', $fechats)){
    case 0: return "Domingo"; break;
    case 1: return "Lunes"; break;
    case 2: return "Martes"; break;
    case 3: return "Miercoles"; break;
    case 4: return "Jueves"; break;
    case 5: return "Viernes"; break;
    case 6: return "Sabado"; break;
}
}

function redondear_precio($precio,$ceros,$direccion){
     // direccion  A: hacia arriba // B: hacia abajo N: Normal
    if($direccion == 'A'){
        $precio_redondeado=ceil($precio/10**$ceros)*(10**$ceros);
    }else if($direccion == 'B'){
        $precio_redondeado=floor($precio/10**$ceros)*(10**$ceros);
    }else{
        $precio_redondeado=round($precio/10**$ceros)*(10**$ceros);
    }
    return $precio_redondeado;
}


$idf=antisqlinyeccion($_REQUEST['idf'],'text');
$tipo=antisqlinyeccion($_REQUEST['tp'],'int');

//Datos del Mes en curso
$buscar="Select * from rrhh_mes_activo where activo=1  order by idreg desc limit 1";
$rsacti=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$idreg=intval($rsacti->fields['idreg']);//TANDA ACTIVA DEL MES EN CURSO PARA PAGOS

//Buscamos si el horario ha sido recalculado y ya existe en pago_salarios, mostraremos en base a dichos valores, si no los de siemrpe
$buscar="Select * from rrhh_pagos_salarios WHERE documento=$idf and idreg=$idreg";
$rspagos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$tpagos=$rspagos->RecordCount();
$tempoadicional=floatval($rspagos->fields['adtmp']);//solo para el fiscal
$adicionales=floatval($rspagos->fields['adicional_base']);
$descuentosdias=floatval($rspagos->fields['descontadonetodias']);
$diasdesc=intval($rspagos->fields['diasdesc']);
$recalculado=trim($rspagos->fields['recalculo']);
$drecalculo=($rspagos->fields['dias_recalculo']);
$jornalrecalculado=floatval($rspagos->fields['jornal_recalculo']);
$netocobrar=floatval($rspagos->fields['neto_cobrar']);
$comiadi=floatval($rspagos->fields['comisiones']);
$pluplu=floatval($rspagos->fields['plux']);
//armamos desde hasta
$m=intval($rsacti->fields['mes']);
if ($m<10){
	$m="0"	.$m;
	
}
$ano=intval($rsacti->fields['ano']);
//armamos primer dia 
$pfecha=$ano."-".$m."-".'01';
$ld=ultimodia(date("Y-m-d",strtotime($pfecha)));
$lfecha=$ano."-".$m."-".$ld;
$inicio=date("Y-m-d",strtotime($pfecha));
$final=date("Y-m-d",strtotime($lfecha));


/*---------------------------------REGISTROS DE MARCACIONES---------------------------------*/
$buscar="Select * from rrhh_planilla_tanda_detalles where fecha between '$inicio'
 and '$final' and documento=$idf order by fecha,entrada1 asc ";
 
 //Nueva consulta hasta arreglar el anterior metodo
$buscar="Select * from rrhh_planilla_tanda_detalles where fecha between '$inicio' and '$final' and  documento=$idf  group by fecha order by fecha asc";
$rsacti=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$tr=$rsacti->RecordCount();
$fechamarca=array();
$minutos=array();
$clase=array();
$lientra='';
$lisale='';
while(!$rsacti->EOF){
	$fecha_registro=$rsacti->fields['fecha'];
	 
	//traemos los datos de la fecha por orden asc
	$buscar="Select entrada1,salida1,minutos_favor,minutos_contra,marca,monto,accion
	from rrhh_planilla_tanda_detalles where 
	fecha='$fecha_registro' and  documento=$idf order by entrada1,salida1 asc"	;
	$rsdat=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$lientra='';$lisale='';$mincontra=0;$minfavor=0;
	while (!$rsdat->EOF){
		$tiporeg=trim($rsdat->fields['marca']);
		if (trim($rsdat->fields['entrada1'])!=''){
			$lientra.=trim($rsdat->fields['entrada1'])."<br />";
		}
		if (trim($rsdat->fields['salida1'])!=''){
			$lisale.=trim($rsdat->fields['salida1'])."<br />";
		}
		$mincontra=$mincontra+floatval($rsdat->fields['minutos_contra']);
		$minfavor=$minfavor+floatval($rsdat->fields['minutos_favor']);
		$rsdat->MoveNext();
	}
	$fechamarca[$fecha_registro]['S'] = $lisale;
	$fechamarca[$fecha_registro]['E'] = $lientra;
	$minutos[$fecha_registro]['F'] = $minfavor;
	$minutos[$fecha_registro]['C'] = $mincontra;
	$clase[$fecha_registro]['T'] = $tiporeg;
	$rsacti->MoveNext();
}



/*---------------------------------------------------------------------------------------------*/


//Buscamos datos del funcionario
$buscar="Select nombres,apellidos,gest_funcionarios.idhorario,descripcion,idfunci
from gest_funcionarios
inner join rrhh_horarios on rrhh_horarios.idhorario=gest_funcionarios.idhorario
where gest_funcionarios.documento=$idf";
//echo $buscar;
$rs1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$nomape=trim($rs1->fields['nombres']).' '.trim($rs1->fields['apellidos']);
$horario=intval($rs1->fields['idhorario']);
$deshora=trim($rs1->fields['descripcion']);
$idfuncionario=intval($rs1->fields['idfunci']);
if ($idfuncionario==0){
	echo "ATENCION: El funcionario no posee un horario asignado. Verifique el horario y regrese nuevamente"	;exit;
	
}

//datos de salario acordado
$buscar="Select * from rrhh_salarios where idfuncionario=$idfuncionario and estado=1";
$rssal=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$salariofuncionario=$rssal->fields['monto_salario'];
$salario=floatval($rssal->fields['monto_salario']);

//Salario vigente s normativa
$buscar="Select * from rrhh_salarios_vigentes where estado=1";
$rssal=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$vigentemes=floatval($rssal->fields['monto_mensual']);
$vigentejornal=floatval($rssal->fields['monto_jornal']);
$vigentejornalfiscal=floatval($rssal->fields['monto_jornal']);
//echo $vigentejornal;exit;
//Calculamos el sobre salario u adicional a parte del basico

//cambiamos y tomamos ya el salario de la tabla de pagos
$salario=floatval($rspagos->fields['salario_base']);
if ($salario < $vigentemes ){
	$sobresalario=0;
} else {
	$sobresalario=$salario-$vigentemes;
	//recalculamos el vigente jornal
	$vigentejornal=$salario/30;
}

//Traemos los descuentos del mes
$buscar="Select sum(monto) as totaldesc from rrhh_cargos_aplicados where idfuncionario=$idfuncionario and estado=1 and fecha between '$inicio' and '$final'";
$rdesc=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$descuentos=floatval($rdesc->fields['totaldesc']);





if ($tipo==1){//RESUMEN DE HORAS Y DIAS T
	

	//Traemos las franjas de horas
	$buscar="Select rrhh_horarios.descripcion,idturno,hora_inicio,hora_final,min_inicio,min_final,idturno
	from rrhh_horarios inner join rrhh_franja_horaria on rrhh_franja_horaria.idtipohora=rrhh_horarios.idhorario
	where rrhh_horarios.idhorario=$horario order by idturno asc
	";
	$rs2=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$franja='';
	$horariocom='';
	$horariofin='';
	while (!$rs2->EOF){
		
		$franja="Tipo Horario: ".trim($rs2->fields['descripcion']);
		$horariocom.='Turno: '.$rs2->fields['idturno'].' de ';
		if (intval($rs2->fields['hora_inicio']) <10){
			$hi='0'.$rs2->fields['hora_inicio'];
		} else {
			$hi=$rs2->fields['hora_inicio'];
		}
		if (intval($rs2->fields['min_inicio']) <10){
			$mi='0'.$rs2->fields['min_inicio'];
		} else {
			$mi=$rs2->fields['min_inicio'];
		}
		//Hora final
		if (intval($rs2->fields['hora_final']) <10){
			$hf='0'.$rs2->fields['hora_final'];
		} else {
			$hf=$rs2->fields['hora_final'];
		}
		if (intval($rs2->fields['min_final']) <10){
			$mf='0'.$rs2->fields['min_final'];
		} else {
			$mf=$rs2->fields['min_final'];
		}
		
		
		$horariocom.=$hi.":".$mi.' a '.$hf.':'.$mf.'<br />';
		
		
		
		//trim($rs2->fields['hora_inicio']).' '.trim($rs2->fields['min_inicio']).' ->'.trim($rs2->fields['hora_final']).' '.trim($rs2->fields['min_final']).' | ';
		$horariofin=trim($rs2->fields['hora_final']).' '.trim($rs2->fields['min_final']);
		$rs2->MoveNext();
	}

	
	
	
	
?>


<!----------------------MARCACIONES--------------------------------->

<div style="border:1px #000000; width:400px;float:left;">
<table width="96%" height="138" border="1">
    <tr>
    	<td colspan="4"  bgcolor="#EFEFEF"><?php echo $nomape;?></td>
        <td colspan="4"  bgcolor="#EFEFEF"><?php echo $franja;?></td>
    </tr>
	<tr>
		<td colspan="8" align="center"  bgcolor="#EFEFEF"><?php echo $horariocom; ?></td>
	</tr>
	<tr>
        <td width="45" height="28" align="center" bgcolor="#F3F3F3"><strong>Dia</strong></td>
        <td align="center" bgcolor="#F3F3F3"><strong>Fecha</strong></td>
        <td width="94" align="center" bgcolor="#F3F3F3"><strong>Entrada</strong></td>
        <td width="89" align="center" bgcolor="#F3F3F3"><strong>Salida</strong></td>
		<td width="59" align="center" bgcolor="#F3F3F3"><strong>Tipo</strong></td>
        <td width="59" align="center" bgcolor="#F3F3F3"><strong>MF+</strong></td>
        <td width="78" align="center" bgcolor="#F3F3F3"><strong>MC-</strong></td>
    </tr>
     <?php 
		$fecactu=$inicio;
		//echo $fecactu;
		//echo $final;
		$i=1;
		$fecactu_int=strtotime($fecactu);
		$final_int=strtotime($final);
		while($fecactu_int <= $final_int){
			$fecactu=date("Y-m-d",$fecactu_int);
			
			$diachar=nombre_dia($fecactu);
			$cca=trim($clase[$fecactu]['T']);
			if ($cca!=''){
				$color="#D8D8D8";
			} else {
				$color="#FFFFFF";
			}
		?>	
		<tr style="background-color: <?php echo $color; ?>">
			<td ><?php echo $diachar; ?></td>
			<td align="center" width="93"><?php echo date("d/m/Y",strtotime($fecactu)); ?></td>
			<td align="center"><?php echo $fechamarca[$fecactu]['E']; ?></td>
			<td align="center"><?php echo $fechamarca[$fecactu]['S']; ?></td>
			 <td align="center"><?php echo $clase[$fecactu]['T']; ?></td>
            <td align="center"><?php echo $minutos[$fecactu]['F']; ?></td>
			<td align="center"><?php echo $minutos[$fecactu]['C']; ?></td>
		</tr>
		<?php	
			$fecactu_int=strtotime(date("Y-m-d",strtotime($fecactu."+ 1 days")));
			$i++;
			if($i>31){
				break;
				echo 'solo se pueden procesar hasta 1000 dias';
				exit;
			}
			
		}

		?>	 
        <tr>
        	<td height="32" colspan="8" align="center" bgcolor="#E5E5E5"><strong>Total Marcaciones: <?php echo $tr;?></strong></td>
        
    </tr>
      
  </table>

</div>
<?php 
$dmes=30;//ver para traer x preferencias en base a la empresa
?>
<!----------------------RESUMEN--------------------------------->
<?php 
//diferencia a pagar..maximo 5
$dpaga=(5*$vigentejornal);
$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
and fecha_descontado is null order by descripcion asc";
$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$v=(($dmes)*$vigentejornal);
/*
//Buscamos el ultimo salario registrado a esa persona, para mostrar en el resumen, si el salario es distinto del minimo, ya sea menor o mayor
$buscar="Select idfunci from gest_funcionarios where documento=$idfuncionario";
$rtempof=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$idtempofun=intval($rtempof->fields['idfunci']);
echo $idtempofun;exit;*/
//ahora el salario
$buscar="Select monto_salario from rrhh_salarios where idfuncionario=$idfuncionario and estado <> 6 order by idsalario desc limit 1";
$rsala1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$mfinal=floatval($rsala1->fields[monto_salario]);




//echo $dmes;
//echo $vigentejornal;exit;
//Siempre hay diferencia de 11 gs
$v=$v-11;
//$netocobrar=($v-$descuentos)+$sobresalario;
//$netocobrar=$netocobrar-$descuentosdias;
if ($tpagos >0){
	if ($rspagos->fields['recalculo']=='S'){
		$rp=1;
		$vigentejornal=floatval($rspagos->fields['jornal_recalculo']);
		$a=floatval($rspagos->fields['dias_recalculo']);
		$netocobrar=floatval($rspagos->fields['neto_cobrar']);
		$adicionales=floatval($rspagos->fields['adicional_base']);
		$v=$a*$vigentejornal;
	} else {
		$a=$tr;
	}
}
//echo $netocobrar;
$documento=str_replace("'","",$idf);
$a=$tr;//para igualar la variable nomas

	
	
$descuentoh=0;
//buscamos los descuentos segun rango de fecha
$buscar="Select sum(monto) as total from rrhh_planilla_tanda_detalles where  documento=$documento and accion='S' and fecha between '$inicio' and '$final' ";
$rsas=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$tsumar1=floatval($rsas->fields['total']);
$buscar="Select sum(monto) as total from rrhh_planilla_tanda_detalles where  documento=$documento and accion='D' and fecha between '$inicio' and '$final' ";
$rsas=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
//echo $buscar;exit;
$trestar1=floatval($rsas->fields['total']);	
$descuentoh=$trestar1;
	
	
	
//para el desgloce, el salario basico, mostraremos en base a los registros
if ($mfinal < $vigentemes){
	$mostrar=$mfinal;	
} else {
	$mostrar=$vigentemes;
}	

$drr=$rspagos->fields['dias_recalculo'];
$plusxdias=0;
$pc=($sobresalario/30);
$pc=$pc*$rspagos->fields['dias_recalculo'];
$plusxdias=redondear_precio($pc,1,'A');

?>


<div style="border:0px solid #E32528; width:300px;float:left; margin-left:2%;">
<table width="284" height="524" border="1">

<tr>
		<td height="37" colspan="3" align="center" bgcolor="#EFEFEF" style="border-bottom:thin; border-bottom-color:black;"><strong>Desgloce </strong></td>
       
	<tr>
		<td width="113" height="34" bgcolor="#E0E0E0"><strong>Sueldo Basico</strong></td>
		<td width="83" align="right"><?php echo formatomoneda($mostrar,4,'N'); ?></td>
        <td width="72" rowspan="8">&nbsp;</td>
    </tr>
	
	<tr>
		<td height="31" bgcolor="#E0E0E0"><strong>Plus</strong></td>
		<td align="right"><?php echo formatomoneda($sobresalario,4,'N'); ?></td>
    </tr>
	<tr>
	  <td height="31" bgcolor="#E0E0E0"><strong>Plus (adicional)</strong></td>
	  <td align="right"><?php echo formatomoneda($comiadi,4,'N'); ?></td>
    </tr>
	<tr>
	  <td height="31" bgcolor="#E0E0E0"><strong>H adicional</strong></td>
	  <td align="right"><?php echo formatomoneda($pluplu,4,'N'); ?></td>
    </tr>
    <tr>
		<td height="35" bgcolor="#E0E0E0"><strong>Jornal Diario</strong></td>
		<td align="right"><?php echo formatomoneda($vigentejornal,4,'N')?></td>
    </tr>
    <tr>
		<td height="28" bgcolor="#E0E0E0"><strong>Dias Mes</strong></td>
		<td align="right"><?php echo formatomoneda($dmes,4,'N');?></td>
    </tr>
     
    <tr>
		<td height="29" bgcolor="#E0E0E0"><strong>Dias Trabajados (marcaciones)</strong></td>
		<td align="right"><?php echo formatomoneda($a,4,'N')?></td>
    </tr>
	<tr>
		<td height="29" bgcolor="#E0E0E0"><strong>Dias Trabajados (reales)</strong></td>
		<td align="right"><?php echo formatomoneda($rspagos->fields['dias_recalculo'],4,'N')?></td>
    </tr>
     <tr>
		<td height="28" bgcolor="#E0E0E0"><strong>Diferencia Dias</strong></td>
		<td align="right"><?php echo formatomoneda(($dmes-$a),4,'N');?></td>
    </tr>
    <?php 
	
	?>
    <tr>
		<td height="28" bgcolor="#E0E0E0"><strong>*Cobrar x dias Gs</strong></td>
		<td align="right"><?php

		echo formatomoneda((redondear_precio($v,2,'A')),4,'N');
		$gh=$v;
		?></td>
    </tr>
	<tr>
		<td height="28" bgcolor="#E0E0E0"><strong>Plus x Dias</strong></td>
		<td align="right"><?php echo formatomoneda(($plusxdias),4,'N');?></td>
    </tr>
	<tr>
		<td height="28" bgcolor="#E0E0E0"><strong>*Adicionales Gs</strong></td>
		<td align="right"><?php echo formatomoneda(($adicionales),4,'N');?></td>
    </tr>
	<tr>
		<td height="28" bgcolor="#E0E0E0"><strong>*Pasantias Gs</strong></td>
		<td align="right"><?php echo formatomoneda(($tsumar1),4,'N');?></td>
    </tr>
	<tr>
		<td height="28" bgcolor="#E0E0E0"><strong>Sub Total Gs</strong></td>
		<td align="right"><strong><?php 
		if ($drr<10){
			echo formatomoneda((redondear_precio($gh+$plusxdias+$comiadi,1,'A')));
			$mini=(redondear_precio($gh+$plusxdias+$comiadi,1,'A'));
		}else {
		echo formatomoneda((redondear_precio($gh,2,'A')+$adicionales+$comiadi+$tsumar1+$sobresalario),4,'N');
		}
		?></strong></td>
    </tr>
     <tr>
		<td height="33" colspan="3" align="center" bgcolor="#E0E0E0"><strong>Descuentos Gs</strong>&nbsp;&nbsp;<?php echo formatomoneda($descuentos+$descuentosdias+$descuentoh,4,'N')?></td>
	</tr>
	 <?php if ($descuentoh > 0){ ?>
    	   <tr>
                 
                  <td height="29" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">Ausencias</td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($descuentoh,4,'N');?></td>
    </tr>
    
    <?php } ?>
    <?php if ($descuentosdias > 0){ ?>
    	   <tr>
                 
                  <td height="29" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">DESCUENTO x <?php echo $diasdesc.' dias'; ?></td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($descuentosdias,4,'N');?></td>
    </tr>
    
    <?php } ?>
    <?php if ($descuentos > 0){?>
   <?php  while (!$rscargos->EOF){?>
      <tr>
                 
                  <td height="29" style="border-bottom:1px solid #000000;border-left:1px solid #000000;"><?php echo $rscargos->fields['descripcion']?></td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
    </tr>
    <?php $rscargos->MoveNext();}?>
	<?php 
	//$netocobrar
	//echo $vigentemes;exit;
	//if ($rspagos->fields['recalculo']!='S'){
		if ($vigentemes > $v){
		$vigentemes=$v;
		}
		$netocobrar=(($vigentemes+$sobresalario+$adicionales+$comiadi+$tsumar1)-($descuentos+$descuentosdias+$descuentoh));
		if ($drr<10){
			$netocobrar=$mini-($descuentos+$descuentosdias+$descuentoh);
		}			
	//}
	?>
    <?php }?>
    <tr>
		<td height="31" bgcolor="#E0E0E0" style="border-bottom:thin; border-bottom-color:black;"><strong>Neto Cobrar Gs</strong></td>
		<td align="right" style="border-bottom:thin; border-bottom-color:black;"><?php echo formatomoneda($netocobrar,4,'N')?></td>
    </tr>
</table>
</div>
<?php }//de tipo==1?>
<?php if ($tipo==3){ //recibo salarial nuevo modelo 
//Fecha por defecto para impresion de recibos (cierre de mes)
	$buscar="select * from preferencias_rrhh limit 1";
	$rsff=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$fecha_real=trim($rsff->fields['cierre_real']);
	if ($fecha_real=='S'){
	    $fecharecibo=date("Y-m-d");
		
	} else {
		 $fecharecibo=trim($rsff->fields['cierre_fecha_definida']);
		 if ($fecharecibo==''){
			 $fecharecibo=date("Y-m-d");
			 //usamos la del dia hasta que definan una fecha
		 } else {
			 //armamos en base al dia
			 $d=intval($rsff->fields['cierre_fecha_definida']);
			 if ($d<10){
				 $d='0'.$d;
			 }
			 $nm=date('m');
			 $nm=$m+1;
		
			if ($nm==13){
				$nm=01;
			}
		
			 $na=date('Y');
			 $fg=$na.'-'.$nm.'-'.$d;
			 $fecharecibo=date("Y-m-d",strtotime($fg));
			 //usamos la del dia hasta que definan una fecha
			 
		 }
		
	}
//datos del funcionario
$dc=trim($_REQUEST['idf']);
$buscar="Select * from gest_funcionarios where documento='$dc'";
$df=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));	
$nomape=trim($df->fields['nombres'].' '.$df->fields['apellidos']);
//Datos de la empresa / empleador
	$buscar="Select * from gest_patronal order by codpatronal desc limit 1";
	$rsp=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$patronal=trim($rsp->fields['razon_social']);
	
	$per=date("m",$inicio);
	$an=date("Y",$inicio);

	//Si uno de los valores fue fijado, verificamo y reemplazamos t dias x el jornal
	$buscar="select sum(dias_trabaja) as tdias from rrhh_pagos_salarios where documento=$idf and fijado=1 and idreg=$idreg";
	$rscontrola=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	if (intval($rscontrola->fields['tdias'])>0){
		//se fijo un valor y encima tiene a mano los dias trabajados, por lo cual respetaremos ese item
		$tdiasf=intval($rscontrola->fields['tdias']);	
		
	}
	

?>
<!-----------------------------FISCAL--------------------------------->
<div style="width:800px; border:1px solid #E0E0E0;min-height:550px;">
	<hr />
	<div style="width:60%; float:left;">
		<span style="font-size:20px;">
			<strong>
				<?php echo $patronal ?>
				<br />
				Recibo de liquidaci&oacute;n
				<br />
				Periodo de Pago: <?php echo $m."/".$ano?>
				<br />
				<?php echo $nomape; ?> 
				<br />
				Fecha : <?php echo date("d/m/Y",strtotime($fecharecibo));?>
			</strong>
		</span>
		<hr />
	</div>
	<div style="width:38%; float:left;">
		<!---------------ACA VA LOGO----------------->
	</div>
	<?php 
		//Cargos-Descuentos
	$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
	inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
	where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
	and fecha_descontado is null order by descripcion asc";
	$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$tcargos=$rscargos->RecordCount();
	
		//Si uno de los valores fue fijado, verificamo y reemplazamos t dias x el jornal
	$buscar="select sum(dias_trabaja) as tdias from rrhh_pagos_salarios where documento=$idf and fijado=1 and idreg=$idreg";
	$rscontrola=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	//echo $buscar;exit;
	if (intval($rscontrola->fields['tdias'])>0){
		//se fijo un valor y encima tiene a mano los dias trabajados, por lo cual respetaremos ese item
		$tdiasf=intval($rscontrola->fields['tdias']);	
		
	}
		$vigentemessubtotal=($vigentejornalfiscal*$tdiasf)+$tempoadicional;//PARA EL FISCAL USAR SIEMPRE EL JORNAL VIGENTE DE LA TABLA< DEFINIDA POR EL MIN
		
	?>
	<div> 
		<table width="100%;">
			<tr >
				<td>Descripcion</td>
				<td>Cant</td>
				<td>Ingresos</td>
				<td>Cant</td>
				<td>Retenciones</td>
			</tr>
			<tr>
				<td colspan="5"><hr /></td>
			</tr>
			<tr>
				<td>Salario B&aacute;sico</td>
				<td>X&nbsp;<?php echo $tdiasf; ?> &nbsp;dias</td>
				<td><?php //se cambia x el subtotal al finalecho formatomoneda($vigentemes,4,'N');
					echo formatomoneda($vigentemessubtotal,4,'N');

				?></td>
				<td></td>
				<td></td>
			</tr>
			 <?php if ($tcargos > 0){?>
        
        <?php 
	
		$ts=0;
		$tcfiscal=0;
		while (!$rscargos->EOF){
			$muestraambos=trim($rscargos->fields['muestra_ambos']);
			$mostraren=intval($rscargos->fields['mostrar_en']);
			if (($muestraambos=='S') or ($mostraren==1)){
			$ts=$ts+floatval($rscargos->fields['monto']);
			$tcfiscal=$tcfiscal+floatval($rscargos->fields['monto']);
			?>
         <tr>
       	  <td colspan="4"><?php echo $rscargos->fields['descripcion']?></td>
            <td><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
            
        </tr>
        <?php }?>
         <?php $rscargos->MoveNext();}
		 $rscargos->MoveFirst();
		 ?>
        <?php } ?>
			<tr>
				<td><br /></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
			</tr>
				<tr>
				<td><br /></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
				<td></td>
			</tr>
            <?php 
			//$vigentemessubtotal
			$sf=$vigentemessubtotal-$tcfiscal;
			?>
			<tr>
				<td>Total Ingresos / Retenciones</td>
				<td></td>
				<td><?php echo formatomoneda($vigentemessubtotal,4,'N'); ?></td>
				<td></td>
				<td align="left"><?php echo formatomoneda($tcfiscal,4,'N'); ?></td>
			</tr>
			<tr>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;">A Cobrar GS:</td>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"><?php echo formatomoneda($sf,4,'N'); ?></td>
			</tr>
		</table>
		<hr />
		<?php $let=num2letras($sf); ?>
		<h3>Recib&iacute; Conforme copia, la suma de Gs: <?php echo formatomoneda($sf,4,'N'); ?> (Gs: <?php echo $let; ?>)</h3>
		<br />
		<div style="float:right; max-width:250px;text-align:center;">
		-------------------------------------------<br />
		Firma del Trabajador <br /> DC: <?php echo $_REQUEST['idf']; ?>
		</div>
	</div>
</div>
<!-----------------------------NM-REAL--------------------------->
<?php
//Total de dias
	$buscar="SELECT count(fecha) as cantidad,fecha from rrhh_planilla_tanda_detalles where documento=$idf and date(fecha) between '$inicio' and '$final' group by fecha order by fecha asc";
	$rsd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	//echo $buscar;
	$tdiasf=$rsd->RecordCount();
	$tdias=$tdiasf;
	
	//Si uno de los valores fue fijado, verificamo y reemplazamos t dias x el jornal
	$buscar="select sum(dias_trabaja) as tdias from rrhh_pagos_salarios where documento=$idf and fijado=1 and idreg=$idreg";
	$rscontrola=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	if (intval($rscontrola->fields['tdias'])>0){
		//se fijo un valor y encima tiene a mano los dias trabajados, por lo cual respetaremos ese item
		$tdiasf=intval($rscontrola->fields['tdias']);	
		
	}
	
	//Cargos-Descuentos
	$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
	inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
	where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
	and fecha_descontado is null order by descripcion asc";
	$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	//echo $buscar;
	$tcargos=$rscargos->RecordCount();
	$documento=intval($_REQUEST['idf']);
	$descuentoh=0;
	//buscamos los descuentos segun rango de fecha
	$buscar="Select sum(monto) as total from rrhh_planilla_tanda_detalles where  documento=$documento and accion='S' and fecha between '$inicio' and '$final' ";
	$rsas=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tsumar1=floatval($rsas->fields['total']);
	$buscar="Select sum(monto) as total from rrhh_planilla_tanda_detalles where  documento=$documento and accion='D' and fecha between '$inicio' and '$final' ";
	$rsas=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	//echo $buscar;exit;
	$trestar1=floatval($rsas->fields['total']);	
	$descuentoh=$trestar1;
	
	//Debemos agregar el plus en caso que exista, pero NO plus adicional, sino el resultante del salario real del funcionario menos el basico registrado
	//datos de salario acordado
	$buscar="Select * from rrhh_salarios where idfuncionario=$idfuncionario and estado=1";
	$rssal=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$salariofuncionario1=$rssal->fields['monto_salario'];
	$salario1=floatval($rssal->fields['monto_salario']);

	//Salario vigente s normativa
	$buscar="Select * from rrhh_salarios_vigentes where estado=1";
	$rssal=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$vigentemes1=floatval($rssal->fields['monto_mensual']);
	$vigentejornal1=floatval($rssal->fields['monto_jornal']);
	$vigentejornalfiscal1=floatval($rssal->fields['monto_jornal']);
	//echo $vigentejornal;exit;
	//Calculamos el sobre salario u adicional a parte del basico

	//cambiamos y tomamos ya el salario de la tabla de pagos
	$salario1=floatval($rspagos->fields['salario_base']);
	if ($salario1 < $vigentemes1 ){
		$sobresalario1=0;
	} else {
		$sobresalario1=$salario1-$vigentemes1;
		//recalculamos el vigente jornal
		$vigentejornal1=$salario1/30;
	}
	//anulamos el sobre
	//$sobresalario1=0;
	//$sobresalario1;
	
	
	//Buscamos si hay agrupacion de descuentos, si los hay, iuncluimos en el while oara mostrar o sumar los conceptos segun la agrupacion
	//se usa en recibo 2
	$buscar="Select count(idcargo) as total from rrhh_cargos_agrupados";
	$rstagrupados=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tagrupados=intval($rstagrupados->fields['total']);
	$vigentemessubtotal=($vigentejornal*$tdiasf)+$tempoadicional;//PARA EL FISCAL USAR SIEMPRE EL JORNAL VIGENTE DE LA TABLA< DEFINIDA POR EL MIN

	//Por sobre el fijado, tiene prevalencia el recalculado
	if ($tpagos > 0){
 			 if($rspagos->fields['recalculo']=='S'){
 			$netocobrar=floatval($rspagos->fields['neto_cobrar']);
			 }
 	}
	$totalingresos=0;
	$totalegresos=0;
	
	$totalingresos=$totalingresos+$salario+$adicionales+$comiadi+$sobresalario1+$tsumar1;
	
	?>




<div style="width:800px; border:1px solid #E0E0E0;min-height:550px;">
	<hr />
	<div style="width:60%; float:left;">
		<span style="font-size:20px;">
			<strong>
				<?php echo $patronal ?>
				<br />
				Recibo de liquidaci&oacute;n
				<br />
				Periodo de Pago: <?php echo $m."/".$ano?>
				<br />
				<?php echo $nomape; ?> 
				<br />
				Fecha : <?php echo date("d/m/Y",strtotime($fecharecibo));?>
			</strong>
		</span>
		<hr />
	</div>
	<div style="width:38%; float:left;">
		
	</div>
	
	<div> 
		<table width="100%;">
			<tr >
				<td>Descripcion</td>
				<td>Cant</td>
				<td>Ingresos</td>
				<td>Cant</td>
				<td>Retenciones</td>
			</tr>
			<tr>
				<td colspan="5"><hr /></td>
			</tr>
            <?php 
			
			$dr=$rspagos->fields['dias_recalculo'];
			?>
            
			<tr>
				<td>Salario</td>
				<td><? if ($recalculado=='S'){
					echo " X $dr  dias.";
				}
				?></td>
				<td><?php 
				if ($recalculado=='S'){
					$salario=floatval($rspagos->fields['dias_recalculo'])*floatval($rspagos->fields['jornal_recalculo']);
					$totalingresos=0;
					$totalingresos=$totalingresos+$salario+$adicionales+$comiadi+$sobresalario1+$tsumar1;
				}
				echo formatomoneda($salario,4,'N');

					
					?>
                
                </td>
				<td></td>
				<td></td>
			</tr>
            
			<?php if ($tcargos > 0){
				$totaldescuentos=0;
				$ts=0;
				$magrupados=0;
				while (!$rscargos->EOF){
					$muestraambos=trim($rscargos->fields['muestra_ambos']);
					$mostraren=intval($rscargos->fields['mostrar_en']);
					$idcargo=intval($rscargos->fields['idcargo']);
					
					if ($tagrupados==0){
						if (($muestraambos=='S') or ($mostraren==2)){
							$ts=$ts+floatval($rscargos->fields['monto']);
							
							
							?>
            <tr>
              <td colspan="4"><?php echo $rscargos->fields['descripcion']?></td>
              <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
            </tr>
						<?php }
					 } else {
						//Existe agrupacion, por lo cual si esta enn la tabla agrupamos segun corresponda	 
						$buscar="Select count(idcargo) as totc from rrhh_cargos_agrupados where idcargo=$idcargo"	 ;
						$tr1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						$ne=intval($tr1->fields['totc']);
						if ($ne>0){	 
							//el item fue agrupado
							$magrupados=$magrupados+floatval($rscargos->fields['monto']);
						} else { 
							//item no argupado, mostramos
							if (($muestraambos=='S') or ($mostraren==2)){
								$ts=$ts+floatval($rscargos->fields['monto']);
							?>
            <tr>
              <td colspan="4"><?php echo $rscargos->fields['descripcion']?></td>
              <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
            </tr>
							<?php }
						 }//de $ne>0
            	 }//de agrupacion =0
         	 $rscargos->MoveNext();
			 $totaldescuentos=$totaldescuentos+$ts;
			 }
         }//de tcargos > 0
		$rscargos->MoveFirst();
		
		?>
		<?php if ($descuentoh>0){ ?>
         <tr>
                  <td colspan="3">AUSENCIAS </td>
                  <td><?php echo $diasdesc;?></td>
                  <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($descuentoh,4,'N');?></td>
			</tr>
        
        <?php } ?>
        <?php if ($descuentosdias>0){ ?>
         <tr>
                  <td colspan="3">DIAS DESC X </td>
                  <td><?php echo $diasdesc;?></td>
                  <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($descuentosdias,4,'N');?></td>
			</tr>
        
        <?php } ?>
        <?php if ($magrupados > 0){
			$totaldescuentos=$totaldescuentos+$magrupados;
			
			?>
          <tr>
                  <td colspan="4">OTROS DESCUENTOS</td>
                  <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($magrupados,4,'N');?></td>
			</tr>
         <?php } ?>
		 <?php 
		// echo $ts;exit;
			//preparamos un neto a cobrar para  los que fueron recalculados
			$desc1=floatval($ts);
			
			$desc2=floatval($magrupados);
		
			$totaldescuentos=$desc1+$desc2+$descuentosdias+$descuentoh;
			//$netorecalc=floatval($desc1)+floatval($desc2);
			//$netorecalc=($subtotal-$netorecalc);
		 	 if ($rspagos->fields['recalculado']=='S'){
				$totaldescuentos=($rspagos->fields['descuentos_varios']+$rspagos->fields['descontadonetodias']);
				
			} 
		 	//Nuevas para mostrar valores en recibo interno
			
		 
		 	$saldo=$totalingresos-$totaldescuentos;
		
		 ?>
		 <?php if ($adicionales>0){ ?>
		 <tr>
			<td height="32" colspan="2">Adicionales</td>
			<td align="left"><?php echo  formatomoneda($adicionales,4,'N');?></td>
			<td></td>
			<td></td>
        </tr>
		 <?php } ?>
		 <?php if ($tsumar1>0){ ?>
		 <tr>
			<td height="32" colspan="2">Pasantia</td>
			<td align="left"><?php echo  formatomoneda($tsumar1,4,'N');?></td>
			<td></td>
			<td></td>
        </tr>
		 <?php } ?>
		<?php if ($sobresalario1>0){ ?>
		 <tr>
			<td height="32" colspan="2">PLUS</td>
			<td align="left"><?php echo  formatomoneda($sobresalario1,4,'N');?></td>
			<td></td>
			<td></td>
        </tr>
		 <?php } ?>
		<?php if ($comiadi>0){ ?>
				 
			<tr>
			  <td height=\"32\" colspan=\"2\">Plus Adicional</td>
				<td align=\"right\">&nbsp;</td>
				<td><?php echo formatomoneda($comiadi,4,'N'); ?></td>
				<td></td>
				
			</tr>
				
				
				
				
				
			<?php } ?>
				
			<tr>
				<td>Total Ingresos / Retenciones</td>
				<td></td>
				<td align=""><?php echo formatomoneda($totalingresos,4,'N'); ?></td>
				<td></td>
				<td align="right"><?php echo formatomoneda($totaldescuentos,4,'N'); ?></td>
			</tr>
			<tr>
				<td  style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;">A Cobrar GS:</td>
				<td style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"></td>
				<td style="height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;"><?php echo formatomoneda($saldo,4,'N'); ?>
					
				</td>
			</tr>
		</table>
		<hr />
		<?php $let=num2letras($saldo); ?>
		<h3>Recib&iacute; Conforme copia, la suma de Gs: <?php echo formatomoneda($saldo,4,'N'); ?> (Gs: <?php echo $let; ?>)</h3>
		<br />
		<div style="float:right; max-width:250px;text-align:center;">
		-------------------------------------------<br />
		Firma del Trabajador <br /> DC: <?php echo $_REQUEST['idf']; ?>
		</div>
	</div>
</div>





<?php } ?>

<?php if ($tipo==2){//Recibo Salarial Original
	/* //datos de salario acordado ANULADO PORQUE YA SE COLOCO FUERA DEL IF PARA MINIMIN+ZAR CONSULTAS INNECESARIAS
	$buscar="Select * from rrhh_salarios where idfuncionario=$idfuncionario and estado=1";
	$rssal=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

	$salario=floatval($rssal->fields['monto_salario']) */;
	
	//Fecha por defecto para impresion de recibos (cierre de mes)
	$buscar="select * from preferencias_rrhh limit 1";
	$rsff=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$fecha_real=trim($rsff->fields['cierre_real']);
	if ($fecha_real=='S'){
	    $fecharecibo=date("Y-m-d");
		
	} else {
		 $fecharecibo=trim($rsff->fields['cierre_fecha_definida']);
		 if ($fecharecibo==''){
			 $fecharecibo=date("Y-m-d");
			 //usamos la del dia hasta que definan una fecha
		 } else {
			 //armamos en base al dia
			 $d=intval($rsff->fields['cierre_fecha_definida']);
			 if ($d<10){
				 $d='0'.$d;
			 }
			 $nm=date('m');
			 $nm=$m+1;
		
			if ($nm==13){
				$nm=01;
			}
		
			 $na=date('Y');
			 $fg=$na.'-'.$nm.'-'.$d;
			 $fecharecibo=date("Y-m-d",strtotime($fg));
			 //usamos la del dia hasta que definan una fecha
			 
		 }
		
	}
	
	
	//Datos de la empresa / empleador
	$buscar="Select * from gest_patronal order by codpatronal desc limit 1";
	$rsp=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$patronal=trim($rsp->fields['razon_social']);
	
	$per=date("m",$inicio);
	$an=date("Y",$inicio);
	//Datos empleado
	
	
	//Total de dias
	$buscar="SELECT count(fecha) as cantidad,fecha from rrhh_planilla_tanda_detalles where documento=$idf and date(fecha) between '$inicio' and '$final' group by fecha order by fecha asc";
	$rsd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	//echo $buscar;
	$tdiasf=$rsd->RecordCount();
	$tdias=$tdiasf;
	
	
	
	
	//Si uno de los valores fue fijado, verificamo y reemplazamos t dias x el jornal
	$buscar="select sum(dias_trabaja) as tdias from rrhh_pagos_salarios where documento=$idf and fijado=1 and idreg=$idreg";
	$rscontrola=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	if (intval($rscontrola->fields['tdias'])>0){
		//se fijo un valor y encima tiene a mano los dias trabajados, por lo cual respetaremos ese item
		$tdiasf=intval($rscontrola->fields['tdias']);	
		
	}
	
	//Cargos-Descuentos
	$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
	inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
	where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
	and fecha_descontado is null order by descripcion asc";
	$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tcargos=$rscargos->RecordCount();
	
	//Buscamos si hay agrupacion de descuentos, si los hay, iuncluimos en el while oara mostrar o sumar los conceptos segun la agrupacion
	//se usa en recibo 2
	$buscar="Select count(idcargo) as total from rrhh_cargos_agrupados";
	$rstagrupados=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$tagrupados=intval($rstagrupados->fields['total']);
	$vigentemessubtotal=($vigentejornal*$tdiasf)+$tempoadicional;//PARA EL FISCAL USAR SIEMPRE EL JORNAL VIGENTE DE LA TABLA< DEFINIDA POR EL MIN
	
	
	//Por sobre el fijado, tiene prevalencia el recalculado
	if ($tpagos > 0){
 			 if($rspagos->fields['recalculo']=='S'){
 			$netocobrar=floatval($rspagos->fields['neto_cobrar']);
			 }
 	}
	?>
    <!----------------------------------------------FISCAL-------------------------->
    
    
    <div style="float:left; margin-left:10px; border:1px solid #000000; width:550px;">
    <table width="545" style="border-collapse:collapse;">
    <tr>
    	<td height="27" colspan="4">Empleador:&nbsp;<strong><?php echo $patronal;?></strong></td>
    	<td colspan="4"></td>
    </tr>
     <tr>
    	<td height="28" colspan="4">Empleado: &nbsp;<strong><?php echo $nomape;?></strong></td>
   	   <td colspan="4">Periodo de Pago:  &nbsp;<strong><?php echo $m."/".$ano?></strong></td>
    </tr>
     <tr>
    	<td height="26" colspan="4">Documento:&nbsp;<strong><?php echo $_REQUEST['idf'];?></strong></td>
    	<td colspan="4">Fecha : &nbsp;<strong><?php echo date("d/m/Y",strtotime($fecharecibo));?></strong></td>
    </tr>
     <tr>
    	<td colspan="4">&nbsp;</td>
    	<td colspan="4"></td>
    </tr>
    	<tr>
        	<td width="65" align="center" bgcolor="#E7E7E7">Dias trabajados</td>
        	<td width="70" align="center" bgcolor="#E7E7E7">Salario B&aacute;sico</td>
            <td width="68" align="center" bgcolor="#E7E7E7">Sub Total</td>
            <td width="60" align="center" bgcolor="#E7E7E7">Extras</td>
            <td width="48" align="center" bgcolor="#E7E7E7">Asig. Familiar</td>
            <td width="70" align="center" bgcolor="#E7E7E7">Vacaciones</td>
            <td width="61" align="center" bgcolor="#E7E7E7">Aguinaldo</td>
             <td width="67" align="center" bgcolor="#E7E7E7">Total Salario</td>
        </tr>
	  <tr>
    		<td align="center"><?php echo $tdiasf;?></td>
            <td align="right"><?php echo formatomoneda($vigentemes,4,'N'); ?></td>
            <td align="right"><?php echo formatomoneda($vigentemessubtotal,4,'N'); ?></td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right"><?php echo formatomoneda($vigentemessubtotal,4,'N'); ?></td>
    	</tr>
        <?php if ($tcargos > 0){?>
         <tr>
        <td colspan="6"></td>
        <td colspan="2" align="center" bgcolor="#E7E7E7">Descuentos</td>
        </tr>
        
        
        <?php 
		$ts=0;
		while (!$rscargos->EOF){
			$muestraambos=trim($rscargos->fields['muestra_ambos']);
			$mostraren=intval($rscargos->fields['mostrar_en']);
			if (($muestraambos=='S') or ($mostraren==1)){
			$ts=$ts+floatval($rscargos->fields['monto']);
			?>
         <tr>
       	  <td colspan="4"></td>
            <td></td>
            <td></td>
          <td style="border-bottom:1px solid #000000;border-left:1px solid #000000;"><?php echo $rscargos->fields['descripcion']?></td>
            <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
        </tr>
        <?php }?>
         <?php $rscargos->MoveNext();}?>
        <?php }
		$rscargos->MoveFirst();?>
        <tr>
       	  <td colspan="4"></td>
            <td></td>
            <td></td>
          <td style="border-bottom:1px solid #000000;border-left:1px solid #000000;">Saldo Cobrar</td>
            <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda(($vigentemessubtotal-$ts),4,'N');?></td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
       	  <td height="29" colspan="4">Recibi conforme el saldo a cobrar</td>
            <td></td>
            <td></td>
          <td colspan="2" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">....................................</td>
          
      </tr>
        <tr>
       	  <td colspan="4"></td>
            <td></td>
          <td></td>
          <td colspan="2" align="center" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">Firma Empleado</td>
          
        </tr>
</table>
</div>
 <!----------------------------USO INTERNO------------------------>
 <?php 
 if ($tpagos > 0){
	 $adicionales=floatval($rspagos->fields['adicional_base']);
	 //echo $adicionales;
	 if($rspagos->fields['recalculo']=='S'){
		 //echo 'ACA';
		$tdias=floatval($rspagos->fields['dias_recalculo']);
		$netocobrar=floatval($rspagos->fields['neto_cobrar']);
	
	
	$subtotal=ceil($rspagos->fields['dias_recalculo']*$rspagos->fields['jornal_recalculo']);
	$subtotal=redondear_precio($subtotal,2,'A'); 
		 
	 } else {
		 
		 $subtotal=$tdias*$vigentejornal;//echo $subtotal;
		$subtotal=redondear_precio($subtotal,2,'A'); 
		 
		 
	 }
 }
 
 ?>
<div style="float:left; margin-left:30px; border:1px solid #000000; width:580px;">
    <table width="545" style="border-collapse:collapse;">
    <tr>
    	<td height="27" colspan="4">Empleador:&nbsp;<strong><?php echo $patronal;?></strong></td>
    	<td colspan="4"></td>
    </tr>
     <tr>
    	<td height="28" colspan="4">Empleado: &nbsp;<strong><?php echo $nomape;?></strong></td>
   	   <td colspan="4">Periodo de Pago:  &nbsp;<strong><?php echo $m."/".$ano?></strong></td>
    </tr>
     <tr>
    	<td height="26" colspan="4">Documento:&nbsp;<strong><?php echo $_REQUEST['idf'];?></strong></td>
    	<td colspan="4">Fecha : &nbsp;<strong><?php echo date("d/m/Y",strtotime($fecharecibo)); ?></strong></td>
    </tr>
     <tr>
    	<td colspan="4">&nbsp;</td>
    	<td colspan="4"></td>
    </tr>
    	<tr>
        	<td width="64" align="center" bgcolor="#E7E7E7">Dias trabajados</td>
        	<td width="54" align="center" bgcolor="#E7E7E7">Salario B&aacute;sico</td>
            <td width="44" align="center" bgcolor="#E7E7E7">Sub Total</td>
            <td width="46" align="center" bgcolor="#E7E7E7">Extras</td>
            <td width="48" align="center" bgcolor="#E7E7E7">Asig. Familiar</td>
            <td width="70" align="center" bgcolor="#E7E7E7">Vacaciones</td>
            <td width="102" align="center" bgcolor="#E7E7E7">Aguinaldo</td>
             <td width="81" align="center" bgcolor="#E7E7E7">Total Salario</td>
        </tr>
	  <tr>
    		<td align="center"><?php echo $tdias;?></td>
            <td align="right"><?php echo formatomoneda($salario,4,'N'); ?></td>
            <td align="right"><?php echo formatomoneda($subtotal,4,'N'); ?></td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right">0</td>
            <td align="right"><?php echo formatomoneda($subtotal,4,'N'); ?></td>
   	  </tr>
        <?php if ($tcargos > 0){?>
         <tr>
        <td colspan="4"></td>
        <td colspan="2" align="center">&nbsp;</td>
        <td colspan="2" align="center" bgcolor="#E7E7E7">Descuentos</td>
      </tr>
        
        
        <?php 
		$ts=0;
		$magrupados=0;
		while (!$rscargos->EOF){
			$muestraambos=trim($rscargos->fields['muestra_ambos']);
			$mostraren=intval($rscargos->fields['mostrar_en']);
			$idcargo=intval($rscargos->fields['idcargo']);
			//echo $tagrupados;exit;
			if ($tagrupados==0){
				if (($muestraambos=='S') or ($mostraren==2)){
				$ts=$ts+floatval($rscargos->fields['monto']);
				?>
               <tr>
                  <td colspan="4"></td>
                    <td></td>
                    <td>&nbsp;</td>
                  <td style="border-bottom:1px solid #000000;border-left:1px solid #000000;"><?php echo $rscargos->fields['descripcion']?></td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
      </tr>
				<?php }?>
             <?php } else {
				// echo 'agrupa';exit;
			//Existe agrupacion, por lo cual si esta enn la tabla agrupamos segun corresponda	 
			$buscar="Select count(idcargo) as totc from rrhh_cargos_agrupados where idcargo=$idcargo"	 ;
			$tr1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$ne=intval($tr1->fields['totc']);
			if ($ne>0){	 
			//el item fue agrupado
			$magrupados=$magrupados+floatval($rscargos->fields['monto']);
			
			
			?>
            
             
             <?php } else{ 
			 //item no argupado, mostramos
			
             if (($muestraambos=='S') or ($mostraren==2)){
				$ts=$ts+floatval($rscargos->fields['monto']);
				?>
               <tr>
                  <td colspan="4"></td>
                    <td></td>
                    <td></td>
                  <td style="border-bottom:1px solid #000000;border-left:1px solid #000000;"><?php echo $rscargos->fields['descripcion']?></td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
      </tr>
				<?php }?>
             <?php }//de $ne>0?>
             <?php }//de agrupacion =0?>
         <?php $rscargos->MoveNext();}?>
        <?php }
		$rscargos->MoveFirst();?>
        <?php if ($magrupados > 0){?>
          <tr>
                  <td colspan="4"></td>
                    <td></td>
                    <td></td>
                    <td style="border-bottom:1px solid #000000;border-right:0px solid #000000;">OTROS DESCUENTOS</td>
                    <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;"><?php echo formatomoneda($magrupados,4,'N');?></td>
      </tr>
         <?php } ?>
		 <?php 
		 //preparamos un neto a cobrar para  los que fueron recalculados
		// echo $magrupados;
		$desc1=floatval($ts);
		$desc2=floatval($magrupados);
		$netorecalc=floatval($desc1)+floatval($desc2);
		$netorecalc=($subtotal-$netorecalc)+$adicionales;
		 //echo $netorecalc;
		 ?>
        <tr>
       	  <td height="32" colspan="4"></td>
            <td>Adicionales</td>
            <td><?php echo  formatomoneda($adicionales,4,'N');?></td>
          <td style="border-bottom:1px solid #000000;border-left:1px solid #000000;">Saldo Cobrar</td>
            <td align="right"  style="border-bottom:1px solid #000000;border-right:1px solid #000000;">
<?php  if ($rspagos->fields['recalculado']!='S'){
			echo formatomoneda($netorecalc,4,'N'); 
		} else { 
			echo formatomoneda(($netocobrar),4,'N');
		}
?>
</td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
        <td colspan="8"></td>
        </tr>
        <tr>
       	  <td height="29" colspan="4">Recibi conforme el saldo a cobrar</td>
            <td></td>
            <td></td>
          <td colspan="2" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">....................................</td>
          
      </tr>
        <tr>
       	  <td colspan="4"></td>
            <td></td>
          <td></td>
          <td colspan="2" align="center" style="border-bottom:1px solid #000000;border-left:1px solid #000000;">Firma Empleado</td>
          
        </tr>
</table>
</div>
<?php } ?>
