<?php
/*------------------------------------------------------------------------------------
Nuevo script que genera el resumen y los recibos, en pantalla 
o bien para descarga en pdf. Individual x funcionario o x sucursal en base a lista
UC: 29/09/2021
07/07/23
-------------------------------------------------------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="18";
$submodulo="281";
require_once("includes/rsusuario.php");
require_once("includes/num2letra.php");


function nombre_dia($fecha){
   $fechats = strtotime($fecha); //pasamos a timestamp

//el parametro w en la funcion date indica que queremos el dia de la semana
//lo devuelve en numero 0 domingo, 1 lunes,....
switch (date('w', $fechats)){
    case 0: return "Domingo"; break;
    case 1: return "Lunes"; break;
    case 2: return "Martes"; break;
    case 3: return "Miercoles"; break;
    case 4: return "Jueves"; break;
    case 5: return "Viernes"; break;
    case 6: return "Sabado"; break;
}
}

function redondear_precio($precio,$ceros,$direccion){
     // direccion  A: hacia arriba // B: hacia abajo N: Normal
    if($direccion == 'A'){
        $precio_redondeado=ceil($precio/10**$ceros)*(10**$ceros);
    }else if($direccion == 'B'){
        $precio_redondeado=floor($precio/10**$ceros)*(10**$ceros);
    }else{
        $precio_redondeado=round($precio/10**$ceros)*(10**$ceros);
    }
    return $precio_redondeado;
}
$dmes=30;//fijo x ahora debe venir de una pref
$idsnap=intval($_REQUEST['idsnap']);//id unico del snapshot para mostrar en documentos
$documento=antisqlinyeccion($_REQUEST['documento'],'text');//documenti del funcionario, solo para uso individual
$tipo=antisqlinyeccion($_REQUEST['tp'],'int');//indica si es resumen o recibo

$idreg=intval($_REQUEST['idmespago']);//id unico de la tanda abierta de pagos
$clase=intval($_REQUEST['cla']);//define si es individual o while x sucursal
$idsucursallocal=intval($_REQUEST['ids']);//id de sucursal para while
//Datos del Mes en curso
$buscar="Select * from rrhh_mes_activo where idreg=$idreg ";
$rsactivo=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$m=intval($rsactivo->fields['mes']);
if ($m<10){
	$m="0"	.$m;
	
}
$ano=intval($rsactivo->fields['ano']);
$pfecha=$ano."-".$m."-".'01';$ld=ultimodia(date("Y-m-d",strtotime($pfecha)));$lfecha=$ano."-".$m."-".$ld;
//Inicio y final de fechas
$inicio=date("Y-m-d",strtotime($pfecha));
$final=date("Y-m-d",strtotime($lfecha));

$buscar="select * from preferencias_rrhh limit 1";
$rsff=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$fecha_real=trim($rsff->fields['cierre_real']);
if ($fecha_real=='S'){
	$fecharecibo=date("Y-m-d");
	
} else {
	 $fecharecibo=trim($rsff->fields['cierre_fecha_definida']);
	 if ($fecharecibo==''){
		 $fecharecibo=date("Y-m-d");
		 //usamos la del dia hasta que definan una fecha
	 } else {
		 //armamos en base al dia
		 $d=intval($rsff->fields['cierre_fecha_definida']);
		 if ($d<10){
			 $d='0'.$d;
		 }
		 $nm=date('m');
		 $nm=$m+1;
	
		if ($nm==13){
			$nm=01;
		}
	
		 $na=date('Y');
		 $fg=$na.'-'.$nm.'-'.$d;
		 $fecharecibo=date("Y-m-d",strtotime($fg));
		 //usamos la del dia hasta que definan una fecha
		 
	 }
	
}
$buscar="Select * from gest_patronal order by codpatronal desc limit 1";
$rsp=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
$patronal=trim($rsp->fields['razon_social']);
$patronal_num=trim($rsp->fields['codpatronal']);
$per=date("m",$inicio);
$an=date("Y",$inicio);

if ($clase!=2){
	//Individual
	if ($tipo==1){
		//resumen
			/*------------------------------------------------ARRAY MARCACIONES------------------------------------------*/
			$buscar="Select * from rrhh_planilla_tanda_detalles where fecha between '$inicio' and '$final' and  documento=$documento  group by fecha order by fecha asc";
			$rsacti=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

			$tr=$rsacti->RecordCount();
			$fechamarca=array();$minutos=array();$clase=array();$lientra='';$lisale='';
			while(!$rsacti->EOF){
				$fecha_registro=$rsacti->fields['fecha'];
				 
				//traemos los datos de la fecha por orden asc
				$buscar="Select entrada1,salida1,minutos_favor,minutos_contra,marca,monto,accion
				from rrhh_planilla_tanda_detalles where 
				fecha='$fecha_registro' and  documento=$documento order by entrada1,salida1 asc"	;
				$rsdat=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$lientra='';$lisale='';$mincontra=0;$minfavor=0;
				while (!$rsdat->EOF){
					$tiporeg=trim($rsdat->fields['marca']);
					if (trim($rsdat->fields['entrada1'])!=''){
						$lientra.=trim($rsdat->fields['entrada1'])."<br />";
					}
					if (trim($rsdat->fields['salida1'])!=''){
						$lisale.=trim($rsdat->fields['salida1'])."<br />";
					}
					$mincontra=$mincontra+floatval($rsdat->fields['minutos_contra']);
					$minfavor=$minfavor+floatval($rsdat->fields['minutos_favor']);
					$rsdat->MoveNext();
				}
				$fechamarca[$fecha_registro]['S'] = $lisale;
				$fechamarca[$fecha_registro]['E'] = $lientra;
				$minutos[$fecha_registro]['F'] = $minfavor;
				$minutos[$fecha_registro]['C'] = $mincontra;
				$clase[$fecha_registro]['T'] = $tiporeg;
				$rsacti->MoveNext();
			}
			/*--------------------------------------------------FINAL ARRAY MARCACIONES--------------------------*/
			/*-----------------------------------------------dDatos del funcionario-------------------------------*/
				$buscar="Select nombres,apellidos,gest_funcionarios.idhorario,descripcion,idfunci,monto_dia_f,monto_mes_f
				from gest_funcionarios
				inner join rrhh_horarios on rrhh_horarios.idhorario=gest_funcionarios.idhorario
				where gest_funcionarios.documento=$documento";
				//echo $buscar;
				$rs1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$nomape=trim($rs1->fields['nombres']).' '.trim($rs1->fields['apellidos']);
				$horario=intval($rs1->fields['idhorario']);
				$deshora=trim($rs1->fields['descripcion']);
				$idfuncionario=intval($rs1->fields['idfunci']);
				if ($idfuncionario==0){
					echo "ATENCION: El funcionario no posee un horario asignado. Verifique el horario y regrese nuevamente"	;exit;
					
				}
				
			/*---------------------------------------------------------------------------------------------*/
			/*--------------------------------------------------FRANJAS HORARIAS----------------------------*/
				//Traemos las franjas de horas
				$buscar="Select rrhh_horarios.descripcion,idturno,hora_inicio,hora_final,min_inicio,min_final,idturno
				from rrhh_horarios inner join rrhh_franja_horaria on rrhh_franja_horaria.idtipohora=rrhh_horarios.idhorario
				where rrhh_horarios.idhorario=$horario order by idturno asc
				";
				$rs2=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				
				$franja='';
				$horariocom='';
				$horariofin='';
				while (!$rs2->EOF){
					
					$franja="Tipo Horario: ".trim($rs2->fields['descripcion']);
					$horariocom.='Turno: '.$rs2->fields['idturno'].' de ';
					if (intval($rs2->fields['hora_inicio']) <10){
						$hi='0'.$rs2->fields['hora_inicio'];
					} else {
						$hi=$rs2->fields['hora_inicio'];
					}
					if (intval($rs2->fields['min_inicio']) <10){
						$mi='0'.$rs2->fields['min_inicio'];
					} else {
						$mi=$rs2->fields['min_inicio'];
					}
					//Hora final
					if (intval($rs2->fields['hora_final']) <10){
						$hf='0'.$rs2->fields['hora_final'];
					} else {
						$hf=$rs2->fields['hora_final'];
					}
					if (intval($rs2->fields['min_final']) <10){
						$mf='0'.$rs2->fields['min_final'];
					} else {
						$mf=$rs2->fields['min_final'];
					}
					
					
					$horariocom.=$hi.":".$mi.' a '.$hf.':'.$mf.'<br />';
					//trim($rs2->fields['hora_inicio']).' '.trim($rs2->fields['min_inicio']).' ->'.trim($rs2->fields['hora_final']).' '.trim($rs2->fields['min_final']).' | ';
					$horariofin=trim($rs2->fields['hora_final']).' '.trim($rs2->fields['min_final']);
					$rs2->MoveNext();
				}
			/*----------------------------------------------------------------------------------------------*/
			$resumen="";
			$resumen.="
			<div style=\"border:1px #000000; width:400px;float:left;\">
				<table width=\"96%\" height=\"138\" border=\"1\">
					<tr>
						<td colspan=\"4\"  bgcolor=\"#EFEFEF\">$nomape</td>
						<td colspan=\"4\"  bgcolor=\"#EFEFEF\">$franja</td>
					</tr>
					<tr>
						<td colspan=\"8\" align=\"center\"  bgcolor=\"#EFEFEF\">$horariocom</td>
					</tr>
					<tr>
						<td width=\"45\" height=\"28\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>Dia</strong></td>
						<td align=\"center\" bgcolor=\"#F3F3F3\"><strong>Fecha</strong></td>
						<td width=\"94\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>Entrada</strong></td>
						<td width=\"89\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>Salida</strong></td>
						<td width=\"59\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>Tipo</strong></td>
						<td width=\"59\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>MF+</strong></td>
						<td width=\"78\" align=\"center\" bgcolor=\"#F3F3F3\"><strong>MC-</strong></td>
					</tr>";
					//echo $resumen;exit;
						$fecactu=$inicio;
						$i=1;
						$fecactu_int=strtotime($fecactu);
						$final_int=strtotime($final);
						
						while($fecactu_int <= $final_int){
						
							$fecactu=date("Y-m-d",$fecactu_int);$diachar=nombre_dia($fecactu);$cca=trim($clase[$fecactu]['T']);
							if ($cca!=''){
								$color="#D8D8D8";
							} else {
								$color="#FFFFFF";
							}
							$resumen.="
							<tr style=\"background-color: $color\">
								<td >$diachar</td>
								<td align=\"center\" width=\"93\">".date("d/m/Y",strtotime($fecactu))."</td>
								<td align=\"center\">".$fechamarca[$fecactu]['E']."</td>
								<td align=\"center\">".$fechamarca[$fecactu]['S']."</td>
								 <td align=\"cente\r\">".$clase[$fecactu]['T']."</td>
								<td align=\"center\">".$minutos[$fecactu]['F']."</td>
								<td align=\"center\">".$minutos[$fecactu]['C']."</td>
							</tr>";
						
								$fecactu_int=strtotime(date("Y-m-d",strtotime($fecactu."+ 1 days")));
								$i++;
								if($i>31){
									break;
									echo 'solo se pueden procesar hasta 1000 dias';
									exit;
								}
							
						}
						$resumen.=" 
						<tr>
							<td height=\"32\" colspan=\"8\" align=\"center\" bgcolor=\"#E5E5E5\"><strong>Total Marcaciones: $tr</strong></td>
						
					</tr>
					  
				  </table>

				</div>";
				/*------------------------------DESGLOCE---------------------------*/
				$buscar="select * from rrhh_snapshot_resumen   where uns=$idsnap";
				$rscab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				
				$cobarxdiasreal=floatval($rscab->fields['cobrar_xdias_trabajados']);
				$plusxdiastrabajados=floatval($rscab->fields['plus_xdias_trabajados']);
				$dtr=intval($rscab->fields['dias_reales_trabajados']);
				$jornal_diario_establecido=floatval($rscab->fields['jornal_real_establecido']);
			
				$buscar="Select * from rrhh_snapshot_suma where idsnap=$idsnap";
				$rssuma=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				
				$buscar="Select * from rrhh_snapshot_resta where idsnap=$idsnap";
				$rsresta=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				
				$plus_adicional_monto=floatval($rssuma->fields['plus_adicional_monto']);//si es que hay algun plus adicional
				$total_hs_nocturnas=floatval($rssuma->fields['total_hs_nocturnas']);
				$montoxhoras_nocturnas=floatval($rssuma->fields['monto_x_hnocturna']);
				$montoxpasantia=floatval($rssuma->fields['monto_xdia_pasantia']);
				$cantidad_dias_pasantia=floatval($rssuma->fields['cant_dias_pasantias']);
				$monto_adicional_otros=floatval($rssuma->fields['monto_xdia_adicional']);
				$describesuma=trim($rssuma->fields['descripcion']);
				$montosuma=floatval($rssuma->fields['montodes']);
				$describeresta=trim($rsresta->fields['descripcion']);
				$montoresta=floatval($rsresta->fields['montodes']);
				
				
				//Salario Neto del funcionario
				$buscar="Select monto_salario from rrhh_salarios where idfuncionario=$idfuncionario and estado <> 6 order by idsalario desc limit 1";
				$rsala1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$salariobase=floatval($rsala1->fields[monto_salario]);
				//Salario Vigente basico x mes
				$buscar="Select * from rrhh_salarios_vigentes";
				$salario=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$salariolegalvigente=floatval($salario->fields['monto_mensual']);
				//calcular la diferencia de salario
				$plusxdiferecia=$salariobase-$salariolegalvigente;
				if ($plusxdiferecia<0){
					$plusxdiferecia=0;
				}
				if ($plusxdiferecia > 0 && $dtr>0){
					$plusxdias=floatval($plusxdiferecia /$dmes);
					$plusxdias=$plusxdias*$dtr;
				}
				if ($jornal_diario_establecido>0){
					$monto_dia_f=$jornal_diario_establecido;
				}
				//en base al jornal establecido, haremos el calculo de cobro x dias
				$cobrarxdias=$dtr*$monto_dia_f;
				$cobrarxdias=floatval($cobrarxdias);
				$plusxdias=floatval($plusxdias);
				
				$desgloce="";
				$desgloce.="
				<div style=\"border:0px solid #E32528; width:300px;float:left; margin-left:2%;\">
					<table width=\"284\" height=\"524\" border=\"1\">
						<tr>
							<td height=\"37\" colspan=\"3\" align=\"center\" bgcolor=\"#EFEFEF\" style=\"border-bottom:thin; border-bottom-color:black;\"><strong>Desgloce </strong></td>
						</tr>
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Sueldo Neto</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($salariobase,4,'N')."</td>
						</tr>
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Sueldo Basico</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($salariolegalvigente,4,'N')."</td>

						</tr>
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Dif. Salario (PLUS)</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($plusxdiferecia,4,'N')."</td>
			
						</tr>
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Jornal Establecido</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($monto_dia_f,4,'N')."</td>
			
						</tr>
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Dias del Mes (fijo)</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($dmes,4,'N')."</td>
			
						</tr>
							<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Dias trabajados (marcaciones)</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($tr,4,'N')."</td>
			
						</tr>
						</tr>
							<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Dias trabajados (reales)</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda($dtr,4,'N')."</td>
			
						</tr>
						</tr>
							<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Diferencia dias</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda(($dmes-$tr),4,'N')."</td>
			
						</tr>
						</tr>
							<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Cobrar x dias trabajados (reales)</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda(($cobrarxdias),4,'N')."</td>
						</tr>
						</tr>
							<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Plus x dias trabajados</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda(($plusxdias),0,'N')."</td>
						</tr>
						
						";
						if ($plus_adicional_monto>0){
							$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Plus Adicional</strong></td>
								<td width=\"83\" align=\"right\">".formatomoneda((plus_adicional_monto),0,'N')."</td>
							</tr>
							";
							
						}
						//formatomoneda(($total_hs_nocturnas),0,'N')." X ". formatomoneda(($cantidad_dias_pasantia),0,'N')." X ". formatomoneda(($montoxhoras_nocturnas),0,'N')."=".formatomoneda(($montoxpasantia),0,'N')."=".
						if ($total_hs_nocturnas>0){
							$monto_nocturnas=$total_hs_nocturnas*$montoxhoras_nocturnas;
							$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Horas Nocturnas</strong></td>
								<td width=\"83\" align=\"right\">".formatomoneda(($monto_nocturnas),0,'N')."</td>
							</tr>
							";
							
						}
						if ($montoxpasantia>0){
							$totalpasantia=$montoxpasantia*$cantidad_dias_pasantia;
							$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Pasantia</strong></td>
								<td width=\"83\" align=\"right\">".formatomoneda(($totalpasantia),0,'N')."</td>
							</tr>
							";
						}
						if ($monto_adicional_otros>0){
							//$totalpasantia=$montoxpasantia*$cantidad_dias_pasantia;
							$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Adicionales/Otros</strong></td>
								<td width=\"83\" align=\"right\">".formatomoneda(($monto_adicional_otros),0,'N')."</td>
							</tr>
							";
						}
						if ($montosuma>0){
							//$totalpasantia=$montoxpasantia*$cantidad_dias_pasantia;
							$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>$describesuma</strong></td>
								<td width=\"83\" align=\"right\">".formatomoneda(($montosuma),0,'N')."</td>
							</tr>
							";
						}
									
						//Sub totalizamos lo que suma
						$neto_cobrar=$cobarxdiasreal+$plusxdiastrabajados+$plus_adicional_monto+$monto_nocturnas+$totalpasantia+$monto_adicional_otros+$montosuma;
						
						$linea.="
							<tr>
								<td width=\"113\" height=\"34\" bgcolor=\"#EFEFEF\"><strong>Sub total Ingresos</strong></td>
								<td width=\"83\" align=\"right\" bgcolor=\"#EFEFEF\">".formatomoneda(($neto_cobrar),0,'N')."</td>
							</tr>
							";
						/*---------------------------------------------------------Descuentos	--------------------------------------------------------------------*/
						$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
						inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
						where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
						and fecha_descontado is null order by descripcion asc";
						
						$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						$descuentos=$rscargos->RecordCount();
						
						$cabedes='';
						$m='N';
						$tcargofinal=0;
						$descxdiast=0;
						$cant_dias_resta=floatval($rsresta->fields['cant_dias_descontar']);
						$monto_desc_xdias=floatval($rsresta->fields['monto_xdias_descontar']);
						if ($cant_dias_resta > 0){
							$m='S';
							$descxdiast=$monto_desc_xdias*$cant_dias_resta;
							$linean=$linean."
							<tr>
								<td style='width:35%;'>Descuento x $cant_dias_resta dias</td>
								
								<td  style='width:50px;' align=\"right\" >".formatomoneda($monto_desc_xdias,0,'N')."</td>
							
								
							</tr>
							";
						}
						$tcargofinal=$tcargofinal+$descxdiast;
						
						
						
						if ($descuentos >0){
							$m='S';
							$linean=$linean."
							
							<tr>
								<td colspan=\"2\" align=\"center\" style='width:98%;background-color:#E5E7E9'>Descuentos</td>
								
							</tr>
							";
							while (!$rscargos->EOF){
								$tcargofinal=$tcargofinal+$rscargos->fields['monto'];
								$descrip=trim($rscargos->fields['descripcion']);
								$linean=$linean."
								<tr>
									<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>$descrip</strong></td>
									<td width=\"83\" align=\"right\">".formatomoneda(($rscargos->fields['monto']),0,'N')."</td>
								</tr>
								";
								$rscargos->MoveNext();
							}
						}
						if ($m=='S'){
							//$cabedes="<tr><td align=\"center\" bgcolor=\"#EFEFEF\" colspan=\"2\"><strong>Descuentos</strong></td></tr>";
						}
						if ($montoresta >0){
							$linean=$linean."
								<tr>
									<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>$describeresta</strong></td>
									<td width=\"83\" align=\"right\">".formatomoneda(($montoresta),0,'N')."</td>
								</tr>
								";
						}
						$neto_cobrar=$neto_cobrar-$tcargofinal-$montoresta;
						$linea=$linea.$cabedes.$linean."
						<tr>
							<td width=\"113\" height=\"34\" bgcolor=\"#E0E0E0\"><strong>Cobrar Neto Gs</strong></td>
							<td width=\"83\" align=\"right\">".formatomoneda(($neto_cobrar),0,'N')."</td>
						</tr>";
			
					
			
			
					$final=$resumen.$desgloce.$linea;
					echo $final;
			
	}
	if ($tipo==2){
		//recibo
		/*-----------------------------------------------Datos del funcionario-------------------------------*/
				$buscar="Select nombres,apellidos,gest_funcionarios.idhorario,descripcion,idfunci,monto_dia_f,monto_mes_f
				from gest_funcionarios
				inner join rrhh_horarios on rrhh_horarios.idhorario=gest_funcionarios.idhorario
				where gest_funcionarios.documento=$documento";
				//echo $buscar;
				$rs1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				$nomape=trim($rs1->fields['nombres']).' '.trim($rs1->fields['apellidos']);
				$horario=intval($rs1->fields['idhorario']);
				$deshora=trim($rs1->fields['descripcion']);
				$idfuncionario=intval($rs1->fields['idfunci']);
				$monto_dia_f=floatval($rs1->fields['monto_dia_f']);
				$monto_mes_f=floatval($rs1->fields['monto_mes_f']);
				if ($monto_dia_f > 0){
					$modopago="Jornal B&aacute;sico Diario :";
					$montopago=$monto_dia_f;
					$tipojornal="D";
				} else {
					$modopago="Salario B&aacute;sico Mensual :";
					$montopago=$monto_mes_f;
					
					$tipojornal='M';
				}
				if ($idfuncionario==0){
					echo "ATENCION: El funcionario no posee un horario asignado. Verifique el horario y regrese nuevamente"	;exit;
					
				}
				
			/*---------------------------------------------------------------------------------------------*/
			$buscar="select * from rrhh_snapshot_resumen   where uns=$idsnap";
			$rscab=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			$cobrarxdiastrabajados=floatval($rscab->fields['cobrar_xdias_trabajados']);
			//echo $cobrarxdiastrabajados;exit;
			$plusxdiastrabajados=floatval($rscab->fields['plus_xdias_trabajados']);
			$buscar="select * from rrhh_snapshot_suma   where idsnap=$idsnap";
			$rssuma=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			//Los dias fiscales reales trabajados ya vienen de snapshot y tambien los reales
			
			$dias_fiscales_trabajados=intval($rscab->fields['dias_fiscales_trabajados']);
			$dias_reales_trabajados=intval($rscab->fields['dias_reales_trabajados']);
			$plusadicionalmonto=floatval($rssuma->fields['plus_adicional_monto']);
			
			
			
			
			
		$l1="";
		$l1.="
			<div style=\"width:800px; border:1px solid #E0E0E0;min-height:550px;\">
				<hr />
				<div style=\"width:80%; float:left;\">
					<span style=\"font-size:20px;\">
						<strong>
							$patronal <br />
							Patronal Num: $patronal_num 
							<br />
							Recibo de liquidaci&oacute;n de Salario conforme al Art. 235 C.T.
							<br />
							Periodo de Pago: $m / $ano
							<br />
							$nomape
							<br />
							 $modopago ".formatomoneda($montopago)."
							<br />
							Fecha : ".date("d/m/Y",strtotime($fecharecibo))."
						</strong>
					</span>
					<hr />
				</div>
				";
				
				
					//Cargos-Descuentos
				$buscar="Select rrhh_cargos_aplicados.idcargo,descripcion,monto,rrhh_cargos.muestra_ambos,rrhh_cargos.mostrar_en from rrhh_cargos_aplicados
				inner join rrhh_cargos on rrhh_cargos_aplicados.idcargo=rrhh_cargos.idcargo
				where idfuncionario=$idfuncionario and date(fecha) between '$inicio' and '$final' and rrhh_cargos_aplicados.estado=1
				and fecha_descontado is null order by descripcion asc";
				$rscargos=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				//echo $buscar;exit;
				$tcargos=$rscargos->RecordCount();
				if ($tipojornal=='D'){
					//Para esta nueva version, tomamos el monto del jornal establecido en la cabecera
					
					$vigentejornalfiscal=$montopago;//ya que trae de la BD
					$vigentemessubtotal=($vigentejornalfiscal*$dias_fiscales_trabajados);//PARA EL FISCAL USAR SIEMPRE EL JORNAL VIGENTE DE LA TABLA< DEFINIDA POR EL MIN
				}
				if ($tipojornal=='M'){
					//calcular en base al salario minimo establecido en 30 dias
					$vigentejornalfiscal=73095;//(falta colocar calculo)
					// Si es mensualero, usamos el nuevo de snapshot resumen
					$vigentejornalfiscal=$rscab->fields['jornal_real_establecido'];
					$vigentemessubtotal=($vigentejornalfiscal*$dias_fiscales_trabajados);//PARA EL FISCAL USAR SIEMPRE EL JORNAL VIGENTE DE LA TABLA< DEFINIDA POR EL MIN
				}
				$monto_h_nocturnas=floatval($rssuma->fields['monto_x_hnocturna']*$rssuma->fields['total_hs_nocturnas']);//Se muestra total nomas ya
				$total_h_nocturnas=floatval($rssuma->fields['total_hs_nocturnas']);
				$monto_pasantias=floatval($rssuma->fields['monto_xdia_pasantia']);
				//echo $monto_pasantias;exit;
				$cantidad_dias_pasantia=floatval($rssuma->fields['cant_dias_pasantias']);
				//echo $cantidad_dias_pasantia;exit;
				$adicionales=floatval($rssuma->fields['monto_xdia_adicional']);
				$l1.="
				<div> 
					<table width=\"100%;\">
						<tr >
							<td>Descripcion</td>
							<td>Cant</td>
							<td>Ingresos</td>
							<td>Cant</td>
							<td>Retenciones</td>
						</tr>
						<tr>
							<td colspan=\"5\"><hr /></td>
						</tr>
						<tr>
							<td>Salario B&aacute;sico</td>
							<td>X $dias_fiscales_trabajados &nbsp;dias</td>
							<td align=\"right\">".formatomoneda($vigentemessubtotal,4,'N')."</td>
							<td></td>
							<td></td>
						</tr>";
						
						if ($tcargos > 0){
							$ts=0;$tcfiscal=0;
							while (!$rscargos->EOF){
									$muestraambos=trim($rscargos->fields['muestra_ambos']);
									$mostraren=intval($rscargos->fields['mostrar_en']);
									if (($muestraambos=='S') or ($mostraren==1)){
										$ts=$ts+floatval($rscargos->fields['monto']);
										$tcfiscal=$tcfiscal+floatval($rscargos->fields['monto']);
										 $l1.="
										 <tr>
											<td colspan=\"4\">".$rscargos->fields['descripcion']."</td>
											<td align=\"right\">".formatomoneda($rscargos->fields['monto'],4,'N')."</td>
										</tr>";
									}
								$rscargos->MoveNext();
							}
							$rscargos->MoveFirst();
					
						}
					   if ($monto_h_nocturnas > 0){
						   $l1.="
							<tr>
								<td>Horas Nocturnas</td>
								<td> X ".formatomoneda($total_h_nocturnas,4,'N')."</td>
								<td align=\"right\">".formatomoneda($monto_h_nocturnas,4,'N')."</td>
								<td></td>
								<td></td>
							</tr>";
					    } 
						$l1.="
							<tr>
								<td><br /></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
							</tr>
							<tr>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
							</tr>
						";
						$sf=($vigentemessubtotal+$monto_h_nocturnas)-$tcfiscal;
						$l1.="
						<tr>
							<td>Total Ingresos / Retenciones</td>
							<td></td>
							<td align=\"right\">".formatomoneda($vigentemessubtotal+$monto_h_nocturnas,4,'N')."</td>
							<td></td>
							<td align=\"right\">".formatomoneda($tcfiscal,4,'N')."</td>
						</tr>
						<tr>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"><strong>A Cobrar GS:</strong></td>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\" align=\"center\"><strong>".formatomoneda($sf,4,'N')."</strong></td>
						</tr>
					</table>
					<hr />";
					
					$let=num2letras($sf); 
					$l1.="
					<h3>Recib&iacute; Conforme copia, la suma de Gs: ".formatomoneda($sf,4,'N')." (Gs:  $let )</h3>
					<br />
					<div style=\"float:right; max-width:250px;text-align:center;\">
					-------------------------------------------<br />
					Firma del Trabajador <br /> DC:  ".formatomoneda(str_replace("'","",$documento),4,'N')." 
					</div>
				</div>
			</div>";
			//-------------------------------------Recibo Real---------------------------------------------------------//
			$l2=
			"
			<div style=\"width:800px; border:1px solid #E0E0E0;min-height:550px;\">
				<hr />
				<div style=\"width:60%; float:left;\">
					<span style=\"font-size:20px;\">
						<strong>
							$patronal
							<br />
							Recibo de liquidaci&oacute;n
							<br />
							Periodo de Pago:  $m / $ano
							<br />
							$nomape
							<br />
							Fecha : ".date("d/m/Y",strtotime($fecharecibo))."
						</strong>
					</span>
					<hr />
				</div>
				<div style=\"width:38%; float:left;\">
					
				</div>
				
				<div> 
					<table width=\"100%;\">
						<tr >
							<td>Descripcion</td>
							<td>Cant</td>
							<td>Ingresos</td>
							<td>Cant</td>
							<td>Retenciones</td>
						</tr>
						<tr>
							<td colspan=\"5\"><hr /></td>
						</tr>";
						$totalingresos=0;
						$dr=$rspagos->fields['dias_recalculo'];
						
						//Buscamos si es x horas para cambiar el titulo
						$buscar="select solohora,montoxhorastrab,totalhorastrab from rrhh_pagos_salarios where documento=$documento and idreg=$idreg";
						$rskk=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						$solohora=trim($rskk->fields['solohora']);//Indica si es que trabajo solo por horas en un dia
						
						
						$montoxhora=floatval($rskk->fields['montoxhorastrab']);
						$thoras=floatval($rskk->fields['totalhorastrab']);
						$subtothoratrab=$montoxhora*$thoras;
						
						//snapshot de suma viene de arriba nomas ya
						//$monto_h_nocturnas=floatval($rssuma->fields['monto_x_hnocturna']);
						
						//$total_h_nocturnas=floatval($rssuma->fields['total_hs_nocturnas']);
						
						
						
						
						if ($solohora=='S'){
						$l2.="
						<tr>
							<td>Salario x horas trabajadas y libres</td>
							<td> X  $thoras </td>
							<td>"; 
								
								$totalingresos=0;
								$totalingresos=$totalingresos+$subtothoratrab+$adicionales+$comiadi+$sobresalario1+$tsumar1;
							
							$l2.=formatomoneda($subtothoratrab,4,'N')."
							
							</td>
							<td></td>
							<td></td>
						</tr>
						
						
						";
						} else { 
						//No se marco como trabajo solo x horas
						$l2.="
						<tr>
							<td>Salario</td>
							<td>";
							//if ($recalculado=='S'){
								$l2.=" X $dias_reales_trabajados  dias.";
							//}
							$l2.="</td>
							<td align=\"right\">";
								$ssr=$sobresalario1;
								if ($tipojornal=='D'){
									
									$salario=$montopago*$dias_reales_trabajados;
									$salario=$cobrarxdiastrabajados;
									$totalingresos=$totalingresos+$salario;
								} else {
									$salario=$cobrarxdiastrabajados;
									//echo $salario;exit;
									$totalingresos=$totalingresos+$salario;
									
								}
								/*
								if ($recalculado=='S'){
									//echo 'ddd';exit;
									$salario=floatval($rspagos->fields['dias_recalculo'])*floatval($rspagos->fields['jornal_recalculo']);
									$totalingresos=0;
									$totalingresos=$totalingresos+$salario+$adicionales+$comiadi+$sobresalario1+$tsumar1;
								}*/
								
								
								
								$l2.="
							".formatomoneda($salario,4,'N')."
							
							</td>
							<td></td>
							<td></td>
						</tr>";
						}
						//p

						
						
						
						
						
						
						if ($tcargos > 0){
							//echo 'HAY';exit;
							$totaldescuentos=0;
							$ts=0;
							$magrupados=0;
							while (!$rscargos->EOF){
								$muestraambos=trim($rscargos->fields['muestra_ambos']);
								$mostraren=intval($rscargos->fields['mostrar_en']);
								$idcargo=intval($rscargos->fields['idcargo']);
								
								if ($tagrupados==0){
									if (($muestraambos=='S') or ($mostraren==2)){
										$ts=$ts+floatval($rscargos->fields['monto']);
										$l2.="				
										<tr>
										  <td colspan=\"4\" style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\">".$rscargos->fields['descripcion']."</td>
										  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\">".formatomoneda($rscargos->fields['monto'],4,'N')."</td>
										</tr>";
									}
								 } else {
									//Existe agrupacion, por lo cual si esta enn la tabla agrupamos segun corresponda	 
									$buscar="Select count(idcargo) as totc from rrhh_cargos_agrupados where idcargo=$idcargo"	 ;
									$tr1=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
									$ne=intval($tr1->fields['totc']);
									if ($ne>0){	 
										//el item fue agrupado
										$magrupados=$magrupados+floatval($rscargos->fields['monto']);
									} else { 
										//item no argupado, mostramos
										if (($muestraambos=='S') or ($mostraren==2)){
											$ts=$ts+floatval($rscargos->fields['monto']);
										$l2.="
										<tr>
										  <td colspan=\"4\"><?php echo $rscargos->fields['descripcion']?></td>
										  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\"><?php echo formatomoneda($rscargos->fields['monto'],4,'N');?></td>
										</tr>";
										}
									 }//de $ne>0
							 }//de agrupacion =0
						 $rscargos->MoveNext();
						 $totaldescuentos=$totaldescuentos+$ts;
						 }
					 }//de tcargos > 0
					$rscargos->MoveFirst();
					
					if ($descuentoh>0){ 
					$l2.="
					 <tr>
							  <td colspan=\"3\">AUSENCIAS </td>
							  <td><?php echo $diasdesc;?></td>
							  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\"><?php echo formatomoneda($descuentoh,4,'N');?></td>
						</tr>
					";
					}
					if ($monto_h_nocturnas > 0){
						$totalingresos=$totalingresos+$monto_h_nocturnas;
						$l2.="
						<tr>
							<td>Horas Nocturnas</td>
							<td align=\"left\"> X ".formatomoneda($total_h_nocturnas,4,'N')." hs</td>
							<td align=\"right\">".formatomoneda($monto_h_nocturnas,4,'N')."</td>
							<td></td>
							<td></td>";
					} 
					if ($monto_pasantias > 0){
						
						
						$totalpasantias=$cantidad_dias_pasantia*$monto_pasantias;
						$totalingresos=$totalingresos+$totalpasantias;
						$l2.="
						<tr>
							<td>Pasantias</td>
							<td align=\"left\"> X ".formatomoneda($cantidad_dias_pasantia,4,'N')." hs</td>
							<td align=\"right\">".formatomoneda($totalpasantias,4,'N')."</td>
							<td></td>
							<td></td>";
					} 
					$describesuma=trim($rssuma->fields['descripcion']);
					$montosuma=floatval($rssuma->fields['montodes']);
					if ($montosuma > 0){			
						$totalingresos=$totalingresos+$montosuma;
						$l2.="
						<tr>
							<td>$describesuma</td>
							<td align=\"left\"> </td>
							<td align=\"right\">".formatomoneda($montosuma,4,'N')."</td>
							<td></td>
							<td></td>";
					} 
				
					//Vemos si hay descuentos  que no esten en la ficha y sean x dias
					$buscar="Select * from rrhh_snapshot_resta where idsnap=$idsnap";
					$rscargos2=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
					$describeresta=trim($rscargos2->fields['descripcion']);
					$montoresta=floatval($rscargos2->fields['montodes']);
					
					$cant_dias_resta=floatval($rscargos2->fields['cant_dias_descontar']);
					$monto_desc_xdias=floatval($rscargos2->fields['monto_xdias_descontar']);
					if ($montoresta > 0){
						$totaldescuentos=$totaldescuentos+$montoresta;
						//echo $totaldescuentos;exit;
						$l2.="
						<tr>
							  <td colspan=\"3\">$describeresta </td>
							  <td></td>
							  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\">".formatomoneda($montoresta,4,'N')."</td>
						</tr>
						";
						
					}
					if ($cant_dias_resta > 0){
						$m='S';
						$descxdiast=$monto_desc_xdias*$cant_dias_resta;
						$l2.="
						<tr>
							  <td colspan=\"3\">DIAS DESC X </td>
							  <td>$cant_dias_resta</td>
							  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\">".formatomoneda($descxdiast,4,'N')."</td>
						</tr>
						";
					} 
					if ($magrupados > 0){
						$totaldescuentos=$totaldescuentos+$magrupados;
						
						$l2.="
					  <tr>
							  <td colspan=\"4\">OTROS DESCUENTOS</td>
							  <td align=\"right\"  style=\"border-bottom:1px solid #000000;border-right:1px solid #000000;\"><?php echo formatomoneda($magrupados,4,'N');?></td>
						</tr>";
					 } 
					 //preparamos un neto a cobrar para  los que fueron recalculados
					$desc1=floatval($ts);
					$desc2=floatval($magrupados);
					$totaldescuentos=$desc1+$desc2+$descuentosdias+$descuentoh+$montoresta;
					if ($rspagos->fields['recalculado']=='S'){
						$totaldescuentos=($rspagos->fields['descuentos_varios']+$rspagos->fields['descontadonetodias']);
							
					} 
					//Nuevas para mostrar valores en recibo interno
					$saldo=$pluplu+$monto_h_nocturnas+$totalingresos-$totaldescuentos;
					
					
					 if ($adicionales>0){ 
					 $totalingresos=$totalingresos+$adicionales;
					 $l2.="
						 <tr>
							<td height=\"32\" colspan=\"2\">Adicionales/Otros</td>
							<td align=\"right\">".formatomoneda($adicionales,4,'N')."</td>
							<td></td>
							<td></td>
						</tr>
					";
					 } 
					
					if ($plusxdiastrabajados>0){
						$totalingresos=$totalingresos+$plusxdiastrabajados;
						//echo 'HAY';exit;
						if ($solohora!='S'){
						$l2.="
							 <tr>
								<td height=\"32\" colspan=\"2\">Plus X dias</td>
								<td align=\"right\">".formatomoneda(intval($plusxdiastrabajados),4,'N')."</td>
								<td></td>
								<td></td>
							</tr>";
					
						}  
					} 
					 
				
					 if ($plusadicionalmonto>0){ 
					 $totalingresos=$totalingresos+$plusadicionalmonto;
					 $l2.="
						<tr>
						  <td height=\"32\" colspan=\"2\">Plus Adicional</td>
							<td align=\"right\">".formatomoneda($plusadicionalmonto,4,'N')."</td>
							<td></td>
							<td></td>
							
						</tr>
						";	
						 } 
						if ($pluplu>0){
						$l2.="	 
							<tr>
							  <td height=\"32\" colspan=\"2\">H Adicional</td>
								<td align=\"right\">&nbsp;</td>
								<td><?php echo formatomoneda($pluplu,4,'N'); ?></td>
								<td></td>
								
							</tr>
							";
						} 
						$saldo=$saldo;
						if ($solohora=='S'){
							$totalingresos=$totalingresos-$sobresalario1;
							$saldo=$saldo-$sobresalario1;
						} else {
							$saldo=$totalingresos-$totaldescuentos;
						}
						$l2.="
						<tr>
							<td>Total Ingresos / Retenciones</td>
							<td></td>
							<td align=\"right\">".formatomoneda(intval($totalingresos),4,'N')."</td>
							<td></td>
							<td align=\"right\">".formatomoneda(intval($totaldescuentos),4,'N')."</td>
						</tr>
						<tr>
							<td  style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\">A Cobrar GS:</td>
							<td style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\"></td>
							<td style=\"height:28px;border-bottom:1px solid #000000;border-top:1px solid #000000;\">".formatomoneda(intval($saldo),4,'N')."
								
							</td>
						</tr>
					</table>
					<hr />";
					$let=num2letras(intval($saldo));
					$l2.="
					<h3>Recib&iacute; Conforme copia, la suma de Gs: ".formatomoneda(intval($saldo),4,'N')." (Gs:  $let)</h3>
					<br />
					<div style=\"float:right; max-width:250px;text-align:center;\">
					-------------------------------------------<br />
					Firma del Trabajador <br /> DC: ".formatomoneda(str_replace("'","",$documento),4,'N')."
					</div>
				</div>
			</div>
			
			
			";
			
			
			
		echo $l1."<br />".$l2;
	}
} else {
	/*------------------------------------------------------METODO: While x Sucursal------------------------------------------*/
	if ($idsucursallocal==0){
		echo 'Error: debe indicar la sucursal de proceso';exit;
	}
	
}
?>