<?php 
    require_once("includes/conexion.php");    
    require('obtenerProductos.php');

    $imgDefault     = "gfx/fotosweb/wprod_0.jpg";
    $descDefault    = "Sin Descripción";
    $precioDefault  = 0;
    $enlaceDefault  = "#";
    
    $prodDestacados = obtenerProductosDestacados( 
        $conexion, 
        $idempresa, 
        $ahorad, 
        $session_id, 
        $limit = 3, 
        $RUTA_IMG 
    )['datos'];

    $prodPromocion = obtenerProductosPromocion( 
        $conexion, 
        $idempresa, 
        $ahorad, 
        $session_id, 
        $limit = 12, 
        $RUTA_IMG
    )['datos'];
?>
<section class="seccion-claro">
    <div class="container-fluid container">
        <div class="row">
            <div class="col-12 text-center col-lg-7 text-lg-start">
                <h3 class="titulo texto-verde titulo-principal">Productos destacados</h3>
                <h5 class="titulo texto-oscuro titulo-secundario">Al mejor precio</h5>
                <div class="row justify-content-evenly text-center mt-5 productos-destacados d-lg-none">
                    <div class="col-12 col-md-4">
                        <?php 
                            $id = !empty( $prodDestacados[0]["idprodserial"] ) ? $prodDestacados[0]["idprodserial"] : null;
                            $img = ( !empty( $prodDestacados[0]["imagen"] ) ) ? $prodDestacados[0]["imagen"] : $imgDefault; 
                        ?>
                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                            <img src="<?php echo $img; ?>" width="100%">
                        </a>
                    </div>
                    <div class="col-6 mt-2 col-md-4 mt-md-0">
                        <?php 
                            $id = !empty( $prodDestacados[1]["idprodserial"] ) ? $prodDestacados[1]["idprodserial"] : null;
                            $img = ( !empty( $prodDestacados[1]["imagen"] ) ) ? $prodDestacados[1]["imagen"] : $imgDefault; 
                        ?>
                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                            <img src="<?php echo $img; ?>" width="100%">
                        </a>
                    </div>
                    <div class="col-6 mt-2 col-md-4 mt-md-0">
                        <?php
                            $id = !empty( $prodDestacados[2]["idprodserial"] ) ? $prodDestacados[2]["idprodserial"] : null; 
                            $img = ( !empty( $prodDestacados[2]["imagen"] ) ) ? $prodDestacados[2]["imagen"] : $imgDefault; 
                        ?>
                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                            <img src="<?php echo $img; ?>" width="100%">
                        </a>
                    </div>
                </div>
                <p class="my-5 info-descripcion">
                    Los productos más consumidos
                </p>
                <a href="productos.php" class="btn btn-comprar">
                Comprar Ya!
                <img src="./img/huellaperro.png" width="20px">
            </a>
            </div>
            <div class="d-none col-lg-5 d-lg-block">
                <div class="row productos-destacados text-center align-items-center">
                    <div class="col-lg-7">
                        <?php 
                            $id = !empty( $prodDestacados[0]["idprodserial"] ) ? $prodDestacados[0]["idprodserial"] : null;
                            $img = ( !empty( $prodDestacados[0]["imagen"] ) ) ? $prodDestacados[0]["imagen"] : $imgDefault; 
                        ?>
                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                            <img src="<?php echo $img; ?>" class="productos-destacados-principal">
                        </a>
                    </div>
                    <div class="col-lg-5">
                        <div class="row text-center">
                            <div class="col-lg-12">
                                <?php 
                                    $id = !empty( $prodDestacados[1]["idprodserial"] ) ? $prodDestacados[1]["idprodserial"] : null;
                                    $img = ( !empty( $prodDestacados[1]["imagen"] ) ) ? $prodDestacados[1]["imagen"] : $imgDefault; 
                                ?>
                                <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                    <img src="<?php echo $img; ?>" class="productos-destacados-secundario">
                                </a>
                            </div>
                            <div class="col-lg-12">
                                <?php
                                    $id = !empty( $prodDestacados[2]["idprodserial"] ) ? $prodDestacados[2]["idprodserial"] : null; 
                                    $img = ( !empty( $prodDestacados[2]["imagen"] ) ) ? $prodDestacados[2]["imagen"] : $imgDefault; 
                                ?>
                                <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                    <img src="<?php echo $img; ?>" class="productos-destacados-secundario">
                                </a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row mt-5 justify-content-center">
            <div class="col-12 col-lg-10">
                <div class="card card-sombra">
                    <div class="card-body">
                        <div
                            class="row text-center justify-content-between justify-content-xl-evenly align-items-center">
                            <div class="col-12 my-2 col-sm-4 my-sm-0 pe-sm-0">
                                <img src="./img/correo-electronico.png" width="30px">
                                <span class="mx-1"><?php echo $rspers->fields['correo']; ?></span>
                            </div>
                            <div class="col-12 my-2 col-sm-2 my-sm-0">
                                <img src="<?php echo $rspers->fields['logo_url']; ?>" width="50px">
                            </div>
                            <div class="col-12 my-2 col-sm-4 my-sm-0 ps-sm-0">
                                <img src="./img/llamada-telefonica.png" width="30px">
                                <span class="mx-1"><?php echo $rspers->fields['telefono']; ?></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<section class="seccion-verde">
    <div class="container-fluid container">
        <div class="row">
            <div class="col-12 text-center titulo texto-blanco">
                <h3 class="titulo-principal">Productos En Promoción</h3>
            </div>
        </div>
        <!-- mobile tablet -->
        <div id="carouselMobile" class="carousel slide d-block d-xl-none" data-bs-ride="carousel">
            <div class="carousel-inner">
                <div class="carousel-item active">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=0; $i < 2; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }

                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
                <div class="carousel-item">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=2; $i < 4; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }

                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
                <div class="carousel-item">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=4; $i < 6; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }
                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
            </div>
            <button class="carousel-control-prev" type="button" data-bs-target="#carouselMobile" data-bs-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="visually-hidden">Previous</span>
            </button>
            <button class="carousel-control-next" type="button" data-bs-target="#carouselMobile" data-bs-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="visually-hidden">Next</span>
            </button>
        </div>
        <!-- desktop -->
        <div id="carouselDesktop" class="carousel slide d-none d-xl-block" data-bs-ride="carousel">
            <div class="carousel-inner">
                <div class="carousel-item active">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=0; $i < 4; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }

                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
                <div class="carousel-item">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=4; $i < 8; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }

                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
                <div class="carousel-item">
                    <div class="row w-80">
                    <!-- inicio -->
                    <?php
                        for ($i=8; $i < 12; $i++)
                        {
                            if( empty( $prodPromocion[$i]["idprodserial"] ) )
                            {
                                break;
                            }
                            ?>
                                <div class="col-12 d-flex justify-content-center col-md-6 col-xl-3">
                                    <?php
                                        $id          = $prodPromocion[$i]["idprodserial"];
                                        $img         = !empty( $prodPromocion[$i]["imagen"] )       ? $prodPromocion[$i]["imagen"] : $imgDefault;
                                        $descripcion = !empty( $prodPromocion[$i]["descripcion"] )  ? $prodPromocion[$i]["descripcion"] : $descDefault;
                                        $precio      = !empty( $prodPromocion[$i]["precio"] )       ? $prodPromocion[$i]["precio"] : $precioDefault;
                                    ?>
                                    <div class="card card-sombra text-center card-producto mt-4">
                                        <a href="<?php echo !empty( $id ) ? "producto.php?id=$id" : $enlaceDefault ?>">
                                            <div class="card-body">
                                                <img src="<?php echo $img; ?>" width="170px">
                                            </div>
                                            <div class="card-footer">
                                                <span class="texto-oscuro"><?php echo $descripcion; ?></span>
                                                <span class="texto-marron">Gs <?php echo number_format($precio, 0, ',', '.'); ?></span>
                                            </div>
                                        </a>
                                    </div>
                                </div>
                            <?php
                        }
                    ?>
                    <!-- fin -->
                    </div>
                </div>
            </div>
            <button class="carousel-control-prev" type="button" data-bs-target="#carouselDesktop" data-bs-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="visually-hidden">Previous</span>
            </button>
            <button class="carousel-control-next" type="button" data-bs-target="#carouselDesktop" data-bs-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="visually-hidden">Next</span>
            </button>
        </div>
    </div>
</section>