<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="39";
$submodulo="574";
$dirsup="S";
require_once("../includes/rsusuario.php"); 

// funciones para factura electronica
if($facturador_electronico == 'S'){
	require_once("../includes/funciones_electronica.php");
	// envio evento
	require_once("../facturaElectronica/EventoCancelacionCDC.php");

	$slot_datos=slot_vigente();
	$slot_firma=trim($slot_datos['nombre_slot']);    //'80052292_test';   // nombre del slot con que se dio de alta la firma digital en el servidor
	
	if($slot_firma == ''){
		echo "No esta cargado el slot de la firma electronica.";
		exit;
	}
	
	// Fecha hora Implementacion facturacion electronica
	$fechahora_inicio_electro=$rsemp->fields['fechahora_inicio_electro']; // traer de la base de datos
	

}else{
	echo "No es un facturador electronico.";
	exit;
}




if(isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	

	// recibe parametros
	$iddocumentoemitido=antisqlinyeccion($_POST['iddocumentoemitido'],"int");
	$cdc=antisqlinyeccion($_POST['cdc'],"text");
	$motivo=antisqlinyeccion($_POST['motivo'],"text");
	$estado=1;
	$fecha_cancelacion=antisqlinyeccion($ahora,"text");
	$registrado_por=$idusu;
	$registrado_el=antisqlinyeccion($ahora,"text");





	if(trim($_POST['cdc']) == ''){
		$valido="N";
		$errores.=" - El campo cdc no puede estar vacio.<br />";	
	}
	if(trim($_POST['motivo']) == ''){
		$valido="N";
		$errores.=" - El campo motivo no puede estar vacio.<br />";	
	}

	// busca el cdc en documentos emitidos
	$consulta="
	select iddocumentoemitido, estado_set,
	(TIMESTAMPDIFF(MINUTE,fecha_comprobante,NOW())/60) as horas_dif
	from documentos_electronicos_emitidos 
	where 
	cdc = $cdc 
	limit 1
	";
	$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$estado_set=$rs->fields['estado_set']; // 3 aprobado
	$iddocumentoemitido=intval($rs->fields['iddocumentoemitido']);
	$horas_dif=floatval($rs->fields['horas_dif']);
	if($iddocumentoemitido == 0){
		$valido="N";
		$errores.=" - El cdc indicado no existe en el sistema.<br />";	
	}
	if($estado_set != 3){
		$valido="N";
		$errores.=" - El cdc indicado no corresonde a un documento electronico aprobado.<br />";	
	}
	if($horas_dif >= 48){
		$valido="N";
		$errores.=" - El cdc indicado ya supero las 48 horas permitidas para cancelar, realice una nota de credito en su lugar.<br />";	
	}
	// busca si ya no hay otra cancelacion de cdc
	/*$consulta="
	select idcancelacion from documentos_electronicos_cancelacion_cdc where cdc = $cdc  and estado <> 6 limit 1;
	";
	$rsex=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idcancelacion_ex=intval($rsex->fields['idcancelacion']);
	if($idcancelacion_ex > 0){
		$valido="N";
		$errores.=" - Ya existe otro evento de cancelacion en el sistema para el mismo cdc.<br />";	
	}*/


	// si todo es correcto inserta
	if($valido == "S"){
		
		
		
		$consulta="
		insert into documentos_electronicos_cancelacion_cdc
		(iddocumentoemitido, cdc, motivo, estado, estado_set, fecha_cancelacion, registrado_por, registrado_el)
		values
		($iddocumentoemitido, $cdc, $motivo, 1, 1, $fecha_cancelacion, $registrado_por, $registrado_el)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// trae el insertado
		$consulta="
		select idcancelacion 
		from documentos_electronicos_cancelacion_cdc 
		where 
		cdc = $cdc  
		and estado = 1 
		and estado_set = 1
		order by idcancelacion desc 
		limit 1
		";
		$rsins=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idcancelacion=intval($rsins->fields['idcancelacion']);
		
		// parametros a enviar al objeto
		$parametros_array=array(
			'idcancelacion' => $idcancelacion,
			'slot_firma' => $slot_firma
		);
		
		// enviar cancelacion a la set
		$res=cancelarCDC($parametros_array);
		if($res['valido'] == 'S'){
			// redireccionar
			header("location: cancelacion.php?id=".$idcancelacion);
			exit;
		}else{
			print_r($res);
			exit;
		}
		
	}

}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());


?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("../includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("../includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("../includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("../includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Cancelacion CDC</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">

<?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<form id="form1" name="form1" method="post" action="">



<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Cdc *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="cdc" id="cdc" value="<?php  if(isset($_POST['cdc'])){ echo htmlentities($_POST['cdc']); }else{ echo htmlentities($rs->fields['cdc']); }?>" placeholder="Cdc" class="form-control" required="required" />                    
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Motivo *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="text" name="motivo" id="motivo" value="<?php  if(isset($_POST['motivo'])){ echo htmlentities($_POST['motivo']); }else{ echo htmlentities($rs->fields['motivo']); }?>" placeholder="Motivo" class="form-control" required="required" />                    
	</div>
</div>



<div class="clearfix"></div>
<br />

    <div class="form-group">
		<div class="col-md-12 col-sm-12 col-xs-12 text-center">
        
	   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar</button>
	   <button type="button" class="btn btn-primary" onMouseUp="document.location.href='cancelacion.php'"><span class="fa fa-ban"></span> Cancelar</button>
        </div>
    </div>

  <input type="hidden" name="MM_insert" value="form1" />
  <input type="hidden" name="form_control" value="<?php echo htmlentities($_SESSION['form_control']); ?>">
<br />
</form>
<div class="clearfix"></div>
<br /><br />
	<hr />	 			  
<strong>Cancelación (11.1.2.)</strong><br />
Es un evento solicitado por el emisor, ocurre cuando el comprobante es emitido sin errores y 
transmitido y aprobado por el SIFEN se convierte en un DTE, sin embargo, por algún motivo no se 
concreta la transacción.<br />
El emisor electrónico puede solicitar la CANCELACIÓN de cualquier tipo de DTE y tiene hasta 48 hs. 
posteriores a la aprobación de uso del DE para generar el evento. El estado de los DTE cancelados 
quedará registrado en el SIFEN y es obligatoria la conservación por 5 años.	<br />	
 
					  
<br /><br /><br />					  

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            

            
            
            
          </div>
        </div>
        <!-- /page content -->
		  
        <!-- POPUP DE MODAL OCULTO -->
<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
        
            <div class="modal-header">
            	<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
           		<h4 class="modal-title" id="modal_titulo">Titulo</h4>
            </div>
            <div class="modal-body" id="modal_cuerpo">
            	Contenido...
            </div>
            <div class="modal-footer" id="modal_pie">
            	<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
            </div>
        
        </div>
    </div>
</div>
        <!-- POPUP DE MODAL OCULTO -->

        <!-- footer content -->
		<?php require_once("../includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("../includes/footer_gen.php"); ?>
  </body>
</html>
