<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="39";
$submodulo="568";
$dirsup="S";
require_once("../includes/rsusuario.php"); 

require_once("../includes/funciones_electronica.php");

// automentar el timpo de ejecucion del script
set_time_limit(0);
// para evitar el error 500 por falta de memoria
//ini_set('memory_limit', '-1');
ignore_user_abort(true);

// DOCUMENTOS POR VEZ
$LIMITE_TANDA=500; // 5 se se ejecuta cada 1 minuto son 7200 documentos por dia
$LIMITE_TANDA_ACTU=500;

$fecha_72horas_atras = new DateTime(); 
$fecha_72horas_atras->modify('-72 hour'); 
$hace_72horas_atras=$fecha_72horas_atras->format('Y-m-d H:i:s');

$consulta="
select facturador_electronico,fechahora_inicio_electro from preferencias limit 1
";
$rsemp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
$facturador_electronico=$rsemp->fields['facturador_electronico'];
$fechahora_inicio_electro=$rsemp->fields['fechahora_inicio_electro'];

// BLOQUEADOR DE BOTON INICIO
$idbotonbloq=3; // tabla botones_bloqueo
$parametros_array=array(
	'apretado_por' => $idusu,
	'idbotonbloq' => $idbotonbloq, 
);
$res=botones_bloqueo_apretar($parametros_array);
// si no permite muestra mensaje
if($res['permite_apretar'] != 'S'){
	echo $res['errores'];
	exit;
}
// si permite trae el id del log generado
if($res['permite_apretar'] == 'S'){
	$idbotonbloqaprieta=intval($res['idbotonbloqaprieta']);
}
// BLOQUEADOR DE BOTON INICIO
	
// funciones para factura electronica
if($facturador_electronico == 'S'){
	// envio documento
	require_once('../facturaElectronica/Validate.php');
	require_once("../facturaElectronica/GeneradorXMLFacturaElectronica.php");
	// consulta de estado
	require_once('../facturaElectronica/VerificarEstadoLote.php');

	$slot_datos=slot_vigente();
	$slot_firma=trim($slot_datos['nombre_slot']);    //'80052292_test';   // nombre del slot con que se dio de alta la firma digital en el servidor
	
	if($slot_firma == ''){
		echo "No esta cargado el slot de la firma electronica.";
		exit;
	}
	
	// Fecha hora Implementacion facturacion electronica
	$fechahora_inicio_electro=$rsemp->fields['fechahora_inicio_electro']; // traer de la base de datos
	if(trim($fechahora_inicio_electro) == ''){
		echo "No se cargo la fecha hora de inicio de produccion de factura electronica.";
		exit;
	}
	

}else{
	echo "No es un facturador electronico.";
	exit;
}


// por seguridad las ventas que paso 1 minuto atras por si ya se esta generando en este momento mientras facturan, que no se genere doble
$mifecha = new DateTime(); 
//echo $mifecha->format('Y-m-d H:i:s')."<br />";
$mifecha->modify('-60 second'); 
$hace_1_minuto=$mifecha->format('Y-m-d H:i:s');

// TRAER VENTAS (LUEGO se puede hacer un union all en la consulta para inclcuir nota de credito)
/*$consulta="
select 1 as iddocumentoelectronico, idventa
from ventas
where
idventa not in (
	select idventa 
	from documentos_electronicos_emitidos 
	where 
	estado = 1
)
and estado <> 6
AND finalizo_correcto = 'S'
and ventas.fecha <= '$hace_1_minuto'
and ventas.fecha >= '$fechahora_inicio_electro'
LIMIT $LIMITE_TANDA
";*/
/*$consulta="
SELECT 
    1 as iddocumentoelectronico, idventa
FROM ventas
LEFT JOIN (
    SELECT idventa 
    FROM documentos_electronicos_emitidos 
    WHERE estado = 1
) AS dee ON ventas.idventa = dee.idventa
WHERE 
    dee.idventa IS NULL
    AND ventas.estado <> 6
    AND ventas.finalizo_correcto = 'S'
	and ventas.fecha <= '$hace_1_minuto'
    and ventas.fecha >= '$fechahora_inicio_electro'
LIMIT $LIMITE_TANDA
";*/
$consulta="
SELECT 
    1 AS iddocumentoelectronico, 
	'FACTURA' as tipo,
	v.idventa as id,
    v.idventa, 
    0 AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura,
	v.factura as numero_documento,
	v.fecha as fecha_documento
FROM 
     (
	 SELECT idventa, factura, fecha
     FROM ventas v
     WHERE 
         estado <> 6 
         AND finalizo_correcto = 'S' 
		 and v.fecha >= '$fechahora_inicio_electro'
         AND v.factura IS NOT NULL 
         AND TRIM(v.factura) <> ''
		 and v.electronica_gen = 'N'
		 and v.fecha <= '$hace_1_minuto'
    ) v


UNION ALL

SELECT 
    2 AS iddocumentoelectronico, 
	'NOTA CREDITO' as tipo,
	nc.idnotacred AS id,
    0 AS idventa, 
    nc.idnotacred AS idnotacredito, 
    0 AS idnotadebito, 
    0 AS idnotaremision, 
    0 AS idautofactura ,
	nc.numero as numero_documento,
	nc.fecha_nota as fecha_documento
	
FROM 
     (
	 SELECT idnotacred, numero, fecha_nota
     FROM nota_credito_cabeza nc
     WHERE 
		nc.estado = 3 
		and nc.fecha_nota >= '$fechahora_inicio_electro'
		and nc.electronica_gen = 'N'
    ) nc
	
LIMIT $LIMITE_TANDA
";
$rs=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

$idventa_acum="";
while(!$rs->EOF){
	
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	$idventa=intval($rs->fields['idventa']);
	$idnotacredito=intval($rs->fields['idnotacredito']);
	$idnotadebito=intval($rs->fields['idnotadebito']);
	$idnotaremision=intval($rs->fields['idnotaremision']);
	$idautofactura=intval($rs->fields['idautofactura']);
	$iddocumentoelectronico=$rs->fields['iddocumentoelectronico'];
	// GENERAR DOCUMENTO ELECTRONICO
	$parametros_array=array(
		'idventa' => $idventa,
		'idnotacredito' => $idnotacredito,
		'idnotadebito' => $idnotadebito,
		'idnotaremision' => $idnotaremision,
		'idautofactura' => $idautofactura,
		'iddocumentoelectronico' => $iddocumentoelectronico
	);
	//print_r($parametros_array);
	echo genera_documento_electronico($parametros_array);

$rs->MoveNext(); }


// BLOQUEADOR DE BOTON FINAL
$parametros_array=array(
	'idbotonbloqaprieta' => $idbotonbloqaprieta
);
botones_bloqueo_finalizar($parametros_array);
// BLOQUEADOR DE BOTON FINAL


?>