<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="39";
$submodulo="567";
require_once("includes/rsusuario.php"); 
/*
if($soporte != 1){
	echo "Modulo solo habilitado para personal de soporte.";
	exit;
}
*/


/**
 * Función para extraer datos adicionales del certificado y manejar errores específicos.
 * 
 * @param string $certFile Ruta del archivo de certificado
 * @param string $certPassword Contraseña del archivo de certificado (si es necesaria)
 * @return array|string|null Array con los datos del certificado, clave privada y otros detalles; un mensaje de error o null si falla
 */
function extraerDatosCertificado($certFile, $certPassword = null) {
    // Intentar leer el contenido del archivo de certificado
    $certContent = @file_get_contents($certFile);

    if ($certContent === false) {
        return "Error: No se pudo leer el archivo de certificado.";
    }

    $extension = pathinfo($certFile, PATHINFO_EXTENSION);
    
    $certInfo = array();

    switch (strtolower($extension)) {
        case 'pfx':
        case 'p12':
            // Archivos PKCS#12 (.pfx, .p12)
            if (openssl_pkcs12_read($certContent, $certInfo, $certPassword)) {
                $certData = openssl_x509_parse($certInfo['cert']);
                return [
                    'privateKey' => $certInfo['pkey'],  // Clave privada
                    'publicCert' => $certInfo['cert'],  // Certificado público
                    'certDetails' => $certData          // Detalles adicionales del certificado
                ];
            } else {
                return "Error: La clave proporcionada es incorrecta o el formato del archivo no es válido.";
            }

        case 'pem':
        case 'crt':
        case 'cer':
            // Archivos PEM o CRT (.pem, .crt, .cer)
            $privateKey = null;
            $publicCert = null;

            // Intentar cargar la clave privada
            $privateKeyResource = @openssl_pkey_get_private($certContent, $certPassword);
            if ($privateKeyResource === false) {
                return "Error: La clave privada es incorrecta o no se pudo leer.";
            } else {
                openssl_pkey_export($privateKeyResource, $privateKey);
            }

            // Intentar cargar el certificado público
            $certResource = @openssl_x509_read($certContent);
            if ($certResource === false) {
                return "Error: No se pudo leer el certificado público.";
            } else {
                openssl_x509_export($certResource, $publicCert);
                $certData = openssl_x509_parse($certResource);  // Extraer información adicional del certificado
            }

            if ($privateKey && $publicCert) {
                return [
                    'privateKey' => $privateKey,
                    'publicCert' => $publicCert,
                    'certDetails' => $certData
                ];
            } else {
                return "Error: Falló la extracción del certificado o la clave privada.";
            }

        default:
            return "Error: Extensión de archivo no compatible.";
    }

    return null;
}





// se puede mover esta funcion al archivo funciones_certificados_firma_digital.php y realizar un require_once
function certificados_firma_digital_add($parametros_array){
	global $conexion;
	global $saltolinea;

	// validaciones basicas
	$valido="S";
	$errores="";
	
    
	$clave_privada=antisqlinyeccion($parametros_array['clave_privada'],"clave");
	$clave_publica=antisqlinyeccion($parametros_array['clave_publica'],"clave");
	$clave_archivo=antisqlinyeccion($parametros_array['clave_archivo'],"clave");
	$datos_extra=antisqlinyeccion($parametros_array['datos_extra'],"textbox");
	$nombre_archivo_orig=antisqlinyeccion($parametros_array['nombre_archivo_orig'],"textbox");
	$nombre_archivo_nuevo=antisqlinyeccion($parametros_array['nombre_archivo_nuevo'],"textbox");
	$estado=antisqlinyeccion($parametros_array['estado'],"int");
	$registrado_por=antisqlinyeccion($parametros_array['registrado_por'],"int");
	$registrado_el=antisqlinyeccion($parametros_array['registrado_el'],"text");

	
/* 
clave_privada 
	if(trim($parametros_array['clave_privada']) == ''){
		$valido="N";
		$errores.=" - El campo clave_privada no puede estar vacio.<br />";	
	}
*/
/* 
clave_publica 
	if(trim($parametros_array['clave_publica']) == ''){
		$valido="N";
		$errores.=" - El campo clave_publica no puede estar vacio.<br />";	
	}
*/
/* 
datos_extra 
	if(trim($parametros_array['datos_extra']) == ''){
		$valido="N";
		$errores.=" - El campo datos_extra no puede estar vacio.<br />";	
	}
*/
/* 
nombre_archivo_orig 
	if(trim($parametros_array['nombre_archivo_orig']) == ''){
		$valido="N";
		$errores.=" - El campo nombre_archivo_orig no puede estar vacio.<br />";	
	}
*/
/* 
nombre_archivo_nuevo 
	if(trim($parametros_array['nombre_archivo_nuevo']) == ''){
		$valido="N";
		$errores.=" - El campo nombre_archivo_nuevo no puede estar vacio.<br />";	
	}
*/
/* 
registrado_por 
*/
/* 
registrado_el 
*/
	

	// si todo es correcto inserta
	if($valido == "S"){
		
		$consulta="
		insert into certificados_firma_digital
		(clave_archivo, clave_privada, clave_publica, datos_extra, nombre_archivo_orig, nombre_archivo_nuevo, estado, registrado_por, registrado_el)
		values
		($clave_archivo, $clave_privada, $clave_publica, $datos_extra, $nombre_archivo_orig, $nombre_archivo_nuevo, $estado, $registrado_por, $registrado_el)
		";
		//echo $consulta;exit;
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		
		// obtiene el id insertado
		$consulta="
		select idcertificado from certificados_firma_digital order by idcertificado desc limit 1
		";
		$rscert=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idcertificado=$rscert->fields['idcertificado'];
		
	}


	return array("errores"=>$errores,"valido"=>$valido, 'idcertificado'=>$idcertificado);
}


if(isset($_POST['MM_insert']) && $_POST['MM_insert'] == 'form1'){

	// validaciones basicas
	$valido="S";
	$errores="";
	
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	if($_SESSION['form_control'] != $_POST['form_control']){
		$errores.="- Se detecto un intento de envio doble, recargue la pagina.<br />";
		$valido="N";
	}
	if(trim($_POST['form_control']) == ''){
		$errores.="- Control del formularios no activado.<br />";
		$valido="N";
	}
	$_SESSION['form_control'] = md5(rand());
	// control de formularios, seguridad para evitar doble envio y ataques via bots
	

	// recibe parametros
	$estado=1;
	$registrado_por=$idusu;
	$registrado_el=$ahora;
	

	// Directorio de almacenamiento del certificado
	$certDir = 'gfx/firma_digital/';
	// si no existe directorio crea
	if (!is_dir($certDir)) {
		if (mkdir($certDir, 0755, true)) {
			// "El directorio ha sido creado correctamente.";
		} else {
			//echo "Error al crear el directorio: ".$certDir.".<br />";
			$errores.="Error al crear el directorio: ".$certDir.".<br />";
			$valido="N";
		}
	} else {
		// "El directorio ya existe.";
	}

	$originalFileName = basename($_FILES['certificado']['name']);
	$extension = pathinfo($originalFileName, PATHINFO_EXTENSION);
	
	//print_r($_FILES);

	// Crear el nuevo nombre de archivo con la estructura "cert_YYYYMMDDHHMMSS.ext"
	$newFileName = "cert_" . date("YmdHis") . "." . $extension;
	$certFile = $certDir . $newFileName;
	
	
	// Obtener la clave ingresada por el usuario
	$certPassword = $_POST['clave'];
	$nombre_archivo_orig=$originalFileName;
	$nombre_archivo_nuevo=$newFileName;
	
	
	if ($_FILES['certificado']['error'] === UPLOAD_ERR_OK) {
		$tempFile = $_FILES['certificado']['tmp_name'];
		$originalFileName = $_FILES['certificado']['name'];
		
		if (is_uploaded_file($tempFile)) {
			/*if (move_uploaded_file($tempFile, $certFile)) {
				echo "Archivo subido y movido correctamente a $certFile.<br>";
			} else {
				echo "Error al mover el archivo a la ubicación destino.<br>";
			}*/
		} else {
			echo "Error: El archivo no parece haber sido subido mediante POST.<br>";
		}
	} else {
		echo "Error en la subida del archivo: " . $_FILES['certificado']['error'] . "<br>";
	}
	//exit;

	
	if(trim($_POST['clave']) == ''){
		$errores.="- No se ingreso la clave del certificado.<br />";
		$valido="N";
	}

    // Validar y mover el archivo subido al directorio
	if ($_FILES['certificado']['error'] === UPLOAD_ERR_OK) {
		if (is_uploaded_file($_FILES['certificado']['tmp_name'])) {
			if (move_uploaded_file($_FILES['certificado']['tmp_name'], $certFile)) {
				//echo "El archivo se ha subido correctamente.<br>";



				// Procesar el certificado
			   // $certContent = file_get_contents($certFile);
				$certInfo = array();
				$resultado = extraerDatosCertificado($certFile, $certPassword);
				
				// si pudo leer el certificado
				if (is_array($resultado)) {
					//echo "Clave privada: \n" . $resultado['privateKey'] . "\n";
					//echo "Certificado público: \n" . $resultado['publicCert'] . "\n";
					//echo "Detalles del certificado: \n";
					//print_r($resultado['certDetails']);
					$certDetails=$resultado['certDetails'];
					$certDetails_json=json_encode($resultado['certDetails'], JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
				
				// si no pudo leer el certificado
				} else {
					// Mostrar el mensaje de error específico
					//echo $resultado . "\n";
					$errores.="- No se pudo obtener datos del certificado: ".htmlentities($resultado).".<br />";
					$valido="N";
				}

			}else{ // if (move_uploaded_file($_FILES['certificado']['tmp_name'], $certFile)) {
				$errores .= "- No se pudo cargar el archivo. Verifica permisos o el tamaño del archivo.<br />";
				$errores .= "Error al mover el archivo. Código de error: " . htmlentities($_FILES['certificado']['error']) . "<br />";
				$errores .= "Ruta destino: " . htmlentities(realpath($certDir)) . "<br />";
				$errores .= "Nombre del archivo temporal: " . htmlentities($_FILES['certificado']['tmp_name']) . "<br />";
				$valido = "N";
			} // if (move_uploaded_file($_FILES['certificado']['tmp_name'], $certFile)) {
		} else { // if (is_uploaded_file($_FILES['certificado']['tmp_name'])) {
			$errores .= "- El archivo no parece haber sido subido mediante POST.<br />";
			$valido = "N";
		} // if (is_uploaded_file($_FILES['certificado']['tmp_name'])) {
	} else { // if ($_FILES['certificado']['error'] === UPLOAD_ERR_OK) {		
		$errores .= "- Error en la subida del archivo: " . htmlentities($_FILES['certificado']['error']) . "<br />";
		$valido = "N";
	} // if ($_FILES['certificado']['error'] === UPLOAD_ERR_OK) {


	$parametros_array=array(
		"clave_privada" => $resultado['privateKey'],
		"clave_publica" => $resultado['publicCert'],
		"clave_archivo" => $certPassword,
		"datos_extra" => $certDetails_json,
		"nombre_archivo_orig" => $nombre_archivo_orig,
		"nombre_archivo_nuevo" => $nombre_archivo_nuevo,
		"estado" => $estado,
		"registrado_por" => $registrado_por,
		"registrado_el" => $registrado_el
	);

	// si todo es correcto actualiza
	if($valido == "S"){
		$res=certificados_firma_digital_add($parametros_array);
		$idcertificado=intval($res["idcertificado"]);
		if ($res["valido"]=="S") {
			header("location: slot_firmadigital_cert_det.php?id=".$idcertificado);
			exit;
		}else{
			$errores.=$res["errores"];
		}
		
	}else{
		$errores.=$res["errores"];
	}


}

// control de formulario despues de recibir el post y validar vuelve a regenerar
$_SESSION['form_control'] = md5(rand());




?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Slot Firma Digital</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">



					<p>
					<a href="slot_firmadigital.php" class="btn btn-sm btn-default"><span class="fa fa-reply"></span> Volver</a>
					
					</p>

<hr />
    
   <?php if(trim($errores) != ""){ ?>
<div class="alert alert-danger alert-dismissible fade in" role="alert">
<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
</button>
<strong>Errores:</strong><br /><?php echo $errores; ?>
</div>
<?php } ?>
<form id="form1" name="form1" method="post" action="" enctype="multipart/form-data">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Certificado:</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="file" name="certificado" id="certificado"   class="form-control" required  />
	</div>
</div>

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">Clave:</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="password" name="clave" id="clave" value="" placeholder="Clave privada" class="form-control" required  />
	</div>
</div>


<div class="clearfix"></div>
<br />
Extensiones permitidas de archivo del certificado (.pfx, .p12, .pem, .crt, .cer)



<div class="clearfix"></div>
<br />
    <div class="form-group">
		<div class="col-md-12 col-sm-12 col-xs-12 text-center">
        
	   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar</button>
	   
        </div>
    </div>

  <input type="hidden" name="MM_insert" value="form1" />
  <input type="hidden" name="form_control" value="<?php echo htmlentities($_SESSION['form_control']); ?>">
<br />
</form>
<br /><br />

                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
			<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="ventanamodal">
                    <div class="modal-dialog modal-lg">
                      <div class="modal-content">
                        <div class="modal-header">
                          <h4 class="modal-title" id="titulov"></h4>
                        </div>
                        <div class="modal-body" id="cuerpov" >
							
                        </div>
                        <div class="modal-footer"  id="piev">
						  
                          <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>&nbsp;
                          
                        </div>

                      </div>
                    </div>
		     </div>
            
            
            
          </div>
        </div>
        <!-- /page content -->
		<script>
		function registra_slot(idslot){
			var parametros = {
                "idslot"             : idslot,
				"registrar"			:1
				};
			   $.ajax({
						data:  parametros,
						url:   'facturaElectronica/registrar_slots.php',
						type:  'post',
						dataType: 'html',
						beforeSend: function () {
								$("#datosreg").html("Enviando datos");
						},
						crossDomain: true,
						success:  function (response) {
							$("#datosreg").html(response);	
								
						}
				});
			
			
			
		}
		
		</script>
        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
	
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
