<?php
/*-----------------------------
22/08/2023
Se corrigen y agregan secciones como anular solicitudes
-------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="4";
$submodulo="3";
require_once("includes/rsusuario.php"); 


$buscar="Select fecha_solicitud,solicitudes.idsolicitud,solicitudes.idsolicitudcab,nombre,apellido,documento,ruc,monto,plazo,razon_social,
(select descripcion from solicitudes_estados where idestado=solicitudes.estado_solicitud) as estadosolicompleto ,
(select razon_social from cliente where idcliente = solicitudes.idcliente) as cliente,solicitudes.registrado_el,
	(select idcliente from cliente where idcliente = solicitudes.idcliente) as idcliente
from solicitudes
inner join solicitudes_cab on solicitudes_cab.idsolicitudcab=solicitudes.idsolicitudcab
inner join cliente on cliente.idcliente=solicitudes.idcliente
where solicitudes.estado_solicitud <> 6 order by idsolicitud desc";
$rstd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

//nuladas

$buscar="Select fecha_solicitud,solicitudes.idsolicitud,solicitudes.idsolicitudcab,nombre,apellido,documento,ruc,monto,plazo,razon_social,
(select descripcion from solicitudes_estados where idestado=solicitudes.estado_solicitud) as estadosolicompleto ,
(select razon_social from cliente where idcliente = solicitudes.idcliente) as cliente,solicitudes.registrado_el,
(select usuario from usuarios where idusu=solicitudes_cab.anulado_por) as userdel,
solicitudes_cab.anulado_el,
(select idcliente from cliente where idcliente = solicitudes.idcliente) as idcliente
from solicitudes
inner join solicitudes_cab on solicitudes_cab.idsolicitudcab=solicitudes.idsolicitudcab
inner join cliente on cliente.idcliente=solicitudes.idcliente
where solicitudes.estado_solicitud=6 order by idsolicitud desc";
$rstda=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
//echo $buscar;
$tanula=$rstda->RecordCount();

?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Solicitudes Cargadas</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					  <p><a href="solicitudes_add.php" class="btn btn-sm btn-default"><span class="fa fa-plus"></span> Agregar</a></p>
					  
					<table class="table table-striped">
						<thead>
							<tr>
								<th>Acciones</th>
								<th>#Id solicitud</th>
								<th>Cliente</th>
								<th>Documento</th>
								<th>Monto Solicitado</th>
								<th>Plazo Solicitado</th>
								<th>Estado Solicitud</th>
								<th>Fecha Carga</th>
							</tr>
						</thead>
						<tbody>
							<?php while (!$rstd->EOF){?>
							<tr>
								<th>
								<a title="Solicitud" class="btn btn-sm btn-default" href="solicitudes_pdf.php?ids=<?php echo $rstd->fields['idsolicitud']; ?>" target="_blank"><span class="fa fa-file-pdf-o"></span></a>
				
								<a title="Legajo" class="btn btn-sm btn-default" href="cliente_legajo.php?id=<?php echo $rstd->fields['idcliente']; ?>" target="_blank"><span class="fa fa-user"></span></a>
								
								<a title="Anular" class="btn btn-sm btn-default" href="solicitudes_anular.php?id=<?php echo $rstd->fields['idsolicitud']; ?>"  target="_blank"><span class="fa fa-trash"></span></a>
								</th>
								<th ><?php echo $rstd->fields['idsolicitud']?></th>
								<td><?php echo $rstd->fields['razon_social']?></td>
								<td><?php echo formatomoneda($rstd->fields['documento'])?></td>
								<td><?php echo formatomoneda($rstd->fields['monto'],4,'N');?></td>
								<td><?php echo formatomoneda($rstd->fields['plazo'],4,'N');?></td>
								<td><?php echo $rstd->fields['estadosolicompleto'];?></td>
								<td><?php echo date("d-m-Y H:i:s",strtotime($rstd->fields['registrado_el']));?></td>
							</tr>
							<?php $rstd->MoveNext();}?>
						</tbody>
						</table>
								
                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            <?php if($tanula > 0){ ?>
              <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Solicitudes Anuladas</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
					 
					  
					<table class="table table-striped">
						<thead>
							<tr>
								
								<th>#Id solicitud</th>
								<th>Fecha Carga</th>
								<th>Cliente</th>
								<th>Documento</th>
								<th>Monto Solicitado</th>
								<th>Plazo Solicitado</th>
								<th>Anulado por</th>
								<th>Anulado el</th>
								
							</tr>
						</thead>
						<tbody>
							<?php while (!$rstda->EOF){
								
							
								$borrado=trim($rstda->fields['userdel']);
								$fb=($rstda->fields['anulado_el']); 
								
								?>
							<tr>
							
								<th ><?php echo $rstda->fields['idsolicitud']?></th>
								<td><?php echo date("d-m-Y H:i:s",strtotime($rstda->fields['registrado_el']));?></td>
								<td><?php echo $rstda->fields['razon_social']?></td>
								<td><?php echo formatomoneda($rstd-a>fields['documento'])?></td>
								<td><?php echo formatomoneda($rstda->fields['monto'],4,'N');?></td>
								<td><?php echo formatomoneda($rstda>fields['plazo'],4,'N');?></td>
								
								<td><?php echo $borrado;?></td>
								<td><?php echo $fb; ?></td>
							</tr>
							<?php $rstda->MoveNext();}?>
						</tbody>
						</table>
								
                  </div>
                </div>
              </div>
            </div>
            <?php } ?>
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
