<?php
/*------------------------------------------------------------------
Script: Agregar solicitudes de crédito al sistema
UR: 20/01/2022
Para uso de analisis y comercial
-------------------------------------------------------------------*/
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="2";
require_once("includes/rsusuario.php"); 
//ini_set('display_errors', 1);
//ini_set('display_startup_errors', 1);
//error_reporting(E_ALL);

function cuadro_amortizacion_frances($capital,$interes,$monto_cuota,$plazo,$tasa,$decimales=0){
	$saldo_insoluto=$capital;
	$saldo_deuda=$capital+$interes;
	$comprobacion=$monto_cuota*$plazo;
	if($comprobacion > $saldo_deuda){
		$saldo_deuda=$comprobacion;	
	}
	if($saldo_deuda < $saldo_insoluto){
		$saldo_deuda=$saldo_insoluto;	
	}
	$tasa_anual=($tasa/100)/12;
	for($i=1;$i<=$plazo;$i++){
		$interes_cuo=round(($saldo_insoluto*$tasa_anual),$decimales);
		$amortizacion=round(($monto_cuota-$interes_cuo),$decimales);
		$cuadro[$i]['ncuota']=$i;
		$cuadro[$i]['saldo_insoluto']=$saldo_insoluto;
		$cuadro[$i]['saldo_deuda']=$saldo_deuda;
		$cuadro[$i]['monto_cuota']=$monto_cuota;
		$cuadro[$i]['interes']=$interes_cuo;
		$cuadro[$i]['amortizacion']=$amortizacion;
		$saldo_insoluto=$saldo_insoluto-$amortizacion;
		$saldo_deuda=$saldo_deuda-$monto_cuota;
	}
	$cuadronew=redondear_cuadro_frances($cuadro,$capital,$interes,$plazo);
	return $cuadronew;
}


function redondear_cuadro_frances($res,$capital,$interes,$plazo){
	//print_r($res);
	$i=1;
	foreach ($res as $valor){
		if($i == 1){
			$saldo_insoluto_ini=round($valor['saldo_deuda']);
		}
		$cuota=$valor['ncuota'];
		$amortizacion=round($valor['amortizacion']);
		$interes_cuo=round($valor['interes']);
		$saldo_insoluto=round($valor['saldo_insoluto']);
		$saldo_deuda=round($valor['saldo_deuda']);
		$monto_cuota=round($valor['monto_cuota']);
		$gastos=0;
		$sumacapital+=$amortizacion;
		$sumainteres+=$interes_cuo;
		$sumacuota+=$monto_cuota;
		$i++;
	}
	//Ajuste de capital
	if ($sumacapital < $capital) {
		$diferencp=$capital-$sumacapital;
		//$amortred=$amortred+$diferencp;	
		//$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']+$amortred;
		$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']+$diferencp;
		$sumacapital=$sumacapital+$diferencp;
	} else if ($sumacapital > $capital) {
		$diferencp=$sumacapital-$capital;
		//$amortred=$amortred-$diferencp;	
		//$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']-$amortred;
		$res[$plazo]['amortizacion'] = $res[$plazo]['amortizacion']-$diferencp;
		$sumacapital=$sumacapital-$diferencp;
	}
	//Ajuste de Interes
	if ($sumainteres < $interes) {
		$diferenint=$interes-$sumainteres;
		$res[$plazo]['interes'] = $res[$plazo]['interes']+$diferenint;
		$inteimprime=$inteimprime+$diferenint;	
		$sumainteres=$sumainteres+$diferenint;	
	} else if ($sumainteres > $interes) {

		$diferenint=$sumainteres-$interes;
		$res[$plazo]['interes'] = $res[$plazo]['interes']-$diferenint;
		$inteimprime=$inteimprime-$diferenint;
		$sumainteres=$sumainteres-$diferenint;		
	}
	//echo $saldo_insoluto_ini;
	// ajuste de cuota
	if($sumacuota < $saldo_insoluto_ini){
		//echo $sumacuota;
		$diferencuo=$saldo_insoluto_ini-$sumacuota;
		$res[$plazo]['monto_cuota'] = $res[$plazo]['monto_cuota']+$diferencuo;
		$sumacuota=$sumacuota+$diferencuo;
	} else if ($sumacuota > $saldo_insoluto_ini) {
		$diferencuo=$sumacuota-$saldo_insoluto_ini;
		$res[$plazo]['monto_cuota'] = $res[$plazo]['monto_cuota']-$diferencuo;
		$cuoimprime=$cuoimprime-$diferencuo;
		$sumacuota=$sumacuota-$diferencuo;	
	}
	return $res;
	
} 



//Post de registro
if (isset($_POST['fecha_solicitud'])){
	//print_r($_POST);exit;
	$nrosoli=intval($_POST['ocsolinum']);
	//print_r($_POST);
	$fechasoli=antisqlinyeccion($_POST['fecha_solicitud'],'date');
	$tiposoli=intval($_POST['tiposoli']);
	$tipodocu=intval($_POST['tipodocu']);
	$documento=antisqlinyeccion($_POST['docu'],'int');
	
	//Adicionales para update cliente ppal
	$fechanac=antisqlinyeccion($_POST['fecha_nacimiento'],'date');
	$direpart=antisqlinyeccion($_POST['direpart'],'text');
	//echo $fechanac;
	//echo $direpart;exit;
	$profesion=intval($_POST['profesion']);
	$ecivil=intval($_POST['estcivil']);
	//para obs larga en solicitudes
	$obsdire=antisqlinyeccion($_POST['obsdire'],'text');
	
	
	$n1=trim($_POST['primnom']);
	$n2=trim($_POST['senom']);
	$nombres=antisqlinyeccion($n1.' '.$n2,'text');
	

	$a1=trim($_POST['primape']);
	$a2=trim($_POST['sape']);
	$apellidos=antisqlinyeccion($a1.' '.$a2,'text');
	
	$rz=antisqlinyeccion($_POST['rz'],'text');

	$monto=0;
	$plazo=0;
	$plazosoli=0;
	if ($tipodocu==1){
		//ci
		$bbadd=" documento=$documento ";
		$buscar="Select ruc from cliente where borrable='N' order by idcliente asc limit 1";
		$rsp=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$ruc=trim($rsp->fields['ruc']);
	}
	if ($tipodocu!=1){
		//ruc
		$bbadd=" ruc=$documento ";
		$documento=0;
		
	}
	if ($_POST['rz']==''){
		$rz=($_POST['primnom'].' '.$_POST['senom'].' '.$_POST['primape'].' '.$_POST['sape']);
		//echo $rz;exit;
		$rz=antisqlinyeccion($rz,'text');
	}
	$dp=antisqlinyeccion($_POST['direpart'],'text');
	
	$buscar="Select * from cliente where $bbadd ";
	$fr=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	
	$idcliente=intval($fr->fields['idcliente']);
	if ($fr->fields['idcliente']==0){
		//generamos el id de cliente
		$insertar="Insert into 
		cliente (nombre,apellido,razon_social,estado,registrado_el,registrado_por,ruc,documento,idempresa,sucursal,profesion,estado_civil)
		values
		($nombres,$apellidos,$rz,1,current_timestamp,$idusu,'$ruc',$documento,$idempresa,$idsucursal,$profesion,$estcivil)";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
		
		$buscar="Select * from cliente where registrado_por=$idusu order by idcliente desc limit 1";
		$fr=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idcliente=intval($fr->fields['idcliente']);
	} 
	//antes de insertar un nuevo registro, verificamos que no exista
	$buscar="select * from solicitudes_cab where registrado_por=$idusu and estado =1 order by idsolicitudcab desc limit 1";
	$rb=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	if (intval($rb->fields['idsolicitudcab'])> 0){
		$idcabecera=intval($rb->fields['idsolicitudcab']);
	} else {
		$insertar="Insert into solicitudes_cab (fecha_solicitud,monto,plazo,registrado_por,registrado_el) values ($fechasoli,$monto,$plazosoli,$idusu,current_timestamp)";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
		$buscar="Select * from solicitudes_cab where registrado_por=$idusu and monto=$monto and plazo=$plazosoli and estado <> 6 order by idsolicitudcab desc limit 1";
		$rf=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$idcabecera=intval($rf->fields['idsolicitudcab']);
	}
	
	
	//hacemos el update en la tabla
	$insertar="
	insert into cliente_historico
	(idcliente,idsolicitud,direccion_obs,estado_civil,profesion,estado)
	values
	($idcliente,$nrosoli,$obsdire,$ecivil,$profesion,1)
	";
	$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
	
	//update en clientes
	$update="update cliente set fechanac=$fechanac,direccion=$direpart,estado_civil=$ecivil,profesion=$profesion where idcliente=$idcliente ";
	//Adicionales para update cliente ppal
	$conexion->Execute($update) or die(errorpg($conexion,$update));

	//actualizamos la solicitud
	$update="update solicitudes set
	idsolicitudcab=$idcabecera,idtiposolicitud=$tiposoli,idcliente=$idcliente,
	clase_solicitud=1,ultima_actualizacion=current_timestamp,actualizado_por=$idusu,
	estado_solicitud=1 where idsolicitud=$nrosoli and estado_solicitud=1";
	$conexion->Execute($update) or die(errorpg($conexion,$update));
	
	
	
	
}
if (isset($_POST['montosoli'])){
	$obsdireccion=antisqlinyeccion($_POST['obsdire'],'text');	
	//Conyuge
	$ncon1=antisqlinyeccion($_POST['nomconyu'],'text');
	$apecon1=antisqlinyeccion($_POST['apeconyu'],'text');
	$dcconyu=antisqlinyeccion($_POST['dcconyu'],'text');
	$obconyu=antisqlinyeccion($_POST['obsconyu'],'text');
	//Garante
	
	$gara1=antisqlinyeccion($_POST['nomgara'],'text');
	$gara2=antisqlinyeccion($_POST['apegara'],'text');
	$dcgara=antisqlinyeccion($_POST['dcgara'],'text');
	$obgara=antisqlinyeccion($_POST['obsgara'],'text');
	$monto=floatval($_POST['montosoli']);
	$plazosoli=intval($_POST['plazosoli']);
	//print_r($_POST);exit;
	$buscar="select * from solicitudes_cab where registrado_por=$idusu and estado =1 order by idsolicitudcab desc limit 1";
	$rb=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$idcabecera=intval($rb->fields['idsolicitudcab']);
	$buscar="Select * from solicitudes where registrado_por =$idusu and estado_solicitud=1  order by idsolicitud desc limit 1";
	$rstd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	$nrosoli=intval($rstd->fields['idsolicitud']);
	
	if ($_POST['nomconyu']!=''){
		//registramos para la soli
		$insertar="insert into solicitudes_datos_otros (nombres,apellidos,documento,obs,idsolicitudcab,tipo) values ($ncon1,$apecon1,$dcconyu,$obconyu,$idcabecera,1) ";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
	}
	if ($_POST['nomgara']!=''){
		//registramos para la soli
		$insertar="insert into solicitudes_datos_otros (nombres,apellidos,documento,obs,idsolicitudcab,tipo) values ($gara1,$gara2,$dcgara,$obgara,$idcabecera,2) ";
		$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
	}	
	
	 
	if ($monto>0&&$plazosoli>0){
		/*
		$monto_cuota=$monto/$plazosoli;
				
		$capital=$monto;
		$interes=0;
		$monto_cuota=round($monto/$plazosoli,0);
		$plazo=$plazosoli;
		$tasa=0;
		$decimales=0;
		$monto_cuota=redondear_tresceros($monto_cuota);
		$res=cuadro_amortizacion_frances($capital,$interes,$monto_cuota,$plazo,$tasa,$decimales);
		
		$i=1;
		$vencimiento=date("Y-m-d",strtotime($_POST['fecha_solicitud']));
		$vtoant=$vencimiento;
		$diavenc=date("d",strtotime($vencimiento));
		
		*/
		//verificamos si hay cuadro del vendedor
		
		$buscar="Select *,sum(amortizacion) as total,max(nro_cuota) as mayor from cuadro_amortizacion_vendedor where idusu=$idusu and estado=1 order by nro_cuota asc";
		$rscuadro=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$treg=$rscuadro->RecordCount();
		//echo $buscar;exit;
		$monto=floatval($rscuadro->fields['total']);
		if($treg==0){
			$monto_cuota=$monto/$plazosoli;
				
			$capital=$monto;
			$interes=0;
			$monto_cuota=round($monto/$plazosoli,0);
			$plazo=$plazosoli;
			$tasa=0;
			$decimales=0;
			$monto_cuota=redondear_tresceros($monto_cuota);
			$res=cuadro_amortizacion_frances($capital,$interes,$monto_cuota,$plazo,$tasa,$decimales);
			
			$i=1;
			$vencimiento=date("Y-m-d",strtotime($_POST['fecha_solicitud']));
			$vtoant=$vencimiento;
			$diavenc=date("d",strtotime($vencimiento));
		
			$consulta="delete from cuadro_amortizacion where nro_soli = $nrosoli";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
			foreach($res as $detalle){
				$nro_cuota=$detalle['ncuota'];
				$vencimiento=mismafechaproximomes($vencimiento,$diavenc);
				$amortizacion=$detalle['amortizacion'];
				$vtoant=$vencimiento;
				//echo $vencimiento."<br />";
				$consulta="
				insert into cuadro_amortizacion 
				(nro_soli, nro_cuota, amortizacion, interes, gastos_adm, vencimiento, registrado_por, registrado_el) 
				values
				($idcabecera, $nro_cuota, $amortizacion, 0, 0, '$vencimiento', $idusu, '$ahora')
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
			}
		} else {
			//hay una proforma
			$buscar="Select * from cuadro_amortizacion_vendedor where idusu=$idusu and estado=1 order by nro_cuota asc";
			$rscuadro=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
			//echo $buscar;exit;
			while(!$rscuadro->EOF){
				
				$nro_cuota=intval($rscuadro->fields['nro_cuota']);
				$vencimiento=date("Y-m-d",strtotime($rscuadro->fields['vencimiento']));
				$amortizacion=intval($rscuadro->fields['amortizacion']);
				
				$consulta="
				insert into cuadro_amortizacion 
				(nro_soli, nro_cuota, amortizacion, interes, gastos_adm, vencimiento, registrado_por, registrado_el) 
				values
				($idcabecera, $nro_cuota, $amortizacion, 0, 0, '$vencimiento', $idusu, '$ahora')
				";
				$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
				
				//echo $consulta;exit;
				
				$rscuadro->MoveNext();
			}
			
			$update="Update cuadro_amortizacion_vendedor set idsolicitud=$nrosoli where idusu=$idusu and estado=1";
			$conexion->Execute($update) or die(errorpg($conexion,$update));
			
		}
		$update="update solicitudes_cab set estado=2,monto=$monto,plazo=$plazosoli,monto_aprobado=0 where idsolicitudcab=$idcabecera";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		$update="update solicitudes set estado_solicitud=2,obsdire=$obsdireccion where idsolicitud=$nrosoli";
		$conexion->Execute($update) or die(errorpg($conexion,$update));
		
		header("Location: solicitudes.php");exit;
	}
	
}
/*------------------------------NUEVA OPERATIVA-------------------------------*/
//verificamos si existe la solicitud o no para continuar cargando
$buscar="Select * from solicitudes where registrado_por =$idusu and estado_solicitud=1  order by idsolicitud desc limit 1";
$rstd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

$idcabecera=intval($rstd->fields['idsolicitudcab']);
$nrosoli=intval($rstd->fields['idsolicitud']);

if ($nrosoli==0){
	$insertar="Insert into solicitudes (registrado_por,estado_solicitud) values ($idusu,1)";
	$conexion->Execute($insertar) or die(errorpg($conexion,$insertar));
	$buscar="Select * from solicitudes where registrado_por =$idusu and estado_solicitud=1  order by idsolicitud desc limit 1";
	$rstd=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

	$nrosoli=intval($rstd->fields['idsolicitud']);
	
	
}
$dc=intval($_REQUEST['dc']);
if ($dc==0){
	$buscar="Select fecha_solicitud,fechanac, direccion,solicitudes.idcliente,clase_solicitud,solicitudes.comentario,
	(select direccion_obs from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as direccion_obs ,
	(select cliente_historico.estado_civil from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as estado_civil ,
	(select cliente_historico.profesion from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as profesion,

	nombre,apellido,documento
	from solicitudes 
	inner join cliente on cliente.idcliente=solicitudes.idcliente
	inner join solicitudes_cab on solicitudes_cab.idsolicitudcab=solicitudes.idsolicitudcab 
	where solicitudes.registrado_por =$idusu and solicitudes.estado_solicitud=1 and solicitudes.idsolicitud=$nrosoli";
	$rsl=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

} else {
	//tiene cedula buscamos ultima solicitud de referencia
	$buscar="Select * from solicitudes where idcliente in(select idcliente from cliente where documento=$dc) order by idsolicitud desc limit 1";
	$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
	if ($rs->fields['idcliente']==''){
		//no existe una solicitud para el cliente, usamos metodo tradicional
		$idsoli_anterior=0;
		$buscar="Select fecha_solicitud,fechanac, direccion,solicitudes.idcliente,clase_solicitud,solicitudes.comentario,
		(select direccion_obs from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as direccion_obs ,
		(select cliente_historico.estado_civil from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as estado_civil ,
		(select cliente_historico.profesion from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as profesion,

		nombre,apellido,documento
		from solicitudes 
		inner join cliente on cliente.idcliente=solicitudes.idcliente
		inner join solicitudes_cab on solicitudes_cab.idsolicitudcab=solicitudes.idsolicitudcab 
		where solicitudes.registrado_por =$idusu and solicitudes.estado_solicitud=1 and solicitudes.idsolicitud=$nrosoli";
		$rsl=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		$treg=$rsl->RecordCount();
	
		if($treg==0){
			//consultamoss el ruc para obtener datos basicos y pre cargar
			$parametros_array=array(
				'ruc' => $dc
			);
			$res=ruc_hacienda($parametros_array);
			// [idcliente] => 64 [idsucursal_clie] => 63 [ruc] => 2308961-0 [documento] => 2308961 [razon_social] => JOSE LOPEZ [apellido_ruc] => LOPEZ [nombre_ruc] => JOSE [tipo_persona] => FISICA [fuente] => CLIENTE 
			$dccontrol=intval($res['documento']);
			$nombrecontrol=trim($res['nombre_ruc']);
			$apellidocontrol=trim($res['apellido_ruc']);
			$idclientecontrol=intval($res['idcliente']);
			
			//print_r($res);exit;
			if ($idclientecontrol> 0){
				$buscar="Select * from cliente where idcliente=$idclientecontrol";
				$rsc=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				if ($rsc->fields['fechanac']==''){
					$fechanac="";
				}else{
					$fechanac=date("Y-m-d",strtotime($rsc->fields['fechanac']));
				}
				$direccion=trim($rsc->fields['direccion']);
				$profesion=($rsc->fields['profesion']);
				$estado_civil=($rsc->fields['estado_civil']);
			} else {
				//Puede que sea de hacienda, por lo cual buscamos en cliente
				$buscar="Select *
				
				from cliente where documento=$dc";
				$rsc=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
				if ($rsc->fields['fechanac']==''){
					$fechanac="";
				}else{
					$fechanac=date("Y-m-d",strtotime($rsc->fields['fechanac']));
				}
				$dccontrol=intval($rsc->fields['documento']);
				$nombrecontrol=trim($rsc->fields['nombre']);
				$apellidocontrol=trim($rsc->fields['apellido']);
				$idclientecontrol=intval($rsc->fields['idcliente']);
				$direccion=trim($rsc->fields['direccion']);
				$profesion=($rsc->fields['profesion']);
				$estado_civil=($rsc->fields['estado_civil']);
			}
		}
	
	} else {
		//ya existe una solicitud , usamos datos de la ultima para cargar los campos
		$idsoli_anterior=intval($rs->fields['idsolicitud']);
		$buscar="Select fecha_solicitud,fechanac, direccion,solicitudes.idcliente,clase_solicitud,solicitudes.comentario,
		(select direccion_obs from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as direccion_obs ,
		(select cliente_historico.estado_civil from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as estado_civil ,
		(select cliente_historico.profesion from cliente_historico where idsolicitud=solicitudes.idsolicitud order by unreg desc limit 1) as profesion,

		nombre,apellido,documento
		from solicitudes 
		inner join cliente on cliente.idcliente=solicitudes.idcliente
		inner join solicitudes_cab on solicitudes_cab.idsolicitudcab=solicitudes.idsolicitudcab 
		where solicitudes.registrado_por =$idusu and solicitudes.estado_solicitud=1 and solicitudes.idsolicitud=$idsoli_anterior";
		$rsl=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
		
	}
	
	
	
}
$update="update tmp_carrito_simuador_creditos_productos set idsolicitudcab=$idcabecera where tmp_carrito_simuador_creditos_productos.estado=1 and tmp_carrito_simuador_creditos_productos.registrado_por=$idusu and idsolicitudcab IS NULL";
$conexion->Execute($update) or die(errorpg($conexion,$update));

$update="update cuadro_amortizacion_vendedor set idsolicitudcab=$idcabecera where cuadro_amortizacion_vendedor.estado=1 and cuadro_amortizacion_vendedor.registrado_por=$idusu and idsolicitudcab IS NULL";
$conexion->Execute($update) or die(errorpg($conexion,$update));

//Traemos los datos del carrito de productos
$buscar="Select descripcion,productos.idprod_serial,cantidad,precio_unitario as precio,subtotal
 from tmp_carrito_simuador_creditos_productos 
 inner join productos on productos.idprod_serial=tmp_carrito_simuador_creditos_productos.idprod_serial
 where tmp_carrito_simuador_creditos_productos.estado=1 and idsolicitudcab=$idcabecera";
$rsprod=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));

//Cuadro de amortizacion del vendedor
//Traemos los datos del carrito de productos
$buscar="Select *,sum(amortizacion) as total,max(nro_cuota) as mayor from cuadro_amortizacion_vendedor where  idsolicitudcab=$idcabecera order by nro_cuota asc";
$rscuadro=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));


$plazo=intval($rscuadro->fields['mayor']);
$total=intval($rscuadro->fields['total']);
?>
<!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->
 
        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>
            <div class="clearfix"></div>
			<?php require_once("includes/lic_gen.php");?>
           <form id="regsoli" action="" method="post">
            <!-- SECCION -->
				<div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel">
					  <div class="x_title">
						<h2>Datos  Iniciales Solicitud N&deg; <?php echo formatomoneda($nrosoli,4,'N'); ?> - <a href="solicitudes.php"><span class="fa fa-home"></span>&nbsp;Regresar</a></h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
					  <div class="x_content">
							<?php if(trim($errores) != ""){ ?>
								<div class="alert alert-danger alert-dismissible fade in" role="alert">
								<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">×</span>
								</button>
								<strong>Errores:</strong><br /><?php echo $errores; ?>
								</div>
								<?php } ?>
								<form id="form1" name="form1" method="post" action="">
									<div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Fecha solicitud *</label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									<input type="date" name="fecha_solicitud" id="fecha_solicitud" value="<?php  if(isset($_POST['fecha_solicitud'])){ echo htmlentities($_POST['fecha_solicitud']); }else{ if($rsl->fields['fecha_solicitud']!=''){ echo htmlentities(date("Y-m-d",strtotime($rsl->fields['fecha_solicitud']))); } else { echo date("Y-m-d");} }?>" placeholder="Fecha solicitud" class="form-control" required="required" />                    
									</div>
								</div>
								<div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Tipo Solicitud *</label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									<select name="tiposoli" id="tiposoli" style="width:100%;height:40px;" required="required">
										<option value="" selected="Selected">Seleccionar</option>
										<?php
											$buscar="select * from solicitudes_clases where estado=1 order by descripcion asc";
											$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
											while (!$rs->EOF){
												$auto=trim($rs->fields['asele']);
												
										?>
											<option value="<?php echo $rs->fields['idclase'] ?>"
											<?php if ($rs->fields['asele']=='S'){ echo "selected='selected' "; }?>	
											<?php if ($rsl->fields['clase_solicitud']=='S'){ echo "selected='selected' "; }?>	
													><?php echo $rs->fields['descripcion'] ?></option>
										<?php 
											$rs->MoveNext();}

										?>
									</select>
									</div>
								</div>
								<div class="clearfix"></div>
						<div class="col-md-6 col-sm-6 form-group">
							<label class="control-label col-md-3 col-sm-3 col-xs-12">Tipo Persona *</label>
							<div class="col-md-9 col-sm-9 col-xs-12">
								   <select name="tipopersona" id="tipopersona" style="width:100%;height:40px;" onchange="cambio(this.value)">
									   <option value="1" selected="Selected">F&iacute;sica</option>
									   <option value="2">Jur&iacute;dica</option>
							</select>       
							</div>
						</div>	

							
						<div class="col-md-6 col-sm-6 form-group">
							<label class="control-label col-md-3 col-sm-3 col-xs-12">Tipo Documento *</label>
							<div class="col-md-9 col-sm-9 col-xs-12">
						<select name="tipodocu" id="tipodocu" style="width:100%;height:40px;" " required="required">
						<option value="" selected="Selected">Seleccionar</option>
						<?php
							$buscar="select * from documentos_tipos where estado=1 order by descripcion asc";
						$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
						while (!$rs->EOF){
						?>
						<option value="<?php echo $rs->fields['idtipodoc'] ?>"<?php if ($rs->fields['asele']=='S'){ echo "selected='selected' "; }?>><?php echo $rs->fields['descripcion'] ?></option>
								<?php 
									$rs->MoveNext();}

								?>
							</select>
							</div>
						</div>
						
						<div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Documento Numero *</label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									<input type="text" name="docu" id="docu" value="<?php if(isset($_POST['docu'])){ echo $_POST['docu'];} else { if($rsl->fields['documento']!=''){ echo $rsl->fields['documento']; } else { echo $dccontrol; }} ?>" placeholder="" class="form-control" required="required" />                    
									</div>
								</div>	
								
								<div id="conjunto01">
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12"> Nombres *</label>
										<div class="col-md-9 col-sm-9 col-xs-12">
										<input type="text" name="primnom" id="primnom" value="<?php if(isset($_POST['primnom'])){ echo $_POST['primnom'];} else { if($rsl->fields['nombre']!=''){ echo $rsl->fields['nombre']; }else{ echo $nombrecontrol;}} ?>" placeholder="" class="form-control" required="required" />                    
										</div>
									</div>
										<div class="clearfix"></div>
									<!--
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12">Segundo Nombre </label>
										<div class="col-md-9 col-sm-9 col-xs-12">
										<input type="text" name="senom" id="senom" value="<?php echo $_POST['senom']; ?>" placeholder="" class="form-control"  />                    
										</div>
									</div>
									-->
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12"> Apellidos *</label>
										<div class="col-md-9 col-sm-9 col-xs-12">
										<input type="text" name="primape" id="primape" value="<?php if(isset($_POST['primape'])){ echo $_POST['primape'];} else { if($rsl->fields['apellido']!=''){ echo $rsl->fields['apellido']; } else { echo $apellidocontrol; }} ?>" placeholder="" class="form-control" required="required" />                    
										</div>
									</div>
									<!--
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12">Segundo Apellido </label>
										<div class="col-md-9 col-sm-9 col-xs-12">
										<input type="text" name="sape" id="sape" value="<?php echo $_POST['sape']; ?>" placeholder="" class="form-control"  />                    
										</div>
									</div>
									-->
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12">Fecha Nacimiento *</label>
										<div class="col-md-9 col-sm-9 col-xs-12">
										<input type="date" name="fecha_nacimiento" id="fecha_nacimiento" value="<?php if(isset($_POST['fecha_nacimiento'])){ echo $_POST['fecha_nacimiento'];} else { if($rsl->fields['fechanac']!=''){ echo $rsl->fields['fechanac']; } else { echo $fechanac;}} ?>" placeholder="" class="form-control" required="required" />                    
										</div>
									</div>
									<div class="col-md-6 col-sm-6 form-group">
										<label class="control-label col-md-3 col-sm-3 col-xs-12">Pais Origen </label>
										<div class="col-md-9 col-sm-9 col-xs-12">
											<select name="tipodocu" id="tipodocu" style="width:100%;height:40px;"  >
												<option value="" selected="Selected">Seleccionar</option>
												<?php
													$buscar="select * from paises where estado=1 order by nombre asc";
													$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
													while (!$rs->EOF){
												?>
													<option value="<?php echo $rs->fields['idpais'] ?>"<?php if ($rs->fields['defecto']==1){ echo " selected='selected'"; }?>><?php echo $rs->fields['nombre'] ?></option>
												<?php 
													$rs->MoveNext();}

												?>
											</select>
										</div>
									</div>
								</div>
								<div class="col-md-6 col-sm-6 form-group" id="rzarea" style="display:none">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Raz&oacute;n Social </label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									<input type="text" name="rz" id="rz" value="" placeholder="" class="form-control"  />                    
									</div>
								</div>


								<div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Direcci&oacute;n </label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									<input type="text" name="direpart" id="direpart" value="<?php if(isset($_POST['direpart'])){ echo $_POST['direpart'];} else { if($rsl->fields['direccion']!=''){ echo $rsl->fields['direccion']; } else { echo $direccion;}} ?>" class="form-control" required="required" />                    
									</div>
								</div>
						  <div class="clearfix"></div>
						  <div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Profesi&oacute;n </label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									     <select name="profesion" id="profesion" style="width:100%;height:40px;"  required="required">
												<option value="" selected="Selected">Seleccionar</option>
												<?php
													$buscar="select * from profesion where estado=1 order by descripcion asc";
													$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
													while (!$rs->EOF){
												?>
													<option value="<?php echo $rs->fields['profesion'] ?>"
													
													<?php if ($rsl->fields['profesion']==$rs->fields['profesion'] ){ echo "selected='selected'"; } ?>
													><?php echo $rs->fields['descripcion'] ?></option>
												<?php 
													$rs->MoveNext();}

												?>
											</select>             
									</div>
								</div>
						  <div class="col-md-6 col-sm-6 form-group">
									<label class="control-label col-md-3 col-sm-3 col-xs-12">Estado Civil </label>
									<div class="col-md-9 col-sm-9 col-xs-12">
									            <select name="estcivil" id="estcivil" style="width:100%;height:40px;"  required="required">
												<option value="" selected="Selected">Seleccionar</option>
												<?php
													$buscar="select * from gest_estado_civil where estado=1 order by descripcion asc";
													$rs=$conexion->Execute($buscar) or die(errorpg($conexion,$buscar));
													while (!$rs->EOF){
												?>
													<option value="<?php echo $rs->fields['idestado'] ?>"
													<?php  if ($rsl->fields['estado_civil']==$rs->fields['idestado']){ echo "selected='selected'"; } else { if($rsl->fields['estado_civil']==$estado_civil){ echo $estado_civil; }} ?>
													><?php echo $rs->fields['descripcion'] ?></option>
												<?php 
													$rs->MoveNext();}

												?>
											</select>             
									</div>
								</div>
								 	<div class="form-group">
											<div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-5">
											<input type="hidden" name="ocsolinum" id="ocsolinum" value="<?php echo $nrosoli; ?>" />
										   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Guardar cabecera Solicitud</button>

										  
											</div>
										</div>
								<div class="clearfix"></div>
						  </div>
					</div>
				  </div>
				</div>
            <!-- SECCION --> 
			     </form>
				 <form id="th1" action="solicitudes_add.php" method="post">
			  <!-- SECCION -->
				<div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel collapsed">
					  <div class="x_title">
						<h2>Datos Adicionales</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-down"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
					  <div class="x_content" style="display: none">
								<div class="col-md-6 col-sm-6">
									C&oacute;nyuge
									<br />
									<div id="soliconyu">
									<?php require_once("solicitudes_conyuge.php"); ?>
									</div>
									<div id="soliconyres">
												
									</div>
								</div>
								<div class="col-md-6 col-sm-6">
									Garante
									<br />
									<div id="soligarante">
									<?php require_once("solicitudes_garante.php"); ?>
									</div>
									<div id="garanteres">

									</div>
								</div>
						 </div>
					</div>
				  </div>
				</div>  
			   
			  <!-- SECCION -->
				<div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel collapsed">
					  <div class="x_title">
						<h2>Datos Laborales / Monetarios</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-down"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
					  <div class="x_content" style="display: none">
								<div class="col-md-6 col-sm-6">
									Referencias Laborales
									<br />
									<div id="solihtmlreflabo">
									<?php require_once("solicitudes_referencias_laborales.php"); ?>
									</div>
									<div id="reflaboregn">
												
									</div>
								</div>
								<div class="col-md-6 col-sm-6">
									Ingresos / Otros
									<br />
									<div id="solihtmlrefotros">
									<?php require_once("solicitudes_referencias_otros.php"); ?>
									</div>
									<div id="refotrosreg">

									</div>
								</div>
						 </div>
					</div>
				  </div>
				</div>  
			   
			   
			   
			   
			   
			   
             <!-- SECCION -->
				<div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel collapsed">
					  <div class="x_title">
						<h2>Datos Complementarios</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-down"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
					  <div class="x_content" style="display: none">
								<div class="col-md-6 col-sm-6">
									Referencias Personales
									<br />
									<div id="solihtmlrefpe">
									<?php require_once("solicitudes_referencias_personales.php"); ?>
									</div>
									<div id="refpersoreg">

									</div>
								</div>
								<div class="col-md-6 col-sm-6">
									Referencias Comerciales
									<br />
									<?php require_once("solicitudes_referencias_comerciales.php"); ?>
									<div id="refcomereg">

									</div>
								</div>
						 </div>
					</div>
				  </div>
				</div>
				<div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel collapsed">
					  <div class="x_title">
						<h2>&Uacute;ltimas referencias registradas</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-down"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
					  <div class="x_content" style="display: none">
						  <div class="col-md-6 col-sm-6">
									 Laborales

									<div id="reflabolista">
									<?php require_once("soli_refe_labo_lista.php");?>
									</div>
						  </div>
						<div class="col-md-3 col-sm-3" style="overflow-x:scroll;">
							Datos Ingresos / Egresos

							<div id="refingresolista" style="overflow-y:scroll;">
							<?php require_once("soli_refe_labo_otros.php");?>
							</div>
						</div>
						  <div class="col-md-3 col-sm-3" id="balance" style="overflow-y:scroll;">
							<?php require_once("soli_mini_balance.php");?>
						  
						  </div>
						  <div class="row"></div>
								<div class="col-md-6 col-sm-6">
									 Personales

									<div id="refpersoregl">
									<?php require_once("soli_refe_perso_lista.php");?>
									</div>
								</div>
								<div class="col-md-6 col-sm-6">
									Comerciales

									<div id="refcomeregl">
										<?php require_once("soli_refe_comer_lista.php");?>
									</div>
								</div>
						 </div>
					</div>
				  </div>
				</div>
			  	
			   <!------------------------------->
			    <div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel">
					  <div class="x_title">
						<h2>Observaciones adicionales de direcci&oacute;n</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
						</ul>
						<div class="clearfix"></div>
					   </div>
						  <div class="x_content">
									
							<div class="col-md-12 col-sm-12 form-group" >
								
								<div class="col-md-12 col-sm-12 col-xs-12"><textarea name="obsdire" id="obsdire"  class="form-control"></textarea>                          
								</div>
							</div>

						  </div>
						</div>
					  </div>
				</div>
	
			  <div class="row">
				  <div class="col-md-12 col-sm-12 col-xs-12">
					<div class="x_panel">
					  <div class="x_title">
						<h2>Datos Monetarios Finales</h2>
						<ul class="nav navbar-right panel_toolbox">
						  <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
						  </li>
						</ul>
						<div class="clearfix"></div>
					  </div>
						  <div class="x_content">
									<div class="col-md-6 col-sm-6 form-group" >
										<label class="control-label col-md-3 col-sm-3 col-xs-12">Monto Solicitado </label>
										<div class="col-md-9 col-sm-9 col-xs-12"><input type="text" name="montosoli" id="montosoli" class="form-control" required="required" value="<?php echo $total ?>" />       

										</div>
									</div>


									<div class="col-md-6 col-sm-6 form-group" >
										<label class="control-label col-md-3 col-sm-3 col-xs-12"> Plazo Solicitado </label>
										<div class="col-md-9 col-sm-9 col-xs-12"><input type="text" name="plazosoli" id="plazosoli"  class="form-control" required="required" value="<?php echo $plazo ?>"  />                          
										</div>
									</div>

									<div class="form-group">
											<div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-5">
											<input type="hidden" name="ocsolinum" id="ocsolinum" value="<?php echo $nrosoli; ?>" />
										   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Registrar Solicitud</button>

										   <button type="button" class="btn btn-primary" onMouseUp="document.location.href='solicitudes.php'"><span class="fa fa-ban"></span> Cancelar</button>
											</div>
										</div>



						  </div>
						</div>
					  </div>
				</div>
		   </form>   
          </div>
        </div >
		  
		  
		  
		  <!------------------------------------------->
			  
			  
			  
			  
			  
          </div>
        </div>
		
		  <div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="pop" style="min-height: 150px;">
                    <div class="modal-dialog modal-lg">
                      <div class="modal-content">

                        <div class="modal-header">
                          <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span>
                          </button>
                          <h4 class="modal-title" id="poptitulo">Titulo</h4>
                        </div>
                        <div class="modal-body" id="popcuerpo">
						...
                        </div>
                        <div class="modal-footer">
                          <button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
                          
                        </div>

                      </div>
                    </div>
                  </div>
        <!-- /page content -->
	</form>
		<script>
		function registrar_tipos_parientes_abre(){
			$("#poptitulo").html("Tipos Parentezco");
				var parametros={
						"clase" : 1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_pariente.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
					}
				});
				$("#pop").modal("show");
			
			
			
		}
			function registrar_tipos_ing_abre(){
				$("#poptitulo").html("Nuevos tipos de ingreso");
				var parametros={
						"clase" : 1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
					}
				});
				$("#pop").modal("show");
			}
			function registrar_tipos_egre_abre(){
				$("#poptitulo").html("Nuevos tipos de egreso");
				var parametros={
						"clase" : 1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_egre.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
					}
				});
				$("#pop").modal("show");
				
			}
			function regd(identificador){
				var parametros={
						"clase" : 1,
						"identificador" : identificador
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						recargar_tipos();
					}
				});
				
				
			}
			function regdeg(identificador){
				var parametros={
						"clase" : 1,
						"identificador" : identificador
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_egre.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						refrescarvalor(5);
					}
				});
				
				
			}
			/*---------PARIENES--------------*/
			function regdpar(identificador){
				var parametros={
						"clase" : 1,
						"identificador" : identificador
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_pariente.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						refrescarvalor(3);
					}
				});
				
				
			}
			function registrarvalor(){
				//registra nuevo tipo
				var valor=$("#describetxt").val();
				var parametros={
						"clase" : 1,
						"valor" : valor,
						"agregar"	:1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						recargar_tipos();
					}
				});
				
				
			}
			function registrarvalorp(){
				var valor=$("#describetxtp").val();
				var parametros={
						"clase" : 1,
						"valor" : valor,
						"agregar"	:1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_pariente.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						refrescarvalor(3);
					}
				});
				
				
			}
			function registrarvaloreg(){
				var valor=$("#describetxtn").val();
				var parametros={
						"clase" : 1,
						"valor" : valor,
						"agregar"	:1
				};
				$.ajax({
					data:  parametros,
					url:   'soli_add_ntipo_egre.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#popcuerpo").html(response);	
						refrescarvalor(5);
					}
				});
				
				
			}
			/*--------------------------PARA REFRESH------------*/
			function refrescarvalor(cual,idsoli){
				var donde='';var url='';
				if (cual==3){
					url="listaparientes.php";
					donde="minipariente";
				}
				if (cual==5){
					
					url="solicitudes_referencias_otros.php";
					donde="solihtmlrefotros";
				}
				var parametros={
						"solicitud" : idsoli
				};
				$.ajax({
					data:  parametros,
					url:   url,
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {
						$("#"+donde).html(response);	
					}
				});
				
				
			}
			/*--------------------------PARA REFRESH------------*/
			function registra_ref_otros(solicitud){
				var ingre='';
				var egre='';
				var tipoprop='';
				var datos='';
				var tipovehi='';
				var obsot='';
				var obsvehi='';
				
				var claserefe=$("#claserefe").val();
				
				ingre=$("#ingresos").val();
				egre=$("#egresos").val();
				tipoprop=$("#ltipoprop").val();
				datos=$("#dprop").val();
				tipovehi=$("#ltipove").val();
				obsot=$("#obsingre").val();
				obsvehi=$("#obsdatosvehi").val();
				var parametros={
						"ingreso"			:ingre,
						"egreso"			:egre,
						"tipopropiedad"		:tipoprop,
						"datos"				:datos,
						"tipovehiculo"	    :tipovehi,
						"obs"			    :obsot,
						"clasereferencia"	: claserefe,
						"solicitud"	    	:solicitud,
						"datosvehiculo"		: obsvehi,
						"tiporeg"				:4

				};
				$.ajax({
					data:  parametros,
					url:   'soli_refe_registro.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#refotrosreg").html(response);
						//alert(response);
						if (response!='error'){
							$("#ingresos").val("");
							$("#egresos").val("");
							$("#ltipoprop").val("");
							$("#dprop").val("");
							$("#ltipove").val("");
							$("#obsingre").val("");
							$("#obsdatosvehi").val("");
							refrescar_vista(2,solicitud);
							setTimeout(function(){refrescar_vista(3,solicitud); }, 1000);
						}
					}
				});
				
			}
			function refrescar_vista(cual,solicitud){
			
				if (cual==2){
					var parametros={	
						"solicitud" : solicitud
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_labo_otros.php',
						type:  'post',
						beforeSend: function () {
							$("#refingresolista").html("RECARGANDO");
						},
						success:  function (response) {

							$("#refingresolista").html(response);

						}
					});
					
				}
				if (cual==3){
					var parametros={	
						"solicitud" : solicitud
					};
					$.ajax({
						data:  parametros,
						url:   'soli_mini_balance.php',
						type:  'post',
						beforeSend: function () {
							$("#balance").html("RECARGANDO");
						},
						success:  function (response) {

							$("#balance").html(response);

						}
					});
					
				}
				
			}
			function recargar_tipos(){
				var parametros={	
				};
				$.ajax({
					data:  parametros,
					url:   'solicitudes_referencias_otros.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#solihtmlrefotros").html(response);

					}
				});
				
				
			}
			function recargar_otros(solicitud){
				var parametros={
					"solicitud"	    	:solicitud
				};
				$.ajax({
					data:  parametros,
					url:   'soli_refe_labo_otros.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#refingresolista").html(response);
						
					}
				});
				
				
			}
			
			
			
			

			
			function registra_ref_laboral(solicitud){
				var empre="";
				var clase="";
				var tipo="";
				var cargo="";
				var ant="";
				var tel="";
				var tel2="";
				var tipoanti="";
				var obsoper="";
				var solicitud=<?php echo $nrosoli ?>;
				empre=$("#nempre").val();
				clase=$("#claserefe").val();
				//tipo=$("#ltipore").val();
				cargo=$("#cargoe").val();
				ant=$("#antiguedadlabo").val();
				tel=$("#telfoe").val();
				tel2=$("#telfoe2").val();
				tipoanti=$("#ltipoa").val();
				obsoper=$("#obs").val();
				var parametros={
						"empresal"			:empre,
						"claseref"			:clase,
						"cargoempresa"		:cargo,
						"antiguedad"	    :ant,
						"telefono"			:tel,
						"telefono2"			:tel2,
						"tipoantiguedad"	:tipoanti,
						"obsreflabo"		: obsoper,
						"solicitud"	    	:solicitud,
						"tiporeg"				:3

				};
				$.ajax({
					data:  parametros,
					url:   'soli_refe_registro.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#reflaboregn").html(response);
						if (response!='error'){
							recargar_laborales(solicitud);
								$("#nempre").val("");
								//$("#claserefe").val("");
						
								$("#cargoe").val("");
								$("#antiguedadlabo").val("");
								$("#telfoe").val("");
								$("#telfoe2").val("");
								$("#ltipoa").val("");
								$("#obs").html("");
								$("#ltipore").val("");
							
							
							
							
						}
					}
				});
				
				
				
				
			}
			
			function recargar_laborales(solicitud){
				
				var parametros={
						"solicitud"	: solicitud
				};
				$.ajax({
					data:  parametros,
					url:   'soli_refe_labo_lista.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#reflabolista").html(response);
						if (response!='error'){
							
						}
					}
				});
				
			}
			
			function registra_ref_comer(numsoli){
					var idempre="";
					var persona="";
					var numconta="";
					var tipooper="";
					var plaoper="";
					var montooper="";
					var obsoper="";
					
					idempre=$("#empresal").val();
					persona=$("#contacto").val();
					numconta=$("#telfo").val();
					tipooper=$("#tipooper").val();
					plaoper=$("#plazoop").val();
					montooper=$("#mcuo").val();
					obsoper=$("#obsrc").val();
					var parametros={
							"tiporeg"			:2,
							"accion"		:1,
							"idempresalis"	:idempre,
							"persona"		:persona,
							"numconta"	    :numconta,
							"tipoop"		:tipooper,
							"plaoper"		:plaoper,
							"obsoper"		: obsoper,
							"montooper"		:montooper,
							"solicitud"	    :numsoli
							
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_registro.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#refcomereg").html(response);
							if (response!='error'){
								
								
								$("#empresal").val("");
								$("#contacto").val("");
								$("#telfo").val("");
								$("#tipooper").val("");
								$("#plazoop").val("");
								$("#mcuo").val("");
								$("#obsrc").val("");
								
								recargar_comerciales(numsoli);
								
								
								
							}
						}
					});
				
				
			}
			function recargar_comerciales(soli){
				var parametros={
							"solicitud"			:soli
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_comer_lista.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#refcomeregl").html(response);
							
						}
					});
				
				
			}
			function eliminarfcomer(soli,idunico){
				var parametros={
							"solicitud"			:soli,
							"eliminar"		:idunico
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_comer_lista.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#refcomeregl").html(response);
							
						}
					});
				
			}
			function eliminarefperso(soli,idunico){
				var parametros={
							"solicitud"			:soli,
							"eliminar"		:idunico
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_perso_lista.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#refpersoregl").html(response);
							
						}
					});
				
			}
			function eliminareflabo(idunico){
				var parametros={
							
							"eliminar"		:idunico
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_labo_lista.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#reflabolista").html(response);
							
						}
					});
				
			}
			function eliminarefot(soli,idunico){
				var parametros={
							"solicitud"			: soli,
							"eliminar"		:idunico
					};
					$.ajax({
						data:  parametros,
						url:   'soli_refe_labo_otros.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#refingresolista").html(response);
							setTimeout(function(){refrescar_vista(3,soli); }, 1000);
						}
					});
				
			}
			function registrar_tipos_operaciones_abre(){
				$("#poptitulo").html("Registrar tipos de operaciones");
				var parametros="";
				$.ajax({
					data:  parametros,
					url:   'solicitudes_toperaciones_add.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#popcuerpo").html(response);
						$("#pop").modal("show");

					}
				});
				
			}
			function registrar_tipos_operaciones_add(){
				var tipooperacion=$("#tipoopera").val();
				var parametros={
						"tipo"			:tipooperacion,
						"accion"		:1
						
				};
				$.ajax({
					data:  parametros,
					url:   'solicitudes_toperaciones_add.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#popcuerpo").html(response);
						//alert(response);
						//$("#pop").modal("hide");
						
						if (response!='error'){
							$("#pop").modal("hide");
							recargar_toper(response);
						}
					}
				});
			
			}
			function recargar_toper(valor){
				
				
				var parametros={
					"tipo"	:valor
				};
				$.ajax({
					data:  parametros,
					url:   'solicitudes_tipos_operaciones.php',
					type:  'post',
					beforeSend: function () {
							$("#tipooperlista").html("");
					},
					success:  function (response) {

						$("#tipooperlista").html(response);
						
					}
				});
			}
			function eliminartoper(idreg){
				var parametros={
					"chau"	:idreg
				};
				$.ajax({
					data:  parametros,
					url:   'solicitudes_tipos_operaciones.php',
					type:  'post',
					beforeSend: function () {
							$("#tipooperlista").html("");
					},
					success:  function (response) {

						$("#tipooperlista").html(response);
						$("#pop").modal("hide");
						
					}
				});
				
				
				
			}
			function registrar_empresas_abre(){
				$("#poptitulo").html("Registrar entidad");
				var parametros="";
				$.ajax({
					data:  parametros,
					url:   'solicitudes_empresas_add.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#popcuerpo").html(response);
						$("#pop").modal("show");

					}
				});

			}
			function registrar_empresas(){
				var empresa="";
				var telefono="";
				var errores="";
				empresa=$("#nombreemp").val();
				telefono=$("#telfoempre").val();
				
				if (empresa==""){
					errores="Debe indicar nombre de empresa";
				}
				if (telefono==""){
					errores="Debe indicar numero telefonico";
				}
				if (errores==""){
				
					//$("#poptitulo").html("Registrar entidad");
					$("#popcuerpo").html("");
								
				
					var parametros={
							"accion"			:1,
							"empresa"			: empresa,
							"telefono"			: telefono
					};
					$.ajax({
						data:  parametros,
						url:   'solicitudes_empresas_add.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#popcuerpo").html(response);
							if (response!='error'){
								$("#pop").modal("hide");
								recargar_entidades(response);
							}
						}
					});
				} else {
					alert(errores);
				}
			}
			function recargar_entidades(valor){
				var parametros={
							"entidad"			:valor
					};
					$.ajax({
						data:  parametros,
						url:   'solicitudes_empresas_lista.php',
						type:  'post',
						beforeSend: function () {

						},
						success:  function (response) {

							$("#listaempresas").html(response);
							
						}
					});
			}
			function cambio(valor){
				if (valor==2){
					//no es documento trad, es un ruc
					$("#conjunto01").hide();
					$("#rzarea").show();
				} else {
					
					$("#conjunto01").show();
					$("#rzarea").hide();
				}
				
			}
		function editarefperso(soli,referencia,accion){
			var parametros = {
				"solicitud" 		:soli,
			     "accion"			:accion,
				"refper"			: referencia
					
 			};
			$.ajax({
				data:  parametros,
				url:   'solicitudes_referencias_personales.php',
				type:  'post',
				beforeSend: function () {

				},
				success:  function (response) {

					$("#solihtmlrefpe").html(response);
					//alert(response);
					if (accion==2){
						limpiar(1,soli);
					}
					//$("#variadomod").modal('show');

				}
			});
			
			
			
		}
		function refperso(solinum){
			var errores="";
			var nombres=$("#nombresr").val();
			var apellidos=$("#apellidosr").val();
			var tipodocu=$("#tipodocur").val();
			var documento=$("#docur").val();
			var direccionpart=$("#direccionpartr").val();
			var celular=$("#celularr").val();
			var obs=$("#obsperso").val();
			var parentezco=$("#parentezcor").val();
			var errores='';
			if (nombres==''){
				errores=errores+"Debe indicar nombre de la referencia \n";
			}
			if (apellidos==''){
				errores=errores+"Debe indicar apellido de la referencia \n";
			}
			if (parentezco==''){
				errores=errores+"Debe indicar tipo de parentezco de la referencia \n";
				
			}
			if (errores==''){
				var parametros = {
					"solicitud" 		:solinum,
					 "nombres"			:nombres,
						"apellidos"		:apellidos,
						"tipodocu"		:tipodocu,
						"documento"		: documento,
						"direccion"		: direccionpart,
						"celular"	    : celular,
						"obs"		    : obs,
						"tiporeg"			:1,
						"parentezco"    : parentezco
				};
				$.ajax({
					data:  parametros,
					url:   'soli_refe_registro.php',
					type:  'post',
					beforeSend: function () {

					},
					success:  function (response) {

						$("#refpersoreg").html(response);
						//alert(response);
						if (response==1){
							limpiar(1,solinum);
						}
						//$("#variadomod").modal('show');

					}
				});
			} else {
				alert(errores);
				
			}
				
		}
		function refpersoedita(solinum,idrefperso){
			var errores="";
			var nombres=$("#nombresr").val();
			var apellidos=$("#apellidosr").val();
			var tipodocu=$("#tipodocur").val();
			var documento=$("#docur").val();
			var direccionpart=$("#direccionpartr").val();
			var celular=$("#celularr").val();
			var obs=$("#obsperso").val();
			var parentezco=$("#parentezcor").val();
			
			var parametros = {
				"solicitud" 		:solinum,
			     "nombres"			:nombres,
					"apellidos"		:apellidos,
					"tipodocu"		:tipodocu,
					"documento"		: documento,
					"direccion"		: direccionpart,
					"celular"	    : celular,
					"obs"		    : obs,
					"tiporeg"			:1,
					"parentezco"    : parentezco,
					"idrefperso"	: idrefperso,
					"tiporeg"		: 1,
					"tipoenvio"		:2
 			};
			$.ajax({
				data:  parametros,
				url:   'soli_refe_registro.php',
				type:  'post',
				beforeSend: function () {

				},
				success:  function (response) {

					$("#refpersoreg").html(response);
					//alert(response);
					if (response==1){
						limpiar(1,solinum);
					}
					//$("#variadomod").modal('show');

				}
			});
				
		}
		function limpiar(cual,soli){
			if (cual==1){
				$("#nombresr").val("");
				$("#apellidosr").val("");
				$("#tipodocur").val("");
				$("#docur").val("");
				$("#direccionpartr").val("");
				$("#celularr").val("");
				$("#obsperso").val("");
				$("#parentezcor").val("");
				referencias(soli);
			}
		}
		function referencias(soli){
			var parametros = {
				"solicitud" 		:soli
 			};
			$.ajax({
				data:  parametros,
				url:   'soli_refe_perso_lista.php',
				type:  'post',
				beforeSend: function () {

				},
				success:  function (response) {

					$("#refpersoregl").html(response);
					
				}
			});
			
		}
		</script>
	
	
	
        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
