<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="25";
$submodulo="226";
require_once("includes/rsusuario.php"); 

set_time_limit(120);

$muestrademo="N";
if($muestrademo != 'S'){
	
	$whereadd=" and ventas_franq.idfranquicia not in (select idfranquicia from franquicia where franquicia.demo is not null) ";	
}

$ano_actual = date("Y");
$ano = date("Y");
$mes_actu = date("m");

if ($ano == $ano_actual) {
    $meses_add = [];
    for ($i = 1; $i <= $mes_actu; $i++) {
        if ($i == 1) {
            $meses_add[] = "SELECT $i AS mes";
        } else {
            $meses_add[] = "SELECT $i";
        }
    }
    $meses_mov = implode(" UNION ALL ", $meses_add);
} else {
    $meses_mov = "
    SELECT 1 AS mes UNION ALL
    SELECT 2 UNION ALL
    SELECT 3 UNION ALL
    SELECT 4 UNION ALL
    SELECT 5 UNION ALL
    SELECT 6 UNION ALL
    SELECT 7 UNION ALL
    SELECT 8 UNION ALL
    SELECT 9 UNION ALL
    SELECT 10 UNION ALL
    SELECT 11 UNION ALL
    SELECT 12
    ";
}

//echo $meses_mov;


$consulta="
-- Paso 1: Generar una lista de meses para el año 2024 y combinarlos con la lista de franquicias
WITH Months AS (
	$meses_mov
),
Franchises AS (
    SELECT franquicia.idfranquicia, franquicia.nombre_franquicia
    FROM ventas_franq
	inner join franquicia on franquicia.idfranquicia = ventas_franq.idfranquicia
    WHERE
    ventas_franq.estado <> 6
    and YEAR(ventas_franq.fechasola) = $ano
	group by franquicia.idfranquicia, franquicia.nombre_franquicia
)
-- Paso 2: Crear todas las combinaciones posibles de franquicias y meses
, FranchiseMonths AS (
    SELECT f.idfranquicia, f.nombre_franquicia, m.mes, $ano AS ano
    FROM Franchises f
    CROSS JOIN Months m
)
-- Paso 3: Hacer LEFT JOIN con la tabla de ventas para obtener las ventas
SELECT 
    fm.ano,
    fm.mes,
    fm.idfranquicia,
	fm.nombre_franquicia,
    COALESCE(COUNT(vf.idventa), 0) AS total_cantidad,
    COALESCE(SUM(vf.total_venta), 0) AS total_venta
FROM 
    FranchiseMonths fm
LEFT JOIN 
    ventas_franq vf
    ON fm.idfranquicia = vf.idfranquicia
    AND fm.ano = YEAR(vf.fechasola)
    AND fm.mes = MONTH(vf.fechasola)
    AND vf.estado <> 6
WHERE 
    fm.ano = $ano
GROUP BY 
    fm.ano, fm.mes, fm.idfranquicia
ORDER BY 
    fm.nombre_franquicia ASC, fm.ano ASC, fm.mes ASC;
";
//echo  $consulta;exit;
$rs = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));



$franchise_sales = [];

if (intval($rs->fields['idfranquicia']) > 0) {
    while (!$rs->EOF) {
        $idfranquicia = $rs->fields['idfranquicia'];
        $nombre_franquicia = $rs->fields['nombre_franquicia'];
        $mes_venta = $rs->fields['mes'];
        $total_venta = $rs->fields['total_venta'];
        $total_cantidad = $rs->fields['total_cantidad'];
        
        if (!isset($franchise_sales[$idfranquicia])) {
            $franchise_sales[$idfranquicia] = [
                'nombre' => $nombre_franquicia,
                'ventas' => []
            ];
        }
        $franchise_sales[$idfranquicia]['ventas'][$mes_venta] = floatval($total_venta);
        $rs->MoveNext();
    }
}
//print_r($franchise_sales);exit;


?><!DOCTYPE html>
<html lang="en">
  <head>
	<?php require_once("includes/head_gen.php"); ?>
  </head>

  <body class="nav-md">
    <div class="container body">
      <div class="main_container">
        <?php require_once("includes/menu_gen.php"); ?>

        <!-- top navigation -->
       <?php require_once("includes/menu_top_gen.php"); ?>
        <!-- /top navigation -->

        <!-- page content -->
        <div class="right_col" role="main">
          <div class="">
            <div class="page-title">
            </div>

            <div class="clearfix"></div>
			
            
            
            <!-- SECCION -->
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="x_panel">
                  <div class="x_title">
                    <h2>Ventas por Franquicia</h2>
                    <ul class="nav navbar-right panel_toolbox">
                      <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                      </li>
                    </ul>
                    <div class="clearfix"></div>
                  </div>
                  <div class="x_content">
<?php 
$menu="evol";
require("includes/menu_rep_franq.php"); ?>
<br /><hr /><br />
<form id="form1" name="form1" method="get" action="">

<div class="col-md-6 col-sm-6 form-group">
	<label class="control-label col-md-3 col-sm-3 col-xs-12">A&ntilde;o *</label>
	<div class="col-md-9 col-sm-9 col-xs-12">
	<input type="numeric" name="ano" id="ano" value="<?php  echo $ano; ?>" placeholder="Ano" class="form-control  has-feedback-left" required />                    
    <span class="fa fa-calendar-o form-control-feedback left" aria-hidden="true"></span>
	</div>
</div>



<div class="clearfix"></div>
<br />

    <div class="form-group">
        <div class="col-md-3 col-sm-3 col-xs-12 col-md-offset-3">
	   <button type="submit" class="btn btn-success" ><span class="fa fa-check-square-o"></span> Filtrar</button>
        </div>
    </div>


<br />
</form>        
  <hr /><br />


<div class="table-responsive">
    <table width="100%" class="table table-bordered jambo_table bulk_action">
        <thead>
            <tr>
                <th>Franquicia</th>
                <th>Enero</th>
                <th>Febrero</th>
                <th>Marzo</th>
                <th>Abril</th>
                <th>Mayo</th>
                <th>Junio</th>
                <th>Julio</th>
                <th>Agosto</th>
                <th>Septiembre</th>
                <th>Octubre</th>
                <th>Noviembre</th>
                <th>Diciembre</th>
            </tr>
        </thead>
        <tbody>
            <?php 
            $total_venta_mes = array_fill(1, 12, 0); // Inicializar el array para los totales mensuales
            
			$i=0;
            foreach ($franchise_sales as $idfranquicia => $data) : ?>
                <tr>
                    <td><?php echo antixss($data['nombre']); ?> [<?php echo antixss($idfranquicia); ?>]</td>
                    <?php for ($month = 1; $month <= 12; $month++) : ?>
                        <td align="right">
                            <?php 
                            $venta = isset($data['ventas'][$month]) ? floatval($data['ventas'][$month]) : 0;
                            echo formatomoneda($venta);
                            $total_venta_mes[$month] += $venta;
                            ?>
                        </td>
                    <?php endfor; ?>
                </tr>
            <?php 
			$i++;
			endforeach; ?>
        </tbody>
        <tfoot>
            <tr>
                <td>Totales</td>
                <?php for ($month = 1; $month <= 12; $month++) : ?>
                    <td align="right"><?php echo formatomoneda($total_venta_mes[$month]); ?></td>
                <?php endfor; ?>
            </tr>
        </tfoot>
    </table>
</div>
<br />

<p align="left">Total Franquicias: <?php echo formatomoneda($i,2,'N'); ?></p>
<br /><br /><br /><br />



                  </div>
                </div>
              </div>
            </div>
            <!-- SECCION --> 
            
            
            
            
          </div>
        </div>
        <!-- /page content -->

        <!-- footer content -->
		<?php require_once("includes/pie_gen.php"); ?>
        <!-- /footer content -->
      </div>
    </div>
<?php require_once("includes/footer_gen.php"); ?>
  </body>
</html>
