<?php
ini_set('display_errors', '1');
ini_set('display_startup_errors', '1');
error_reporting(E_ALL);
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "660";
require_once("../includes/rsusuario.php");

$fecha_desde = '';
$fecha_hasta = '';
$date_condition = '';

// Filtro fecha
// consulta a la tabla	
if (!empty($_REQUEST['desde']) || !empty($_REQUEST['hasta'])) {

    if (!empty($_REQUEST['desde'])) {

        $fecha_desde = antisqlinyeccion($_REQUEST['desde'], 'date');
        $date_condition .= "date(tvc.fechahora) >= $fecha_desde";
    }

    if (!empty($_REQUEST['hasta'])) {

        $fecha_hasta = antisqlinyeccion($_REQUEST['hasta'], 'date');
        $date_condition .= ($date_condition ? " AND " : "") . "date(tvc.fechahora) <= $fecha_hasta";
    }
} else {

    $date_condition = "YEAR(tvc.fechahora) = YEAR(now())";
}

$consulta = "SELECT 
                tvc.*,
                s.nombre as sucursal,
                CONCAT(u.nombres, ' ', u.apellidos) as usuario
            FROM 
                tmp_ventares_cab tvc
            INNER JOIN 
                sucursales s on s.idsucu = tvc.idsucursal 
            INNER JOIN 
                usuarios u on u.idusu = tvc.idusu
            INNER JOIN 
                tmp_ventares tv on tv.idtmpventares_cab = tvc.idtmpventares_cab    
            WHERE
                $date_condition 
                and tv.idproducto = 197
            ORDER BY 
                idtmpventares_cab desc";

$rs = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
$tr = $rs->RecordCount();
$idtmpventares_cab = intval($rs->fields['idtmpventares_cab']);
?>

<!DOCTYPE html>

<head>
    <?php require_once("../includes/head_gen.php"); ?>
    <!-- Script -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>

<body class="nav-md">
    <div class="container body">
        <div class="main_container">
            <?php require_once("../includes/menu_gen.php"); ?>

            <!-- top navigation -->
            <?php require_once("../includes/menu_top_gen.php"); ?>
            <!-- /top navigation -->

            <!-- page content -->
            <div class="right_col" role="main">
                <div class="">
                    <div class="page-title">
                    </div>
                    <div class="clearfix"></div>
                    <?php require_once("../includes/lic_gen.php"); ?>

                    <!-- SECCION -->
                    <!-- Filtro -->
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="x_panel">
                                <div class="x_title">
                                    <h2></h2>
                                    <ul class="nav navbar-right panel_toolbox">
                                        <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                                        </li>
                                    </ul>
                                    <div class="clearfix"></div>
                                </div>
                                <div class="x_content">
                                    <form id="hg" action="" method="get">

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Desde Fecha</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="date" name="desde" id="desde" class="form-control" value="<?php echo $_REQUEST['desde'] ?>" />
                                            </div>
                                        </div>

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Hasta Fecha</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="date" name="hasta" id="hasta" class="form-control" value="<?php echo $_REQUEST['hasta'] ?>" />
                                            </div>
                                        </div>

                                        <div class="clearfix"></div>
                                        <br />

                                        <div class="form-group">
                                            <div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
                                                <button type="submit" class="btn btn-default"><span class="fa fa-search"></span> Filtrar</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>

                    <!-- Tabla -->
                    <?php if ($tr > 0) { ?>
                        <div class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel">
                                    <div class="x_title">
                                        <h2>Cobros encontrado(s): <?php echo $tr ?></h2>
                                        <ul class="nav navbar-right panel_toolbox">
                                            <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                                            </li>
                                        </ul>
                                        <div class="clearfix"></div>
                                    </div>
                                    <div class="x_content">
                                        <div class="table-responsive">
                                            <table width="100%" class="table table-bordered jambo_table bulk_action">
                                                <thead>
                                                    <tr>
                                                        <th></th>
                                                        <th align="center">Idtmpventares cab</th>
                                                        <th align="center">Razon social</th>
                                                        <th align="center">Ruc</th>
                                                        <th align="center">Monto</th>
                                                        <!-- <th align="center">Idusu</th> -->
                                                        <th align="center">Fechahora</th>
                                                        <th align="center">Sucursal</th>
                                                        <!-- <th align="center">Idempresa</th> -->
                                                        <th align="center">Idventa</th>
                                                        <th align="center">Estado</th>
                                                        <th align="center">Anulado por</th>
                                                        <th align="center">Anulado el</th>
                                                        <!-- <th align="center">Impreso</th> -->
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <?php while (!$rs->EOF) { ?>
                                                        <tr>
                                                            <td>
                                                                <div class="btn-group">
                                                                    <button class="openModalBtn" data-id="<?php echo $rs->fields['idventa']; ?>" data-idtmp="<?php echo $rs->fields['idtmpventares_cab']; ?>"><span class="fa fa-trash-o"></button>
                                                                </div>
                                                            </td>
                                                            <td align="center"><?php echo intval($rs->fields['idtmpventares_cab']); ?></td>
                                                            <td align="center"><?php echo antixss($rs->fields['razon_social']); ?></td>
                                                            <td align="center"><?php echo antixss($rs->fields['ruc']); ?></td>
                                                            <td align="right"><?php echo formatomoneda($rs->fields['monto']);  ?></td>
                                                            <!-- <td align="center"><?php //echo intval($rs->fields['idusu']); ?></td> -->
                                                            <td align="center"><?php if ($rs->fields['fechahora'] != "") {
                                                                                    echo date("d/m/Y H:i:s", strtotime($rs->fields['fechahora']));
                                                                                }  ?></td>
                                                            <td align="center"><?php echo trim($rs->fields['sucursal']); ?></td>
                                                            <!-- <td align="center"><?php //echo intval($rs->fields['idempresa']); ?></td> -->
                                                            <td align="center"><?php echo intval($rs->fields['idventa']); ?></td>
                                                            <td align="center"><?php echo intval($rs->fields['estado']); ?></td>
                                                            <td align="center"><?php echo trim($rs->fields['usuario']); ?></td>
                                                            <td align="center"><?php if ($rs->fields['anulado_el'] != "") {
                                                                                    echo date("d/m/Y H:i:s", strtotime($rs->fields['anulado_el']));
                                                                                }  ?></td>
                                                        </tr>
                                                    <?php
                                                        $monto_acum += $rs->fields['monto'];

                                                        $rs->MoveNext();
                                                    }
                                                    ?>
                                                </tbody>
                                                <tfoot>
                                                    <tr>
                                                        <td>Totales</td>
                                                        <td></td>
                                                        <td></td>
                                                        <td></td>
                                                        <td align="center"><?php echo formatomoneda($monto_acum); ?></td>
                                                        <td></td>
                                                        <td></td>
                                                        <td></td>
                                                        <td></td>
                                                        <td></td>
                                                    </tr>
                                                </tfoot>
                                            </table>
                                        </div>
                                        <br />
                                    </div>
                                </div>
                            </div>
                        </div>
                </div>
            <?php } ?>

            <!-- Popup anular cobro -->
            <div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_anular_cobro">
                <div class="modal-dialog modal-lg">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
                            <h4 class="modal-title" id="modal_titulo">Anular Cobro</h4>
                        </div>
                        <div class="modal-body" id="modal_cuerpo">
                            <p>Desea anular el cobro?</p>
                            <div id="message-container"></div>
                        </div>
                        <div class="modal-footer" id="modal_pie">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                            <button type="button" class="btn btn-primary" id="anularCobroBtn">Aceptar</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- /footer content -->
            <?php require_once("../includes/pie_gen.php"); ?>
            </div>
        </div>
        <?php require_once("../includes/footer_gen.php"); ?>

        <!-- Script -->
        <script>
            $(document).ready(function() {
                var modal = $("#modal_anular_cobro");
                var modalBtns = $(".openModalBtn");
                var span = $(".close");

                modalBtns.click(function() {
                    var idventa = $(this).data("id");
                    var idtmpventa = $(this).data("idtmp");
                    // console.log("modalBtns", idventa);
                    // console.log("modalBtns", idtmpventa);
                    modal.data("idventa", idventa);
                    modal.data("idtmpventa", idtmpventa);
                    modal.modal("show");
                });

                span.click(function() {
                    modal.modal("hide");
                });

                $("#anularCobroBtn").click(function() {
                    var idventa = modal.data("idventa");
                    var idtmpventa = modal.data("idtmpventa");
                    // console.log("anular boton", idventa);
                    $.ajax({
                        url: "anular_cobros.php",
                        method: "POST",
                        data: {
                            idventa: idventa,
                            idtmpventa: idtmpventa
                        },
                        dataType: "json",
                        success: function(response) {
                            if (response && response.success) {
                                $("#message-container").html(response.message);
                                // modal.modal("hide"); 
                                location.reload();
                            } else if (response && !response.success) {
                                $("#message-container").html(response.message);
                            } else {
                                $("#message-container").html("Empty or invalid response from server.");
                            }
                            // console.log(response);
                        },
                        error: function(xhr, status, error) {
                            // console.log(error);
                            $("#message-container").html("Error: " + error);
                        }
                    });
                });

                $(window).click(function(event) {
                    if (event.target == modal[0]) {
                        modal.modal("hide");
                    }
                });
            });
        </script>
</body>

</html>