<?php
ini_set('display_errors', '1');
ini_set('display_startup_errors', '1');
error_reporting(E_ALL);
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "660";

require_once("../includes/rsusuario.php");

$response = array('success' => false, 'message' => '');

function handleError($message, $query = '')
{

    global $response, $conexion;

    $response['success'] = false;
    $response['message'] = $message;

    if ($query & $conexion) {

        $response['error_details'] = $conexion->ErrorMsg();
    }

    outputResponse();
}

function outputResponse()
{

    global $response;

    header('Content-Type: application/json');
    echo json_encode($response);
    exit;
}

if (!isset($_POST['idventa']) || empty($_POST['idventa'])) {
    handleError("Error: No se proporcionó el ID del cobro.");
}
if (!isset($_POST['idtmpventa']) || empty($_POST['idtmpventa'])) {
    handleError("Error: No se proporcionó el ID del cobro temporal.");
}

// Sanitize the input
$idventa = antisqlinyeccion(($_POST['idventa']), "int");
$idtmpventa = antisqlinyeccion(($_POST['idtmpventa']), "int");
$anulado_el = antisqlinyeccion(date("Y-m-d H:i:s"), "date");

try {

    // Buscamos primero en la tabla de ventas 
    $buscaVenta = "SELECT * FROM ventas WHERE idventa = $idventa";
    $resultVenta = $conexion->Execute($buscaVenta);
    if (!$resultVenta) handleError("Error al buscar la venta", $buscaVenta);

    $estadoVenta = intval($resultVenta->fields['estado']);
    $factura = antisqlinyeccion($resultVenta->fields['factura'], "text");
    $idcaja = intval($resultVenta->filds['idcaja']);
    $monto = antisqlinyeccion($resultVenta->fields['total_venta'], "float");

    // Bucasmos en la tabla de ventas tmp
    $buscarTmpVenta = "SELECT 
                            tvc.idclienteped, 
                            tvc.estado, 
                            tv.idproducto, 
                            tvc.monto 
                        FROM 
                            tmp_ventares_cab tvc 
                        INNER JOIN 
                            tmp_ventares tv on tv.idtmpventares_cab = tvc.idtmpventares_cab 
                        WHERE 
                            tvc.idventa = $idventa
                            or tvc.idtmpventares_cab = $idtmpventa";
    $resultTmpVenta = $conexion->Execute($buscarTmpVenta);
    if (!$resultTmpVenta) handleError("Error al buscar la venta temporal", $buscarTmpVenta);

    $idcliente = antisqlinyeccion($resultTmpVenta->fields['idclienteped'], "int");
    $estado = intval($resultTmpVenta->fields['estado']);
    $idprod =  antisqlinyeccion($resultTmpVenta->fields['idproducto'], "int");

    // Controla por si la venta ya halla sido anulada
    if ($estadoVenta != 6) {

        // Anulamos el pago
        $updateAnula = "UPDATE gest_pagos SET estado = 6,anulado_el = '$ahora', anulado_por = $idusu WHERE idventa = $idventa and estado = 1 and idempresa = $idempresa";
        $resultAnula = $conexion->Execute($updateAnula);
        if (!$resultAnula) handleError("Error al anular el pago", $updateAnula);

        //Insertamos el registro de anulacion de venta
        $insertarAnula = "INSERT INTO anulaciones_ventas
            (fecha_anulado,anulado_por,idventa,factura,monto_venta,idempresa,sucursal)
            VALUES
            ($anulado_el,$idusu,$idventa,$factura,$monto,$idempresa,$idsucursal)";
        $rsca = $conexion->Execute($insertarAnula);
        if (!$rsca) handleError("Error al insertar en anulaciones ventas", $insertarAnula);

        //traemos el id de anulacion
        $buscarIdAnu = "SELECT max(idanula) as idanula FROM anulaciones_ventas WHERE idventa = $idventa and idempresa = $idempresa";
        $rsanu = $conexion->Execute($buscarIdAnu);
        if (!$rsanu) handleError("Error al tratar de conseguir el id de la anulacion", $buscarIdAnu);

        //Traemos el id de anulacion
        $idanu = intval($rsanu->fields['idanula']);

        //inserta el cuerpo de la anulacion 
        $insertarAnuCue = "INSERT INTO anulaciones_ventas_detalles
            (idanula,idproducto,cantidad,precio)
            VALUES 
            ($idanu,$idprod,1,$monto)";
        $rsanucue = $conexion->Execute($insertarAnuCue);
        if (!$rsanucue) handleError("Error al tratar de insertat en el cuerpo de la anulacion", $insertarAnuCue);

        // Update the tmp_ventares_cab table
        $updateVentares = "UPDATE 
                                tmp_ventares_cab 
                            SET 
                                estado = 6, 
                                anulado_por = $idusu, 
                                anulado_el = $anulado_el 
                            WHERE 
                                idtmpventares_cab = $idtmpventa";
        $resultVentares = $conexion->Execute($updateVentares);
        if (!$resultVentares) handleError("Error al cambiar al estado anulado", $updateVentares);

        // Actualizamos la tabla venta detalles
        $updateVentaDet = "UPDATE ventas_detalles SET subtotal = 0, utilidad = 0, costo = 0, iva = 0 WHERE idventa = $idventa";
        $resultVentaDet = $conexion->Execute($updateVentaDet);
        if (!$resultVentaDet) handleError("Error al actualizar los detalles", $updateVentaDet);

        // Actualizamos la tabla de ventas al estado de anulado
        $updateVenta = "UPDATE ventas SET estado = 6, anulado_por = $idusu, anulado_el = $anulado_el WHERE idventa = $idventa";
        $rsVenta = $conexion->Execute($updateVenta);
        if (!$rsVenta) handleError("Error al actualizar la venta", $updateVenta);

        // Searching for the old values from cuentas_clientes_membresia
        $buscarCuenta = "SELECT 
                            ultimo_valido_hasta
                        FROM 
                            cuentas_clientes_membresia   
                        WHERE
                            idcliente = $idcliente";
        $resultCuenta = $conexion->Execute($buscarCuenta);

        if (!$resultCuenta) handleError("Error al obtener las fechas cliente", $buscarCuenta);

        $ult_valido_hasta = antisqlinyeccion($resultCuenta->fields['ultimo_valido_hasta'], "text");
       
        if($ult_valido_hasta != ''){
            $ult_valido_clean = $ult_valido_hasta;
        }else{
            $ult_valido_clean = 'DATE_SUB(CURDATE(), INTERVAL 1 MONTH)';
        }

        // Now we update with those old values again
        $updateVence = "UPDATE 
                            cuentas_clientes_membresia
                        SET
                            valido_hasta = $ult_valido_clean
                        WHERE
                        idcliente = $idcliente";
        $resultVence = $conexion->Execute($updateVence) or die(errorpg($conexion, $updateVence));
        if (!$resultVence) handleError("Error al actualizar las fechas cliente", $buscarCuenta);

        // recalcula la caja
        recalcular_caja($idcaja);

        // marca como finalizado
        $updateAnulacion = "UPDATE anulaciones_ventas SET finalizo_ok = 'S' WHERE idventa = $idventa";
        $resultAnulacion = $conexion->Execute($updateAnulacion);

        if (!$resultAnulacion) {

            $response['success'] = false;
            $response['message'] = "Error: No se ha podido anular el cobro.";
        } else {

            $response['success'] = true;
            $response['message'] = "Cobro anulado correctamente";
        }
    } else {

        $response['success'] = false;
        $response['message'] = "Error: Cobro anulado anteriormente.";
    }
} catch (Exception $e) {

    handleError("Error: " . $e->getMessage());
}

outputResponse();
