<?php
require_once("impresorweb/conexiones/conexion_local.php");
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Authorization');
header('Content-Type: application/json');

// Generamos un uuid hara el search id
function generateUuid() {
    $com = new COM('Scriptlet.TypeLib');
    return $com->GUID;
}
$uuid = generateUuid();
$url = 'http://192.168.0.110/ISAPI/AccessControl/AcsEvent?format=json';

// Consultar la terminal de reconocimiento facial si exite eventos de tipo acceso
$curl = curl_init();

curl_setopt_array($curl, array(
    CURLOPT_URL => $url,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => 'POST',
    CURLOPT_POSTFIELDS => '{
                "AcsEventCond": {
                "searchID": "' . $uuid . '",
                "searchResultPosition": 0,
                "maxResults": 3,
                "major": 0,
                "minor": 0,
                "picEnable": true,
                "timeReverseOrder": true
                }
            }',
    CURLOPT_HTTPHEADER => array(
        'Content-Type: application/json'
    ),
    CURLOPT_HTTPAUTH => CURLAUTH_DIGEST,
    CURLOPT_USERPWD => 'admin:1234keeper'
));

$response = curl_exec($curl);

curl_close($curl);
// echo $response;

$data = json_decode($response, true);
// print_r($data);

if (json_last_error() === JSON_ERROR_NONE) {

    // Si $data esta seteado y es un array
    if (isset($data['AcsEvent']['InfoList']) && is_array($data['AcsEvent']['InfoList'])) {

        // Inicializamos las variables en null
        $lastSearchID = null;
        $lastCardNo = null;
        $lastName = null;
        $lastTime = null;

        // Guardamos el searchID
        $lastSearchID = $data['AcsEvent']['searchID'];

        // Recorremos en un foreach para guardar los datos del cliente
        foreach ($data['AcsEvent']['InfoList'] as $item) {
            if (isset($item['cardNo']) && isset($item['name']) && isset($item['time'])) {
                $this->nroDocumento = $item['cardNo'];
                $lastName = $item['name'];
                $lastTime = date('Y-m-d H:i:s', strtotime($item['time']));
                // echo '<br/>' . $lastSearchID . ' ' . $lastCardNo . ' ' . $lastName . ' ' . $lastTime;
            }
        }

        // Si los datos son distintos a null
        if ($lastCardNo !== 0 && $lastName !== '') {

            // Verificamos que esos mismos datos no existan para no abrir el molinete cada tanto
            $consulta = "SELECT 
                            * 
                        FROM 
                            control_accesos 
                        WHERE 
                            cardNo = '$lastCardNo' 
                            and time_acceso = '$lastTime'";
            $rs = $conexion_local->Execute($consulta) or die(errorpg($conexion_local, $consulta));

            if (!$rs->recordCount() > 0) {

                $jsonRespuesta = array(
                    'status' => false,
                    'msg' => "Previamente consultado, no abrir molinete"
                );
                $jsonRespuesta = json_encode($jsonRespuesta);
            } else {

                // Si los datos son nuevos lo guardara en la tabla control_acccesos
                $insertar = "INSERT INTO control_accesos
                        (searchID, cardNO, name_cliente, time_acceso)
                        VALUES('$lastSearchID', '$lastCardNo', '$lastName', '$lastTime')";
                $conexion_local->Execute($insertar) or die(errorpg($conexion_local, $insertar));

                // Mandamos el numero de documento para verificar el acceso
                $url = 'https://goldengym.otrolevel.com.py/wellness/well_acceso_molinete.php';
                $curl = curl_init();

                curl_setopt_array($curl, array(
                    CURLOPT_URL => $url,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => '{
                        "cedula": "' . $lastCardNo . '"
                    }',
                    CURLOPT_HTTPHEADER => array(
                        'Authorization: Bearer 93bdf063c1142f52631e2d04393a3a3da2f40ad73244c17e825188242040b7f6b04b2e6c6309ed5627d7e323a935caf24f2935ba56893f7bf8b795ec4617bb05',
                        'Content-Type: application/json'
                    ),
                ));

                $response = curl_exec($curl);

                echo json_decode($response);
                $jsonRespuesta = json_decode($response, true);
            }
        } else {
            $jsonRespuesta = array(
                'status' => false,
                'msg' => "No se pudo obtener el Nro de Documento en el último elemento"
            );
            $jsonRespuesta = json_encode($jsonRespuesta);
        }
    } else {
        $jsonRespuesta = array(
            'status' => false,
            'msg' => "No se encontró la lista de información"
        );
        $jsonRespuesta = json_encode($jsonRespuesta);
    }
} else {
    $jsonRespuesta = array(
        'status' => false,
        'msg' => "Fallo: " . json_last_error_msg()
    );
    $jsonRespuesta = json_encode($jsonRespuesta);
}

// echo $jsonRespuesta;
