<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");

// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "654";
require_once("../includes/rsusuario.php");

// Filtro 
if (trim($_GET['desde']) == '' or trim($_GET['hasta']) == '') {
    $desde = date("Y-m-") . '01';
    $hasta = date("Y-m-d");
} else {
    $desde = date("Y-m-d", strtotime($_GET['desde']));
    $hasta = date("Y-m-d", strtotime($_GET['hasta']));
}

$proveedor = isset($_GET['proveedor']) ? $_GET['proveedor'] : '';
$tdocumento = isset($_GET['tdocumento']) ? $_GET['tdocumento'] : '';
$concepto = isset($_GET['concepto']) ? $_GET['concepto'] : '';

//Compras de stock
function constructQuery($desde, $hasta, $proveedor, $tdocumento, $concepto)
{
    $query = "SELECT 
	            idcompra,
                fecha_compra,
                factura_numero,
                nombre,
                ruc,
                timbrado,
                vtotimbrado,
                id_factura,
                CASE WHEN
                    (
                    select id_factura 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura 
                    limit 1
                    ) > 0
                THEN
                    (
                    select sum(monto_col) 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura
                    and iva_porc_col = 10
                    )
                ELSE
                    CASE WHEN 
                        idcompra > 0
                    THEN
                        (
                        select sum(subtotal) 
                        from facturas_proveedores_compras 
                        where id_factura = facturas_proveedores.id_factura 
                        and iva_porc = 10
                        )
                    ELSE
                        (
                        select sum(monto_gasto) from facturas_proveedores_gastos 
                        where id_factura = facturas_proveedores.id_factura and iva_porc = 10
                        )
                    END
                END as iva10,
                CASE WHEN
                    (
                    select id_factura 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura 
                    limit 1
                    ) > 0
                THEN
                    (
                    select sum(monto_col) 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura
                    and iva_porc_col = 5
                    )
                ELSE
                    CASE WHEN 
                        idcompra > 0
                    THEN
                        (
                        select sum(subtotal) 
                        from facturas_proveedores_compras 
                        where id_factura = facturas_proveedores.id_factura 
                        and iva_porc = 5
                        )
                    ELSE
                        (
                        select sum(monto_gasto) from facturas_proveedores_gastos 
                        where id_factura = facturas_proveedores.id_factura and iva_porc = 5
                        )
                    END
                END as iva5,
                CASE WHEN
                    (
                    select id_factura 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura 
                    limit 1
                    ) > 0
                THEN
                    (
                    select sum(monto_col) 
                    from facturas_proveedores_det_impuesto 
                    where facturas_proveedores_det_impuesto.id_factura = facturas_proveedores.id_factura
                    and iva_porc_col = 0
                    )
                ELSE
                    CASE WHEN 
                        idcompra > 0
                    THEN
                        (
                        select sum(subtotal) 
                        from facturas_proveedores_compras 
                        where id_factura = facturas_proveedores.id_factura 
                        and iva_porc = 0
                        )
                    ELSE
                        (
                        select sum(monto_gasto) from facturas_proveedores_gastos 
                        where id_factura = facturas_proveedores.id_factura and iva_porc = 0
                        )
                    END
                END as exenta,
                vencimiento_factura,
                tipo_factura,
                saldo_factura,
                total_factura,
                CASE 
                    WHEN idcompra IS NOT NULL THEN (select cnc.descripcion from cn_conceptos cnc inner join facturas_proveedores_compras fpc on fpc.idconcepto = cnc.idconcepto limit 1)
                    ELSE (select cnc.descripcion from cn_conceptos cnc inner join facturas_proveedores_gastos fpg on fpg.idconcepto = cnc.idconcepto limit 1)	
                END as concepto
	        FROM 
                facturas_proveedores
	        INNER JOIN 
               proveedores on proveedores.idproveedor=facturas_proveedores.id_proveedor
	        WHERE 
	            date(fecha_compra) between '$desde' and '$hasta' 
	            and facturas_proveedores.estado<>6";

    if (!empty($proveedor)) {
        $query .= " AND nombre LIKE '%$proveedor%'";
    }

    if (!empty($tdocumento)) {
        $tdocumento = strtoupper($tdocumento);
        echo $tdocumento;
        if ($tdocumento == 'COMPRA') {
            $query .= " AND idcompra <> '' ";
        } else if ($tdocumento == 'GASTO') {
            $query .= " AND (idcompra  = '' or idcompra is null)";
        }
    }

    if (!empty($concepto)) {
        $query .= " AND concepto LIKE '%$concepto%'";
    }

    $query .= " ORDER BY facturas_proveedores.fecha_compra asc";

    return $query;
}

$buscar = constructQuery($desde, $hasta, $proveedor, $tdocumento, $concepto);
$rs = $rsprov = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
$tr = $rs->RecordCount();
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <?php require_once("../includes/head_gen.php"); ?>
</head>

<body class="nav-md">
    <div class="container body">
        <div class="main_container">
            <?php require_once("../includes/menu_gen.php"); ?>

            <!-- top navigation -->
            <?php require_once("../includes/menu_top_gen.php"); ?>

            <!-- page content -->
            <div class="right_col" role="main">
                <div class="">
                    <div class="page-title">
                    </div>
                    <div class="clearfix"></div>
                    <?php require_once("../includes/lic_gen.php"); ?>

                    <!-- SECCION -->
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="x_panel">
                                <div class="x_title">
                                    <h2>Registros de Compras y Gastos</h2>
                                    <ul class="nav navbar-right panel_toolbox">
                                        <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                                        </li>
                                    </ul>
                                    <div class="clearfix"></div>
                                </div>
                                <div class="x_content">
                                    <form action="" id="filtrosl" method="get">

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Desde *</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="date" name="desde" id="desde" value="<?php echo $desde; ?>" placeholder="Desde" class="form-control" required />
                                            </div>
                                        </div>

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Hasta *</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="date" name="hasta" id="hasta" value="<?php echo $hasta; ?>" placeholder="Hasta" class="form-control" required />
                                            </div>
                                        </div>

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Proveedor</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="text" name="proveedor" id="proveedor" value="<?php echo $proveedor; ?>" placeholder="Proveedor" class="form-control" />
                                            </div>
                                        </div>

                                        <div class=" col-md-6 col-sm-6 form-group">
                                            <select name="tdocumento" id="tdocumento" class="form-control">
                                                <option value="">Seleccionar tipo de documento</option>
                                                <option value="COMPRA" <?php if ($tdocumento == 'COMPRA') echo 'selected="selected"'; ?>>COMPRA</option>
                                                <option value="GASTO" <?php if ($tdocumento == 'GASTO') echo 'selected="selected"'; ?>>GASTO</option>
                                            </select>
                                        </div>

                                        <div class="col-md-6 col-sm-6 form-group">
                                            <label class="control-label col-md-3 col-sm-3 col-xs-12">Concepto</label>
                                            <div class="col-md-9 col-sm-9 col-xs-12">
                                                <input type="text" name="concepto" id="concepto" value="<?php echo $concepto; ?>" placeholder="Concepto" class="form-control" />
                                            </div>
                                        </div>
                                        <div class="clearfix"></div>
                                        <br />

                                        <div class="form-group">
                                            <div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
                                                <a class="btn btn-default" onclick="enviar(event);"> <span class="fa fa-search"></span> Filtrar</a>
                                            </div>
                                        </div>
                                    </form>
                                    <div class="clearfix"></div>
                                    <br />
                                    <hr />
                                    <div class="table-responsive">
                                        <a href="reporte_gimnasio_xls.php?desde=<?php echo $_REQUEST['desde'] ?>&hasta=<?php echo $_REQUEST['hasta'] ?>&proveedor=<?php echo $_REQUEST['proveedor'] ?>&tdocumento=<?php echo $_REQUEST['tdocumento'] ?>&concepto=<?php echo $_REQUEST['concepto'] ?>" target="_blank"><span class="fa fa-file-excel-o"></span> [Descargar]</a>
                                        <table width="100%" class="table table-bordered jambo_table bulk_action">
                                            <thead>
                                                <tr>
                                                    <th align="center">Tipo Documento</th>
                                                    <th align="center">Fecha compra</th>
                                                    <th align="center">Proveedor</th>
                                                    <th align="center">Ruc</th>
                                                    <th align="center">Factura numero</th>
                                                    <th align="center">Total Factura</th>
                                                    <th align="center">Saldo Activo</th>
                                                    <th align="center">Forma Pago</th>
                                                    <th align="center">Concepto</th>
                                                    <th align="center">Observacion(Detalle)</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <?php while (!$rs->EOF) {
                                                    $cuerpo = '';
                                                    $idfactura = intval($rs->fields['id_factura']);

                                                    //Verificamos si hay una orden de pago abonada para esta Factura, con e fin de mostrar las formas de Pago
                                                    $buscar = "SELECT 
                                                                    fecha_ordenpago,
                                                                    orden_pago_det.idordenpago 
                                                                FROM 
                                                                    orden_pago_det 
                                                                inner join 
                                                                    orden_pago 
                                                                on 
                                                                    orden_pago.idordenpago=orden_pago_det.idordenpago
						                                        WHERE 
                                                                    orden_pago_det.idfactura=$idfactura 
                                                                    and estado <> 6 ";

                                                    $rs1 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
                                                    $total_reg = $rs1->RecordCount();
                                                    if ($total_reg > 0) {

                                                        $idordenpago = intval($rs1->fields['idordenpago']);

                                                        $consulta = "SELECT 
                                                                        formas_pago2.descripcion as formapago, 
                                                                        caja_gestion_mov_det.monto_movimiento,
							                                            (select cheques_emitidos.nrochq from cheques_emitidos where cheques_emitidos.idcajamov = caja_gestion_mov_det.idcajamov) as nrochq,
							                                            (select cheques_emitidos.fecha_emision from cheques_emitidos where cheques_emitidos.idcajamov = caja_gestion_mov_det.idcajamov) as fecha_emision,
							                                            (select cheques_emitidos.idbanco from cheques_emitidos where cheques_emitidos.idcajamov = caja_gestion_mov_det.idcajamov) as idbanco_chq,
							                                            (select bancos.nombre from cheques_emitidos inner join bancos on bancos.idbanco = cheques_emitidos.idbanco where cheques_emitidos.idcajamov = caja_gestion_mov_det.idcajamov) as banco_chq,
							                                            caja_gestion_mov_det.idbanco,
							                                            (select bancos.nombre from bancos where bancos.idbanco = caja_gestion_mov_det.idbanco) as banco,
							                                            (select cuentas.denominacion from cuentas  where cuentas.idcuenta = caja_gestion_mov_det.idcuentacon) as cuenta,
                                                                        caja_gestion_mov_det.fecha_emision_chq,
                                                                        caja_gestion_mov_det.fecha_transfer,
                                                                        caja_gestion_mov_det.boleta_nro,
                                                                        caja_gestion_mov_det.transfer_nro
							                                        FROM 
                                                                        orden_pago
							                                        inner join 
                                                                        caja_gestion_mov_cab on orden_pago.idcajamov = caja_gestion_mov_cab.idcajamov
							                                        inner join 
                                                                        caja_gestion_mov_det on caja_gestion_mov_det.idcajamov = caja_gestion_mov_cab.idcajamov
							                                        inner join 
                                                                        formas_pago2 on formas_pago2.idforma = caja_gestion_mov_det.idformapago
                                                                    WHERE
                                                                        idordenpago = $idordenpago";

                                                        $rs3 = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));
                                                        $cuerpo = 'S';
                                                    }
                                                ?>
                                                    <tr>
                                                        <td align="center"><?php if ($rs->fields['idcompra'] != '') {
                                                                                echo "COMPRA";
                                                                            } else {
                                                                                echo "GASTO";
                                                                            } ?></td>
                                                        <td align="center"><?php if ($rs->fields['fecha_compra'] != "") {
                                                                                echo date("d/m/Y", strtotime($rs->fields['fecha_compra']));
                                                                            } ?></td>
                                                        <td align="center"><?php echo antixss($rs->fields['nombre']); ?></td>
                                                        <td align="center"><?php echo antixss($rs->fields['ruc']); ?></td>
                                                        <td align="center"><?php echo antixss($rs->fields['factura_numero']); ?></td>
                                                        <td align="right"><?php echo formatomoneda($rs->fields['total_factura']);  ?></td>
                                                        <td align="right"><?php echo formatomoneda($rs->fields['saldo_factura']);  ?></td>
                                                        <td>
                                                            <?php if ($cuerpo == 'S') {

                                                                while (!$rs3->EOF) {
                                                                    $forma = trim($rs3->fields['formapago']);
                                                                    if ($forma != 'EFECTIVO') {
                                                                        $datos = "$forma &nbsp;|  CTA: " . $rs3->fields['cuenta'];
                                                                        if ($rs3->fields['nrochq'] != '') {
                                                                            $datos2 = "NUM:&nbsp;  " . $rs3->fields['nrochq'] . "&nbsp; FECHA: &nbsp; " . date("d/m/Y", strtotime($rs3->fields['fecha_emision']));
                                                                        }
                                                                        if ($rs3->fields['transfer_nro'] != '') {

                                                                            $datos3 = "NUM:&nbsp;  " . $rs3->fields['transfer_nro'] . "&nbsp; FECHA: &nbsp; " . date("d/m/Y", strtotime($rs3->fields['fecha_transfer']));
                                                                        }
                                                                        echo $datos . "<br />";
                                                                        echo $datos2 . "<br />";
                                                                        echo $datos3 . "<br />";
                                                                    } else {
                                                                        echo $forma . "<br />";
                                                                    }

                                                                    $datos = "";
                                                                    $datos2 = "";
                                                                    $datos3 = "";

                                                                    $rs3->MoveNext();
                                                                }
                                                            } ?>
                                                        </td>
                                                        <td align="right"><?php echo antixss($rs->fields['concepto']);  ?></td>
                                                    </tr>
                                                <?php $rs->MoveNext();
                                                } //$rs->MoveFirst(); 
                                                ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <script>
                function filterTable() {
                    var table = document.getElementsByTagName('table')[0];
                    var tableRows = table.getElementsByTagName('tr');

                    for (var i = 1; i < tableRows.length; i++) {
                        var tdocumentoCell = tableRows[i].getElementsByTagName('td')[0];
                        var proveedorCell = tableRows[i].getElementsByTagName('td')[2];
                        var conceptoCell = tableRows[i].getElementsByTagName('td')[8];

                        if (tdocumentoCell && proveedorCell && conceptoCell) {
                            tableRows[i].style.display = '';
                        }
                    }
                }

                function enviar(event) {

                    event.preventDefault();

                    var tdocumentoFilter = document.getElementById('tdocumento').value.toUpperCase();
                    var proveedorFilter = document.getElementById('proveedor').value.toUpperCase();
                    var conceptoFilter = document.getElementById('concepto').value.toUpperCase();

                    var table = document.getElementsByTagName('table')[0];
                    var tableRows = table.getElementsByTagName('tr');

                    for (var i = 1; i < tableRows.length; i++) {
                        var tdocumentoCell = tableRows[i].getElementsByTagName('td')[0];
                        var proveedorCell = tableRows[i].getElementsByTagName('td')[2];
                        var conceptoCell = tableRows[i].getElementsByTagName('td')[8];

                        if (tdocumentoCell && proveedorCell && conceptoCell) {
                            var tdocumentoValue = tdocumentoCell.textContent || tdocumentoCell.innerText;
                            var proveedorValue = proveedorCell.textContent || proveedorCell.innerText;
                            var conceptoValue = conceptoCell.textContent || conceptoCell.innerText;

                            if (tdocumentoValue.toUpperCase().indexOf(tdocumentoFilter) > -1 &&
                                proveedorValue.toUpperCase().indexOf(proveedorFilter) > -1 &&
                                conceptoValue.toUpperCase().indexOf(conceptoFilter) > -1) {
                                tableRows[i].style.display = '';
                            } else {
                                tableRows[i].style.display = 'none';
                            }
                        }
                    }

                    $("#filtrosl").submit();
                }
            </script>
            <!-- footer content -->
            <?php require_once("../includes/pie_gen.php"); ?>
        </div>
    </div>
    <?php require_once("../includes/footer_gen.php"); ?>
</body>

</html>