<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "547";
require_once("../includes/rsusuario.php");

$idcliente = isset($_GET['idcliente']) ? intval($_GET['idcliente']) : 0;
$idcliente = antisqlinyeccion($idcliente, "int");

if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['guardar_asociados'])) {

    $errors = []; // Array to collect error messages
    $successCount = 0; // Counter for successful insertions

    // Obtenemos los datos del cliente para insertar y actualizar los asociamientos en las tablas correspondientes
    $buscar_cliente = "SELECT * FROM cliente WHERE idcliente = $idcliente";
    $rs_cliente = $conexion->Execute($buscar_cliente) or die(errorpg($conexion, $buscar_cliente));

    $nombre_completo_cliente = trim($rs_cliente->fields['nombre']) . ' ' . trim($rs_cliente->fields['apellido']);
    $asociado = trim($rs_cliente->fields['apellido']) . '-' . $idcliente;
    $asociado = antisqlinyeccion($asociado, "text");

    // Insertamos en la tabla de clientes asociados
    $insert_asociado = "INSERT INTO clientes_asociados (asociado) VALUES ($asociado)";
    $result_asociado = $conexion->Execute($insert_asociado) or die(errorpg($conexion, $insert_asociado));

    if (!$result_asociado) {

        $errors[] = "Error al insertar el asociamiento $asociado: " . $conexion->ErrorMsg();
    } else {

        $successCount++;

        // Obtener el idasociado para insertar 
        $buscar_asociado = "SELECT idasociado FROM clientes_asociados WHERE asociado = $asociado";
        $rs_asociado = $conexion->Execute($buscar_asociado) or die(errorpg($conexion, $buscar_asociado));
        $idasociado = intval($rs_asociado->fields['idasociado']);
        $idasociado = antisqlinyeccion($idasociado, "int");

        // Procedemos a insertar los datos del cliente en la tabla de asociaciones 
        // Cliente
        $insert_cliente_asociado = "INSERT INTO cuentas_clientes_asociados (idasociado, idcliente) VALUES ($idasociado, $idcliente)";
        $result_cliente_asociado = $conexion->Execute($insert_cliente_asociado) or die(errorpg($conexion, $insert_cliente_asociado));

        if (!$result_cliente_asociado) {

            $errors[] = "Error al insertar el cliente  $nombre_completo_cliente: " . $conexion->ErrorMsg();
        } else {

            $update_cliente_asociado = "UPDATE cuentas_clientes_membresia SET idasociado = $idasociado WHERE idcliente = $idcliente";
            $rs_cliente_asociado = $conexion->Execute($update_cliente_asociado) or die(errorpg($conexion, $update_cliente_asociado));

            if (!$rs_cliente_asociado) {

                $errors[] = "Error al actualizar el cliente  $nombre_completo_cliente: " . $conexion->ErrorMsg();
            } else {

                $successCount++;

                // Asociados del cliente
                if (isset($_POST['asociados']) && is_array($_POST['asociados'])) {
                    $clientesSeleccionados = $_POST['asociados'];

                    foreach ($clientesSeleccionados as $idclienteasociado) {

                        $idclienteasociado = antisqlinyeccion($idclienteasociado, "int");
                        $insert_asociados = "INSERT INTO cuentas_clientes_asociados (idasociado, idcliente) VALUES ($idasociado, $idclienteasociado)";
                        $result_asociados = $conexion->Execute($insert_asociados) or die(errorpg($conexion, $insert_asociados));

                        if (!$result_asociados) {

                            $errors[] = "Error al insertar  los asociados: " . $conexion->ErrorMsg();
                        } else {
                            $update_asociados = "UPDATE cuentas_clientes_membresia SET idasociado = $idasociado WHERE idcliente = $idclienteasociado";
                            $rs_asociados = $conexion->Execute($update_asociados) or die(errorpg($conexion, $update_asociads));

                            if (!$rs_asociados) {

                                $errors[] = "Error al actualizar los asociados: " . $conexion->ErrorMsg();
                            } else {

                                $successCount++;
                                header("well_cuentas.php?idcliente=$idcliente");
                            }
                        }
                    }
                } else {
                    echo '<div class="alert alert-warning" role="alert">';
                    echo "Necesita seleccionar clientes para asociar a la membresias familiar.";
                    echo '</div>';
                }
            }
        }
    }

    // Display errors if any
    if (!empty($errors)) {
        echo '<div class="alert alert-danger" role="alert">';
        echo '<h4 class="alert-heading">Erro al asociar cliente:</h4>';
        echo '<ul>';
        foreach ($errors as $error) {
            echo "<li>$error</li>";
        }
        echo '</ul>';
        echo '</div>';
    }

    // Display success message
    if ($successCount > 0) {
        echo '<div class="alert alert-success" role="alert">';
        echo "$successCount clientes asociados exitosamente.";
        echo '</div>';
    }
}
?>

<!DOCTYPE html>

<head>
    <?php require_once("../includes/head_gen.php"); ?>
</head>

<body class="nav-md">
    <div class="container body">
        <div class="main_container">
            <?php require_once("../includes/menu_gen.php"); ?>

            <!-- top navigation -->
            <?php require_once("../includes/menu_top_gen.php"); ?>

            <!-- page content -->
            <div class="right_col" role="main">
                <div class="">
                    <div class="page-title">
                    </div>
                    <div class="clearfix"></div>
                    <?php require_once("../includes/lic_gen.php"); ?>

                    <!-- SECCION -->
                    <div class="row">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="x_panel">
                                <div class="x_content">
                                    <div class="col-md-12">
                                        <h2>Agregar Asociados al Cliente</h2>
                                        <div class="col-md-8">
                                            <input type="text" id="filterInput" class="form-control mb-3" placeholder="Filtra por nombre o documento">
                                        </div>
                                        <form id="asoc" method="post">
                                            <div class="col-md-4 text-end">
                                                <button type="submit" class="btn btn-primary" name="guardar_asociados">Guardar Asociados</button>
                                            </div>
                                            <table class="table table-striped">
                                                <thead>
                                                    <tr>
                                                        <th>Cliente</th>
                                                        <th>Documento</th>
                                                        <th>Seleccionar</th>
                                                    </tr>
                                                </thead>
                                                <tbody id="clienteTableBody">
                                                    <?php

                                                    $buscar_miembros = "SELECT * FROM cliente WHERE estado <> 6 ORDER BY nombre, apellido ASC";
                                                    $rs_miembros = $conexion->Execute($buscar_miembros) or die(errorpg($conexion, $buscar_miembros));

                                                    while (!$rs_miembros->EOF) {
                                                        $nombre_completo = htmlspecialchars($rs_miembros->fields['nombre'] . " " . $rs_miembros->fields['apellido']);
                                                        $documentoasociado = htmlspecialchars($rs_miembros->fields['documento']);
                                                        $idclienteasociado = htmlspecialchars($rs_miembros->fields['idcliente']);
                                                        echo "<tr>";
                                                        echo "<td>" . $nombre_completo . "</td>";
                                                        echo "<td>" . $documentoasociado . "</td>";
                                                        echo "<td><input type='checkbox' name='asociados[]' value='" . $idclienteasociado . "'></td>";
                                                        echo "</tr>";
                                                        $rs_miembros->MoveNext();
                                                    }
                                                    ?>
                                                </tbody>
                                            </table>
                                            <div class="clearfix"></div>
                                        </form>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <?php require_once("../includes/pie_gen.php"); ?>
        </div>
    </div>
    <!-- /footer content -->
    <?php require_once("../includes/footer_gen.php"); ?>

    <script>
        $(document).ready(function() {
            $("#filterInput").on("keyup", function() {
                var value = $(this).val().toLowerCase();
                $("#clienteTableBody tr").filter(function() {
                    var name = $(this).find("td:first").text().toLowerCase();
                    var document = $(this).find("td:eq(1)").text().toLowerCase();
                    $(this).toggle(name.indexOf(value) > -1 || document.indexOf(value) > -1);
                });
            });
        });
    </script>
</body>

</html>