<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S';
$modulo = "38";
$submodulo = "547";
require_once("../includes/rsusuario.php");

/*------------------------------------BUSCAR DATOS--------------------------*/
if (isset($_REQUEST['documento'])) {

	$dc = intval($_REQUEST['documento']);

	$buscar = "SELECT 
					idtipocuenta,
					nombre, 
					apellido,
					razon_social,
					documento,
					cliente.telefono,
					idmembresia,
					monto_cuota,
					frecuencia,
					disponible_dias,
					valido_hasta,
					ultimo_valido_hasta,
					cliente.idcliente,
					cliente.sucursal,
					idasociado,
					date(cuentas_clientes_membresia.registrado_el) as fechareg,
					(select CONCAT(nombres,' ',apellidos) from profesionales where idprofe=cuentas_clientes_membresia.idprofe) as profesional,
					(Select descripcion from cuentas_tipos where idcuenta_tipo=cuentas_clientes_membresia.idtipocuenta) as clasemiembro
				FROM  
					cuentas_clientes_membresia 
				INNER JOIN 
					cliente on cliente.idcliente=cuentas_clientes_membresia.idcliente
				WHERE 
					documento=$dc";
	$rs = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
	$tr = $rs->RecordCount();

	$idmembresia = intval($rs->fields['idmembresia']);
	$profesionalv = trim($rs->fields['profesional']);
	$nombre = trim($rs->fields['nombre']);
	$apellido = trim($rs->fields['apellido']);
	$clasemiembro = trim($rs->fields['clasemiembro']);
	$monto_cuota = floatval($rs->fields['monto_cuota']);
	$idcliente = intval($rs->fields['idcliente']);
	$idtipocuenta = intval($rs->fields['idtipocuenta']);
	$idasociado = intval($rs->fields['idasociado']);
	$vencimiento = '';
	$validoHasta = trim($rs->fields['valido_hasta']);
	$ultimoValidoHasta = trim($rs->fields['ultimo_valido_hasta']);
	$sucursal = intval($rs->fields['sucursal']);

	if (!empty($validoHasta) && $validoHasta != 0) {

		$vencimiento = $validoHasta;
	} elseif (!empty($ultimoValidoHasta) && $ultimoValidoHasta != 0) {

		$vencimiento = $ultimoValidoHasta;
	}

	if ($tr == 0) {

		$buscar = "SELECT 
						idcliente,
						nombre,
						apellido,
						telefono,
						razon_social,
						documento,
						sucursal
					FROM  
						cliente
					WHERE 
						documento=$dc";
		$rs = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
		$tr1 = $rs->RecordCount();

		$idcliente = intval($rs->fields['idcliente']);
		$nombre = trim($rs->fields['nombre']);
		$apellido = trim($rs->fields['apellido']);
		$celular = intval($rs->fields['telefono']);
		$sucursal = intval($rs->fields['sucursal']);

		//De no existir en clientes, es posible que tenga ruc,por lo cual comprobamos si ese documento existe como ruc
		if ($tr1 == 0) {

			$parametros_array = array(
				'ruc' => $dc
			);

			// respuesta
			$res = ruc_hacienda($parametros_array);
			$idcliente = intval($res['idcliente']);
			$nombre = trim($res['nombre_ruc']);
			$apellido = trim($res['apellido_ruc']);
		}
	}

	//Tipos de cuentas_clientes_membresia
	$buscar = "Select * from cuentas_tipos where estado <> 6 and idsucursal = $sucursal order by descripcion asc";
	$rs1 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));

	//Buscar si el cliente tiene asociados 
	$buscar_asoc = "SELECT 
						ccm.idmembresia,
						CONCAT(c.nombre, ' ', c.apellido) as asociado,
						c.documento,
						c.idcliente,
						c.telefono,
						ccm.idasociado 
					FROM 
						cuentas_clientes_membresia ccm 
					INNER JOIN 
						cliente c on c.idcliente = ccm.idcliente
					WHERE
						ccm.idasociado = $idasociado
						and c.idcliente <> $idcliente
					ORDER BY
						c.idcliente";
	$rs_asoc = $conexion->Execute($buscar_asoc) or die(errorpg($conexion, $buscar_asoc));
	$num_rows = $rs_asoc->RecordCount();
}

/*------------------------------------REGISTRAR DATOS--------------------------*/
if (isset($_POST['dc'])) {

	$dc = intval($_REQUEST['dc']);
	$tipo_membresia = intval($_REQUEST['tipomiembro']);
	$profesional = intval($_REQUEST['profesional']);
	$idcliente = intval($_REQUEST['idcliente']);

	//documento de control por seguridad
	$parametros_array = array(
		'ruc' => $dc
	);
	$res = ruc_hacienda($parametros_array);

	$dccontrol = intval($res['documento']);

	if ($res['fuente'] == 'NOEXISTE') {

		$dc1 = intval($res['ruc']);

		if ($dccontrol == 0 && $dc1 > 0) {

			$dccontrol = $dc1;
		}
	}

	//vemos si posee el campo cedula completado, sino updatear
	$buscar = "SELECT documento FROM cliente WHERE idcliente=$idcliente ";
	$rs2 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));

	if ($idcliente > 0 && $dccontrol == $dc) {

		$update = "UPDATE cliente SET documento=$dc WHERE idcliente=$idcliente";
		$conexion->Execute($update) or die(errorpg($conexion, $update));
	} else {

		echo "Prueba de control seguridad no aprobada. El documento no coincide (Control: $dccontrol - Cedula Ingresada: $dc)";
		exit;
	}

	if ($idcliente > 0  and $tipo_membresia > 0) {

		$buscar = "SELECT * FROM cuentas_tipos WHERE idcuenta_tipo=$tipo_membresia";
		$rs2 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));

		$frecuencia = intval($rs2->fields['frecuencia']);
		$monto = floatval($rs2->fields['monto']);
		$val = date("Y-m-d");
		$date1 = date("Y-m-d", strtotime($val . '+ ' . $frecuencia . ' days'));

		//generamos el registro de membresia
		$insertar = "INSERT INTO cuentas_clientes_membresia 
		(idcliente,idprofe,idtipocuenta,monto_cuota,frecuencia,tipo_mebresia,estado,registrado_el,registrado_por)
		VALUES	
		($idcliente,$profesional,$tipo_membresia,$monto,$frecuencia,$tipo_membresia,1,'$ahora',$idusu)";
		$conexion->Execute($insertar) or die(errorpg($conexion, $insertar));

		header("Location: well_cuentas.php?documento=$dc&ui=1");
		exit;
	}

	header("Location: well_cuentas.php?documento=$dc");
	exit;
}

/*-----------------------VINCULAR UN PROFESIONAAL A DATOS EXISTENTES-----*/
if (isset($_POST['cedula'])) {

	$idmembresia = intval($_POST['ocmiembro']);
	$idprofe = intval($_POST['vincular']);
	$documento = intval($_POST['cedula']);

	if ($idmembresia > 0) {

		$update = "update cuentas_clientes_membresia set idprofe=$idprofe where idmembresia=$idmembresia ";
		$conexion->Execute($update) or die(errorpg($conexion, $update));

		header("Location: well_cuentas.php?documento=$documento");
		exit;
	}
}
?>

<!DOCTYPE html>

<head>
	<?php require_once("../includes/head_gen.php"); ?>
</head>

<body class="nav-md">
	<div class="container body">
		<div class="main_container">
			<?php require_once("../includes/menu_gen.php"); ?>

			<!-- top navigation -->
			<?php require_once("../includes/menu_top_gen.php"); ?>
			<!-- /top navigation -->

			<!-- page content -->
			<div class="right_col" role="main">
				<div class="">
					<div class="page-title">
					</div>
					<div class="clearfix"></div>
					<?php require_once("../includes/lic_gen.php"); ?>

					<!-- SECCION -->
					<div class="row">
						<div class="col-md-12 col-sm-12 col-xs-12">
							<div class="x_panel">
								<div class="x_title">
									<h2>Cuentas Clientes</h2>
									<ul class="nav navbar-right panel_toolbox">
										<li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
										</li>
									</ul>
									<div class="clearfix"></div>
								</div>
								<div class="x_content">
									<?php echo $error; ?>
									<form id="form1" name="form1" method="get" action="">
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Documento *</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="documento" id="documento" class="form-control" required />
												<input type="submit" class="btn btn-primary" value="Buscar" />
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>
					</div>
					<!-- SECCION -->

					<?php if ($tr > 0) {
						$disponible_dias = intval($rs->fields['disponible_dias']);
						$idcliente = intval($rs->fields['idcliente']);
					?>
						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel">
									<div class="x_title">
										<h2><?php echo $rs->fields['razon_social']; ?></h2>
										<ul class="nav navbar-right panel_toolbox">
											<li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
											</li>
										</ul>
										<div class="clearfix"></div>
									</div>
									<div class="x_content">
										<div class="col-md-12">
											<div class="col-md-1">
												<a href="../cliente_edit.php?id=<?php echo $idcliente; ?>" class="btn btn-sm btn-default" title="Editar" data-toggle="tooltip" data-placement="right" data-original-title="Editar"><span class="fa fa-edit"></span></a>
											</div>
											<div class="col-md-3"><span style="fa fa-teacher"></span>&nbsp;Profesional Vinculado:&nbsp;<?php echo $profesionalv; ?>
												<?php if ($profesionalv == '') { ?>
													<span class="fa fa-gear"></span>&nbsp;<a href="javascript:void(0);" onclick="asignar_profe();">[Designar profesional]</a>
												<?php } ?>
											</div>
											<div class="col-md-3"><span style="fa fa-star"></span>&nbsp;Miembro desde/Member from :&nbsp;<?php echo date("d/m/Y", strtotime($rs->fields['fechareg'])); ?></div>
											<div class="col-md-3"><span style="fa fa-user"></span>&nbsp;Tipo membres&iacute;a :&nbsp;<?php echo $clasemiembro; ?> X <?php echo formatomoneda($monto_cuota, 2, 'N'); ?></div>
											<div class="col-md-3"><span style="fa fa-user"></span>&nbsp;Disponibles a usar en dias :&nbsp;<?php echo $disponible_dias; ?></div>
											<div class="col-md-3"><span style="fa fa-user"></span>&nbsp;Vencimiento membresia:&nbsp;<?php echo $vencimiento; ?></div>
										</div>
									</div>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel">
									<div class="x_content">
										<div class="col-md-12">
											<h2>Registro de asistencias</h2>
											<?php
											$buscar = "Select * from registros_asistencias where idcliente=$idcliente and estado <> 6 order by fecha_asistencia desc limit 32";
											$rsl1 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
											$ff = $rsl1->RecordCount();

											$ff == 0;
											if ($ff == 0) {
												echo "&nbsp;&nbsp;<span class='fa fa-warning'></span>&nbsp;No existen registros de asistencias";
											} else {
												while (!$rsl1->EOF) {
											?>
													<span class="fa fa-gear"></span>&nbsp;&nbsp;<?php echo date("d/m/Y H:i:s", strtotime($rsl1->fields['fecha_asistencia'])); ?>

											<?php
													$rsl1->MoveNext();
												}
											}
											?>
										</div>
									</div>
								</div>
							</div>
						</div>
						<!-- Si el cliente/miembro cuenta con membresia familiar-->
						<?php
						if ($idtipocuenta === 5 || $idtipocuenta === 6) {
							if ($num_rows === 0) {
						?>
								<div class="row">
									<div class="col-md-12 col-sm-12 col-xs-12">
										<div class="x_panel">
											<div class="x_content">
												<div class="col-md-12">
													<h2>Agregar Asociados al Cliente</h2>
													<a href="well_asociar_cuentas.php?idcliente=<?php echo $idcliente ?>" class="btn btn-primary ml-2">Agregar asociados</a>
												</div>
											</div>
										</div>
									</div>
								</div>

							<?php } elseif ($num_rows > 0) {
							?>

								<div class="row">
									<div class="col-md-12 col-sm-12 col-xs-12">
										<div class="x_panel">
											<div class="x_content">
												<div class="col-md-12">
													<h2>Miembros Asociados al Cliente</h2>
												</div>
												<table class="table table-striped table-bordered">
													<thead>
														<tr>
															<th style="width: 20px; text-align:center;">
																Acciones
															</th>
															<th>Asociado</th>
															<th>Documento</th>
															<th>Telefono</th>
														</tr>
													</thead>
													<tbody>
														<?php while ($row = $rs_asoc->FetchRow()) { ?>
															<tr>
																<td style="width: 20px; text-align: center;">
																	<a href="well_cuentas.php?documento=<?php echo antixss($row['documento']) ?>" class="btn btn-sm btn-default" title="Ver Cliente" data-toggle="tooltip" data-placement="right" data-original-title="Editar"><span class="fa fa-search"></span></a>
																</td>
																<td><?php echo htmlspecialchars($row['asociado']); ?></td>
																<td><?php echo htmlspecialchars($row['documento']); ?></td>
																<td><?php echo htmlspecialchars($row['telefono']); ?></td>
															</tr>
														<?php } ?>
													</tbody>
												</table>
											</div>
										</div>
									</div>
								</div>
							<?php }
						}
					} elseif ($tr === 0 && isset($dc)) {
						if (!$idcliente) {
							?>
							<div class="alert alert-warning" role="alert">
								<span>¿Desea agregar un nuevo cliente?</span>
								<a href="../cliente_add.php" class="btn btn-primary ml-2">Agregar cliente</a>
							</div>
						<?php
						} elseif ($idcliente > 0) { ?>
							<div class="row">
								<div class="col-md-12 col-sm-12 col-xs-12">
									<span class="fa fa-info-circle">&nbsp;Cliente no posee membresia activa.--></span>
									<a href="javascript:void(0);" onclick="membresia();" class="btn btn-warning"><span class="fa fa-plus-square"></span>&nbsp;Nueva Membresia</a>
								</div>
							</div>
						<?php } ?>
					<?php } ?>
					<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana">
						<div class="modal-dialog modal-lg">
							<div class="modal-content">

								<div class="modal-header">
									<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span>
									</button>
									<h4 class="modal-title" id="modal_titulo">Agregar Membresia</h4>
								</div>
								<form id="jkl" action="well_cuentas.php" method="post">
									<div class="modal-body" id="modal_cuerpo">
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Documento *</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="dc" id="dc" class="form-control" required value="<?php echo $_REQUEST['documento']; ?>" />
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Nombres</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="nombres" id="nombres" class="form-control" required value="<?php echo $nombre; ?>" />
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Apellidos</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="apellidos" id="apellidos" class="form-control" required value="<?php echo  $apellido; ?>" />
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Celular</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="celular" id="celular" class="form-control" required value="<?php echo $celular; ?>" />
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Tipo Membresia</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<select name="tipomiembro" id="tipomiembro" class="form-control" required>
													<option value="" selected>Seleccionar</option>
													<?php while (!$rs1->EOF) { ?>
														<option value="<?php echo $rs1->fields['idcuenta_tipo'] ?>"><?php echo $rs1->fields['descripcion'] . ' x Gs: ' . formatomoneda($rs1->fields['monto'], 2, 'N'); ?></option>
													<?php $rs1->MoveNext();
													} ?>
												</select>
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Profesional Vinculado</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<?php
												$buscar = "Select * from profesionales where estado <> 6 order by nombres,apellidos asc";
												$rs1 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
												?>
												<select name="profesional" id="profesional" class="form-control">
													<option value="" selected>Seleccionar</option>
													<?php while (!$rs1->EOF) { ?>
														<option value="<?php echo $rs1->fields['idprofe'] ?>"><?php echo $rs1->fields['nombres'] . ' ' . $rs1->fields['apellidos']; ?></option>
													<?php $rs1->MoveNext();
													} ?>
												</select>
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Id Cliente</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="idcliente" id="idcliente" class="form-control" readonly value="<?php echo $idcliente; ?>" />
											</div>
										</div>
										<div class="clearfix"></div>
										<input type="submit" class="btn-primary" value="Registrar Miembro" />
									</div>
								</form>
								<div class="modal-footer" id="modal_pie"></div>
							</div>
						</div>
					</div>

					<!----------------------------------------------------------------------->
					<div class="modal fade bs-example-modal-lg" tabindex="-1" role="dialog" aria-hidden="true" id="modal_ventana2">
						<div class="modal-dialog modal-lg">
							<div class="modal-content">
								<div class="modal-header">
									<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">×</span></button>
									<h4 class="modal-title" id="modal_titulo2">Vincular Profesional</h4>
								</div>
								<form id="jkl" action="well_cuentas.php" method="post">
									<div class="modal-body" id="modal_cuerpo2">
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Documento *</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" name="cedula" id="cedula" class="form-control" readonly value="<?php echo $_REQUEST['documento']; ?>" />

											</div>
										</div>

										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Profesional Vincular</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<?php
												$buscar = "Select * from profesionales where estado <> 6 order by nombres,apellidos asc";
												$rs1 = $conexion->Execute($buscar) or die(errorpg($conexion, $buscar));
												?>
												<select name="vincular" id="vincular" class="form-control" required>
													<option value="" selected>Seleccionar</option>
													<?php while (!$rs1->EOF) { ?>
														<option value="<?php echo $rs1->fields['idprofe'] ?>"><?php echo $rs1->fields['nombres'] . ' ' . $rs1->fields['apellidos']; ?></option>
													<?php $rs1->MoveNext();
													} ?>
												</select>
											</div>
										</div>
										<input type="hidden" name="ocmiembro" id="ocmiembro" value="<?php echo $idmembresia; ?>" />
										<div class="clearfix"></div>
										<input type="submit" class="btn-primary" value="Asignar profesional" />
									</div>
								</form>
								<div class="modal-footer" id="modal_pie2"></div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!-- /page content -->
			<script>
				function busca_cliente(idcampo, tipo) {
					var direccionurl = 'busqueda_cliente_cat.php';
					$("#procede_bt").hide();
					var parametros = {
						"m": '1',
						"idcampo": idcampo,
						"tipo": tipo
					};
					$.ajax({
						data: parametros,
						url: direccionurl,
						type: 'post',
						beforeSend: function() {
							$('#modal_ventana').modal('show');
							$("#modal_titulo").html('Busqueda de Cliente');
							$("#modal_cuerpo").html('Cargando...');
						},
						success: function(response) {
							$("#modal_cuerpo").html(response);
						}
					});
				}

				function asignar_profe() {

					$("#modal_ventana2").modal('show');
				}

				function membresia() {

					$('#modal_ventana').modal('show');
					//$("#modal_titulo").html('Busqueda de Cliente');
					//$("#modal_cuerpo").html('Cargando...');
				}
			</script>
			<?php require_once("../includes/pie_gen.php"); ?>
			<!-- /footer content -->
		</div>
	</div>
	<?php require_once("../includes/footer_gen.php"); ?>
</body>

</html>