<?php
require_once("../includes/conexion.php");
require_once("../includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$dirsup = 'S'; 
$modulo = "38";
$submodulo = "689";
require_once("../includes/rsusuario.php");

if ($_REQUEST['desde'] != '') {

	$fecha_desde = antisqlinyeccion($_REQUEST['desde'], 'date');
} else {

	$fecha_desde = date("Y-m-d");
	$fecha_desde = antisqlinyeccion($fecha_desde, 'date');
}

if ($_REQUEST['hasta'] != '') {

	$fecha_hasta = antisqlinyeccion($_REQUEST['hasta'], 'date');
} else {

	$fecha_hasta = date("Y-m-d");
	$fecha_hasta = antisqlinyeccion($fecha_hasta, 'date');
}

$proveedor = isset($_GET['proveedor']) ? trim(antisqlinyeccion($_GET['proveedor'], 'text')) : '';
if ($proveedor === NULL || $proveedor === 'NULL' || $proveedor === '') {

	$proveedor = '';
} else {

	$add .= " and p.nombre LIKE $proveedor";
}

$consulta = "SELECT 
              *
			      FROM (
				          SELECT
					          rao.*,
                    p.nombre 
				          FROM
                    registros_asistencias_override rao
                  INNER JOIN 
                    proveedores p ON p.pin = rao.pin
				          WHERE
					          DATE(rao.fecha_asistencia) BETWEEN $fecha_desde AND $fecha_hasta
					          $add
                  ORDER BY
				            rao.fecha_asistencia ASC
			          ) AS subquery;";
$rs = $conexion->Execute($consulta) or die(errorpg($conexion, $consulta));

$tregistros = $rs->RecordCount();
?>
<!DOCTYPE html>

<head>
	<?php require_once("../includes/head_gen.php"); ?>
</head>

<body class="nav-md">
	<div class="container body">
		<div class="main_container">
			<?php require_once("../includes/menu_gen.php"); ?>

			<!-- top navigation -->
			<?php require_once("../includes/menu_top_gen.php"); ?>

			<!-- page content -->
			<div class="right_col" role="main">
				<div class="">
					<div class="page-title"></div>
					<div class="clearfix"></div>
					<?php require_once("../includes/lic_gen.php"); ?>

					<div class="row">
						<div class="col-md-12 col-sm-12 col-xs-12">
							<div class="x_panel">
								<div class="x_title">
									<ul class="nav navbar-right panel_toolbox">
										<li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a></li>
									</ul>
									<div class="clearfix"></div>
								</div>
								<div class="x_content">
									<form id="hg" action="" method="get">
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Desde Fecha</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="date" name="desde" id="desde" class="form-control" value="<?php echo $_REQUEST['desde'] ?>" />
											</div>
										</div>
										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Hasta Fecha</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="date" name="hasta" id="hasta" class="form-control" value="<?php echo $_REQUEST['hasta'] ?>" />
											</div>
										</div>

										<div class="col-md-6 col-sm-6 form-group">
											<label class="control-label col-md-3 col-sm-3 col-xs-12">Proveedor</label>
											<div class="col-md-9 col-sm-9 col-xs-12">
												<input type="text" placeholder="Indique el proveedor" name="proveedor" id="proveedor" class="form-control" />
											</div>
										</div>

										<div class="clearfix"></div>
										<br />

										<div class="form-group">
											<div class="col-md-5 col-sm-5 col-xs-12 col-md-offset-5">
												<button type="submit" class="btn btn-default"><span class="fa fa-search"></span> Filtrar</button>
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>
					</div>

					<?php if ($tregistros > 0) { ?>

						<!-- SECCION -->
						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel">
									<div class="x_title">
										<h2>Total Accesos: <?php echo formatomoneda($tregistros); ?> encontrado(s).</h2>
										<ul class="nav navbar-right panel_toolbox">
											<li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
											</li>
										</ul>
										<div class="clearfix"></div>
									</div>
									<div class="x_content">
										<div class="col-md-12">
											<div class="table-responsive">
												<table width="100%" class="table table-bordered jambo_table bulk_action">
													<thead>
														<tr>
															<th align="center">Id Asistencia</th>
															<th align="center">Proveedor</th>
															<th align="center">Fecha asistencia</th>
														</tr>
													</thead>
													<tbody>
														<?php while (!$rs->EOF) { ?>
															<tr>
																<td align="center"><?php echo intval($rs->fields['idasistencia']); ?></td>
																<td align="center"><?php echo antixss($rs->fields['proveedor']); ?></td>
																<td align="center"><?php if ($rs->fields['fecha_asistencia'] != "") {
																						echo date("d/m/Y H:i:s", strtotime($rs->fields['fecha_asistencia']));
																					}  ?></td>
															</tr>
														<?php $rs->MoveNext();
														} //$rs->MoveFirst(); 
														?>
													</tbody>
												</table>
											</div>
										</div>
										<br />
									</div>
								</div>
							</div>
						</div>
					<?php } ?>
				</div>
			</div>
			<!-- footer content -->
			<?php require_once("../includes/pie_gen.php"); ?>
		</div>
	</div>
	<?php require_once("../includes/footer_gen.php"); ?>
</body>

</html>
