<?php 

class BigFile
{
    protected $file;
 
    public function __construct($filename, $mode = "r")
    {
        if (!file_exists($filename)) {
 
            throw new Exception("File not found");
 
        }
 
        $this->file = new SplFileObject($filename, $mode);
    }
 
    protected function iterateText()
    {
        $count = 0;
 
        while (!$this->file->eof()) {
 
            yield ($this->file->fgets());
 
            $count++;
        }
        return $count;
    }
 
    protected function iterateBinary($bytes)
    {
        $count = 0;
 
        while (!$this->file->eof()) {
 
            yield ($this->file->fread($bytes));
 
            $count++;
        }
    }
 
    public function iterate($type = "Text", $bytes = NULL)
    {
        if ($type == "Text") {
 
            return new NoRewindIterator($this->iterateText());
 
        } else {
 
            return new NoRewindIterator($this->iterateBinary($bytes));
        }
 
    }
}
/*
$largefile = new BigFile("file.csv");
 
$iterator = $largefile->iterate("Text"); // Text or Binary based on your file type
 
foreach ($iterator as $line) {
 
    echo $line;
 
}
*/
/*function gen_one_to_three() {
    for ($i = 1; $i <= 3; $i++) {
        // Observe que $i es preservado entre yields
        yield $i;
    }
}

$generator = gen_one_to_three();
foreach ($generator as $value) {
    echo "$value\n";
}*/
?>