<?php 
// Ruta del archivo configuracion del servidor
$ruta_archivo = '../1_conf_servidor.json';
// Leer el contenido del archivo
$contenido_archivo = file_get_contents($ruta_archivo);
if(!file_exists($ruta_archivo)){
	echo "No existe el archivo de configuracion del servidor.";
	exit;
}
// Decodificar el JSON en un array asociativo
$datos_servidor = json_decode($contenido_archivo, true);
$user_serv=$datos_servidor['user_serv'];
$dominio_serv=$datos_servidor['dominio_serv'];
$usuario_hosting=$user_serv;

$archivo_verifica="gfx/empresas/emp_1.png";

// lista todos los directorios del public_html que dentro de ellos contiene un directorio llamado ws/
function listar_directorios_ws($usuario_hosting,$inicio_dir){
	$dir="/home/$usuario_hosting/public_html/";
	$directorio = opendir($dir);
	
	global $archivo_verifica;
	
	//echo $dir;
	
	$archivos = array();
	$carpetas = array();
	//Carpetas y Archivos a excluir
	$excluir = array('.', '..', 'index.php', 'favicon.ico','folder.png','file.png','.dropbox.cache','.dropbox');
	
	
	while ($f = readdir($directorio)) {
		if (is_dir("$dir/$f") && !in_array($f, $excluir)) {
			if(file_exists("$dir/$f/ws/")){
				// descomentar si queremos filtar por nombre de inicio
				//if (strpos("$dir/$f/ws/", $inicio_dir) !== false) {
					$carpetas[] = $f;
				//}
			}
		} else if (!in_array($f, $excluir)){
			//No es una carpeta, por ende lo mandamos a archivos
			$archivos[] = $f;
		}
	}
	closedir($directorio);
	sort($carpetas,SORT_NATURAL | SORT_FLAG_CASE);
	//sort($archivos,SORT_NATURAL | SORT_FLAG_CASE);
	
	//Mostrar Carpetas
	$i = 1;
	$directorios=array();
	foreach ($carpetas as $c) {
		$directorios[]=$dir.''.$c."/".$archivo_verifica;
		$i++;
	}
	
	return $directorios;
//print_r($directorios);
}

$directorios=listar_directorios_ws($usuario_hosting,'');



function obtenerColoresDominantes($imagen, $numColores = 2)
{
    $img = imagecreatefrompng($imagen);
    $imgAncho = imagesx($img);
    $imgAlto = imagesy($img);
    $colores = [];
    for ($x = 0; $x < $imgAncho; $x++) {
        for ($y = 0; $y < $imgAlto; $y++) {
            $rgb = imagecolorat($img, $x, $y);
            $colores[] = sprintf("#%06X", $rgb);
        }
    }
    $colores = array_count_values($colores);
    arsort($colores);
    return array_slice(array_keys($colores), 0, $numColores, true);
} // Uso del código $coloresDominantes = obtenerColoresDominantes("ruta/a/tu/imagen.jpg"); print_r($coloresDominantes);


// copia de burgerfactory/pedidos/ a todos/pedidos/
$fichero_origen='/home/'.$usuario_hosting.'/public_html/maestro.'.$dominio_serv.'/'.$archivo_verifica;

?><html>
<head>
<script src="../js/jquery-1.10.2.min.js"></script>
<meta charset="utf-8">
<title>Sitios con Foto</title>
<script>
function IsJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}
function aplicar_sugerencia(url_cli,fondo,linea,token,id){
	if (window.confirm("Se aplicara los colores a: '"+url_cli+"'\n estas seguro?")) {
		var parametros = {
		  "fondo"   : fondo,
		  "linea"   : linea,
		  "token"   : token
		};
		$.ajax({		  
			data:  parametros,
			url:   url_cli+'/ws_colores.php',
			type:  'post',
			cache: false,
			timeout: 5000,  // I chose 3 secs for kicks: 5000
			crossDomain: true,
			beforeSend: function () {
				$("#box_msg").val('Cargando...');				
			},
			success:  function (response) {
				if(IsJsonString(response)){
					var obj = jQuery.parseJSON(response);
					if(obj.valido == 'S'){
						// Cambiar el color de fondo
						$("#aplicado_"+id).css("background-color", obj.fondo);
						// Cambiar el color del borde
						$("#aplicado_"+id).css("border-color", obj.linea);
						
						$("#box_msg").val('APLICADO!!!');	
					}else{
						alert('Errores: '+obj.errores);	
						$("#box_msg").html(nl2br(obj.errores));
						$("#box_msg").show();
					}
				}else{
					alert(response);	
				}
			},
			error: function(jqXHR, textStatus, errorThrown) {
				errores_ajax_manejador(jqXHR, textStatus, errorThrown, 'error');
			}
		}).fail( function( jqXHR, textStatus, errorThrown ) {
			errores_ajax_manejador(jqXHR, textStatus, errorThrown, 'fail');
		});
	
	} // if (window.confirm("Do you really want to leave?")) {
}
function nl2br (str, is_xhtml) {
  var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br ' + '/>' : '<br>'; // Adjust comment to avoid issue on phpjs.org display

  return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
}
function errores_ajax_manejador(jqXHR, textStatus, errorThrown, tipo){
	// error
	if(tipo == 'error'){
		if(jqXHR.status == 404){
			alert('Pagina no encontrada. '+jqXHR.status+' '+errorThrown);
		}else if(jqXHR.status == 0){
			alert('Se ha rechazado la conexión.');
		}else{
			alert(jqXHR.status+' '+errorThrown);
		}
	// fail
	}else{
		if (jqXHR.status === 0) {
			alert('No conectado: verifique la red.');
		} else if (jqXHR.status == 404) {
			alert('Pagina no encontrada [404]');
		} else if (jqXHR.status == 500) {
			alert('Internal Server Error [500].');
		} else if (textStatus === 'parsererror') {
			alert('Requested JSON parse failed.');
		} else if (textStatus === 'timeout') {
			alert('Tiempo de espera agotado, time out error.');
		} else if (textStatus === 'abort') {
			alert('Solicitud ajax abortada.'); // Ajax request aborted.
		} else {
			alert('Uncaught Error: ' + jqXHR.responseText);
		}
	}
}
</script>
</head>
<body>
<?php

echo "<strong>Clientes con Fotos:</strong>";
echo "<hr />";
//print_r($directorios);exit;

$i=1;
foreach($directorios as $fichero_destino){
	if($fichero_destino != $fichero_origen){
		// crea carpeta si no existe
		$micarpeta = $fichero_destino;
		if (file_exists($micarpeta)){
			//echo 'SI EXISTE:'.$micarpeta;echo "<br />";
			$sin_foto_url=str_replace('/home/'.$usuario_hosting.'/public_html/','',$micarpeta);
			$sin_foto_url=str_replace($archivo_verifica,'',$sin_foto_url);
			//echo '<a href="https://'.$sin_foto_url.'" target="_blank">https://'.$sin_foto_url.'</a><br />';
			$url_imagen='https://'.$sin_foto_url.''.$archivo_verifica.'';
			$url_colores='https://'.$sin_foto_url.'ws_colores.php';
			//echo $url_imagen.'<br />';
			//echo $micarpeta.'<br />';
			//echo $url_colores.'<br />';
			
			
			
			
			$datos_colores=file_get_contents($url_colores);
			$colores_aplicados=json_decode($datos_colores,true);
			$fondo_aplicado=$colores_aplicados['fondo'];
			$linea_aplicado=$colores_aplicados['linea'];
			
			$coloresDominantes = obtenerColoresDominantes($micarpeta); 
			//print_r($coloresDominantes);
			$fondo_sugerido=$coloresDominantes[0];
			$linea_sugerido=$coloresDominantes[1];
			
			if($fondo_sugerido != $fondo_aplicado && $linea_sugerido != $linea_aplicado){
				
				
				$token=md5('b5166ebc81b94e753d091d3665543c92+**+'.date("Ymd").$fondo_sugerido.$linea_sugerido);
				
				echo "[".$i."] <br />";
			
				echo '<a href="https://'.$sin_foto_url.'" target="_blank">https://'.$sin_foto_url.'</a><br /><br />';
				
				echo 'Actual: <div id="aplicado_'.$i.'" style="background-color:'.$fondo_aplicado.';border-bottom:3px solid '.$linea_aplicado.'; width:500px; text-align:center;"><img src="'.$url_imagen.'" height="100" /></div><br /><br />';
				echo 'Sugerido: <div id="sugerido_'.$i.'" style="background-color:'.$fondo_sugerido.';border-bottom:3px solid '.$linea_sugerido.'; width:500px; text-align:center;"><img src="'.$url_imagen.'" height="100" /></div><br /><br />';
				
				
				echo '<a href="javascript:void(0);" onclick="aplicar_sugerencia(\'https://' . $sin_foto_url . '\',\'' . $fondo_sugerido . '\',\'' . $linea_sugerido . '\',\'' . $token . '\',' . $i . ');">[Aplica Sugerencia]</a><br />';

				
				
				echo '
				<table border="1">
					<tr>
						<td> </td>
						<td>Fondo </td>
						<td>Linea</td>
					</tr>
					<tr>
						<td >Sugerido</td>
						<td style="background-color:'.$fondo_sugerido.';">'.$fondo_sugerido.'</td>
						<td style="background-color:'.$linea_sugerido.';">'.$linea_sugerido.'</td>
					</tr>
					<tr>
						<td >Actual</td>
						<td style="background-color:'.$fondo_aplicado.';">'.$fondo_aplicado.'</td>
						<td style="background-color:'.$linea_aplicado.';">'.$linea_aplicado.'</td>
					</tr>
				</table>';
				
				echo "<hr />";
				
				$i++;
			
			} // if($fondo_sugerido != $fondo_aplicado && $linea_sugerido != $linea_aplicado){

		}else{
			//echo 'NO EXISTE:'.$micarpeta;echo "<br />";
		}
	}
}


?>
</body>
</html>