<?php
// Función para copiar archivos y directorios recursivamente
function copiarDirectorio($origen, $destino) {
	
    // Verificar si el directorio de origen existe
    if (!is_dir($origen)) {
        echo "El directorio de origen no existe.";
        return false;
    }

    // Crear el directorio de destino si no existe
    if (!is_dir($destino)) {
        if (!mkdir($destino, 0777, true)) {
            echo "No se pudo crear el directorio destino: $destino";
            return false;
        }
    }
	
    // Verificar si ya existe una carpeta "ws" en el directorio de destino
    if (is_dir($destino . '/ws')) {
        //return false;
		echo "Bloqueado, no se puede copiar xq ya tiene archivos ws";
		return false;
		//exit;
    }

    // Usamos RecursiveDirectoryIterator para recorrer los directorios y subdirectorios
    $iterator = new RecursiveIteratorIterator(
        new RecursiveDirectoryIterator($origen, RecursiveDirectoryIterator::SKIP_DOTS),
        RecursiveIteratorIterator::SELF_FIRST
    );

    // Recorrer todos los elementos (archivos y directorios) de manera recursiva
    foreach ($iterator as $archivo) {
        $destinoPath = $destino . DIRECTORY_SEPARATOR . $iterator->getSubPathName();

        // Si es un directorio, crear el directorio en el destino
        if ($archivo->isDir()) {
            if (!is_dir($destinoPath)) {
                if (!mkdir($destinoPath, 0777, true)) {
                    echo "No se pudo crear el directorio: $destinoPath";
                    return false;
                }
            }
        }
        // Si es un archivo, copiarlo
        else {
            if (!copy($archivo, $destinoPath)) {
                echo "No se pudo copiar el archivo: " . $archivo;
                return 0;
            }
        }

        // Copiar los permisos del archivo o directorio original
        chmod($destinoPath, $archivo->getPerms());
    }

    return 1;
}
function replaceConnectionLines($file, $usuario, $contrasena, $database) {
    // Leer el contenido completo del archivo
    $content = file_get_contents($file);
	
    // Limpieza y validación de las variables recibidas
    $usuario = trim(htmlspecialchars($usuario));
    $contrasena = trim($contrasena); // no poner aca el htmlspecialchars
    $database = trim(htmlspecialchars($database));
	
	// conversiones
	$search_p = array("'",'"','$','\'','/','&');
	$replace_p = array('','','[dolarsing]','','','');
	$contrasena = str_replace($search_p, $replace_p, $contrasena);

    // Escapado de comillas en las variables
    $usuario = addslashes($usuario);
    $contrasena = addslashes($contrasena);
    $database = addslashes($database);	
	

    
    // Reemplazar las líneas con los nuevos valores
    $search = [
        'echo \'MODIFICAR ARCHIVO DE CONEXION\';exit;',
        '$usuario=\'<usuario>\';',
        '$contrasena=\'<contrasena>\';',
        '$database=\'<database>\';'
    ];

    $replace = [
        "// echo 'MODIFICAR ARCHIVO DE CONEXION';exit;",
        "\$usuario='{$usuario}';",
        "\$contrasena='{$contrasena}';",
        "\$database='{$database}';"
    ];

    $newContent = str_replace($search, $replace, $content);
	
	
	$newContent = str_replace('[dolarsing]', '$', $newContent);
	$newContent = str_replace('&amp;', '&', $newContent);
	//echo $newContent;exit;
    
    // Escribir el nuevo contenido en el archivo
    file_put_contents($file, $newContent);
}





//print_r($_REQUEST);exit;
//Array ( [clase] => 2 [origen] => servid21_maestro [destino] => servid21_demobar [prima] => servid21 [abuela] => Inversiones2022++1912 )
//( [idcliente] => 1293 [url_generada] => newstore.store.com.py [dominio_ppal] => store.com.py [usuario_ppal] => storec15 
//[usuario_bd] => storec15_newstore [database] => storec15_newstore [clave_db] => [evento] => 1 [clase] => 1 )

$clase=intval($_REQUEST['clase']);
$usuario_ppal=trim($_REQUEST['usuario_ppal']);
$dominio_ppal=trim($_REQUEST['dominio_ppal']);
$url=trim($_REQUEST['url_generada']);
$usuario_bd=trim($_REQUEST['usuario_bd']);
$clave_bd=trim($_REQUEST['clave_db']);
$nombre_bd=trim($_REQUEST['database']);

if($clase==1){
	//copia de archivos
	//$origen="maestro.".trim($_REQUEST['dominio_ppal']);
	///$destino=trim($_REQUEST['url_generada']);
	
	$origen = '/home/'.$usuario_ppal.'/public_html/maestro.'.$dominio_ppal;  // Reemplaza con el directorio de origen
	$destino = '/home/'.$usuario_ppal.'/public_html/'.$url;  // Reemplaza con el directorio de destino

	//print_r($_REQUEST);exit;
	$ver=copiarDirectorio($origen, $destino);
	
	if(intval($ver)==1){
		
		//Si salio todo bien, le metemos el usuario y la clave al de conexion
		//$archivo = "$destino/includes/conexion.php";

		// Llamar a la función para reemplazar las líneas en el archivo de conexión
		$conexionFile = $destino . '/includes/conexion.php';
		replaceConnectionLines($conexionFile, $usuario_bd, $clave_bd, $nombre_bd);
		echo "OK";
	} else{
		echo "NO";
		
	}
}


?>