<?php
require_once("includes/conexion.php");
require_once("includes/funciones.php");
// nombre del modulo al que pertenece este archivo
$modulo="1";
$submodulo="2";
require_once("includes/rsusuario.php"); 

function limpiacsv($txt){
	global $saltolinea;
	$txt=trim($txt);
	$txt=str_replace(";",",",$txt);
	$txt=str_replace($saltolinea,"",$txt);
	return $txt;
}

function genera_archivo_csv_shopping($parametros_array){

	global $conexion;
	global $saltolinea;

	$nombre_archivo=antixss($parametros_array['nombre_archivo']);
	$ruta_archivo=antixss($parametros_array['ruta_archivo']);
	$fecha_desde=antisqlinyeccion($parametros_array['fecha_desde'],"text");
	$fecha_hasta=antisqlinyeccion($parametros_array['fecha_hasta'],"text");
	$idsucursal=antisqlinyeccion($parametros_array['idsucursal'],"int");
	if(intval($idsucursal) == 0){
		echo "No se envio idsucursal";
		exit;
	}

	// ruta completa
	$ruta_completa=$ruta_archivo.''.$nombre_archivo;

	// Nombre del archivo CSV en el servidor
	$nombreArchivo = $ruta_completa.'.csv';

    // Comprobar si la carpeta existe, y si no, crearla
    if (!file_exists($ruta_archivo)) {
        mkdir($ruta_archivo, 0777, true);
    }

	// Abre el archivo en modo de escritura
	$archivo = fopen($nombreArchivo, 'w');

	$consulta="
	SELECT ventas.idventa, 
		ventas.ruc as ruc,
		CASE WHEN
				ventas.ruc = '44444401-7'
				OR ventas.ruc = 'X'
				OR ventas.ruc = 'XXX'
		THEN
			'SIN NOMBRE'
		ELSE
			SUBSTR(ventas.razon_social, 1, 250)
		END AS razon_social,
		date(ventas.fecha) as fecha_comprobante,
		ventas.fecha as fecha_hora_comprobante,
		CONCAT(SUBSTRING(REPLACE(ventas.factura,'-',''), 1, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 4, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 7, 7)) as comprobante,
		'FACTURA' as tipo_comprobante,
		CASE WHEN ventas.estado =  6 THEN 'ANULADO' ELSE 'VIGENTE' END as estado_comprobante,
		CASE WHEN 
			(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
		THEN
			REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 10),0),0),'.',',')
		ELSE
			REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=10),0),0),'.',',')
		END as gravadas_10, 

		CASE WHEN 
			(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
		THEN
			REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 5),0),0),'.',',')
		ELSE
			REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=5),0),0),'.',',')
		END as gravadas_5,
		CASE WHEN 
			(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
		THEN
			REPLACE(ROUND(COALESCE((Select sum(monto_col) as subtotal from ventas_detalles_impuesto where idventa=ventas.idventa and iva_porc_col=0),0),0),'.',',')
		ELSE
			REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=0),0),0),'.',',')
		END as exentas,
		REPLACE(ROUND(COALESCE(ventas.totalcobrar,0),0),'.',',') as monto_comprobante,
		case when ventas.tipo_venta = 1 then 'CONTADO' ELSE 'CREDITO' END AS condicion,
		0 as tipocambio,
		'GS' AS moneda,
		 ventas.anulado_el,
		ventas.idcaja,
		CONCAT(ELT(WEEKDAY(fecha)+1, 
		'Lunes', 'Martes', 'Miercoles', 'Jueves', 'Viernes', 'Sabado', 'Domingo')) AS dia_semana,
		(
			SELECT GROUP_CONCAT(CONCAT(formas_pago.descripcion, ' (', ROUND(REPLACE(gest_pagos_det.monto_pago_det,'.',','),0), ')') SEPARATOR ', ') AS formapago 
			from gest_pagos_det 
			inner join gest_pagos on gest_pagos.idpago = gest_pagos_det.idpago
			inner join formas_pago on formas_pago.idforma = gest_pagos_det.idformapago
			where 
			gest_pagos.idventa = ventas.idventa
			and gest_pagos.estado <> 6
			order by formas_pago.descripcion asc
		 ) as 'Forma de Pago'
		FROM ventas
		INNER JOIN cliente ON cliente.idcliente = ventas.idcliente
		WHERE
		ventas.finalizo_correcto = 'S'
		and ventas.excluye_repven = 0 
		and ventas.estado <> 6
		and ventas.factura is not null
		and ventas.sucursal = $idsucursal
		and date(ventas.fecha) >= $fecha_desde
		and date(ventas.fecha) <= $fecha_hasta
		order by idventa desc
	";
	$rs = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

	$datos="";


	// asigna los datos de la consulta a una variable
	$array=$rs->fields;

	// CONSTRUYE CABECERA
	foreach($array as $key=>$value){
		$i++;
		$datos.=limpiacsv($key).';';
	}
	reset($array);
	$datos.=$saltolinea;

	// imprime cabecera
	//echo $datos;

	// Escribe la cabecera en el archivo
	fwrite($archivo, $datos);


	//CONSTRUYE CUERPO
	$fila=1;
	while (!$rs->EOF){
		$fila++;
		$array=$rs->fields;
		$i=0;
		$linea = '';
		foreach($array as $key=>$value){
			$i++;
			//echo limpiacsv($value).';';
			$linea .= limpiacsv($value) . ';';
		}
		//echo $saltolinea;
		$linea .= $saltolinea;

		// Escribe la línea en el archivo
		fwrite($archivo, $linea);

	$rs->MoveNext(); }

	// Cierra el archivo
	fclose($archivo);

	$res=array(
		'valido' => 'S',
		'errores' => $errores,
		'nombre_archivo' => $nombre_archivo
	);

	return $res;

}
/*
$nombre_archivo='shopping_'.date("YmdHis").$idsucursal;
$ruta_archivo='gfx/shopping/';

$parametros_array=array(
	'nombre_archivo' => $nombre_archivo,
	'ruta_archivo' => $ruta_archivo,
	'fecha_desde' => '2023-11-01',
	'fecha_hasta' => '2023-11-31',
	'idsucursal' => $idsucursal,
);
$res=genera_archivo_csv_shopping($parametros_array);

//unlink($nombre_archivo);

print_r($res);*/

?>