<?php

function informar_shopping_valida_mcalymariano($parametros_array){
	global $conexion;
	global $saltolinea;
	global $ahora;
	
	$valido='S';
	$errores='';
	
	$idsucursal_sistema = intval($parametros_array['idsucursal_sistema']);
	$fecha_forzar=$parametros_array['fecha_forzar']; // opcional, si no se envia toma la mas antigua sin informar
	
	if($idsucursal_sistema == 0){
		$valido='N';
		$errores.='- No se envio el idsucursal del sistema.<br />'.$saltolinea;
	}
	
	$consulta="
	select empresa from empresas limit 1
	";
	$rsemp = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$empresa_nombre=antixss($rsemp->fields['empresa']);
	
	// si envio la sucursal valida que este activa y asignada al shopping 
	if($idsucursal_sistema > 0){
		$consulta="
		SELECT *
		FROM shopping_sucursales
		where 
		idsucursal_sistema = $idsucursal_sistema
		and estado <> 6
		order by idshoppingsuc asc
		limit 1
		";
		$rsshop = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idsucursal_sistema=intval($rsshop->fields['idsucursal_sistema']);
		$idshopping=intval($rsshop->fields['idshopping']);
		if(intval($idsucursal_sistema) == 0){
			$errores.='- No hay sucursal asignada para el shopping.<br />'.$saltolinea;
			$valido='N';
		}
	}
	

	// buscar si hay fechas anteriores sin informar (activas y anuladas), si hay sobrescribir
	$consulta="
	select idventa, date(ventas.fecha) AS fecha
	from ventas 
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado <> 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) < '$fecha'
	and date(ventas.fecha) >= '$ayer'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante <> 6 and estado_log = 1)

	UNION ALL

	select idventa, date(ventas.fecha) AS fecha
	from ventas 
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado = 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) < '$fecha'
	and date(ventas.fecha) >= '$ayer'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante = 6 and estado_log = 1)
	order by fecha asc
	";
	$rsant=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if(intval($rsant->fields['idventa']) > 0){
		$fecha=date("Y-m-d",strtotime($rsant->fields['fecha']));
	}

	// sobreescribir fecha si se envio
	if(trim($parametros_array['fecha_forzar']) != ''){
		$fecha=date("Y-m-d",strtotime($parametros_array['fecha_forzar']));
	}

	$consulta="
	SELECT idshopping, shopping, estado, url_shopping
	FROM shopping 
	where 
	idshopping = $idshopping
	";
	$rsconf = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$shopping_txt=antixss($rsconf->fields['shopping']);

	$consulta="
	SELECT `idshoppingsuc`, `idsucursal_sistema`, `idshopping`, `token`, `contrato`, `estado`, `registrado_por`, `registrado_el`,
	(select nombre from sucursales where idsucu = shopping_sucursales.idsucursal_sistema) as sucursal_sistema
	FROM shopping_sucursales 
	where 
	idshopping = $idshopping
	and idsucursal_sistema = $idsucursal_sistema
	and estado = 1
	";
	$rsconfsuc = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$sucursal_sistema=antixss($rsconfsuc->fields['sucursal_sistema']);

	// CONFIGURACION
	$url_shopping=$rsconf->fields['url_shopping'];
	$Bearer_token=$rsconfsuc->fields['token'];
	$contrato=$rsconfsuc->fields['contrato']; // C0000000879 // C0000000695
	$idsucursal_sistema=$rsconfsuc->fields['idsucursal_sistema'];


	// validaciones bd
	if(intval($idsucursal_sistema) == 0){
		$errores.='- La sucursal enviada '.$sucursal_sistema.' no esta vinculada al shopping '.$shopping_txt.'.<br />'.$saltolinea;
		$valido='N';
	}
	if(trim($Bearer_token) == ''){
		$errores.='- No se cargo el TOKEN del shopping '.$shopping_txt.' para la sucursal '.$sucursal_sistema.'.<br />'.$saltolinea;
		$valido='N';
	}
	if(trim($contrato) == ''){
		$errores.='- No se cargo el CONTRATO  del shopping '.$shopping_txt.' para la sucursal '.$sucursal_sistema.'.<br />'.$saltolinea;
		$valido='N';
	}
	if(trim($url_shopping) == ''){
		$errores.='- No se cargo la URL del webservice del shopping '.$shopping_txt.' para la sucursal '.$sucursal_sistema.'.<br />'.$saltolinea;
		$valido='N';
	}
	
	$res=array(
		'valido' => $valido,
		'errores' => $empresa_nombre.':<br />'.$saltolinea.$errores
	);
	return $res;
	
}

function informar_shopping_envia_mcalymariano($parametros_array){
	global $conexion;
	global $saltolinea;
	global $ahora;
	
	
	
	$fecha=date("Y-m-d");
	$ayer=date("Y-m-d",strtotime($fecha."- 1 days")); 
	$fecha_forzar=$parametros_array['fecha_forzar']; // opcional, si no se envia  toma la actual por defecto
	
	// parametros de entrada (no mover arriba)
	$idsucursal_sistema = intval($parametros_array['idsucursal_sistema']);
	
	$consulta="
	select empresa from empresas limit 1
	";
	$rsemp = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$empresa_nombre=antixss($rsemp->fields['empresa']);

	// buscar si hay fechas anteriores sin informar (activas y anuladas), si hay sobrescribir
	$consulta="
	select idventa, date(ventas.fecha) AS fecha
	from ventas 
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado <> 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) < '$fecha'
	and date(ventas.fecha) >= '$ayer'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante <> 6 and estado_log = 1)

	UNION ALL

	select idventa, date(ventas.fecha) AS fecha
	from ventas 
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado = 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) < '$fecha'
	and date(ventas.fecha) >= '$ayer'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante = 6 and estado_log = 1)
	order by fecha asc
	";
	$rsant=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	if(intval($rsant->fields['idventa']) > 0){
		$fecha=date("Y-m-d",strtotime($rsant->fields['fecha']));
	}
	// sobreescribir fecha si se envio
	if(trim($parametros_array['fecha_forzar']) != ''){
		$fecha=date("Y-m-d",strtotime($parametros_array['fecha_forzar']));
	}
	
	// obtiene el shopping
	$consulta="
	SELECT *
	FROM shopping_sucursales
	where 
	idsucursal_sistema = $idsucursal_sistema
	and estado <> 6
	order by idshoppingsuc asc
	limit 1
	";
	$rsshop = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idshopping=intval($rsshop->fields['idshopping']);

	$consulta="
	SELECT idshopping, shopping, estado, url_shopping
	FROM shopping 
	where 
	idshopping = $idshopping
	";
	$rsconf = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$shopping_txt=htmlentities($rsconf->fields['shopping']);

	$consulta="
	SELECT `idshoppingsuc`, `idsucursal_sistema`, `idshopping`, `token`, `contrato`, `estado`, `registrado_por`, `registrado_el`,
	(select nombre from sucursales where idsucu = shopping_sucursales.idsucursal_sistema) as sucursal_sistema
	FROM shopping_sucursales 
	where 
	idshopping = $idshopping
	and idsucursal_sistema = $idsucursal_sistema
	and estado = 1
	";
	$rsconfsuc = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$sucursal_sistema=antixss($rsconfsuc->fields['sucursal_sistema']);

	// CONFIGURACION
	$url_shopping=$rsconf->fields['url_shopping'];
	$Bearer_token=$rsconfsuc->fields['token'];
	$contrato=$rsconfsuc->fields['contrato']; // C0000000879 // C0000000695
	$idsucursal_sistema=$rsconfsuc->fields['idsucursal_sistema'];

	// datos para informar
	$consulta="
	SELECT ventas.idventa,
	ventas.ruc as ruc,
	CASE WHEN
			ventas.ruc = '44444401-7'
			OR ventas.ruc = 'X'
			OR ventas.ruc = 'XXX'
	THEN
		'SIN NOMBRE'
	ELSE
		SUBSTR(ventas.razon_social, 1, 250)
	END AS razon_social,
	date(ventas.fecha) as fecha_comprobante,
	CONCAT(SUBSTRING(REPLACE(ventas.factura,'-',''), 1, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 4, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 7, 7)) as comprobante,
	'FACTURA' as tipo_comprobante,
	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 10),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=10),0),0),'.',',')
	END as gravadas_10, 

	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 5),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=5),0),0),'.',',')
	END as gravadas_5,
	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((Select sum(monto_col) as subtotal from ventas_detalles_impuesto where idventa=ventas.idventa and iva_porc_col=0),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=0),0),0),'.',',')
	END as exentas,
	REPLACE(ROUND(COALESCE(ventas.totalcobrar,0),0),'.',',') as monto_comprobante,
	case when ventas.tipo_venta = 1 then 'CONTADO' ELSE 'CREDITO' END AS condicion,
	'GS' AS moneda,
	ventas.estado as estado, ventas.anulado_el
	FROM ventas
	INNER JOIN cliente ON cliente.idcliente = ventas.idcliente
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado <> 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) = '$fecha'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante <> 6 and estado_log = 1)

	UNION ALL

	SELECT ventas.idventa,
	ventas.ruc as ruc,
	CASE WHEN
			ventas.ruc = '44444401-7'
			OR ventas.ruc = 'X'
			OR ventas.ruc = 'XXX'
	THEN
		'SIN NOMBRE'
	ELSE
		SUBSTR(ventas.razon_social, 1, 250)
	END AS razon_social,
	date(ventas.fecha) as fecha_comprobante,
	CONCAT(SUBSTRING(REPLACE(ventas.factura,'-',''), 1, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 4, 3),'-',SUBSTRING(REPLACE(ventas.factura,'-',''), 7, 7)) as comprobante,
	'FACTURA' as tipo_comprobante,
	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 10),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=10),0),0),'.',',')
	END as gravadas_10, 

	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((select sum(monto_col) from ventas_detalles_impuesto where idventa = ventas.idventa and ventas_detalles_impuesto.iva_porc_col = 5),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=5),0),0),'.',',')
	END as gravadas_5,
	CASE WHEN 
		(select idventa from ventas_detalles_impuesto where idventa = ventas.idventa limit 1) > 0
	THEN
		REPLACE(ROUND(COALESCE((Select sum(monto_col) as subtotal from ventas_detalles_impuesto where idventa=ventas.idventa and iva_porc_col=0),0),0),'.',',')
	ELSE
		REPLACE(ROUND(COALESCE((Select sum(subtotal) as subtotal from ventas_detalles where idventa=ventas.idventa and iva=0),0),0),'.',',')
	END as exentas,
	REPLACE(ROUND(COALESCE(ventas.totalcobrar,0),0),'.',',') as monto_comprobante,
	case when ventas.tipo_venta = 1 then 'CONTADO' ELSE 'CREDITO' END AS condicion,
	'GS' AS moneda,
	ventas.estado as estado, ventas.anulado_el
	FROM ventas
	INNER JOIN cliente ON cliente.idcliente = ventas.idcliente
	WHERE
	ventas.finalizo_correcto = 'S'
	and ventas.excluye_repven = 0 
	and ventas.estado = 6
	and ventas.factura is not null
	and ventas.sucursal = $idsucursal_sistema
	and date(ventas.fecha) = '$fecha'
	and ventas.idventa not in (select idventa from shoppings_informa where estado_comprobante = 6 and estado_log = 1)
	ORDER by fecha_comprobante asc, comprobante asc
	";
	//echo $consulta;exit;
	$rsvdet = $conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
	$idventa=intval($rsvdet->fields['idventa']);

	if($idventa == 0){
		$fecha_txt=date("d/m/Y",strtotime($fecha));
		echo $empresa_nombre.": NO HAY VENTAS PARA INFORMAR EN LA FECHA SELECCIONADA [$fecha_txt] | Suc: $sucursal_sistema | Shopping: $shopping_txt.'.<br />".$saltolinea;
		//exit;
	}
	if($idventa > 0){
		// date(ventas.fecha) = '$fecha'
		//echo $fecha;
		$json_env=array();

		$json_env['contrato'] = $contrato;
		$json_env['fecha'] = date("d-m-Y",strtotime($fecha)); // fecha envio no de la factura pero debe ser la misma
		//$json_env['ventas'] = array();
		//echo $rsvdet->fields['idventa'];; 
		$i=0;
		while(!$rsvdet->EOF){
			$estado=$rsvdet->fields['estado'];

			$json_env['ventas'][$i]['comprobante']=$rsvdet->fields['comprobante'];
			$json_env['ventas'][$i]['fecha']=date("d-m-Y",strtotime($rsvdet->fields['fecha_comprobante']));
			$json_env['ventas'][$i]['moneda']="GS";
			$json_env['ventas'][$i]['tipoCambio']="0";
			$json_env['ventas'][$i]['gravadas10']=$rsvdet->fields['gravadas_10'];
			$json_env['ventas'][$i]['gravadas5']=$rsvdet->fields['gravadas_5'];
			$json_env['ventas'][$i]['exentas']=$rsvdet->fields['exentas'];
			$json_env['ventas'][$i]['total']=$rsvdet->fields['monto_comprobante'];
			$json_env['ventas'][$i]['cliente']=limpiar_json_shopping($rsvdet->fields['razon_social']);
			$json_env['ventas'][$i]['ruc']=limpiar_json_shopping($rsvdet->fields['ruc']);
			if($estado == 6){
				$json_env['ventas'][$i]['anulado']=date("d/m/Y",strtotime($rsvdet->fields['anulado_el']));
				$json_env['ventas'][$i]['tipo']="AFACT";
			}else{
				$json_env['ventas'][$i]['tipo']="FACT";
			}
			$i++;
		$rsvdet->MoveNext(); }
		$rsvdet->MoveFirst();

		//print_r($json_env);exit;
		//$respuesta=json_encode($json_env, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT);
		$json_envio=json_encode($json_env, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
		//echo $respuesta;
		//print_r($json_env);
		//exit;

		$json_envio_ins=antisqlinyeccion($json_envio,"textbox");

		// inserta el log
		$consulta="
		insert into log_shoppings
		(json_envio, json_respuesta, registrado_por, registrado_el, estado, idsucursal_sistema, idshopping)
		values
		($json_envio_ins, NULL, 0, '$ahora', 1, $idsucursal_sistema, $idshopping)
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		// consulta ultimo log
		$consulta="
		SELECT idlogshopping 
		FROM log_shoppings 
		where 
		registrado_por = 0
		and registrado_el = '$ahora' 
		order by idlogshopping desc 
		limit 1
		";
		$rslog=$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));
		$idlogshopping=intval($rslog->fields['idlogshopping']);

		// insertar como informado
		while(!$rsvdet->EOF){
			$estado_comprobante=intval($rsvdet->fields['estado']);
			$idventa=intval($rsvdet->fields['idventa']);
			$consulta="
			insert into shoppings_informa
			(idshopping, idventa, estado_comprobante, estado_log, iditipocomprobante, registrado_por, registrado_el, idlogshopping)
			values
			($idshopping, $idventa, $estado_comprobante, 6, 1, 0, '$ahora', $idlogshopping)
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

		$rsvdet->MoveNext(); }

		// INICIO enviar informacion al shopping 
		$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL => $url_shopping,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => '',
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => 'POST',
		  CURLOPT_POSTFIELDS =>$json_envio,
		  CURLOPT_HTTPHEADER => array(
			'Authorization: Bearer '.$Bearer_token,
			'Content-Type: application/json'
		  ),
		));

		$response = curl_exec($curl);

		curl_close($curl);
		// FIN enviar informacion al shopping 


		// actualiza log con respuesta
		$json_respuesta_ins=antisqlinyeccion($response,"textbox");
		$consulta="
		update  log_shoppings 
		set 
		json_respuesta = $json_respuesta_ins
		where 
		idlogshopping = $idlogshopping
		";
		$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));



		// respuesta del shopping 
		$res=json_decode($response,true);
		if($res['mensaje'] == 'Registrado con exito'){

			// marca  los registros como correctos solo si el shoppinng respondio que es valido
			$consulta="
			update shoppings_informa
			set
			estado_log = 1
			where
			idlogshopping = $idlogshopping
			";
			$conexion->Execute($consulta) or die(errorpg($conexion,$consulta));

			//header("location: ../inf_reporte_shopping.php?enviado=1&shopping=$idshopping");exit;
			$respuesta=$empresa_nombre.": La fecha: ".date("d/m/Y",strtotime($fecha))." Suc: $sucursal_sistema fue informada al shopping '$shopping_txt' exitosamente!".$saltolinea;
			echo $respuesta;


		}else{
			$errores=$empresa_nombre.': <strong>ERROR:</strong><br />'.$response.$saltolinea;
			echo $errores;

		}

	} // if($idventa > 0){
	
}

?>