<?php
    /**
     * Obtener los productos destacados
     */
    function obtenerProductosDestacados( $pConexion, $pIdempresa, $pAhorad, $pSession_id, $pLimit, $pRutaImg )
    {
        $sql = "
            Select productos.idprod_serial, ROUND(productos.precio_venta, 0) as precio_venta, productos.descripcion, 
            productos.descripcion_larga, categorias.nombre as categoria, sub_categorias.descripcion as subcategoria,
            (select idprod from recetas_detalles where recetas_detalles.idprod = productos.idprod_serial limit 1) as receta,
            (select idproducto from agregado where agregado.idproducto = productos.idprod_serial limit 1) as agregado,
            (select idproducto from producto_impresora where producto_impresora.idproducto = productos.idprod_serial limit 1) as tieneimpre,
            (select marca from marca where marca.idmarca = productos.idmarca and idempresa = $pIdempresa) as marca,
            (select idproducto from web_carrito_det where id_ses = '$pSession_id' and idproducto = productos.idprod_serial limit 1) as en_carrito,
            (select precio from productos_sucursales where idproducto = productos.idprod_serial and idsucursal = 1) as p1,
                (
                select ROUND( oferta_detalles.precio_oferta, 0 )
                from oferta 
                inner join oferta_detalles on oferta.idoferta = oferta_detalles.idoferta
                where 
                oferta_detalles.idproducto = productos.idprod_serial 
                and productos.idempresa = $pIdempresa 
                and oferta.idempresa = $pIdempresa
                and oferta_detalles.idempresa = $pIdempresa
                and oferta.inicio <= '$pAhorad'
                and oferta.fin >= '$pAhorad'
                and oferta.estado = 3
                ) as precio_oferta
            from productos 
            inner join categorias on productos.idcategoria = categorias.id_categoria 
            inner join sub_categorias on productos.idsubcate = sub_categorias.idsubcate 
            where 
            productos.borrado = 'N'
            and productos.web_muestra = 'S'
            and productos.web_destacado = 'S'
            and productos.idempresa = $pIdempresa
            and productos.idtipoproducto in (1,2,4)
            order by combo asc, combinado asc, productos.descripcion asc
            limit $pLimit";

        $rs = $pConexion->Execute($sql) or die(errorpg($pConexion,$sql));
        $productos['datos'] = [];

        foreach ( $rs as $key => $value )
        {
            // crea imagen
            $id  = $value['idprod_serial'];
            $img = "$pRutaImg/wprod_$id.jpg";	 

            if( !file_exists( $img ) )
            {
                $img = "$pRutaImg/wprod_0.jpg";
            }

            $descripcion = substr( $value['descripcion'], 0, 30 );
            $precio      = ( !empty( $value['precio_oferta'] ) ) ? $value['precio_oferta'] : $value['precio_venta'];

            $datos = [
                'idprodserial'      => $value['idprod_serial'],
                'descripcion'       => $descripcion,
                'imagen'            => $img,
                'marca'             => $value['marca'],
                'descripcionlarga'  => $value['descripcion_larga'],
                'precio'            => $precio
            ];

            array_push($productos['datos'], $datos);
        }

        return $productos;
    }

    /**
     * Obtener los productos en promoción
     */
    function obtenerProductosPromocion( $pConexion, $pIdempresa, $pAhorad, $pSession_id, $pLimit, $pRutaImg )
    {
        $idPromo = obtenerIdPromoActiva( $pConexion, $pIdempresa, $pAhorad );

        //si no existe idpromo, entonces mostrar productos destacados
        if( empty( $idPromo ) )
        {
            return obtenerProductosDestacados( $pConexion, $pIdempresa, $pAhorad, $pSession_id, $pLimit, $pRutaImg );
        }

        $sql = "
            Select productos.idprod_serial, ROUND(productos.precio_venta, 0) as precio_venta, productos.marca, productos.descripcion, 
            productos.descripcion_larga, categorias.nombre as categoria, sub_categorias.descripcion as subcategoria,
            (select idprod from recetas_detalles where recetas_detalles.idprod = productos.idprod_serial limit 1) as receta,
            (select idproducto from agregado where agregado.idproducto = productos.idprod_serial limit 1) as agregado,
            (select idproducto from producto_impresora where producto_impresora.idproducto = productos.idprod_serial limit 1) as tieneimpre,
            (select marca from marca where marca.idmarca = productos.idmarca and idempresa = $pIdempresa) as marca,
            (select idproducto from web_carrito_det where id_ses = '$pSession_id' and idproducto = productos.idprod_serial limit 1) as en_carrito,
            (select precio from productos_sucursales where idproducto = productos.idprod_serial and idsucursal = 1) as p1,
                (
                select ROUND( oferta_detalles.precio_oferta, 0 )
                from oferta 
                inner join oferta_detalles on oferta.idoferta = oferta_detalles.idoferta
                where 
                oferta_detalles.idproducto = productos.idprod_serial 
                and productos.idempresa = $pIdempresa 
                and oferta.idempresa = $pIdempresa
                and oferta_detalles.idempresa = $pIdempresa
                and oferta.inicio <= '$pAhorad'
                and oferta.fin >= '$pAhorad'
                and oferta.estado = 3
                ) as precio_oferta
            from productos 
            inner join categorias on productos.idcategoria = categorias.id_categoria 
            inner join sub_categorias on productos.idsubcate = sub_categorias.idsubcate 
            where 
            productos.borrado = 'N'
            and productos.web_muestra = 'S'
            and productos.idempresa = $pIdempresa
            and productos.idtipoproducto in (1,2,4)
            and productos.idprod_serial in (select idprod from promociones_detalles where idpromo = $idPromo and idempresa = $pIdempresa)
            order by combo desc, combinado desc, productos.descripcion asc
            limit $pLimit";

        $rs = $pConexion->Execute($sql) or die(errorpg($pConexion,$sql));
        $productos['datos'] = [];
        
        foreach ( $rs as $key => $value )
        {
            // crea imagen
            $id  = $value['idprod_serial'];
            $img = "$pRutaImg/wprod_$id.jpg";	 

            if( !file_exists( $img ) )
            {
                $img = "$pRutaImg/wprod_0.jpg";
            }

            $descripcion = substr( $value['descripcion'], 0, 30 );
            $precio      = ( !empty( $value['precio_oferta'] ) ) ? $value['precio_oferta'] : $value['precio_venta'];

            $datos = [
                'idprodserial'      => $value['idprod_serial'],
                'descripcion'       => $descripcion,
                'imagen'            => $img,
                'marca'             => $value['marca'],
                'descripcionlarga'  => $value['descripcion_larga'],
                'precio'            => $precio
            ];

            array_push($productos['datos'], $datos);
        }

        return $productos;
    }

    /**
     * Obtener id promo activa
     */
    function obtenerIdPromoActiva( $pConexion, $pIdempresa, $pAhorad )
    {
        $idpromo = null;

        $sql = "
            select * 
            from promociones
            inner join promociones_detalles on promociones.idpromo = promociones_detalles.idpromo
            where
            promociones.desde <= '$pAhorad'
            and promociones.hasta >= '$pAhorad'
            and promociones.idempresa = $pIdempresa
            and promociones_detalles.idempresa = $pIdempresa
            order by promociones.desde asc
            limit 1";

        $rs = $pConexion->Execute($sql) or die(errorpg($pConexion,$sql));

        if( !empty( $rs_promoact->fields['idpromo'] ) )
        {
            $idpromo = intval($rs_promoact->fields['idpromo']);
        }

        return $idpromo;
    }
?>